class ie {
  /**
  Get the line description around the given position.
  */
  lineAt(e) {
    if (e < 0 || e > this.length)
      throw new RangeError(`Invalid position ${e} in document of length ${this.length}`);
    return this.lineInner(e, !1, 1, 0);
  }
  /**
  Get the description for the given (1-based) line number.
  */
  line(e) {
    if (e < 1 || e > this.lines)
      throw new RangeError(`Invalid line number ${e} in ${this.lines}-line document`);
    return this.lineInner(e, !0, 1, 0);
  }
  /**
  Replace a range of the text with the given content.
  */
  replace(e, t, i) {
    [e, t] = En(this, e, t);
    let s = [];
    return this.decompose(
      0,
      e,
      s,
      2
      /* Open.To */
    ), i.length && i.decompose(
      0,
      i.length,
      s,
      3
      /* Open.To */
    ), this.decompose(
      t,
      this.length,
      s,
      1
      /* Open.From */
    ), jt.from(s, this.length - (t - e) + i.length);
  }
  /**
  Append another document to this one.
  */
  append(e) {
    return this.replace(this.length, this.length, e);
  }
  /**
  Retrieve the text between the given points.
  */
  slice(e, t = this.length) {
    [e, t] = En(this, e, t);
    let i = [];
    return this.decompose(e, t, i, 0), jt.from(i, t - e);
  }
  /**
  Test whether this text is equal to another instance.
  */
  eq(e) {
    if (e == this)
      return !0;
    if (e.length != this.length || e.lines != this.lines)
      return !1;
    let t = this.scanIdentical(e, 1), i = this.length - this.scanIdentical(e, -1), s = new ys(this), r = new ys(e);
    for (let o = t, l = t; ; ) {
      if (s.next(o), r.next(o), o = 0, s.lineBreak != r.lineBreak || s.done != r.done || s.value != r.value)
        return !1;
      if (l += s.value.length, s.done || l >= i)
        return !0;
    }
  }
  /**
  Iterate over the text. When `dir` is `-1`, iteration happens
  from end to start. This will return lines and the breaks between
  them as separate strings.
  */
  iter(e = 1) {
    return new ys(this, e);
  }
  /**
  Iterate over a range of the text. When `from` > `to`, the
  iterator will run in reverse.
  */
  iterRange(e, t = this.length) {
    return new vd(this, e, t);
  }
  /**
  Return a cursor that iterates over the given range of lines,
  _without_ returning the line breaks between, and yielding empty
  strings for empty lines.
  
  When `from` and `to` are given, they should be 1-based line numbers.
  */
  iterLines(e, t) {
    let i;
    if (e == null)
      i = this.iter();
    else {
      t == null && (t = this.lines + 1);
      let s = this.line(e).from;
      i = this.iterRange(s, Math.max(s, t == this.lines + 1 ? this.length : t <= 1 ? 0 : this.line(t - 1).to));
    }
    return new xd(i);
  }
  /**
  Return the document as a string, using newline characters to
  separate lines.
  */
  toString() {
    return this.sliceString(0);
  }
  /**
  Convert the document to an array of lines (which can be
  deserialized again via [`Text.of`](https://codemirror.net/6/docs/ref/#state.Text^of)).
  */
  toJSON() {
    let e = [];
    return this.flatten(e), e;
  }
  /**
  @internal
  */
  constructor() {
  }
  /**
  Create a `Text` instance for the given array of lines.
  */
  static of(e) {
    if (e.length == 0)
      throw new RangeError("A document must have at least one line");
    return e.length == 1 && !e[0] ? ie.empty : e.length <= 32 ? new ye(e) : jt.from(ye.split(e, []));
  }
}
class ye extends ie {
  constructor(e, t = r1(e)) {
    super(), this.text = e, this.length = t;
  }
  get lines() {
    return this.text.length;
  }
  get children() {
    return null;
  }
  lineInner(e, t, i, s) {
    for (let r = 0; ; r++) {
      let o = this.text[r], l = s + o.length;
      if ((t ? i : l) >= e)
        return new o1(s, l, i, o);
      s = l + 1, i++;
    }
  }
  decompose(e, t, i, s) {
    let r = e <= 0 && t >= this.length ? this : new ye(rc(this.text, e, t), Math.min(t, this.length) - Math.max(0, e));
    if (s & 1) {
      let o = i.pop(), l = Nr(r.text, o.text.slice(), 0, r.length);
      if (l.length <= 32)
        i.push(new ye(l, o.length + r.length));
      else {
        let a = l.length >> 1;
        i.push(new ye(l.slice(0, a)), new ye(l.slice(a)));
      }
    } else
      i.push(r);
  }
  replace(e, t, i) {
    if (!(i instanceof ye))
      return super.replace(e, t, i);
    [e, t] = En(this, e, t);
    let s = Nr(this.text, Nr(i.text, rc(this.text, 0, e)), t), r = this.length + i.length - (t - e);
    return s.length <= 32 ? new ye(s, r) : jt.from(ye.split(s, []), r);
  }
  sliceString(e, t = this.length, i = `
`) {
    [e, t] = En(this, e, t);
    let s = "";
    for (let r = 0, o = 0; r <= t && o < this.text.length; o++) {
      let l = this.text[o], a = r + l.length;
      r > e && o && (s += i), e < a && t > r && (s += l.slice(Math.max(0, e - r), t - r)), r = a + 1;
    }
    return s;
  }
  flatten(e) {
    for (let t of this.text)
      e.push(t);
  }
  scanIdentical() {
    return 0;
  }
  static split(e, t) {
    let i = [], s = -1;
    for (let r of e)
      i.push(r), s += r.length + 1, i.length == 32 && (t.push(new ye(i, s)), i = [], s = -1);
    return s > -1 && t.push(new ye(i, s)), t;
  }
}
class jt extends ie {
  constructor(e, t) {
    super(), this.children = e, this.length = t, this.lines = 0;
    for (let i of e)
      this.lines += i.lines;
  }
  lineInner(e, t, i, s) {
    for (let r = 0; ; r++) {
      let o = this.children[r], l = s + o.length, a = i + o.lines - 1;
      if ((t ? a : l) >= e)
        return o.lineInner(e, t, i, s);
      s = l + 1, i = a + 1;
    }
  }
  decompose(e, t, i, s) {
    for (let r = 0, o = 0; o <= t && r < this.children.length; r++) {
      let l = this.children[r], a = o + l.length;
      if (e <= a && t >= o) {
        let h = s & ((o <= e ? 1 : 0) | (a >= t ? 2 : 0));
        o >= e && a <= t && !h ? i.push(l) : l.decompose(e - o, t - o, i, h);
      }
      o = a + 1;
    }
  }
  replace(e, t, i) {
    if ([e, t] = En(this, e, t), i.lines < this.lines)
      for (let s = 0, r = 0; s < this.children.length; s++) {
        let o = this.children[s], l = r + o.length;
        if (e >= r && t <= l) {
          let a = o.replace(e - r, t - r, i), h = this.lines - o.lines + a.lines;
          if (a.lines < h >> 4 && a.lines > h >> 6) {
            let c = this.children.slice();
            return c[s] = a, new jt(c, this.length - (t - e) + i.length);
          }
          return super.replace(r, l, a);
        }
        r = l + 1;
      }
    return super.replace(e, t, i);
  }
  sliceString(e, t = this.length, i = `
`) {
    [e, t] = En(this, e, t);
    let s = "";
    for (let r = 0, o = 0; r < this.children.length && o <= t; r++) {
      let l = this.children[r], a = o + l.length;
      o > e && r && (s += i), e < a && t > o && (s += l.sliceString(e - o, t - o, i)), o = a + 1;
    }
    return s;
  }
  flatten(e) {
    for (let t of this.children)
      t.flatten(e);
  }
  scanIdentical(e, t) {
    if (!(e instanceof jt))
      return 0;
    let i = 0, [s, r, o, l] = t > 0 ? [0, 0, this.children.length, e.children.length] : [this.children.length - 1, e.children.length - 1, -1, -1];
    for (; ; s += t, r += t) {
      if (s == o || r == l)
        return i;
      let a = this.children[s], h = e.children[r];
      if (a != h)
        return i + a.scanIdentical(h, t);
      i += a.length + 1;
    }
  }
  static from(e, t = e.reduce((i, s) => i + s.length + 1, -1)) {
    let i = 0;
    for (let d of e)
      i += d.lines;
    if (i < 32) {
      let d = [];
      for (let m of e)
        m.flatten(d);
      return new ye(d, t);
    }
    let s = Math.max(
      32,
      i >> 5
      /* Tree.BranchShift */
    ), r = s << 1, o = s >> 1, l = [], a = 0, h = -1, c = [];
    function f(d) {
      let m;
      if (d.lines > r && d instanceof jt)
        for (let p of d.children)
          f(p);
      else d.lines > o && (a > o || !a) ? (u(), l.push(d)) : d instanceof ye && a && (m = c[c.length - 1]) instanceof ye && d.lines + m.lines <= 32 ? (a += d.lines, h += d.length + 1, c[c.length - 1] = new ye(m.text.concat(d.text), m.length + 1 + d.length)) : (a + d.lines > s && u(), a += d.lines, h += d.length + 1, c.push(d));
    }
    function u() {
      a != 0 && (l.push(c.length == 1 ? c[0] : jt.from(c, h)), h = -1, a = c.length = 0);
    }
    for (let d of e)
      f(d);
    return u(), l.length == 1 ? l[0] : new jt(l, t);
  }
}
ie.empty = /* @__PURE__ */ new ye([""], 0);
function r1(n) {
  let e = -1;
  for (let t of n)
    e += t.length + 1;
  return e;
}
function Nr(n, e, t = 0, i = 1e9) {
  for (let s = 0, r = 0, o = !0; r < n.length && s <= i; r++) {
    let l = n[r], a = s + l.length;
    a >= t && (a > i && (l = l.slice(0, i - s)), s < t && (l = l.slice(t - s)), o ? (e[e.length - 1] += l, o = !1) : e.push(l)), s = a + 1;
  }
  return e;
}
function rc(n, e, t) {
  return Nr(n, [""], e, t);
}
class ys {
  constructor(e, t = 1) {
    this.dir = t, this.done = !1, this.lineBreak = !1, this.value = "", this.nodes = [e], this.offsets = [t > 0 ? 1 : (e instanceof ye ? e.text.length : e.children.length) << 1];
  }
  nextInner(e, t) {
    for (this.done = this.lineBreak = !1; ; ) {
      let i = this.nodes.length - 1, s = this.nodes[i], r = this.offsets[i], o = r >> 1, l = s instanceof ye ? s.text.length : s.children.length;
      if (o == (t > 0 ? l : 0)) {
        if (i == 0)
          return this.done = !0, this.value = "", this;
        t > 0 && this.offsets[i - 1]++, this.nodes.pop(), this.offsets.pop();
      } else if ((r & 1) == (t > 0 ? 0 : 1)) {
        if (this.offsets[i] += t, e == 0)
          return this.lineBreak = !0, this.value = `
`, this;
        e--;
      } else if (s instanceof ye) {
        let a = s.text[o + (t < 0 ? -1 : 0)];
        if (this.offsets[i] += t, a.length > Math.max(0, e))
          return this.value = e == 0 ? a : t > 0 ? a.slice(e) : a.slice(0, a.length - e), this;
        e -= a.length;
      } else {
        let a = s.children[o + (t < 0 ? -1 : 0)];
        e > a.length ? (e -= a.length, this.offsets[i] += t) : (t < 0 && this.offsets[i]--, this.nodes.push(a), this.offsets.push(t > 0 ? 1 : (a instanceof ye ? a.text.length : a.children.length) << 1));
      }
    }
  }
  next(e = 0) {
    return e < 0 && (this.nextInner(-e, -this.dir), e = this.value.length), this.nextInner(e, this.dir);
  }
}
class vd {
  constructor(e, t, i) {
    this.value = "", this.done = !1, this.cursor = new ys(e, t > i ? -1 : 1), this.pos = t > i ? e.length : 0, this.from = Math.min(t, i), this.to = Math.max(t, i);
  }
  nextInner(e, t) {
    if (t < 0 ? this.pos <= this.from : this.pos >= this.to)
      return this.value = "", this.done = !0, this;
    e += Math.max(0, t < 0 ? this.pos - this.to : this.from - this.pos);
    let i = t < 0 ? this.pos - this.from : this.to - this.pos;
    e > i && (e = i), i -= e;
    let { value: s } = this.cursor.next(e);
    return this.pos += (s.length + e) * t, this.value = s.length <= i ? s : t < 0 ? s.slice(s.length - i) : s.slice(0, i), this.done = !this.value, this;
  }
  next(e = 0) {
    return e < 0 ? e = Math.max(e, this.from - this.pos) : e > 0 && (e = Math.min(e, this.to - this.pos)), this.nextInner(e, this.cursor.dir);
  }
  get lineBreak() {
    return this.cursor.lineBreak && this.value != "";
  }
}
class xd {
  constructor(e) {
    this.inner = e, this.afterBreak = !0, this.value = "", this.done = !1;
  }
  next(e = 0) {
    let { done: t, lineBreak: i, value: s } = this.inner.next(e);
    return t && this.afterBreak ? (this.value = "", this.afterBreak = !1) : t ? (this.done = !0, this.value = "") : i ? this.afterBreak ? this.value = "" : (this.afterBreak = !0, this.next()) : (this.value = s, this.afterBreak = !1), this;
  }
  get lineBreak() {
    return !1;
  }
}
typeof Symbol < "u" && (ie.prototype[Symbol.iterator] = function() {
  return this.iter();
}, ys.prototype[Symbol.iterator] = vd.prototype[Symbol.iterator] = xd.prototype[Symbol.iterator] = function() {
  return this;
});
class o1 {
  /**
  @internal
  */
  constructor(e, t, i, s) {
    this.from = e, this.to = t, this.number = i, this.text = s;
  }
  /**
  The length of the line (not including any line break after it).
  */
  get length() {
    return this.to - this.from;
  }
}
function En(n, e, t) {
  return e = Math.max(0, Math.min(n.length, e)), [e, Math.max(e, Math.min(n.length, t))];
}
let Sn = /* @__PURE__ */ "lc,34,7n,7,7b,19,,,,2,,2,,,20,b,1c,l,g,,2t,7,2,6,2,2,,4,z,,u,r,2j,b,1m,9,9,,o,4,,9,,3,,5,17,3,3b,f,,w,1j,,,,4,8,4,,3,7,a,2,t,,1m,,,,2,4,8,,9,,a,2,q,,2,2,1l,,4,2,4,2,2,3,3,,u,2,3,,b,2,1l,,4,5,,2,4,,k,2,m,6,,,1m,,,2,,4,8,,7,3,a,2,u,,1n,,,,c,,9,,14,,3,,1l,3,5,3,,4,7,2,b,2,t,,1m,,2,,2,,3,,5,2,7,2,b,2,s,2,1l,2,,,2,4,8,,9,,a,2,t,,20,,4,,2,3,,,8,,29,,2,7,c,8,2q,,2,9,b,6,22,2,r,,,,,,1j,e,,5,,2,5,b,,10,9,,2u,4,,6,,2,2,2,p,2,4,3,g,4,d,,2,2,6,,f,,jj,3,qa,3,t,3,t,2,u,2,1s,2,,7,8,,2,b,9,,19,3,3b,2,y,,3a,3,4,2,9,,6,3,63,2,2,,1m,,,7,,,,,2,8,6,a,2,,1c,h,1r,4,1c,7,,,5,,14,9,c,2,w,4,2,2,,3,1k,,,2,3,,,3,1m,8,2,2,48,3,,d,,7,4,,6,,3,2,5i,1m,,5,ek,,5f,x,2da,3,3x,,2o,w,fe,6,2x,2,n9w,4,,a,w,2,28,2,7k,,3,,4,,p,2,5,,47,2,q,i,d,,12,8,p,b,1a,3,1c,,2,4,2,2,13,,1v,6,2,2,2,2,c,,8,,1b,,1f,,,3,2,2,5,2,,,16,2,8,,6m,,2,,4,,fn4,,kh,g,g,g,a6,2,gt,,6a,,45,5,1ae,3,,2,5,4,14,3,4,,4l,2,fx,4,ar,2,49,b,4w,,1i,f,1k,3,1d,4,2,2,1x,3,10,5,,8,1q,,c,2,1g,9,a,4,2,,2n,3,2,,,2,6,,4g,,3,8,l,2,1l,2,,,,,m,,e,7,3,5,5f,8,2,3,,,n,,29,,2,6,,,2,,,2,,2,6j,,2,4,6,2,,2,r,2,2d,8,2,,,2,2y,,,,2,6,,,2t,3,2,4,,5,77,9,,2,6t,,a,2,,,4,,40,4,2,2,4,,w,a,14,6,2,4,8,,9,6,2,3,1a,d,,2,ba,7,,6,,,2a,m,2,7,,2,,2,3e,6,3,,,2,,7,,,20,2,3,,,,9n,2,f0b,5,1n,7,t4,,1r,4,29,,f5k,2,43q,,,3,4,5,8,8,2,7,u,4,44,3,1iz,1j,4,1e,8,,e,,m,5,,f,11s,7,,h,2,7,,2,,5,79,7,c5,4,15s,7,31,7,240,5,gx7k,2o,3k,6o".split(",").map((n) => n ? parseInt(n, 36) : 1);
for (let n = 1; n < Sn.length; n++)
  Sn[n] += Sn[n - 1];
function l1(n) {
  for (let e = 1; e < Sn.length; e += 2)
    if (Sn[e] > n)
      return Sn[e - 1] <= n;
  return !1;
}
function oc(n) {
  return n >= 127462 && n <= 127487;
}
const lc = 8205;
function Re(n, e, t = !0, i = !0) {
  return (t ? Sd : a1)(n, e, i);
}
function Sd(n, e, t) {
  if (e == n.length)
    return e;
  e && _d(n.charCodeAt(e)) && Cd(n.charCodeAt(e - 1)) && e--;
  let i = De(n, e);
  for (e += lt(i); e < n.length; ) {
    let s = De(n, e);
    if (i == lc || s == lc || t && l1(s))
      e += lt(s), i = s;
    else if (oc(s)) {
      let r = 0, o = e - 2;
      for (; o >= 0 && oc(De(n, o)); )
        r++, o -= 2;
      if (r % 2 == 0)
        break;
      e += 2;
    } else
      break;
  }
  return e;
}
function a1(n, e, t) {
  for (; e > 0; ) {
    let i = Sd(n, e - 2, t);
    if (i < e)
      return i;
    e--;
  }
  return 0;
}
function _d(n) {
  return n >= 56320 && n < 57344;
}
function Cd(n) {
  return n >= 55296 && n < 56320;
}
function De(n, e) {
  let t = n.charCodeAt(e);
  if (!Cd(t) || e + 1 == n.length)
    return t;
  let i = n.charCodeAt(e + 1);
  return _d(i) ? (t - 55296 << 10) + (i - 56320) + 65536 : t;
}
function ja(n) {
  return n <= 65535 ? String.fromCharCode(n) : (n -= 65536, String.fromCharCode((n >> 10) + 55296, (n & 1023) + 56320));
}
function lt(n) {
  return n < 65536 ? 1 : 2;
}
const Hl = /\r\n?|\n/;
var Ee = /* @__PURE__ */ function(n) {
  return n[n.Simple = 0] = "Simple", n[n.TrackDel = 1] = "TrackDel", n[n.TrackBefore = 2] = "TrackBefore", n[n.TrackAfter = 3] = "TrackAfter", n;
}(Ee || (Ee = {}));
class Zt {
  // Sections are encoded as pairs of integers. The first is the
  // length in the current document, and the second is -1 for
  // unaffected sections, and the length of the replacement content
  // otherwise. So an insertion would be (0, n>0), a deletion (n>0,
  // 0), and a replacement two positive numbers.
  /**
  @internal
  */
  constructor(e) {
    this.sections = e;
  }
  /**
  The length of the document before the change.
  */
  get length() {
    let e = 0;
    for (let t = 0; t < this.sections.length; t += 2)
      e += this.sections[t];
    return e;
  }
  /**
  The length of the document after the change.
  */
  get newLength() {
    let e = 0;
    for (let t = 0; t < this.sections.length; t += 2) {
      let i = this.sections[t + 1];
      e += i < 0 ? this.sections[t] : i;
    }
    return e;
  }
  /**
  False when there are actual changes in this set.
  */
  get empty() {
    return this.sections.length == 0 || this.sections.length == 2 && this.sections[1] < 0;
  }
  /**
  Iterate over the unchanged parts left by these changes. `posA`
  provides the position of the range in the old document, `posB`
  the new position in the changed document.
  */
  iterGaps(e) {
    for (let t = 0, i = 0, s = 0; t < this.sections.length; ) {
      let r = this.sections[t++], o = this.sections[t++];
      o < 0 ? (e(i, s, r), s += r) : s += o, i += r;
    }
  }
  /**
  Iterate over the ranges changed by these changes. (See
  [`ChangeSet.iterChanges`](https://codemirror.net/6/docs/ref/#state.ChangeSet.iterChanges) for a
  variant that also provides you with the inserted text.)
  `fromA`/`toA` provides the extent of the change in the starting
  document, `fromB`/`toB` the extent of the replacement in the
  changed document.
  
  When `individual` is true, adjacent changes (which are kept
  separate for [position mapping](https://codemirror.net/6/docs/ref/#state.ChangeDesc.mapPos)) are
  reported separately.
  */
  iterChangedRanges(e, t = !1) {
    Vl(this, e, t);
  }
  /**
  Get a description of the inverted form of these changes.
  */
  get invertedDesc() {
    let e = [];
    for (let t = 0; t < this.sections.length; ) {
      let i = this.sections[t++], s = this.sections[t++];
      s < 0 ? e.push(i, s) : e.push(s, i);
    }
    return new Zt(e);
  }
  /**
  Compute the combined effect of applying another set of changes
  after this one. The length of the document after this set should
  match the length before `other`.
  */
  composeDesc(e) {
    return this.empty ? e : e.empty ? this : Ad(this, e);
  }
  /**
  Map this description, which should start with the same document
  as `other`, over another set of changes, so that it can be
  applied after it. When `before` is true, map as if the changes
  in `other` happened before the ones in `this`.
  */
  mapDesc(e, t = !1) {
    return e.empty ? this : Wl(this, e, t);
  }
  mapPos(e, t = -1, i = Ee.Simple) {
    let s = 0, r = 0;
    for (let o = 0; o < this.sections.length; ) {
      let l = this.sections[o++], a = this.sections[o++], h = s + l;
      if (a < 0) {
        if (h > e)
          return r + (e - s);
        r += l;
      } else {
        if (i != Ee.Simple && h >= e && (i == Ee.TrackDel && s < e && h > e || i == Ee.TrackBefore && s < e || i == Ee.TrackAfter && h > e))
          return null;
        if (h > e || h == e && t < 0 && !l)
          return e == s || t < 0 ? r : r + a;
        r += a;
      }
      s = h;
    }
    if (e > s)
      throw new RangeError(`Position ${e} is out of range for changeset of length ${s}`);
    return r;
  }
  /**
  Check whether these changes touch a given range. When one of the
  changes entirely covers the range, the string `"cover"` is
  returned.
  */
  touchesRange(e, t = e) {
    for (let i = 0, s = 0; i < this.sections.length && s <= t; ) {
      let r = this.sections[i++], o = this.sections[i++], l = s + r;
      if (o >= 0 && s <= t && l >= e)
        return s < e && l > t ? "cover" : !0;
      s = l;
    }
    return !1;
  }
  /**
  @internal
  */
  toString() {
    let e = "";
    for (let t = 0; t < this.sections.length; ) {
      let i = this.sections[t++], s = this.sections[t++];
      e += (e ? " " : "") + i + (s >= 0 ? ":" + s : "");
    }
    return e;
  }
  /**
  Serialize this change desc to a JSON-representable value.
  */
  toJSON() {
    return this.sections;
  }
  /**
  Create a change desc from its JSON representation (as produced
  by [`toJSON`](https://codemirror.net/6/docs/ref/#state.ChangeDesc.toJSON).
  */
  static fromJSON(e) {
    if (!Array.isArray(e) || e.length % 2 || e.some((t) => typeof t != "number"))
      throw new RangeError("Invalid JSON representation of ChangeDesc");
    return new Zt(e);
  }
  /**
  @internal
  */
  static create(e) {
    return new Zt(e);
  }
}
class Se extends Zt {
  constructor(e, t) {
    super(e), this.inserted = t;
  }
  /**
  Apply the changes to a document, returning the modified
  document.
  */
  apply(e) {
    if (this.length != e.length)
      throw new RangeError("Applying change set to a document with the wrong length");
    return Vl(this, (t, i, s, r, o) => e = e.replace(s, s + (i - t), o), !1), e;
  }
  mapDesc(e, t = !1) {
    return Wl(this, e, t, !0);
  }
  /**
  Given the document as it existed _before_ the changes, return a
  change set that represents the inverse of this set, which could
  be used to go from the document created by the changes back to
  the document as it existed before the changes.
  */
  invert(e) {
    let t = this.sections.slice(), i = [];
    for (let s = 0, r = 0; s < t.length; s += 2) {
      let o = t[s], l = t[s + 1];
      if (l >= 0) {
        t[s] = l, t[s + 1] = o;
        let a = s >> 1;
        for (; i.length < a; )
          i.push(ie.empty);
        i.push(o ? e.slice(r, r + o) : ie.empty);
      }
      r += o;
    }
    return new Se(t, i);
  }
  /**
  Combine two subsequent change sets into a single set. `other`
  must start in the document produced by `this`. If `this` goes
  `docA` → `docB` and `other` represents `docB` → `docC`, the
  returned value will represent the change `docA` → `docC`.
  */
  compose(e) {
    return this.empty ? e : e.empty ? this : Ad(this, e, !0);
  }
  /**
  Given another change set starting in the same document, maps this
  change set over the other, producing a new change set that can be
  applied to the document produced by applying `other`. When
  `before` is `true`, order changes as if `this` comes before
  `other`, otherwise (the default) treat `other` as coming first.
  
  Given two changes `A` and `B`, `A.compose(B.map(A))` and
  `B.compose(A.map(B, true))` will produce the same document. This
  provides a basic form of [operational
  transformation](https://en.wikipedia.org/wiki/Operational_transformation),
  and can be used for collaborative editing.
  */
  map(e, t = !1) {
    return e.empty ? this : Wl(this, e, t, !0);
  }
  /**
  Iterate over the changed ranges in the document, calling `f` for
  each, with the range in the original document (`fromA`-`toA`)
  and the range that replaces it in the new document
  (`fromB`-`toB`).
  
  When `individual` is true, adjacent changes are reported
  separately.
  */
  iterChanges(e, t = !1) {
    Vl(this, e, t);
  }
  /**
  Get a [change description](https://codemirror.net/6/docs/ref/#state.ChangeDesc) for this change
  set.
  */
  get desc() {
    return Zt.create(this.sections);
  }
  /**
  @internal
  */
  filter(e) {
    let t = [], i = [], s = [], r = new Ms(this);
    e: for (let o = 0, l = 0; ; ) {
      let a = o == e.length ? 1e9 : e[o++];
      for (; l < a || l == a && r.len == 0; ) {
        if (r.done)
          break e;
        let c = Math.min(r.len, a - l);
        Be(s, c, -1);
        let f = r.ins == -1 ? -1 : r.off == 0 ? r.ins : 0;
        Be(t, c, f), f > 0 && Si(i, t, r.text), r.forward(c), l += c;
      }
      let h = e[o++];
      for (; l < h; ) {
        if (r.done)
          break e;
        let c = Math.min(r.len, h - l);
        Be(t, c, -1), Be(s, c, r.ins == -1 ? -1 : r.off == 0 ? r.ins : 0), r.forward(c), l += c;
      }
    }
    return {
      changes: new Se(t, i),
      filtered: Zt.create(s)
    };
  }
  /**
  Serialize this change set to a JSON-representable value.
  */
  toJSON() {
    let e = [];
    for (let t = 0; t < this.sections.length; t += 2) {
      let i = this.sections[t], s = this.sections[t + 1];
      s < 0 ? e.push(i) : s == 0 ? e.push([i]) : e.push([i].concat(this.inserted[t >> 1].toJSON()));
    }
    return e;
  }
  /**
  Create a change set for the given changes, for a document of the
  given length, using `lineSep` as line separator.
  */
  static of(e, t, i) {
    let s = [], r = [], o = 0, l = null;
    function a(c = !1) {
      if (!c && !s.length)
        return;
      o < t && Be(s, t - o, -1);
      let f = new Se(s, r);
      l = l ? l.compose(f.map(l)) : f, s = [], r = [], o = 0;
    }
    function h(c) {
      if (Array.isArray(c))
        for (let f of c)
          h(f);
      else if (c instanceof Se) {
        if (c.length != t)
          throw new RangeError(`Mismatched change set length (got ${c.length}, expected ${t})`);
        a(), l = l ? l.compose(c.map(l)) : c;
      } else {
        let { from: f, to: u = f, insert: d } = c;
        if (f > u || f < 0 || u > t)
          throw new RangeError(`Invalid change range ${f} to ${u} (in doc of length ${t})`);
        let m = d ? typeof d == "string" ? ie.of(d.split(i || Hl)) : d : ie.empty, p = m.length;
        if (f == u && p == 0)
          return;
        f < o && a(), f > o && Be(s, f - o, -1), Be(s, u - f, p), Si(r, s, m), o = u;
      }
    }
    return h(e), a(!l), l;
  }
  /**
  Create an empty changeset of the given length.
  */
  static empty(e) {
    return new Se(e ? [e, -1] : [], []);
  }
  /**
  Create a changeset from its JSON representation (as produced by
  [`toJSON`](https://codemirror.net/6/docs/ref/#state.ChangeSet.toJSON).
  */
  static fromJSON(e) {
    if (!Array.isArray(e))
      throw new RangeError("Invalid JSON representation of ChangeSet");
    let t = [], i = [];
    for (let s = 0; s < e.length; s++) {
      let r = e[s];
      if (typeof r == "number")
        t.push(r, -1);
      else {
        if (!Array.isArray(r) || typeof r[0] != "number" || r.some((o, l) => l && typeof o != "string"))
          throw new RangeError("Invalid JSON representation of ChangeSet");
        if (r.length == 1)
          t.push(r[0], 0);
        else {
          for (; i.length < s; )
            i.push(ie.empty);
          i[s] = ie.of(r.slice(1)), t.push(r[0], i[s].length);
        }
      }
    }
    return new Se(t, i);
  }
  /**
  @internal
  */
  static createSet(e, t) {
    return new Se(e, t);
  }
}
function Be(n, e, t, i = !1) {
  if (e == 0 && t <= 0)
    return;
  let s = n.length - 2;
  s >= 0 && t <= 0 && t == n[s + 1] ? n[s] += e : e == 0 && n[s] == 0 ? n[s + 1] += t : i ? (n[s] += e, n[s + 1] += t) : n.push(e, t);
}
function Si(n, e, t) {
  if (t.length == 0)
    return;
  let i = e.length - 2 >> 1;
  if (i < n.length)
    n[n.length - 1] = n[n.length - 1].append(t);
  else {
    for (; n.length < i; )
      n.push(ie.empty);
    n.push(t);
  }
}
function Vl(n, e, t) {
  let i = n.inserted;
  for (let s = 0, r = 0, o = 0; o < n.sections.length; ) {
    let l = n.sections[o++], a = n.sections[o++];
    if (a < 0)
      s += l, r += l;
    else {
      let h = s, c = r, f = ie.empty;
      for (; h += l, c += a, a && i && (f = f.append(i[o - 2 >> 1])), !(t || o == n.sections.length || n.sections[o + 1] < 0); )
        l = n.sections[o++], a = n.sections[o++];
      e(s, h, r, c, f), s = h, r = c;
    }
  }
}
function Wl(n, e, t, i = !1) {
  let s = [], r = i ? [] : null, o = new Ms(n), l = new Ms(e);
  for (let a = -1; ; )
    if (o.ins == -1 && l.ins == -1) {
      let h = Math.min(o.len, l.len);
      Be(s, h, -1), o.forward(h), l.forward(h);
    } else if (l.ins >= 0 && (o.ins < 0 || a == o.i || o.off == 0 && (l.len < o.len || l.len == o.len && !t))) {
      let h = l.len;
      for (Be(s, l.ins, -1); h; ) {
        let c = Math.min(o.len, h);
        o.ins >= 0 && a < o.i && o.len <= c && (Be(s, 0, o.ins), r && Si(r, s, o.text), a = o.i), o.forward(c), h -= c;
      }
      l.next();
    } else if (o.ins >= 0) {
      let h = 0, c = o.len;
      for (; c; )
        if (l.ins == -1) {
          let f = Math.min(c, l.len);
          h += f, c -= f, l.forward(f);
        } else if (l.ins == 0 && l.len < c)
          c -= l.len, l.next();
        else
          break;
      Be(s, h, a < o.i ? o.ins : 0), r && a < o.i && Si(r, s, o.text), a = o.i, o.forward(o.len - c);
    } else {
      if (o.done && l.done)
        return r ? Se.createSet(s, r) : Zt.create(s);
      throw new Error("Mismatched change set lengths");
    }
}
function Ad(n, e, t = !1) {
  let i = [], s = t ? [] : null, r = new Ms(n), o = new Ms(e);
  for (let l = !1; ; ) {
    if (r.done && o.done)
      return s ? Se.createSet(i, s) : Zt.create(i);
    if (r.ins == 0)
      Be(i, r.len, 0, l), r.next();
    else if (o.len == 0 && !o.done)
      Be(i, 0, o.ins, l), s && Si(s, i, o.text), o.next();
    else {
      if (r.done || o.done)
        throw new Error("Mismatched change set lengths");
      {
        let a = Math.min(r.len2, o.len), h = i.length;
        if (r.ins == -1) {
          let c = o.ins == -1 ? -1 : o.off ? 0 : o.ins;
          Be(i, a, c, l), s && c && Si(s, i, o.text);
        } else o.ins == -1 ? (Be(i, r.off ? 0 : r.len, a, l), s && Si(s, i, r.textBit(a))) : (Be(i, r.off ? 0 : r.len, o.off ? 0 : o.ins, l), s && !o.off && Si(s, i, o.text));
        l = (r.ins > a || o.ins >= 0 && o.len > a) && (l || i.length > h), r.forward2(a), o.forward(a);
      }
    }
  }
}
class Ms {
  constructor(e) {
    this.set = e, this.i = 0, this.next();
  }
  next() {
    let { sections: e } = this.set;
    this.i < e.length ? (this.len = e[this.i++], this.ins = e[this.i++]) : (this.len = 0, this.ins = -2), this.off = 0;
  }
  get done() {
    return this.ins == -2;
  }
  get len2() {
    return this.ins < 0 ? this.len : this.ins;
  }
  get text() {
    let { inserted: e } = this.set, t = this.i - 2 >> 1;
    return t >= e.length ? ie.empty : e[t];
  }
  textBit(e) {
    let { inserted: t } = this.set, i = this.i - 2 >> 1;
    return i >= t.length && !e ? ie.empty : t[i].slice(this.off, e == null ? void 0 : this.off + e);
  }
  forward(e) {
    e == this.len ? this.next() : (this.len -= e, this.off += e);
  }
  forward2(e) {
    this.ins == -1 ? this.forward(e) : e == this.ins ? this.next() : (this.ins -= e, this.off += e);
  }
}
class Ui {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.flags = i;
  }
  /**
  The anchor of the range—the side that doesn't move when you
  extend it.
  */
  get anchor() {
    return this.flags & 32 ? this.to : this.from;
  }
  /**
  The head of the range, which is moved when the range is
  [extended](https://codemirror.net/6/docs/ref/#state.SelectionRange.extend).
  */
  get head() {
    return this.flags & 32 ? this.from : this.to;
  }
  /**
  True when `anchor` and `head` are at the same position.
  */
  get empty() {
    return this.from == this.to;
  }
  /**
  If this is a cursor that is explicitly associated with the
  character on one of its sides, this returns the side. -1 means
  the character before its position, 1 the character after, and 0
  means no association.
  */
  get assoc() {
    return this.flags & 8 ? -1 : this.flags & 16 ? 1 : 0;
  }
  /**
  The bidirectional text level associated with this cursor, if
  any.
  */
  get bidiLevel() {
    let e = this.flags & 7;
    return e == 7 ? null : e;
  }
  /**
  The goal column (stored vertical offset) associated with a
  cursor. This is used to preserve the vertical position when
  [moving](https://codemirror.net/6/docs/ref/#view.EditorView.moveVertically) across
  lines of different length.
  */
  get goalColumn() {
    let e = this.flags >> 6;
    return e == 16777215 ? void 0 : e;
  }
  /**
  Map this range through a change, producing a valid range in the
  updated document.
  */
  map(e, t = -1) {
    let i, s;
    return this.empty ? i = s = e.mapPos(this.from, t) : (i = e.mapPos(this.from, 1), s = e.mapPos(this.to, -1)), i == this.from && s == this.to ? this : new Ui(i, s, this.flags);
  }
  /**
  Extend this range to cover at least `from` to `to`.
  */
  extend(e, t = e) {
    if (e <= this.anchor && t >= this.anchor)
      return C.range(e, t);
    let i = Math.abs(e - this.anchor) > Math.abs(t - this.anchor) ? e : t;
    return C.range(this.anchor, i);
  }
  /**
  Compare this range to another range.
  */
  eq(e, t = !1) {
    return this.anchor == e.anchor && this.head == e.head && (!t || !this.empty || this.assoc == e.assoc);
  }
  /**
  Return a JSON-serializable object representing the range.
  */
  toJSON() {
    return { anchor: this.anchor, head: this.head };
  }
  /**
  Convert a JSON representation of a range to a `SelectionRange`
  instance.
  */
  static fromJSON(e) {
    if (!e || typeof e.anchor != "number" || typeof e.head != "number")
      throw new RangeError("Invalid JSON representation for SelectionRange");
    return C.range(e.anchor, e.head);
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new Ui(e, t, i);
  }
}
class C {
  constructor(e, t) {
    this.ranges = e, this.mainIndex = t;
  }
  /**
  Map a selection through a change. Used to adjust the selection
  position for changes.
  */
  map(e, t = -1) {
    return e.empty ? this : C.create(this.ranges.map((i) => i.map(e, t)), this.mainIndex);
  }
  /**
  Compare this selection to another selection. By default, ranges
  are compared only by position. When `includeAssoc` is true,
  cursor ranges must also have the same
  [`assoc`](https://codemirror.net/6/docs/ref/#state.SelectionRange.assoc) value.
  */
  eq(e, t = !1) {
    if (this.ranges.length != e.ranges.length || this.mainIndex != e.mainIndex)
      return !1;
    for (let i = 0; i < this.ranges.length; i++)
      if (!this.ranges[i].eq(e.ranges[i], t))
        return !1;
    return !0;
  }
  /**
  Get the primary selection range. Usually, you should make sure
  your code applies to _all_ ranges, by using methods like
  [`changeByRange`](https://codemirror.net/6/docs/ref/#state.EditorState.changeByRange).
  */
  get main() {
    return this.ranges[this.mainIndex];
  }
  /**
  Make sure the selection only has one range. Returns a selection
  holding only the main range from this selection.
  */
  asSingle() {
    return this.ranges.length == 1 ? this : new C([this.main], 0);
  }
  /**
  Extend this selection with an extra range.
  */
  addRange(e, t = !0) {
    return C.create([e].concat(this.ranges), t ? 0 : this.mainIndex + 1);
  }
  /**
  Replace a given range with another range, and then normalize the
  selection to merge and sort ranges if necessary.
  */
  replaceRange(e, t = this.mainIndex) {
    let i = this.ranges.slice();
    return i[t] = e, C.create(i, this.mainIndex);
  }
  /**
  Convert this selection to an object that can be serialized to
  JSON.
  */
  toJSON() {
    return { ranges: this.ranges.map((e) => e.toJSON()), main: this.mainIndex };
  }
  /**
  Create a selection from a JSON representation.
  */
  static fromJSON(e) {
    if (!e || !Array.isArray(e.ranges) || typeof e.main != "number" || e.main >= e.ranges.length)
      throw new RangeError("Invalid JSON representation for EditorSelection");
    return new C(e.ranges.map((t) => Ui.fromJSON(t)), e.main);
  }
  /**
  Create a selection holding a single range.
  */
  static single(e, t = e) {
    return new C([C.range(e, t)], 0);
  }
  /**
  Sort and merge the given set of ranges, creating a valid
  selection.
  */
  static create(e, t = 0) {
    if (e.length == 0)
      throw new RangeError("A selection needs at least one range");
    for (let i = 0, s = 0; s < e.length; s++) {
      let r = e[s];
      if (r.empty ? r.from <= i : r.from < i)
        return C.normalized(e.slice(), t);
      i = r.to;
    }
    return new C(e, t);
  }
  /**
  Create a cursor selection range at the given position. You can
  safely ignore the optional arguments in most situations.
  */
  static cursor(e, t = 0, i, s) {
    return Ui.create(e, e, (t == 0 ? 0 : t < 0 ? 8 : 16) | (i == null ? 7 : Math.min(6, i)) | (s ?? 16777215) << 6);
  }
  /**
  Create a selection range.
  */
  static range(e, t, i, s) {
    let r = (i ?? 16777215) << 6 | (s == null ? 7 : Math.min(6, s));
    return t < e ? Ui.create(t, e, 48 | r) : Ui.create(e, t, (t > e ? 8 : 0) | r);
  }
  /**
  @internal
  */
  static normalized(e, t = 0) {
    let i = e[t];
    e.sort((s, r) => s.from - r.from), t = e.indexOf(i);
    for (let s = 1; s < e.length; s++) {
      let r = e[s], o = e[s - 1];
      if (r.empty ? r.from <= o.to : r.from < o.to) {
        let l = o.from, a = Math.max(r.to, o.to);
        s <= t && t--, e.splice(--s, 2, r.anchor > r.head ? C.range(a, l) : C.range(l, a));
      }
    }
    return new C(e, t);
  }
}
function Md(n, e) {
  for (let t of n.ranges)
    if (t.to > e)
      throw new RangeError("Selection points outside of document");
}
let Ka = 0;
class I {
  constructor(e, t, i, s, r) {
    this.combine = e, this.compareInput = t, this.compare = i, this.isStatic = s, this.id = Ka++, this.default = e([]), this.extensions = typeof r == "function" ? r(this) : r;
  }
  /**
  Returns a facet reader for this facet, which can be used to
  [read](https://codemirror.net/6/docs/ref/#state.EditorState.facet) it but not to define values for it.
  */
  get reader() {
    return this;
  }
  /**
  Define a new facet.
  */
  static define(e = {}) {
    return new I(e.combine || ((t) => t), e.compareInput || ((t, i) => t === i), e.compare || (e.combine ? (t, i) => t === i : Ga), !!e.static, e.enables);
  }
  /**
  Returns an extension that adds the given value to this facet.
  */
  of(e) {
    return new Fr([], this, 0, e);
  }
  /**
  Create an extension that computes a value for the facet from a
  state. You must take care to declare the parts of the state that
  this value depends on, since your function is only called again
  for a new state when one of those parts changed.
  
  In cases where your value depends only on a single field, you'll
  want to use the [`from`](https://codemirror.net/6/docs/ref/#state.Facet.from) method instead.
  */
  compute(e, t) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new Fr(e, this, 1, t);
  }
  /**
  Create an extension that computes zero or more values for this
  facet from a state.
  */
  computeN(e, t) {
    if (this.isStatic)
      throw new Error("Can't compute a static facet");
    return new Fr(e, this, 2, t);
  }
  from(e, t) {
    return t || (t = (i) => i), this.compute([e], (i) => t(i.field(e)));
  }
}
function Ga(n, e) {
  return n == e || n.length == e.length && n.every((t, i) => t === e[i]);
}
class Fr {
  constructor(e, t, i, s) {
    this.dependencies = e, this.facet = t, this.type = i, this.value = s, this.id = Ka++;
  }
  dynamicSlot(e) {
    var t;
    let i = this.value, s = this.facet.compareInput, r = this.id, o = e[r] >> 1, l = this.type == 2, a = !1, h = !1, c = [];
    for (let f of this.dependencies)
      f == "doc" ? a = !0 : f == "selection" ? h = !0 : ((t = e[f.id]) !== null && t !== void 0 ? t : 1) & 1 || c.push(e[f.id]);
    return {
      create(f) {
        return f.values[o] = i(f), 1;
      },
      update(f, u) {
        if (a && u.docChanged || h && (u.docChanged || u.selection) || zl(f, c)) {
          let d = i(f);
          if (l ? !ac(d, f.values[o], s) : !s(d, f.values[o]))
            return f.values[o] = d, 1;
        }
        return 0;
      },
      reconfigure: (f, u) => {
        let d, m = u.config.address[r];
        if (m != null) {
          let p = Jr(u, m);
          if (this.dependencies.every((g) => g instanceof I ? u.facet(g) === f.facet(g) : g instanceof ke ? u.field(g, !1) == f.field(g, !1) : !0) || (l ? ac(d = i(f), p, s) : s(d = i(f), p)))
            return f.values[o] = p, 0;
        } else
          d = i(f);
        return f.values[o] = d, 1;
      }
    };
  }
}
function ac(n, e, t) {
  if (n.length != e.length)
    return !1;
  for (let i = 0; i < n.length; i++)
    if (!t(n[i], e[i]))
      return !1;
  return !0;
}
function zl(n, e) {
  let t = !1;
  for (let i of e)
    ws(n, i) & 1 && (t = !0);
  return t;
}
function h1(n, e, t) {
  let i = t.map((a) => n[a.id]), s = t.map((a) => a.type), r = i.filter((a) => !(a & 1)), o = n[e.id] >> 1;
  function l(a) {
    let h = [];
    for (let c = 0; c < i.length; c++) {
      let f = Jr(a, i[c]);
      if (s[c] == 2)
        for (let u of f)
          h.push(u);
      else
        h.push(f);
    }
    return e.combine(h);
  }
  return {
    create(a) {
      for (let h of i)
        ws(a, h);
      return a.values[o] = l(a), 1;
    },
    update(a, h) {
      if (!zl(a, r))
        return 0;
      let c = l(a);
      return e.compare(c, a.values[o]) ? 0 : (a.values[o] = c, 1);
    },
    reconfigure(a, h) {
      let c = zl(a, i), f = h.config.facets[e.id], u = h.facet(e);
      if (f && !c && Ga(t, f))
        return a.values[o] = u, 0;
      let d = l(a);
      return e.compare(d, u) ? (a.values[o] = u, 0) : (a.values[o] = d, 1);
    }
  };
}
const hc = /* @__PURE__ */ I.define({ static: !0 });
class ke {
  constructor(e, t, i, s, r) {
    this.id = e, this.createF = t, this.updateF = i, this.compareF = s, this.spec = r, this.provides = void 0;
  }
  /**
  Define a state field.
  */
  static define(e) {
    let t = new ke(Ka++, e.create, e.update, e.compare || ((i, s) => i === s), e);
    return e.provide && (t.provides = e.provide(t)), t;
  }
  create(e) {
    let t = e.facet(hc).find((i) => i.field == this);
    return ((t == null ? void 0 : t.create) || this.createF)(e);
  }
  /**
  @internal
  */
  slot(e) {
    let t = e[this.id] >> 1;
    return {
      create: (i) => (i.values[t] = this.create(i), 1),
      update: (i, s) => {
        let r = i.values[t], o = this.updateF(r, s);
        return this.compareF(r, o) ? 0 : (i.values[t] = o, 1);
      },
      reconfigure: (i, s) => s.config.address[this.id] != null ? (i.values[t] = s.field(this), 0) : (i.values[t] = this.create(i), 1)
    };
  }
  /**
  Returns an extension that enables this field and overrides the
  way it is initialized. Can be useful when you need to provide a
  non-default starting value for the field.
  */
  init(e) {
    return [this, hc.of({ field: this, create: e })];
  }
  /**
  State field instances can be used as
  [`Extension`](https://codemirror.net/6/docs/ref/#state.Extension) values to enable the field in a
  given state.
  */
  get extension() {
    return this;
  }
}
const zi = { lowest: 4, low: 3, default: 2, high: 1, highest: 0 };
function Qn(n) {
  return (e) => new Td(e, n);
}
const ei = {
  /**
  The highest precedence level, for extensions that should end up
  near the start of the precedence ordering.
  */
  highest: /* @__PURE__ */ Qn(zi.highest),
  /**
  A higher-than-default precedence, for extensions that should
  come before those with default precedence.
  */
  high: /* @__PURE__ */ Qn(zi.high),
  /**
  The default precedence, which is also used for extensions
  without an explicit precedence.
  */
  default: /* @__PURE__ */ Qn(zi.default),
  /**
  A lower-than-default precedence.
  */
  low: /* @__PURE__ */ Qn(zi.low),
  /**
  The lowest precedence level. Meant for things that should end up
  near the end of the extension order.
  */
  lowest: /* @__PURE__ */ Qn(zi.lowest)
};
class Td {
  constructor(e, t) {
    this.inner = e, this.prec = t;
  }
}
class Co {
  /**
  Create an instance of this compartment to add to your [state
  configuration](https://codemirror.net/6/docs/ref/#state.EditorStateConfig.extensions).
  */
  of(e) {
    return new ql(this, e);
  }
  /**
  Create an [effect](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) that
  reconfigures this compartment.
  */
  reconfigure(e) {
    return Co.reconfigure.of({ compartment: this, extension: e });
  }
  /**
  Get the current content of the compartment in the state, or
  `undefined` if it isn't present.
  */
  get(e) {
    return e.config.compartments.get(this);
  }
}
class ql {
  constructor(e, t) {
    this.compartment = e, this.inner = t;
  }
}
class Xr {
  constructor(e, t, i, s, r, o) {
    for (this.base = e, this.compartments = t, this.dynamicSlots = i, this.address = s, this.staticValues = r, this.facets = o, this.statusTemplate = []; this.statusTemplate.length < i.length; )
      this.statusTemplate.push(
        0
        /* SlotStatus.Unresolved */
      );
  }
  staticFacet(e) {
    let t = this.address[e.id];
    return t == null ? e.default : this.staticValues[t >> 1];
  }
  static resolve(e, t, i) {
    let s = [], r = /* @__PURE__ */ Object.create(null), o = /* @__PURE__ */ new Map();
    for (let u of c1(e, t, o))
      u instanceof ke ? s.push(u) : (r[u.facet.id] || (r[u.facet.id] = [])).push(u);
    let l = /* @__PURE__ */ Object.create(null), a = [], h = [];
    for (let u of s)
      l[u.id] = h.length << 1, h.push((d) => u.slot(d));
    let c = i == null ? void 0 : i.config.facets;
    for (let u in r) {
      let d = r[u], m = d[0].facet, p = c && c[u] || [];
      if (d.every(
        (g) => g.type == 0
        /* Provider.Static */
      ))
        if (l[m.id] = a.length << 1 | 1, Ga(p, d))
          a.push(i.facet(m));
        else {
          let g = m.combine(d.map((b) => b.value));
          a.push(i && m.compare(g, i.facet(m)) ? i.facet(m) : g);
        }
      else {
        for (let g of d)
          g.type == 0 ? (l[g.id] = a.length << 1 | 1, a.push(g.value)) : (l[g.id] = h.length << 1, h.push((b) => g.dynamicSlot(b)));
        l[m.id] = h.length << 1, h.push((g) => h1(g, m, d));
      }
    }
    let f = h.map((u) => u(l));
    return new Xr(e, o, f, l, a, r);
  }
}
function c1(n, e, t) {
  let i = [[], [], [], [], []], s = /* @__PURE__ */ new Map();
  function r(o, l) {
    let a = s.get(o);
    if (a != null) {
      if (a <= l)
        return;
      let h = i[a].indexOf(o);
      h > -1 && i[a].splice(h, 1), o instanceof ql && t.delete(o.compartment);
    }
    if (s.set(o, l), Array.isArray(o))
      for (let h of o)
        r(h, l);
    else if (o instanceof ql) {
      if (t.has(o.compartment))
        throw new RangeError("Duplicate use of compartment in extensions");
      let h = e.get(o.compartment) || o.inner;
      t.set(o.compartment, h), r(h, l);
    } else if (o instanceof Td)
      r(o.inner, o.prec);
    else if (o instanceof ke)
      i[l].push(o), o.provides && r(o.provides, l);
    else if (o instanceof Fr)
      i[l].push(o), o.facet.extensions && r(o.facet.extensions, zi.default);
    else {
      let h = o.extension;
      if (!h)
        throw new Error(`Unrecognized extension value in extension set (${o}). This sometimes happens because multiple instances of @codemirror/state are loaded, breaking instanceof checks.`);
      r(h, l);
    }
  }
  return r(n, zi.default), i.reduce((o, l) => o.concat(l));
}
function ws(n, e) {
  if (e & 1)
    return 2;
  let t = e >> 1, i = n.status[t];
  if (i == 4)
    throw new Error("Cyclic dependency between fields and/or facets");
  if (i & 2)
    return i;
  n.status[t] = 4;
  let s = n.computeSlot(n, n.config.dynamicSlots[t]);
  return n.status[t] = 2 | s;
}
function Jr(n, e) {
  return e & 1 ? n.config.staticValues[e >> 1] : n.values[e >> 1];
}
const Dd = /* @__PURE__ */ I.define(), Ul = /* @__PURE__ */ I.define({
  combine: (n) => n.some((e) => e),
  static: !0
}), Od = /* @__PURE__ */ I.define({
  combine: (n) => n.length ? n[0] : void 0,
  static: !0
}), Ed = /* @__PURE__ */ I.define(), Ld = /* @__PURE__ */ I.define(), Rd = /* @__PURE__ */ I.define(), Pd = /* @__PURE__ */ I.define({
  combine: (n) => n.length ? n[0] : !1
});
class di {
  /**
  @internal
  */
  constructor(e, t) {
    this.type = e, this.value = t;
  }
  /**
  Define a new type of annotation.
  */
  static define() {
    return new f1();
  }
}
class f1 {
  /**
  Create an instance of this annotation.
  */
  of(e) {
    return new di(this, e);
  }
}
class u1 {
  /**
  @internal
  */
  constructor(e) {
    this.map = e;
  }
  /**
  Create a [state effect](https://codemirror.net/6/docs/ref/#state.StateEffect) instance of this
  type.
  */
  of(e) {
    return new K(this, e);
  }
}
class K {
  /**
  @internal
  */
  constructor(e, t) {
    this.type = e, this.value = t;
  }
  /**
  Map this effect through a position mapping. Will return
  `undefined` when that ends up deleting the effect.
  */
  map(e) {
    let t = this.type.map(this.value, e);
    return t === void 0 ? void 0 : t == this.value ? this : new K(this.type, t);
  }
  /**
  Tells you whether this effect object is of a given
  [type](https://codemirror.net/6/docs/ref/#state.StateEffectType).
  */
  is(e) {
    return this.type == e;
  }
  /**
  Define a new effect type. The type parameter indicates the type
  of values that his effect holds. It should be a type that
  doesn't include `undefined`, since that is used in
  [mapping](https://codemirror.net/6/docs/ref/#state.StateEffect.map) to indicate that an effect is
  removed.
  */
  static define(e = {}) {
    return new u1(e.map || ((t) => t));
  }
  /**
  Map an array of effects through a change set.
  */
  static mapEffects(e, t) {
    if (!e.length)
      return e;
    let i = [];
    for (let s of e) {
      let r = s.map(t);
      r && i.push(r);
    }
    return i;
  }
}
K.reconfigure = /* @__PURE__ */ K.define();
K.appendConfig = /* @__PURE__ */ K.define();
class _e {
  constructor(e, t, i, s, r, o) {
    this.startState = e, this.changes = t, this.selection = i, this.effects = s, this.annotations = r, this.scrollIntoView = o, this._doc = null, this._state = null, i && Md(i, t.newLength), r.some((l) => l.type == _e.time) || (this.annotations = r.concat(_e.time.of(Date.now())));
  }
  /**
  @internal
  */
  static create(e, t, i, s, r, o) {
    return new _e(e, t, i, s, r, o);
  }
  /**
  The new document produced by the transaction. Contrary to
  [`.state`](https://codemirror.net/6/docs/ref/#state.Transaction.state)`.doc`, accessing this won't
  force the entire new state to be computed right away, so it is
  recommended that [transaction
  filters](https://codemirror.net/6/docs/ref/#state.EditorState^transactionFilter) use this getter
  when they need to look at the new document.
  */
  get newDoc() {
    return this._doc || (this._doc = this.changes.apply(this.startState.doc));
  }
  /**
  The new selection produced by the transaction. If
  [`this.selection`](https://codemirror.net/6/docs/ref/#state.Transaction.selection) is undefined,
  this will [map](https://codemirror.net/6/docs/ref/#state.EditorSelection.map) the start state's
  current selection through the changes made by the transaction.
  */
  get newSelection() {
    return this.selection || this.startState.selection.map(this.changes);
  }
  /**
  The new state created by the transaction. Computed on demand
  (but retained for subsequent access), so it is recommended not to
  access it in [transaction
  filters](https://codemirror.net/6/docs/ref/#state.EditorState^transactionFilter) when possible.
  */
  get state() {
    return this._state || this.startState.applyTransaction(this), this._state;
  }
  /**
  Get the value of the given annotation type, if any.
  */
  annotation(e) {
    for (let t of this.annotations)
      if (t.type == e)
        return t.value;
  }
  /**
  Indicates whether the transaction changed the document.
  */
  get docChanged() {
    return !this.changes.empty;
  }
  /**
  Indicates whether this transaction reconfigures the state
  (through a [configuration compartment](https://codemirror.net/6/docs/ref/#state.Compartment) or
  with a top-level configuration
  [effect](https://codemirror.net/6/docs/ref/#state.StateEffect^reconfigure).
  */
  get reconfigured() {
    return this.startState.config != this.state.config;
  }
  /**
  Returns true if the transaction has a [user
  event](https://codemirror.net/6/docs/ref/#state.Transaction^userEvent) annotation that is equal to
  or more specific than `event`. For example, if the transaction
  has `"select.pointer"` as user event, `"select"` and
  `"select.pointer"` will match it.
  */
  isUserEvent(e) {
    let t = this.annotation(_e.userEvent);
    return !!(t && (t == e || t.length > e.length && t.slice(0, e.length) == e && t[e.length] == "."));
  }
}
_e.time = /* @__PURE__ */ di.define();
_e.userEvent = /* @__PURE__ */ di.define();
_e.addToHistory = /* @__PURE__ */ di.define();
_e.remote = /* @__PURE__ */ di.define();
function d1(n, e) {
  let t = [];
  for (let i = 0, s = 0; ; ) {
    let r, o;
    if (i < n.length && (s == e.length || e[s] >= n[i]))
      r = n[i++], o = n[i++];
    else if (s < e.length)
      r = e[s++], o = e[s++];
    else
      return t;
    !t.length || t[t.length - 1] < r ? t.push(r, o) : t[t.length - 1] < o && (t[t.length - 1] = o);
  }
}
function Bd(n, e, t) {
  var i;
  let s, r, o;
  return t ? (s = e.changes, r = Se.empty(e.changes.length), o = n.changes.compose(e.changes)) : (s = e.changes.map(n.changes), r = n.changes.mapDesc(e.changes, !0), o = n.changes.compose(s)), {
    changes: o,
    selection: e.selection ? e.selection.map(r) : (i = n.selection) === null || i === void 0 ? void 0 : i.map(s),
    effects: K.mapEffects(n.effects, s).concat(K.mapEffects(e.effects, r)),
    annotations: n.annotations.length ? n.annotations.concat(e.annotations) : e.annotations,
    scrollIntoView: n.scrollIntoView || e.scrollIntoView
  };
}
function jl(n, e, t) {
  let i = e.selection, s = _n(e.annotations);
  return e.userEvent && (s = s.concat(_e.userEvent.of(e.userEvent))), {
    changes: e.changes instanceof Se ? e.changes : Se.of(e.changes || [], t, n.facet(Od)),
    selection: i && (i instanceof C ? i : C.single(i.anchor, i.head)),
    effects: _n(e.effects),
    annotations: s,
    scrollIntoView: !!e.scrollIntoView
  };
}
function Id(n, e, t) {
  let i = jl(n, e.length ? e[0] : {}, n.doc.length);
  e.length && e[0].filter === !1 && (t = !1);
  for (let r = 1; r < e.length; r++) {
    e[r].filter === !1 && (t = !1);
    let o = !!e[r].sequential;
    i = Bd(i, jl(n, e[r], o ? i.changes.newLength : n.doc.length), o);
  }
  let s = _e.create(n, i.changes, i.selection, i.effects, i.annotations, i.scrollIntoView);
  return p1(t ? m1(s) : s);
}
function m1(n) {
  let e = n.startState, t = !0;
  for (let s of e.facet(Ed)) {
    let r = s(n);
    if (r === !1) {
      t = !1;
      break;
    }
    Array.isArray(r) && (t = t === !0 ? r : d1(t, r));
  }
  if (t !== !0) {
    let s, r;
    if (t === !1)
      r = n.changes.invertedDesc, s = Se.empty(e.doc.length);
    else {
      let o = n.changes.filter(t);
      s = o.changes, r = o.filtered.mapDesc(o.changes).invertedDesc;
    }
    n = _e.create(e, s, n.selection && n.selection.map(r), K.mapEffects(n.effects, r), n.annotations, n.scrollIntoView);
  }
  let i = e.facet(Ld);
  for (let s = i.length - 1; s >= 0; s--) {
    let r = i[s](n);
    r instanceof _e ? n = r : Array.isArray(r) && r.length == 1 && r[0] instanceof _e ? n = r[0] : n = Id(e, _n(r), !1);
  }
  return n;
}
function p1(n) {
  let e = n.startState, t = e.facet(Rd), i = n;
  for (let s = t.length - 1; s >= 0; s--) {
    let r = t[s](n);
    r && Object.keys(r).length && (i = Bd(i, jl(e, r, n.changes.newLength), !0));
  }
  return i == n ? n : _e.create(e, n.changes, n.selection, i.effects, i.annotations, i.scrollIntoView);
}
const g1 = [];
function _n(n) {
  return n == null ? g1 : Array.isArray(n) ? n : [n];
}
var me = /* @__PURE__ */ function(n) {
  return n[n.Word = 0] = "Word", n[n.Space = 1] = "Space", n[n.Other = 2] = "Other", n;
}(me || (me = {}));
const b1 = /[\u00df\u0587\u0590-\u05f4\u0600-\u06ff\u3040-\u309f\u30a0-\u30ff\u3400-\u4db5\u4e00-\u9fcc\uac00-\ud7af]/;
let Kl;
try {
  Kl = /* @__PURE__ */ new RegExp("[\\p{Alphabetic}\\p{Number}_]", "u");
} catch {
}
function y1(n) {
  if (Kl)
    return Kl.test(n);
  for (let e = 0; e < n.length; e++) {
    let t = n[e];
    if (/\w/.test(t) || t > "" && (t.toUpperCase() != t.toLowerCase() || b1.test(t)))
      return !0;
  }
  return !1;
}
function w1(n) {
  return (e) => {
    if (!/\S/.test(e))
      return me.Space;
    if (y1(e))
      return me.Word;
    for (let t = 0; t < n.length; t++)
      if (e.indexOf(n[t]) > -1)
        return me.Word;
    return me.Other;
  };
}
class Z {
  constructor(e, t, i, s, r, o) {
    this.config = e, this.doc = t, this.selection = i, this.values = s, this.status = e.statusTemplate.slice(), this.computeSlot = r, o && (o._state = this);
    for (let l = 0; l < this.config.dynamicSlots.length; l++)
      ws(this, l << 1);
    this.computeSlot = null;
  }
  field(e, t = !0) {
    let i = this.config.address[e.id];
    if (i == null) {
      if (t)
        throw new RangeError("Field is not present in this state");
      return;
    }
    return ws(this, i), Jr(this, i);
  }
  /**
  Create a [transaction](https://codemirror.net/6/docs/ref/#state.Transaction) that updates this
  state. Any number of [transaction specs](https://codemirror.net/6/docs/ref/#state.TransactionSpec)
  can be passed. Unless
  [`sequential`](https://codemirror.net/6/docs/ref/#state.TransactionSpec.sequential) is set, the
  [changes](https://codemirror.net/6/docs/ref/#state.TransactionSpec.changes) (if any) of each spec
  are assumed to start in the _current_ document (not the document
  produced by previous specs), and its
  [selection](https://codemirror.net/6/docs/ref/#state.TransactionSpec.selection) and
  [effects](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) are assumed to refer
  to the document created by its _own_ changes. The resulting
  transaction contains the combined effect of all the different
  specs. For [selection](https://codemirror.net/6/docs/ref/#state.TransactionSpec.selection), later
  specs take precedence over earlier ones.
  */
  update(...e) {
    return Id(this, e, !0);
  }
  /**
  @internal
  */
  applyTransaction(e) {
    let t = this.config, { base: i, compartments: s } = t;
    for (let l of e.effects)
      l.is(Co.reconfigure) ? (t && (s = /* @__PURE__ */ new Map(), t.compartments.forEach((a, h) => s.set(h, a)), t = null), s.set(l.value.compartment, l.value.extension)) : l.is(K.reconfigure) ? (t = null, i = l.value) : l.is(K.appendConfig) && (t = null, i = _n(i).concat(l.value));
    let r;
    t ? r = e.startState.values.slice() : (t = Xr.resolve(i, s, this), r = new Z(t, this.doc, this.selection, t.dynamicSlots.map(() => null), (a, h) => h.reconfigure(a, this), null).values);
    let o = e.startState.facet(Ul) ? e.newSelection : e.newSelection.asSingle();
    new Z(t, e.newDoc, o, r, (l, a) => a.update(l, e), e);
  }
  /**
  Create a [transaction spec](https://codemirror.net/6/docs/ref/#state.TransactionSpec) that
  replaces every selection range with the given content.
  */
  replaceSelection(e) {
    return typeof e == "string" && (e = this.toText(e)), this.changeByRange((t) => ({
      changes: { from: t.from, to: t.to, insert: e },
      range: C.cursor(t.from + e.length)
    }));
  }
  /**
  Create a set of changes and a new selection by running the given
  function for each range in the active selection. The function
  can return an optional set of changes (in the coordinate space
  of the start document), plus an updated range (in the coordinate
  space of the document produced by the call's own changes). This
  method will merge all the changes and ranges into a single
  changeset and selection, and return it as a [transaction
  spec](https://codemirror.net/6/docs/ref/#state.TransactionSpec), which can be passed to
  [`update`](https://codemirror.net/6/docs/ref/#state.EditorState.update).
  */
  changeByRange(e) {
    let t = this.selection, i = e(t.ranges[0]), s = this.changes(i.changes), r = [i.range], o = _n(i.effects);
    for (let l = 1; l < t.ranges.length; l++) {
      let a = e(t.ranges[l]), h = this.changes(a.changes), c = h.map(s);
      for (let u = 0; u < l; u++)
        r[u] = r[u].map(c);
      let f = s.mapDesc(h, !0);
      r.push(a.range.map(f)), s = s.compose(c), o = K.mapEffects(o, c).concat(K.mapEffects(_n(a.effects), f));
    }
    return {
      changes: s,
      selection: C.create(r, t.mainIndex),
      effects: o
    };
  }
  /**
  Create a [change set](https://codemirror.net/6/docs/ref/#state.ChangeSet) from the given change
  description, taking the state's document length and line
  separator into account.
  */
  changes(e = []) {
    return e instanceof Se ? e : Se.of(e, this.doc.length, this.facet(Z.lineSeparator));
  }
  /**
  Using the state's [line
  separator](https://codemirror.net/6/docs/ref/#state.EditorState^lineSeparator), create a
  [`Text`](https://codemirror.net/6/docs/ref/#state.Text) instance from the given string.
  */
  toText(e) {
    return ie.of(e.split(this.facet(Z.lineSeparator) || Hl));
  }
  /**
  Return the given range of the document as a string.
  */
  sliceDoc(e = 0, t = this.doc.length) {
    return this.doc.sliceString(e, t, this.lineBreak);
  }
  /**
  Get the value of a state [facet](https://codemirror.net/6/docs/ref/#state.Facet).
  */
  facet(e) {
    let t = this.config.address[e.id];
    return t == null ? e.default : (ws(this, t), Jr(this, t));
  }
  /**
  Convert this state to a JSON-serializable object. When custom
  fields should be serialized, you can pass them in as an object
  mapping property names (in the resulting object, which should
  not use `doc` or `selection`) to fields.
  */
  toJSON(e) {
    let t = {
      doc: this.sliceDoc(),
      selection: this.selection.toJSON()
    };
    if (e)
      for (let i in e) {
        let s = e[i];
        s instanceof ke && this.config.address[s.id] != null && (t[i] = s.spec.toJSON(this.field(e[i]), this));
      }
    return t;
  }
  /**
  Deserialize a state from its JSON representation. When custom
  fields should be deserialized, pass the same object you passed
  to [`toJSON`](https://codemirror.net/6/docs/ref/#state.EditorState.toJSON) when serializing as
  third argument.
  */
  static fromJSON(e, t = {}, i) {
    if (!e || typeof e.doc != "string")
      throw new RangeError("Invalid JSON representation for EditorState");
    let s = [];
    if (i) {
      for (let r in i)
        if (Object.prototype.hasOwnProperty.call(e, r)) {
          let o = i[r], l = e[r];
          s.push(o.init((a) => o.spec.fromJSON(l, a)));
        }
    }
    return Z.create({
      doc: e.doc,
      selection: C.fromJSON(e.selection),
      extensions: t.extensions ? s.concat([t.extensions]) : s
    });
  }
  /**
  Create a new state. You'll usually only need this when
  initializing an editor—updated states are created by applying
  transactions.
  */
  static create(e = {}) {
    let t = Xr.resolve(e.extensions || [], /* @__PURE__ */ new Map()), i = e.doc instanceof ie ? e.doc : ie.of((e.doc || "").split(t.staticFacet(Z.lineSeparator) || Hl)), s = e.selection ? e.selection instanceof C ? e.selection : C.single(e.selection.anchor, e.selection.head) : C.single(0);
    return Md(s, i.length), t.staticFacet(Ul) || (s = s.asSingle()), new Z(t, i, s, t.dynamicSlots.map(() => null), (r, o) => o.create(r), null);
  }
  /**
  The size (in columns) of a tab in the document, determined by
  the [`tabSize`](https://codemirror.net/6/docs/ref/#state.EditorState^tabSize) facet.
  */
  get tabSize() {
    return this.facet(Z.tabSize);
  }
  /**
  Get the proper [line-break](https://codemirror.net/6/docs/ref/#state.EditorState^lineSeparator)
  string for this state.
  */
  get lineBreak() {
    return this.facet(Z.lineSeparator) || `
`;
  }
  /**
  Returns true when the editor is
  [configured](https://codemirror.net/6/docs/ref/#state.EditorState^readOnly) to be read-only.
  */
  get readOnly() {
    return this.facet(Pd);
  }
  /**
  Look up a translation for the given phrase (via the
  [`phrases`](https://codemirror.net/6/docs/ref/#state.EditorState^phrases) facet), or return the
  original string if no translation is found.
  
  If additional arguments are passed, they will be inserted in
  place of markers like `$1` (for the first value) and `$2`, etc.
  A single `$` is equivalent to `$1`, and `$$` will produce a
  literal dollar sign.
  */
  phrase(e, ...t) {
    for (let i of this.facet(Z.phrases))
      if (Object.prototype.hasOwnProperty.call(i, e)) {
        e = i[e];
        break;
      }
    return t.length && (e = e.replace(/\$(\$|\d*)/g, (i, s) => {
      if (s == "$")
        return "$";
      let r = +(s || 1);
      return !r || r > t.length ? i : t[r - 1];
    })), e;
  }
  /**
  Find the values for a given language data field, provided by the
  the [`languageData`](https://codemirror.net/6/docs/ref/#state.EditorState^languageData) facet.
  
  Examples of language data fields are...
  
  - [`"commentTokens"`](https://codemirror.net/6/docs/ref/#commands.CommentTokens) for specifying
    comment syntax.
  - [`"autocomplete"`](https://codemirror.net/6/docs/ref/#autocomplete.autocompletion^config.override)
    for providing language-specific completion sources.
  - [`"wordChars"`](https://codemirror.net/6/docs/ref/#state.EditorState.charCategorizer) for adding
    characters that should be considered part of words in this
    language.
  - [`"closeBrackets"`](https://codemirror.net/6/docs/ref/#autocomplete.CloseBracketConfig) controls
    bracket closing behavior.
  */
  languageDataAt(e, t, i = -1) {
    let s = [];
    for (let r of this.facet(Dd))
      for (let o of r(this, t, i))
        Object.prototype.hasOwnProperty.call(o, e) && s.push(o[e]);
    return s;
  }
  /**
  Return a function that can categorize strings (expected to
  represent a single [grapheme cluster](https://codemirror.net/6/docs/ref/#state.findClusterBreak))
  into one of:
  
   - Word (contains an alphanumeric character or a character
     explicitly listed in the local language's `"wordChars"`
     language data, which should be a string)
   - Space (contains only whitespace)
   - Other (anything else)
  */
  charCategorizer(e) {
    return w1(this.languageDataAt("wordChars", e).join(""));
  }
  /**
  Find the word at the given position, meaning the range
  containing all [word](https://codemirror.net/6/docs/ref/#state.CharCategory.Word) characters
  around it. If no word characters are adjacent to the position,
  this returns null.
  */
  wordAt(e) {
    let { text: t, from: i, length: s } = this.doc.lineAt(e), r = this.charCategorizer(e), o = e - i, l = e - i;
    for (; o > 0; ) {
      let a = Re(t, o, !1);
      if (r(t.slice(a, o)) != me.Word)
        break;
      o = a;
    }
    for (; l < s; ) {
      let a = Re(t, l);
      if (r(t.slice(l, a)) != me.Word)
        break;
      l = a;
    }
    return o == l ? null : C.range(o + i, l + i);
  }
}
Z.allowMultipleSelections = Ul;
Z.tabSize = /* @__PURE__ */ I.define({
  combine: (n) => n.length ? n[0] : 4
});
Z.lineSeparator = Od;
Z.readOnly = Pd;
Z.phrases = /* @__PURE__ */ I.define({
  compare(n, e) {
    let t = Object.keys(n), i = Object.keys(e);
    return t.length == i.length && t.every((s) => n[s] == e[s]);
  }
});
Z.languageData = Dd;
Z.changeFilter = Ed;
Z.transactionFilter = Ld;
Z.transactionExtender = Rd;
Co.reconfigure = /* @__PURE__ */ K.define();
function ti(n, e, t = {}) {
  let i = {};
  for (let s of n)
    for (let r of Object.keys(s)) {
      let o = s[r], l = i[r];
      if (l === void 0)
        i[r] = o;
      else if (!(l === o || o === void 0)) if (Object.hasOwnProperty.call(t, r))
        i[r] = t[r](l, o);
      else
        throw new Error("Config merge conflict for field " + r);
    }
  for (let s in e)
    i[s] === void 0 && (i[s] = e[s]);
  return i;
}
class Xi {
  /**
  Compare this value with another value. Used when comparing
  rangesets. The default implementation compares by identity.
  Unless you are only creating a fixed number of unique instances
  of your value type, it is a good idea to implement this
  properly.
  */
  eq(e) {
    return this == e;
  }
  /**
  Create a [range](https://codemirror.net/6/docs/ref/#state.Range) with this value.
  */
  range(e, t = e) {
    return Gl.create(e, t, this);
  }
}
Xi.prototype.startSide = Xi.prototype.endSide = 0;
Xi.prototype.point = !1;
Xi.prototype.mapMode = Ee.TrackDel;
let Gl = class Nd {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.value = i;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new Nd(e, t, i);
  }
};
function Yl(n, e) {
  return n.from - e.from || n.value.startSide - e.value.startSide;
}
let k1 = class Fd {
  constructor(e, t, i, s) {
    this.from = e, this.to = t, this.value = i, this.maxPoint = s;
  }
  get length() {
    return this.to[this.to.length - 1];
  }
  // Find the index of the given position and side. Use the ranges'
  // `from` pos when `end == false`, `to` when `end == true`.
  findIndex(e, t, i, s = 0) {
    let r = i ? this.to : this.from;
    for (let o = s, l = r.length; ; ) {
      if (o == l)
        return o;
      let a = o + l >> 1, h = r[a] - e || (i ? this.value[a].endSide : this.value[a].startSide) - t;
      if (a == o)
        return h >= 0 ? o : l;
      h >= 0 ? l = a : o = a + 1;
    }
  }
  between(e, t, i, s) {
    for (let r = this.findIndex(t, -1e9, !0), o = this.findIndex(i, 1e9, !1, r); r < o; r++)
      if (s(this.from[r] + e, this.to[r] + e, this.value[r]) === !1)
        return !1;
  }
  map(e, t) {
    let i = [], s = [], r = [], o = -1, l = -1;
    for (let a = 0; a < this.value.length; a++) {
      let h = this.value[a], c = this.from[a] + e, f = this.to[a] + e, u, d;
      if (c == f) {
        let m = t.mapPos(c, h.startSide, h.mapMode);
        if (m == null || (u = d = m, h.startSide != h.endSide && (d = t.mapPos(c, h.endSide), d < u)))
          continue;
      } else if (u = t.mapPos(c, h.startSide), d = t.mapPos(f, h.endSide), u > d || u == d && h.startSide > 0 && h.endSide <= 0)
        continue;
      (d - u || h.endSide - h.startSide) < 0 || (o < 0 && (o = u), h.point && (l = Math.max(l, d - u)), i.push(h), s.push(u - o), r.push(d - o));
    }
    return { mapped: i.length ? new Fd(s, r, i, l) : null, pos: o };
  }
};
class ne {
  constructor(e, t, i, s) {
    this.chunkPos = e, this.chunk = t, this.nextLayer = i, this.maxPoint = s;
  }
  /**
  @internal
  */
  static create(e, t, i, s) {
    return new ne(e, t, i, s);
  }
  /**
  @internal
  */
  get length() {
    let e = this.chunk.length - 1;
    return e < 0 ? 0 : Math.max(this.chunkEnd(e), this.nextLayer.length);
  }
  /**
  The number of ranges in the set.
  */
  get size() {
    if (this.isEmpty)
      return 0;
    let e = this.nextLayer.size;
    for (let t of this.chunk)
      e += t.value.length;
    return e;
  }
  /**
  @internal
  */
  chunkEnd(e) {
    return this.chunkPos[e] + this.chunk[e].length;
  }
  /**
  Update the range set, optionally adding new ranges or filtering
  out existing ones.
  
  (Note: The type parameter is just there as a kludge to work
  around TypeScript variance issues that prevented `RangeSet<X>`
  from being a subtype of `RangeSet<Y>` when `X` is a subtype of
  `Y`.)
  */
  update(e) {
    let { add: t = [], sort: i = !1, filterFrom: s = 0, filterTo: r = this.length } = e, o = e.filter;
    if (t.length == 0 && !o)
      return this;
    if (i && (t = t.slice().sort(Yl)), this.isEmpty)
      return t.length ? ne.of(t) : this;
    let l = new Hd(this, null, -1).goto(0), a = 0, h = [], c = new Tt();
    for (; l.value || a < t.length; )
      if (a < t.length && (l.from - t[a].from || l.startSide - t[a].value.startSide) >= 0) {
        let f = t[a++];
        c.addInner(f.from, f.to, f.value) || h.push(f);
      } else l.rangeIndex == 1 && l.chunkIndex < this.chunk.length && (a == t.length || this.chunkEnd(l.chunkIndex) < t[a].from) && (!o || s > this.chunkEnd(l.chunkIndex) || r < this.chunkPos[l.chunkIndex]) && c.addChunk(this.chunkPos[l.chunkIndex], this.chunk[l.chunkIndex]) ? l.nextChunk() : ((!o || s > l.to || r < l.from || o(l.from, l.to, l.value)) && (c.addInner(l.from, l.to, l.value) || h.push(Gl.create(l.from, l.to, l.value))), l.next());
    return c.finishInner(this.nextLayer.isEmpty && !h.length ? ne.empty : this.nextLayer.update({ add: h, filter: o, filterFrom: s, filterTo: r }));
  }
  /**
  Map this range set through a set of changes, return the new set.
  */
  map(e) {
    if (e.empty || this.isEmpty)
      return this;
    let t = [], i = [], s = -1;
    for (let o = 0; o < this.chunk.length; o++) {
      let l = this.chunkPos[o], a = this.chunk[o], h = e.touchesRange(l, l + a.length);
      if (h === !1)
        s = Math.max(s, a.maxPoint), t.push(a), i.push(e.mapPos(l));
      else if (h === !0) {
        let { mapped: c, pos: f } = a.map(l, e);
        c && (s = Math.max(s, c.maxPoint), t.push(c), i.push(f));
      }
    }
    let r = this.nextLayer.map(e);
    return t.length == 0 ? r : new ne(i, t, r || ne.empty, s);
  }
  /**
  Iterate over the ranges that touch the region `from` to `to`,
  calling `f` for each. There is no guarantee that the ranges will
  be reported in any specific order. When the callback returns
  `false`, iteration stops.
  */
  between(e, t, i) {
    if (!this.isEmpty) {
      for (let s = 0; s < this.chunk.length; s++) {
        let r = this.chunkPos[s], o = this.chunk[s];
        if (t >= r && e <= r + o.length && o.between(r, e - r, t - r, i) === !1)
          return;
      }
      this.nextLayer.between(e, t, i);
    }
  }
  /**
  Iterate over the ranges in this set, in order, including all
  ranges that end at or after `from`.
  */
  iter(e = 0) {
    return Ts.from([this]).goto(e);
  }
  /**
  @internal
  */
  get isEmpty() {
    return this.nextLayer == this;
  }
  /**
  Iterate over the ranges in a collection of sets, in order,
  starting from `from`.
  */
  static iter(e, t = 0) {
    return Ts.from(e).goto(t);
  }
  /**
  Iterate over two groups of sets, calling methods on `comparator`
  to notify it of possible differences.
  */
  static compare(e, t, i, s, r = -1) {
    let o = e.filter((f) => f.maxPoint > 0 || !f.isEmpty && f.maxPoint >= r), l = t.filter((f) => f.maxPoint > 0 || !f.isEmpty && f.maxPoint >= r), a = cc(o, l, i), h = new Zn(o, a, r), c = new Zn(l, a, r);
    i.iterGaps((f, u, d) => fc(h, f, c, u, d, s)), i.empty && i.length == 0 && fc(h, 0, c, 0, 0, s);
  }
  /**
  Compare the contents of two groups of range sets, returning true
  if they are equivalent in the given range.
  */
  static eq(e, t, i = 0, s) {
    s == null && (s = 999999999);
    let r = e.filter((c) => !c.isEmpty && t.indexOf(c) < 0), o = t.filter((c) => !c.isEmpty && e.indexOf(c) < 0);
    if (r.length != o.length)
      return !1;
    if (!r.length)
      return !0;
    let l = cc(r, o), a = new Zn(r, l, 0).goto(i), h = new Zn(o, l, 0).goto(i);
    for (; ; ) {
      if (a.to != h.to || !Xl(a.active, h.active) || a.point && (!h.point || !a.point.eq(h.point)))
        return !1;
      if (a.to > s)
        return !0;
      a.next(), h.next();
    }
  }
  /**
  Iterate over a group of range sets at the same time, notifying
  the iterator about the ranges covering every given piece of
  content. Returns the open count (see
  [`SpanIterator.span`](https://codemirror.net/6/docs/ref/#state.SpanIterator.span)) at the end
  of the iteration.
  */
  static spans(e, t, i, s, r = -1) {
    let o = new Zn(e, null, r).goto(t), l = t, a = o.openStart;
    for (; ; ) {
      let h = Math.min(o.to, i);
      if (o.point) {
        let c = o.activeForPoint(o.to), f = o.pointFrom < t ? c.length + 1 : o.point.startSide < 0 ? c.length : Math.min(c.length, a);
        s.point(l, h, o.point, c, f, o.pointRank), a = Math.min(o.openEnd(h), c.length);
      } else h > l && (s.span(l, h, o.active, a), a = o.openEnd(h));
      if (o.to > i)
        return a + (o.point && o.to > i ? 1 : 0);
      l = o.to, o.next();
    }
  }
  /**
  Create a range set for the given range or array of ranges. By
  default, this expects the ranges to be _sorted_ (by start
  position and, if two start at the same position,
  `value.startSide`). You can pass `true` as second argument to
  cause the method to sort them.
  */
  static of(e, t = !1) {
    let i = new Tt();
    for (let s of e instanceof Gl ? [e] : t ? v1(e) : e)
      i.add(s.from, s.to, s.value);
    return i.finish();
  }
  /**
  Join an array of range sets into a single set.
  */
  static join(e) {
    if (!e.length)
      return ne.empty;
    let t = e[e.length - 1];
    for (let i = e.length - 2; i >= 0; i--)
      for (let s = e[i]; s != ne.empty; s = s.nextLayer)
        t = new ne(s.chunkPos, s.chunk, t, Math.max(s.maxPoint, t.maxPoint));
    return t;
  }
}
ne.empty = /* @__PURE__ */ new ne([], [], null, -1);
function v1(n) {
  if (n.length > 1)
    for (let e = n[0], t = 1; t < n.length; t++) {
      let i = n[t];
      if (Yl(e, i) > 0)
        return n.slice().sort(Yl);
      e = i;
    }
  return n;
}
ne.empty.nextLayer = ne.empty;
class Tt {
  finishChunk(e) {
    this.chunks.push(new k1(this.from, this.to, this.value, this.maxPoint)), this.chunkPos.push(this.chunkStart), this.chunkStart = -1, this.setMaxPoint = Math.max(this.setMaxPoint, this.maxPoint), this.maxPoint = -1, e && (this.from = [], this.to = [], this.value = []);
  }
  /**
  Create an empty builder.
  */
  constructor() {
    this.chunks = [], this.chunkPos = [], this.chunkStart = -1, this.last = null, this.lastFrom = -1e9, this.lastTo = -1e9, this.from = [], this.to = [], this.value = [], this.maxPoint = -1, this.setMaxPoint = -1, this.nextLayer = null;
  }
  /**
  Add a range. Ranges should be added in sorted (by `from` and
  `value.startSide`) order.
  */
  add(e, t, i) {
    this.addInner(e, t, i) || (this.nextLayer || (this.nextLayer = new Tt())).add(e, t, i);
  }
  /**
  @internal
  */
  addInner(e, t, i) {
    let s = e - this.lastTo || i.startSide - this.last.endSide;
    if (s <= 0 && (e - this.lastFrom || i.startSide - this.last.startSide) < 0)
      throw new Error("Ranges must be added sorted by `from` position and `startSide`");
    return s < 0 ? !1 : (this.from.length == 250 && this.finishChunk(!0), this.chunkStart < 0 && (this.chunkStart = e), this.from.push(e - this.chunkStart), this.to.push(t - this.chunkStart), this.last = i, this.lastFrom = e, this.lastTo = t, this.value.push(i), i.point && (this.maxPoint = Math.max(this.maxPoint, t - e)), !0);
  }
  /**
  @internal
  */
  addChunk(e, t) {
    if ((e - this.lastTo || t.value[0].startSide - this.last.endSide) < 0)
      return !1;
    this.from.length && this.finishChunk(!0), this.setMaxPoint = Math.max(this.setMaxPoint, t.maxPoint), this.chunks.push(t), this.chunkPos.push(e);
    let i = t.value.length - 1;
    return this.last = t.value[i], this.lastFrom = t.from[i] + e, this.lastTo = t.to[i] + e, !0;
  }
  /**
  Finish the range set. Returns the new set. The builder can't be
  used anymore after this has been called.
  */
  finish() {
    return this.finishInner(ne.empty);
  }
  /**
  @internal
  */
  finishInner(e) {
    if (this.from.length && this.finishChunk(!1), this.chunks.length == 0)
      return e;
    let t = ne.create(this.chunkPos, this.chunks, this.nextLayer ? this.nextLayer.finishInner(e) : e, this.setMaxPoint);
    return this.from = null, t;
  }
}
function cc(n, e, t) {
  let i = /* @__PURE__ */ new Map();
  for (let r of n)
    for (let o = 0; o < r.chunk.length; o++)
      r.chunk[o].maxPoint <= 0 && i.set(r.chunk[o], r.chunkPos[o]);
  let s = /* @__PURE__ */ new Set();
  for (let r of e)
    for (let o = 0; o < r.chunk.length; o++) {
      let l = i.get(r.chunk[o]);
      l != null && (t ? t.mapPos(l) : l) == r.chunkPos[o] && !(t != null && t.touchesRange(l, l + r.chunk[o].length)) && s.add(r.chunk[o]);
    }
  return s;
}
class Hd {
  constructor(e, t, i, s = 0) {
    this.layer = e, this.skip = t, this.minPoint = i, this.rank = s;
  }
  get startSide() {
    return this.value ? this.value.startSide : 0;
  }
  get endSide() {
    return this.value ? this.value.endSide : 0;
  }
  goto(e, t = -1e9) {
    return this.chunkIndex = this.rangeIndex = 0, this.gotoInner(e, t, !1), this;
  }
  gotoInner(e, t, i) {
    for (; this.chunkIndex < this.layer.chunk.length; ) {
      let s = this.layer.chunk[this.chunkIndex];
      if (!(this.skip && this.skip.has(s) || this.layer.chunkEnd(this.chunkIndex) < e || s.maxPoint < this.minPoint))
        break;
      this.chunkIndex++, i = !1;
    }
    if (this.chunkIndex < this.layer.chunk.length) {
      let s = this.layer.chunk[this.chunkIndex].findIndex(e - this.layer.chunkPos[this.chunkIndex], t, !0);
      (!i || this.rangeIndex < s) && this.setRangeIndex(s);
    }
    this.next();
  }
  forward(e, t) {
    (this.to - e || this.endSide - t) < 0 && this.gotoInner(e, t, !0);
  }
  next() {
    for (; ; )
      if (this.chunkIndex == this.layer.chunk.length) {
        this.from = this.to = 1e9, this.value = null;
        break;
      } else {
        let e = this.layer.chunkPos[this.chunkIndex], t = this.layer.chunk[this.chunkIndex], i = e + t.from[this.rangeIndex];
        if (this.from = i, this.to = e + t.to[this.rangeIndex], this.value = t.value[this.rangeIndex], this.setRangeIndex(this.rangeIndex + 1), this.minPoint < 0 || this.value.point && this.to - this.from >= this.minPoint)
          break;
      }
  }
  setRangeIndex(e) {
    if (e == this.layer.chunk[this.chunkIndex].value.length) {
      if (this.chunkIndex++, this.skip)
        for (; this.chunkIndex < this.layer.chunk.length && this.skip.has(this.layer.chunk[this.chunkIndex]); )
          this.chunkIndex++;
      this.rangeIndex = 0;
    } else
      this.rangeIndex = e;
  }
  nextChunk() {
    this.chunkIndex++, this.rangeIndex = 0, this.next();
  }
  compare(e) {
    return this.from - e.from || this.startSide - e.startSide || this.rank - e.rank || this.to - e.to || this.endSide - e.endSide;
  }
}
class Ts {
  constructor(e) {
    this.heap = e;
  }
  static from(e, t = null, i = -1) {
    let s = [];
    for (let r = 0; r < e.length; r++)
      for (let o = e[r]; !o.isEmpty; o = o.nextLayer)
        o.maxPoint >= i && s.push(new Hd(o, t, i, r));
    return s.length == 1 ? s[0] : new Ts(s);
  }
  get startSide() {
    return this.value ? this.value.startSide : 0;
  }
  goto(e, t = -1e9) {
    for (let i of this.heap)
      i.goto(e, t);
    for (let i = this.heap.length >> 1; i >= 0; i--)
      jo(this.heap, i);
    return this.next(), this;
  }
  forward(e, t) {
    for (let i of this.heap)
      i.forward(e, t);
    for (let i = this.heap.length >> 1; i >= 0; i--)
      jo(this.heap, i);
    (this.to - e || this.value.endSide - t) < 0 && this.next();
  }
  next() {
    if (this.heap.length == 0)
      this.from = this.to = 1e9, this.value = null, this.rank = -1;
    else {
      let e = this.heap[0];
      this.from = e.from, this.to = e.to, this.value = e.value, this.rank = e.rank, e.value && e.next(), jo(this.heap, 0);
    }
  }
}
function jo(n, e) {
  for (let t = n[e]; ; ) {
    let i = (e << 1) + 1;
    if (i >= n.length)
      break;
    let s = n[i];
    if (i + 1 < n.length && s.compare(n[i + 1]) >= 0 && (s = n[i + 1], i++), t.compare(s) < 0)
      break;
    n[i] = t, n[e] = s, e = i;
  }
}
class Zn {
  constructor(e, t, i) {
    this.minPoint = i, this.active = [], this.activeTo = [], this.activeRank = [], this.minActive = -1, this.point = null, this.pointFrom = 0, this.pointRank = 0, this.to = -1e9, this.endSide = 0, this.openStart = -1, this.cursor = Ts.from(e, t, i);
  }
  goto(e, t = -1e9) {
    return this.cursor.goto(e, t), this.active.length = this.activeTo.length = this.activeRank.length = 0, this.minActive = -1, this.to = e, this.endSide = t, this.openStart = -1, this.next(), this;
  }
  forward(e, t) {
    for (; this.minActive > -1 && (this.activeTo[this.minActive] - e || this.active[this.minActive].endSide - t) < 0; )
      this.removeActive(this.minActive);
    this.cursor.forward(e, t);
  }
  removeActive(e) {
    rr(this.active, e), rr(this.activeTo, e), rr(this.activeRank, e), this.minActive = uc(this.active, this.activeTo);
  }
  addActive(e) {
    let t = 0, { value: i, to: s, rank: r } = this.cursor;
    for (; t < this.activeRank.length && (r - this.activeRank[t] || s - this.activeTo[t]) > 0; )
      t++;
    or(this.active, t, i), or(this.activeTo, t, s), or(this.activeRank, t, r), e && or(e, t, this.cursor.from), this.minActive = uc(this.active, this.activeTo);
  }
  // After calling this, if `this.point` != null, the next range is a
  // point. Otherwise, it's a regular range, covered by `this.active`.
  next() {
    let e = this.to, t = this.point;
    this.point = null;
    let i = this.openStart < 0 ? [] : null;
    for (; ; ) {
      let s = this.minActive;
      if (s > -1 && (this.activeTo[s] - this.cursor.from || this.active[s].endSide - this.cursor.startSide) < 0) {
        if (this.activeTo[s] > e) {
          this.to = this.activeTo[s], this.endSide = this.active[s].endSide;
          break;
        }
        this.removeActive(s), i && rr(i, s);
      } else if (this.cursor.value)
        if (this.cursor.from > e) {
          this.to = this.cursor.from, this.endSide = this.cursor.startSide;
          break;
        } else {
          let r = this.cursor.value;
          if (!r.point)
            this.addActive(i), this.cursor.next();
          else if (t && this.cursor.to == this.to && this.cursor.from < this.cursor.to)
            this.cursor.next();
          else {
            this.point = r, this.pointFrom = this.cursor.from, this.pointRank = this.cursor.rank, this.to = this.cursor.to, this.endSide = r.endSide, this.cursor.next(), this.forward(this.to, this.endSide);
            break;
          }
        }
      else {
        this.to = this.endSide = 1e9;
        break;
      }
    }
    if (i) {
      this.openStart = 0;
      for (let s = i.length - 1; s >= 0 && i[s] < e; s--)
        this.openStart++;
    }
  }
  activeForPoint(e) {
    if (!this.active.length)
      return this.active;
    let t = [];
    for (let i = this.active.length - 1; i >= 0 && !(this.activeRank[i] < this.pointRank); i--)
      (this.activeTo[i] > e || this.activeTo[i] == e && this.active[i].endSide >= this.point.endSide) && t.push(this.active[i]);
    return t.reverse();
  }
  openEnd(e) {
    let t = 0;
    for (let i = this.activeTo.length - 1; i >= 0 && this.activeTo[i] > e; i--)
      t++;
    return t;
  }
}
function fc(n, e, t, i, s, r) {
  n.goto(e), t.goto(i);
  let o = i + s, l = i, a = i - e;
  for (; ; ) {
    let h = n.to + a - t.to || n.endSide - t.endSide, c = h < 0 ? n.to + a : t.to, f = Math.min(c, o);
    if (n.point || t.point ? n.point && t.point && (n.point == t.point || n.point.eq(t.point)) && Xl(n.activeForPoint(n.to), t.activeForPoint(t.to)) || r.comparePoint(l, f, n.point, t.point) : f > l && !Xl(n.active, t.active) && r.compareRange(l, f, n.active, t.active), c > o)
      break;
    l = c, h <= 0 && n.next(), h >= 0 && t.next();
  }
}
function Xl(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++)
    if (n[t] != e[t] && !n[t].eq(e[t]))
      return !1;
  return !0;
}
function rr(n, e) {
  for (let t = e, i = n.length - 1; t < i; t++)
    n[t] = n[t + 1];
  n.pop();
}
function or(n, e, t) {
  for (let i = n.length - 1; i >= e; i--)
    n[i + 1] = n[i];
  n[e] = t;
}
function uc(n, e) {
  let t = -1, i = 1e9;
  for (let s = 0; s < e.length; s++)
    (e[s] - i || n[s].endSide - n[t].endSide) < 0 && (t = s, i = e[s]);
  return t;
}
function Wn(n, e, t = n.length) {
  let i = 0;
  for (let s = 0; s < t; )
    n.charCodeAt(s) == 9 ? (i += e - i % e, s++) : (i++, s = Re(n, s));
  return i;
}
function Jl(n, e, t, i) {
  for (let s = 0, r = 0; ; ) {
    if (r >= e)
      return s;
    if (s == n.length)
      break;
    r += n.charCodeAt(s) == 9 ? t - r % t : 1, s = Re(n, s);
  }
  return i === !0 ? -1 : n.length;
}
const Ql = "ͼ", dc = typeof Symbol > "u" ? "__" + Ql : Symbol.for(Ql), Zl = typeof Symbol > "u" ? "__styleSet" + Math.floor(Math.random() * 1e8) : Symbol("styleSet"), mc = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : {};
class Di {
  // :: (Object<Style>, ?{finish: ?(string) → string})
  // Create a style module from the given spec.
  //
  // When `finish` is given, it is called on regular (non-`@`)
  // selectors (after `&` expansion) to compute the final selector.
  constructor(e, t) {
    this.rules = [];
    let { finish: i } = t || {};
    function s(o) {
      return /^@/.test(o) ? [o] : o.split(/,\s*/);
    }
    function r(o, l, a, h) {
      let c = [], f = /^@(\w+)\b/.exec(o[0]), u = f && f[1] == "keyframes";
      if (f && l == null) return a.push(o[0] + ";");
      for (let d in l) {
        let m = l[d];
        if (/&/.test(d))
          r(
            d.split(/,\s*/).map((p) => o.map((g) => p.replace(/&/, g))).reduce((p, g) => p.concat(g)),
            m,
            a
          );
        else if (m && typeof m == "object") {
          if (!f) throw new RangeError("The value of a property (" + d + ") should be a primitive value.");
          r(s(d), m, c, u);
        } else m != null && c.push(d.replace(/_.*/, "").replace(/[A-Z]/g, (p) => "-" + p.toLowerCase()) + ": " + m + ";");
      }
      (c.length || u) && a.push((i && !f && !h ? o.map(i) : o).join(", ") + " {" + c.join(" ") + "}");
    }
    for (let o in e) r(s(o), e[o], this.rules);
  }
  // :: () → string
  // Returns a string containing the module's CSS rules.
  getRules() {
    return this.rules.join(`
`);
  }
  // :: () → string
  // Generate a new unique CSS class name.
  static newName() {
    let e = mc[dc] || 1;
    return mc[dc] = e + 1, Ql + e.toString(36);
  }
  // :: (union<Document, ShadowRoot>, union<[StyleModule], StyleModule>, ?{nonce: ?string})
  //
  // Mount the given set of modules in the given DOM root, which ensures
  // that the CSS rules defined by the module are available in that
  // context.
  //
  // Rules are only added to the document once per root.
  //
  // Rule order will follow the order of the modules, so that rules from
  // modules later in the array take precedence of those from earlier
  // modules. If you call this function multiple times for the same root
  // in a way that changes the order of already mounted modules, the old
  // order will be changed.
  //
  // If a Content Security Policy nonce is provided, it is added to
  // the `<style>` tag generated by the library.
  static mount(e, t, i) {
    let s = e[Zl], r = i && i.nonce;
    s ? r && s.setNonce(r) : s = new x1(e, r), s.mount(Array.isArray(t) ? t : [t], e);
  }
}
let pc = /* @__PURE__ */ new Map();
class x1 {
  constructor(e, t) {
    let i = e.ownerDocument || e, s = i.defaultView;
    if (!e.head && e.adoptedStyleSheets && s.CSSStyleSheet) {
      let r = pc.get(i);
      if (r) return e[Zl] = r;
      this.sheet = new s.CSSStyleSheet(), pc.set(i, this);
    } else
      this.styleTag = i.createElement("style"), t && this.styleTag.setAttribute("nonce", t);
    this.modules = [], e[Zl] = this;
  }
  mount(e, t) {
    let i = this.sheet, s = 0, r = 0;
    for (let o = 0; o < e.length; o++) {
      let l = e[o], a = this.modules.indexOf(l);
      if (a < r && a > -1 && (this.modules.splice(a, 1), r--, a = -1), a == -1) {
        if (this.modules.splice(r++, 0, l), i) for (let h = 0; h < l.rules.length; h++)
          i.insertRule(l.rules[h], s++);
      } else {
        for (; r < a; ) s += this.modules[r++].rules.length;
        s += l.rules.length, r++;
      }
    }
    if (i)
      t.adoptedStyleSheets.indexOf(this.sheet) < 0 && (t.adoptedStyleSheets = [this.sheet, ...t.adoptedStyleSheets]);
    else {
      let o = "";
      for (let a = 0; a < this.modules.length; a++)
        o += this.modules[a].getRules() + `
`;
      this.styleTag.textContent = o;
      let l = t.head || t;
      this.styleTag.parentNode != l && l.insertBefore(this.styleTag, l.firstChild);
    }
  }
  setNonce(e) {
    this.styleTag && this.styleTag.getAttribute("nonce") != e && this.styleTag.setAttribute("nonce", e);
  }
}
var Oi = {
  8: "Backspace",
  9: "Tab",
  10: "Enter",
  12: "NumLock",
  13: "Enter",
  16: "Shift",
  17: "Control",
  18: "Alt",
  20: "CapsLock",
  27: "Escape",
  32: " ",
  33: "PageUp",
  34: "PageDown",
  35: "End",
  36: "Home",
  37: "ArrowLeft",
  38: "ArrowUp",
  39: "ArrowRight",
  40: "ArrowDown",
  44: "PrintScreen",
  45: "Insert",
  46: "Delete",
  59: ";",
  61: "=",
  91: "Meta",
  92: "Meta",
  106: "*",
  107: "+",
  108: ",",
  109: "-",
  110: ".",
  111: "/",
  144: "NumLock",
  145: "ScrollLock",
  160: "Shift",
  161: "Shift",
  162: "Control",
  163: "Control",
  164: "Alt",
  165: "Alt",
  173: "-",
  186: ";",
  187: "=",
  188: ",",
  189: "-",
  190: ".",
  191: "/",
  192: "`",
  219: "[",
  220: "\\",
  221: "]",
  222: "'"
}, Ds = {
  48: ")",
  49: "!",
  50: "@",
  51: "#",
  52: "$",
  53: "%",
  54: "^",
  55: "&",
  56: "*",
  57: "(",
  59: ":",
  61: "+",
  173: "_",
  186: ":",
  187: "+",
  188: "<",
  189: "_",
  190: ">",
  191: "?",
  192: "~",
  219: "{",
  220: "|",
  221: "}",
  222: '"'
}, S1 = typeof navigator < "u" && /Mac/.test(navigator.platform), _1 = typeof navigator < "u" && /MSIE \d|Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(navigator.userAgent);
for (var Oe = 0; Oe < 10; Oe++) Oi[48 + Oe] = Oi[96 + Oe] = String(Oe);
for (var Oe = 1; Oe <= 24; Oe++) Oi[Oe + 111] = "F" + Oe;
for (var Oe = 65; Oe <= 90; Oe++)
  Oi[Oe] = String.fromCharCode(Oe + 32), Ds[Oe] = String.fromCharCode(Oe);
for (var Ko in Oi) Ds.hasOwnProperty(Ko) || (Ds[Ko] = Oi[Ko]);
function C1(n) {
  var e = S1 && n.metaKey && n.shiftKey && !n.ctrlKey && !n.altKey || _1 && n.shiftKey && n.key && n.key.length == 1 || n.key == "Unidentified", t = !e && n.key || (n.shiftKey ? Ds : Oi)[n.keyCode] || n.key || "Unidentified";
  return t == "Esc" && (t = "Escape"), t == "Del" && (t = "Delete"), t == "Left" && (t = "ArrowLeft"), t == "Up" && (t = "ArrowUp"), t == "Right" && (t = "ArrowRight"), t == "Down" && (t = "ArrowDown"), t;
}
function Os(n) {
  let e;
  return n.nodeType == 11 ? e = n.getSelection ? n : n.ownerDocument : e = n, e.getSelection();
}
function $l(n, e) {
  return e ? n == e || n.contains(e.nodeType != 1 ? e.parentNode : e) : !1;
}
function A1(n) {
  let e = n.activeElement;
  for (; e && e.shadowRoot; )
    e = e.shadowRoot.activeElement;
  return e;
}
function Hr(n, e) {
  if (!e.anchorNode)
    return !1;
  try {
    return $l(n, e.anchorNode);
  } catch {
    return !1;
  }
}
function Ln(n) {
  return n.nodeType == 3 ? Qi(n, 0, n.nodeValue.length).getClientRects() : n.nodeType == 1 ? n.getClientRects() : [];
}
function ks(n, e, t, i) {
  return t ? gc(n, e, t, i, -1) || gc(n, e, t, i, 1) : !1;
}
function Ji(n) {
  for (var e = 0; ; e++)
    if (n = n.previousSibling, !n)
      return e;
}
function Qr(n) {
  return n.nodeType == 1 && /^(DIV|P|LI|UL|OL|BLOCKQUOTE|DD|DT|H\d|SECTION|PRE)$/.test(n.nodeName);
}
function gc(n, e, t, i, s) {
  for (; ; ) {
    if (n == t && e == i)
      return !0;
    if (e == (s < 0 ? 0 : ci(n))) {
      if (n.nodeName == "DIV")
        return !1;
      let r = n.parentNode;
      if (!r || r.nodeType != 1)
        return !1;
      e = Ji(n) + (s < 0 ? 0 : 1), n = r;
    } else if (n.nodeType == 1) {
      if (n = n.childNodes[e + (s < 0 ? -1 : 0)], n.nodeType == 1 && n.contentEditable == "false")
        return !1;
      e = s < 0 ? ci(n) : 0;
    } else
      return !1;
  }
}
function ci(n) {
  return n.nodeType == 3 ? n.nodeValue.length : n.childNodes.length;
}
function Ao(n, e) {
  let t = e ? n.left : n.right;
  return { left: t, right: t, top: n.top, bottom: n.bottom };
}
function M1(n) {
  let e = n.visualViewport;
  return e ? {
    left: 0,
    right: e.width,
    top: 0,
    bottom: e.height
  } : {
    left: 0,
    right: n.innerWidth,
    top: 0,
    bottom: n.innerHeight
  };
}
function Vd(n, e) {
  let t = e.width / n.offsetWidth, i = e.height / n.offsetHeight;
  return (t > 0.995 && t < 1.005 || !isFinite(t) || Math.abs(e.width - n.offsetWidth) < 1) && (t = 1), (i > 0.995 && i < 1.005 || !isFinite(i) || Math.abs(e.height - n.offsetHeight) < 1) && (i = 1), { scaleX: t, scaleY: i };
}
function T1(n, e, t, i, s, r, o, l) {
  let a = n.ownerDocument, h = a.defaultView || window;
  for (let c = n, f = !1; c && !f; )
    if (c.nodeType == 1) {
      let u, d = c == a.body, m = 1, p = 1;
      if (d)
        u = M1(h);
      else {
        if (/^(fixed|sticky)$/.test(getComputedStyle(c).position) && (f = !0), c.scrollHeight <= c.clientHeight && c.scrollWidth <= c.clientWidth) {
          c = c.assignedSlot || c.parentNode;
          continue;
        }
        let w = c.getBoundingClientRect();
        ({ scaleX: m, scaleY: p } = Vd(c, w)), u = {
          left: w.left,
          right: w.left + c.clientWidth * m,
          top: w.top,
          bottom: w.top + c.clientHeight * p
        };
      }
      let g = 0, b = 0;
      if (s == "nearest")
        e.top < u.top ? (b = -(u.top - e.top + o), t > 0 && e.bottom > u.bottom + b && (b = e.bottom - u.bottom + b + o)) : e.bottom > u.bottom && (b = e.bottom - u.bottom + o, t < 0 && e.top - b < u.top && (b = -(u.top + b - e.top + o)));
      else {
        let w = e.bottom - e.top, k = u.bottom - u.top;
        b = (s == "center" && w <= k ? e.top + w / 2 - k / 2 : s == "start" || s == "center" && t < 0 ? e.top - o : e.bottom - k + o) - u.top;
      }
      if (i == "nearest" ? e.left < u.left ? (g = -(u.left - e.left + r), t > 0 && e.right > u.right + g && (g = e.right - u.right + g + r)) : e.right > u.right && (g = e.right - u.right + r, t < 0 && e.left < u.left + g && (g = -(u.left + g - e.left + r))) : g = (i == "center" ? e.left + (e.right - e.left) / 2 - (u.right - u.left) / 2 : i == "start" == l ? e.left - r : e.right - (u.right - u.left) + r) - u.left, g || b)
        if (d)
          h.scrollBy(g, b);
        else {
          let w = 0, k = 0;
          if (b) {
            let x = c.scrollTop;
            c.scrollTop += b / p, k = (c.scrollTop - x) * p;
          }
          if (g) {
            let x = c.scrollLeft;
            c.scrollLeft += g / m, w = (c.scrollLeft - x) * m;
          }
          e = {
            left: e.left - w,
            top: e.top - k,
            right: e.right - w,
            bottom: e.bottom - k
          }, w && Math.abs(w - g) < 1 && (i = "nearest"), k && Math.abs(k - b) < 1 && (s = "nearest");
        }
      if (d)
        break;
      c = c.assignedSlot || c.parentNode;
    } else if (c.nodeType == 11)
      c = c.host;
    else
      break;
}
function D1(n) {
  let e = n.ownerDocument, t, i;
  for (let s = n.parentNode; s && !(s == e.body || t && i); )
    if (s.nodeType == 1)
      !i && s.scrollHeight > s.clientHeight && (i = s), !t && s.scrollWidth > s.clientWidth && (t = s), s = s.assignedSlot || s.parentNode;
    else if (s.nodeType == 11)
      s = s.host;
    else
      break;
  return { x: t, y: i };
}
class O1 {
  constructor() {
    this.anchorNode = null, this.anchorOffset = 0, this.focusNode = null, this.focusOffset = 0;
  }
  eq(e) {
    return this.anchorNode == e.anchorNode && this.anchorOffset == e.anchorOffset && this.focusNode == e.focusNode && this.focusOffset == e.focusOffset;
  }
  setRange(e) {
    let { anchorNode: t, focusNode: i } = e;
    this.set(t, Math.min(e.anchorOffset, t ? ci(t) : 0), i, Math.min(e.focusOffset, i ? ci(i) : 0));
  }
  set(e, t, i, s) {
    this.anchorNode = e, this.anchorOffset = t, this.focusNode = i, this.focusOffset = s;
  }
}
let fn = null;
function Wd(n) {
  if (n.setActive)
    return n.setActive();
  if (fn)
    return n.focus(fn);
  let e = [];
  for (let t = n; t && (e.push(t, t.scrollTop, t.scrollLeft), t != t.ownerDocument); t = t.parentNode)
    ;
  if (n.focus(fn == null ? {
    get preventScroll() {
      return fn = { preventScroll: !0 }, !0;
    }
  } : void 0), !fn) {
    fn = !1;
    for (let t = 0; t < e.length; ) {
      let i = e[t++], s = e[t++], r = e[t++];
      i.scrollTop != s && (i.scrollTop = s), i.scrollLeft != r && (i.scrollLeft = r);
    }
  }
}
let bc;
function Qi(n, e, t = e) {
  let i = bc || (bc = document.createRange());
  return i.setEnd(n, t), i.setStart(n, e), i;
}
function Cn(n, e, t, i) {
  let s = { key: e, code: e, keyCode: t, which: t, cancelable: !0 };
  i && ({ altKey: s.altKey, ctrlKey: s.ctrlKey, shiftKey: s.shiftKey, metaKey: s.metaKey } = i);
  let r = new KeyboardEvent("keydown", s);
  r.synthetic = !0, n.dispatchEvent(r);
  let o = new KeyboardEvent("keyup", s);
  return o.synthetic = !0, n.dispatchEvent(o), r.defaultPrevented || o.defaultPrevented;
}
function E1(n) {
  for (; n; ) {
    if (n && (n.nodeType == 9 || n.nodeType == 11 && n.host))
      return n;
    n = n.assignedSlot || n.parentNode;
  }
  return null;
}
function zd(n) {
  for (; n.attributes.length; )
    n.removeAttributeNode(n.attributes[0]);
}
function L1(n, e) {
  let t = e.focusNode, i = e.focusOffset;
  if (!t || e.anchorNode != t || e.anchorOffset != i)
    return !1;
  for (i = Math.min(i, ci(t)); ; )
    if (i) {
      if (t.nodeType != 1)
        return !1;
      let s = t.childNodes[i - 1];
      s.contentEditable == "false" ? i-- : (t = s, i = ci(t));
    } else {
      if (t == n)
        return !0;
      i = Ji(t), t = t.parentNode;
    }
}
function qd(n) {
  return n.scrollTop > Math.max(1, n.scrollHeight - n.clientHeight - 4);
}
function Ud(n, e) {
  for (let t = n, i = e; ; ) {
    if (t.nodeType == 3 && i > 0)
      return { node: t, offset: i };
    if (t.nodeType == 1 && i > 0) {
      if (t.contentEditable == "false")
        return null;
      t = t.childNodes[i - 1], i = ci(t);
    } else if (t.parentNode && !Qr(t))
      i = Ji(t), t = t.parentNode;
    else
      return null;
  }
}
function jd(n, e) {
  for (let t = n, i = e; ; ) {
    if (t.nodeType == 3 && i < t.nodeValue.length)
      return { node: t, offset: i };
    if (t.nodeType == 1 && i < t.childNodes.length) {
      if (t.contentEditable == "false")
        return null;
      t = t.childNodes[i], i = 0;
    } else if (t.parentNode && !Qr(t))
      i = Ji(t) + 1, t = t.parentNode;
    else
      return null;
  }
}
class Ie {
  constructor(e, t, i = !0) {
    this.node = e, this.offset = t, this.precise = i;
  }
  static before(e, t) {
    return new Ie(e.parentNode, Ji(e), t);
  }
  static after(e, t) {
    return new Ie(e.parentNode, Ji(e) + 1, t);
  }
}
const Ya = [];
class ae {
  constructor() {
    this.parent = null, this.dom = null, this.flags = 2;
  }
  get overrideDOMText() {
    return null;
  }
  get posAtStart() {
    return this.parent ? this.parent.posBefore(this) : 0;
  }
  get posAtEnd() {
    return this.posAtStart + this.length;
  }
  posBefore(e) {
    let t = this.posAtStart;
    for (let i of this.children) {
      if (i == e)
        return t;
      t += i.length + i.breakAfter;
    }
    throw new RangeError("Invalid child in posBefore");
  }
  posAfter(e) {
    return this.posBefore(e) + e.length;
  }
  sync(e, t) {
    if (this.flags & 2) {
      let i = this.dom, s = null, r;
      for (let o of this.children) {
        if (o.flags & 7) {
          if (!o.dom && (r = s ? s.nextSibling : i.firstChild)) {
            let l = ae.get(r);
            (!l || !l.parent && l.canReuseDOM(o)) && o.reuseDOM(r);
          }
          o.sync(e, t), o.flags &= -8;
        }
        if (r = s ? s.nextSibling : i.firstChild, t && !t.written && t.node == i && r != o.dom && (t.written = !0), o.dom.parentNode == i)
          for (; r && r != o.dom; )
            r = yc(r);
        else
          i.insertBefore(o.dom, r);
        s = o.dom;
      }
      for (r = s ? s.nextSibling : i.firstChild, r && t && t.node == i && (t.written = !0); r; )
        r = yc(r);
    } else if (this.flags & 1)
      for (let i of this.children)
        i.flags & 7 && (i.sync(e, t), i.flags &= -8);
  }
  reuseDOM(e) {
  }
  localPosFromDOM(e, t) {
    let i;
    if (e == this.dom)
      i = this.dom.childNodes[t];
    else {
      let s = ci(e) == 0 ? 0 : t == 0 ? -1 : 1;
      for (; ; ) {
        let r = e.parentNode;
        if (r == this.dom)
          break;
        s == 0 && r.firstChild != r.lastChild && (e == r.firstChild ? s = -1 : s = 1), e = r;
      }
      s < 0 ? i = e : i = e.nextSibling;
    }
    if (i == this.dom.firstChild)
      return 0;
    for (; i && !ae.get(i); )
      i = i.nextSibling;
    if (!i)
      return this.length;
    for (let s = 0, r = 0; ; s++) {
      let o = this.children[s];
      if (o.dom == i)
        return r;
      r += o.length + o.breakAfter;
    }
  }
  domBoundsAround(e, t, i = 0) {
    let s = -1, r = -1, o = -1, l = -1;
    for (let a = 0, h = i, c = i; a < this.children.length; a++) {
      let f = this.children[a], u = h + f.length;
      if (h < e && u > t)
        return f.domBoundsAround(e, t, h);
      if (u >= e && s == -1 && (s = a, r = h), h > t && f.dom.parentNode == this.dom) {
        o = a, l = c;
        break;
      }
      c = u, h = u + f.breakAfter;
    }
    return {
      from: r,
      to: l < 0 ? i + this.length : l,
      startDOM: (s ? this.children[s - 1].dom.nextSibling : null) || this.dom.firstChild,
      endDOM: o < this.children.length && o >= 0 ? this.children[o].dom : null
    };
  }
  markDirty(e = !1) {
    this.flags |= 2, this.markParentsDirty(e);
  }
  markParentsDirty(e) {
    for (let t = this.parent; t; t = t.parent) {
      if (e && (t.flags |= 2), t.flags & 1)
        return;
      t.flags |= 1, e = !1;
    }
  }
  setParent(e) {
    this.parent != e && (this.parent = e, this.flags & 7 && this.markParentsDirty(!0));
  }
  setDOM(e) {
    this.dom != e && (this.dom && (this.dom.cmView = null), this.dom = e, e.cmView = this);
  }
  get rootView() {
    for (let e = this; ; ) {
      let t = e.parent;
      if (!t)
        return e;
      e = t;
    }
  }
  replaceChildren(e, t, i = Ya) {
    this.markDirty();
    for (let s = e; s < t; s++) {
      let r = this.children[s];
      r.parent == this && i.indexOf(r) < 0 && r.destroy();
    }
    this.children.splice(e, t - e, ...i);
    for (let s = 0; s < i.length; s++)
      i[s].setParent(this);
  }
  ignoreMutation(e) {
    return !1;
  }
  ignoreEvent(e) {
    return !1;
  }
  childCursor(e = this.length) {
    return new Kd(this.children, e, this.children.length);
  }
  childPos(e, t = 1) {
    return this.childCursor().findPos(e, t);
  }
  toString() {
    let e = this.constructor.name.replace("View", "");
    return e + (this.children.length ? "(" + this.children.join() + ")" : this.length ? "[" + (e == "Text" ? this.text : this.length) + "]" : "") + (this.breakAfter ? "#" : "");
  }
  static get(e) {
    return e.cmView;
  }
  get isEditable() {
    return !0;
  }
  get isWidget() {
    return !1;
  }
  get isHidden() {
    return !1;
  }
  merge(e, t, i, s, r, o) {
    return !1;
  }
  become(e) {
    return !1;
  }
  canReuseDOM(e) {
    return e.constructor == this.constructor && !((this.flags | e.flags) & 8);
  }
  // When this is a zero-length view with a side, this should return a
  // number <= 0 to indicate it is before its position, or a
  // number > 0 when after its position.
  getSide() {
    return 0;
  }
  destroy() {
    for (let e of this.children)
      e.parent == this && e.destroy();
    this.parent = null;
  }
}
ae.prototype.breakAfter = 0;
function yc(n) {
  let e = n.nextSibling;
  return n.parentNode.removeChild(n), e;
}
class Kd {
  constructor(e, t, i) {
    this.children = e, this.pos = t, this.i = i, this.off = 0;
  }
  findPos(e, t = 1) {
    for (; ; ) {
      if (e > this.pos || e == this.pos && (t > 0 || this.i == 0 || this.children[this.i - 1].breakAfter))
        return this.off = e - this.pos, this;
      let i = this.children[--this.i];
      this.pos -= i.length + i.breakAfter;
    }
  }
}
function Gd(n, e, t, i, s, r, o, l, a) {
  let { children: h } = n, c = h.length ? h[e] : null, f = r.length ? r[r.length - 1] : null, u = f ? f.breakAfter : o;
  if (!(e == i && c && !o && !u && r.length < 2 && c.merge(t, s, r.length ? f : null, t == 0, l, a))) {
    if (i < h.length) {
      let d = h[i];
      d && (s < d.length || d.breakAfter && (f != null && f.breakAfter)) ? (e == i && (d = d.split(s), s = 0), !u && f && d.merge(0, s, f, !0, 0, a) ? r[r.length - 1] = d : ((s || d.children.length && !d.children[0].length) && d.merge(0, s, null, !1, 0, a), r.push(d))) : d != null && d.breakAfter && (f ? f.breakAfter = 1 : o = 1), i++;
    }
    for (c && (c.breakAfter = o, t > 0 && (!o && r.length && c.merge(t, c.length, r[0], !1, l, 0) ? c.breakAfter = r.shift().breakAfter : (t < c.length || c.children.length && c.children[c.children.length - 1].length == 0) && c.merge(t, c.length, null, !1, l, 0), e++)); e < i && r.length; )
      if (h[i - 1].become(r[r.length - 1]))
        i--, r.pop(), a = r.length ? 0 : l;
      else if (h[e].become(r[0]))
        e++, r.shift(), l = r.length ? 0 : a;
      else
        break;
    !r.length && e && i < h.length && !h[e - 1].breakAfter && h[i].merge(0, 0, h[e - 1], !1, l, a) && e--, (e < i || r.length) && n.replaceChildren(e, i, r);
  }
}
function Yd(n, e, t, i, s, r) {
  let o = n.childCursor(), { i: l, off: a } = o.findPos(t, 1), { i: h, off: c } = o.findPos(e, -1), f = e - t;
  for (let u of i)
    f += u.length;
  n.length += f, Gd(n, h, c, l, a, i, 0, s, r);
}
let Ye = typeof navigator < "u" ? navigator : { userAgent: "", vendor: "", platform: "" }, ea = typeof document < "u" ? document : { documentElement: { style: {} } };
const ta = /* @__PURE__ */ /Edge\/(\d+)/.exec(Ye.userAgent), Xd = /* @__PURE__ */ /MSIE \d/.test(Ye.userAgent), ia = /* @__PURE__ */ /Trident\/(?:[7-9]|\d{2,})\..*rv:(\d+)/.exec(Ye.userAgent), Mo = !!(Xd || ia || ta), wc = !Mo && /* @__PURE__ */ /gecko\/(\d+)/i.test(Ye.userAgent), Go = !Mo && /* @__PURE__ */ /Chrome\/(\d+)/.exec(Ye.userAgent), kc = "webkitFontSmoothing" in ea.documentElement.style, Jd = !Mo && /* @__PURE__ */ /Apple Computer/.test(Ye.vendor), vc = Jd && (/* @__PURE__ */ /Mobile\/\w+/.test(Ye.userAgent) || Ye.maxTouchPoints > 2);
var B = {
  mac: vc || /* @__PURE__ */ /Mac/.test(Ye.platform),
  windows: /* @__PURE__ */ /Win/.test(Ye.platform),
  linux: /* @__PURE__ */ /Linux|X11/.test(Ye.platform),
  ie: Mo,
  ie_version: Xd ? ea.documentMode || 6 : ia ? +ia[1] : ta ? +ta[1] : 0,
  gecko: wc,
  gecko_version: wc ? +(/* @__PURE__ */ /Firefox\/(\d+)/.exec(Ye.userAgent) || [0, 0])[1] : 0,
  chrome: !!Go,
  chrome_version: Go ? +Go[1] : 0,
  ios: vc,
  android: /* @__PURE__ */ /Android\b/.test(Ye.userAgent),
  webkit: kc,
  safari: Jd,
  webkit_version: kc ? +(/* @__PURE__ */ /\bAppleWebKit\/(\d+)/.exec(Ye.userAgent) || [0, 0])[1] : 0,
  tabSize: ea.documentElement.style.tabSize != null ? "tab-size" : "-moz-tab-size"
};
const R1 = 256;
class Dt extends ae {
  constructor(e) {
    super(), this.text = e;
  }
  get length() {
    return this.text.length;
  }
  createDOM(e) {
    this.setDOM(e || document.createTextNode(this.text));
  }
  sync(e, t) {
    this.dom || this.createDOM(), this.dom.nodeValue != this.text && (t && t.node == this.dom && (t.written = !0), this.dom.nodeValue = this.text);
  }
  reuseDOM(e) {
    e.nodeType == 3 && this.createDOM(e);
  }
  merge(e, t, i) {
    return this.flags & 8 || i && (!(i instanceof Dt) || this.length - (t - e) + i.length > R1 || i.flags & 8) ? !1 : (this.text = this.text.slice(0, e) + (i ? i.text : "") + this.text.slice(t), this.markDirty(), !0);
  }
  split(e) {
    let t = new Dt(this.text.slice(e));
    return this.text = this.text.slice(0, e), this.markDirty(), t.flags |= this.flags & 8, t;
  }
  localPosFromDOM(e, t) {
    return e == this.dom ? t : t ? this.text.length : 0;
  }
  domAtPos(e) {
    return new Ie(this.dom, e);
  }
  domBoundsAround(e, t, i) {
    return { from: i, to: i + this.length, startDOM: this.dom, endDOM: this.dom.nextSibling };
  }
  coordsAt(e, t) {
    return P1(this.dom, e, t);
  }
}
class fi extends ae {
  constructor(e, t = [], i = 0) {
    super(), this.mark = e, this.children = t, this.length = i;
    for (let s of t)
      s.setParent(this);
  }
  setAttrs(e) {
    if (zd(e), this.mark.class && (e.className = this.mark.class), this.mark.attrs)
      for (let t in this.mark.attrs)
        e.setAttribute(t, this.mark.attrs[t]);
    return e;
  }
  canReuseDOM(e) {
    return super.canReuseDOM(e) && !((this.flags | e.flags) & 8);
  }
  reuseDOM(e) {
    e.nodeName == this.mark.tagName.toUpperCase() && (this.setDOM(e), this.flags |= 6);
  }
  sync(e, t) {
    this.dom ? this.flags & 4 && this.setAttrs(this.dom) : this.setDOM(this.setAttrs(document.createElement(this.mark.tagName))), super.sync(e, t);
  }
  merge(e, t, i, s, r, o) {
    return i && (!(i instanceof fi && i.mark.eq(this.mark)) || e && r <= 0 || t < this.length && o <= 0) ? !1 : (Yd(this, e, t, i ? i.children.slice() : [], r - 1, o - 1), this.markDirty(), !0);
  }
  split(e) {
    let t = [], i = 0, s = -1, r = 0;
    for (let l of this.children) {
      let a = i + l.length;
      a > e && t.push(i < e ? l.split(e - i) : l), s < 0 && i >= e && (s = r), i = a, r++;
    }
    let o = this.length - e;
    return this.length = e, s > -1 && (this.children.length = s, this.markDirty()), new fi(this.mark, t, o);
  }
  domAtPos(e) {
    return Qd(this, e);
  }
  coordsAt(e, t) {
    return $d(this, e, t);
  }
}
function P1(n, e, t) {
  let i = n.nodeValue.length;
  e > i && (e = i);
  let s = e, r = e, o = 0;
  e == 0 && t < 0 || e == i && t >= 0 ? B.chrome || B.gecko || (e ? (s--, o = 1) : r < i && (r++, o = -1)) : t < 0 ? s-- : r < i && r++;
  let l = Qi(n, s, r).getClientRects();
  if (!l.length)
    return null;
  let a = l[(o ? o < 0 : t >= 0) ? 0 : l.length - 1];
  return B.safari && !o && a.width == 0 && (a = Array.prototype.find.call(l, (h) => h.width) || a), o ? Ao(a, o < 0) : a || null;
}
class _i extends ae {
  static create(e, t, i) {
    return new _i(e, t, i);
  }
  constructor(e, t, i) {
    super(), this.widget = e, this.length = t, this.side = i, this.prevWidget = null;
  }
  split(e) {
    let t = _i.create(this.widget, this.length - e, this.side);
    return this.length -= e, t;
  }
  sync(e) {
    (!this.dom || !this.widget.updateDOM(this.dom, e)) && (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(e)), this.widget.editable || (this.dom.contentEditable = "false"));
  }
  getSide() {
    return this.side;
  }
  merge(e, t, i, s, r, o) {
    return i && (!(i instanceof _i) || !this.widget.compare(i.widget) || e > 0 && r <= 0 || t < this.length && o <= 0) ? !1 : (this.length = e + (i ? i.length : 0) + (this.length - t), !0);
  }
  become(e) {
    return e instanceof _i && e.side == this.side && this.widget.constructor == e.widget.constructor ? (this.widget.compare(e.widget) || this.markDirty(!0), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e.widget, this.length = e.length, !0) : !1;
  }
  ignoreMutation() {
    return !0;
  }
  ignoreEvent(e) {
    return this.widget.ignoreEvent(e);
  }
  get overrideDOMText() {
    if (this.length == 0)
      return ie.empty;
    let e = this;
    for (; e.parent; )
      e = e.parent;
    let { view: t } = e, i = t && t.state.doc, s = this.posAtStart;
    return i ? i.slice(s, s + this.length) : ie.empty;
  }
  domAtPos(e) {
    return (this.length ? e == 0 : this.side > 0) ? Ie.before(this.dom) : Ie.after(this.dom, e == this.length);
  }
  domBoundsAround() {
    return null;
  }
  coordsAt(e, t) {
    let i = this.widget.coordsAt(this.dom, e, t);
    if (i)
      return i;
    let s = this.dom.getClientRects(), r = null;
    if (!s.length)
      return null;
    let o = this.side ? this.side < 0 : e > 0;
    for (let l = o ? s.length - 1 : 0; r = s[l], !(e > 0 ? l == 0 : l == s.length - 1 || r.top < r.bottom); l += o ? -1 : 1)
      ;
    return Ao(r, !o);
  }
  get isEditable() {
    return !1;
  }
  get isWidget() {
    return !0;
  }
  get isHidden() {
    return this.widget.isHidden;
  }
  destroy() {
    super.destroy(), this.dom && this.widget.destroy(this.dom);
  }
}
class Rn extends ae {
  constructor(e) {
    super(), this.side = e;
  }
  get length() {
    return 0;
  }
  merge() {
    return !1;
  }
  become(e) {
    return e instanceof Rn && e.side == this.side;
  }
  split() {
    return new Rn(this.side);
  }
  sync() {
    if (!this.dom) {
      let e = document.createElement("img");
      e.className = "cm-widgetBuffer", e.setAttribute("aria-hidden", "true"), this.setDOM(e);
    }
  }
  getSide() {
    return this.side;
  }
  domAtPos(e) {
    return this.side > 0 ? Ie.before(this.dom) : Ie.after(this.dom);
  }
  localPosFromDOM() {
    return 0;
  }
  domBoundsAround() {
    return null;
  }
  coordsAt(e) {
    return this.dom.getBoundingClientRect();
  }
  get overrideDOMText() {
    return ie.empty;
  }
  get isHidden() {
    return !0;
  }
}
Dt.prototype.children = _i.prototype.children = Rn.prototype.children = Ya;
function Qd(n, e) {
  let t = n.dom, { children: i } = n, s = 0;
  for (let r = 0; s < i.length; s++) {
    let o = i[s], l = r + o.length;
    if (!(l == r && o.getSide() <= 0)) {
      if (e > r && e < l && o.dom.parentNode == t)
        return o.domAtPos(e - r);
      if (e <= r)
        break;
      r = l;
    }
  }
  for (let r = s; r > 0; r--) {
    let o = i[r - 1];
    if (o.dom.parentNode == t)
      return o.domAtPos(o.length);
  }
  for (let r = s; r < i.length; r++) {
    let o = i[r];
    if (o.dom.parentNode == t)
      return o.domAtPos(0);
  }
  return new Ie(t, 0);
}
function Zd(n, e, t) {
  let i, { children: s } = n;
  t > 0 && e instanceof fi && s.length && (i = s[s.length - 1]) instanceof fi && i.mark.eq(e.mark) ? Zd(i, e.children[0], t - 1) : (s.push(e), e.setParent(n)), n.length += e.length;
}
function $d(n, e, t) {
  let i = null, s = -1, r = null, o = -1;
  function l(h, c) {
    for (let f = 0, u = 0; f < h.children.length && u <= c; f++) {
      let d = h.children[f], m = u + d.length;
      m >= c && (d.children.length ? l(d, c - u) : (!r || r.isHidden && t > 0) && (m > c || u == m && d.getSide() > 0) ? (r = d, o = c - u) : (u < c || u == m && d.getSide() < 0 && !d.isHidden) && (i = d, s = c - u)), u = m;
    }
  }
  l(n, e);
  let a = (t < 0 ? i : r) || i || r;
  return a ? a.coordsAt(Math.max(0, a == i ? s : o), t) : B1(n);
}
function B1(n) {
  let e = n.dom.lastChild;
  if (!e)
    return n.dom.getBoundingClientRect();
  let t = Ln(e);
  return t[t.length - 1] || null;
}
function na(n, e) {
  for (let t in n)
    t == "class" && e.class ? e.class += " " + n.class : t == "style" && e.style ? e.style += ";" + n.style : e[t] = n[t];
  return e;
}
const xc = /* @__PURE__ */ Object.create(null);
function Zr(n, e, t) {
  if (n == e)
    return !0;
  n || (n = xc), e || (e = xc);
  let i = Object.keys(n), s = Object.keys(e);
  if (i.length - (t && i.indexOf(t) > -1 ? 1 : 0) != s.length - (t && s.indexOf(t) > -1 ? 1 : 0))
    return !1;
  for (let r of i)
    if (r != t && (s.indexOf(r) == -1 || n[r] !== e[r]))
      return !1;
  return !0;
}
function sa(n, e, t) {
  let i = !1;
  if (e)
    for (let s in e)
      t && s in t || (i = !0, s == "style" ? n.style.cssText = "" : n.removeAttribute(s));
  if (t)
    for (let s in t)
      e && e[s] == t[s] || (i = !0, s == "style" ? n.style.cssText = t[s] : n.setAttribute(s, t[s]));
  return i;
}
function I1(n) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let t = 0; t < n.attributes.length; t++) {
    let i = n.attributes[t];
    e[i.name] = i.value;
  }
  return e;
}
class xe extends ae {
  constructor() {
    super(...arguments), this.children = [], this.length = 0, this.prevAttrs = void 0, this.attrs = null, this.breakAfter = 0;
  }
  // Consumes source
  merge(e, t, i, s, r, o) {
    if (i) {
      if (!(i instanceof xe))
        return !1;
      this.dom || i.transferDOM(this);
    }
    return s && this.setDeco(i ? i.attrs : null), Yd(this, e, t, i ? i.children.slice() : [], r, o), !0;
  }
  split(e) {
    let t = new xe();
    if (t.breakAfter = this.breakAfter, this.length == 0)
      return t;
    let { i, off: s } = this.childPos(e);
    s && (t.append(this.children[i].split(s), 0), this.children[i].merge(s, this.children[i].length, null, !1, 0, 0), i++);
    for (let r = i; r < this.children.length; r++)
      t.append(this.children[r], 0);
    for (; i > 0 && this.children[i - 1].length == 0; )
      this.children[--i].destroy();
    return this.children.length = i, this.markDirty(), this.length = e, t;
  }
  transferDOM(e) {
    this.dom && (this.markDirty(), e.setDOM(this.dom), e.prevAttrs = this.prevAttrs === void 0 ? this.attrs : this.prevAttrs, this.prevAttrs = void 0, this.dom = null);
  }
  setDeco(e) {
    Zr(this.attrs, e) || (this.dom && (this.prevAttrs = this.attrs, this.markDirty()), this.attrs = e);
  }
  append(e, t) {
    Zd(this, e, t);
  }
  // Only called when building a line view in ContentBuilder
  addLineDeco(e) {
    let t = e.spec.attributes, i = e.spec.class;
    t && (this.attrs = na(t, this.attrs || {})), i && (this.attrs = na({ class: i }, this.attrs || {}));
  }
  domAtPos(e) {
    return Qd(this, e);
  }
  reuseDOM(e) {
    e.nodeName == "DIV" && (this.setDOM(e), this.flags |= 6);
  }
  sync(e, t) {
    var i;
    this.dom ? this.flags & 4 && (zd(this.dom), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0) : (this.setDOM(document.createElement("div")), this.dom.className = "cm-line", this.prevAttrs = this.attrs ? null : void 0), this.prevAttrs !== void 0 && (sa(this.dom, this.prevAttrs, this.attrs), this.dom.classList.add("cm-line"), this.prevAttrs = void 0), super.sync(e, t);
    let s = this.dom.lastChild;
    for (; s && ae.get(s) instanceof fi; )
      s = s.lastChild;
    if (!s || !this.length || s.nodeName != "BR" && ((i = ae.get(s)) === null || i === void 0 ? void 0 : i.isEditable) == !1 && (!B.ios || !this.children.some((r) => r instanceof Dt))) {
      let r = document.createElement("BR");
      r.cmIgnore = !0, this.dom.appendChild(r);
    }
  }
  measureTextSize() {
    if (this.children.length == 0 || this.length > 20)
      return null;
    let e = 0, t;
    for (let i of this.children) {
      if (!(i instanceof Dt) || /[^ -~]/.test(i.text))
        return null;
      let s = Ln(i.dom);
      if (s.length != 1)
        return null;
      e += s[0].width, t = s[0].height;
    }
    return e ? {
      lineHeight: this.dom.getBoundingClientRect().height,
      charWidth: e / this.length,
      textHeight: t
    } : null;
  }
  coordsAt(e, t) {
    let i = $d(this, e, t);
    if (!this.children.length && i && this.parent) {
      let { heightOracle: s } = this.parent.view.viewState, r = i.bottom - i.top;
      if (Math.abs(r - s.lineHeight) < 2 && s.textHeight < r) {
        let o = (r - s.textHeight) / 2;
        return { top: i.top + o, bottom: i.bottom - o, left: i.left, right: i.left };
      }
    }
    return i;
  }
  become(e) {
    return e instanceof xe && this.children.length == 0 && e.children.length == 0 && Zr(this.attrs, e.attrs) && this.breakAfter == e.breakAfter;
  }
  covers() {
    return !0;
  }
  static find(e, t) {
    for (let i = 0, s = 0; i < e.children.length; i++) {
      let r = e.children[i], o = s + r.length;
      if (o >= t) {
        if (r instanceof xe)
          return r;
        if (o > t)
          break;
      }
      s = o + r.breakAfter;
    }
    return null;
  }
}
class ai extends ae {
  constructor(e, t, i) {
    super(), this.widget = e, this.length = t, this.deco = i, this.breakAfter = 0, this.prevWidget = null;
  }
  merge(e, t, i, s, r, o) {
    return i && (!(i instanceof ai) || !this.widget.compare(i.widget) || e > 0 && r <= 0 || t < this.length && o <= 0) ? !1 : (this.length = e + (i ? i.length : 0) + (this.length - t), !0);
  }
  domAtPos(e) {
    return e == 0 ? Ie.before(this.dom) : Ie.after(this.dom, e == this.length);
  }
  split(e) {
    let t = this.length - e;
    this.length = e;
    let i = new ai(this.widget, t, this.deco);
    return i.breakAfter = this.breakAfter, i;
  }
  get children() {
    return Ya;
  }
  sync(e) {
    (!this.dom || !this.widget.updateDOM(this.dom, e)) && (this.dom && this.prevWidget && this.prevWidget.destroy(this.dom), this.prevWidget = null, this.setDOM(this.widget.toDOM(e)), this.widget.editable || (this.dom.contentEditable = "false"));
  }
  get overrideDOMText() {
    return this.parent ? this.parent.view.state.doc.slice(this.posAtStart, this.posAtEnd) : ie.empty;
  }
  domBoundsAround() {
    return null;
  }
  become(e) {
    return e instanceof ai && e.widget.constructor == this.widget.constructor ? (e.widget.compare(this.widget) || this.markDirty(!0), this.dom && !this.prevWidget && (this.prevWidget = this.widget), this.widget = e.widget, this.length = e.length, this.deco = e.deco, this.breakAfter = e.breakAfter, !0) : !1;
  }
  ignoreMutation() {
    return !0;
  }
  ignoreEvent(e) {
    return this.widget.ignoreEvent(e);
  }
  get isEditable() {
    return !1;
  }
  get isWidget() {
    return !0;
  }
  coordsAt(e, t) {
    return this.widget.coordsAt(this.dom, e, t);
  }
  destroy() {
    super.destroy(), this.dom && this.widget.destroy(this.dom);
  }
  covers(e) {
    let { startSide: t, endSide: i } = this.deco;
    return t == i ? !1 : e < 0 ? t < 0 : i > 0;
  }
}
class Lt {
  /**
  Compare this instance to another instance of the same type.
  (TypeScript can't express this, but only instances of the same
  specific class will be passed to this method.) This is used to
  avoid redrawing widgets when they are replaced by a new
  decoration of the same type. The default implementation just
  returns `false`, which will cause new instances of the widget to
  always be redrawn.
  */
  eq(e) {
    return !1;
  }
  /**
  Update a DOM element created by a widget of the same type (but
  different, non-`eq` content) to reflect this widget. May return
  true to indicate that it could update, false to indicate it
  couldn't (in which case the widget will be redrawn). The default
  implementation just returns false.
  */
  updateDOM(e, t) {
    return !1;
  }
  /**
  @internal
  */
  compare(e) {
    return this == e || this.constructor == e.constructor && this.eq(e);
  }
  /**
  The estimated height this widget will have, to be used when
  estimating the height of content that hasn't been drawn. May
  return -1 to indicate you don't know. The default implementation
  returns -1.
  */
  get estimatedHeight() {
    return -1;
  }
  /**
  For inline widgets that are displayed inline (as opposed to
  `inline-block`) and introduce line breaks (through `<br>` tags
  or textual newlines), this must indicate the amount of line
  breaks they introduce. Defaults to 0.
  */
  get lineBreaks() {
    return 0;
  }
  /**
  Can be used to configure which kinds of events inside the widget
  should be ignored by the editor. The default is to ignore all
  events.
  */
  ignoreEvent(e) {
    return !0;
  }
  /**
  Override the way screen coordinates for positions at/in the
  widget are found. `pos` will be the offset into the widget, and
  `side` the side of the position that is being queried—less than
  zero for before, greater than zero for after, and zero for
  directly at that position.
  */
  coordsAt(e, t, i) {
    return null;
  }
  /**
  @internal
  */
  get isHidden() {
    return !1;
  }
  /**
  @internal
  */
  get editable() {
    return !1;
  }
  /**
  This is called when the an instance of the widget is removed
  from the editor view.
  */
  destroy(e) {
  }
}
var ze = /* @__PURE__ */ function(n) {
  return n[n.Text = 0] = "Text", n[n.WidgetBefore = 1] = "WidgetBefore", n[n.WidgetAfter = 2] = "WidgetAfter", n[n.WidgetRange = 3] = "WidgetRange", n;
}(ze || (ze = {}));
class N extends Xi {
  constructor(e, t, i, s) {
    super(), this.startSide = e, this.endSide = t, this.widget = i, this.spec = s;
  }
  /**
  @internal
  */
  get heightRelevant() {
    return !1;
  }
  /**
  Create a mark decoration, which influences the styling of the
  content in its range. Nested mark decorations will cause nested
  DOM elements to be created. Nesting order is determined by
  precedence of the [facet](https://codemirror.net/6/docs/ref/#view.EditorView^decorations), with
  the higher-precedence decorations creating the inner DOM nodes.
  Such elements are split on line boundaries and on the boundaries
  of lower-precedence decorations.
  */
  static mark(e) {
    return new Gs(e);
  }
  /**
  Create a widget decoration, which displays a DOM element at the
  given position.
  */
  static widget(e) {
    let t = Math.max(-1e4, Math.min(1e4, e.side || 0)), i = !!e.block;
    return t += i && !e.inlineOrder ? t > 0 ? 3e8 : -4e8 : t > 0 ? 1e8 : -1e8, new Ei(e, t, t, i, e.widget || null, !1);
  }
  /**
  Create a replace decoration which replaces the given range with
  a widget, or simply hides it.
  */
  static replace(e) {
    let t = !!e.block, i, s;
    if (e.isBlockGap)
      i = -5e8, s = 4e8;
    else {
      let { start: r, end: o } = em(e, t);
      i = (r ? t ? -3e8 : -1 : 5e8) - 1, s = (o ? t ? 2e8 : 1 : -6e8) + 1;
    }
    return new Ei(e, i, s, t, e.widget || null, !0);
  }
  /**
  Create a line decoration, which can add DOM attributes to the
  line starting at the given position.
  */
  static line(e) {
    return new Ys(e);
  }
  /**
  Build a [`DecorationSet`](https://codemirror.net/6/docs/ref/#view.DecorationSet) from the given
  decorated range or ranges. If the ranges aren't already sorted,
  pass `true` for `sort` to make the library sort them for you.
  */
  static set(e, t = !1) {
    return ne.of(e, t);
  }
  /**
  @internal
  */
  hasHeight() {
    return this.widget ? this.widget.estimatedHeight > -1 : !1;
  }
}
N.none = ne.empty;
class Gs extends N {
  constructor(e) {
    let { start: t, end: i } = em(e);
    super(t ? -1 : 5e8, i ? 1 : -6e8, null, e), this.tagName = e.tagName || "span", this.class = e.class || "", this.attrs = e.attributes || null;
  }
  eq(e) {
    var t, i;
    return this == e || e instanceof Gs && this.tagName == e.tagName && (this.class || ((t = this.attrs) === null || t === void 0 ? void 0 : t.class)) == (e.class || ((i = e.attrs) === null || i === void 0 ? void 0 : i.class)) && Zr(this.attrs, e.attrs, "class");
  }
  range(e, t = e) {
    if (e >= t)
      throw new RangeError("Mark decorations may not be empty");
    return super.range(e, t);
  }
}
Gs.prototype.point = !1;
class Ys extends N {
  constructor(e) {
    super(-2e8, -2e8, null, e);
  }
  eq(e) {
    return e instanceof Ys && this.spec.class == e.spec.class && Zr(this.spec.attributes, e.spec.attributes);
  }
  range(e, t = e) {
    if (t != e)
      throw new RangeError("Line decoration ranges must be zero-length");
    return super.range(e, t);
  }
}
Ys.prototype.mapMode = Ee.TrackBefore;
Ys.prototype.point = !0;
class Ei extends N {
  constructor(e, t, i, s, r, o) {
    super(t, i, r, e), this.block = s, this.isReplace = o, this.mapMode = s ? t <= 0 ? Ee.TrackBefore : Ee.TrackAfter : Ee.TrackDel;
  }
  // Only relevant when this.block == true
  get type() {
    return this.startSide != this.endSide ? ze.WidgetRange : this.startSide <= 0 ? ze.WidgetBefore : ze.WidgetAfter;
  }
  get heightRelevant() {
    return this.block || !!this.widget && (this.widget.estimatedHeight >= 5 || this.widget.lineBreaks > 0);
  }
  eq(e) {
    return e instanceof Ei && N1(this.widget, e.widget) && this.block == e.block && this.startSide == e.startSide && this.endSide == e.endSide;
  }
  range(e, t = e) {
    if (this.isReplace && (e > t || e == t && this.startSide > 0 && this.endSide <= 0))
      throw new RangeError("Invalid range for replacement decoration");
    if (!this.isReplace && t != e)
      throw new RangeError("Widget decorations can only have zero-length ranges");
    return super.range(e, t);
  }
}
Ei.prototype.point = !0;
function em(n, e = !1) {
  let { inclusiveStart: t, inclusiveEnd: i } = n;
  return t == null && (t = n.inclusive), i == null && (i = n.inclusive), { start: t ?? e, end: i ?? e };
}
function N1(n, e) {
  return n == e || !!(n && e && n.compare(e));
}
function ra(n, e, t, i = 0) {
  let s = t.length - 1;
  s >= 0 && t[s] + i >= n ? t[s] = Math.max(t[s], e) : t.push(n, e);
}
class vs {
  constructor(e, t, i, s) {
    this.doc = e, this.pos = t, this.end = i, this.disallowBlockEffectsFor = s, this.content = [], this.curLine = null, this.breakAtStart = 0, this.pendingBuffer = 0, this.bufferMarks = [], this.atCursorPos = !0, this.openStart = -1, this.openEnd = -1, this.text = "", this.textOff = 0, this.cursor = e.iter(), this.skip = t;
  }
  posCovered() {
    if (this.content.length == 0)
      return !this.breakAtStart && this.doc.lineAt(this.pos).from != this.pos;
    let e = this.content[this.content.length - 1];
    return !(e.breakAfter || e instanceof ai && e.deco.endSide < 0);
  }
  getLine() {
    return this.curLine || (this.content.push(this.curLine = new xe()), this.atCursorPos = !0), this.curLine;
  }
  flushBuffer(e = this.bufferMarks) {
    this.pendingBuffer && (this.curLine.append(lr(new Rn(-1), e), e.length), this.pendingBuffer = 0);
  }
  addBlockWidget(e) {
    this.flushBuffer(), this.curLine = null, this.content.push(e);
  }
  finish(e) {
    this.pendingBuffer && e <= this.bufferMarks.length ? this.flushBuffer() : this.pendingBuffer = 0, !this.posCovered() && !(e && this.content.length && this.content[this.content.length - 1] instanceof ai) && this.getLine();
  }
  buildText(e, t, i) {
    for (; e > 0; ) {
      if (this.textOff == this.text.length) {
        let { value: r, lineBreak: o, done: l } = this.cursor.next(this.skip);
        if (this.skip = 0, l)
          throw new Error("Ran out of text content when drawing inline views");
        if (o) {
          this.posCovered() || this.getLine(), this.content.length ? this.content[this.content.length - 1].breakAfter = 1 : this.breakAtStart = 1, this.flushBuffer(), this.curLine = null, this.atCursorPos = !0, e--;
          continue;
        } else
          this.text = r, this.textOff = 0;
      }
      let s = Math.min(
        this.text.length - this.textOff,
        e,
        512
        /* T.Chunk */
      );
      this.flushBuffer(t.slice(t.length - i)), this.getLine().append(lr(new Dt(this.text.slice(this.textOff, this.textOff + s)), t), i), this.atCursorPos = !0, this.textOff += s, e -= s, i = 0;
    }
  }
  span(e, t, i, s) {
    this.buildText(t - e, i, s), this.pos = t, this.openStart < 0 && (this.openStart = s);
  }
  point(e, t, i, s, r, o) {
    if (this.disallowBlockEffectsFor[o] && i instanceof Ei) {
      if (i.block)
        throw new RangeError("Block decorations may not be specified via plugins");
      if (t > this.doc.lineAt(this.pos).to)
        throw new RangeError("Decorations that replace line breaks may not be specified via plugins");
    }
    let l = t - e;
    if (i instanceof Ei)
      if (i.block)
        i.startSide > 0 && !this.posCovered() && this.getLine(), this.addBlockWidget(new ai(i.widget || Pn.block, l, i));
      else {
        let a = _i.create(i.widget || Pn.inline, l, l ? 0 : i.startSide), h = this.atCursorPos && !a.isEditable && r <= s.length && (e < t || i.startSide > 0), c = !a.isEditable && (e < t || r > s.length || i.startSide <= 0), f = this.getLine();
        this.pendingBuffer == 2 && !h && !a.isEditable && (this.pendingBuffer = 0), this.flushBuffer(s), h && (f.append(lr(new Rn(1), s), r), r = s.length + Math.max(0, r - s.length)), f.append(lr(a, s), r), this.atCursorPos = c, this.pendingBuffer = c ? e < t || r > s.length ? 1 : 2 : 0, this.pendingBuffer && (this.bufferMarks = s.slice());
      }
    else this.doc.lineAt(this.pos).from == this.pos && this.getLine().addLineDeco(i);
    l && (this.textOff + l <= this.text.length ? this.textOff += l : (this.skip += l - (this.text.length - this.textOff), this.text = "", this.textOff = 0), this.pos = t), this.openStart < 0 && (this.openStart = r);
  }
  static build(e, t, i, s, r) {
    let o = new vs(e, t, i, r);
    return o.openEnd = ne.spans(s, t, i, o), o.openStart < 0 && (o.openStart = o.openEnd), o.finish(o.openEnd), o;
  }
}
function lr(n, e) {
  for (let t of e)
    n = new fi(t, [n], n.length);
  return n;
}
class Pn extends Lt {
  constructor(e) {
    super(), this.tag = e;
  }
  eq(e) {
    return e.tag == this.tag;
  }
  toDOM() {
    return document.createElement(this.tag);
  }
  updateDOM(e) {
    return e.nodeName.toLowerCase() == this.tag;
  }
  get isHidden() {
    return !0;
  }
}
Pn.inline = /* @__PURE__ */ new Pn("span");
Pn.block = /* @__PURE__ */ new Pn("div");
var de = /* @__PURE__ */ function(n) {
  return n[n.LTR = 0] = "LTR", n[n.RTL = 1] = "RTL", n;
}(de || (de = {}));
const Zi = de.LTR, Xa = de.RTL;
function tm(n) {
  let e = [];
  for (let t = 0; t < n.length; t++)
    e.push(1 << +n[t]);
  return e;
}
const F1 = /* @__PURE__ */ tm("88888888888888888888888888888888888666888888787833333333337888888000000000000000000000000008888880000000000000000000000000088888888888888888888888888888888888887866668888088888663380888308888800000000000000000000000800000000000000000000000000000008"), H1 = /* @__PURE__ */ tm("4444448826627288999999999992222222222222222222222222222222222222222222222229999999999999999999994444444444644222822222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222999999949999999229989999223333333333"), oa = /* @__PURE__ */ Object.create(null), It = [];
for (let n of ["()", "[]", "{}"]) {
  let e = /* @__PURE__ */ n.charCodeAt(0), t = /* @__PURE__ */ n.charCodeAt(1);
  oa[e] = t, oa[t] = -e;
}
function im(n) {
  return n <= 247 ? F1[n] : 1424 <= n && n <= 1524 ? 2 : 1536 <= n && n <= 1785 ? H1[n - 1536] : 1774 <= n && n <= 2220 ? 4 : 8192 <= n && n <= 8204 ? 256 : 64336 <= n && n <= 65023 ? 4 : 1;
}
const V1 = /[\u0590-\u05f4\u0600-\u06ff\u0700-\u08ac\ufb50-\ufdff]/;
class Ci {
  /**
  The direction of this span.
  */
  get dir() {
    return this.level % 2 ? Xa : Zi;
  }
  /**
  @internal
  */
  constructor(e, t, i) {
    this.from = e, this.to = t, this.level = i;
  }
  /**
  @internal
  */
  side(e, t) {
    return this.dir == t == e ? this.to : this.from;
  }
  /**
  @internal
  */
  forward(e, t) {
    return e == (this.dir == t);
  }
  /**
  @internal
  */
  static find(e, t, i, s) {
    let r = -1;
    for (let o = 0; o < e.length; o++) {
      let l = e[o];
      if (l.from <= t && l.to >= t) {
        if (l.level == i)
          return o;
        (r < 0 || (s != 0 ? s < 0 ? l.from < t : l.to > t : e[r].level > l.level)) && (r = o);
      }
    }
    if (r < 0)
      throw new RangeError("Index out of range");
    return r;
  }
}
function nm(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++) {
    let i = n[t], s = e[t];
    if (i.from != s.from || i.to != s.to || i.direction != s.direction || !nm(i.inner, s.inner))
      return !1;
  }
  return !0;
}
const le = [];
function W1(n, e, t, i, s) {
  for (let r = 0; r <= i.length; r++) {
    let o = r ? i[r - 1].to : e, l = r < i.length ? i[r].from : t, a = r ? 256 : s;
    for (let h = o, c = a, f = a; h < l; h++) {
      let u = im(n.charCodeAt(h));
      u == 512 ? u = c : u == 8 && f == 4 && (u = 16), le[h] = u == 4 ? 2 : u, u & 7 && (f = u), c = u;
    }
    for (let h = o, c = a, f = a; h < l; h++) {
      let u = le[h];
      if (u == 128)
        h < l - 1 && c == le[h + 1] && c & 24 ? u = le[h] = c : le[h] = 256;
      else if (u == 64) {
        let d = h + 1;
        for (; d < l && le[d] == 64; )
          d++;
        let m = h && c == 8 || d < t && le[d] == 8 ? f == 1 ? 1 : 8 : 256;
        for (let p = h; p < d; p++)
          le[p] = m;
        h = d - 1;
      } else u == 8 && f == 1 && (le[h] = 1);
      c = u, u & 7 && (f = u);
    }
  }
}
function z1(n, e, t, i, s) {
  let r = s == 1 ? 2 : 1;
  for (let o = 0, l = 0, a = 0; o <= i.length; o++) {
    let h = o ? i[o - 1].to : e, c = o < i.length ? i[o].from : t;
    for (let f = h, u, d, m; f < c; f++)
      if (d = oa[u = n.charCodeAt(f)])
        if (d < 0) {
          for (let p = l - 3; p >= 0; p -= 3)
            if (It[p + 1] == -d) {
              let g = It[p + 2], b = g & 2 ? s : g & 4 ? g & 1 ? r : s : 0;
              b && (le[f] = le[It[p]] = b), l = p;
              break;
            }
        } else {
          if (It.length == 189)
            break;
          It[l++] = f, It[l++] = u, It[l++] = a;
        }
      else if ((m = le[f]) == 2 || m == 1) {
        let p = m == s;
        a = p ? 0 : 1;
        for (let g = l - 3; g >= 0; g -= 3) {
          let b = It[g + 2];
          if (b & 2)
            break;
          if (p)
            It[g + 2] |= 2;
          else {
            if (b & 4)
              break;
            It[g + 2] |= 4;
          }
        }
      }
  }
}
function q1(n, e, t, i) {
  for (let s = 0, r = i; s <= t.length; s++) {
    let o = s ? t[s - 1].to : n, l = s < t.length ? t[s].from : e;
    for (let a = o; a < l; ) {
      let h = le[a];
      if (h == 256) {
        let c = a + 1;
        for (; ; )
          if (c == l) {
            if (s == t.length)
              break;
            c = t[s++].to, l = s < t.length ? t[s].from : e;
          } else if (le[c] == 256)
            c++;
          else
            break;
        let f = r == 1, u = (c < e ? le[c] : i) == 1, d = f == u ? f ? 1 : 2 : i;
        for (let m = c, p = s, g = p ? t[p - 1].to : n; m > a; )
          m == g && (m = t[--p].from, g = p ? t[p - 1].to : n), le[--m] = d;
        a = c;
      } else
        r = h, a++;
    }
  }
}
function la(n, e, t, i, s, r, o) {
  let l = i % 2 ? 2 : 1;
  if (i % 2 == s % 2)
    for (let a = e, h = 0; a < t; ) {
      let c = !0, f = !1;
      if (h == r.length || a < r[h].from) {
        let p = le[a];
        p != l && (c = !1, f = p == 16);
      }
      let u = !c && l == 1 ? [] : null, d = c ? i : i + 1, m = a;
      e: for (; ; )
        if (h < r.length && m == r[h].from) {
          if (f)
            break e;
          let p = r[h];
          if (!c)
            for (let g = p.to, b = h + 1; ; ) {
              if (g == t)
                break e;
              if (b < r.length && r[b].from == g)
                g = r[b++].to;
              else {
                if (le[g] == l)
                  break e;
                break;
              }
            }
          if (h++, u)
            u.push(p);
          else {
            p.from > a && o.push(new Ci(a, p.from, d));
            let g = p.direction == Zi != !(d % 2);
            aa(n, g ? i + 1 : i, s, p.inner, p.from, p.to, o), a = p.to;
          }
          m = p.to;
        } else {
          if (m == t || (c ? le[m] != l : le[m] == l))
            break;
          m++;
        }
      u ? la(n, a, m, i + 1, s, u, o) : a < m && o.push(new Ci(a, m, d)), a = m;
    }
  else
    for (let a = t, h = r.length; a > e; ) {
      let c = !0, f = !1;
      if (!h || a > r[h - 1].to) {
        let p = le[a - 1];
        p != l && (c = !1, f = p == 16);
      }
      let u = !c && l == 1 ? [] : null, d = c ? i : i + 1, m = a;
      e: for (; ; )
        if (h && m == r[h - 1].to) {
          if (f)
            break e;
          let p = r[--h];
          if (!c)
            for (let g = p.from, b = h; ; ) {
              if (g == e)
                break e;
              if (b && r[b - 1].to == g)
                g = r[--b].from;
              else {
                if (le[g - 1] == l)
                  break e;
                break;
              }
            }
          if (u)
            u.push(p);
          else {
            p.to < a && o.push(new Ci(p.to, a, d));
            let g = p.direction == Zi != !(d % 2);
            aa(n, g ? i + 1 : i, s, p.inner, p.from, p.to, o), a = p.from;
          }
          m = p.from;
        } else {
          if (m == e || (c ? le[m - 1] != l : le[m - 1] == l))
            break;
          m--;
        }
      u ? la(n, m, a, i + 1, s, u, o) : m < a && o.push(new Ci(m, a, d)), a = m;
    }
}
function aa(n, e, t, i, s, r, o) {
  let l = e % 2 ? 2 : 1;
  W1(n, s, r, i, l), z1(n, s, r, i, l), q1(s, r, i, l), la(n, s, r, e, t, i, o);
}
function U1(n, e, t) {
  if (!n)
    return [new Ci(0, 0, e == Xa ? 1 : 0)];
  if (e == Zi && !t.length && !V1.test(n))
    return sm(n.length);
  if (t.length)
    for (; n.length > le.length; )
      le[le.length] = 256;
  let i = [], s = e == Zi ? 0 : 1;
  return aa(n, s, s, t, 0, n.length, i), i;
}
function sm(n) {
  return [new Ci(0, n, 0)];
}
let rm = "";
function j1(n, e, t, i, s) {
  var r;
  let o = i.head - n.from, l = Ci.find(e, o, (r = i.bidiLevel) !== null && r !== void 0 ? r : -1, i.assoc), a = e[l], h = a.side(s, t);
  if (o == h) {
    let u = l += s ? 1 : -1;
    if (u < 0 || u >= e.length)
      return null;
    a = e[l = u], o = a.side(!s, t), h = a.side(s, t);
  }
  let c = Re(n.text, o, a.forward(s, t));
  (c < a.from || c > a.to) && (c = h), rm = n.text.slice(Math.min(o, c), Math.max(o, c));
  let f = l == (s ? e.length - 1 : 0) ? null : e[l + (s ? 1 : -1)];
  return f && c == h && f.level + (s ? 0 : 1) < a.level ? C.cursor(f.side(!s, t) + n.from, f.forward(s, t) ? 1 : -1, f.level) : C.cursor(c + n.from, a.forward(s, t) ? -1 : 1, a.level);
}
function K1(n, e, t) {
  for (let i = e; i < t; i++) {
    let s = im(n.charCodeAt(i));
    if (s == 1)
      return Zi;
    if (s == 2 || s == 4)
      return Xa;
  }
  return Zi;
}
const om = /* @__PURE__ */ I.define(), lm = /* @__PURE__ */ I.define(), am = /* @__PURE__ */ I.define(), hm = /* @__PURE__ */ I.define(), ha = /* @__PURE__ */ I.define(), cm = /* @__PURE__ */ I.define(), fm = /* @__PURE__ */ I.define(), um = /* @__PURE__ */ I.define({
  combine: (n) => n.some((e) => e)
}), dm = /* @__PURE__ */ I.define({
  combine: (n) => n.some((e) => e)
}), mm = /* @__PURE__ */ I.define();
class An {
  constructor(e, t = "nearest", i = "nearest", s = 5, r = 5, o = !1) {
    this.range = e, this.y = t, this.x = i, this.yMargin = s, this.xMargin = r, this.isSnapshot = o;
  }
  map(e) {
    return e.empty ? this : new An(this.range.map(e), this.y, this.x, this.yMargin, this.xMargin, this.isSnapshot);
  }
  clip(e) {
    return this.range.to <= e.doc.length ? this : new An(C.cursor(e.doc.length), this.y, this.x, this.yMargin, this.xMargin, this.isSnapshot);
  }
}
const ar = /* @__PURE__ */ K.define({ map: (n, e) => n.map(e) }), pm = /* @__PURE__ */ K.define();
function Je(n, e, t) {
  let i = n.facet(hm);
  i.length ? i[0](e) : window.onerror ? window.onerror(String(e), t, void 0, void 0, e) : t ? console.error(t + ":", e) : console.error(e);
}
const vi = /* @__PURE__ */ I.define({ combine: (n) => n.length ? n[0] : !0 });
let G1 = 0;
const fs = /* @__PURE__ */ I.define();
class be {
  constructor(e, t, i, s, r) {
    this.id = e, this.create = t, this.domEventHandlers = i, this.domEventObservers = s, this.extension = r(this);
  }
  /**
  Define a plugin from a constructor function that creates the
  plugin's value, given an editor view.
  */
  static define(e, t) {
    const { eventHandlers: i, eventObservers: s, provide: r, decorations: o } = t || {};
    return new be(G1++, e, i, s, (l) => {
      let a = [fs.of(l)];
      return o && a.push(Es.of((h) => {
        let c = h.plugin(l);
        return c ? o(c) : N.none;
      })), r && a.push(r(l)), a;
    });
  }
  /**
  Create a plugin for a class whose constructor takes a single
  editor view as argument.
  */
  static fromClass(e, t) {
    return be.define((i) => new e(i), t);
  }
}
class Yo {
  constructor(e) {
    this.spec = e, this.mustUpdate = null, this.value = null;
  }
  update(e) {
    if (this.value) {
      if (this.mustUpdate) {
        let t = this.mustUpdate;
        if (this.mustUpdate = null, this.value.update)
          try {
            this.value.update(t);
          } catch (i) {
            if (Je(t.state, i, "CodeMirror plugin crashed"), this.value.destroy)
              try {
                this.value.destroy();
              } catch {
              }
            this.deactivate();
          }
      }
    } else if (this.spec)
      try {
        this.value = this.spec.create(e);
      } catch (t) {
        Je(e.state, t, "CodeMirror plugin crashed"), this.deactivate();
      }
    return this;
  }
  destroy(e) {
    var t;
    if (!((t = this.value) === null || t === void 0) && t.destroy)
      try {
        this.value.destroy();
      } catch (i) {
        Je(e.state, i, "CodeMirror plugin crashed");
      }
  }
  deactivate() {
    this.spec = this.value = null;
  }
}
const gm = /* @__PURE__ */ I.define(), Ja = /* @__PURE__ */ I.define(), Es = /* @__PURE__ */ I.define(), bm = /* @__PURE__ */ I.define(), Qa = /* @__PURE__ */ I.define(), ym = /* @__PURE__ */ I.define();
function Sc(n, e) {
  let t = n.state.facet(ym);
  if (!t.length)
    return t;
  let i = t.map((r) => r instanceof Function ? r(n) : r), s = [];
  return ne.spans(i, e.from, e.to, {
    point() {
    },
    span(r, o, l, a) {
      let h = r - e.from, c = o - e.from, f = s;
      for (let u = l.length - 1; u >= 0; u--, a--) {
        let d = l[u].spec.bidiIsolate, m;
        if (d == null && (d = K1(e.text, h, c)), a > 0 && f.length && (m = f[f.length - 1]).to == h && m.direction == d)
          m.to = c, f = m.inner;
        else {
          let p = { from: h, to: c, direction: d, inner: [] };
          f.push(p), f = p.inner;
        }
      }
    }
  }), s;
}
const wm = /* @__PURE__ */ I.define();
function km(n) {
  let e = 0, t = 0, i = 0, s = 0;
  for (let r of n.state.facet(wm)) {
    let o = r(n);
    o && (o.left != null && (e = Math.max(e, o.left)), o.right != null && (t = Math.max(t, o.right)), o.top != null && (i = Math.max(i, o.top)), o.bottom != null && (s = Math.max(s, o.bottom)));
  }
  return { left: e, right: t, top: i, bottom: s };
}
const us = /* @__PURE__ */ I.define();
class mt {
  constructor(e, t, i, s) {
    this.fromA = e, this.toA = t, this.fromB = i, this.toB = s;
  }
  join(e) {
    return new mt(Math.min(this.fromA, e.fromA), Math.max(this.toA, e.toA), Math.min(this.fromB, e.fromB), Math.max(this.toB, e.toB));
  }
  addToSet(e) {
    let t = e.length, i = this;
    for (; t > 0; t--) {
      let s = e[t - 1];
      if (!(s.fromA > i.toA)) {
        if (s.toA < i.fromA)
          break;
        i = i.join(s), e.splice(t - 1, 1);
      }
    }
    return e.splice(t, 0, i), e;
  }
  static extendWithRanges(e, t) {
    if (t.length == 0)
      return e;
    let i = [];
    for (let s = 0, r = 0, o = 0, l = 0; ; s++) {
      let a = s == e.length ? null : e[s], h = o - l, c = a ? a.fromB : 1e9;
      for (; r < t.length && t[r] < c; ) {
        let f = t[r], u = t[r + 1], d = Math.max(l, f), m = Math.min(c, u);
        if (d <= m && new mt(d + h, m + h, d, m).addToSet(i), u > c)
          break;
        r += 2;
      }
      if (!a)
        return i;
      new mt(a.fromA, a.toA, a.fromB, a.toB).addToSet(i), o = a.toA, l = a.toB;
    }
  }
}
class $r {
  constructor(e, t, i) {
    this.view = e, this.state = t, this.transactions = i, this.flags = 0, this.startState = e.state, this.changes = Se.empty(this.startState.doc.length);
    for (let r of i)
      this.changes = this.changes.compose(r.changes);
    let s = [];
    this.changes.iterChangedRanges((r, o, l, a) => s.push(new mt(r, o, l, a))), this.changedRanges = s;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new $r(e, t, i);
  }
  /**
  Tells you whether the [viewport](https://codemirror.net/6/docs/ref/#view.EditorView.viewport) or
  [visible ranges](https://codemirror.net/6/docs/ref/#view.EditorView.visibleRanges) changed in this
  update.
  */
  get viewportChanged() {
    return (this.flags & 4) > 0;
  }
  /**
  Indicates whether the height of a block element in the editor
  changed in this update.
  */
  get heightChanged() {
    return (this.flags & 2) > 0;
  }
  /**
  Returns true when the document was modified or the size of the
  editor, or elements within the editor, changed.
  */
  get geometryChanged() {
    return this.docChanged || (this.flags & 10) > 0;
  }
  /**
  True when this update indicates a focus change.
  */
  get focusChanged() {
    return (this.flags & 1) > 0;
  }
  /**
  Whether the document changed in this update.
  */
  get docChanged() {
    return !this.changes.empty;
  }
  /**
  Whether the selection was explicitly set in this update.
  */
  get selectionSet() {
    return this.transactions.some((e) => e.selection);
  }
  /**
  @internal
  */
  get empty() {
    return this.flags == 0 && this.transactions.length == 0;
  }
}
class _c extends ae {
  get length() {
    return this.view.state.doc.length;
  }
  constructor(e) {
    super(), this.view = e, this.decorations = [], this.dynamicDecorationMap = [!1], this.domChanged = null, this.hasComposition = null, this.markedForComposition = /* @__PURE__ */ new Set(), this.editContextFormatting = N.none, this.lastCompositionAfterCursor = !1, this.minWidth = 0, this.minWidthFrom = 0, this.minWidthTo = 0, this.impreciseAnchor = null, this.impreciseHead = null, this.forceSelection = !1, this.lastUpdate = Date.now(), this.setDOM(e.contentDOM), this.children = [new xe()], this.children[0].setParent(this), this.updateDeco(), this.updateInner([new mt(0, 0, 0, e.state.doc.length)], 0, null);
  }
  // Update the document view to a given state.
  update(e) {
    var t;
    let i = e.changedRanges;
    this.minWidth > 0 && i.length && (i.every(({ fromA: h, toA: c }) => c < this.minWidthFrom || h > this.minWidthTo) ? (this.minWidthFrom = e.changes.mapPos(this.minWidthFrom, 1), this.minWidthTo = e.changes.mapPos(this.minWidthTo, 1)) : this.minWidth = this.minWidthFrom = this.minWidthTo = 0), this.updateEditContextFormatting(e);
    let s = -1;
    this.view.inputState.composing >= 0 && !this.view.observer.editContext && (!((t = this.domChanged) === null || t === void 0) && t.newSel ? s = this.domChanged.newSel.head : !eb(e.changes, this.hasComposition) && !e.selectionSet && (s = e.state.selection.main.head));
    let r = s > -1 ? X1(this.view, e.changes, s) : null;
    if (this.domChanged = null, this.hasComposition) {
      this.markedForComposition.clear();
      let { from: h, to: c } = this.hasComposition;
      i = new mt(h, c, e.changes.mapPos(h, -1), e.changes.mapPos(c, 1)).addToSet(i.slice());
    }
    this.hasComposition = r ? { from: r.range.fromB, to: r.range.toB } : null, (B.ie || B.chrome) && !r && e && e.state.doc.lines != e.startState.doc.lines && (this.forceSelection = !0);
    let o = this.decorations, l = this.updateDeco(), a = Z1(o, l, e.changes);
    return i = mt.extendWithRanges(i, a), !(this.flags & 7) && i.length == 0 ? !1 : (this.updateInner(i, e.startState.doc.length, r), e.transactions.length && (this.lastUpdate = Date.now()), !0);
  }
  // Used by update and the constructor do perform the actual DOM
  // update
  updateInner(e, t, i) {
    this.view.viewState.mustMeasureContent = !0, this.updateChildren(e, t, i);
    let { observer: s } = this.view;
    s.ignore(() => {
      this.dom.style.height = this.view.viewState.contentHeight / this.view.scaleY + "px", this.dom.style.flexBasis = this.minWidth ? this.minWidth + "px" : "";
      let o = B.chrome || B.ios ? { node: s.selectionRange.focusNode, written: !1 } : void 0;
      this.sync(this.view, o), this.flags &= -8, o && (o.written || s.selectionRange.focusNode != o.node) && (this.forceSelection = !0), this.dom.style.height = "";
    }), this.markedForComposition.forEach(
      (o) => o.flags &= -9
      /* ViewFlag.Composition */
    );
    let r = [];
    if (this.view.viewport.from || this.view.viewport.to < this.view.state.doc.length)
      for (let o of this.children)
        o instanceof ai && o.widget instanceof Cc && r.push(o.dom);
    s.updateGaps(r);
  }
  updateChildren(e, t, i) {
    let s = i ? i.range.addToSet(e.slice()) : e, r = this.childCursor(t);
    for (let o = s.length - 1; ; o--) {
      let l = o >= 0 ? s[o] : null;
      if (!l)
        break;
      let { fromA: a, toA: h, fromB: c, toB: f } = l, u, d, m, p;
      if (i && i.range.fromB < f && i.range.toB > c) {
        let x = vs.build(this.view.state.doc, c, i.range.fromB, this.decorations, this.dynamicDecorationMap), _ = vs.build(this.view.state.doc, i.range.toB, f, this.decorations, this.dynamicDecorationMap);
        d = x.breakAtStart, m = x.openStart, p = _.openEnd;
        let S = this.compositionView(i);
        _.breakAtStart ? S.breakAfter = 1 : _.content.length && S.merge(S.length, S.length, _.content[0], !1, _.openStart, 0) && (S.breakAfter = _.content[0].breakAfter, _.content.shift()), x.content.length && S.merge(0, 0, x.content[x.content.length - 1], !0, 0, x.openEnd) && x.content.pop(), u = x.content.concat(S).concat(_.content);
      } else
        ({ content: u, breakAtStart: d, openStart: m, openEnd: p } = vs.build(this.view.state.doc, c, f, this.decorations, this.dynamicDecorationMap));
      let { i: g, off: b } = r.findPos(h, 1), { i: w, off: k } = r.findPos(a, -1);
      Gd(this, w, k, g, b, u, d, m, p);
    }
    i && this.fixCompositionDOM(i);
  }
  updateEditContextFormatting(e) {
    this.editContextFormatting = this.editContextFormatting.map(e.changes);
    for (let t of e.transactions)
      for (let i of t.effects)
        i.is(pm) && (this.editContextFormatting = i.value);
  }
  compositionView(e) {
    let t = new Dt(e.text.nodeValue);
    t.flags |= 8;
    for (let { deco: s } of e.marks)
      t = new fi(s, [t], t.length);
    let i = new xe();
    return i.append(t, 0), i;
  }
  fixCompositionDOM(e) {
    let t = (r, o) => {
      o.flags |= 8 | (o.children.some(
        (a) => a.flags & 7
        /* ViewFlag.Dirty */
      ) ? 1 : 0), this.markedForComposition.add(o);
      let l = ae.get(r);
      l && l != o && (l.dom = null), o.setDOM(r);
    }, i = this.childPos(e.range.fromB, 1), s = this.children[i.i];
    t(e.line, s);
    for (let r = e.marks.length - 1; r >= -1; r--)
      i = s.childPos(i.off, 1), s = s.children[i.i], t(r >= 0 ? e.marks[r].node : e.text, s);
  }
  // Sync the DOM selection to this.state.selection
  updateSelection(e = !1, t = !1) {
    (e || !this.view.observer.selectionRange.focusNode) && this.view.observer.readSelectionRange();
    let i = this.view.root.activeElement, s = i == this.dom, r = !s && Hr(this.dom, this.view.observer.selectionRange) && !(i && this.dom.contains(i));
    if (!(s || t || r))
      return;
    let o = this.forceSelection;
    this.forceSelection = !1;
    let l = this.view.state.selection.main, a = this.moveToLine(this.domAtPos(l.anchor)), h = l.empty ? a : this.moveToLine(this.domAtPos(l.head));
    if (B.gecko && l.empty && !this.hasComposition && Y1(a)) {
      let f = document.createTextNode("");
      this.view.observer.ignore(() => a.node.insertBefore(f, a.node.childNodes[a.offset] || null)), a = h = new Ie(f, 0), o = !0;
    }
    let c = this.view.observer.selectionRange;
    (o || !c.focusNode || (!ks(a.node, a.offset, c.anchorNode, c.anchorOffset) || !ks(h.node, h.offset, c.focusNode, c.focusOffset)) && !this.suppressWidgetCursorChange(c, l)) && (this.view.observer.ignore(() => {
      B.android && B.chrome && this.dom.contains(c.focusNode) && $1(c.focusNode, this.dom) && (this.dom.blur(), this.dom.focus({ preventScroll: !0 }));
      let f = Os(this.view.root);
      if (f) if (l.empty) {
        if (B.gecko) {
          let u = J1(a.node, a.offset);
          if (u && u != 3) {
            let d = (u == 1 ? Ud : jd)(a.node, a.offset);
            d && (a = new Ie(d.node, d.offset));
          }
        }
        f.collapse(a.node, a.offset), l.bidiLevel != null && f.caretBidiLevel !== void 0 && (f.caretBidiLevel = l.bidiLevel);
      } else if (f.extend) {
        f.collapse(a.node, a.offset);
        try {
          f.extend(h.node, h.offset);
        } catch {
        }
      } else {
        let u = document.createRange();
        l.anchor > l.head && ([a, h] = [h, a]), u.setEnd(h.node, h.offset), u.setStart(a.node, a.offset), f.removeAllRanges(), f.addRange(u);
      }
      r && this.view.root.activeElement == this.dom && (this.dom.blur(), i && i.focus());
    }), this.view.observer.setSelectionRange(a, h)), this.impreciseAnchor = a.precise ? null : new Ie(c.anchorNode, c.anchorOffset), this.impreciseHead = h.precise ? null : new Ie(c.focusNode, c.focusOffset);
  }
  // If a zero-length widget is inserted next to the cursor during
  // composition, avoid moving it across it and disrupting the
  // composition.
  suppressWidgetCursorChange(e, t) {
    return this.hasComposition && t.empty && ks(e.focusNode, e.focusOffset, e.anchorNode, e.anchorOffset) && this.posFromDOM(e.focusNode, e.focusOffset) == t.head;
  }
  enforceCursorAssoc() {
    if (this.hasComposition)
      return;
    let { view: e } = this, t = e.state.selection.main, i = Os(e.root), { anchorNode: s, anchorOffset: r } = e.observer.selectionRange;
    if (!i || !t.empty || !t.assoc || !i.modify)
      return;
    let o = xe.find(this, t.head);
    if (!o)
      return;
    let l = o.posAtStart;
    if (t.head == l || t.head == l + o.length)
      return;
    let a = this.coordsAt(t.head, -1), h = this.coordsAt(t.head, 1);
    if (!a || !h || a.bottom > h.top)
      return;
    let c = this.domAtPos(t.head + t.assoc);
    i.collapse(c.node, c.offset), i.modify("move", t.assoc < 0 ? "forward" : "backward", "lineboundary"), e.observer.readSelectionRange();
    let f = e.observer.selectionRange;
    e.docView.posFromDOM(f.anchorNode, f.anchorOffset) != t.from && i.collapse(s, r);
  }
  // If a position is in/near a block widget, move it to a nearby text
  // line, since we don't want the cursor inside a block widget.
  moveToLine(e) {
    let t = this.dom, i;
    if (e.node != t)
      return e;
    for (let s = e.offset; !i && s < t.childNodes.length; s++) {
      let r = ae.get(t.childNodes[s]);
      r instanceof xe && (i = r.domAtPos(0));
    }
    for (let s = e.offset - 1; !i && s >= 0; s--) {
      let r = ae.get(t.childNodes[s]);
      r instanceof xe && (i = r.domAtPos(r.length));
    }
    return i ? new Ie(i.node, i.offset, !0) : e;
  }
  nearest(e) {
    for (let t = e; t; ) {
      let i = ae.get(t);
      if (i && i.rootView == this)
        return i;
      t = t.parentNode;
    }
    return null;
  }
  posFromDOM(e, t) {
    let i = this.nearest(e);
    if (!i)
      throw new RangeError("Trying to find position for a DOM position outside of the document");
    return i.localPosFromDOM(e, t) + i.posAtStart;
  }
  domAtPos(e) {
    let { i: t, off: i } = this.childCursor().findPos(e, -1);
    for (; t < this.children.length - 1; ) {
      let s = this.children[t];
      if (i < s.length || s instanceof xe)
        break;
      t++, i = 0;
    }
    return this.children[t].domAtPos(i);
  }
  coordsAt(e, t) {
    let i = null, s = 0;
    for (let r = this.length, o = this.children.length - 1; o >= 0; o--) {
      let l = this.children[o], a = r - l.breakAfter, h = a - l.length;
      if (a < e)
        break;
      if (h <= e && (h < e || l.covers(-1)) && (a > e || l.covers(1)) && (!i || l instanceof xe && !(i instanceof xe && t >= 0)))
        i = l, s = h;
      else if (i && h == e && a == e && l instanceof ai && Math.abs(t) < 2) {
        if (l.deco.startSide < 0)
          break;
        o && (i = null);
      }
      r = h;
    }
    return i ? i.coordsAt(e - s, t) : null;
  }
  coordsForChar(e) {
    let { i: t, off: i } = this.childPos(e, 1), s = this.children[t];
    if (!(s instanceof xe))
      return null;
    for (; s.children.length; ) {
      let { i: l, off: a } = s.childPos(i, 1);
      for (; ; l++) {
        if (l == s.children.length)
          return null;
        if ((s = s.children[l]).length)
          break;
      }
      i = a;
    }
    if (!(s instanceof Dt))
      return null;
    let r = Re(s.text, i);
    if (r == i)
      return null;
    let o = Qi(s.dom, i, r).getClientRects();
    for (let l = 0; l < o.length; l++) {
      let a = o[l];
      if (l == o.length - 1 || a.top < a.bottom && a.left < a.right)
        return a;
    }
    return null;
  }
  measureVisibleLineHeights(e) {
    let t = [], { from: i, to: s } = e, r = this.view.contentDOM.clientWidth, o = r > Math.max(this.view.scrollDOM.clientWidth, this.minWidth) + 1, l = -1, a = this.view.textDirection == de.LTR;
    for (let h = 0, c = 0; c < this.children.length; c++) {
      let f = this.children[c], u = h + f.length;
      if (u > s)
        break;
      if (h >= i) {
        let d = f.dom.getBoundingClientRect();
        if (t.push(d.height), o) {
          let m = f.dom.lastChild, p = m ? Ln(m) : [];
          if (p.length) {
            let g = p[p.length - 1], b = a ? g.right - d.left : d.right - g.left;
            b > l && (l = b, this.minWidth = r, this.minWidthFrom = h, this.minWidthTo = u);
          }
        }
      }
      h = u + f.breakAfter;
    }
    return t;
  }
  textDirectionAt(e) {
    let { i: t } = this.childPos(e, 1);
    return getComputedStyle(this.children[t].dom).direction == "rtl" ? de.RTL : de.LTR;
  }
  measureTextSize() {
    for (let r of this.children)
      if (r instanceof xe) {
        let o = r.measureTextSize();
        if (o)
          return o;
      }
    let e = document.createElement("div"), t, i, s;
    return e.className = "cm-line", e.style.width = "99999px", e.style.position = "absolute", e.textContent = "abc def ghi jkl mno pqr stu", this.view.observer.ignore(() => {
      this.dom.appendChild(e);
      let r = Ln(e.firstChild)[0];
      t = e.getBoundingClientRect().height, i = r ? r.width / 27 : 7, s = r ? r.height : t, e.remove();
    }), { lineHeight: t, charWidth: i, textHeight: s };
  }
  childCursor(e = this.length) {
    let t = this.children.length;
    return t && (e -= this.children[--t].length), new Kd(this.children, e, t);
  }
  computeBlockGapDeco() {
    let e = [], t = this.view.viewState;
    for (let i = 0, s = 0; ; s++) {
      let r = s == t.viewports.length ? null : t.viewports[s], o = r ? r.from - 1 : this.length;
      if (o > i) {
        let l = (t.lineBlockAt(o).bottom - t.lineBlockAt(i).top) / this.view.scaleY;
        e.push(N.replace({
          widget: new Cc(l),
          block: !0,
          inclusive: !0,
          isBlockGap: !0
        }).range(i, o));
      }
      if (!r)
        break;
      i = r.to + 1;
    }
    return N.set(e);
  }
  updateDeco() {
    let e = 1, t = this.view.state.facet(Es).map((r) => (this.dynamicDecorationMap[e++] = typeof r == "function") ? r(this.view) : r), i = !1, s = this.view.state.facet(bm).map((r, o) => {
      let l = typeof r == "function";
      return l && (i = !0), l ? r(this.view) : r;
    });
    for (s.length && (this.dynamicDecorationMap[e++] = i, t.push(ne.join(s))), this.decorations = [
      this.editContextFormatting,
      ...t,
      this.computeBlockGapDeco(),
      this.view.viewState.lineGapDeco
    ]; e < this.decorations.length; )
      this.dynamicDecorationMap[e++] = !1;
    return this.decorations;
  }
  scrollIntoView(e) {
    if (e.isSnapshot) {
      let h = this.view.viewState.lineBlockAt(e.range.head);
      this.view.scrollDOM.scrollTop = h.top - e.yMargin, this.view.scrollDOM.scrollLeft = e.xMargin;
      return;
    }
    for (let h of this.view.state.facet(mm))
      try {
        if (h(this.view, e.range, e))
          return !0;
      } catch (c) {
        Je(this.view.state, c, "scroll handler");
      }
    let { range: t } = e, i = this.coordsAt(t.head, t.empty ? t.assoc : t.head > t.anchor ? -1 : 1), s;
    if (!i)
      return;
    !t.empty && (s = this.coordsAt(t.anchor, t.anchor > t.head ? -1 : 1)) && (i = {
      left: Math.min(i.left, s.left),
      top: Math.min(i.top, s.top),
      right: Math.max(i.right, s.right),
      bottom: Math.max(i.bottom, s.bottom)
    });
    let r = km(this.view), o = {
      left: i.left - r.left,
      top: i.top - r.top,
      right: i.right + r.right,
      bottom: i.bottom + r.bottom
    }, { offsetWidth: l, offsetHeight: a } = this.view.scrollDOM;
    T1(this.view.scrollDOM, o, t.head < t.anchor ? -1 : 1, e.x, e.y, Math.max(Math.min(e.xMargin, l), -l), Math.max(Math.min(e.yMargin, a), -a), this.view.textDirection == de.LTR);
  }
}
function Y1(n) {
  return n.node.nodeType == 1 && n.node.firstChild && (n.offset == 0 || n.node.childNodes[n.offset - 1].contentEditable == "false") && (n.offset == n.node.childNodes.length || n.node.childNodes[n.offset].contentEditable == "false");
}
class Cc extends Lt {
  constructor(e) {
    super(), this.height = e;
  }
  toDOM() {
    let e = document.createElement("div");
    return e.className = "cm-gap", this.updateDOM(e), e;
  }
  eq(e) {
    return e.height == this.height;
  }
  updateDOM(e) {
    return e.style.height = this.height + "px", !0;
  }
  get editable() {
    return !0;
  }
  get estimatedHeight() {
    return this.height;
  }
  ignoreEvent() {
    return !1;
  }
}
function vm(n, e) {
  let t = n.observer.selectionRange;
  if (!t.focusNode)
    return null;
  let i = Ud(t.focusNode, t.focusOffset), s = jd(t.focusNode, t.focusOffset), r = i || s;
  if (s && i && s.node != i.node) {
    let l = ae.get(s.node);
    if (!l || l instanceof Dt && l.text != s.node.nodeValue)
      r = s;
    else if (n.docView.lastCompositionAfterCursor) {
      let a = ae.get(i.node);
      !a || a instanceof Dt && a.text != i.node.nodeValue || (r = s);
    }
  }
  if (n.docView.lastCompositionAfterCursor = r != i, !r)
    return null;
  let o = e - r.offset;
  return { from: o, to: o + r.node.nodeValue.length, node: r.node };
}
function X1(n, e, t) {
  let i = vm(n, t);
  if (!i)
    return null;
  let { node: s, from: r, to: o } = i, l = s.nodeValue;
  if (/[\n\r]/.test(l) || n.state.doc.sliceString(i.from, i.to) != l)
    return null;
  let a = e.invertedDesc, h = new mt(a.mapPos(r), a.mapPos(o), r, o), c = [];
  for (let f = s.parentNode; ; f = f.parentNode) {
    let u = ae.get(f);
    if (u instanceof fi)
      c.push({ node: f, deco: u.mark });
    else {
      if (u instanceof xe || f.nodeName == "DIV" && f.parentNode == n.contentDOM)
        return { range: h, text: s, marks: c, line: f };
      if (f != n.contentDOM)
        c.push({ node: f, deco: new Gs({
          inclusive: !0,
          attributes: I1(f),
          tagName: f.tagName.toLowerCase()
        }) });
      else
        return null;
    }
  }
}
function J1(n, e) {
  return n.nodeType != 1 ? 0 : (e && n.childNodes[e - 1].contentEditable == "false" ? 1 : 0) | (e < n.childNodes.length && n.childNodes[e].contentEditable == "false" ? 2 : 0);
}
let Q1 = class {
  constructor() {
    this.changes = [];
  }
  compareRange(e, t) {
    ra(e, t, this.changes);
  }
  comparePoint(e, t) {
    ra(e, t, this.changes);
  }
};
function Z1(n, e, t) {
  let i = new Q1();
  return ne.compare(n, e, t, i), i.changes;
}
function $1(n, e) {
  for (let t = n; t && t != e; t = t.assignedSlot || t.parentNode)
    if (t.nodeType == 1 && t.contentEditable == "false")
      return !0;
  return !1;
}
function eb(n, e) {
  let t = !1;
  return e && n.iterChangedRanges((i, s) => {
    i < e.to && s > e.from && (t = !0);
  }), t;
}
function tb(n, e, t = 1) {
  let i = n.charCategorizer(e), s = n.doc.lineAt(e), r = e - s.from;
  if (s.length == 0)
    return C.cursor(e);
  r == 0 ? t = 1 : r == s.length && (t = -1);
  let o = r, l = r;
  t < 0 ? o = Re(s.text, r, !1) : l = Re(s.text, r);
  let a = i(s.text.slice(o, l));
  for (; o > 0; ) {
    let h = Re(s.text, o, !1);
    if (i(s.text.slice(h, o)) != a)
      break;
    o = h;
  }
  for (; l < s.length; ) {
    let h = Re(s.text, l);
    if (i(s.text.slice(l, h)) != a)
      break;
    l = h;
  }
  return C.range(o + s.from, l + s.from);
}
function ib(n, e) {
  return e.left > n ? e.left - n : Math.max(0, n - e.right);
}
function nb(n, e) {
  return e.top > n ? e.top - n : Math.max(0, n - e.bottom);
}
function Xo(n, e) {
  return n.top < e.bottom - 1 && n.bottom > e.top + 1;
}
function Ac(n, e) {
  return e < n.top ? { top: e, left: n.left, right: n.right, bottom: n.bottom } : n;
}
function Mc(n, e) {
  return e > n.bottom ? { top: n.top, left: n.left, right: n.right, bottom: e } : n;
}
function ca(n, e, t) {
  let i, s, r, o, l = !1, a, h, c, f;
  for (let m = n.firstChild; m; m = m.nextSibling) {
    let p = Ln(m);
    for (let g = 0; g < p.length; g++) {
      let b = p[g];
      s && Xo(s, b) && (b = Ac(Mc(b, s.bottom), s.top));
      let w = ib(e, b), k = nb(t, b);
      if (w == 0 && k == 0)
        return m.nodeType == 3 ? Tc(m, e, t) : ca(m, e, t);
      if (!i || o > k || o == k && r > w) {
        i = m, s = b, r = w, o = k;
        let x = k ? t < b.top ? -1 : 1 : w ? e < b.left ? -1 : 1 : 0;
        l = !x || (x > 0 ? g < p.length - 1 : g > 0);
      }
      w == 0 ? t > b.bottom && (!c || c.bottom < b.bottom) ? (a = m, c = b) : t < b.top && (!f || f.top > b.top) && (h = m, f = b) : c && Xo(c, b) ? c = Mc(c, b.bottom) : f && Xo(f, b) && (f = Ac(f, b.top));
    }
  }
  if (c && c.bottom >= t ? (i = a, s = c) : f && f.top <= t && (i = h, s = f), !i)
    return { node: n, offset: 0 };
  let u = Math.max(s.left, Math.min(s.right, e));
  if (i.nodeType == 3)
    return Tc(i, u, t);
  if (l && i.contentEditable != "false")
    return ca(i, u, t);
  let d = Array.prototype.indexOf.call(n.childNodes, i) + (e >= (s.left + s.right) / 2 ? 1 : 0);
  return { node: n, offset: d };
}
function Tc(n, e, t) {
  let i = n.nodeValue.length, s = -1, r = 1e9, o = 0;
  for (let l = 0; l < i; l++) {
    let a = Qi(n, l, l + 1).getClientRects();
    for (let h = 0; h < a.length; h++) {
      let c = a[h];
      if (c.top == c.bottom)
        continue;
      o || (o = e - c.left);
      let f = (c.top > t ? c.top - t : t - c.bottom) - 1;
      if (c.left - 1 <= e && c.right + 1 >= e && f < r) {
        let u = e >= (c.left + c.right) / 2, d = u;
        if ((B.chrome || B.gecko) && Qi(n, l).getBoundingClientRect().left == c.right && (d = !u), f <= 0)
          return { node: n, offset: l + (d ? 1 : 0) };
        s = l + (d ? 1 : 0), r = f;
      }
    }
  }
  return { node: n, offset: s > -1 ? s : o > 0 ? n.nodeValue.length : 0 };
}
function xm(n, e, t, i = -1) {
  var s, r;
  let o = n.contentDOM.getBoundingClientRect(), l = o.top + n.viewState.paddingTop, a, { docHeight: h } = n.viewState, { x: c, y: f } = e, u = f - l;
  if (u < 0)
    return 0;
  if (u > h)
    return n.state.doc.length;
  for (let x = n.viewState.heightOracle.textHeight / 2, _ = !1; a = n.elementAtHeight(u), a.type != ze.Text; )
    for (; u = i > 0 ? a.bottom + x : a.top - x, !(u >= 0 && u <= h); ) {
      if (_)
        return t ? null : 0;
      _ = !0, i = -i;
    }
  f = l + u;
  let d = a.from;
  if (d < n.viewport.from)
    return n.viewport.from == 0 ? 0 : t ? null : Dc(n, o, a, c, f);
  if (d > n.viewport.to)
    return n.viewport.to == n.state.doc.length ? n.state.doc.length : t ? null : Dc(n, o, a, c, f);
  let m = n.dom.ownerDocument, p = n.root.elementFromPoint ? n.root : m, g = p.elementFromPoint(c, f);
  g && !n.contentDOM.contains(g) && (g = null), g || (c = Math.max(o.left + 1, Math.min(o.right - 1, c)), g = p.elementFromPoint(c, f), g && !n.contentDOM.contains(g) && (g = null));
  let b, w = -1;
  if (g && ((s = n.docView.nearest(g)) === null || s === void 0 ? void 0 : s.isEditable) != !1) {
    if (m.caretPositionFromPoint) {
      let x = m.caretPositionFromPoint(c, f);
      x && ({ offsetNode: b, offset: w } = x);
    } else if (m.caretRangeFromPoint) {
      let x = m.caretRangeFromPoint(c, f);
      x && ({ startContainer: b, startOffset: w } = x, (!n.contentDOM.contains(b) || B.safari && sb(b, w, c) || B.chrome && rb(b, w, c)) && (b = void 0));
    }
  }
  if (!b || !n.docView.dom.contains(b)) {
    let x = xe.find(n.docView, d);
    if (!x)
      return u > a.top + a.height / 2 ? a.to : a.from;
    ({ node: b, offset: w } = ca(x.dom, c, f));
  }
  let k = n.docView.nearest(b);
  if (!k)
    return null;
  if (k.isWidget && ((r = k.dom) === null || r === void 0 ? void 0 : r.nodeType) == 1) {
    let x = k.dom.getBoundingClientRect();
    return e.y < x.top || e.y <= x.bottom && e.x <= (x.left + x.right) / 2 ? k.posAtStart : k.posAtEnd;
  } else
    return k.localPosFromDOM(b, w) + k.posAtStart;
}
function Dc(n, e, t, i, s) {
  let r = Math.round((i - e.left) * n.defaultCharacterWidth);
  if (n.lineWrapping && t.height > n.defaultLineHeight * 1.5) {
    let l = n.viewState.heightOracle.textHeight, a = Math.floor((s - t.top - (n.defaultLineHeight - l) * 0.5) / l);
    r += a * n.viewState.heightOracle.lineLength;
  }
  let o = n.state.sliceDoc(t.from, t.to);
  return t.from + Jl(o, r, n.state.tabSize);
}
function sb(n, e, t) {
  let i;
  if (n.nodeType != 3 || e != (i = n.nodeValue.length))
    return !1;
  for (let s = n.nextSibling; s; s = s.nextSibling)
    if (s.nodeType != 1 || s.nodeName != "BR")
      return !1;
  return Qi(n, i - 1, i).getBoundingClientRect().left > t;
}
function rb(n, e, t) {
  if (e != 0)
    return !1;
  for (let s = n; ; ) {
    let r = s.parentNode;
    if (!r || r.nodeType != 1 || r.firstChild != s)
      return !1;
    if (r.classList.contains("cm-line"))
      break;
    s = r;
  }
  let i = n.nodeType == 1 ? n.getBoundingClientRect() : Qi(n, 0, Math.max(n.nodeValue.length, 1)).getBoundingClientRect();
  return t - i.left > 5;
}
function fa(n, e) {
  let t = n.lineBlockAt(e);
  if (Array.isArray(t.type)) {
    for (let i of t.type)
      if (i.to > e || i.to == e && (i.to == t.to || i.type == ze.Text))
        return i;
  }
  return t;
}
function ob(n, e, t, i) {
  let s = fa(n, e.head), r = !i || s.type != ze.Text || !(n.lineWrapping || s.widgetLineBreaks) ? null : n.coordsAtPos(e.assoc < 0 && e.head > s.from ? e.head - 1 : e.head);
  if (r) {
    let o = n.dom.getBoundingClientRect(), l = n.textDirectionAt(s.from), a = n.posAtCoords({
      x: t == (l == de.LTR) ? o.right - 1 : o.left + 1,
      y: (r.top + r.bottom) / 2
    });
    if (a != null)
      return C.cursor(a, t ? -1 : 1);
  }
  return C.cursor(t ? s.to : s.from, t ? -1 : 1);
}
function Oc(n, e, t, i) {
  let s = n.state.doc.lineAt(e.head), r = n.bidiSpans(s), o = n.textDirectionAt(s.from);
  for (let l = e, a = null; ; ) {
    let h = j1(s, r, o, l, t), c = rm;
    if (!h) {
      if (s.number == (t ? n.state.doc.lines : 1))
        return l;
      c = `
`, s = n.state.doc.line(s.number + (t ? 1 : -1)), r = n.bidiSpans(s), h = n.visualLineSide(s, !t);
    }
    if (a) {
      if (!a(c))
        return l;
    } else {
      if (!i)
        return h;
      a = i(c);
    }
    l = h;
  }
}
function lb(n, e, t) {
  let i = n.state.charCategorizer(e), s = i(t);
  return (r) => {
    let o = i(r);
    return s == me.Space && (s = o), s == o;
  };
}
function ab(n, e, t, i) {
  let s = e.head, r = t ? 1 : -1;
  if (s == (t ? n.state.doc.length : 0))
    return C.cursor(s, e.assoc);
  let o = e.goalColumn, l, a = n.contentDOM.getBoundingClientRect(), h = n.coordsAtPos(s, e.assoc || -1), c = n.documentTop;
  if (h)
    o == null && (o = h.left - a.left), l = r < 0 ? h.top : h.bottom;
  else {
    let d = n.viewState.lineBlockAt(s);
    o == null && (o = Math.min(a.right - a.left, n.defaultCharacterWidth * (s - d.from))), l = (r < 0 ? d.top : d.bottom) + c;
  }
  let f = a.left + o, u = i ?? n.viewState.heightOracle.textHeight >> 1;
  for (let d = 0; ; d += 10) {
    let m = l + (u + d) * r, p = xm(n, { x: f, y: m }, !1, r);
    if (m < a.top || m > a.bottom || (r < 0 ? p < s : p > s)) {
      let g = n.docView.coordsForChar(p), b = !g || m < g.top ? -1 : 1;
      return C.cursor(p, b, void 0, o);
    }
  }
}
function Vr(n, e, t) {
  for (; ; ) {
    let i = 0;
    for (let s of n)
      s.between(e - 1, e + 1, (r, o, l) => {
        if (e > r && e < o) {
          let a = i || t || (e - r < o - e ? -1 : 1);
          e = a < 0 ? r : o, i = a;
        }
      });
    if (!i)
      return e;
  }
}
function Jo(n, e, t) {
  let i = Vr(n.state.facet(Qa).map((s) => s(n)), t.from, e.head > t.from ? -1 : 1);
  return i == t.from ? t : C.cursor(i, i < t.from ? 1 : -1);
}
const ds = "￿";
class hb {
  constructor(e, t) {
    this.points = e, this.text = "", this.lineSeparator = t.facet(Z.lineSeparator);
  }
  append(e) {
    this.text += e;
  }
  lineBreak() {
    this.text += ds;
  }
  readRange(e, t) {
    if (!e)
      return this;
    let i = e.parentNode;
    for (let s = e; ; ) {
      this.findPointBefore(i, s);
      let r = this.text.length;
      this.readNode(s);
      let o = s.nextSibling;
      if (o == t)
        break;
      let l = ae.get(s), a = ae.get(o);
      (l && a ? l.breakAfter : (l ? l.breakAfter : Qr(s)) || Qr(o) && (s.nodeName != "BR" || s.cmIgnore) && this.text.length > r) && this.lineBreak(), s = o;
    }
    return this.findPointBefore(i, t), this;
  }
  readTextNode(e) {
    let t = e.nodeValue;
    for (let i of this.points)
      i.node == e && (i.pos = this.text.length + Math.min(i.offset, t.length));
    for (let i = 0, s = this.lineSeparator ? null : /\r\n?|\n/g; ; ) {
      let r = -1, o = 1, l;
      if (this.lineSeparator ? (r = t.indexOf(this.lineSeparator, i), o = this.lineSeparator.length) : (l = s.exec(t)) && (r = l.index, o = l[0].length), this.append(t.slice(i, r < 0 ? t.length : r)), r < 0)
        break;
      if (this.lineBreak(), o > 1)
        for (let a of this.points)
          a.node == e && a.pos > this.text.length && (a.pos -= o - 1);
      i = r + o;
    }
  }
  readNode(e) {
    if (e.cmIgnore)
      return;
    let t = ae.get(e), i = t && t.overrideDOMText;
    if (i != null) {
      this.findPointInside(e, i.length);
      for (let s = i.iter(); !s.next().done; )
        s.lineBreak ? this.lineBreak() : this.append(s.value);
    } else e.nodeType == 3 ? this.readTextNode(e) : e.nodeName == "BR" ? e.nextSibling && this.lineBreak() : e.nodeType == 1 && this.readRange(e.firstChild, null);
  }
  findPointBefore(e, t) {
    for (let i of this.points)
      i.node == e && e.childNodes[i.offset] == t && (i.pos = this.text.length);
  }
  findPointInside(e, t) {
    for (let i of this.points)
      (e.nodeType == 3 ? i.node == e : e.contains(i.node)) && (i.pos = this.text.length + (cb(e, i.node, i.offset) ? t : 0));
  }
}
function cb(n, e, t) {
  for (; ; ) {
    if (!e || t < ci(e))
      return !1;
    if (e == n)
      return !0;
    t = Ji(e) + 1, e = e.parentNode;
  }
}
class Ec {
  constructor(e, t) {
    this.node = e, this.offset = t, this.pos = -1;
  }
}
class fb {
  constructor(e, t, i, s) {
    this.typeOver = s, this.bounds = null, this.text = "", this.domChanged = t > -1;
    let { impreciseHead: r, impreciseAnchor: o } = e.docView;
    if (e.state.readOnly && t > -1)
      this.newSel = null;
    else if (t > -1 && (this.bounds = e.docView.domBoundsAround(t, i, 0))) {
      let l = r || o ? [] : mb(e), a = new hb(l, e.state);
      a.readRange(this.bounds.startDOM, this.bounds.endDOM), this.text = a.text, this.newSel = pb(l, this.bounds.from);
    } else {
      let l = e.observer.selectionRange, a = r && r.node == l.focusNode && r.offset == l.focusOffset || !$l(e.contentDOM, l.focusNode) ? e.state.selection.main.head : e.docView.posFromDOM(l.focusNode, l.focusOffset), h = o && o.node == l.anchorNode && o.offset == l.anchorOffset || !$l(e.contentDOM, l.anchorNode) ? e.state.selection.main.anchor : e.docView.posFromDOM(l.anchorNode, l.anchorOffset), c = e.viewport;
      if ((B.ios || B.chrome) && e.state.selection.main.empty && a != h && (c.from > 0 || c.to < e.state.doc.length)) {
        let f = Math.min(a, h), u = Math.max(a, h), d = c.from - f, m = c.to - u;
        (d == 0 || d == 1 || f == 0) && (m == 0 || m == -1 || u == e.state.doc.length) && (a = 0, h = e.state.doc.length);
      }
      this.newSel = C.single(h, a);
    }
  }
}
function Sm(n, e) {
  let t, { newSel: i } = e, s = n.state.selection.main, r = n.inputState.lastKeyTime > Date.now() - 100 ? n.inputState.lastKeyCode : -1;
  if (e.bounds) {
    let { from: o, to: l } = e.bounds, a = s.from, h = null;
    (r === 8 || B.android && e.text.length < l - o) && (a = s.to, h = "end");
    let c = db(n.state.doc.sliceString(o, l, ds), e.text, a - o, h);
    c && (B.chrome && r == 13 && c.toB == c.from + 2 && e.text.slice(c.from, c.toB) == ds + ds && c.toB--, t = {
      from: o + c.from,
      to: o + c.toA,
      insert: ie.of(e.text.slice(c.from, c.toB).split(ds))
    });
  } else i && (!n.hasFocus && n.state.facet(vi) || i.main.eq(s)) && (i = null);
  if (!t && !i)
    return !1;
  if (!t && e.typeOver && !s.empty && i && i.main.empty ? t = { from: s.from, to: s.to, insert: n.state.doc.slice(s.from, s.to) } : t && t.from >= s.from && t.to <= s.to && (t.from != s.from || t.to != s.to) && s.to - s.from - (t.to - t.from) <= 4 ? t = {
    from: s.from,
    to: s.to,
    insert: n.state.doc.slice(s.from, t.from).append(t.insert).append(n.state.doc.slice(t.to, s.to))
  } : (B.mac || B.android) && t && t.from == t.to && t.from == s.head - 1 && /^\. ?$/.test(t.insert.toString()) && n.contentDOM.getAttribute("autocorrect") == "off" ? (i && t.insert.length == 2 && (i = C.single(i.main.anchor - 1, i.main.head - 1)), t = { from: s.from, to: s.to, insert: ie.of([" "]) }) : B.chrome && t && t.from == t.to && t.from == s.head && t.insert.toString() == `
 ` && n.lineWrapping && (i && (i = C.single(i.main.anchor - 1, i.main.head - 1)), t = { from: s.from, to: s.to, insert: ie.of([" "]) }), t)
    return Za(n, t, i, r);
  if (i && !i.main.eq(s)) {
    let o = !1, l = "select";
    return n.inputState.lastSelectionTime > Date.now() - 50 && (n.inputState.lastSelectionOrigin == "select" && (o = !0), l = n.inputState.lastSelectionOrigin), n.dispatch({ selection: i, scrollIntoView: o, userEvent: l }), !0;
  } else
    return !1;
}
function Za(n, e, t, i = -1) {
  if (B.ios && n.inputState.flushIOSKey(e))
    return !0;
  let s = n.state.selection.main;
  if (B.android && (e.to == s.to && // GBoard will sometimes remove a space it just inserted
  // after a completion when you press enter
  (e.from == s.from || e.from == s.from - 1 && n.state.sliceDoc(e.from, s.from) == " ") && e.insert.length == 1 && e.insert.lines == 2 && Cn(n.contentDOM, "Enter", 13) || (e.from == s.from - 1 && e.to == s.to && e.insert.length == 0 || i == 8 && e.insert.length < e.to - e.from && e.to > s.head) && Cn(n.contentDOM, "Backspace", 8) || e.from == s.from && e.to == s.to + 1 && e.insert.length == 0 && Cn(n.contentDOM, "Delete", 46)))
    return !0;
  let r = e.insert.toString();
  n.inputState.composing >= 0 && n.inputState.composing++;
  let o, l = () => o || (o = ub(n, e, t));
  return n.state.facet(cm).some((a) => a(n, e.from, e.to, r, l)) || n.dispatch(l()), !0;
}
function ub(n, e, t) {
  let i, s = n.state, r = s.selection.main;
  if (e.from >= r.from && e.to <= r.to && e.to - e.from >= (r.to - r.from) / 3 && (!t || t.main.empty && t.main.from == e.from + e.insert.length) && n.inputState.composing < 0) {
    let l = r.from < e.from ? s.sliceDoc(r.from, e.from) : "", a = r.to > e.to ? s.sliceDoc(e.to, r.to) : "";
    i = s.replaceSelection(n.state.toText(l + e.insert.sliceString(0, void 0, n.state.lineBreak) + a));
  } else {
    let l = s.changes(e), a = t && t.main.to <= l.newLength ? t.main : void 0;
    if (s.selection.ranges.length > 1 && n.inputState.composing >= 0 && e.to <= r.to && e.to >= r.to - 10) {
      let h = n.state.sliceDoc(e.from, e.to), c, f = t && vm(n, t.main.head);
      if (f) {
        let m = e.insert.length - (e.to - e.from);
        c = { from: f.from, to: f.to - m };
      } else
        c = n.state.doc.lineAt(r.head);
      let u = r.to - e.to, d = r.to - r.from;
      i = s.changeByRange((m) => {
        if (m.from == r.from && m.to == r.to)
          return { changes: l, range: a || m.map(l) };
        let p = m.to - u, g = p - h.length;
        if (m.to - m.from != d || n.state.sliceDoc(g, p) != h || // Unfortunately, there's no way to make multiple
        // changes in the same node work without aborting
        // composition, so cursors in the composition range are
        // ignored.
        m.to >= c.from && m.from <= c.to)
          return { range: m };
        let b = s.changes({ from: g, to: p, insert: e.insert }), w = m.to - r.to;
        return {
          changes: b,
          range: a ? C.range(Math.max(0, a.anchor + w), Math.max(0, a.head + w)) : m.map(b)
        };
      });
    } else
      i = {
        changes: l,
        selection: a && s.selection.replaceRange(a)
      };
  }
  let o = "input.type";
  return (n.composing || n.inputState.compositionPendingChange && n.inputState.compositionEndedAt > Date.now() - 50) && (n.inputState.compositionPendingChange = !1, o += ".compose", n.inputState.compositionFirstChange && (o += ".start", n.inputState.compositionFirstChange = !1)), s.update(i, { userEvent: o, scrollIntoView: !0 });
}
function db(n, e, t, i) {
  let s = Math.min(n.length, e.length), r = 0;
  for (; r < s && n.charCodeAt(r) == e.charCodeAt(r); )
    r++;
  if (r == s && n.length == e.length)
    return null;
  let o = n.length, l = e.length;
  for (; o > 0 && l > 0 && n.charCodeAt(o - 1) == e.charCodeAt(l - 1); )
    o--, l--;
  if (i == "end") {
    let a = Math.max(0, r - Math.min(o, l));
    t -= o + a - r;
  }
  if (o < r && n.length < e.length) {
    let a = t <= r && t >= o ? r - t : 0;
    r -= a, l = r + (l - o), o = r;
  } else if (l < r) {
    let a = t <= r && t >= l ? r - t : 0;
    r -= a, o = r + (o - l), l = r;
  }
  return { from: r, toA: o, toB: l };
}
function mb(n) {
  let e = [];
  if (n.root.activeElement != n.contentDOM)
    return e;
  let { anchorNode: t, anchorOffset: i, focusNode: s, focusOffset: r } = n.observer.selectionRange;
  return t && (e.push(new Ec(t, i)), (s != t || r != i) && e.push(new Ec(s, r))), e;
}
function pb(n, e) {
  if (n.length == 0)
    return null;
  let t = n[0].pos, i = n.length == 2 ? n[1].pos : t;
  return t > -1 && i > -1 ? C.single(t + e, i + e) : null;
}
class gb {
  setSelectionOrigin(e) {
    this.lastSelectionOrigin = e, this.lastSelectionTime = Date.now();
  }
  constructor(e) {
    this.view = e, this.lastKeyCode = 0, this.lastKeyTime = 0, this.lastTouchTime = 0, this.lastFocusTime = 0, this.lastScrollTop = 0, this.lastScrollLeft = 0, this.pendingIOSKey = void 0, this.tabFocusMode = -1, this.lastSelectionOrigin = null, this.lastSelectionTime = 0, this.lastContextMenu = 0, this.scrollHandlers = [], this.handlers = /* @__PURE__ */ Object.create(null), this.composing = -1, this.compositionFirstChange = null, this.compositionEndedAt = 0, this.compositionPendingKey = !1, this.compositionPendingChange = !1, this.mouseSelection = null, this.draggedContent = null, this.handleEvent = this.handleEvent.bind(this), this.notifiedFocused = e.hasFocus, B.safari && e.contentDOM.addEventListener("input", () => null), B.gecko && Lb(e.contentDOM.ownerDocument);
  }
  handleEvent(e) {
    !_b(this.view, e) || this.ignoreDuringComposition(e) || e.type == "keydown" && this.keydown(e) || this.runHandlers(e.type, e);
  }
  runHandlers(e, t) {
    let i = this.handlers[e];
    if (i) {
      for (let s of i.observers)
        s(this.view, t);
      for (let s of i.handlers) {
        if (t.defaultPrevented)
          break;
        if (s(this.view, t)) {
          t.preventDefault();
          break;
        }
      }
    }
  }
  ensureHandlers(e) {
    let t = bb(e), i = this.handlers, s = this.view.contentDOM;
    for (let r in t)
      if (r != "scroll") {
        let o = !t[r].handlers.length, l = i[r];
        l && o != !l.handlers.length && (s.removeEventListener(r, this.handleEvent), l = null), l || s.addEventListener(r, this.handleEvent, { passive: o });
      }
    for (let r in i)
      r != "scroll" && !t[r] && s.removeEventListener(r, this.handleEvent);
    this.handlers = t;
  }
  keydown(e) {
    if (this.lastKeyCode = e.keyCode, this.lastKeyTime = Date.now(), e.keyCode == 9 && this.tabFocusMode > -1 && (!this.tabFocusMode || Date.now() <= this.tabFocusMode))
      return !0;
    if (this.tabFocusMode > 0 && e.keyCode != 27 && Cm.indexOf(e.keyCode) < 0 && (this.tabFocusMode = -1), B.android && B.chrome && !e.synthetic && (e.keyCode == 13 || e.keyCode == 8))
      return this.view.observer.delayAndroidKey(e.key, e.keyCode), !0;
    let t;
    return B.ios && !e.synthetic && !e.altKey && !e.metaKey && ((t = _m.find((i) => i.keyCode == e.keyCode)) && !e.ctrlKey || yb.indexOf(e.key) > -1 && e.ctrlKey && !e.shiftKey) ? (this.pendingIOSKey = t || e, setTimeout(() => this.flushIOSKey(), 250), !0) : (e.keyCode != 229 && this.view.observer.forceFlush(), !1);
  }
  flushIOSKey(e) {
    let t = this.pendingIOSKey;
    return !t || t.key == "Enter" && e && e.from < e.to && /^\S+$/.test(e.insert.toString()) ? !1 : (this.pendingIOSKey = void 0, Cn(this.view.contentDOM, t.key, t.keyCode, t instanceof KeyboardEvent ? t : void 0));
  }
  ignoreDuringComposition(e) {
    return /^key/.test(e.type) ? this.composing > 0 ? !0 : B.safari && !B.ios && this.compositionPendingKey && Date.now() - this.compositionEndedAt < 100 ? (this.compositionPendingKey = !1, !0) : !1 : !1;
  }
  startMouseSelection(e) {
    this.mouseSelection && this.mouseSelection.destroy(), this.mouseSelection = e;
  }
  update(e) {
    this.view.observer.update(e), this.mouseSelection && this.mouseSelection.update(e), this.draggedContent && e.docChanged && (this.draggedContent = this.draggedContent.map(e.changes)), e.transactions.length && (this.lastKeyCode = this.lastSelectionTime = 0);
  }
  destroy() {
    this.mouseSelection && this.mouseSelection.destroy();
  }
}
function Lc(n, e) {
  return (t, i) => {
    try {
      return e.call(n, i, t);
    } catch (s) {
      Je(t.state, s);
    }
  };
}
function bb(n) {
  let e = /* @__PURE__ */ Object.create(null);
  function t(i) {
    return e[i] || (e[i] = { observers: [], handlers: [] });
  }
  for (let i of n) {
    let s = i.spec;
    if (s && s.domEventHandlers)
      for (let r in s.domEventHandlers) {
        let o = s.domEventHandlers[r];
        o && t(r).handlers.push(Lc(i.value, o));
      }
    if (s && s.domEventObservers)
      for (let r in s.domEventObservers) {
        let o = s.domEventObservers[r];
        o && t(r).observers.push(Lc(i.value, o));
      }
  }
  for (let i in Ot)
    t(i).handlers.push(Ot[i]);
  for (let i in pt)
    t(i).observers.push(pt[i]);
  return e;
}
const _m = [
  { key: "Backspace", keyCode: 8, inputType: "deleteContentBackward" },
  { key: "Enter", keyCode: 13, inputType: "insertParagraph" },
  { key: "Enter", keyCode: 13, inputType: "insertLineBreak" },
  { key: "Delete", keyCode: 46, inputType: "deleteContentForward" }
], yb = "dthko", Cm = [16, 17, 18, 20, 91, 92, 224, 225], hr = 6;
function cr(n) {
  return Math.max(0, n) * 0.7 + 8;
}
function wb(n, e) {
  return Math.max(Math.abs(n.clientX - e.clientX), Math.abs(n.clientY - e.clientY));
}
class kb {
  constructor(e, t, i, s) {
    this.view = e, this.startEvent = t, this.style = i, this.mustSelect = s, this.scrollSpeed = { x: 0, y: 0 }, this.scrolling = -1, this.lastEvent = t, this.scrollParents = D1(e.contentDOM), this.atoms = e.state.facet(Qa).map((o) => o(e));
    let r = e.contentDOM.ownerDocument;
    r.addEventListener("mousemove", this.move = this.move.bind(this)), r.addEventListener("mouseup", this.up = this.up.bind(this)), this.extend = t.shiftKey, this.multiple = e.state.facet(Z.allowMultipleSelections) && vb(e, t), this.dragging = Sb(e, t) && Tm(t) == 1 ? null : !1;
  }
  start(e) {
    this.dragging === !1 && this.select(e);
  }
  move(e) {
    if (e.buttons == 0)
      return this.destroy();
    if (this.dragging || this.dragging == null && wb(this.startEvent, e) < 10)
      return;
    this.select(this.lastEvent = e);
    let t = 0, i = 0, s = 0, r = 0, o = this.view.win.innerWidth, l = this.view.win.innerHeight;
    this.scrollParents.x && ({ left: s, right: o } = this.scrollParents.x.getBoundingClientRect()), this.scrollParents.y && ({ top: r, bottom: l } = this.scrollParents.y.getBoundingClientRect());
    let a = km(this.view);
    e.clientX - a.left <= s + hr ? t = -cr(s - e.clientX) : e.clientX + a.right >= o - hr && (t = cr(e.clientX - o)), e.clientY - a.top <= r + hr ? i = -cr(r - e.clientY) : e.clientY + a.bottom >= l - hr && (i = cr(e.clientY - l)), this.setScrollSpeed(t, i);
  }
  up(e) {
    this.dragging == null && this.select(this.lastEvent), this.dragging || e.preventDefault(), this.destroy();
  }
  destroy() {
    this.setScrollSpeed(0, 0);
    let e = this.view.contentDOM.ownerDocument;
    e.removeEventListener("mousemove", this.move), e.removeEventListener("mouseup", this.up), this.view.inputState.mouseSelection = this.view.inputState.draggedContent = null;
  }
  setScrollSpeed(e, t) {
    this.scrollSpeed = { x: e, y: t }, e || t ? this.scrolling < 0 && (this.scrolling = setInterval(() => this.scroll(), 50)) : this.scrolling > -1 && (clearInterval(this.scrolling), this.scrolling = -1);
  }
  scroll() {
    let { x: e, y: t } = this.scrollSpeed;
    e && this.scrollParents.x && (this.scrollParents.x.scrollLeft += e, e = 0), t && this.scrollParents.y && (this.scrollParents.y.scrollTop += t, t = 0), (e || t) && this.view.win.scrollBy(e, t), this.dragging === !1 && this.select(this.lastEvent);
  }
  skipAtoms(e) {
    let t = null;
    for (let i = 0; i < e.ranges.length; i++) {
      let s = e.ranges[i], r = null;
      if (s.empty) {
        let o = Vr(this.atoms, s.from, 0);
        o != s.from && (r = C.cursor(o, -1));
      } else {
        let o = Vr(this.atoms, s.from, -1), l = Vr(this.atoms, s.to, 1);
        (o != s.from || l != s.to) && (r = C.range(s.from == s.anchor ? o : l, s.from == s.head ? o : l));
      }
      r && (t || (t = e.ranges.slice()), t[i] = r);
    }
    return t ? C.create(t, e.mainIndex) : e;
  }
  select(e) {
    let { view: t } = this, i = this.skipAtoms(this.style.get(e, this.extend, this.multiple));
    (this.mustSelect || !i.eq(t.state.selection, this.dragging === !1)) && this.view.dispatch({
      selection: i,
      userEvent: "select.pointer"
    }), this.mustSelect = !1;
  }
  update(e) {
    e.transactions.some((t) => t.isUserEvent("input.type")) ? this.destroy() : this.style.update(e) && setTimeout(() => this.select(this.lastEvent), 20);
  }
}
function vb(n, e) {
  let t = n.state.facet(om);
  return t.length ? t[0](e) : B.mac ? e.metaKey : e.ctrlKey;
}
function xb(n, e) {
  let t = n.state.facet(lm);
  return t.length ? t[0](e) : B.mac ? !e.altKey : !e.ctrlKey;
}
function Sb(n, e) {
  let { main: t } = n.state.selection;
  if (t.empty)
    return !1;
  let i = Os(n.root);
  if (!i || i.rangeCount == 0)
    return !0;
  let s = i.getRangeAt(0).getClientRects();
  for (let r = 0; r < s.length; r++) {
    let o = s[r];
    if (o.left <= e.clientX && o.right >= e.clientX && o.top <= e.clientY && o.bottom >= e.clientY)
      return !0;
  }
  return !1;
}
function _b(n, e) {
  if (!e.bubbles)
    return !0;
  if (e.defaultPrevented)
    return !1;
  for (let t = e.target, i; t != n.contentDOM; t = t.parentNode)
    if (!t || t.nodeType == 11 || (i = ae.get(t)) && i.ignoreEvent(e))
      return !1;
  return !0;
}
const Ot = /* @__PURE__ */ Object.create(null), pt = /* @__PURE__ */ Object.create(null), Am = B.ie && B.ie_version < 15 || B.ios && B.webkit_version < 604;
function Cb(n) {
  let e = n.dom.parentNode;
  if (!e)
    return;
  let t = e.appendChild(document.createElement("textarea"));
  t.style.cssText = "position: fixed; left: -10000px; top: 10px", t.focus(), setTimeout(() => {
    n.focus(), t.remove(), Mm(n, t.value);
  }, 50);
}
function Mm(n, e) {
  let { state: t } = n, i, s = 1, r = t.toText(e), o = r.lines == t.selection.ranges.length;
  if (ua != null && t.selection.ranges.every((a) => a.empty) && ua == r.toString()) {
    let a = -1;
    i = t.changeByRange((h) => {
      let c = t.doc.lineAt(h.from);
      if (c.from == a)
        return { range: h };
      a = c.from;
      let f = t.toText((o ? r.line(s++).text : e) + t.lineBreak);
      return {
        changes: { from: c.from, insert: f },
        range: C.cursor(h.from + f.length)
      };
    });
  } else o ? i = t.changeByRange((a) => {
    let h = r.line(s++);
    return {
      changes: { from: a.from, to: a.to, insert: h.text },
      range: C.cursor(a.from + h.length)
    };
  }) : i = t.replaceSelection(r);
  n.dispatch(i, {
    userEvent: "input.paste",
    scrollIntoView: !0
  });
}
pt.scroll = (n) => {
  n.inputState.lastScrollTop = n.scrollDOM.scrollTop, n.inputState.lastScrollLeft = n.scrollDOM.scrollLeft;
};
Ot.keydown = (n, e) => (n.inputState.setSelectionOrigin("select"), e.keyCode == 27 && n.inputState.tabFocusMode != 0 && (n.inputState.tabFocusMode = Date.now() + 2e3), !1);
pt.touchstart = (n, e) => {
  n.inputState.lastTouchTime = Date.now(), n.inputState.setSelectionOrigin("select.pointer");
};
pt.touchmove = (n) => {
  n.inputState.setSelectionOrigin("select.pointer");
};
Ot.mousedown = (n, e) => {
  if (n.observer.flush(), n.inputState.lastTouchTime > Date.now() - 2e3)
    return !1;
  let t = null;
  for (let i of n.state.facet(am))
    if (t = i(n, e), t)
      break;
  if (!t && e.button == 0 && (t = Tb(n, e)), t) {
    let i = !n.hasFocus;
    n.inputState.startMouseSelection(new kb(n, e, t, i)), i && n.observer.ignore(() => {
      Wd(n.contentDOM);
      let r = n.root.activeElement;
      r && !r.contains(n.contentDOM) && r.blur();
    });
    let s = n.inputState.mouseSelection;
    if (s)
      return s.start(e), s.dragging === !1;
  }
  return !1;
};
function Rc(n, e, t, i) {
  if (i == 1)
    return C.cursor(e, t);
  if (i == 2)
    return tb(n.state, e, t);
  {
    let s = xe.find(n.docView, e), r = n.state.doc.lineAt(s ? s.posAtEnd : e), o = s ? s.posAtStart : r.from, l = s ? s.posAtEnd : r.to;
    return l < n.state.doc.length && l == r.to && l++, C.range(o, l);
  }
}
let Pc = (n, e, t) => e >= t.top && e <= t.bottom && n >= t.left && n <= t.right;
function Ab(n, e, t, i) {
  let s = xe.find(n.docView, e);
  if (!s)
    return 1;
  let r = e - s.posAtStart;
  if (r == 0)
    return 1;
  if (r == s.length)
    return -1;
  let o = s.coordsAt(r, -1);
  if (o && Pc(t, i, o))
    return -1;
  let l = s.coordsAt(r, 1);
  return l && Pc(t, i, l) ? 1 : o && o.bottom >= i ? -1 : 1;
}
function Bc(n, e) {
  let t = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1);
  return { pos: t, bias: Ab(n, t, e.clientX, e.clientY) };
}
const Mb = B.ie && B.ie_version <= 11;
let Ic = null, Nc = 0, Fc = 0;
function Tm(n) {
  if (!Mb)
    return n.detail;
  let e = Ic, t = Fc;
  return Ic = n, Fc = Date.now(), Nc = !e || t > Date.now() - 400 && Math.abs(e.clientX - n.clientX) < 2 && Math.abs(e.clientY - n.clientY) < 2 ? (Nc + 1) % 3 : 1;
}
function Tb(n, e) {
  let t = Bc(n, e), i = Tm(e), s = n.state.selection;
  return {
    update(r) {
      r.docChanged && (t.pos = r.changes.mapPos(t.pos), s = s.map(r.changes));
    },
    get(r, o, l) {
      let a = Bc(n, r), h, c = Rc(n, a.pos, a.bias, i);
      if (t.pos != a.pos && !o) {
        let f = Rc(n, t.pos, t.bias, i), u = Math.min(f.from, c.from), d = Math.max(f.to, c.to);
        c = u < c.from ? C.range(u, d) : C.range(d, u);
      }
      return o ? s.replaceRange(s.main.extend(c.from, c.to)) : l && i == 1 && s.ranges.length > 1 && (h = Db(s, a.pos)) ? h : l ? s.addRange(c) : C.create([c]);
    }
  };
}
function Db(n, e) {
  for (let t = 0; t < n.ranges.length; t++) {
    let { from: i, to: s } = n.ranges[t];
    if (i <= e && s >= e)
      return C.create(n.ranges.slice(0, t).concat(n.ranges.slice(t + 1)), n.mainIndex == t ? 0 : n.mainIndex - (n.mainIndex > t ? 1 : 0));
  }
  return null;
}
Ot.dragstart = (n, e) => {
  let { selection: { main: t } } = n.state;
  if (e.target.draggable) {
    let s = n.docView.nearest(e.target);
    if (s && s.isWidget) {
      let r = s.posAtStart, o = r + s.length;
      (r >= t.to || o <= t.from) && (t = C.range(r, o));
    }
  }
  let { inputState: i } = n;
  return i.mouseSelection && (i.mouseSelection.dragging = !0), i.draggedContent = t, e.dataTransfer && (e.dataTransfer.setData("Text", n.state.sliceDoc(t.from, t.to)), e.dataTransfer.effectAllowed = "copyMove"), !1;
};
Ot.dragend = (n) => (n.inputState.draggedContent = null, !1);
function Hc(n, e, t, i) {
  if (!t)
    return;
  let s = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1), { draggedContent: r } = n.inputState, o = i && r && xb(n, e) ? { from: r.from, to: r.to } : null, l = { from: s, insert: t }, a = n.state.changes(o ? [o, l] : l);
  n.focus(), n.dispatch({
    changes: a,
    selection: { anchor: a.mapPos(s, -1), head: a.mapPos(s, 1) },
    userEvent: o ? "move.drop" : "input.drop"
  }), n.inputState.draggedContent = null;
}
Ot.drop = (n, e) => {
  if (!e.dataTransfer)
    return !1;
  if (n.state.readOnly)
    return !0;
  let t = e.dataTransfer.files;
  if (t && t.length) {
    let i = Array(t.length), s = 0, r = () => {
      ++s == t.length && Hc(n, e, i.filter((o) => o != null).join(n.state.lineBreak), !1);
    };
    for (let o = 0; o < t.length; o++) {
      let l = new FileReader();
      l.onerror = r, l.onload = () => {
        /[\x00-\x08\x0e-\x1f]{2}/.test(l.result) || (i[o] = l.result), r();
      }, l.readAsText(t[o]);
    }
    return !0;
  } else {
    let i = e.dataTransfer.getData("Text");
    if (i)
      return Hc(n, e, i, !0), !0;
  }
  return !1;
};
Ot.paste = (n, e) => {
  if (n.state.readOnly)
    return !0;
  n.observer.flush();
  let t = Am ? null : e.clipboardData;
  return t ? (Mm(n, t.getData("text/plain") || t.getData("text/uri-list")), !0) : (Cb(n), !1);
};
function Ob(n, e) {
  let t = n.dom.parentNode;
  if (!t)
    return;
  let i = t.appendChild(document.createElement("textarea"));
  i.style.cssText = "position: fixed; left: -10000px; top: 10px", i.value = e, i.focus(), i.selectionEnd = e.length, i.selectionStart = 0, setTimeout(() => {
    i.remove(), n.focus();
  }, 50);
}
function Eb(n) {
  let e = [], t = [], i = !1;
  for (let s of n.selection.ranges)
    s.empty || (e.push(n.sliceDoc(s.from, s.to)), t.push(s));
  if (!e.length) {
    let s = -1;
    for (let { from: r } of n.selection.ranges) {
      let o = n.doc.lineAt(r);
      o.number > s && (e.push(o.text), t.push({ from: o.from, to: Math.min(n.doc.length, o.to + 1) })), s = o.number;
    }
    i = !0;
  }
  return { text: e.join(n.lineBreak), ranges: t, linewise: i };
}
let ua = null;
Ot.copy = Ot.cut = (n, e) => {
  let { text: t, ranges: i, linewise: s } = Eb(n.state);
  if (!t && !s)
    return !1;
  ua = s ? t : null, e.type == "cut" && !n.state.readOnly && n.dispatch({
    changes: i,
    scrollIntoView: !0,
    userEvent: "delete.cut"
  });
  let r = Am ? null : e.clipboardData;
  return r ? (r.clearData(), r.setData("text/plain", t), !0) : (Ob(n, t), !1);
};
const Dm = /* @__PURE__ */ di.define();
function Om(n, e) {
  let t = [];
  for (let i of n.facet(fm)) {
    let s = i(n, e);
    s && t.push(s);
  }
  return t ? n.update({ effects: t, annotations: Dm.of(!0) }) : null;
}
function Em(n) {
  setTimeout(() => {
    let e = n.hasFocus;
    if (e != n.inputState.notifiedFocused) {
      let t = Om(n.state, e);
      t ? n.dispatch(t) : n.update([]);
    }
  }, 10);
}
pt.focus = (n) => {
  n.inputState.lastFocusTime = Date.now(), !n.scrollDOM.scrollTop && (n.inputState.lastScrollTop || n.inputState.lastScrollLeft) && (n.scrollDOM.scrollTop = n.inputState.lastScrollTop, n.scrollDOM.scrollLeft = n.inputState.lastScrollLeft), Em(n);
};
pt.blur = (n) => {
  n.observer.clearSelectionRange(), Em(n);
};
pt.compositionstart = pt.compositionupdate = (n) => {
  n.observer.editContext || (n.inputState.compositionFirstChange == null && (n.inputState.compositionFirstChange = !0), n.inputState.composing < 0 && (n.inputState.composing = 0));
};
pt.compositionend = (n) => {
  n.observer.editContext || (n.inputState.composing = -1, n.inputState.compositionEndedAt = Date.now(), n.inputState.compositionPendingKey = !0, n.inputState.compositionPendingChange = n.observer.pendingRecords().length > 0, n.inputState.compositionFirstChange = null, B.chrome && B.android ? n.observer.flushSoon() : n.inputState.compositionPendingChange ? Promise.resolve().then(() => n.observer.flush()) : setTimeout(() => {
    n.inputState.composing < 0 && n.docView.hasComposition && n.update([]);
  }, 50));
};
pt.contextmenu = (n) => {
  n.inputState.lastContextMenu = Date.now();
};
Ot.beforeinput = (n, e) => {
  var t, i;
  if (e.inputType == "insertReplacementText" && n.observer.editContext) {
    let r = (t = e.dataTransfer) === null || t === void 0 ? void 0 : t.getData("text/plain"), o = e.getTargetRanges();
    if (r && o.length) {
      let l = o[0], a = n.posAtDOM(l.startContainer, l.startOffset), h = n.posAtDOM(l.endContainer, l.endOffset);
      return Za(n, { from: a, to: h, insert: n.state.toText(r) }, null), !0;
    }
  }
  let s;
  if (B.chrome && B.android && (s = _m.find((r) => r.inputType == e.inputType)) && (n.observer.delayAndroidKey(s.key, s.keyCode), s.key == "Backspace" || s.key == "Delete")) {
    let r = ((i = window.visualViewport) === null || i === void 0 ? void 0 : i.height) || 0;
    setTimeout(() => {
      var o;
      (((o = window.visualViewport) === null || o === void 0 ? void 0 : o.height) || 0) > r + 10 && n.hasFocus && (n.contentDOM.blur(), n.focus());
    }, 100);
  }
  return B.ios && e.inputType == "deleteContentForward" && n.observer.flushSoon(), B.safari && e.inputType == "insertText" && n.inputState.composing >= 0 && setTimeout(() => pt.compositionend(n, e), 20), !1;
};
const Vc = /* @__PURE__ */ new Set();
function Lb(n) {
  Vc.has(n) || (Vc.add(n), n.addEventListener("copy", () => {
  }), n.addEventListener("cut", () => {
  }));
}
const Wc = ["pre-wrap", "normal", "pre-line", "break-spaces"];
let Bn = !1;
function zc() {
  Bn = !1;
}
class Rb {
  constructor(e) {
    this.lineWrapping = e, this.doc = ie.empty, this.heightSamples = {}, this.lineHeight = 14, this.charWidth = 7, this.textHeight = 14, this.lineLength = 30;
  }
  heightForGap(e, t) {
    let i = this.doc.lineAt(t).number - this.doc.lineAt(e).number + 1;
    return this.lineWrapping && (i += Math.max(0, Math.ceil((t - e - i * this.lineLength * 0.5) / this.lineLength))), this.lineHeight * i;
  }
  heightForLine(e) {
    return this.lineWrapping ? (1 + Math.max(0, Math.ceil((e - this.lineLength) / (this.lineLength - 5)))) * this.lineHeight : this.lineHeight;
  }
  setDoc(e) {
    return this.doc = e, this;
  }
  mustRefreshForWrapping(e) {
    return Wc.indexOf(e) > -1 != this.lineWrapping;
  }
  mustRefreshForHeights(e) {
    let t = !1;
    for (let i = 0; i < e.length; i++) {
      let s = e[i];
      s < 0 ? i++ : this.heightSamples[Math.floor(s * 10)] || (t = !0, this.heightSamples[Math.floor(s * 10)] = !0);
    }
    return t;
  }
  refresh(e, t, i, s, r, o) {
    let l = Wc.indexOf(e) > -1, a = Math.round(t) != Math.round(this.lineHeight) || this.lineWrapping != l;
    if (this.lineWrapping = l, this.lineHeight = t, this.charWidth = i, this.textHeight = s, this.lineLength = r, a) {
      this.heightSamples = {};
      for (let h = 0; h < o.length; h++) {
        let c = o[h];
        c < 0 ? h++ : this.heightSamples[Math.floor(c * 10)] = !0;
      }
    }
    return a;
  }
}
class Pb {
  constructor(e, t) {
    this.from = e, this.heights = t, this.index = 0;
  }
  get more() {
    return this.index < this.heights.length;
  }
}
class Kt {
  /**
  @internal
  */
  constructor(e, t, i, s, r) {
    this.from = e, this.length = t, this.top = i, this.height = s, this._content = r;
  }
  /**
  The type of element this is. When querying lines, this may be
  an array of all the blocks that make up the line.
  */
  get type() {
    return typeof this._content == "number" ? ze.Text : Array.isArray(this._content) ? this._content : this._content.type;
  }
  /**
  The end of the element as a document position.
  */
  get to() {
    return this.from + this.length;
  }
  /**
  The bottom position of the element.
  */
  get bottom() {
    return this.top + this.height;
  }
  /**
  If this is a widget block, this will return the widget
  associated with it.
  */
  get widget() {
    return this._content instanceof Ei ? this._content.widget : null;
  }
  /**
  If this is a textblock, this holds the number of line breaks
  that appear in widgets inside the block.
  */
  get widgetLineBreaks() {
    return typeof this._content == "number" ? this._content : 0;
  }
  /**
  @internal
  */
  join(e) {
    let t = (Array.isArray(this._content) ? this._content : [this]).concat(Array.isArray(e._content) ? e._content : [e]);
    return new Kt(this.from, this.length + e.length, this.top, this.height + e.height, t);
  }
}
var ue = /* @__PURE__ */ function(n) {
  return n[n.ByPos = 0] = "ByPos", n[n.ByHeight = 1] = "ByHeight", n[n.ByPosNoHeight = 2] = "ByPosNoHeight", n;
}(ue || (ue = {}));
const Wr = 1e-3;
class qe {
  constructor(e, t, i = 2) {
    this.length = e, this.height = t, this.flags = i;
  }
  get outdated() {
    return (this.flags & 2) > 0;
  }
  set outdated(e) {
    this.flags = (e ? 2 : 0) | this.flags & -3;
  }
  setHeight(e) {
    this.height != e && (Math.abs(this.height - e) > Wr && (Bn = !0), this.height = e);
  }
  // Base case is to replace a leaf node, which simply builds a tree
  // from the new nodes and returns that (HeightMapBranch and
  // HeightMapGap override this to actually use from/to)
  replace(e, t, i) {
    return qe.of(i);
  }
  // Again, these are base cases, and are overridden for branch and gap nodes.
  decomposeLeft(e, t) {
    t.push(this);
  }
  decomposeRight(e, t) {
    t.push(this);
  }
  applyChanges(e, t, i, s) {
    let r = this, o = i.doc;
    for (let l = s.length - 1; l >= 0; l--) {
      let { fromA: a, toA: h, fromB: c, toB: f } = s[l], u = r.lineAt(a, ue.ByPosNoHeight, i.setDoc(t), 0, 0), d = u.to >= h ? u : r.lineAt(h, ue.ByPosNoHeight, i, 0, 0);
      for (f += d.to - h, h = d.to; l > 0 && u.from <= s[l - 1].toA; )
        a = s[l - 1].fromA, c = s[l - 1].fromB, l--, a < u.from && (u = r.lineAt(a, ue.ByPosNoHeight, i, 0, 0));
      c += u.from - a, a = u.from;
      let m = $a.build(i.setDoc(o), e, c, f);
      r = eo(r, r.replace(a, h, m));
    }
    return r.updateHeight(i, 0);
  }
  static empty() {
    return new et(0, 0);
  }
  // nodes uses null values to indicate the position of line breaks.
  // There are never line breaks at the start or end of the array, or
  // two line breaks next to each other, and the array isn't allowed
  // to be empty (same restrictions as return value from the builder).
  static of(e) {
    if (e.length == 1)
      return e[0];
    let t = 0, i = e.length, s = 0, r = 0;
    for (; ; )
      if (t == i)
        if (s > r * 2) {
          let l = e[t - 1];
          l.break ? e.splice(--t, 1, l.left, null, l.right) : e.splice(--t, 1, l.left, l.right), i += 1 + l.break, s -= l.size;
        } else if (r > s * 2) {
          let l = e[i];
          l.break ? e.splice(i, 1, l.left, null, l.right) : e.splice(i, 1, l.left, l.right), i += 2 + l.break, r -= l.size;
        } else
          break;
      else if (s < r) {
        let l = e[t++];
        l && (s += l.size);
      } else {
        let l = e[--i];
        l && (r += l.size);
      }
    let o = 0;
    return e[t - 1] == null ? (o = 1, t--) : e[t] == null && (o = 1, i++), new Bb(qe.of(e.slice(0, t)), o, qe.of(e.slice(i)));
  }
}
function eo(n, e) {
  return n == e ? n : (n.constructor != e.constructor && (Bn = !0), e);
}
qe.prototype.size = 1;
class Lm extends qe {
  constructor(e, t, i) {
    super(e, t), this.deco = i;
  }
  blockAt(e, t, i, s) {
    return new Kt(s, this.length, i, this.height, this.deco || 0);
  }
  lineAt(e, t, i, s, r) {
    return this.blockAt(0, i, s, r);
  }
  forEachLine(e, t, i, s, r, o) {
    e <= r + this.length && t >= r && o(this.blockAt(0, i, s, r));
  }
  updateHeight(e, t = 0, i = !1, s) {
    return s && s.from <= t && s.more && this.setHeight(s.heights[s.index++]), this.outdated = !1, this;
  }
  toString() {
    return `block(${this.length})`;
  }
}
class et extends Lm {
  constructor(e, t) {
    super(e, t, null), this.collapsed = 0, this.widgetHeight = 0, this.breaks = 0;
  }
  blockAt(e, t, i, s) {
    return new Kt(s, this.length, i, this.height, this.breaks);
  }
  replace(e, t, i) {
    let s = i[0];
    return i.length == 1 && (s instanceof et || s instanceof Te && s.flags & 4) && Math.abs(this.length - s.length) < 10 ? (s instanceof Te ? s = new et(s.length, this.height) : s.height = this.height, this.outdated || (s.outdated = !1), s) : qe.of(i);
  }
  updateHeight(e, t = 0, i = !1, s) {
    return s && s.from <= t && s.more ? this.setHeight(s.heights[s.index++]) : (i || this.outdated) && this.setHeight(Math.max(this.widgetHeight, e.heightForLine(this.length - this.collapsed)) + this.breaks * e.lineHeight), this.outdated = !1, this;
  }
  toString() {
    return `line(${this.length}${this.collapsed ? -this.collapsed : ""}${this.widgetHeight ? ":" + this.widgetHeight : ""})`;
  }
}
class Te extends qe {
  constructor(e) {
    super(e, 0);
  }
  heightMetrics(e, t) {
    let i = e.doc.lineAt(t).number, s = e.doc.lineAt(t + this.length).number, r = s - i + 1, o, l = 0;
    if (e.lineWrapping) {
      let a = Math.min(this.height, e.lineHeight * r);
      o = a / r, this.length > r + 1 && (l = (this.height - a) / (this.length - r - 1));
    } else
      o = this.height / r;
    return { firstLine: i, lastLine: s, perLine: o, perChar: l };
  }
  blockAt(e, t, i, s) {
    let { firstLine: r, lastLine: o, perLine: l, perChar: a } = this.heightMetrics(t, s);
    if (t.lineWrapping) {
      let h = s + (e < t.lineHeight ? 0 : Math.round(Math.max(0, Math.min(1, (e - i) / this.height)) * this.length)), c = t.doc.lineAt(h), f = l + c.length * a, u = Math.max(i, e - f / 2);
      return new Kt(c.from, c.length, u, f, 0);
    } else {
      let h = Math.max(0, Math.min(o - r, Math.floor((e - i) / l))), { from: c, length: f } = t.doc.line(r + h);
      return new Kt(c, f, i + l * h, l, 0);
    }
  }
  lineAt(e, t, i, s, r) {
    if (t == ue.ByHeight)
      return this.blockAt(e, i, s, r);
    if (t == ue.ByPosNoHeight) {
      let { from: d, to: m } = i.doc.lineAt(e);
      return new Kt(d, m - d, 0, 0, 0);
    }
    let { firstLine: o, perLine: l, perChar: a } = this.heightMetrics(i, r), h = i.doc.lineAt(e), c = l + h.length * a, f = h.number - o, u = s + l * f + a * (h.from - r - f);
    return new Kt(h.from, h.length, Math.max(s, Math.min(u, s + this.height - c)), c, 0);
  }
  forEachLine(e, t, i, s, r, o) {
    e = Math.max(e, r), t = Math.min(t, r + this.length);
    let { firstLine: l, perLine: a, perChar: h } = this.heightMetrics(i, r);
    for (let c = e, f = s; c <= t; ) {
      let u = i.doc.lineAt(c);
      if (c == e) {
        let m = u.number - l;
        f += a * m + h * (e - r - m);
      }
      let d = a + h * u.length;
      o(new Kt(u.from, u.length, f, d, 0)), f += d, c = u.to + 1;
    }
  }
  replace(e, t, i) {
    let s = this.length - t;
    if (s > 0) {
      let r = i[i.length - 1];
      r instanceof Te ? i[i.length - 1] = new Te(r.length + s) : i.push(null, new Te(s - 1));
    }
    if (e > 0) {
      let r = i[0];
      r instanceof Te ? i[0] = new Te(e + r.length) : i.unshift(new Te(e - 1), null);
    }
    return qe.of(i);
  }
  decomposeLeft(e, t) {
    t.push(new Te(e - 1), null);
  }
  decomposeRight(e, t) {
    t.push(null, new Te(this.length - e - 1));
  }
  updateHeight(e, t = 0, i = !1, s) {
    let r = t + this.length;
    if (s && s.from <= t + this.length && s.more) {
      let o = [], l = Math.max(t, s.from), a = -1;
      for (s.from > t && o.push(new Te(s.from - t - 1).updateHeight(e, t)); l <= r && s.more; ) {
        let c = e.doc.lineAt(l).length;
        o.length && o.push(null);
        let f = s.heights[s.index++];
        a == -1 ? a = f : Math.abs(f - a) >= Wr && (a = -2);
        let u = new et(c, f);
        u.outdated = !1, o.push(u), l += c + 1;
      }
      l <= r && o.push(null, new Te(r - l).updateHeight(e, l));
      let h = qe.of(o);
      return (a < 0 || Math.abs(h.height - this.height) >= Wr || Math.abs(a - this.heightMetrics(e, t).perLine) >= Wr) && (Bn = !0), eo(this, h);
    } else (i || this.outdated) && (this.setHeight(e.heightForGap(t, t + this.length)), this.outdated = !1);
    return this;
  }
  toString() {
    return `gap(${this.length})`;
  }
}
class Bb extends qe {
  constructor(e, t, i) {
    super(e.length + t + i.length, e.height + i.height, t | (e.outdated || i.outdated ? 2 : 0)), this.left = e, this.right = i, this.size = e.size + i.size;
  }
  get break() {
    return this.flags & 1;
  }
  blockAt(e, t, i, s) {
    let r = i + this.left.height;
    return e < r ? this.left.blockAt(e, t, i, s) : this.right.blockAt(e, t, r, s + this.left.length + this.break);
  }
  lineAt(e, t, i, s, r) {
    let o = s + this.left.height, l = r + this.left.length + this.break, a = t == ue.ByHeight ? e < o : e < l, h = a ? this.left.lineAt(e, t, i, s, r) : this.right.lineAt(e, t, i, o, l);
    if (this.break || (a ? h.to < l : h.from > l))
      return h;
    let c = t == ue.ByPosNoHeight ? ue.ByPosNoHeight : ue.ByPos;
    return a ? h.join(this.right.lineAt(l, c, i, o, l)) : this.left.lineAt(l, c, i, s, r).join(h);
  }
  forEachLine(e, t, i, s, r, o) {
    let l = s + this.left.height, a = r + this.left.length + this.break;
    if (this.break)
      e < a && this.left.forEachLine(e, t, i, s, r, o), t >= a && this.right.forEachLine(e, t, i, l, a, o);
    else {
      let h = this.lineAt(a, ue.ByPos, i, s, r);
      e < h.from && this.left.forEachLine(e, h.from - 1, i, s, r, o), h.to >= e && h.from <= t && o(h), t > h.to && this.right.forEachLine(h.to + 1, t, i, l, a, o);
    }
  }
  replace(e, t, i) {
    let s = this.left.length + this.break;
    if (t < s)
      return this.balanced(this.left.replace(e, t, i), this.right);
    if (e > this.left.length)
      return this.balanced(this.left, this.right.replace(e - s, t - s, i));
    let r = [];
    e > 0 && this.decomposeLeft(e, r);
    let o = r.length;
    for (let l of i)
      r.push(l);
    if (e > 0 && qc(r, o - 1), t < this.length) {
      let l = r.length;
      this.decomposeRight(t, r), qc(r, l);
    }
    return qe.of(r);
  }
  decomposeLeft(e, t) {
    let i = this.left.length;
    if (e <= i)
      return this.left.decomposeLeft(e, t);
    t.push(this.left), this.break && (i++, e >= i && t.push(null)), e > i && this.right.decomposeLeft(e - i, t);
  }
  decomposeRight(e, t) {
    let i = this.left.length, s = i + this.break;
    if (e >= s)
      return this.right.decomposeRight(e - s, t);
    e < i && this.left.decomposeRight(e, t), this.break && e < s && t.push(null), t.push(this.right);
  }
  balanced(e, t) {
    return e.size > 2 * t.size || t.size > 2 * e.size ? qe.of(this.break ? [e, null, t] : [e, t]) : (this.left = eo(this.left, e), this.right = eo(this.right, t), this.setHeight(e.height + t.height), this.outdated = e.outdated || t.outdated, this.size = e.size + t.size, this.length = e.length + this.break + t.length, this);
  }
  updateHeight(e, t = 0, i = !1, s) {
    let { left: r, right: o } = this, l = t + r.length + this.break, a = null;
    return s && s.from <= t + r.length && s.more ? a = r = r.updateHeight(e, t, i, s) : r.updateHeight(e, t, i), s && s.from <= l + o.length && s.more ? a = o = o.updateHeight(e, l, i, s) : o.updateHeight(e, l, i), a ? this.balanced(r, o) : (this.height = this.left.height + this.right.height, this.outdated = !1, this);
  }
  toString() {
    return this.left + (this.break ? " " : "-") + this.right;
  }
}
function qc(n, e) {
  let t, i;
  n[e] == null && (t = n[e - 1]) instanceof Te && (i = n[e + 1]) instanceof Te && n.splice(e - 1, 3, new Te(t.length + 1 + i.length));
}
const Ib = 5;
class $a {
  constructor(e, t) {
    this.pos = e, this.oracle = t, this.nodes = [], this.lineStart = -1, this.lineEnd = -1, this.covering = null, this.writtenTo = e;
  }
  get isCovered() {
    return this.covering && this.nodes[this.nodes.length - 1] == this.covering;
  }
  span(e, t) {
    if (this.lineStart > -1) {
      let i = Math.min(t, this.lineEnd), s = this.nodes[this.nodes.length - 1];
      s instanceof et ? s.length += i - this.pos : (i > this.pos || !this.isCovered) && this.nodes.push(new et(i - this.pos, -1)), this.writtenTo = i, t > i && (this.nodes.push(null), this.writtenTo++, this.lineStart = -1);
    }
    this.pos = t;
  }
  point(e, t, i) {
    if (e < t || i.heightRelevant) {
      let s = i.widget ? i.widget.estimatedHeight : 0, r = i.widget ? i.widget.lineBreaks : 0;
      s < 0 && (s = this.oracle.lineHeight);
      let o = t - e;
      i.block ? this.addBlock(new Lm(o, s, i)) : (o || r || s >= Ib) && this.addLineDeco(s, r, o);
    } else t > e && this.span(e, t);
    this.lineEnd > -1 && this.lineEnd < this.pos && (this.lineEnd = this.oracle.doc.lineAt(this.pos).to);
  }
  enterLine() {
    if (this.lineStart > -1)
      return;
    let { from: e, to: t } = this.oracle.doc.lineAt(this.pos);
    this.lineStart = e, this.lineEnd = t, this.writtenTo < e && ((this.writtenTo < e - 1 || this.nodes[this.nodes.length - 1] == null) && this.nodes.push(this.blankContent(this.writtenTo, e - 1)), this.nodes.push(null)), this.pos > e && this.nodes.push(new et(this.pos - e, -1)), this.writtenTo = this.pos;
  }
  blankContent(e, t) {
    let i = new Te(t - e);
    return this.oracle.doc.lineAt(e).to == t && (i.flags |= 4), i;
  }
  ensureLine() {
    this.enterLine();
    let e = this.nodes.length ? this.nodes[this.nodes.length - 1] : null;
    if (e instanceof et)
      return e;
    let t = new et(0, -1);
    return this.nodes.push(t), t;
  }
  addBlock(e) {
    this.enterLine();
    let t = e.deco;
    t && t.startSide > 0 && !this.isCovered && this.ensureLine(), this.nodes.push(e), this.writtenTo = this.pos = this.pos + e.length, t && t.endSide > 0 && (this.covering = e);
  }
  addLineDeco(e, t, i) {
    let s = this.ensureLine();
    s.length += i, s.collapsed += i, s.widgetHeight = Math.max(s.widgetHeight, e), s.breaks += t, this.writtenTo = this.pos = this.pos + i;
  }
  finish(e) {
    let t = this.nodes.length == 0 ? null : this.nodes[this.nodes.length - 1];
    this.lineStart > -1 && !(t instanceof et) && !this.isCovered ? this.nodes.push(new et(0, -1)) : (this.writtenTo < this.pos || t == null) && this.nodes.push(this.blankContent(this.writtenTo, this.pos));
    let i = e;
    for (let s of this.nodes)
      s instanceof et && s.updateHeight(this.oracle, i), i += s ? s.length : 1;
    return this.nodes;
  }
  // Always called with a region that on both sides either stretches
  // to a line break or the end of the document.
  // The returned array uses null to indicate line breaks, but never
  // starts or ends in a line break, or has multiple line breaks next
  // to each other.
  static build(e, t, i, s) {
    let r = new $a(i, e);
    return ne.spans(t, i, s, r, 0), r.finish(i);
  }
}
function Nb(n, e, t) {
  let i = new Fb();
  return ne.compare(n, e, t, i, 0), i.changes;
}
class Fb {
  constructor() {
    this.changes = [];
  }
  compareRange() {
  }
  comparePoint(e, t, i, s) {
    (e < t || i && i.heightRelevant || s && s.heightRelevant) && ra(e, t, this.changes, 5);
  }
}
function Hb(n, e) {
  let t = n.getBoundingClientRect(), i = n.ownerDocument, s = i.defaultView || window, r = Math.max(0, t.left), o = Math.min(s.innerWidth, t.right), l = Math.max(0, t.top), a = Math.min(s.innerHeight, t.bottom);
  for (let h = n.parentNode; h && h != i.body; )
    if (h.nodeType == 1) {
      let c = h, f = window.getComputedStyle(c);
      if ((c.scrollHeight > c.clientHeight || c.scrollWidth > c.clientWidth) && f.overflow != "visible") {
        let u = c.getBoundingClientRect();
        r = Math.max(r, u.left), o = Math.min(o, u.right), l = Math.max(l, u.top), a = h == n.parentNode ? u.bottom : Math.min(a, u.bottom);
      }
      h = f.position == "absolute" || f.position == "fixed" ? c.offsetParent : c.parentNode;
    } else if (h.nodeType == 11)
      h = h.host;
    else
      break;
  return {
    left: r - t.left,
    right: Math.max(r, o) - t.left,
    top: l - (t.top + e),
    bottom: Math.max(l, a) - (t.top + e)
  };
}
function Vb(n, e) {
  let t = n.getBoundingClientRect();
  return {
    left: 0,
    right: t.right - t.left,
    top: e,
    bottom: t.bottom - (t.top + e)
  };
}
class Qo {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.size = i;
  }
  static same(e, t) {
    if (e.length != t.length)
      return !1;
    for (let i = 0; i < e.length; i++) {
      let s = e[i], r = t[i];
      if (s.from != r.from || s.to != r.to || s.size != r.size)
        return !1;
    }
    return !0;
  }
  draw(e, t) {
    return N.replace({
      widget: new Wb(this.size * (t ? e.scaleY : e.scaleX), t)
    }).range(this.from, this.to);
  }
}
class Wb extends Lt {
  constructor(e, t) {
    super(), this.size = e, this.vertical = t;
  }
  eq(e) {
    return e.size == this.size && e.vertical == this.vertical;
  }
  toDOM() {
    let e = document.createElement("div");
    return this.vertical ? e.style.height = this.size + "px" : (e.style.width = this.size + "px", e.style.height = "2px", e.style.display = "inline-block"), e;
  }
  get estimatedHeight() {
    return this.vertical ? this.size : -1;
  }
}
class Uc {
  constructor(e) {
    this.state = e, this.pixelViewport = { left: 0, right: window.innerWidth, top: 0, bottom: 0 }, this.inView = !0, this.paddingTop = 0, this.paddingBottom = 0, this.contentDOMWidth = 0, this.contentDOMHeight = 0, this.editorHeight = 0, this.editorWidth = 0, this.scrollTop = 0, this.scrolledToBottom = !1, this.scaleX = 1, this.scaleY = 1, this.scrollAnchorPos = 0, this.scrollAnchorHeight = -1, this.scaler = jc, this.scrollTarget = null, this.printing = !1, this.mustMeasureContent = !0, this.defaultTextDirection = de.LTR, this.visibleRanges = [], this.mustEnforceCursorAssoc = !1;
    let t = e.facet(Ja).some((i) => typeof i != "function" && i.class == "cm-lineWrapping");
    this.heightOracle = new Rb(t), this.stateDeco = e.facet(Es).filter((i) => typeof i != "function"), this.heightMap = qe.empty().applyChanges(this.stateDeco, ie.empty, this.heightOracle.setDoc(e.doc), [new mt(0, 0, 0, e.doc.length)]);
    for (let i = 0; i < 2 && (this.viewport = this.getViewport(0, null), !!this.updateForViewport()); i++)
      ;
    this.updateViewportLines(), this.lineGaps = this.ensureLineGaps([]), this.lineGapDeco = N.set(this.lineGaps.map((i) => i.draw(this, !1))), this.computeVisibleRanges();
  }
  updateForViewport() {
    let e = [this.viewport], { main: t } = this.state.selection;
    for (let i = 0; i <= 1; i++) {
      let s = i ? t.head : t.anchor;
      if (!e.some(({ from: r, to: o }) => s >= r && s <= o)) {
        let { from: r, to: o } = this.lineBlockAt(s);
        e.push(new fr(r, o));
      }
    }
    return this.viewports = e.sort((i, s) => i.from - s.from), this.updateScaler();
  }
  updateScaler() {
    let e = this.scaler;
    return this.scaler = this.heightMap.height <= 7e6 ? jc : new eh(this.heightOracle, this.heightMap, this.viewports), e.eq(this.scaler) ? 0 : 2;
  }
  updateViewportLines() {
    this.viewportLines = [], this.heightMap.forEachLine(this.viewport.from, this.viewport.to, this.heightOracle.setDoc(this.state.doc), 0, 0, (e) => {
      this.viewportLines.push(ms(e, this.scaler));
    });
  }
  update(e, t = null) {
    this.state = e.state;
    let i = this.stateDeco;
    this.stateDeco = this.state.facet(Es).filter((c) => typeof c != "function");
    let s = e.changedRanges, r = mt.extendWithRanges(s, Nb(i, this.stateDeco, e ? e.changes : Se.empty(this.state.doc.length))), o = this.heightMap.height, l = this.scrolledToBottom ? null : this.scrollAnchorAt(this.scrollTop);
    zc(), this.heightMap = this.heightMap.applyChanges(this.stateDeco, e.startState.doc, this.heightOracle.setDoc(this.state.doc), r), (this.heightMap.height != o || Bn) && (e.flags |= 2), l ? (this.scrollAnchorPos = e.changes.mapPos(l.from, -1), this.scrollAnchorHeight = l.top) : (this.scrollAnchorPos = -1, this.scrollAnchorHeight = this.heightMap.height);
    let a = r.length ? this.mapViewport(this.viewport, e.changes) : this.viewport;
    (t && (t.range.head < a.from || t.range.head > a.to) || !this.viewportIsAppropriate(a)) && (a = this.getViewport(0, t));
    let h = a.from != this.viewport.from || a.to != this.viewport.to;
    this.viewport = a, e.flags |= this.updateForViewport(), (h || !e.changes.empty || e.flags & 2) && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(this.mapLineGaps(this.lineGaps, e.changes))), e.flags |= this.computeVisibleRanges(), t && (this.scrollTarget = t), !this.mustEnforceCursorAssoc && e.selectionSet && e.view.lineWrapping && e.state.selection.main.empty && e.state.selection.main.assoc && !e.state.facet(dm) && (this.mustEnforceCursorAssoc = !0);
  }
  measure(e) {
    let t = e.contentDOM, i = window.getComputedStyle(t), s = this.heightOracle, r = i.whiteSpace;
    this.defaultTextDirection = i.direction == "rtl" ? de.RTL : de.LTR;
    let o = this.heightOracle.mustRefreshForWrapping(r), l = t.getBoundingClientRect(), a = o || this.mustMeasureContent || this.contentDOMHeight != l.height;
    this.contentDOMHeight = l.height, this.mustMeasureContent = !1;
    let h = 0, c = 0;
    if (l.width && l.height) {
      let { scaleX: x, scaleY: _ } = Vd(t, l);
      (x > 5e-3 && Math.abs(this.scaleX - x) > 5e-3 || _ > 5e-3 && Math.abs(this.scaleY - _) > 5e-3) && (this.scaleX = x, this.scaleY = _, h |= 8, o = a = !0);
    }
    let f = (parseInt(i.paddingTop) || 0) * this.scaleY, u = (parseInt(i.paddingBottom) || 0) * this.scaleY;
    (this.paddingTop != f || this.paddingBottom != u) && (this.paddingTop = f, this.paddingBottom = u, h |= 10), this.editorWidth != e.scrollDOM.clientWidth && (s.lineWrapping && (a = !0), this.editorWidth = e.scrollDOM.clientWidth, h |= 8);
    let d = e.scrollDOM.scrollTop * this.scaleY;
    this.scrollTop != d && (this.scrollAnchorHeight = -1, this.scrollTop = d), this.scrolledToBottom = qd(e.scrollDOM);
    let m = (this.printing ? Vb : Hb)(t, this.paddingTop), p = m.top - this.pixelViewport.top, g = m.bottom - this.pixelViewport.bottom;
    this.pixelViewport = m;
    let b = this.pixelViewport.bottom > this.pixelViewport.top && this.pixelViewport.right > this.pixelViewport.left;
    if (b != this.inView && (this.inView = b, b && (a = !0)), !this.inView && !this.scrollTarget)
      return 0;
    let w = l.width;
    if ((this.contentDOMWidth != w || this.editorHeight != e.scrollDOM.clientHeight) && (this.contentDOMWidth = l.width, this.editorHeight = e.scrollDOM.clientHeight, h |= 8), a) {
      let x = e.docView.measureVisibleLineHeights(this.viewport);
      if (s.mustRefreshForHeights(x) && (o = !0), o || s.lineWrapping && Math.abs(w - this.contentDOMWidth) > s.charWidth) {
        let { lineHeight: _, charWidth: S, textHeight: A } = e.docView.measureTextSize();
        o = _ > 0 && s.refresh(r, _, S, A, w / S, x), o && (e.docView.minWidth = 0, h |= 8);
      }
      p > 0 && g > 0 ? c = Math.max(p, g) : p < 0 && g < 0 && (c = Math.min(p, g)), zc();
      for (let _ of this.viewports) {
        let S = _.from == this.viewport.from ? x : e.docView.measureVisibleLineHeights(_);
        this.heightMap = (o ? qe.empty().applyChanges(this.stateDeco, ie.empty, this.heightOracle, [new mt(0, 0, 0, e.state.doc.length)]) : this.heightMap).updateHeight(s, 0, o, new Pb(_.from, S));
      }
      Bn && (h |= 2);
    }
    let k = !this.viewportIsAppropriate(this.viewport, c) || this.scrollTarget && (this.scrollTarget.range.head < this.viewport.from || this.scrollTarget.range.head > this.viewport.to);
    return k && (h & 2 && (h |= this.updateScaler()), this.viewport = this.getViewport(c, this.scrollTarget), h |= this.updateForViewport()), (h & 2 || k) && this.updateViewportLines(), (this.lineGaps.length || this.viewport.to - this.viewport.from > 4e3) && this.updateLineGaps(this.ensureLineGaps(o ? [] : this.lineGaps, e)), h |= this.computeVisibleRanges(), this.mustEnforceCursorAssoc && (this.mustEnforceCursorAssoc = !1, e.docView.enforceCursorAssoc()), h;
  }
  get visibleTop() {
    return this.scaler.fromDOM(this.pixelViewport.top);
  }
  get visibleBottom() {
    return this.scaler.fromDOM(this.pixelViewport.bottom);
  }
  getViewport(e, t) {
    let i = 0.5 - Math.max(-0.5, Math.min(0.5, e / 1e3 / 2)), s = this.heightMap, r = this.heightOracle, { visibleTop: o, visibleBottom: l } = this, a = new fr(s.lineAt(o - i * 1e3, ue.ByHeight, r, 0, 0).from, s.lineAt(l + (1 - i) * 1e3, ue.ByHeight, r, 0, 0).to);
    if (t) {
      let { head: h } = t.range;
      if (h < a.from || h > a.to) {
        let c = Math.min(this.editorHeight, this.pixelViewport.bottom - this.pixelViewport.top), f = s.lineAt(h, ue.ByPos, r, 0, 0), u;
        t.y == "center" ? u = (f.top + f.bottom) / 2 - c / 2 : t.y == "start" || t.y == "nearest" && h < a.from ? u = f.top : u = f.bottom - c, a = new fr(s.lineAt(u - 1e3 / 2, ue.ByHeight, r, 0, 0).from, s.lineAt(u + c + 1e3 / 2, ue.ByHeight, r, 0, 0).to);
      }
    }
    return a;
  }
  mapViewport(e, t) {
    let i = t.mapPos(e.from, -1), s = t.mapPos(e.to, 1);
    return new fr(this.heightMap.lineAt(i, ue.ByPos, this.heightOracle, 0, 0).from, this.heightMap.lineAt(s, ue.ByPos, this.heightOracle, 0, 0).to);
  }
  // Checks if a given viewport covers the visible part of the
  // document and not too much beyond that.
  viewportIsAppropriate({ from: e, to: t }, i = 0) {
    if (!this.inView)
      return !0;
    let { top: s } = this.heightMap.lineAt(e, ue.ByPos, this.heightOracle, 0, 0), { bottom: r } = this.heightMap.lineAt(t, ue.ByPos, this.heightOracle, 0, 0), { visibleTop: o, visibleBottom: l } = this;
    return (e == 0 || s <= o - Math.max(10, Math.min(
      -i,
      250
      /* VP.MaxCoverMargin */
    ))) && (t == this.state.doc.length || r >= l + Math.max(10, Math.min(
      i,
      250
      /* VP.MaxCoverMargin */
    ))) && s > o - 2 * 1e3 && r < l + 2 * 1e3;
  }
  mapLineGaps(e, t) {
    if (!e.length || t.empty)
      return e;
    let i = [];
    for (let s of e)
      t.touchesRange(s.from, s.to) || i.push(new Qo(t.mapPos(s.from), t.mapPos(s.to), s.size));
    return i;
  }
  // Computes positions in the viewport where the start or end of a
  // line should be hidden, trying to reuse existing line gaps when
  // appropriate to avoid unneccesary redraws.
  // Uses crude character-counting for the positioning and sizing,
  // since actual DOM coordinates aren't always available and
  // predictable. Relies on generous margins (see LG.Margin) to hide
  // the artifacts this might produce from the user.
  ensureLineGaps(e, t) {
    let i = this.heightOracle.lineWrapping, s = i ? 1e4 : 2e3, r = s >> 1, o = s << 1;
    if (this.defaultTextDirection != de.LTR && !i)
      return [];
    let l = [], a = (c, f, u, d) => {
      if (f - c < r)
        return;
      let m = this.state.selection.main, p = [m.from];
      m.empty || p.push(m.to);
      for (let b of p)
        if (b > c && b < f) {
          a(c, b - 10, u, d), a(b + 10, f, u, d);
          return;
        }
      let g = qb(e, (b) => b.from >= u.from && b.to <= u.to && Math.abs(b.from - c) < r && Math.abs(b.to - f) < r && !p.some((w) => b.from < w && b.to > w));
      if (!g) {
        if (f < u.to && t && i && t.visibleRanges.some((b) => b.from <= f && b.to >= f)) {
          let b = t.moveToLineBoundary(C.cursor(f), !1, !0).head;
          b > c && (f = b);
        }
        g = new Qo(c, f, this.gapSize(u, c, f, d));
      }
      l.push(g);
    }, h = (c) => {
      if (c.length < o || c.type != ze.Text)
        return;
      let f = zb(c.from, c.to, this.stateDeco);
      if (f.total < o)
        return;
      let u = this.scrollTarget ? this.scrollTarget.range.head : null, d, m;
      if (i) {
        let p = s / this.heightOracle.lineLength * this.heightOracle.lineHeight, g, b;
        if (u != null) {
          let w = dr(f, u), k = ((this.visibleBottom - this.visibleTop) / 2 + p) / c.height;
          g = w - k, b = w + k;
        } else
          g = (this.visibleTop - c.top - p) / c.height, b = (this.visibleBottom - c.top + p) / c.height;
        d = ur(f, g), m = ur(f, b);
      } else {
        let p = f.total * this.heightOracle.charWidth, g = s * this.heightOracle.charWidth, b, w;
        if (u != null) {
          let k = dr(f, u), x = ((this.pixelViewport.right - this.pixelViewport.left) / 2 + g) / p;
          b = k - x, w = k + x;
        } else
          b = (this.pixelViewport.left - g) / p, w = (this.pixelViewport.right + g) / p;
        d = ur(f, b), m = ur(f, w);
      }
      d > c.from && a(c.from, d, c, f), m < c.to && a(m, c.to, c, f);
    };
    for (let c of this.viewportLines)
      Array.isArray(c.type) ? c.type.forEach(h) : h(c);
    return l;
  }
  gapSize(e, t, i, s) {
    let r = dr(s, i) - dr(s, t);
    return this.heightOracle.lineWrapping ? e.height * r : s.total * this.heightOracle.charWidth * r;
  }
  updateLineGaps(e) {
    Qo.same(e, this.lineGaps) || (this.lineGaps = e, this.lineGapDeco = N.set(e.map((t) => t.draw(this, this.heightOracle.lineWrapping))));
  }
  computeVisibleRanges() {
    let e = this.stateDeco;
    this.lineGaps.length && (e = e.concat(this.lineGapDeco));
    let t = [];
    ne.spans(e, this.viewport.from, this.viewport.to, {
      span(s, r) {
        t.push({ from: s, to: r });
      },
      point() {
      }
    }, 20);
    let i = t.length != this.visibleRanges.length || this.visibleRanges.some((s, r) => s.from != t[r].from || s.to != t[r].to);
    return this.visibleRanges = t, i ? 4 : 0;
  }
  lineBlockAt(e) {
    return e >= this.viewport.from && e <= this.viewport.to && this.viewportLines.find((t) => t.from <= e && t.to >= e) || ms(this.heightMap.lineAt(e, ue.ByPos, this.heightOracle, 0, 0), this.scaler);
  }
  lineBlockAtHeight(e) {
    return e >= this.viewportLines[0].top && e <= this.viewportLines[this.viewportLines.length - 1].bottom && this.viewportLines.find((t) => t.top <= e && t.bottom >= e) || ms(this.heightMap.lineAt(this.scaler.fromDOM(e), ue.ByHeight, this.heightOracle, 0, 0), this.scaler);
  }
  scrollAnchorAt(e) {
    let t = this.lineBlockAtHeight(e + 8);
    return t.from >= this.viewport.from || this.viewportLines[0].top - e > 200 ? t : this.viewportLines[0];
  }
  elementAtHeight(e) {
    return ms(this.heightMap.blockAt(this.scaler.fromDOM(e), this.heightOracle, 0, 0), this.scaler);
  }
  get docHeight() {
    return this.scaler.toDOM(this.heightMap.height);
  }
  get contentHeight() {
    return this.docHeight + this.paddingTop + this.paddingBottom;
  }
}
class fr {
  constructor(e, t) {
    this.from = e, this.to = t;
  }
}
function zb(n, e, t) {
  let i = [], s = n, r = 0;
  return ne.spans(t, n, e, {
    span() {
    },
    point(o, l) {
      o > s && (i.push({ from: s, to: o }), r += o - s), s = l;
    }
  }, 20), s < e && (i.push({ from: s, to: e }), r += e - s), { total: r, ranges: i };
}
function ur({ total: n, ranges: e }, t) {
  if (t <= 0)
    return e[0].from;
  if (t >= 1)
    return e[e.length - 1].to;
  let i = Math.floor(n * t);
  for (let s = 0; ; s++) {
    let { from: r, to: o } = e[s], l = o - r;
    if (i <= l)
      return r + i;
    i -= l;
  }
}
function dr(n, e) {
  let t = 0;
  for (let { from: i, to: s } of n.ranges) {
    if (e <= s) {
      t += e - i;
      break;
    }
    t += s - i;
  }
  return t / n.total;
}
function qb(n, e) {
  for (let t of n)
    if (e(t))
      return t;
}
const jc = {
  toDOM(n) {
    return n;
  },
  fromDOM(n) {
    return n;
  },
  scale: 1,
  eq(n) {
    return n == this;
  }
};
class eh {
  constructor(e, t, i) {
    let s = 0, r = 0, o = 0;
    this.viewports = i.map(({ from: l, to: a }) => {
      let h = t.lineAt(l, ue.ByPos, e, 0, 0).top, c = t.lineAt(a, ue.ByPos, e, 0, 0).bottom;
      return s += c - h, { from: l, to: a, top: h, bottom: c, domTop: 0, domBottom: 0 };
    }), this.scale = (7e6 - s) / (t.height - s);
    for (let l of this.viewports)
      l.domTop = o + (l.top - r) * this.scale, o = l.domBottom = l.domTop + (l.bottom - l.top), r = l.bottom;
  }
  toDOM(e) {
    for (let t = 0, i = 0, s = 0; ; t++) {
      let r = t < this.viewports.length ? this.viewports[t] : null;
      if (!r || e < r.top)
        return s + (e - i) * this.scale;
      if (e <= r.bottom)
        return r.domTop + (e - r.top);
      i = r.bottom, s = r.domBottom;
    }
  }
  fromDOM(e) {
    for (let t = 0, i = 0, s = 0; ; t++) {
      let r = t < this.viewports.length ? this.viewports[t] : null;
      if (!r || e < r.domTop)
        return i + (e - s) / this.scale;
      if (e <= r.domBottom)
        return r.top + (e - r.domTop);
      i = r.bottom, s = r.domBottom;
    }
  }
  eq(e) {
    return e instanceof eh ? this.scale == e.scale && this.viewports.length == e.viewports.length && this.viewports.every((t, i) => t.from == e.viewports[i].from && t.to == e.viewports[i].to) : !1;
  }
}
function ms(n, e) {
  if (e.scale == 1)
    return n;
  let t = e.toDOM(n.top), i = e.toDOM(n.bottom);
  return new Kt(n.from, n.length, t, i - t, Array.isArray(n._content) ? n._content.map((s) => ms(s, e)) : n._content);
}
const mr = /* @__PURE__ */ I.define({ combine: (n) => n.join(" ") }), da = /* @__PURE__ */ I.define({ combine: (n) => n.indexOf(!0) > -1 }), ma = /* @__PURE__ */ Di.newName(), Rm = /* @__PURE__ */ Di.newName(), Pm = /* @__PURE__ */ Di.newName(), Bm = { "&light": "." + Rm, "&dark": "." + Pm };
function pa(n, e, t) {
  return new Di(e, {
    finish(i) {
      return /&/.test(i) ? i.replace(/&\w*/, (s) => {
        if (s == "&")
          return n;
        if (!t || !t[s])
          throw new RangeError(`Unsupported selector: ${s}`);
        return t[s];
      }) : n + " " + i;
    }
  });
}
const Ub = /* @__PURE__ */ pa("." + ma, {
  "&": {
    position: "relative !important",
    boxSizing: "border-box",
    "&.cm-focused": {
      // Provide a simple default outline to make sure a focused
      // editor is visually distinct. Can't leave the default behavior
      // because that will apply to the content element, which is
      // inside the scrollable container and doesn't include the
      // gutters. We also can't use an 'auto' outline, since those
      // are, for some reason, drawn behind the element content, which
      // will cause things like the active line background to cover
      // the outline (#297).
      outline: "1px dotted #212121"
    },
    display: "flex !important",
    flexDirection: "column"
  },
  ".cm-scroller": {
    display: "flex !important",
    alignItems: "flex-start !important",
    fontFamily: "monospace",
    lineHeight: 1.4,
    height: "100%",
    overflowX: "auto",
    position: "relative",
    zIndex: 0
  },
  ".cm-content": {
    margin: 0,
    flexGrow: 2,
    flexShrink: 0,
    display: "block",
    whiteSpace: "pre",
    wordWrap: "normal",
    // https://github.com/codemirror/dev/issues/456
    boxSizing: "border-box",
    minHeight: "100%",
    padding: "4px 0",
    outline: "none",
    "&[contenteditable=true]": {
      WebkitUserModify: "read-write-plaintext-only"
    }
  },
  ".cm-lineWrapping": {
    whiteSpace_fallback: "pre-wrap",
    // For IE
    whiteSpace: "break-spaces",
    wordBreak: "break-word",
    // For Safari, which doesn't support overflow-wrap: anywhere
    overflowWrap: "anywhere",
    flexShrink: 1
  },
  "&light .cm-content": { caretColor: "black" },
  "&dark .cm-content": { caretColor: "white" },
  ".cm-line": {
    display: "block",
    padding: "0 2px 0 6px"
  },
  ".cm-layer": {
    position: "absolute",
    left: 0,
    top: 0,
    contain: "size style",
    "& > *": {
      position: "absolute"
    }
  },
  "&light .cm-selectionBackground": {
    background: "#d9d9d9"
  },
  "&dark .cm-selectionBackground": {
    background: "#222"
  },
  "&light.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground": {
    background: "#d7d4f0"
  },
  "&dark.cm-focused > .cm-scroller > .cm-selectionLayer .cm-selectionBackground": {
    background: "#233"
  },
  ".cm-cursorLayer": {
    pointerEvents: "none"
  },
  "&.cm-focused > .cm-scroller > .cm-cursorLayer": {
    animation: "steps(1) cm-blink 1.2s infinite"
  },
  // Two animations defined so that we can switch between them to
  // restart the animation without forcing another style
  // recomputation.
  "@keyframes cm-blink": { "0%": {}, "50%": { opacity: 0 }, "100%": {} },
  "@keyframes cm-blink2": { "0%": {}, "50%": { opacity: 0 }, "100%": {} },
  ".cm-cursor, .cm-dropCursor": {
    borderLeft: "1.2px solid black",
    marginLeft: "-0.6px",
    pointerEvents: "none"
  },
  ".cm-cursor": {
    display: "none"
  },
  "&dark .cm-cursor": {
    borderLeftColor: "#444"
  },
  ".cm-dropCursor": {
    position: "absolute"
  },
  "&.cm-focused > .cm-scroller > .cm-cursorLayer .cm-cursor": {
    display: "block"
  },
  ".cm-iso": {
    unicodeBidi: "isolate"
  },
  ".cm-announced": {
    position: "fixed",
    top: "-10000px"
  },
  "@media print": {
    ".cm-announced": { display: "none" }
  },
  "&light .cm-activeLine": { backgroundColor: "#cceeff44" },
  "&dark .cm-activeLine": { backgroundColor: "#99eeff33" },
  "&light .cm-specialChar": { color: "red" },
  "&dark .cm-specialChar": { color: "#f78" },
  ".cm-gutters": {
    flexShrink: 0,
    display: "flex",
    height: "100%",
    boxSizing: "border-box",
    insetInlineStart: 0,
    zIndex: 200
  },
  "&light .cm-gutters": {
    backgroundColor: "#f5f5f5",
    color: "#6c6c6c",
    borderRight: "1px solid #ddd"
  },
  "&dark .cm-gutters": {
    backgroundColor: "#333338",
    color: "#ccc"
  },
  ".cm-gutter": {
    display: "flex !important",
    // Necessary -- prevents margin collapsing
    flexDirection: "column",
    flexShrink: 0,
    boxSizing: "border-box",
    minHeight: "100%",
    overflow: "hidden"
  },
  ".cm-gutterElement": {
    boxSizing: "border-box"
  },
  ".cm-lineNumbers .cm-gutterElement": {
    padding: "0 3px 0 5px",
    minWidth: "20px",
    textAlign: "right",
    whiteSpace: "nowrap"
  },
  "&light .cm-activeLineGutter": {
    backgroundColor: "#e2f2ff"
  },
  "&dark .cm-activeLineGutter": {
    backgroundColor: "#222227"
  },
  ".cm-panels": {
    boxSizing: "border-box",
    position: "sticky",
    left: 0,
    right: 0
  },
  "&light .cm-panels": {
    backgroundColor: "#f5f5f5",
    color: "black"
  },
  "&light .cm-panels-top": {
    borderBottom: "1px solid #ddd"
  },
  "&light .cm-panels-bottom": {
    borderTop: "1px solid #ddd"
  },
  "&dark .cm-panels": {
    backgroundColor: "#333338",
    color: "white"
  },
  ".cm-tab": {
    display: "inline-block",
    overflow: "hidden",
    verticalAlign: "bottom"
  },
  ".cm-widgetBuffer": {
    verticalAlign: "text-top",
    height: "1em",
    width: 0,
    display: "inline"
  },
  ".cm-placeholder": {
    color: "#888",
    display: "inline-block",
    verticalAlign: "top"
  },
  ".cm-highlightSpace:before": {
    content: "attr(data-display)",
    position: "absolute",
    pointerEvents: "none",
    color: "#888"
  },
  ".cm-highlightTab": {
    backgroundImage: `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" width="200" height="20"><path stroke="%23888" stroke-width="1" fill="none" d="M1 10H196L190 5M190 15L196 10M197 4L197 16"/></svg>')`,
    backgroundSize: "auto 100%",
    backgroundPosition: "right 90%",
    backgroundRepeat: "no-repeat"
  },
  ".cm-trailingSpace": {
    backgroundColor: "#ff332255"
  },
  ".cm-button": {
    verticalAlign: "middle",
    color: "inherit",
    fontSize: "70%",
    padding: ".2em 1em",
    borderRadius: "1px"
  },
  "&light .cm-button": {
    backgroundImage: "linear-gradient(#eff1f5, #d9d9df)",
    border: "1px solid #888",
    "&:active": {
      backgroundImage: "linear-gradient(#b4b4b4, #d0d3d6)"
    }
  },
  "&dark .cm-button": {
    backgroundImage: "linear-gradient(#393939, #111)",
    border: "1px solid #888",
    "&:active": {
      backgroundImage: "linear-gradient(#111, #333)"
    }
  },
  ".cm-textfield": {
    verticalAlign: "middle",
    color: "inherit",
    fontSize: "70%",
    border: "1px solid silver",
    padding: ".2em .5em"
  },
  "&light .cm-textfield": {
    backgroundColor: "white"
  },
  "&dark .cm-textfield": {
    border: "1px solid #555",
    backgroundColor: "inherit"
  }
}, Bm), jb = {
  childList: !0,
  characterData: !0,
  subtree: !0,
  attributes: !0,
  characterDataOldValue: !0
}, Zo = B.ie && B.ie_version <= 11;
class Kb {
  constructor(e) {
    this.view = e, this.active = !1, this.editContext = null, this.selectionRange = new O1(), this.selectionChanged = !1, this.delayedFlush = -1, this.resizeTimeout = -1, this.queue = [], this.delayedAndroidKey = null, this.flushingAndroidKey = -1, this.lastChange = 0, this.scrollTargets = [], this.intersection = null, this.resizeScroll = null, this.intersecting = !1, this.gapIntersection = null, this.gaps = [], this.printQuery = null, this.parentCheck = -1, this.dom = e.contentDOM, this.observer = new MutationObserver((t) => {
      for (let i of t)
        this.queue.push(i);
      (B.ie && B.ie_version <= 11 || B.ios && e.composing) && t.some((i) => i.type == "childList" && i.removedNodes.length || i.type == "characterData" && i.oldValue.length > i.target.nodeValue.length) ? this.flushSoon() : this.flush();
    }), window.EditContext && e.constructor.EDIT_CONTEXT !== !1 && // Chrome <126 doesn't support inverted selections in edit context (#1392)
    !(B.chrome && B.chrome_version < 126) && (this.editContext = new Yb(e), e.state.facet(vi) && (e.contentDOM.editContext = this.editContext.editContext)), Zo && (this.onCharData = (t) => {
      this.queue.push({
        target: t.target,
        type: "characterData",
        oldValue: t.prevValue
      }), this.flushSoon();
    }), this.onSelectionChange = this.onSelectionChange.bind(this), this.onResize = this.onResize.bind(this), this.onPrint = this.onPrint.bind(this), this.onScroll = this.onScroll.bind(this), window.matchMedia && (this.printQuery = window.matchMedia("print")), typeof ResizeObserver == "function" && (this.resizeScroll = new ResizeObserver(() => {
      var t;
      ((t = this.view.docView) === null || t === void 0 ? void 0 : t.lastUpdate) < Date.now() - 75 && this.onResize();
    }), this.resizeScroll.observe(e.scrollDOM)), this.addWindowListeners(this.win = e.win), this.start(), typeof IntersectionObserver == "function" && (this.intersection = new IntersectionObserver((t) => {
      this.parentCheck < 0 && (this.parentCheck = setTimeout(this.listenForScroll.bind(this), 1e3)), t.length > 0 && t[t.length - 1].intersectionRatio > 0 != this.intersecting && (this.intersecting = !this.intersecting, this.intersecting != this.view.inView && this.onScrollChanged(document.createEvent("Event")));
    }, { threshold: [0, 1e-3] }), this.intersection.observe(this.dom), this.gapIntersection = new IntersectionObserver((t) => {
      t.length > 0 && t[t.length - 1].intersectionRatio > 0 && this.onScrollChanged(document.createEvent("Event"));
    }, {})), this.listenForScroll(), this.readSelectionRange();
  }
  onScrollChanged(e) {
    this.view.inputState.runHandlers("scroll", e), this.intersecting && this.view.measure();
  }
  onScroll(e) {
    this.intersecting && this.flush(!1), this.editContext && this.view.requestMeasure(this.editContext.measureReq), this.onScrollChanged(e);
  }
  onResize() {
    this.resizeTimeout < 0 && (this.resizeTimeout = setTimeout(() => {
      this.resizeTimeout = -1, this.view.requestMeasure();
    }, 50));
  }
  onPrint(e) {
    (e.type == "change" || !e.type) && !e.matches || (this.view.viewState.printing = !0, this.view.measure(), setTimeout(() => {
      this.view.viewState.printing = !1, this.view.requestMeasure();
    }, 500));
  }
  updateGaps(e) {
    if (this.gapIntersection && (e.length != this.gaps.length || this.gaps.some((t, i) => t != e[i]))) {
      this.gapIntersection.disconnect();
      for (let t of e)
        this.gapIntersection.observe(t);
      this.gaps = e;
    }
  }
  onSelectionChange(e) {
    let t = this.selectionChanged;
    if (!this.readSelectionRange() || this.delayedAndroidKey)
      return;
    let { view: i } = this, s = this.selectionRange;
    if (i.state.facet(vi) ? i.root.activeElement != this.dom : !Hr(i.dom, s))
      return;
    let r = s.anchorNode && i.docView.nearest(s.anchorNode);
    if (r && r.ignoreEvent(e)) {
      t || (this.selectionChanged = !1);
      return;
    }
    (B.ie && B.ie_version <= 11 || B.android && B.chrome) && !i.state.selection.main.empty && // (Selection.isCollapsed isn't reliable on IE)
    s.focusNode && ks(s.focusNode, s.focusOffset, s.anchorNode, s.anchorOffset) ? this.flushSoon() : this.flush(!1);
  }
  readSelectionRange() {
    let { view: e } = this, t = Os(e.root);
    if (!t)
      return !1;
    let i = B.safari && e.root.nodeType == 11 && A1(this.dom.ownerDocument) == this.dom && Gb(this.view, t) || t;
    if (!i || this.selectionRange.eq(i))
      return !1;
    let s = Hr(this.dom, i);
    return s && !this.selectionChanged && e.inputState.lastFocusTime > Date.now() - 200 && e.inputState.lastTouchTime < Date.now() - 300 && L1(this.dom, i) ? (this.view.inputState.lastFocusTime = 0, e.docView.updateSelection(), !1) : (this.selectionRange.setRange(i), s && (this.selectionChanged = !0), !0);
  }
  setSelectionRange(e, t) {
    this.selectionRange.set(e.node, e.offset, t.node, t.offset), this.selectionChanged = !1;
  }
  clearSelectionRange() {
    this.selectionRange.set(null, 0, null, 0);
  }
  listenForScroll() {
    this.parentCheck = -1;
    let e = 0, t = null;
    for (let i = this.dom; i; )
      if (i.nodeType == 1)
        !t && e < this.scrollTargets.length && this.scrollTargets[e] == i ? e++ : t || (t = this.scrollTargets.slice(0, e)), t && t.push(i), i = i.assignedSlot || i.parentNode;
      else if (i.nodeType == 11)
        i = i.host;
      else
        break;
    if (e < this.scrollTargets.length && !t && (t = this.scrollTargets.slice(0, e)), t) {
      for (let i of this.scrollTargets)
        i.removeEventListener("scroll", this.onScroll);
      for (let i of this.scrollTargets = t)
        i.addEventListener("scroll", this.onScroll);
    }
  }
  ignore(e) {
    if (!this.active)
      return e();
    try {
      return this.stop(), e();
    } finally {
      this.start(), this.clear();
    }
  }
  start() {
    this.active || (this.observer.observe(this.dom, jb), Zo && this.dom.addEventListener("DOMCharacterDataModified", this.onCharData), this.active = !0);
  }
  stop() {
    this.active && (this.active = !1, this.observer.disconnect(), Zo && this.dom.removeEventListener("DOMCharacterDataModified", this.onCharData));
  }
  // Throw away any pending changes
  clear() {
    this.processRecords(), this.queue.length = 0, this.selectionChanged = !1;
  }
  // Chrome Android, especially in combination with GBoard, not only
  // doesn't reliably fire regular key events, but also often
  // surrounds the effect of enter or backspace with a bunch of
  // composition events that, when interrupted, cause text duplication
  // or other kinds of corruption. This hack makes the editor back off
  // from handling DOM changes for a moment when such a key is
  // detected (via beforeinput or keydown), and then tries to flush
  // them or, if that has no effect, dispatches the given key.
  delayAndroidKey(e, t) {
    var i;
    if (!this.delayedAndroidKey) {
      let s = () => {
        let r = this.delayedAndroidKey;
        r && (this.clearDelayedAndroidKey(), this.view.inputState.lastKeyCode = r.keyCode, this.view.inputState.lastKeyTime = Date.now(), !this.flush() && r.force && Cn(this.dom, r.key, r.keyCode));
      };
      this.flushingAndroidKey = this.view.win.requestAnimationFrame(s);
    }
    (!this.delayedAndroidKey || e == "Enter") && (this.delayedAndroidKey = {
      key: e,
      keyCode: t,
      // Only run the key handler when no changes are detected if
      // this isn't coming right after another change, in which case
      // it is probably part of a weird chain of updates, and should
      // be ignored if it returns the DOM to its previous state.
      force: this.lastChange < Date.now() - 50 || !!(!((i = this.delayedAndroidKey) === null || i === void 0) && i.force)
    });
  }
  clearDelayedAndroidKey() {
    this.win.cancelAnimationFrame(this.flushingAndroidKey), this.delayedAndroidKey = null, this.flushingAndroidKey = -1;
  }
  flushSoon() {
    this.delayedFlush < 0 && (this.delayedFlush = this.view.win.requestAnimationFrame(() => {
      this.delayedFlush = -1, this.flush();
    }));
  }
  forceFlush() {
    this.delayedFlush >= 0 && (this.view.win.cancelAnimationFrame(this.delayedFlush), this.delayedFlush = -1), this.flush();
  }
  pendingRecords() {
    for (let e of this.observer.takeRecords())
      this.queue.push(e);
    return this.queue;
  }
  processRecords() {
    let e = this.pendingRecords();
    e.length && (this.queue = []);
    let t = -1, i = -1, s = !1;
    for (let r of e) {
      let o = this.readMutation(r);
      o && (o.typeOver && (s = !0), t == -1 ? { from: t, to: i } = o : (t = Math.min(o.from, t), i = Math.max(o.to, i)));
    }
    return { from: t, to: i, typeOver: s };
  }
  readChange() {
    let { from: e, to: t, typeOver: i } = this.processRecords(), s = this.selectionChanged && Hr(this.dom, this.selectionRange);
    if (e < 0 && !s)
      return null;
    e > -1 && (this.lastChange = Date.now()), this.view.inputState.lastFocusTime = 0, this.selectionChanged = !1;
    let r = new fb(this.view, e, t, i);
    return this.view.docView.domChanged = { newSel: r.newSel ? r.newSel.main : null }, r;
  }
  // Apply pending changes, if any
  flush(e = !0) {
    if (this.delayedFlush >= 0 || this.delayedAndroidKey)
      return !1;
    e && this.readSelectionRange();
    let t = this.readChange();
    if (!t)
      return this.view.requestMeasure(), !1;
    let i = this.view.state, s = Sm(this.view, t);
    return this.view.state == i && (t.domChanged || t.newSel && !t.newSel.main.eq(this.view.state.selection.main)) && this.view.update([]), s;
  }
  readMutation(e) {
    let t = this.view.docView.nearest(e.target);
    if (!t || t.ignoreMutation(e))
      return null;
    if (t.markDirty(e.type == "attributes"), e.type == "attributes" && (t.flags |= 4), e.type == "childList") {
      let i = Kc(t, e.previousSibling || e.target.previousSibling, -1), s = Kc(t, e.nextSibling || e.target.nextSibling, 1);
      return {
        from: i ? t.posAfter(i) : t.posAtStart,
        to: s ? t.posBefore(s) : t.posAtEnd,
        typeOver: !1
      };
    } else return e.type == "characterData" ? { from: t.posAtStart, to: t.posAtEnd, typeOver: e.target.nodeValue == e.oldValue } : null;
  }
  setWindow(e) {
    e != this.win && (this.removeWindowListeners(this.win), this.win = e, this.addWindowListeners(this.win));
  }
  addWindowListeners(e) {
    e.addEventListener("resize", this.onResize), this.printQuery ? this.printQuery.addEventListener ? this.printQuery.addEventListener("change", this.onPrint) : this.printQuery.addListener(this.onPrint) : e.addEventListener("beforeprint", this.onPrint), e.addEventListener("scroll", this.onScroll), e.document.addEventListener("selectionchange", this.onSelectionChange);
  }
  removeWindowListeners(e) {
    e.removeEventListener("scroll", this.onScroll), e.removeEventListener("resize", this.onResize), this.printQuery ? this.printQuery.removeEventListener ? this.printQuery.removeEventListener("change", this.onPrint) : this.printQuery.removeListener(this.onPrint) : e.removeEventListener("beforeprint", this.onPrint), e.document.removeEventListener("selectionchange", this.onSelectionChange);
  }
  update(e) {
    this.editContext && (this.editContext.update(e), e.startState.facet(vi) != e.state.facet(vi) && (e.view.contentDOM.editContext = e.state.facet(vi) ? this.editContext.editContext : null));
  }
  destroy() {
    var e, t, i;
    this.stop(), (e = this.intersection) === null || e === void 0 || e.disconnect(), (t = this.gapIntersection) === null || t === void 0 || t.disconnect(), (i = this.resizeScroll) === null || i === void 0 || i.disconnect();
    for (let s of this.scrollTargets)
      s.removeEventListener("scroll", this.onScroll);
    this.removeWindowListeners(this.win), clearTimeout(this.parentCheck), clearTimeout(this.resizeTimeout), this.win.cancelAnimationFrame(this.delayedFlush), this.win.cancelAnimationFrame(this.flushingAndroidKey), this.editContext && (this.view.contentDOM.editContext = null, this.editContext.destroy());
  }
}
function Kc(n, e, t) {
  for (; e; ) {
    let i = ae.get(e);
    if (i && i.parent == n)
      return i;
    let s = e.parentNode;
    e = s != n.dom ? s : t > 0 ? e.nextSibling : e.previousSibling;
  }
  return null;
}
function Gc(n, e) {
  let t = e.startContainer, i = e.startOffset, s = e.endContainer, r = e.endOffset, o = n.docView.domAtPos(n.state.selection.main.anchor);
  return ks(o.node, o.offset, s, r) && ([t, i, s, r] = [s, r, t, i]), { anchorNode: t, anchorOffset: i, focusNode: s, focusOffset: r };
}
function Gb(n, e) {
  if (e.getComposedRanges) {
    let s = e.getComposedRanges(n.root)[0];
    if (s)
      return Gc(n, s);
  }
  let t = null;
  function i(s) {
    s.preventDefault(), s.stopImmediatePropagation(), t = s.getTargetRanges()[0];
  }
  return n.contentDOM.addEventListener("beforeinput", i, !0), n.dom.ownerDocument.execCommand("indent"), n.contentDOM.removeEventListener("beforeinput", i, !0), t ? Gc(n, t) : null;
}
class Yb {
  constructor(e) {
    this.from = 0, this.to = 0, this.pendingContextChange = null, this.handlers = /* @__PURE__ */ Object.create(null), this.resetRange(e.state);
    let t = this.editContext = new window.EditContext({
      text: e.state.doc.sliceString(this.from, this.to),
      selectionStart: this.toContextPos(Math.max(this.from, Math.min(this.to, e.state.selection.main.anchor))),
      selectionEnd: this.toContextPos(e.state.selection.main.head)
    });
    this.handlers.textupdate = (i) => {
      let { anchor: s } = e.state.selection.main, r = {
        from: this.toEditorPos(i.updateRangeStart),
        to: this.toEditorPos(i.updateRangeEnd),
        insert: ie.of(i.text.split(`
`))
      };
      r.from == this.from && s < this.from ? r.from = s : r.to == this.to && s > this.to && (r.to = s), !(r.from == r.to && !r.insert.length) && (this.pendingContextChange = r, e.state.readOnly || Za(e, r, C.single(this.toEditorPos(i.selectionStart), this.toEditorPos(i.selectionEnd))), this.pendingContextChange && (this.revertPending(e.state), this.setSelection(e.state)));
    }, this.handlers.characterboundsupdate = (i) => {
      let s = [], r = null;
      for (let o = this.toEditorPos(i.rangeStart), l = this.toEditorPos(i.rangeEnd); o < l; o++) {
        let a = e.coordsForChar(o);
        r = a && new DOMRect(a.left, a.top, a.right - a.left, a.bottom - a.top) || r || new DOMRect(), s.push(r);
      }
      t.updateCharacterBounds(i.rangeStart, s);
    }, this.handlers.textformatupdate = (i) => {
      let s = [];
      for (let r of i.getTextFormats()) {
        let o = r.underlineStyle, l = r.underlineThickness;
        if (o != "None" && l != "None") {
          let a = `text-decoration: underline ${o == "Dashed" ? "dashed " : o == "Squiggle" ? "wavy " : ""}${l == "Thin" ? 1 : 2}px`;
          s.push(N.mark({ attributes: { style: a } }).range(this.toEditorPos(r.rangeStart), this.toEditorPos(r.rangeEnd)));
        }
      }
      e.dispatch({ effects: pm.of(N.set(s)) });
    }, this.handlers.compositionstart = () => {
      e.inputState.composing < 0 && (e.inputState.composing = 0, e.inputState.compositionFirstChange = !0);
    }, this.handlers.compositionend = () => {
      e.inputState.composing = -1, e.inputState.compositionFirstChange = null;
    };
    for (let i in this.handlers)
      t.addEventListener(i, this.handlers[i]);
    this.measureReq = { read: (i) => {
      this.editContext.updateControlBounds(i.contentDOM.getBoundingClientRect());
      let s = Os(i.root);
      s && s.rangeCount && this.editContext.updateSelectionBounds(s.getRangeAt(0).getBoundingClientRect());
    } };
  }
  applyEdits(e) {
    let t = 0, i = !1, s = this.pendingContextChange;
    return e.changes.iterChanges((r, o, l, a, h) => {
      if (i)
        return;
      let c = h.length - (o - r);
      if (s && o >= s.to)
        if (s.from == r && s.to == o && s.insert.eq(h)) {
          s = this.pendingContextChange = null, t += c, this.to += c;
          return;
        } else
          s = null, this.revertPending(e.state);
      if (r += t, o += t, o <= this.from)
        this.from += c, this.to += c;
      else if (r < this.to) {
        if (r < this.from || o > this.to || this.to - this.from + h.length > 3e4) {
          i = !0;
          return;
        }
        this.editContext.updateText(this.toContextPos(r), this.toContextPos(o), h.toString()), this.to += c;
      }
      t += c;
    }), s && !i && this.revertPending(e.state), !i;
  }
  update(e) {
    let t = this.pendingContextChange;
    !this.applyEdits(e) || !this.rangeIsValid(e.state) ? (this.pendingContextChange = null, this.resetRange(e.state), this.editContext.updateText(0, this.editContext.text.length, e.state.doc.sliceString(this.from, this.to)), this.setSelection(e.state)) : (e.docChanged || e.selectionSet || t) && this.setSelection(e.state), (e.geometryChanged || e.docChanged || e.selectionSet) && e.view.requestMeasure(this.measureReq);
  }
  resetRange(e) {
    let { head: t } = e.selection.main;
    this.from = Math.max(
      0,
      t - 1e4
      /* CxVp.Margin */
    ), this.to = Math.min(
      e.doc.length,
      t + 1e4
      /* CxVp.Margin */
    );
  }
  revertPending(e) {
    let t = this.pendingContextChange;
    this.pendingContextChange = null, this.editContext.updateText(this.toContextPos(t.from), this.toContextPos(t.from + t.insert.length), e.doc.sliceString(t.from, t.to));
  }
  setSelection(e) {
    let { main: t } = e.selection, i = this.toContextPos(Math.max(this.from, Math.min(this.to, t.anchor))), s = this.toContextPos(t.head);
    (this.editContext.selectionStart != i || this.editContext.selectionEnd != s) && this.editContext.updateSelection(i, s);
  }
  rangeIsValid(e) {
    let { head: t } = e.selection.main;
    return !(this.from > 0 && t - this.from < 500 || this.to < e.doc.length && this.to - t < 500 || this.to - this.from > 1e4 * 3);
  }
  toEditorPos(e) {
    return e + this.from;
  }
  toContextPos(e) {
    return e - this.from;
  }
  destroy() {
    for (let e in this.handlers)
      this.editContext.removeEventListener(e, this.handlers[e]);
  }
}
class O {
  /**
  The current editor state.
  */
  get state() {
    return this.viewState.state;
  }
  /**
  To be able to display large documents without consuming too much
  memory or overloading the browser, CodeMirror only draws the
  code that is visible (plus a margin around it) to the DOM. This
  property tells you the extent of the current drawn viewport, in
  document positions.
  */
  get viewport() {
    return this.viewState.viewport;
  }
  /**
  When there are, for example, large collapsed ranges in the
  viewport, its size can be a lot bigger than the actual visible
  content. Thus, if you are doing something like styling the
  content in the viewport, it is preferable to only do so for
  these ranges, which are the subset of the viewport that is
  actually drawn.
  */
  get visibleRanges() {
    return this.viewState.visibleRanges;
  }
  /**
  Returns false when the editor is entirely scrolled out of view
  or otherwise hidden.
  */
  get inView() {
    return this.viewState.inView;
  }
  /**
  Indicates whether the user is currently composing text via
  [IME](https://en.wikipedia.org/wiki/Input_method), and at least
  one change has been made in the current composition.
  */
  get composing() {
    return this.inputState.composing > 0;
  }
  /**
  Indicates whether the user is currently in composing state. Note
  that on some platforms, like Android, this will be the case a
  lot, since just putting the cursor on a word starts a
  composition there.
  */
  get compositionStarted() {
    return this.inputState.composing >= 0;
  }
  /**
  The document or shadow root that the view lives in.
  */
  get root() {
    return this._root;
  }
  /**
  @internal
  */
  get win() {
    return this.dom.ownerDocument.defaultView || window;
  }
  /**
  Construct a new view. You'll want to either provide a `parent`
  option, or put `view.dom` into your document after creating a
  view, so that the user can see the editor.
  */
  constructor(e = {}) {
    this.plugins = [], this.pluginMap = /* @__PURE__ */ new Map(), this.editorAttrs = {}, this.contentAttrs = {}, this.bidiCache = [], this.destroyed = !1, this.updateState = 2, this.measureScheduled = -1, this.measureRequests = [], this.contentDOM = document.createElement("div"), this.scrollDOM = document.createElement("div"), this.scrollDOM.tabIndex = -1, this.scrollDOM.className = "cm-scroller", this.scrollDOM.appendChild(this.contentDOM), this.announceDOM = document.createElement("div"), this.announceDOM.className = "cm-announced", this.announceDOM.setAttribute("aria-live", "polite"), this.dom = document.createElement("div"), this.dom.appendChild(this.announceDOM), this.dom.appendChild(this.scrollDOM), e.parent && e.parent.appendChild(this.dom);
    let { dispatch: t } = e;
    this.dispatchTransactions = e.dispatchTransactions || t && ((i) => i.forEach((s) => t(s, this))) || ((i) => this.update(i)), this.dispatch = this.dispatch.bind(this), this._root = e.root || E1(e.parent) || document, this.viewState = new Uc(e.state || Z.create(e)), e.scrollTo && e.scrollTo.is(ar) && (this.viewState.scrollTarget = e.scrollTo.value.clip(this.viewState.state)), this.plugins = this.state.facet(fs).map((i) => new Yo(i));
    for (let i of this.plugins)
      i.update(this);
    this.observer = new Kb(this), this.inputState = new gb(this), this.inputState.ensureHandlers(this.plugins), this.docView = new _c(this), this.mountStyles(), this.updateAttrs(), this.updateState = 0, this.requestMeasure();
  }
  dispatch(...e) {
    let t = e.length == 1 && e[0] instanceof _e ? e : e.length == 1 && Array.isArray(e[0]) ? e[0] : [this.state.update(...e)];
    this.dispatchTransactions(t, this);
  }
  /**
  Update the view for the given array of transactions. This will
  update the visible document and selection to match the state
  produced by the transactions, and notify view plugins of the
  change. You should usually call
  [`dispatch`](https://codemirror.net/6/docs/ref/#view.EditorView.dispatch) instead, which uses this
  as a primitive.
  */
  update(e) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.update are not allowed while an update is in progress");
    let t = !1, i = !1, s, r = this.state;
    for (let u of e) {
      if (u.startState != r)
        throw new RangeError("Trying to update state with a transaction that doesn't start from the previous state.");
      r = u.state;
    }
    if (this.destroyed) {
      this.viewState.state = r;
      return;
    }
    let o = this.hasFocus, l = 0, a = null;
    e.some((u) => u.annotation(Dm)) ? (this.inputState.notifiedFocused = o, l = 1) : o != this.inputState.notifiedFocused && (this.inputState.notifiedFocused = o, a = Om(r, o), a || (l = 1));
    let h = this.observer.delayedAndroidKey, c = null;
    if (h ? (this.observer.clearDelayedAndroidKey(), c = this.observer.readChange(), (c && !this.state.doc.eq(r.doc) || !this.state.selection.eq(r.selection)) && (c = null)) : this.observer.clear(), r.facet(Z.phrases) != this.state.facet(Z.phrases))
      return this.setState(r);
    s = $r.create(this, r, e), s.flags |= l;
    let f = this.viewState.scrollTarget;
    try {
      this.updateState = 2;
      for (let u of e) {
        if (f && (f = f.map(u.changes)), u.scrollIntoView) {
          let { main: d } = u.state.selection;
          f = new An(d.empty ? d : C.cursor(d.head, d.head > d.anchor ? -1 : 1));
        }
        for (let d of u.effects)
          d.is(ar) && (f = d.value.clip(this.state));
      }
      this.viewState.update(s, f), this.bidiCache = to.update(this.bidiCache, s.changes), s.empty || (this.updatePlugins(s), this.inputState.update(s)), t = this.docView.update(s), this.state.facet(us) != this.styleModules && this.mountStyles(), i = this.updateAttrs(), this.showAnnouncements(e), this.docView.updateSelection(t, e.some((u) => u.isUserEvent("select.pointer")));
    } finally {
      this.updateState = 0;
    }
    if (s.startState.facet(mr) != s.state.facet(mr) && (this.viewState.mustMeasureContent = !0), (t || i || f || this.viewState.mustEnforceCursorAssoc || this.viewState.mustMeasureContent) && this.requestMeasure(), t && this.docViewUpdate(), !s.empty)
      for (let u of this.state.facet(ha))
        try {
          u(s);
        } catch (d) {
          Je(this.state, d, "update listener");
        }
    (a || c) && Promise.resolve().then(() => {
      a && this.state == a.startState && this.dispatch(a), c && !Sm(this, c) && h.force && Cn(this.contentDOM, h.key, h.keyCode);
    });
  }
  /**
  Reset the view to the given state. (This will cause the entire
  document to be redrawn and all view plugins to be reinitialized,
  so you should probably only use it when the new state isn't
  derived from the old state. Otherwise, use
  [`dispatch`](https://codemirror.net/6/docs/ref/#view.EditorView.dispatch) instead.)
  */
  setState(e) {
    if (this.updateState != 0)
      throw new Error("Calls to EditorView.setState are not allowed while an update is in progress");
    if (this.destroyed) {
      this.viewState.state = e;
      return;
    }
    this.updateState = 2;
    let t = this.hasFocus;
    try {
      for (let i of this.plugins)
        i.destroy(this);
      this.viewState = new Uc(e), this.plugins = e.facet(fs).map((i) => new Yo(i)), this.pluginMap.clear();
      for (let i of this.plugins)
        i.update(this);
      this.docView.destroy(), this.docView = new _c(this), this.inputState.ensureHandlers(this.plugins), this.mountStyles(), this.updateAttrs(), this.bidiCache = [];
    } finally {
      this.updateState = 0;
    }
    t && this.focus(), this.requestMeasure();
  }
  updatePlugins(e) {
    let t = e.startState.facet(fs), i = e.state.facet(fs);
    if (t != i) {
      let s = [];
      for (let r of i) {
        let o = t.indexOf(r);
        if (o < 0)
          s.push(new Yo(r));
        else {
          let l = this.plugins[o];
          l.mustUpdate = e, s.push(l);
        }
      }
      for (let r of this.plugins)
        r.mustUpdate != e && r.destroy(this);
      this.plugins = s, this.pluginMap.clear();
    } else
      for (let s of this.plugins)
        s.mustUpdate = e;
    for (let s = 0; s < this.plugins.length; s++)
      this.plugins[s].update(this);
    t != i && this.inputState.ensureHandlers(this.plugins);
  }
  docViewUpdate() {
    for (let e of this.plugins) {
      let t = e.value;
      if (t && t.docViewUpdate)
        try {
          t.docViewUpdate(this);
        } catch (i) {
          Je(this.state, i, "doc view update listener");
        }
    }
  }
  /**
  @internal
  */
  measure(e = !0) {
    if (this.destroyed)
      return;
    if (this.measureScheduled > -1 && this.win.cancelAnimationFrame(this.measureScheduled), this.observer.delayedAndroidKey) {
      this.measureScheduled = -1, this.requestMeasure();
      return;
    }
    this.measureScheduled = 0, e && this.observer.forceFlush();
    let t = null, i = this.scrollDOM, s = i.scrollTop * this.scaleY, { scrollAnchorPos: r, scrollAnchorHeight: o } = this.viewState;
    Math.abs(s - this.viewState.scrollTop) > 1 && (o = -1), this.viewState.scrollAnchorHeight = -1;
    try {
      for (let l = 0; ; l++) {
        if (o < 0)
          if (qd(i))
            r = -1, o = this.viewState.heightMap.height;
          else {
            let d = this.viewState.scrollAnchorAt(s);
            r = d.from, o = d.top;
          }
        this.updateState = 1;
        let a = this.viewState.measure(this);
        if (!a && !this.measureRequests.length && this.viewState.scrollTarget == null)
          break;
        if (l > 5) {
          console.warn(this.measureRequests.length ? "Measure loop restarted more than 5 times" : "Viewport failed to stabilize");
          break;
        }
        let h = [];
        a & 4 || ([this.measureRequests, h] = [h, this.measureRequests]);
        let c = h.map((d) => {
          try {
            return d.read(this);
          } catch (m) {
            return Je(this.state, m), Yc;
          }
        }), f = $r.create(this, this.state, []), u = !1;
        f.flags |= a, t ? t.flags |= a : t = f, this.updateState = 2, f.empty || (this.updatePlugins(f), this.inputState.update(f), this.updateAttrs(), u = this.docView.update(f), u && this.docViewUpdate());
        for (let d = 0; d < h.length; d++)
          if (c[d] != Yc)
            try {
              let m = h[d];
              m.write && m.write(c[d], this);
            } catch (m) {
              Je(this.state, m);
            }
        if (u && this.docView.updateSelection(!0), !f.viewportChanged && this.measureRequests.length == 0) {
          if (this.viewState.editorHeight)
            if (this.viewState.scrollTarget) {
              this.docView.scrollIntoView(this.viewState.scrollTarget), this.viewState.scrollTarget = null, o = -1;
              continue;
            } else {
              let m = (r < 0 ? this.viewState.heightMap.height : this.viewState.lineBlockAt(r).top) - o;
              if (m > 1 || m < -1) {
                s = s + m, i.scrollTop = s / this.scaleY, o = -1;
                continue;
              }
            }
          break;
        }
      }
    } finally {
      this.updateState = 0, this.measureScheduled = -1;
    }
    if (t && !t.empty)
      for (let l of this.state.facet(ha))
        l(t);
  }
  /**
  Get the CSS classes for the currently active editor themes.
  */
  get themeClasses() {
    return ma + " " + (this.state.facet(da) ? Pm : Rm) + " " + this.state.facet(mr);
  }
  updateAttrs() {
    let e = Xc(this, gm, {
      class: "cm-editor" + (this.hasFocus ? " cm-focused " : " ") + this.themeClasses
    }), t = {
      spellcheck: "false",
      autocorrect: "off",
      autocapitalize: "off",
      translate: "no",
      contenteditable: this.state.facet(vi) ? "true" : "false",
      class: "cm-content",
      style: `${B.tabSize}: ${this.state.tabSize}`,
      role: "textbox",
      "aria-multiline": "true"
    };
    this.state.readOnly && (t["aria-readonly"] = "true"), Xc(this, Ja, t);
    let i = this.observer.ignore(() => {
      let s = sa(this.contentDOM, this.contentAttrs, t), r = sa(this.dom, this.editorAttrs, e);
      return s || r;
    });
    return this.editorAttrs = e, this.contentAttrs = t, i;
  }
  showAnnouncements(e) {
    let t = !0;
    for (let i of e)
      for (let s of i.effects)
        if (s.is(O.announce)) {
          t && (this.announceDOM.textContent = ""), t = !1;
          let r = this.announceDOM.appendChild(document.createElement("div"));
          r.textContent = s.value;
        }
  }
  mountStyles() {
    this.styleModules = this.state.facet(us);
    let e = this.state.facet(O.cspNonce);
    Di.mount(this.root, this.styleModules.concat(Ub).reverse(), e ? { nonce: e } : void 0);
  }
  readMeasured() {
    if (this.updateState == 2)
      throw new Error("Reading the editor layout isn't allowed during an update");
    this.updateState == 0 && this.measureScheduled > -1 && this.measure(!1);
  }
  /**
  Schedule a layout measurement, optionally providing callbacks to
  do custom DOM measuring followed by a DOM write phase. Using
  this is preferable reading DOM layout directly from, for
  example, an event handler, because it'll make sure measuring and
  drawing done by other components is synchronized, avoiding
  unnecessary DOM layout computations.
  */
  requestMeasure(e) {
    if (this.measureScheduled < 0 && (this.measureScheduled = this.win.requestAnimationFrame(() => this.measure())), e) {
      if (this.measureRequests.indexOf(e) > -1)
        return;
      if (e.key != null) {
        for (let t = 0; t < this.measureRequests.length; t++)
          if (this.measureRequests[t].key === e.key) {
            this.measureRequests[t] = e;
            return;
          }
      }
      this.measureRequests.push(e);
    }
  }
  /**
  Get the value of a specific plugin, if present. Note that
  plugins that crash can be dropped from a view, so even when you
  know you registered a given plugin, it is recommended to check
  the return value of this method.
  */
  plugin(e) {
    let t = this.pluginMap.get(e);
    return (t === void 0 || t && t.spec != e) && this.pluginMap.set(e, t = this.plugins.find((i) => i.spec == e) || null), t && t.update(this).value;
  }
  /**
  The top position of the document, in screen coordinates. This
  may be negative when the editor is scrolled down. Points
  directly to the top of the first line, not above the padding.
  */
  get documentTop() {
    return this.contentDOM.getBoundingClientRect().top + this.viewState.paddingTop;
  }
  /**
  Reports the padding above and below the document.
  */
  get documentPadding() {
    return { top: this.viewState.paddingTop, bottom: this.viewState.paddingBottom };
  }
  /**
  If the editor is transformed with CSS, this provides the scale
  along the X axis. Otherwise, it will just be 1. Note that
  transforms other than translation and scaling are not supported.
  */
  get scaleX() {
    return this.viewState.scaleX;
  }
  /**
  Provide the CSS transformed scale along the Y axis.
  */
  get scaleY() {
    return this.viewState.scaleY;
  }
  /**
  Find the text line or block widget at the given vertical
  position (which is interpreted as relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop)).
  */
  elementAtHeight(e) {
    return this.readMeasured(), this.viewState.elementAtHeight(e);
  }
  /**
  Find the line block (see
  [`lineBlockAt`](https://codemirror.net/6/docs/ref/#view.EditorView.lineBlockAt) at the given
  height, again interpreted relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop).
  */
  lineBlockAtHeight(e) {
    return this.readMeasured(), this.viewState.lineBlockAtHeight(e);
  }
  /**
  Get the extent and vertical position of all [line
  blocks](https://codemirror.net/6/docs/ref/#view.EditorView.lineBlockAt) in the viewport. Positions
  are relative to the [top of the
  document](https://codemirror.net/6/docs/ref/#view.EditorView.documentTop);
  */
  get viewportLineBlocks() {
    return this.viewState.viewportLines;
  }
  /**
  Find the line block around the given document position. A line
  block is a range delimited on both sides by either a
  non-[hidden](https://codemirror.net/6/docs/ref/#view.Decoration^replace) line breaks, or the
  start/end of the document. It will usually just hold a line of
  text, but may be broken into multiple textblocks by block
  widgets.
  */
  lineBlockAt(e) {
    return this.viewState.lineBlockAt(e);
  }
  /**
  The editor's total content height.
  */
  get contentHeight() {
    return this.viewState.contentHeight;
  }
  /**
  Move a cursor position by [grapheme
  cluster](https://codemirror.net/6/docs/ref/#state.findClusterBreak). `forward` determines whether
  the motion is away from the line start, or towards it. In
  bidirectional text, the line is traversed in visual order, using
  the editor's [text direction](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection).
  When the start position was the last one on the line, the
  returned position will be across the line break. If there is no
  further line, the original position is returned.
  
  By default, this method moves over a single cluster. The
  optional `by` argument can be used to move across more. It will
  be called with the first cluster as argument, and should return
  a predicate that determines, for each subsequent cluster,
  whether it should also be moved over.
  */
  moveByChar(e, t, i) {
    return Jo(this, e, Oc(this, e, t, i));
  }
  /**
  Move a cursor position across the next group of either
  [letters](https://codemirror.net/6/docs/ref/#state.EditorState.charCategorizer) or non-letter
  non-whitespace characters.
  */
  moveByGroup(e, t) {
    return Jo(this, e, Oc(this, e, t, (i) => lb(this, e.head, i)));
  }
  /**
  Get the cursor position visually at the start or end of a line.
  Note that this may differ from the _logical_ position at its
  start or end (which is simply at `line.from`/`line.to`) if text
  at the start or end goes against the line's base text direction.
  */
  visualLineSide(e, t) {
    let i = this.bidiSpans(e), s = this.textDirectionAt(e.from), r = i[t ? i.length - 1 : 0];
    return C.cursor(r.side(t, s) + e.from, r.forward(!t, s) ? 1 : -1);
  }
  /**
  Move to the next line boundary in the given direction. If
  `includeWrap` is true, line wrapping is on, and there is a
  further wrap point on the current line, the wrap point will be
  returned. Otherwise this function will return the start or end
  of the line.
  */
  moveToLineBoundary(e, t, i = !0) {
    return ob(this, e, t, i);
  }
  /**
  Move a cursor position vertically. When `distance` isn't given,
  it defaults to moving to the next line (including wrapped
  lines). Otherwise, `distance` should provide a positive distance
  in pixels.
  
  When `start` has a
  [`goalColumn`](https://codemirror.net/6/docs/ref/#state.SelectionRange.goalColumn), the vertical
  motion will use that as a target horizontal position. Otherwise,
  the cursor's own horizontal position is used. The returned
  cursor will have its goal column set to whichever column was
  used.
  */
  moveVertically(e, t, i) {
    return Jo(this, e, ab(this, e, t, i));
  }
  /**
  Find the DOM parent node and offset (child offset if `node` is
  an element, character offset when it is a text node) at the
  given document position.
  
  Note that for positions that aren't currently in
  `visibleRanges`, the resulting DOM position isn't necessarily
  meaningful (it may just point before or after a placeholder
  element).
  */
  domAtPos(e) {
    return this.docView.domAtPos(e);
  }
  /**
  Find the document position at the given DOM node. Can be useful
  for associating positions with DOM events. Will raise an error
  when `node` isn't part of the editor content.
  */
  posAtDOM(e, t = 0) {
    return this.docView.posFromDOM(e, t);
  }
  posAtCoords(e, t = !0) {
    return this.readMeasured(), xm(this, e, t);
  }
  /**
  Get the screen coordinates at the given document position.
  `side` determines whether the coordinates are based on the
  element before (-1) or after (1) the position (if no element is
  available on the given side, the method will transparently use
  another strategy to get reasonable coordinates).
  */
  coordsAtPos(e, t = 1) {
    this.readMeasured();
    let i = this.docView.coordsAt(e, t);
    if (!i || i.left == i.right)
      return i;
    let s = this.state.doc.lineAt(e), r = this.bidiSpans(s), o = r[Ci.find(r, e - s.from, -1, t)];
    return Ao(i, o.dir == de.LTR == t > 0);
  }
  /**
  Return the rectangle around a given character. If `pos` does not
  point in front of a character that is in the viewport and
  rendered (i.e. not replaced, not a line break), this will return
  null. For space characters that are a line wrap point, this will
  return the position before the line break.
  */
  coordsForChar(e) {
    return this.readMeasured(), this.docView.coordsForChar(e);
  }
  /**
  The default width of a character in the editor. May not
  accurately reflect the width of all characters (given variable
  width fonts or styling of invididual ranges).
  */
  get defaultCharacterWidth() {
    return this.viewState.heightOracle.charWidth;
  }
  /**
  The default height of a line in the editor. May not be accurate
  for all lines.
  */
  get defaultLineHeight() {
    return this.viewState.heightOracle.lineHeight;
  }
  /**
  The text direction
  ([`direction`](https://developer.mozilla.org/en-US/docs/Web/CSS/direction)
  CSS property) of the editor's content element.
  */
  get textDirection() {
    return this.viewState.defaultTextDirection;
  }
  /**
  Find the text direction of the block at the given position, as
  assigned by CSS. If
  [`perLineTextDirection`](https://codemirror.net/6/docs/ref/#view.EditorView^perLineTextDirection)
  isn't enabled, or the given position is outside of the viewport,
  this will always return the same as
  [`textDirection`](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection). Note that
  this may trigger a DOM layout.
  */
  textDirectionAt(e) {
    return !this.state.facet(um) || e < this.viewport.from || e > this.viewport.to ? this.textDirection : (this.readMeasured(), this.docView.textDirectionAt(e));
  }
  /**
  Whether this editor [wraps lines](https://codemirror.net/6/docs/ref/#view.EditorView.lineWrapping)
  (as determined by the
  [`white-space`](https://developer.mozilla.org/en-US/docs/Web/CSS/white-space)
  CSS property of its content element).
  */
  get lineWrapping() {
    return this.viewState.heightOracle.lineWrapping;
  }
  /**
  Returns the bidirectional text structure of the given line
  (which should be in the current document) as an array of span
  objects. The order of these spans matches the [text
  direction](https://codemirror.net/6/docs/ref/#view.EditorView.textDirection)—if that is
  left-to-right, the leftmost spans come first, otherwise the
  rightmost spans come first.
  */
  bidiSpans(e) {
    if (e.length > Xb)
      return sm(e.length);
    let t = this.textDirectionAt(e.from), i;
    for (let r of this.bidiCache)
      if (r.from == e.from && r.dir == t && (r.fresh || nm(r.isolates, i = Sc(this, e))))
        return r.order;
    i || (i = Sc(this, e));
    let s = U1(e.text, t, i);
    return this.bidiCache.push(new to(e.from, e.to, t, i, !0, s)), s;
  }
  /**
  Check whether the editor has focus.
  */
  get hasFocus() {
    var e;
    return (this.dom.ownerDocument.hasFocus() || B.safari && ((e = this.inputState) === null || e === void 0 ? void 0 : e.lastContextMenu) > Date.now() - 3e4) && this.root.activeElement == this.contentDOM;
  }
  /**
  Put focus on the editor.
  */
  focus() {
    this.observer.ignore(() => {
      Wd(this.contentDOM), this.docView.updateSelection();
    });
  }
  /**
  Update the [root](https://codemirror.net/6/docs/ref/##view.EditorViewConfig.root) in which the editor lives. This is only
  necessary when moving the editor's existing DOM to a new window or shadow root.
  */
  setRoot(e) {
    this._root != e && (this._root = e, this.observer.setWindow((e.nodeType == 9 ? e : e.ownerDocument).defaultView || window), this.mountStyles());
  }
  /**
  Clean up this editor view, removing its element from the
  document, unregistering event handlers, and notifying
  plugins. The view instance can no longer be used after
  calling this.
  */
  destroy() {
    this.root.activeElement == this.contentDOM && this.contentDOM.blur();
    for (let e of this.plugins)
      e.destroy(this);
    this.plugins = [], this.inputState.destroy(), this.docView.destroy(), this.dom.remove(), this.observer.destroy(), this.measureScheduled > -1 && this.win.cancelAnimationFrame(this.measureScheduled), this.destroyed = !0;
  }
  /**
  Returns an effect that can be
  [added](https://codemirror.net/6/docs/ref/#state.TransactionSpec.effects) to a transaction to
  cause it to scroll the given position or range into view.
  */
  static scrollIntoView(e, t = {}) {
    return ar.of(new An(typeof e == "number" ? C.cursor(e) : e, t.y, t.x, t.yMargin, t.xMargin));
  }
  /**
  Return an effect that resets the editor to its current (at the
  time this method was called) scroll position. Note that this
  only affects the editor's own scrollable element, not parents.
  See also
  [`EditorViewConfig.scrollTo`](https://codemirror.net/6/docs/ref/#view.EditorViewConfig.scrollTo).
  
  The effect should be used with a document identical to the one
  it was created for. Failing to do so is not an error, but may
  not scroll to the expected position. You can
  [map](https://codemirror.net/6/docs/ref/#state.StateEffect.map) the effect to account for changes.
  */
  scrollSnapshot() {
    let { scrollTop: e, scrollLeft: t } = this.scrollDOM, i = this.viewState.scrollAnchorAt(e);
    return ar.of(new An(C.cursor(i.from), "start", "start", i.top - e, t, !0));
  }
  /**
  Enable or disable tab-focus mode, which disables key bindings
  for Tab and Shift-Tab, letting the browser's default
  focus-changing behavior go through instead. This is useful to
  prevent trapping keyboard users in your editor.
  
  Without argument, this toggles the mode. With a boolean, it
  enables (true) or disables it (false). Given a number, it
  temporarily enables the mode until that number of milliseconds
  have passed or another non-Tab key is pressed.
  */
  setTabFocusMode(e) {
    e == null ? this.inputState.tabFocusMode = this.inputState.tabFocusMode < 0 ? 0 : -1 : typeof e == "boolean" ? this.inputState.tabFocusMode = e ? 0 : -1 : this.inputState.tabFocusMode != 0 && (this.inputState.tabFocusMode = Date.now() + e);
  }
  /**
  Returns an extension that can be used to add DOM event handlers.
  The value should be an object mapping event names to handler
  functions. For any given event, such functions are ordered by
  extension precedence, and the first handler to return true will
  be assumed to have handled that event, and no other handlers or
  built-in behavior will be activated for it. These are registered
  on the [content element](https://codemirror.net/6/docs/ref/#view.EditorView.contentDOM), except
  for `scroll` handlers, which will be called any time the
  editor's [scroll element](https://codemirror.net/6/docs/ref/#view.EditorView.scrollDOM) or one of
  its parent nodes is scrolled.
  */
  static domEventHandlers(e) {
    return be.define(() => ({}), { eventHandlers: e });
  }
  /**
  Create an extension that registers DOM event observers. Contrary
  to event [handlers](https://codemirror.net/6/docs/ref/#view.EditorView^domEventHandlers),
  observers can't be prevented from running by a higher-precedence
  handler returning true. They also don't prevent other handlers
  and observers from running when they return true, and should not
  call `preventDefault`.
  */
  static domEventObservers(e) {
    return be.define(() => ({}), { eventObservers: e });
  }
  /**
  Create a theme extension. The first argument can be a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)
  style spec providing the styles for the theme. These will be
  prefixed with a generated class for the style.
  
  Because the selectors will be prefixed with a scope class, rule
  that directly match the editor's [wrapper
  element](https://codemirror.net/6/docs/ref/#view.EditorView.dom)—to which the scope class will be
  added—need to be explicitly differentiated by adding an `&` to
  the selector for that element—for example
  `&.cm-focused`.
  
  When `dark` is set to true, the theme will be marked as dark,
  which will cause the `&dark` rules from [base
  themes](https://codemirror.net/6/docs/ref/#view.EditorView^baseTheme) to be used (as opposed to
  `&light` when a light theme is active).
  */
  static theme(e, t) {
    let i = Di.newName(), s = [mr.of(i), us.of(pa(`.${i}`, e))];
    return t && t.dark && s.push(da.of(!0)), s;
  }
  /**
  Create an extension that adds styles to the base theme. Like
  with [`theme`](https://codemirror.net/6/docs/ref/#view.EditorView^theme), use `&` to indicate the
  place of the editor wrapper element when directly targeting
  that. You can also use `&dark` or `&light` instead to only
  target editors with a dark or light theme.
  */
  static baseTheme(e) {
    return ei.lowest(us.of(pa("." + ma, e, Bm)));
  }
  /**
  Retrieve an editor view instance from the view's DOM
  representation.
  */
  static findFromDOM(e) {
    var t;
    let i = e.querySelector(".cm-content"), s = i && ae.get(i) || ae.get(e);
    return ((t = s == null ? void 0 : s.rootView) === null || t === void 0 ? void 0 : t.view) || null;
  }
}
O.styleModule = us;
O.inputHandler = cm;
O.scrollHandler = mm;
O.focusChangeEffect = fm;
O.perLineTextDirection = um;
O.exceptionSink = hm;
O.updateListener = ha;
O.editable = vi;
O.mouseSelectionStyle = am;
O.dragMovesSelection = lm;
O.clickAddsSelectionRange = om;
O.decorations = Es;
O.outerDecorations = bm;
O.atomicRanges = Qa;
O.bidiIsolatedRanges = ym;
O.scrollMargins = wm;
O.darkTheme = da;
O.cspNonce = /* @__PURE__ */ I.define({ combine: (n) => n.length ? n[0] : "" });
O.contentAttributes = Ja;
O.editorAttributes = gm;
O.lineWrapping = /* @__PURE__ */ O.contentAttributes.of({ class: "cm-lineWrapping" });
O.announce = /* @__PURE__ */ K.define();
const Xb = 4096, Yc = {};
class to {
  constructor(e, t, i, s, r, o) {
    this.from = e, this.to = t, this.dir = i, this.isolates = s, this.fresh = r, this.order = o;
  }
  static update(e, t) {
    if (t.empty && !e.some((r) => r.fresh))
      return e;
    let i = [], s = e.length ? e[e.length - 1].dir : de.LTR;
    for (let r = Math.max(0, e.length - 10); r < e.length; r++) {
      let o = e[r];
      o.dir == s && !t.touchesRange(o.from, o.to) && i.push(new to(t.mapPos(o.from, 1), t.mapPos(o.to, -1), o.dir, o.isolates, !1, o.order));
    }
    return i;
  }
}
function Xc(n, e, t) {
  for (let i = n.state.facet(e), s = i.length - 1; s >= 0; s--) {
    let r = i[s], o = typeof r == "function" ? r(n) : r;
    o && na(o, t);
  }
  return t;
}
const Jb = B.mac ? "mac" : B.windows ? "win" : B.linux ? "linux" : "key";
function Qb(n, e) {
  const t = n.split(/-(?!$)/);
  let i = t[t.length - 1];
  i == "Space" && (i = " ");
  let s, r, o, l;
  for (let a = 0; a < t.length - 1; ++a) {
    const h = t[a];
    if (/^(cmd|meta|m)$/i.test(h))
      l = !0;
    else if (/^a(lt)?$/i.test(h))
      s = !0;
    else if (/^(c|ctrl|control)$/i.test(h))
      r = !0;
    else if (/^s(hift)?$/i.test(h))
      o = !0;
    else if (/^mod$/i.test(h))
      e == "mac" ? l = !0 : r = !0;
    else
      throw new Error("Unrecognized modifier name: " + h);
  }
  return s && (i = "Alt-" + i), r && (i = "Ctrl-" + i), l && (i = "Meta-" + i), o && (i = "Shift-" + i), i;
}
function pr(n, e, t) {
  return e.altKey && (n = "Alt-" + n), e.ctrlKey && (n = "Ctrl-" + n), e.metaKey && (n = "Meta-" + n), t !== !1 && e.shiftKey && (n = "Shift-" + n), n;
}
const Zb = /* @__PURE__ */ ei.default(/* @__PURE__ */ O.domEventHandlers({
  keydown(n, e) {
    return Nm(Im(e.state), n, e, "editor");
  }
})), rn = /* @__PURE__ */ I.define({ enables: Zb }), Jc = /* @__PURE__ */ new WeakMap();
function Im(n) {
  let e = n.facet(rn), t = Jc.get(e);
  return t || Jc.set(e, t = ty(e.reduce((i, s) => i.concat(s), []))), t;
}
function $b(n, e, t) {
  return Nm(Im(n.state), e, n, t);
}
let xi = null;
const ey = 4e3;
function ty(n, e = Jb) {
  let t = /* @__PURE__ */ Object.create(null), i = /* @__PURE__ */ Object.create(null), s = (o, l) => {
    let a = i[o];
    if (a == null)
      i[o] = l;
    else if (a != l)
      throw new Error("Key binding " + o + " is used both as a regular binding and as a multi-stroke prefix");
  }, r = (o, l, a, h, c) => {
    var f, u;
    let d = t[o] || (t[o] = /* @__PURE__ */ Object.create(null)), m = l.split(/ (?!$)/).map((b) => Qb(b, e));
    for (let b = 1; b < m.length; b++) {
      let w = m.slice(0, b).join(" ");
      s(w, !0), d[w] || (d[w] = {
        preventDefault: !0,
        stopPropagation: !1,
        run: [(k) => {
          let x = xi = { view: k, prefix: w, scope: o };
          return setTimeout(() => {
            xi == x && (xi = null);
          }, ey), !0;
        }]
      });
    }
    let p = m.join(" ");
    s(p, !1);
    let g = d[p] || (d[p] = {
      preventDefault: !1,
      stopPropagation: !1,
      run: ((u = (f = d._any) === null || f === void 0 ? void 0 : f.run) === null || u === void 0 ? void 0 : u.slice()) || []
    });
    a && g.run.push(a), h && (g.preventDefault = !0), c && (g.stopPropagation = !0);
  };
  for (let o of n) {
    let l = o.scope ? o.scope.split(" ") : ["editor"];
    if (o.any)
      for (let h of l) {
        let c = t[h] || (t[h] = /* @__PURE__ */ Object.create(null));
        c._any || (c._any = { preventDefault: !1, stopPropagation: !1, run: [] });
        let { any: f } = o;
        for (let u in c)
          c[u].run.push((d) => f(d, ga));
      }
    let a = o[e] || o.key;
    if (a)
      for (let h of l)
        r(h, a, o.run, o.preventDefault, o.stopPropagation), o.shift && r(h, "Shift-" + a, o.shift, o.preventDefault, o.stopPropagation);
  }
  return t;
}
let ga = null;
function Nm(n, e, t, i) {
  ga = e;
  let s = C1(e), r = De(s, 0), o = lt(r) == s.length && s != " ", l = "", a = !1, h = !1, c = !1;
  xi && xi.view == t && xi.scope == i && (l = xi.prefix + " ", Cm.indexOf(e.keyCode) < 0 && (h = !0, xi = null));
  let f = /* @__PURE__ */ new Set(), u = (g) => {
    if (g) {
      for (let b of g.run)
        if (!f.has(b) && (f.add(b), b(t)))
          return g.stopPropagation && (c = !0), !0;
      g.preventDefault && (g.stopPropagation && (c = !0), h = !0);
    }
    return !1;
  }, d = n[i], m, p;
  return d && (u(d[l + pr(s, e, !o)]) ? a = !0 : o && (e.altKey || e.metaKey || e.ctrlKey) && // Ctrl-Alt may be used for AltGr on Windows
  !(B.windows && e.ctrlKey && e.altKey) && (m = Oi[e.keyCode]) && m != s ? (u(d[l + pr(m, e, !0)]) || e.shiftKey && (p = Ds[e.keyCode]) != s && p != m && u(d[l + pr(p, e, !1)])) && (a = !0) : o && e.shiftKey && u(d[l + pr(s, e, !0)]) && (a = !0), !a && u(d._any) && (a = !0)), h && (a = !0), a && c && e.stopPropagation(), ga = null, a;
}
class Xs {
  /**
  Create a marker with the given class and dimensions. If `width`
  is null, the DOM element will get no width style.
  */
  constructor(e, t, i, s, r) {
    this.className = e, this.left = t, this.top = i, this.width = s, this.height = r;
  }
  draw() {
    let e = document.createElement("div");
    return e.className = this.className, this.adjust(e), e;
  }
  update(e, t) {
    return t.className != this.className ? !1 : (this.adjust(e), !0);
  }
  adjust(e) {
    e.style.left = this.left + "px", e.style.top = this.top + "px", this.width != null && (e.style.width = this.width + "px"), e.style.height = this.height + "px";
  }
  eq(e) {
    return this.left == e.left && this.top == e.top && this.width == e.width && this.height == e.height && this.className == e.className;
  }
  /**
  Create a set of rectangles for the given selection range,
  assigning them theclass`className`. Will create a single
  rectangle for empty ranges, and a set of selection-style
  rectangles covering the range's content (in a bidi-aware
  way) for non-empty ones.
  */
  static forRange(e, t, i) {
    if (i.empty) {
      let s = e.coordsAtPos(i.head, i.assoc || 1);
      if (!s)
        return [];
      let r = Fm(e);
      return [new Xs(t, s.left - r.left, s.top - r.top, null, s.bottom - s.top)];
    } else
      return iy(e, t, i);
  }
}
function Fm(n) {
  let e = n.scrollDOM.getBoundingClientRect();
  return { left: (n.textDirection == de.LTR ? e.left : e.right - n.scrollDOM.clientWidth * n.scaleX) - n.scrollDOM.scrollLeft * n.scaleX, top: e.top - n.scrollDOM.scrollTop * n.scaleY };
}
function Qc(n, e, t, i) {
  let s = n.coordsAtPos(e, t * 2);
  if (!s)
    return i;
  let r = n.dom.getBoundingClientRect(), o = (s.top + s.bottom) / 2, l = n.posAtCoords({ x: r.left + 1, y: o }), a = n.posAtCoords({ x: r.right - 1, y: o });
  return l == null || a == null ? i : { from: Math.max(i.from, Math.min(l, a)), to: Math.min(i.to, Math.max(l, a)) };
}
function iy(n, e, t) {
  if (t.to <= n.viewport.from || t.from >= n.viewport.to)
    return [];
  let i = Math.max(t.from, n.viewport.from), s = Math.min(t.to, n.viewport.to), r = n.textDirection == de.LTR, o = n.contentDOM, l = o.getBoundingClientRect(), a = Fm(n), h = o.querySelector(".cm-line"), c = h && window.getComputedStyle(h), f = l.left + (c ? parseInt(c.paddingLeft) + Math.min(0, parseInt(c.textIndent)) : 0), u = l.right - (c ? parseInt(c.paddingRight) : 0), d = fa(n, i), m = fa(n, s), p = d.type == ze.Text ? d : null, g = m.type == ze.Text ? m : null;
  if (p && (n.lineWrapping || d.widgetLineBreaks) && (p = Qc(n, i, 1, p)), g && (n.lineWrapping || m.widgetLineBreaks) && (g = Qc(n, s, -1, g)), p && g && p.from == g.from && p.to == g.to)
    return w(k(t.from, t.to, p));
  {
    let _ = p ? k(t.from, null, p) : x(d, !1), S = g ? k(null, t.to, g) : x(m, !0), A = [];
    return (p || d).to < (g || m).from - (p && g ? 1 : 0) || d.widgetLineBreaks > 1 && _.bottom + n.defaultLineHeight / 2 < S.top ? A.push(b(f, _.bottom, u, S.top)) : _.bottom < S.top && n.elementAtHeight((_.bottom + S.top) / 2).type == ze.Text && (_.bottom = S.top = (_.bottom + S.top) / 2), w(_).concat(A).concat(w(S));
  }
  function b(_, S, A, P) {
    return new Xs(
      e,
      _ - a.left,
      S - a.top - 0.01,
      A - _,
      P - S + 0.01
      /* C.Epsilon */
    );
  }
  function w({ top: _, bottom: S, horizontal: A }) {
    let P = [];
    for (let W = 0; W < A.length; W += 2)
      P.push(b(A[W], _, A[W + 1], S));
    return P;
  }
  function k(_, S, A) {
    let P = 1e9, W = -1e9, U = [];
    function F(z, G, Q, re, T) {
      let ee = n.coordsAtPos(z, z == A.to ? -2 : 2), J = n.coordsAtPos(Q, Q == A.from ? 2 : -2);
      !ee || !J || (P = Math.min(ee.top, J.top, P), W = Math.max(ee.bottom, J.bottom, W), T == de.LTR ? U.push(r && G ? f : ee.left, r && re ? u : J.right) : U.push(!r && re ? f : J.left, !r && G ? u : ee.right));
    }
    let M = _ ?? A.from, R = S ?? A.to;
    for (let z of n.visibleRanges)
      if (z.to > M && z.from < R)
        for (let G = Math.max(z.from, M), Q = Math.min(z.to, R); ; ) {
          let re = n.state.doc.lineAt(G);
          for (let T of n.bidiSpans(re)) {
            let ee = T.from + re.from, J = T.to + re.from;
            if (ee >= Q)
              break;
            J > G && F(Math.max(ee, G), _ == null && ee <= M, Math.min(J, Q), S == null && J >= R, T.dir);
          }
          if (G = re.to + 1, G >= Q)
            break;
        }
    return U.length == 0 && F(M, _ == null, R, S == null, n.textDirection), { top: P, bottom: W, horizontal: U };
  }
  function x(_, S) {
    let A = l.top + (S ? _.top : _.bottom);
    return { top: A, bottom: A, horizontal: [] };
  }
}
function ny(n, e) {
  return n.constructor == e.constructor && n.eq(e);
}
class sy {
  constructor(e, t) {
    this.view = e, this.layer = t, this.drawn = [], this.scaleX = 1, this.scaleY = 1, this.measureReq = { read: this.measure.bind(this), write: this.draw.bind(this) }, this.dom = e.scrollDOM.appendChild(document.createElement("div")), this.dom.classList.add("cm-layer"), t.above && this.dom.classList.add("cm-layer-above"), t.class && this.dom.classList.add(t.class), this.scale(), this.dom.setAttribute("aria-hidden", "true"), this.setOrder(e.state), e.requestMeasure(this.measureReq), t.mount && t.mount(this.dom, e);
  }
  update(e) {
    e.startState.facet(zr) != e.state.facet(zr) && this.setOrder(e.state), (this.layer.update(e, this.dom) || e.geometryChanged) && (this.scale(), e.view.requestMeasure(this.measureReq));
  }
  docViewUpdate(e) {
    this.layer.updateOnDocViewUpdate !== !1 && e.requestMeasure(this.measureReq);
  }
  setOrder(e) {
    let t = 0, i = e.facet(zr);
    for (; t < i.length && i[t] != this.layer; )
      t++;
    this.dom.style.zIndex = String((this.layer.above ? 150 : -1) - t);
  }
  measure() {
    return this.layer.markers(this.view);
  }
  scale() {
    let { scaleX: e, scaleY: t } = this.view;
    (e != this.scaleX || t != this.scaleY) && (this.scaleX = e, this.scaleY = t, this.dom.style.transform = `scale(${1 / e}, ${1 / t})`);
  }
  draw(e) {
    if (e.length != this.drawn.length || e.some((t, i) => !ny(t, this.drawn[i]))) {
      let t = this.dom.firstChild, i = 0;
      for (let s of e)
        s.update && t && s.constructor && this.drawn[i].constructor && s.update(t, this.drawn[i]) ? (t = t.nextSibling, i++) : this.dom.insertBefore(s.draw(), t);
      for (; t; ) {
        let s = t.nextSibling;
        t.remove(), t = s;
      }
      this.drawn = e;
    }
  }
  destroy() {
    this.layer.destroy && this.layer.destroy(this.dom, this.view), this.dom.remove();
  }
}
const zr = /* @__PURE__ */ I.define();
function Hm(n) {
  return [
    be.define((e) => new sy(e, n)),
    zr.of(n)
  ];
}
const Vm = !B.ios, Ls = /* @__PURE__ */ I.define({
  combine(n) {
    return ti(n, {
      cursorBlinkRate: 1200,
      drawRangeCursor: !0
    }, {
      cursorBlinkRate: (e, t) => Math.min(e, t),
      drawRangeCursor: (e, t) => e || t
    });
  }
});
function Wm(n = {}) {
  return [
    Ls.of(n),
    ry,
    oy,
    ly,
    dm.of(!0)
  ];
}
function zm(n) {
  return n.startState.facet(Ls) != n.state.facet(Ls);
}
const ry = /* @__PURE__ */ Hm({
  above: !0,
  markers(n) {
    let { state: e } = n, t = e.facet(Ls), i = [];
    for (let s of e.selection.ranges) {
      let r = s == e.selection.main;
      if (s.empty ? !r || Vm : t.drawRangeCursor) {
        let o = r ? "cm-cursor cm-cursor-primary" : "cm-cursor cm-cursor-secondary", l = s.empty ? s : C.cursor(s.head, s.head > s.anchor ? -1 : 1);
        for (let a of Xs.forRange(n, o, l))
          i.push(a);
      }
    }
    return i;
  },
  update(n, e) {
    n.transactions.some((i) => i.selection) && (e.style.animationName = e.style.animationName == "cm-blink" ? "cm-blink2" : "cm-blink");
    let t = zm(n);
    return t && Zc(n.state, e), n.docChanged || n.selectionSet || t;
  },
  mount(n, e) {
    Zc(e.state, n);
  },
  class: "cm-cursorLayer"
});
function Zc(n, e) {
  e.style.animationDuration = n.facet(Ls).cursorBlinkRate + "ms";
}
const oy = /* @__PURE__ */ Hm({
  above: !1,
  markers(n) {
    return n.state.selection.ranges.map((e) => e.empty ? [] : Xs.forRange(n, "cm-selectionBackground", e)).reduce((e, t) => e.concat(t));
  },
  update(n, e) {
    return n.docChanged || n.selectionSet || n.viewportChanged || zm(n);
  },
  class: "cm-selectionLayer"
}), ba = {
  ".cm-line": {
    "& ::selection, &::selection": { backgroundColor: "transparent !important" }
  },
  ".cm-content": {
    "& :focus": {
      caretColor: "initial !important",
      "&::selection, & ::selection": {
        backgroundColor: "Highlight !important"
      }
    }
  }
};
Vm && (ba[".cm-line"].caretColor = ba[".cm-content"].caretColor = "transparent !important");
const ly = /* @__PURE__ */ ei.highest(/* @__PURE__ */ O.theme(ba)), qm = /* @__PURE__ */ K.define({
  map(n, e) {
    return n == null ? null : e.mapPos(n);
  }
}), ps = /* @__PURE__ */ ke.define({
  create() {
    return null;
  },
  update(n, e) {
    return n != null && (n = e.changes.mapPos(n)), e.effects.reduce((t, i) => i.is(qm) ? i.value : t, n);
  }
}), ay = /* @__PURE__ */ be.fromClass(class {
  constructor(n) {
    this.view = n, this.cursor = null, this.measureReq = { read: this.readPos.bind(this), write: this.drawCursor.bind(this) };
  }
  update(n) {
    var e;
    let t = n.state.field(ps);
    t == null ? this.cursor != null && ((e = this.cursor) === null || e === void 0 || e.remove(), this.cursor = null) : (this.cursor || (this.cursor = this.view.scrollDOM.appendChild(document.createElement("div")), this.cursor.className = "cm-dropCursor"), (n.startState.field(ps) != t || n.docChanged || n.geometryChanged) && this.view.requestMeasure(this.measureReq));
  }
  readPos() {
    let { view: n } = this, e = n.state.field(ps), t = e != null && n.coordsAtPos(e);
    if (!t)
      return null;
    let i = n.scrollDOM.getBoundingClientRect();
    return {
      left: t.left - i.left + n.scrollDOM.scrollLeft * n.scaleX,
      top: t.top - i.top + n.scrollDOM.scrollTop * n.scaleY,
      height: t.bottom - t.top
    };
  }
  drawCursor(n) {
    if (this.cursor) {
      let { scaleX: e, scaleY: t } = this.view;
      n ? (this.cursor.style.left = n.left / e + "px", this.cursor.style.top = n.top / t + "px", this.cursor.style.height = n.height / t + "px") : this.cursor.style.left = "-100000px";
    }
  }
  destroy() {
    this.cursor && this.cursor.remove();
  }
  setDropPos(n) {
    this.view.state.field(ps) != n && this.view.dispatch({ effects: qm.of(n) });
  }
}, {
  eventObservers: {
    dragover(n) {
      this.setDropPos(this.view.posAtCoords({ x: n.clientX, y: n.clientY }));
    },
    dragleave(n) {
      (n.target == this.view.contentDOM || !this.view.contentDOM.contains(n.relatedTarget)) && this.setDropPos(null);
    },
    dragend() {
      this.setDropPos(null);
    },
    drop() {
      this.setDropPos(null);
    }
  }
});
function hy() {
  return [ps, ay];
}
function $c(n, e, t, i, s) {
  e.lastIndex = 0;
  for (let r = n.iterRange(t, i), o = t, l; !r.next().done; o += r.value.length)
    if (!r.lineBreak)
      for (; l = e.exec(r.value); )
        s(o + l.index, l);
}
function cy(n, e) {
  let t = n.visibleRanges;
  if (t.length == 1 && t[0].from == n.viewport.from && t[0].to == n.viewport.to)
    return t;
  let i = [];
  for (let { from: s, to: r } of t)
    s = Math.max(n.state.doc.lineAt(s).from, s - e), r = Math.min(n.state.doc.lineAt(r).to, r + e), i.length && i[i.length - 1].to >= s ? i[i.length - 1].to = r : i.push({ from: s, to: r });
  return i;
}
class fy {
  /**
  Create a decorator.
  */
  constructor(e) {
    const { regexp: t, decoration: i, decorate: s, boundary: r, maxLength: o = 1e3 } = e;
    if (!t.global)
      throw new RangeError("The regular expression given to MatchDecorator should have its 'g' flag set");
    if (this.regexp = t, s)
      this.addMatch = (l, a, h, c) => s(c, h, h + l[0].length, l, a);
    else if (typeof i == "function")
      this.addMatch = (l, a, h, c) => {
        let f = i(l, a, h);
        f && c(h, h + l[0].length, f);
      };
    else if (i)
      this.addMatch = (l, a, h, c) => c(h, h + l[0].length, i);
    else
      throw new RangeError("Either 'decorate' or 'decoration' should be provided to MatchDecorator");
    this.boundary = r, this.maxLength = o;
  }
  /**
  Compute the full set of decorations for matches in the given
  view's viewport. You'll want to call this when initializing your
  plugin.
  */
  createDeco(e) {
    let t = new Tt(), i = t.add.bind(t);
    for (let { from: s, to: r } of cy(e, this.maxLength))
      $c(e.state.doc, this.regexp, s, r, (o, l) => this.addMatch(l, e, o, i));
    return t.finish();
  }
  /**
  Update a set of decorations for a view update. `deco` _must_ be
  the set of decorations produced by _this_ `MatchDecorator` for
  the view state before the update.
  */
  updateDeco(e, t) {
    let i = 1e9, s = -1;
    return e.docChanged && e.changes.iterChanges((r, o, l, a) => {
      a > e.view.viewport.from && l < e.view.viewport.to && (i = Math.min(l, i), s = Math.max(a, s));
    }), e.viewportChanged || s - i > 1e3 ? this.createDeco(e.view) : s > -1 ? this.updateRange(e.view, t.map(e.changes), i, s) : t;
  }
  updateRange(e, t, i, s) {
    for (let r of e.visibleRanges) {
      let o = Math.max(r.from, i), l = Math.min(r.to, s);
      if (l > o) {
        let a = e.state.doc.lineAt(o), h = a.to < l ? e.state.doc.lineAt(l) : a, c = Math.max(r.from, a.from), f = Math.min(r.to, h.to);
        if (this.boundary) {
          for (; o > a.from; o--)
            if (this.boundary.test(a.text[o - 1 - a.from])) {
              c = o;
              break;
            }
          for (; l < h.to; l++)
            if (this.boundary.test(h.text[l - h.from])) {
              f = l;
              break;
            }
        }
        let u = [], d, m = (p, g, b) => u.push(b.range(p, g));
        if (a == h)
          for (this.regexp.lastIndex = c - a.from; (d = this.regexp.exec(a.text)) && d.index < f - a.from; )
            this.addMatch(d, e, d.index + a.from, m);
        else
          $c(e.state.doc, this.regexp, c, f, (p, g) => this.addMatch(g, e, p, m));
        t = t.update({ filterFrom: c, filterTo: f, filter: (p, g) => p < c || g > f, add: u });
      }
    }
    return t;
  }
}
const ya = /x/.unicode != null ? "gu" : "g", uy = /* @__PURE__ */ new RegExp(`[\0-\b
--­؜​‎‏\u2028\u2029‭‮⁦⁧⁩\uFEFF￹-￼]`, ya), dy = {
  0: "null",
  7: "bell",
  8: "backspace",
  10: "newline",
  11: "vertical tab",
  13: "carriage return",
  27: "escape",
  8203: "zero width space",
  8204: "zero width non-joiner",
  8205: "zero width joiner",
  8206: "left-to-right mark",
  8207: "right-to-left mark",
  8232: "line separator",
  8237: "left-to-right override",
  8238: "right-to-left override",
  8294: "left-to-right isolate",
  8295: "right-to-left isolate",
  8297: "pop directional isolate",
  8233: "paragraph separator",
  65279: "zero width no-break space",
  65532: "object replacement"
};
let $o = null;
function my() {
  var n;
  if ($o == null && typeof document < "u" && document.body) {
    let e = document.body.style;
    $o = ((n = e.tabSize) !== null && n !== void 0 ? n : e.MozTabSize) != null;
  }
  return $o || !1;
}
const qr = /* @__PURE__ */ I.define({
  combine(n) {
    let e = ti(n, {
      render: null,
      specialChars: uy,
      addSpecialChars: null
    });
    return (e.replaceTabs = !my()) && (e.specialChars = new RegExp("	|" + e.specialChars.source, ya)), e.addSpecialChars && (e.specialChars = new RegExp(e.specialChars.source + "|" + e.addSpecialChars.source, ya)), e;
  }
});
function Um(n = {}) {
  return [qr.of(n), py()];
}
let ef = null;
function py() {
  return ef || (ef = be.fromClass(class {
    constructor(n) {
      this.view = n, this.decorations = N.none, this.decorationCache = /* @__PURE__ */ Object.create(null), this.decorator = this.makeDecorator(n.state.facet(qr)), this.decorations = this.decorator.createDeco(n);
    }
    makeDecorator(n) {
      return new fy({
        regexp: n.specialChars,
        decoration: (e, t, i) => {
          let { doc: s } = t.state, r = De(e[0], 0);
          if (r == 9) {
            let o = s.lineAt(i), l = t.state.tabSize, a = Wn(o.text, l, i - o.from);
            return N.replace({
              widget: new wy((l - a % l) * this.view.defaultCharacterWidth / this.view.scaleX)
            });
          }
          return this.decorationCache[r] || (this.decorationCache[r] = N.replace({ widget: new yy(n, r) }));
        },
        boundary: n.replaceTabs ? void 0 : /[^]/
      });
    }
    update(n) {
      let e = n.state.facet(qr);
      n.startState.facet(qr) != e ? (this.decorator = this.makeDecorator(e), this.decorations = this.decorator.createDeco(n.view)) : this.decorations = this.decorator.updateDeco(n, this.decorations);
    }
  }, {
    decorations: (n) => n.decorations
  }));
}
const gy = "•";
function by(n) {
  return n >= 32 ? gy : n == 10 ? "␤" : String.fromCharCode(9216 + n);
}
class yy extends Lt {
  constructor(e, t) {
    super(), this.options = e, this.code = t;
  }
  eq(e) {
    return e.code == this.code;
  }
  toDOM(e) {
    let t = by(this.code), i = e.state.phrase("Control character") + " " + (dy[this.code] || "0x" + this.code.toString(16)), s = this.options.render && this.options.render(this.code, i, t);
    if (s)
      return s;
    let r = document.createElement("span");
    return r.textContent = t, r.title = i, r.setAttribute("aria-label", i), r.className = "cm-specialChar", r;
  }
  ignoreEvent() {
    return !1;
  }
}
class wy extends Lt {
  constructor(e) {
    super(), this.width = e;
  }
  eq(e) {
    return e.width == this.width;
  }
  toDOM() {
    let e = document.createElement("span");
    return e.textContent = "	", e.className = "cm-tab", e.style.width = this.width + "px", e;
  }
  ignoreEvent() {
    return !1;
  }
}
function ky() {
  return xy;
}
const vy = /* @__PURE__ */ N.line({ class: "cm-activeLine" }), xy = /* @__PURE__ */ be.fromClass(class {
  constructor(n) {
    this.decorations = this.getDeco(n);
  }
  update(n) {
    (n.docChanged || n.selectionSet) && (this.decorations = this.getDeco(n.view));
  }
  getDeco(n) {
    let e = -1, t = [];
    for (let i of n.state.selection.ranges) {
      let s = n.lineBlockAt(i.head);
      s.from > e && (t.push(vy.range(s.from)), e = s.from);
    }
    return N.set(t);
  }
}, {
  decorations: (n) => n.decorations
});
class Sy extends Lt {
  constructor(e) {
    super(), this.content = e;
  }
  toDOM() {
    let e = document.createElement("span");
    return e.className = "cm-placeholder", e.style.pointerEvents = "none", e.appendChild(typeof this.content == "string" ? document.createTextNode(this.content) : this.content), typeof this.content == "string" ? e.setAttribute("aria-label", "placeholder " + this.content) : e.setAttribute("aria-hidden", "true"), e;
  }
  coordsAt(e) {
    let t = e.firstChild ? Ln(e.firstChild) : [];
    if (!t.length)
      return null;
    let i = window.getComputedStyle(e.parentNode), s = Ao(t[0], i.direction != "rtl"), r = parseInt(i.lineHeight);
    return s.bottom - s.top > r * 1.5 ? { left: s.left, right: s.right, top: s.top, bottom: s.top + r } : s;
  }
  ignoreEvent() {
    return !1;
  }
}
function _y(n) {
  return be.fromClass(class {
    constructor(e) {
      this.view = e, this.placeholder = n ? N.set([N.widget({ widget: new Sy(n), side: 1 }).range(0)]) : N.none;
    }
    get decorations() {
      return this.view.state.doc.length ? N.none : this.placeholder;
    }
  }, { decorations: (e) => e.decorations });
}
const wa = 2e3;
function Cy(n, e, t) {
  let i = Math.min(e.line, t.line), s = Math.max(e.line, t.line), r = [];
  if (e.off > wa || t.off > wa || e.col < 0 || t.col < 0) {
    let o = Math.min(e.off, t.off), l = Math.max(e.off, t.off);
    for (let a = i; a <= s; a++) {
      let h = n.doc.line(a);
      h.length <= l && r.push(C.range(h.from + o, h.to + l));
    }
  } else {
    let o = Math.min(e.col, t.col), l = Math.max(e.col, t.col);
    for (let a = i; a <= s; a++) {
      let h = n.doc.line(a), c = Jl(h.text, o, n.tabSize, !0);
      if (c < 0)
        r.push(C.cursor(h.to));
      else {
        let f = Jl(h.text, l, n.tabSize);
        r.push(C.range(h.from + c, h.from + f));
      }
    }
  }
  return r;
}
function Ay(n, e) {
  let t = n.coordsAtPos(n.viewport.from);
  return t ? Math.round(Math.abs((t.left - e) / n.defaultCharacterWidth)) : -1;
}
function tf(n, e) {
  let t = n.posAtCoords({ x: e.clientX, y: e.clientY }, !1), i = n.state.doc.lineAt(t), s = t - i.from, r = s > wa ? -1 : s == i.length ? Ay(n, e.clientX) : Wn(i.text, n.state.tabSize, t - i.from);
  return { line: i.number, col: r, off: s };
}
function My(n, e) {
  let t = tf(n, e), i = n.state.selection;
  return t ? {
    update(s) {
      if (s.docChanged) {
        let r = s.changes.mapPos(s.startState.doc.line(t.line).from), o = s.state.doc.lineAt(r);
        t = { line: o.number, col: t.col, off: Math.min(t.off, o.length) }, i = i.map(s.changes);
      }
    },
    get(s, r, o) {
      let l = tf(n, s);
      if (!l)
        return i;
      let a = Cy(n.state, t, l);
      return a.length ? o ? C.create(a.concat(i.ranges)) : C.create(a) : i;
    }
  } : null;
}
function jm(n) {
  let e = (t) => t.altKey && t.button == 0;
  return O.mouseSelectionStyle.of((t, i) => e(i) ? My(t, i) : null);
}
const Ty = {
  Alt: [18, (n) => !!n.altKey],
  Control: [17, (n) => !!n.ctrlKey],
  Shift: [16, (n) => !!n.shiftKey],
  Meta: [91, (n) => !!n.metaKey]
}, Dy = { style: "cursor: crosshair" };
function Km(n = {}) {
  let [e, t] = Ty[n.key || "Alt"], i = be.fromClass(class {
    constructor(s) {
      this.view = s, this.isDown = !1;
    }
    set(s) {
      this.isDown != s && (this.isDown = s, this.view.update([]));
    }
  }, {
    eventObservers: {
      keydown(s) {
        this.set(s.keyCode == e || t(s));
      },
      keyup(s) {
        (s.keyCode == e || !t(s)) && this.set(!1);
      },
      mousemove(s) {
        this.set(t(s));
      }
    }
  });
  return [
    i,
    O.contentAttributes.of((s) => {
      var r;
      return !((r = s.plugin(i)) === null || r === void 0) && r.isDown ? Dy : null;
    })
  ];
}
const $n = "-10000px";
class Gm {
  constructor(e, t, i, s) {
    this.facet = t, this.createTooltipView = i, this.removeTooltipView = s, this.input = e.state.facet(t), this.tooltips = this.input.filter((o) => o);
    let r = null;
    this.tooltipViews = this.tooltips.map((o) => r = i(o, r));
  }
  update(e, t) {
    var i;
    let s = e.state.facet(this.facet), r = s.filter((a) => a);
    if (s === this.input) {
      for (let a of this.tooltipViews)
        a.update && a.update(e);
      return !1;
    }
    let o = [], l = t ? [] : null;
    for (let a = 0; a < r.length; a++) {
      let h = r[a], c = -1;
      if (h) {
        for (let f = 0; f < this.tooltips.length; f++) {
          let u = this.tooltips[f];
          u && u.create == h.create && (c = f);
        }
        if (c < 0)
          o[a] = this.createTooltipView(h, a ? o[a - 1] : null), l && (l[a] = !!h.above);
        else {
          let f = o[a] = this.tooltipViews[c];
          l && (l[a] = t[c]), f.update && f.update(e);
        }
      }
    }
    for (let a of this.tooltipViews)
      o.indexOf(a) < 0 && (this.removeTooltipView(a), (i = a.destroy) === null || i === void 0 || i.call(a));
    return t && (l.forEach((a, h) => t[h] = a), t.length = l.length), this.input = s, this.tooltips = r, this.tooltipViews = o, !0;
  }
}
function Oy(n) {
  let { win: e } = n;
  return { top: 0, left: 0, bottom: e.innerHeight, right: e.innerWidth };
}
const el = /* @__PURE__ */ I.define({
  combine: (n) => {
    var e, t, i;
    return {
      position: B.ios ? "absolute" : ((e = n.find((s) => s.position)) === null || e === void 0 ? void 0 : e.position) || "fixed",
      parent: ((t = n.find((s) => s.parent)) === null || t === void 0 ? void 0 : t.parent) || null,
      tooltipSpace: ((i = n.find((s) => s.tooltipSpace)) === null || i === void 0 ? void 0 : i.tooltipSpace) || Oy
    };
  }
}), nf = /* @__PURE__ */ new WeakMap(), th = /* @__PURE__ */ be.fromClass(class {
  constructor(n) {
    this.view = n, this.above = [], this.inView = !0, this.madeAbsolute = !1, this.lastTransaction = 0, this.measureTimeout = -1;
    let e = n.state.facet(el);
    this.position = e.position, this.parent = e.parent, this.classes = n.themeClasses, this.createContainer(), this.measureReq = { read: this.readMeasure.bind(this), write: this.writeMeasure.bind(this), key: this }, this.resizeObserver = typeof ResizeObserver == "function" ? new ResizeObserver(() => this.measureSoon()) : null, this.manager = new Gm(n, ih, (t, i) => this.createTooltip(t, i), (t) => {
      this.resizeObserver && this.resizeObserver.unobserve(t.dom), t.dom.remove();
    }), this.above = this.manager.tooltips.map((t) => !!t.above), this.intersectionObserver = typeof IntersectionObserver == "function" ? new IntersectionObserver((t) => {
      Date.now() > this.lastTransaction - 50 && t.length > 0 && t[t.length - 1].intersectionRatio < 1 && this.measureSoon();
    }, { threshold: [1] }) : null, this.observeIntersection(), n.win.addEventListener("resize", this.measureSoon = this.measureSoon.bind(this)), this.maybeMeasure();
  }
  createContainer() {
    this.parent ? (this.container = document.createElement("div"), this.container.style.position = "relative", this.container.className = this.view.themeClasses, this.parent.appendChild(this.container)) : this.container = this.view.dom;
  }
  observeIntersection() {
    if (this.intersectionObserver) {
      this.intersectionObserver.disconnect();
      for (let n of this.manager.tooltipViews)
        this.intersectionObserver.observe(n.dom);
    }
  }
  measureSoon() {
    this.measureTimeout < 0 && (this.measureTimeout = setTimeout(() => {
      this.measureTimeout = -1, this.maybeMeasure();
    }, 50));
  }
  update(n) {
    n.transactions.length && (this.lastTransaction = Date.now());
    let e = this.manager.update(n, this.above);
    e && this.observeIntersection();
    let t = e || n.geometryChanged, i = n.state.facet(el);
    if (i.position != this.position && !this.madeAbsolute) {
      this.position = i.position;
      for (let s of this.manager.tooltipViews)
        s.dom.style.position = this.position;
      t = !0;
    }
    if (i.parent != this.parent) {
      this.parent && this.container.remove(), this.parent = i.parent, this.createContainer();
      for (let s of this.manager.tooltipViews)
        this.container.appendChild(s.dom);
      t = !0;
    } else this.parent && this.view.themeClasses != this.classes && (this.classes = this.container.className = this.view.themeClasses);
    t && this.maybeMeasure();
  }
  createTooltip(n, e) {
    let t = n.create(this.view), i = e ? e.dom : null;
    if (t.dom.classList.add("cm-tooltip"), n.arrow && !t.dom.querySelector(".cm-tooltip > .cm-tooltip-arrow")) {
      let s = document.createElement("div");
      s.className = "cm-tooltip-arrow", t.dom.appendChild(s);
    }
    return t.dom.style.position = this.position, t.dom.style.top = $n, t.dom.style.left = "0px", this.container.insertBefore(t.dom, i), t.mount && t.mount(this.view), this.resizeObserver && this.resizeObserver.observe(t.dom), t;
  }
  destroy() {
    var n, e, t;
    this.view.win.removeEventListener("resize", this.measureSoon);
    for (let i of this.manager.tooltipViews)
      i.dom.remove(), (n = i.destroy) === null || n === void 0 || n.call(i);
    this.parent && this.container.remove(), (e = this.resizeObserver) === null || e === void 0 || e.disconnect(), (t = this.intersectionObserver) === null || t === void 0 || t.disconnect(), clearTimeout(this.measureTimeout);
  }
  readMeasure() {
    let n = this.view.dom.getBoundingClientRect(), e = 1, t = 1, i = !1;
    if (this.position == "fixed" && this.manager.tooltipViews.length) {
      let { dom: s } = this.manager.tooltipViews[0];
      if (B.gecko)
        i = s.offsetParent != this.container.ownerDocument.body;
      else if (s.style.top == $n && s.style.left == "0px") {
        let r = s.getBoundingClientRect();
        i = Math.abs(r.top + 1e4) > 1 || Math.abs(r.left) > 1;
      }
    }
    if (i || this.position == "absolute")
      if (this.parent) {
        let s = this.parent.getBoundingClientRect();
        s.width && s.height && (e = s.width / this.parent.offsetWidth, t = s.height / this.parent.offsetHeight);
      } else
        ({ scaleX: e, scaleY: t } = this.view.viewState);
    return {
      editor: n,
      parent: this.parent ? this.container.getBoundingClientRect() : n,
      pos: this.manager.tooltips.map((s, r) => {
        let o = this.manager.tooltipViews[r];
        return o.getCoords ? o.getCoords(s.pos) : this.view.coordsAtPos(s.pos);
      }),
      size: this.manager.tooltipViews.map(({ dom: s }) => s.getBoundingClientRect()),
      space: this.view.state.facet(el).tooltipSpace(this.view),
      scaleX: e,
      scaleY: t,
      makeAbsolute: i
    };
  }
  writeMeasure(n) {
    var e;
    if (n.makeAbsolute) {
      this.madeAbsolute = !0, this.position = "absolute";
      for (let l of this.manager.tooltipViews)
        l.dom.style.position = "absolute";
    }
    let { editor: t, space: i, scaleX: s, scaleY: r } = n, o = [];
    for (let l = 0; l < this.manager.tooltips.length; l++) {
      let a = this.manager.tooltips[l], h = this.manager.tooltipViews[l], { dom: c } = h, f = n.pos[l], u = n.size[l];
      if (!f || f.bottom <= Math.max(t.top, i.top) || f.top >= Math.min(t.bottom, i.bottom) || f.right < Math.max(t.left, i.left) - 0.1 || f.left > Math.min(t.right, i.right) + 0.1) {
        c.style.top = $n;
        continue;
      }
      let d = a.arrow ? h.dom.querySelector(".cm-tooltip-arrow") : null, m = d ? 7 : 0, p = u.right - u.left, g = (e = nf.get(h)) !== null && e !== void 0 ? e : u.bottom - u.top, b = h.offset || Ly, w = this.view.textDirection == de.LTR, k = u.width > i.right - i.left ? w ? i.left : i.right - u.width : w ? Math.max(i.left, Math.min(f.left - (d ? 14 : 0) + b.x, i.right - p)) : Math.min(Math.max(i.left, f.left - p + (d ? 14 : 0) - b.x), i.right - p), x = this.above[l];
      !a.strictSide && (x ? f.top - (u.bottom - u.top) - b.y < i.top : f.bottom + (u.bottom - u.top) + b.y > i.bottom) && x == i.bottom - f.bottom > f.top - i.top && (x = this.above[l] = !x);
      let _ = (x ? f.top - i.top : i.bottom - f.bottom) - m;
      if (_ < g && h.resize !== !1) {
        if (_ < this.view.defaultLineHeight) {
          c.style.top = $n;
          continue;
        }
        nf.set(h, g), c.style.height = (g = _) / r + "px";
      } else c.style.height && (c.style.height = "");
      let S = x ? f.top - g - m - b.y : f.bottom + m + b.y, A = k + p;
      if (h.overlap !== !0)
        for (let P of o)
          P.left < A && P.right > k && P.top < S + g && P.bottom > S && (S = x ? P.top - g - 2 - m : P.bottom + m + 2);
      if (this.position == "absolute" ? (c.style.top = (S - n.parent.top) / r + "px", c.style.left = (k - n.parent.left) / s + "px") : (c.style.top = S / r + "px", c.style.left = k / s + "px"), d) {
        let P = f.left + (w ? b.x : -b.x) - (k + 14 - 7);
        d.style.left = P / s + "px";
      }
      h.overlap !== !0 && o.push({ left: k, top: S, right: A, bottom: S + g }), c.classList.toggle("cm-tooltip-above", x), c.classList.toggle("cm-tooltip-below", !x), h.positioned && h.positioned(n.space);
    }
  }
  maybeMeasure() {
    if (this.manager.tooltips.length && (this.view.inView && this.view.requestMeasure(this.measureReq), this.inView != this.view.inView && (this.inView = this.view.inView, !this.inView)))
      for (let n of this.manager.tooltipViews)
        n.dom.style.top = $n;
  }
}, {
  eventObservers: {
    scroll() {
      this.maybeMeasure();
    }
  }
}), Ey = /* @__PURE__ */ O.baseTheme({
  ".cm-tooltip": {
    zIndex: 100,
    boxSizing: "border-box"
  },
  "&light .cm-tooltip": {
    border: "1px solid #bbb",
    backgroundColor: "#f5f5f5"
  },
  "&light .cm-tooltip-section:not(:first-child)": {
    borderTop: "1px solid #bbb"
  },
  "&dark .cm-tooltip": {
    backgroundColor: "#333338",
    color: "white"
  },
  ".cm-tooltip-arrow": {
    height: "7px",
    width: `${7 * 2}px`,
    position: "absolute",
    zIndex: -1,
    overflow: "hidden",
    "&:before, &:after": {
      content: "''",
      position: "absolute",
      width: 0,
      height: 0,
      borderLeft: "7px solid transparent",
      borderRight: "7px solid transparent"
    },
    ".cm-tooltip-above &": {
      bottom: "-7px",
      "&:before": {
        borderTop: "7px solid #bbb"
      },
      "&:after": {
        borderTop: "7px solid #f5f5f5",
        bottom: "1px"
      }
    },
    ".cm-tooltip-below &": {
      top: "-7px",
      "&:before": {
        borderBottom: "7px solid #bbb"
      },
      "&:after": {
        borderBottom: "7px solid #f5f5f5",
        top: "1px"
      }
    }
  },
  "&dark .cm-tooltip .cm-tooltip-arrow": {
    "&:before": {
      borderTopColor: "#333338",
      borderBottomColor: "#333338"
    },
    "&:after": {
      borderTopColor: "transparent",
      borderBottomColor: "transparent"
    }
  }
}), Ly = { x: 0, y: 0 }, ih = /* @__PURE__ */ I.define({
  enables: [th, Ey]
}), io = /* @__PURE__ */ I.define({
  combine: (n) => n.reduce((e, t) => e.concat(t), [])
});
class To {
  // Needs to be static so that host tooltip instances always match
  static create(e) {
    return new To(e);
  }
  constructor(e) {
    this.view = e, this.mounted = !1, this.dom = document.createElement("div"), this.dom.classList.add("cm-tooltip-hover"), this.manager = new Gm(e, io, (t, i) => this.createHostedView(t, i), (t) => t.dom.remove());
  }
  createHostedView(e, t) {
    let i = e.create(this.view);
    return i.dom.classList.add("cm-tooltip-section"), this.dom.insertBefore(i.dom, t ? t.dom.nextSibling : this.dom.firstChild), this.mounted && i.mount && i.mount(this.view), i;
  }
  mount(e) {
    for (let t of this.manager.tooltipViews)
      t.mount && t.mount(e);
    this.mounted = !0;
  }
  positioned(e) {
    for (let t of this.manager.tooltipViews)
      t.positioned && t.positioned(e);
  }
  update(e) {
    this.manager.update(e);
  }
  destroy() {
    var e;
    for (let t of this.manager.tooltipViews)
      (e = t.destroy) === null || e === void 0 || e.call(t);
  }
  passProp(e) {
    let t;
    for (let i of this.manager.tooltipViews) {
      let s = i[e];
      if (s !== void 0) {
        if (t === void 0)
          t = s;
        else if (t !== s)
          return;
      }
    }
    return t;
  }
  get offset() {
    return this.passProp("offset");
  }
  get getCoords() {
    return this.passProp("getCoords");
  }
  get overlap() {
    return this.passProp("overlap");
  }
  get resize() {
    return this.passProp("resize");
  }
}
const Ry = /* @__PURE__ */ ih.compute([io], (n) => {
  let e = n.facet(io);
  return e.length === 0 ? null : {
    pos: Math.min(...e.map((t) => t.pos)),
    end: Math.max(...e.map((t) => {
      var i;
      return (i = t.end) !== null && i !== void 0 ? i : t.pos;
    })),
    create: To.create,
    above: e[0].above,
    arrow: e.some((t) => t.arrow)
  };
});
class Py {
  constructor(e, t, i, s, r) {
    this.view = e, this.source = t, this.field = i, this.setHover = s, this.hoverTime = r, this.hoverTimeout = -1, this.restartTimeout = -1, this.pending = null, this.lastMove = { x: 0, y: 0, target: e.dom, time: 0 }, this.checkHover = this.checkHover.bind(this), e.dom.addEventListener("mouseleave", this.mouseleave = this.mouseleave.bind(this)), e.dom.addEventListener("mousemove", this.mousemove = this.mousemove.bind(this));
  }
  update() {
    this.pending && (this.pending = null, clearTimeout(this.restartTimeout), this.restartTimeout = setTimeout(() => this.startHover(), 20));
  }
  get active() {
    return this.view.state.field(this.field);
  }
  checkHover() {
    if (this.hoverTimeout = -1, this.active.length)
      return;
    let e = Date.now() - this.lastMove.time;
    e < this.hoverTime ? this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime - e) : this.startHover();
  }
  startHover() {
    clearTimeout(this.restartTimeout);
    let { view: e, lastMove: t } = this, i = e.docView.nearest(t.target);
    if (!i)
      return;
    let s, r = 1;
    if (i instanceof _i)
      s = i.posAtStart;
    else {
      if (s = e.posAtCoords(t), s == null)
        return;
      let l = e.coordsAtPos(s);
      if (!l || t.y < l.top || t.y > l.bottom || t.x < l.left - e.defaultCharacterWidth || t.x > l.right + e.defaultCharacterWidth)
        return;
      let a = e.bidiSpans(e.state.doc.lineAt(s)).find((c) => c.from <= s && c.to >= s), h = a && a.dir == de.RTL ? -1 : 1;
      r = t.x < l.left ? -h : h;
    }
    let o = this.source(e, s, r);
    if (o != null && o.then) {
      let l = this.pending = { pos: s };
      o.then((a) => {
        this.pending == l && (this.pending = null, a && !(Array.isArray(a) && !a.length) && e.dispatch({ effects: this.setHover.of(Array.isArray(a) ? a : [a]) }));
      }, (a) => Je(e.state, a, "hover tooltip"));
    } else o && !(Array.isArray(o) && !o.length) && e.dispatch({ effects: this.setHover.of(Array.isArray(o) ? o : [o]) });
  }
  get tooltip() {
    let e = this.view.plugin(th), t = e ? e.manager.tooltips.findIndex((i) => i.create == To.create) : -1;
    return t > -1 ? e.manager.tooltipViews[t] : null;
  }
  mousemove(e) {
    var t, i;
    this.lastMove = { x: e.clientX, y: e.clientY, target: e.target, time: Date.now() }, this.hoverTimeout < 0 && (this.hoverTimeout = setTimeout(this.checkHover, this.hoverTime));
    let { active: s, tooltip: r } = this;
    if (s.length && r && !By(r.dom, e) || this.pending) {
      let { pos: o } = s[0] || this.pending, l = (i = (t = s[0]) === null || t === void 0 ? void 0 : t.end) !== null && i !== void 0 ? i : o;
      (o == l ? this.view.posAtCoords(this.lastMove) != o : !Iy(this.view, o, l, e.clientX, e.clientY)) && (this.view.dispatch({ effects: this.setHover.of([]) }), this.pending = null);
    }
  }
  mouseleave(e) {
    clearTimeout(this.hoverTimeout), this.hoverTimeout = -1;
    let { active: t } = this;
    if (t.length) {
      let { tooltip: i } = this;
      i && i.dom.contains(e.relatedTarget) ? this.watchTooltipLeave(i.dom) : this.view.dispatch({ effects: this.setHover.of([]) });
    }
  }
  watchTooltipLeave(e) {
    let t = (i) => {
      e.removeEventListener("mouseleave", t), this.active.length && !this.view.dom.contains(i.relatedTarget) && this.view.dispatch({ effects: this.setHover.of([]) });
    };
    e.addEventListener("mouseleave", t);
  }
  destroy() {
    clearTimeout(this.hoverTimeout), this.view.dom.removeEventListener("mouseleave", this.mouseleave), this.view.dom.removeEventListener("mousemove", this.mousemove);
  }
}
const gr = 4;
function By(n, e) {
  let t = n.getBoundingClientRect();
  return e.clientX >= t.left - gr && e.clientX <= t.right + gr && e.clientY >= t.top - gr && e.clientY <= t.bottom + gr;
}
function Iy(n, e, t, i, s, r) {
  let o = n.scrollDOM.getBoundingClientRect(), l = n.documentTop + n.documentPadding.top + n.contentHeight;
  if (o.left > i || o.right < i || o.top > s || Math.min(o.bottom, l) < s)
    return !1;
  let a = n.posAtCoords({ x: i, y: s }, !1);
  return a >= e && a <= t;
}
function Ny(n, e = {}) {
  let t = K.define(), i = ke.define({
    create() {
      return [];
    },
    update(s, r) {
      if (s.length && (e.hideOnChange && (r.docChanged || r.selection) ? s = [] : e.hideOn && (s = s.filter((o) => !e.hideOn(r, o))), r.docChanged)) {
        let o = [];
        for (let l of s) {
          let a = r.changes.mapPos(l.pos, -1, Ee.TrackDel);
          if (a != null) {
            let h = Object.assign(/* @__PURE__ */ Object.create(null), l);
            h.pos = a, h.end != null && (h.end = r.changes.mapPos(h.end)), o.push(h);
          }
        }
        s = o;
      }
      for (let o of r.effects)
        o.is(t) && (s = o.value), o.is(Fy) && (s = []);
      return s;
    },
    provide: (s) => io.from(s)
  });
  return {
    active: i,
    extension: [
      i,
      be.define((s) => new Py(
        s,
        n,
        i,
        t,
        e.hoverTime || 300
        /* Hover.Time */
      )),
      Ry
    ]
  };
}
function Ym(n, e) {
  let t = n.plugin(th);
  if (!t)
    return null;
  let i = t.manager.tooltips.indexOf(e);
  return i < 0 ? null : t.manager.tooltipViews[i];
}
const Fy = /* @__PURE__ */ K.define(), sf = /* @__PURE__ */ I.define({
  combine(n) {
    let e, t;
    for (let i of n)
      e = e || i.topContainer, t = t || i.bottomContainer;
    return { topContainer: e, bottomContainer: t };
  }
});
function Rs(n, e) {
  let t = n.plugin(Xm), i = t ? t.specs.indexOf(e) : -1;
  return i > -1 ? t.panels[i] : null;
}
const Xm = /* @__PURE__ */ be.fromClass(class {
  constructor(n) {
    this.input = n.state.facet(Ps), this.specs = this.input.filter((t) => t), this.panels = this.specs.map((t) => t(n));
    let e = n.state.facet(sf);
    this.top = new br(n, !0, e.topContainer), this.bottom = new br(n, !1, e.bottomContainer), this.top.sync(this.panels.filter((t) => t.top)), this.bottom.sync(this.panels.filter((t) => !t.top));
    for (let t of this.panels)
      t.dom.classList.add("cm-panel"), t.mount && t.mount();
  }
  update(n) {
    let e = n.state.facet(sf);
    this.top.container != e.topContainer && (this.top.sync([]), this.top = new br(n.view, !0, e.topContainer)), this.bottom.container != e.bottomContainer && (this.bottom.sync([]), this.bottom = new br(n.view, !1, e.bottomContainer)), this.top.syncClasses(), this.bottom.syncClasses();
    let t = n.state.facet(Ps);
    if (t != this.input) {
      let i = t.filter((a) => a), s = [], r = [], o = [], l = [];
      for (let a of i) {
        let h = this.specs.indexOf(a), c;
        h < 0 ? (c = a(n.view), l.push(c)) : (c = this.panels[h], c.update && c.update(n)), s.push(c), (c.top ? r : o).push(c);
      }
      this.specs = i, this.panels = s, this.top.sync(r), this.bottom.sync(o);
      for (let a of l)
        a.dom.classList.add("cm-panel"), a.mount && a.mount();
    } else
      for (let i of this.panels)
        i.update && i.update(n);
  }
  destroy() {
    this.top.sync([]), this.bottom.sync([]);
  }
}, {
  provide: (n) => O.scrollMargins.of((e) => {
    let t = e.plugin(n);
    return t && { top: t.top.scrollMargin(), bottom: t.bottom.scrollMargin() };
  })
});
class br {
  constructor(e, t, i) {
    this.view = e, this.top = t, this.container = i, this.dom = void 0, this.classes = "", this.panels = [], this.syncClasses();
  }
  sync(e) {
    for (let t of this.panels)
      t.destroy && e.indexOf(t) < 0 && t.destroy();
    this.panels = e, this.syncDOM();
  }
  syncDOM() {
    if (this.panels.length == 0) {
      this.dom && (this.dom.remove(), this.dom = void 0);
      return;
    }
    if (!this.dom) {
      this.dom = document.createElement("div"), this.dom.className = this.top ? "cm-panels cm-panels-top" : "cm-panels cm-panels-bottom", this.dom.style[this.top ? "top" : "bottom"] = "0";
      let t = this.container || this.view.dom;
      t.insertBefore(this.dom, this.top ? t.firstChild : null);
    }
    let e = this.dom.firstChild;
    for (let t of this.panels)
      if (t.dom.parentNode == this.dom) {
        for (; e != t.dom; )
          e = rf(e);
        e = e.nextSibling;
      } else
        this.dom.insertBefore(t.dom, e);
    for (; e; )
      e = rf(e);
  }
  scrollMargin() {
    return !this.dom || this.container ? 0 : Math.max(0, this.top ? this.dom.getBoundingClientRect().bottom - Math.max(0, this.view.scrollDOM.getBoundingClientRect().top) : Math.min(innerHeight, this.view.scrollDOM.getBoundingClientRect().bottom) - this.dom.getBoundingClientRect().top);
  }
  syncClasses() {
    if (!(!this.container || this.classes == this.view.themeClasses)) {
      for (let e of this.classes.split(" "))
        e && this.container.classList.remove(e);
      for (let e of (this.classes = this.view.themeClasses).split(" "))
        e && this.container.classList.add(e);
    }
  }
}
function rf(n) {
  let e = n.nextSibling;
  return n.remove(), e;
}
const Ps = /* @__PURE__ */ I.define({
  enables: Xm
});
class Et extends Xi {
  /**
  @internal
  */
  compare(e) {
    return this == e || this.constructor == e.constructor && this.eq(e);
  }
  /**
  Compare this marker to another marker of the same type.
  */
  eq(e) {
    return !1;
  }
  /**
  Called if the marker has a `toDOM` method and its representation
  was removed from a gutter.
  */
  destroy(e) {
  }
}
Et.prototype.elementClass = "";
Et.prototype.toDOM = void 0;
Et.prototype.mapMode = Ee.TrackBefore;
Et.prototype.startSide = Et.prototype.endSide = -1;
Et.prototype.point = !0;
const Ur = /* @__PURE__ */ I.define(), Hy = {
  class: "",
  renderEmptyElements: !1,
  elementStyle: "",
  markers: () => ne.empty,
  lineMarker: () => null,
  widgetMarker: () => null,
  lineMarkerChange: null,
  initialSpacer: null,
  updateSpacer: null,
  domEventHandlers: {}
}, xs = /* @__PURE__ */ I.define();
function Jm(n) {
  return [Qm(), xs.of(Object.assign(Object.assign({}, Hy), n))];
}
const of = /* @__PURE__ */ I.define({
  combine: (n) => n.some((e) => e)
});
function Qm(n) {
  return [
    Vy
  ];
}
const Vy = /* @__PURE__ */ be.fromClass(class {
  constructor(n) {
    this.view = n, this.prevViewport = n.viewport, this.dom = document.createElement("div"), this.dom.className = "cm-gutters", this.dom.setAttribute("aria-hidden", "true"), this.dom.style.minHeight = this.view.contentHeight / this.view.scaleY + "px", this.gutters = n.state.facet(xs).map((e) => new af(n, e));
    for (let e of this.gutters)
      this.dom.appendChild(e.dom);
    this.fixed = !n.state.facet(of), this.fixed && (this.dom.style.position = "sticky"), this.syncGutters(!1), n.scrollDOM.insertBefore(this.dom, n.contentDOM);
  }
  update(n) {
    if (this.updateGutters(n)) {
      let e = this.prevViewport, t = n.view.viewport, i = Math.min(e.to, t.to) - Math.max(e.from, t.from);
      this.syncGutters(i < (t.to - t.from) * 0.8);
    }
    n.geometryChanged && (this.dom.style.minHeight = this.view.contentHeight / this.view.scaleY + "px"), this.view.state.facet(of) != !this.fixed && (this.fixed = !this.fixed, this.dom.style.position = this.fixed ? "sticky" : ""), this.prevViewport = n.view.viewport;
  }
  syncGutters(n) {
    let e = this.dom.nextSibling;
    n && this.dom.remove();
    let t = ne.iter(this.view.state.facet(Ur), this.view.viewport.from), i = [], s = this.gutters.map((r) => new Wy(r, this.view.viewport, -this.view.documentPadding.top));
    for (let r of this.view.viewportLineBlocks)
      if (i.length && (i = []), Array.isArray(r.type)) {
        let o = !0;
        for (let l of r.type)
          if (l.type == ze.Text && o) {
            ka(t, i, l.from);
            for (let a of s)
              a.line(this.view, l, i);
            o = !1;
          } else if (l.widget)
            for (let a of s)
              a.widget(this.view, l);
      } else if (r.type == ze.Text) {
        ka(t, i, r.from);
        for (let o of s)
          o.line(this.view, r, i);
      } else if (r.widget)
        for (let o of s)
          o.widget(this.view, r);
    for (let r of s)
      r.finish();
    n && this.view.scrollDOM.insertBefore(this.dom, e);
  }
  updateGutters(n) {
    let e = n.startState.facet(xs), t = n.state.facet(xs), i = n.docChanged || n.heightChanged || n.viewportChanged || !ne.eq(n.startState.facet(Ur), n.state.facet(Ur), n.view.viewport.from, n.view.viewport.to);
    if (e == t)
      for (let s of this.gutters)
        s.update(n) && (i = !0);
    else {
      i = !0;
      let s = [];
      for (let r of t) {
        let o = e.indexOf(r);
        o < 0 ? s.push(new af(this.view, r)) : (this.gutters[o].update(n), s.push(this.gutters[o]));
      }
      for (let r of this.gutters)
        r.dom.remove(), s.indexOf(r) < 0 && r.destroy();
      for (let r of s)
        this.dom.appendChild(r.dom);
      this.gutters = s;
    }
    return i;
  }
  destroy() {
    for (let n of this.gutters)
      n.destroy();
    this.dom.remove();
  }
}, {
  provide: (n) => O.scrollMargins.of((e) => {
    let t = e.plugin(n);
    return !t || t.gutters.length == 0 || !t.fixed ? null : e.textDirection == de.LTR ? { left: t.dom.offsetWidth * e.scaleX } : { right: t.dom.offsetWidth * e.scaleX };
  })
});
function lf(n) {
  return Array.isArray(n) ? n : [n];
}
function ka(n, e, t) {
  for (; n.value && n.from <= t; )
    n.from == t && e.push(n.value), n.next();
}
class Wy {
  constructor(e, t, i) {
    this.gutter = e, this.height = i, this.i = 0, this.cursor = ne.iter(e.markers, t.from);
  }
  addElement(e, t, i) {
    let { gutter: s } = this, r = (t.top - this.height) / e.scaleY, o = t.height / e.scaleY;
    if (this.i == s.elements.length) {
      let l = new Zm(e, o, r, i);
      s.elements.push(l), s.dom.appendChild(l.dom);
    } else
      s.elements[this.i].update(e, o, r, i);
    this.height = t.bottom, this.i++;
  }
  line(e, t, i) {
    let s = [];
    ka(this.cursor, s, t.from), i.length && (s = s.concat(i));
    let r = this.gutter.config.lineMarker(e, t, s);
    r && s.unshift(r);
    let o = this.gutter;
    s.length == 0 && !o.config.renderEmptyElements || this.addElement(e, t, s);
  }
  widget(e, t) {
    let i = this.gutter.config.widgetMarker(e, t.widget, t);
    i && this.addElement(e, t, [i]);
  }
  finish() {
    let e = this.gutter;
    for (; e.elements.length > this.i; ) {
      let t = e.elements.pop();
      e.dom.removeChild(t.dom), t.destroy();
    }
  }
}
class af {
  constructor(e, t) {
    this.view = e, this.config = t, this.elements = [], this.spacer = null, this.dom = document.createElement("div"), this.dom.className = "cm-gutter" + (this.config.class ? " " + this.config.class : "");
    for (let i in t.domEventHandlers)
      this.dom.addEventListener(i, (s) => {
        let r = s.target, o;
        if (r != this.dom && this.dom.contains(r)) {
          for (; r.parentNode != this.dom; )
            r = r.parentNode;
          let a = r.getBoundingClientRect();
          o = (a.top + a.bottom) / 2;
        } else
          o = s.clientY;
        let l = e.lineBlockAtHeight(o - e.documentTop);
        t.domEventHandlers[i](e, l, s) && s.preventDefault();
      });
    this.markers = lf(t.markers(e)), t.initialSpacer && (this.spacer = new Zm(e, 0, 0, [t.initialSpacer(e)]), this.dom.appendChild(this.spacer.dom), this.spacer.dom.style.cssText += "visibility: hidden; pointer-events: none");
  }
  update(e) {
    let t = this.markers;
    if (this.markers = lf(this.config.markers(e.view)), this.spacer && this.config.updateSpacer) {
      let s = this.config.updateSpacer(this.spacer.markers[0], e);
      s != this.spacer.markers[0] && this.spacer.update(e.view, 0, 0, [s]);
    }
    let i = e.view.viewport;
    return !ne.eq(this.markers, t, i.from, i.to) || (this.config.lineMarkerChange ? this.config.lineMarkerChange(e) : !1);
  }
  destroy() {
    for (let e of this.elements)
      e.destroy();
  }
}
class Zm {
  constructor(e, t, i, s) {
    this.height = -1, this.above = 0, this.markers = [], this.dom = document.createElement("div"), this.dom.className = "cm-gutterElement", this.update(e, t, i, s);
  }
  update(e, t, i, s) {
    this.height != t && (this.height = t, this.dom.style.height = t + "px"), this.above != i && (this.dom.style.marginTop = (this.above = i) ? i + "px" : ""), zy(this.markers, s) || this.setMarkers(e, s);
  }
  setMarkers(e, t) {
    let i = "cm-gutterElement", s = this.dom.firstChild;
    for (let r = 0, o = 0; ; ) {
      let l = o, a = r < t.length ? t[r++] : null, h = !1;
      if (a) {
        let c = a.elementClass;
        c && (i += " " + c);
        for (let f = o; f < this.markers.length; f++)
          if (this.markers[f].compare(a)) {
            l = f, h = !0;
            break;
          }
      } else
        l = this.markers.length;
      for (; o < l; ) {
        let c = this.markers[o++];
        if (c.toDOM) {
          c.destroy(s);
          let f = s.nextSibling;
          s.remove(), s = f;
        }
      }
      if (!a)
        break;
      a.toDOM && (h ? s = s.nextSibling : this.dom.insertBefore(a.toDOM(e), s)), h && o++;
    }
    this.dom.className = i, this.markers = t;
  }
  destroy() {
    this.setMarkers(null, []);
  }
}
function zy(n, e) {
  if (n.length != e.length)
    return !1;
  for (let t = 0; t < n.length; t++)
    if (!n[t].compare(e[t]))
      return !1;
  return !0;
}
const qy = /* @__PURE__ */ I.define(), wn = /* @__PURE__ */ I.define({
  combine(n) {
    return ti(n, { formatNumber: String, domEventHandlers: {} }, {
      domEventHandlers(e, t) {
        let i = Object.assign({}, e);
        for (let s in t) {
          let r = i[s], o = t[s];
          i[s] = r ? (l, a, h) => r(l, a, h) || o(l, a, h) : o;
        }
        return i;
      }
    });
  }
});
class tl extends Et {
  constructor(e) {
    super(), this.number = e;
  }
  eq(e) {
    return this.number == e.number;
  }
  toDOM() {
    return document.createTextNode(this.number);
  }
}
function il(n, e) {
  return n.state.facet(wn).formatNumber(e, n.state);
}
const Uy = /* @__PURE__ */ xs.compute([wn], (n) => ({
  class: "cm-lineNumbers",
  renderEmptyElements: !1,
  markers(e) {
    return e.state.facet(qy);
  },
  lineMarker(e, t, i) {
    return i.some((s) => s.toDOM) ? null : new tl(il(e, e.state.doc.lineAt(t.from).number));
  },
  widgetMarker: () => null,
  lineMarkerChange: (e) => e.startState.facet(wn) != e.state.facet(wn),
  initialSpacer(e) {
    return new tl(il(e, hf(e.state.doc.lines)));
  },
  updateSpacer(e, t) {
    let i = il(t.view, hf(t.view.state.doc.lines));
    return i == e.number ? e : new tl(i);
  },
  domEventHandlers: n.facet(wn).domEventHandlers
}));
function $m(n = {}) {
  return [
    wn.of(n),
    Qm(),
    Uy
  ];
}
function hf(n) {
  let e = 9;
  for (; e < n; )
    e = e * 10 + 9;
  return e;
}
const jy = /* @__PURE__ */ new class extends Et {
  constructor() {
    super(...arguments), this.elementClass = "cm-activeLineGutter";
  }
}(), Ky = /* @__PURE__ */ Ur.compute(["selection"], (n) => {
  let e = [], t = -1;
  for (let i of n.selection.ranges) {
    let s = n.doc.lineAt(i.head).from;
    s > t && (t = s, e.push(jy.range(s)));
  }
  return ne.of(e);
});
function Gy() {
  return Ky;
}
const Yy = 1024;
let Xy = 0;
class at {
  constructor(e, t) {
    this.from = e, this.to = t;
  }
}
class $ {
  /**
  Create a new node prop type.
  */
  constructor(e = {}) {
    this.id = Xy++, this.perNode = !!e.perNode, this.deserialize = e.deserialize || (() => {
      throw new Error("This node type doesn't define a deserialize function");
    });
  }
  /**
  This is meant to be used with
  [`NodeSet.extend`](#common.NodeSet.extend) or
  [`LRParser.configure`](#lr.ParserConfig.props) to compute
  prop values for each node type in the set. Takes a [match
  object](#common.NodeType^match) or function that returns undefined
  if the node type doesn't get this prop, and the prop's value if
  it does.
  */
  add(e) {
    if (this.perNode)
      throw new RangeError("Can't add per-node props to node types");
    return typeof e != "function" && (e = Ue.match(e)), (t) => {
      let i = e(t);
      return i === void 0 ? null : [this, i];
    };
  }
}
$.closedBy = new $({ deserialize: (n) => n.split(" ") });
$.openedBy = new $({ deserialize: (n) => n.split(" ") });
$.group = new $({ deserialize: (n) => n.split(" ") });
$.isolate = new $({ deserialize: (n) => {
  if (n && n != "rtl" && n != "ltr" && n != "auto")
    throw new RangeError("Invalid value for isolate: " + n);
  return n || "auto";
} });
$.contextHash = new $({ perNode: !0 });
$.lookAhead = new $({ perNode: !0 });
$.mounted = new $({ perNode: !0 });
class Bs {
  constructor(e, t, i) {
    this.tree = e, this.overlay = t, this.parser = i;
  }
  /**
  @internal
  */
  static get(e) {
    return e && e.props && e.props[$.mounted.id];
  }
}
const Jy = /* @__PURE__ */ Object.create(null);
class Ue {
  /**
  @internal
  */
  constructor(e, t, i, s = 0) {
    this.name = e, this.props = t, this.id = i, this.flags = s;
  }
  /**
  Define a node type.
  */
  static define(e) {
    let t = e.props && e.props.length ? /* @__PURE__ */ Object.create(null) : Jy, i = (e.top ? 1 : 0) | (e.skipped ? 2 : 0) | (e.error ? 4 : 0) | (e.name == null ? 8 : 0), s = new Ue(e.name || "", t, e.id, i);
    if (e.props) {
      for (let r of e.props)
        if (Array.isArray(r) || (r = r(s)), r) {
          if (r[0].perNode)
            throw new RangeError("Can't store a per-node prop on a node type");
          t[r[0].id] = r[1];
        }
    }
    return s;
  }
  /**
  Retrieves a node prop for this type. Will return `undefined` if
  the prop isn't present on this node.
  */
  prop(e) {
    return this.props[e.id];
  }
  /**
  True when this is the top node of a grammar.
  */
  get isTop() {
    return (this.flags & 1) > 0;
  }
  /**
  True when this node is produced by a skip rule.
  */
  get isSkipped() {
    return (this.flags & 2) > 0;
  }
  /**
  Indicates whether this is an error node.
  */
  get isError() {
    return (this.flags & 4) > 0;
  }
  /**
  When true, this node type doesn't correspond to a user-declared
  named node, for example because it is used to cache repetition.
  */
  get isAnonymous() {
    return (this.flags & 8) > 0;
  }
  /**
  Returns true when this node's name or one of its
  [groups](#common.NodeProp^group) matches the given string.
  */
  is(e) {
    if (typeof e == "string") {
      if (this.name == e)
        return !0;
      let t = this.prop($.group);
      return t ? t.indexOf(e) > -1 : !1;
    }
    return this.id == e;
  }
  /**
  Create a function from node types to arbitrary values by
  specifying an object whose property names are node or
  [group](#common.NodeProp^group) names. Often useful with
  [`NodeProp.add`](#common.NodeProp.add). You can put multiple
  names, separated by spaces, in a single property name to map
  multiple node names to a single value.
  */
  static match(e) {
    let t = /* @__PURE__ */ Object.create(null);
    for (let i in e)
      for (let s of i.split(" "))
        t[s] = e[i];
    return (i) => {
      for (let s = i.prop($.group), r = -1; r < (s ? s.length : 0); r++) {
        let o = t[r < 0 ? i.name : s[r]];
        if (o)
          return o;
      }
    };
  }
}
Ue.none = new Ue(
  "",
  /* @__PURE__ */ Object.create(null),
  0,
  8
  /* NodeFlag.Anonymous */
);
class nh {
  /**
  Create a set with the given types. The `id` property of each
  type should correspond to its position within the array.
  */
  constructor(e) {
    this.types = e;
    for (let t = 0; t < e.length; t++)
      if (e[t].id != t)
        throw new RangeError("Node type ids should correspond to array positions when creating a node set");
  }
  /**
  Create a copy of this set with some node properties added. The
  arguments to this method can be created with
  [`NodeProp.add`](#common.NodeProp.add).
  */
  extend(...e) {
    let t = [];
    for (let i of this.types) {
      let s = null;
      for (let r of e) {
        let o = r(i);
        o && (s || (s = Object.assign({}, i.props)), s[o[0].id] = o[1]);
      }
      t.push(s ? new Ue(i.name, s, i.id, i.flags) : i);
    }
    return new nh(t);
  }
}
const yr = /* @__PURE__ */ new WeakMap(), cf = /* @__PURE__ */ new WeakMap();
var pe;
(function(n) {
  n[n.ExcludeBuffers = 1] = "ExcludeBuffers", n[n.IncludeAnonymous = 2] = "IncludeAnonymous", n[n.IgnoreMounts = 4] = "IgnoreMounts", n[n.IgnoreOverlays = 8] = "IgnoreOverlays";
})(pe || (pe = {}));
class fe {
  /**
  Construct a new tree. See also [`Tree.build`](#common.Tree^build).
  */
  constructor(e, t, i, s, r) {
    if (this.type = e, this.children = t, this.positions = i, this.length = s, this.props = null, r && r.length) {
      this.props = /* @__PURE__ */ Object.create(null);
      for (let [o, l] of r)
        this.props[typeof o == "number" ? o : o.id] = l;
    }
  }
  /**
  @internal
  */
  toString() {
    let e = Bs.get(this);
    if (e && !e.overlay)
      return e.tree.toString();
    let t = "";
    for (let i of this.children) {
      let s = i.toString();
      s && (t && (t += ","), t += s);
    }
    return this.type.name ? (/\W/.test(this.type.name) && !this.type.isError ? JSON.stringify(this.type.name) : this.type.name) + (t.length ? "(" + t + ")" : "") : t;
  }
  /**
  Get a [tree cursor](#common.TreeCursor) positioned at the top of
  the tree. Mode can be used to [control](#common.IterMode) which
  nodes the cursor visits.
  */
  cursor(e = 0) {
    return new no(this.topNode, e);
  }
  /**
  Get a [tree cursor](#common.TreeCursor) pointing into this tree
  at the given position and side (see
  [`moveTo`](#common.TreeCursor.moveTo).
  */
  cursorAt(e, t = 0, i = 0) {
    let s = yr.get(this) || this.topNode, r = new no(s);
    return r.moveTo(e, t), yr.set(this, r._tree), r;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) object for the top of the
  tree.
  */
  get topNode() {
    return new Ne(this, 0, 0, null);
  }
  /**
  Get the [syntax node](#common.SyntaxNode) at the given position.
  If `side` is -1, this will move into nodes that end at the
  position. If 1, it'll move into nodes that start at the
  position. With 0, it'll only enter nodes that cover the position
  from both sides.
  
  Note that this will not enter
  [overlays](#common.MountedTree.overlay), and you often want
  [`resolveInner`](#common.Tree.resolveInner) instead.
  */
  resolve(e, t = 0) {
    let i = Is(yr.get(this) || this.topNode, e, t, !1);
    return yr.set(this, i), i;
  }
  /**
  Like [`resolve`](#common.Tree.resolve), but will enter
  [overlaid](#common.MountedTree.overlay) nodes, producing a syntax node
  pointing into the innermost overlaid tree at the given position
  (with parent links going through all parent structure, including
  the host trees).
  */
  resolveInner(e, t = 0) {
    let i = Is(cf.get(this) || this.topNode, e, t, !0);
    return cf.set(this, i), i;
  }
  /**
  In some situations, it can be useful to iterate through all
  nodes around a position, including those in overlays that don't
  directly cover the position. This method gives you an iterator
  that will produce all nodes, from small to big, around the given
  position.
  */
  resolveStack(e, t = 0) {
    return $y(this, e, t);
  }
  /**
  Iterate over the tree and its children, calling `enter` for any
  node that touches the `from`/`to` region (if given) before
  running over such a node's children, and `leave` (if given) when
  leaving the node. When `enter` returns `false`, that node will
  not have its children iterated over (or `leave` called).
  */
  iterate(e) {
    let { enter: t, leave: i, from: s = 0, to: r = this.length } = e, o = e.mode || 0, l = (o & pe.IncludeAnonymous) > 0;
    for (let a = this.cursor(o | pe.IncludeAnonymous); ; ) {
      let h = !1;
      if (a.from <= r && a.to >= s && (!l && a.type.isAnonymous || t(a) !== !1)) {
        if (a.firstChild())
          continue;
        h = !0;
      }
      for (; h && i && (l || !a.type.isAnonymous) && i(a), !a.nextSibling(); ) {
        if (!a.parent())
          return;
        h = !0;
      }
    }
  }
  /**
  Get the value of the given [node prop](#common.NodeProp) for this
  node. Works with both per-node and per-type props.
  */
  prop(e) {
    return e.perNode ? this.props ? this.props[e.id] : void 0 : this.type.prop(e);
  }
  /**
  Returns the node's [per-node props](#common.NodeProp.perNode) in a
  format that can be passed to the [`Tree`](#common.Tree)
  constructor.
  */
  get propValues() {
    let e = [];
    if (this.props)
      for (let t in this.props)
        e.push([+t, this.props[t]]);
    return e;
  }
  /**
  Balance the direct children of this tree, producing a copy of
  which may have children grouped into subtrees with type
  [`NodeType.none`](#common.NodeType^none).
  */
  balance(e = {}) {
    return this.children.length <= 8 ? this : oh(Ue.none, this.children, this.positions, 0, this.children.length, 0, this.length, (t, i, s) => new fe(this.type, t, i, s, this.propValues), e.makeTree || ((t, i, s) => new fe(Ue.none, t, i, s)));
  }
  /**
  Build a tree from a postfix-ordered buffer of node information,
  or a cursor over such a buffer.
  */
  static build(e) {
    return ew(e);
  }
}
fe.empty = new fe(Ue.none, [], [], 0);
class sh {
  constructor(e, t) {
    this.buffer = e, this.index = t;
  }
  get id() {
    return this.buffer[this.index - 4];
  }
  get start() {
    return this.buffer[this.index - 3];
  }
  get end() {
    return this.buffer[this.index - 2];
  }
  get size() {
    return this.buffer[this.index - 1];
  }
  get pos() {
    return this.index;
  }
  next() {
    this.index -= 4;
  }
  fork() {
    return new sh(this.buffer, this.index);
  }
}
class Li {
  /**
  Create a tree buffer.
  */
  constructor(e, t, i) {
    this.buffer = e, this.length = t, this.set = i;
  }
  /**
  @internal
  */
  get type() {
    return Ue.none;
  }
  /**
  @internal
  */
  toString() {
    let e = [];
    for (let t = 0; t < this.buffer.length; )
      e.push(this.childString(t)), t = this.buffer[t + 3];
    return e.join(",");
  }
  /**
  @internal
  */
  childString(e) {
    let t = this.buffer[e], i = this.buffer[e + 3], s = this.set.types[t], r = s.name;
    if (/\W/.test(r) && !s.isError && (r = JSON.stringify(r)), e += 4, i == e)
      return r;
    let o = [];
    for (; e < i; )
      o.push(this.childString(e)), e = this.buffer[e + 3];
    return r + "(" + o.join(",") + ")";
  }
  /**
  @internal
  */
  findChild(e, t, i, s, r) {
    let { buffer: o } = this, l = -1;
    for (let a = e; a != t && !(ep(r, s, o[a + 1], o[a + 2]) && (l = a, i > 0)); a = o[a + 3])
      ;
    return l;
  }
  /**
  @internal
  */
  slice(e, t, i) {
    let s = this.buffer, r = new Uint16Array(t - e), o = 0;
    for (let l = e, a = 0; l < t; ) {
      r[a++] = s[l++], r[a++] = s[l++] - i;
      let h = r[a++] = s[l++] - i;
      r[a++] = s[l++] - e, o = Math.max(o, h);
    }
    return new Li(r, o, this.set);
  }
}
function ep(n, e, t, i) {
  switch (n) {
    case -2:
      return t < e;
    case -1:
      return i >= e && t < e;
    case 0:
      return t < e && i > e;
    case 1:
      return t <= e && i > e;
    case 2:
      return i > e;
    case 4:
      return !0;
  }
}
function Is(n, e, t, i) {
  for (var s; n.from == n.to || (t < 1 ? n.from >= e : n.from > e) || (t > -1 ? n.to <= e : n.to < e); ) {
    let o = !i && n instanceof Ne && n.index < 0 ? null : n.parent;
    if (!o)
      return n;
    n = o;
  }
  let r = i ? 0 : pe.IgnoreOverlays;
  if (i)
    for (let o = n, l = o.parent; l; o = l, l = o.parent)
      o instanceof Ne && o.index < 0 && ((s = l.enter(e, t, r)) === null || s === void 0 ? void 0 : s.from) != o.from && (n = l);
  for (; ; ) {
    let o = n.enter(e, t, r);
    if (!o)
      return n;
    n = o;
  }
}
class tp {
  cursor(e = 0) {
    return new no(this, e);
  }
  getChild(e, t = null, i = null) {
    let s = ff(this, e, t, i);
    return s.length ? s[0] : null;
  }
  getChildren(e, t = null, i = null) {
    return ff(this, e, t, i);
  }
  resolve(e, t = 0) {
    return Is(this, e, t, !1);
  }
  resolveInner(e, t = 0) {
    return Is(this, e, t, !0);
  }
  matchContext(e) {
    return va(this, e);
  }
  enterUnfinishedNodesBefore(e) {
    let t = this.childBefore(e), i = this;
    for (; t; ) {
      let s = t.lastChild;
      if (!s || s.to != t.to)
        break;
      s.type.isError && s.from == s.to ? (i = t, t = s.prevSibling) : t = s;
    }
    return i;
  }
  get node() {
    return this;
  }
  get next() {
    return this.parent;
  }
}
class Ne extends tp {
  constructor(e, t, i, s) {
    super(), this._tree = e, this.from = t, this.index = i, this._parent = s;
  }
  get type() {
    return this._tree.type;
  }
  get name() {
    return this._tree.type.name;
  }
  get to() {
    return this.from + this._tree.length;
  }
  nextChild(e, t, i, s, r = 0) {
    for (let o = this; ; ) {
      for (let { children: l, positions: a } = o._tree, h = t > 0 ? l.length : -1; e != h; e += t) {
        let c = l[e], f = a[e] + o.from;
        if (ep(s, i, f, f + c.length)) {
          if (c instanceof Li) {
            if (r & pe.ExcludeBuffers)
              continue;
            let u = c.findChild(0, c.buffer.length, t, i - f, s);
            if (u > -1)
              return new Gt(new Qy(o, c, e, f), null, u);
          } else if (r & pe.IncludeAnonymous || !c.type.isAnonymous || rh(c)) {
            let u;
            if (!(r & pe.IgnoreMounts) && (u = Bs.get(c)) && !u.overlay)
              return new Ne(u.tree, f, e, o);
            let d = new Ne(c, f, e, o);
            return r & pe.IncludeAnonymous || !d.type.isAnonymous ? d : d.nextChild(t < 0 ? c.children.length - 1 : 0, t, i, s);
          }
        }
      }
      if (r & pe.IncludeAnonymous || !o.type.isAnonymous || (o.index >= 0 ? e = o.index + t : e = t < 0 ? -1 : o._parent._tree.children.length, o = o._parent, !o))
        return null;
    }
  }
  get firstChild() {
    return this.nextChild(
      0,
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.nextChild(
      0,
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.nextChild(
      this._tree.children.length - 1,
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, t, i = 0) {
    let s;
    if (!(i & pe.IgnoreOverlays) && (s = Bs.get(this._tree)) && s.overlay) {
      let r = e - this.from;
      for (let { from: o, to: l } of s.overlay)
        if ((t > 0 ? o <= r : o < r) && (t < 0 ? l >= r : l > r))
          return new Ne(s.tree, s.overlay[0].from + this.from, -1, this);
    }
    return this.nextChild(0, 1, e, t, i);
  }
  nextSignificantParent() {
    let e = this;
    for (; e.type.isAnonymous && e._parent; )
      e = e._parent;
    return e;
  }
  get parent() {
    return this._parent ? this._parent.nextSignificantParent() : null;
  }
  get nextSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index + 1,
      1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get prevSibling() {
    return this._parent && this.index >= 0 ? this._parent.nextChild(
      this.index - 1,
      -1,
      0,
      4
      /* Side.DontCare */
    ) : null;
  }
  get tree() {
    return this._tree;
  }
  toTree() {
    return this._tree;
  }
  /**
  @internal
  */
  toString() {
    return this._tree.toString();
  }
}
function ff(n, e, t, i) {
  let s = n.cursor(), r = [];
  if (!s.firstChild())
    return r;
  if (t != null) {
    for (let o = !1; !o; )
      if (o = s.type.is(t), !s.nextSibling())
        return r;
  }
  for (; ; ) {
    if (i != null && s.type.is(i))
      return r;
    if (s.type.is(e) && r.push(s.node), !s.nextSibling())
      return i == null ? r : [];
  }
}
function va(n, e, t = e.length - 1) {
  for (let i = n.parent; t >= 0; i = i.parent) {
    if (!i)
      return !1;
    if (!i.type.isAnonymous) {
      if (e[t] && e[t] != i.name)
        return !1;
      t--;
    }
  }
  return !0;
}
class Qy {
  constructor(e, t, i, s) {
    this.parent = e, this.buffer = t, this.index = i, this.start = s;
  }
}
class Gt extends tp {
  get name() {
    return this.type.name;
  }
  get from() {
    return this.context.start + this.context.buffer.buffer[this.index + 1];
  }
  get to() {
    return this.context.start + this.context.buffer.buffer[this.index + 2];
  }
  constructor(e, t, i) {
    super(), this.context = e, this._parent = t, this.index = i, this.type = e.buffer.set.types[e.buffer.buffer[i]];
  }
  child(e, t, i) {
    let { buffer: s } = this.context, r = s.findChild(this.index + 4, s.buffer[this.index + 3], e, t - this.context.start, i);
    return r < 0 ? null : new Gt(this.context, this, r);
  }
  get firstChild() {
    return this.child(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  get lastChild() {
    return this.child(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  childAfter(e) {
    return this.child(
      1,
      e,
      2
      /* Side.After */
    );
  }
  childBefore(e) {
    return this.child(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  enter(e, t, i = 0) {
    if (i & pe.ExcludeBuffers)
      return null;
    let { buffer: s } = this.context, r = s.findChild(this.index + 4, s.buffer[this.index + 3], t > 0 ? 1 : -1, e - this.context.start, t);
    return r < 0 ? null : new Gt(this.context, this, r);
  }
  get parent() {
    return this._parent || this.context.parent.nextSignificantParent();
  }
  externalSibling(e) {
    return this._parent ? null : this.context.parent.nextChild(
      this.context.index + e,
      e,
      0,
      4
      /* Side.DontCare */
    );
  }
  get nextSibling() {
    let { buffer: e } = this.context, t = e.buffer[this.index + 3];
    return t < (this._parent ? e.buffer[this._parent.index + 3] : e.buffer.length) ? new Gt(this.context, this._parent, t) : this.externalSibling(1);
  }
  get prevSibling() {
    let { buffer: e } = this.context, t = this._parent ? this._parent.index + 4 : 0;
    return this.index == t ? this.externalSibling(-1) : new Gt(this.context, this._parent, e.findChild(
      t,
      this.index,
      -1,
      0,
      4
      /* Side.DontCare */
    ));
  }
  get tree() {
    return null;
  }
  toTree() {
    let e = [], t = [], { buffer: i } = this.context, s = this.index + 4, r = i.buffer[this.index + 3];
    if (r > s) {
      let o = i.buffer[this.index + 1];
      e.push(i.slice(s, r, o)), t.push(0);
    }
    return new fe(this.type, e, t, this.to - this.from);
  }
  /**
  @internal
  */
  toString() {
    return this.context.buffer.childString(this.index);
  }
}
function ip(n) {
  if (!n.length)
    return null;
  let e = 0, t = n[0];
  for (let r = 1; r < n.length; r++) {
    let o = n[r];
    (o.from > t.from || o.to < t.to) && (t = o, e = r);
  }
  let i = t instanceof Ne && t.index < 0 ? null : t.parent, s = n.slice();
  return i ? s[e] = i : s.splice(e, 1), new Zy(s, t);
}
class Zy {
  constructor(e, t) {
    this.heads = e, this.node = t;
  }
  get next() {
    return ip(this.heads);
  }
}
function $y(n, e, t) {
  let i = n.resolveInner(e, t), s = null;
  for (let r = i instanceof Ne ? i : i.context.parent; r; r = r.parent)
    if (r.index < 0) {
      let o = r.parent;
      (s || (s = [i])).push(o.resolve(e, t)), r = o;
    } else {
      let o = Bs.get(r.tree);
      if (o && o.overlay && o.overlay[0].from <= e && o.overlay[o.overlay.length - 1].to >= e) {
        let l = new Ne(o.tree, o.overlay[0].from + r.from, -1, r);
        (s || (s = [i])).push(Is(l, e, t, !1));
      }
    }
  return s ? ip(s) : i;
}
class no {
  /**
  Shorthand for `.type.name`.
  */
  get name() {
    return this.type.name;
  }
  /**
  @internal
  */
  constructor(e, t = 0) {
    if (this.mode = t, this.buffer = null, this.stack = [], this.index = 0, this.bufferNode = null, e instanceof Ne)
      this.yieldNode(e);
    else {
      this._tree = e.context.parent, this.buffer = e.context;
      for (let i = e._parent; i; i = i._parent)
        this.stack.unshift(i.index);
      this.bufferNode = e, this.yieldBuf(e.index);
    }
  }
  yieldNode(e) {
    return e ? (this._tree = e, this.type = e.type, this.from = e.from, this.to = e.to, !0) : !1;
  }
  yieldBuf(e, t) {
    this.index = e;
    let { start: i, buffer: s } = this.buffer;
    return this.type = t || s.set.types[s.buffer[e]], this.from = i + s.buffer[e + 1], this.to = i + s.buffer[e + 2], !0;
  }
  /**
  @internal
  */
  yield(e) {
    return e ? e instanceof Ne ? (this.buffer = null, this.yieldNode(e)) : (this.buffer = e.context, this.yieldBuf(e.index, e.type)) : !1;
  }
  /**
  @internal
  */
  toString() {
    return this.buffer ? this.buffer.buffer.childString(this.index) : this._tree.toString();
  }
  /**
  @internal
  */
  enterChild(e, t, i) {
    if (!this.buffer)
      return this.yield(this._tree.nextChild(e < 0 ? this._tree._tree.children.length - 1 : 0, e, t, i, this.mode));
    let { buffer: s } = this.buffer, r = s.findChild(this.index + 4, s.buffer[this.index + 3], e, t - this.buffer.start, i);
    return r < 0 ? !1 : (this.stack.push(this.index), this.yieldBuf(r));
  }
  /**
  Move the cursor to this node's first child. When this returns
  false, the node has no child, and the cursor has not been moved.
  */
  firstChild() {
    return this.enterChild(
      1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to this node's last child.
  */
  lastChild() {
    return this.enterChild(
      -1,
      0,
      4
      /* Side.DontCare */
    );
  }
  /**
  Move the cursor to the first child that ends after `pos`.
  */
  childAfter(e) {
    return this.enterChild(
      1,
      e,
      2
      /* Side.After */
    );
  }
  /**
  Move to the last child that starts before `pos`.
  */
  childBefore(e) {
    return this.enterChild(
      -1,
      e,
      -2
      /* Side.Before */
    );
  }
  /**
  Move the cursor to the child around `pos`. If side is -1 the
  child may end at that position, when 1 it may start there. This
  will also enter [overlaid](#common.MountedTree.overlay)
  [mounted](#common.NodeProp^mounted) trees unless `overlays` is
  set to false.
  */
  enter(e, t, i = this.mode) {
    return this.buffer ? i & pe.ExcludeBuffers ? !1 : this.enterChild(1, e, t) : this.yield(this._tree.enter(e, t, i));
  }
  /**
  Move to the node's parent node, if this isn't the top node.
  */
  parent() {
    if (!this.buffer)
      return this.yieldNode(this.mode & pe.IncludeAnonymous ? this._tree._parent : this._tree.parent);
    if (this.stack.length)
      return this.yieldBuf(this.stack.pop());
    let e = this.mode & pe.IncludeAnonymous ? this.buffer.parent : this.buffer.parent.nextSignificantParent();
    return this.buffer = null, this.yieldNode(e);
  }
  /**
  @internal
  */
  sibling(e) {
    if (!this.buffer)
      return this._tree._parent ? this.yield(this._tree.index < 0 ? null : this._tree._parent.nextChild(this._tree.index + e, e, 0, 4, this.mode)) : !1;
    let { buffer: t } = this.buffer, i = this.stack.length - 1;
    if (e < 0) {
      let s = i < 0 ? 0 : this.stack[i] + 4;
      if (this.index != s)
        return this.yieldBuf(t.findChild(
          s,
          this.index,
          -1,
          0,
          4
          /* Side.DontCare */
        ));
    } else {
      let s = t.buffer[this.index + 3];
      if (s < (i < 0 ? t.buffer.length : t.buffer[this.stack[i] + 3]))
        return this.yieldBuf(s);
    }
    return i < 0 ? this.yield(this.buffer.parent.nextChild(this.buffer.index + e, e, 0, 4, this.mode)) : !1;
  }
  /**
  Move to this node's next sibling, if any.
  */
  nextSibling() {
    return this.sibling(1);
  }
  /**
  Move to this node's previous sibling, if any.
  */
  prevSibling() {
    return this.sibling(-1);
  }
  atLastNode(e) {
    let t, i, { buffer: s } = this;
    if (s) {
      if (e > 0) {
        if (this.index < s.buffer.buffer.length)
          return !1;
      } else
        for (let r = 0; r < this.index; r++)
          if (s.buffer.buffer[r + 3] < this.index)
            return !1;
      ({ index: t, parent: i } = s);
    } else
      ({ index: t, _parent: i } = this._tree);
    for (; i; { index: t, _parent: i } = i)
      if (t > -1)
        for (let r = t + e, o = e < 0 ? -1 : i._tree.children.length; r != o; r += e) {
          let l = i._tree.children[r];
          if (this.mode & pe.IncludeAnonymous || l instanceof Li || !l.type.isAnonymous || rh(l))
            return !1;
        }
    return !0;
  }
  move(e, t) {
    if (t && this.enterChild(
      e,
      0,
      4
      /* Side.DontCare */
    ))
      return !0;
    for (; ; ) {
      if (this.sibling(e))
        return !0;
      if (this.atLastNode(e) || !this.parent())
        return !1;
    }
  }
  /**
  Move to the next node in a
  [pre-order](https://en.wikipedia.org/wiki/Tree_traversal#Pre-order,_NLR)
  traversal, going from a node to its first child or, if the
  current node is empty or `enter` is false, its next sibling or
  the next sibling of the first parent node that has one.
  */
  next(e = !0) {
    return this.move(1, e);
  }
  /**
  Move to the next node in a last-to-first pre-order traveral. A
  node is followed by its last child or, if it has none, its
  previous sibling or the previous sibling of the first parent
  node that has one.
  */
  prev(e = !0) {
    return this.move(-1, e);
  }
  /**
  Move the cursor to the innermost node that covers `pos`. If
  `side` is -1, it will enter nodes that end at `pos`. If it is 1,
  it will enter nodes that start at `pos`.
  */
  moveTo(e, t = 0) {
    for (; (this.from == this.to || (t < 1 ? this.from >= e : this.from > e) || (t > -1 ? this.to <= e : this.to < e)) && this.parent(); )
      ;
    for (; this.enterChild(1, e, t); )
      ;
    return this;
  }
  /**
  Get a [syntax node](#common.SyntaxNode) at the cursor's current
  position.
  */
  get node() {
    if (!this.buffer)
      return this._tree;
    let e = this.bufferNode, t = null, i = 0;
    if (e && e.context == this.buffer)
      e: for (let s = this.index, r = this.stack.length; r >= 0; ) {
        for (let o = e; o; o = o._parent)
          if (o.index == s) {
            if (s == this.index)
              return o;
            t = o, i = r + 1;
            break e;
          }
        s = this.stack[--r];
      }
    for (let s = i; s < this.stack.length; s++)
      t = new Gt(this.buffer, t, this.stack[s]);
    return this.bufferNode = new Gt(this.buffer, t, this.index);
  }
  /**
  Get the [tree](#common.Tree) that represents the current node, if
  any. Will return null when the node is in a [tree
  buffer](#common.TreeBuffer).
  */
  get tree() {
    return this.buffer ? null : this._tree._tree;
  }
  /**
  Iterate over the current node and all its descendants, calling
  `enter` when entering a node and `leave`, if given, when leaving
  one. When `enter` returns `false`, any children of that node are
  skipped, and `leave` isn't called for it.
  */
  iterate(e, t) {
    for (let i = 0; ; ) {
      let s = !1;
      if (this.type.isAnonymous || e(this) !== !1) {
        if (this.firstChild()) {
          i++;
          continue;
        }
        this.type.isAnonymous || (s = !0);
      }
      for (; s && t && t(this), s = this.type.isAnonymous, !this.nextSibling(); ) {
        if (!i)
          return;
        this.parent(), i--, s = !0;
      }
    }
  }
  /**
  Test whether the current node matches a given context—a sequence
  of direct parent node names. Empty strings in the context array
  are treated as wildcards.
  */
  matchContext(e) {
    if (!this.buffer)
      return va(this.node, e);
    let { buffer: t } = this.buffer, { types: i } = t.set;
    for (let s = e.length - 1, r = this.stack.length - 1; s >= 0; r--) {
      if (r < 0)
        return va(this.node, e, s);
      let o = i[t.buffer[this.stack[r]]];
      if (!o.isAnonymous) {
        if (e[s] && e[s] != o.name)
          return !1;
        s--;
      }
    }
    return !0;
  }
}
function rh(n) {
  return n.children.some((e) => e instanceof Li || !e.type.isAnonymous || rh(e));
}
function ew(n) {
  var e;
  let { buffer: t, nodeSet: i, maxBufferLength: s = Yy, reused: r = [], minRepeatType: o = i.types.length } = n, l = Array.isArray(t) ? new sh(t, t.length) : t, a = i.types, h = 0, c = 0;
  function f(_, S, A, P, W, U) {
    let { id: F, start: M, end: R, size: z } = l, G = c;
    for (; z < 0; )
      if (l.next(), z == -1) {
        let J = r[F];
        A.push(J), P.push(M - _);
        return;
      } else if (z == -3) {
        h = F;
        return;
      } else if (z == -4) {
        c = F;
        return;
      } else
        throw new RangeError(`Unrecognized record size: ${z}`);
    let Q = a[F], re, T, ee = M - _;
    if (R - M <= s && (T = g(l.pos - S, W))) {
      let J = new Uint16Array(T.size - T.skip), j = l.pos - T.size, oe = J.length;
      for (; l.pos > j; )
        oe = b(T.start, J, oe);
      re = new Li(J, R - T.start, i), ee = T.start - _;
    } else {
      let J = l.pos - z;
      l.next();
      let j = [], oe = [], q = F >= o ? F : -1, ve = 0, E = R;
      for (; l.pos > J; )
        q >= 0 && l.id == q && l.size >= 0 ? (l.end <= E - s && (m(j, oe, M, ve, l.end, E, q, G), ve = j.length, E = l.end), l.next()) : U > 2500 ? u(M, J, j, oe) : f(M, J, j, oe, q, U + 1);
      if (q >= 0 && ve > 0 && ve < j.length && m(j, oe, M, ve, M, E, q, G), j.reverse(), oe.reverse(), q > -1 && ve > 0) {
        let st = d(Q);
        re = oh(Q, j, oe, 0, j.length, 0, R - M, st, st);
      } else
        re = p(Q, j, oe, R - M, G - R);
    }
    A.push(re), P.push(ee);
  }
  function u(_, S, A, P) {
    let W = [], U = 0, F = -1;
    for (; l.pos > S; ) {
      let { id: M, start: R, end: z, size: G } = l;
      if (G > 4)
        l.next();
      else {
        if (F > -1 && R < F)
          break;
        F < 0 && (F = z - s), W.push(M, R, z), U++, l.next();
      }
    }
    if (U) {
      let M = new Uint16Array(U * 4), R = W[W.length - 2];
      for (let z = W.length - 3, G = 0; z >= 0; z -= 3)
        M[G++] = W[z], M[G++] = W[z + 1] - R, M[G++] = W[z + 2] - R, M[G++] = G;
      A.push(new Li(M, W[2] - R, i)), P.push(R - _);
    }
  }
  function d(_) {
    return (S, A, P) => {
      let W = 0, U = S.length - 1, F, M;
      if (U >= 0 && (F = S[U]) instanceof fe) {
        if (!U && F.type == _ && F.length == P)
          return F;
        (M = F.prop($.lookAhead)) && (W = A[U] + F.length + M);
      }
      return p(_, S, A, P, W);
    };
  }
  function m(_, S, A, P, W, U, F, M) {
    let R = [], z = [];
    for (; _.length > P; )
      R.push(_.pop()), z.push(S.pop() + A - W);
    _.push(p(i.types[F], R, z, U - W, M - U)), S.push(W - A);
  }
  function p(_, S, A, P, W = 0, U) {
    if (h) {
      let F = [$.contextHash, h];
      U = U ? [F].concat(U) : [F];
    }
    if (W > 25) {
      let F = [$.lookAhead, W];
      U = U ? [F].concat(U) : [F];
    }
    return new fe(_, S, A, P, U);
  }
  function g(_, S) {
    let A = l.fork(), P = 0, W = 0, U = 0, F = A.end - s, M = { size: 0, start: 0, skip: 0 };
    e: for (let R = A.pos - _; A.pos > R; ) {
      let z = A.size;
      if (A.id == S && z >= 0) {
        M.size = P, M.start = W, M.skip = U, U += 4, P += 4, A.next();
        continue;
      }
      let G = A.pos - z;
      if (z < 0 || G < R || A.start < F)
        break;
      let Q = A.id >= o ? 4 : 0, re = A.start;
      for (A.next(); A.pos > G; ) {
        if (A.size < 0)
          if (A.size == -3)
            Q += 4;
          else
            break e;
        else A.id >= o && (Q += 4);
        A.next();
      }
      W = re, P += z, U += Q;
    }
    return (S < 0 || P == _) && (M.size = P, M.start = W, M.skip = U), M.size > 4 ? M : void 0;
  }
  function b(_, S, A) {
    let { id: P, start: W, end: U, size: F } = l;
    if (l.next(), F >= 0 && P < o) {
      let M = A;
      if (F > 4) {
        let R = l.pos - (F - 4);
        for (; l.pos > R; )
          A = b(_, S, A);
      }
      S[--A] = M, S[--A] = U - _, S[--A] = W - _, S[--A] = P;
    } else F == -3 ? h = P : F == -4 && (c = P);
    return A;
  }
  let w = [], k = [];
  for (; l.pos > 0; )
    f(n.start || 0, n.bufferStart || 0, w, k, -1, 0);
  let x = (e = n.length) !== null && e !== void 0 ? e : w.length ? k[0] + w[0].length : 0;
  return new fe(a[n.topID], w.reverse(), k.reverse(), x);
}
const uf = /* @__PURE__ */ new WeakMap();
function jr(n, e) {
  if (!n.isAnonymous || e instanceof Li || e.type != n)
    return 1;
  let t = uf.get(e);
  if (t == null) {
    t = 1;
    for (let i of e.children) {
      if (i.type != n || !(i instanceof fe)) {
        t = 1;
        break;
      }
      t += jr(n, i);
    }
    uf.set(e, t);
  }
  return t;
}
function oh(n, e, t, i, s, r, o, l, a) {
  let h = 0;
  for (let m = i; m < s; m++)
    h += jr(n, e[m]);
  let c = Math.ceil(
    h * 1.5 / 8
    /* Balance.BranchFactor */
  ), f = [], u = [];
  function d(m, p, g, b, w) {
    for (let k = g; k < b; ) {
      let x = k, _ = p[k], S = jr(n, m[k]);
      for (k++; k < b; k++) {
        let A = jr(n, m[k]);
        if (S + A >= c)
          break;
        S += A;
      }
      if (k == x + 1) {
        if (S > c) {
          let A = m[x];
          d(A.children, A.positions, 0, A.children.length, p[x] + w);
          continue;
        }
        f.push(m[x]);
      } else {
        let A = p[k - 1] + m[k - 1].length - _;
        f.push(oh(n, m, p, x, k, _, A, null, a));
      }
      u.push(_ + w - r);
    }
  }
  return d(e, t, i, s, 0), (l || a)(f, u, o);
}
class BM {
  constructor() {
    this.map = /* @__PURE__ */ new WeakMap();
  }
  setBuffer(e, t, i) {
    let s = this.map.get(e);
    s || this.map.set(e, s = /* @__PURE__ */ new Map()), s.set(t, i);
  }
  getBuffer(e, t) {
    let i = this.map.get(e);
    return i && i.get(t);
  }
  /**
  Set the value for this syntax node.
  */
  set(e, t) {
    e instanceof Gt ? this.setBuffer(e.context.buffer, e.index, t) : e instanceof Ne && this.map.set(e.tree, t);
  }
  /**
  Retrieve value for this syntax node, if it exists in the map.
  */
  get(e) {
    return e instanceof Gt ? this.getBuffer(e.context.buffer, e.index) : e instanceof Ne ? this.map.get(e.tree) : void 0;
  }
  /**
  Set the value for the node that a cursor currently points to.
  */
  cursorSet(e, t) {
    e.buffer ? this.setBuffer(e.buffer.buffer, e.index, t) : this.map.set(e.tree, t);
  }
  /**
  Retrieve the value for the node that a cursor currently points
  to.
  */
  cursorGet(e) {
    return e.buffer ? this.getBuffer(e.buffer.buffer, e.index) : this.map.get(e.tree);
  }
}
class hi {
  /**
  Construct a tree fragment. You'll usually want to use
  [`addTree`](#common.TreeFragment^addTree) and
  [`applyChanges`](#common.TreeFragment^applyChanges) instead of
  calling this directly.
  */
  constructor(e, t, i, s, r = !1, o = !1) {
    this.from = e, this.to = t, this.tree = i, this.offset = s, this.open = (r ? 1 : 0) | (o ? 2 : 0);
  }
  /**
  Whether the start of the fragment represents the start of a
  parse, or the end of a change. (In the second case, it may not
  be safe to reuse some nodes at the start, depending on the
  parsing algorithm.)
  */
  get openStart() {
    return (this.open & 1) > 0;
  }
  /**
  Whether the end of the fragment represents the end of a
  full-document parse, or the start of a change.
  */
  get openEnd() {
    return (this.open & 2) > 0;
  }
  /**
  Create a set of fragments from a freshly parsed tree, or update
  an existing set of fragments by replacing the ones that overlap
  with a tree with content from the new tree. When `partial` is
  true, the parse is treated as incomplete, and the resulting
  fragment has [`openEnd`](#common.TreeFragment.openEnd) set to
  true.
  */
  static addTree(e, t = [], i = !1) {
    let s = [new hi(0, e.length, e, 0, !1, i)];
    for (let r of t)
      r.to > e.length && s.push(r);
    return s;
  }
  /**
  Apply a set of edits to an array of fragments, removing or
  splitting fragments as necessary to remove edited ranges, and
  adjusting offsets for fragments that moved.
  */
  static applyChanges(e, t, i = 128) {
    if (!t.length)
      return e;
    let s = [], r = 1, o = e.length ? e[0] : null;
    for (let l = 0, a = 0, h = 0; ; l++) {
      let c = l < t.length ? t[l] : null, f = c ? c.fromA : 1e9;
      if (f - a >= i)
        for (; o && o.from < f; ) {
          let u = o;
          if (a >= u.from || f <= u.to || h) {
            let d = Math.max(u.from, a) - h, m = Math.min(u.to, f) - h;
            u = d >= m ? null : new hi(d, m, u.tree, u.offset + h, l > 0, !!c);
          }
          if (u && s.push(u), o.to > f)
            break;
          o = r < e.length ? e[r++] : null;
        }
      if (!c)
        break;
      a = c.toA, h = c.toA - c.toB;
    }
    return s;
  }
}
class np {
  /**
  Start a parse, returning a [partial parse](#common.PartialParse)
  object. [`fragments`](#common.TreeFragment) can be passed in to
  make the parse incremental.
  
  By default, the entire input is parsed. You can pass `ranges`,
  which should be a sorted array of non-empty, non-overlapping
  ranges, to parse only those ranges. The tree returned in that
  case will start at `ranges[0].from`.
  */
  startParse(e, t, i) {
    return typeof e == "string" && (e = new tw(e)), i = i ? i.length ? i.map((s) => new at(s.from, s.to)) : [new at(0, 0)] : [new at(0, e.length)], this.createParse(e, t || [], i);
  }
  /**
  Run a full parse, returning the resulting tree.
  */
  parse(e, t, i) {
    let s = this.startParse(e, t, i);
    for (; ; ) {
      let r = s.advance();
      if (r)
        return r;
    }
  }
}
class tw {
  constructor(e) {
    this.string = e;
  }
  get length() {
    return this.string.length;
  }
  chunk(e) {
    return this.string.slice(e);
  }
  get lineChunks() {
    return !1;
  }
  read(e, t) {
    return this.string.slice(e, t);
  }
}
function IM(n) {
  return (e, t, i, s) => new nw(e, n, t, i, s);
}
class df {
  constructor(e, t, i, s, r) {
    this.parser = e, this.parse = t, this.overlay = i, this.target = s, this.from = r;
  }
}
function mf(n) {
  if (!n.length || n.some((e) => e.from >= e.to))
    throw new RangeError("Invalid inner parse ranges given: " + JSON.stringify(n));
}
class iw {
  constructor(e, t, i, s, r, o, l) {
    this.parser = e, this.predicate = t, this.mounts = i, this.index = s, this.start = r, this.target = o, this.prev = l, this.depth = 0, this.ranges = [];
  }
}
const xa = new $({ perNode: !0 });
class nw {
  constructor(e, t, i, s, r) {
    this.nest = t, this.input = i, this.fragments = s, this.ranges = r, this.inner = [], this.innerDone = 0, this.baseTree = null, this.stoppedAt = null, this.baseParse = e;
  }
  advance() {
    if (this.baseParse) {
      let i = this.baseParse.advance();
      if (!i)
        return null;
      if (this.baseParse = null, this.baseTree = i, this.startInner(), this.stoppedAt != null)
        for (let s of this.inner)
          s.parse.stopAt(this.stoppedAt);
    }
    if (this.innerDone == this.inner.length) {
      let i = this.baseTree;
      return this.stoppedAt != null && (i = new fe(i.type, i.children, i.positions, i.length, i.propValues.concat([[xa, this.stoppedAt]]))), i;
    }
    let e = this.inner[this.innerDone], t = e.parse.advance();
    if (t) {
      this.innerDone++;
      let i = Object.assign(/* @__PURE__ */ Object.create(null), e.target.props);
      i[$.mounted.id] = new Bs(t, e.overlay, e.parser), e.target.props = i;
    }
    return null;
  }
  get parsedPos() {
    if (this.baseParse)
      return 0;
    let e = this.input.length;
    for (let t = this.innerDone; t < this.inner.length; t++)
      this.inner[t].from < e && (e = Math.min(e, this.inner[t].parse.parsedPos));
    return e;
  }
  stopAt(e) {
    if (this.stoppedAt = e, this.baseParse)
      this.baseParse.stopAt(e);
    else
      for (let t = this.innerDone; t < this.inner.length; t++)
        this.inner[t].parse.stopAt(e);
  }
  startInner() {
    let e = new ow(this.fragments), t = null, i = null, s = new no(new Ne(this.baseTree, this.ranges[0].from, 0, null), pe.IncludeAnonymous | pe.IgnoreMounts);
    e: for (let r, o; ; ) {
      let l = !0, a;
      if (this.stoppedAt != null && s.from >= this.stoppedAt)
        l = !1;
      else if (e.hasNode(s)) {
        if (t) {
          let h = t.mounts.find((c) => c.frag.from <= s.from && c.frag.to >= s.to && c.mount.overlay);
          if (h)
            for (let c of h.mount.overlay) {
              let f = c.from + h.pos, u = c.to + h.pos;
              f >= s.from && u <= s.to && !t.ranges.some((d) => d.from < u && d.to > f) && t.ranges.push({ from: f, to: u });
            }
        }
        l = !1;
      } else if (i && (o = sw(i.ranges, s.from, s.to)))
        l = o != 2;
      else if (!s.type.isAnonymous && (r = this.nest(s, this.input)) && (s.from < s.to || !r.overlay)) {
        s.tree || rw(s);
        let h = e.findMounts(s.from, r.parser);
        if (typeof r.overlay == "function")
          t = new iw(r.parser, r.overlay, h, this.inner.length, s.from, s.tree, t);
        else {
          let c = bf(this.ranges, r.overlay || (s.from < s.to ? [new at(s.from, s.to)] : []));
          c.length && mf(c), (c.length || !r.overlay) && this.inner.push(new df(r.parser, c.length ? r.parser.startParse(this.input, yf(h, c), c) : r.parser.startParse(""), r.overlay ? r.overlay.map((f) => new at(f.from - s.from, f.to - s.from)) : null, s.tree, c.length ? c[0].from : s.from)), r.overlay ? c.length && (i = { ranges: c, depth: 0, prev: i }) : l = !1;
        }
      } else t && (a = t.predicate(s)) && (a === !0 && (a = new at(s.from, s.to)), a.from < a.to && t.ranges.push(a));
      if (l && s.firstChild())
        t && t.depth++, i && i.depth++;
      else
        for (; !s.nextSibling(); ) {
          if (!s.parent())
            break e;
          if (t && !--t.depth) {
            let h = bf(this.ranges, t.ranges);
            h.length && (mf(h), this.inner.splice(t.index, 0, new df(t.parser, t.parser.startParse(this.input, yf(t.mounts, h), h), t.ranges.map((c) => new at(c.from - t.start, c.to - t.start)), t.target, h[0].from))), t = t.prev;
          }
          i && !--i.depth && (i = i.prev);
        }
    }
  }
}
function sw(n, e, t) {
  for (let i of n) {
    if (i.from >= t)
      break;
    if (i.to > e)
      return i.from <= e && i.to >= t ? 2 : 1;
  }
  return 0;
}
function pf(n, e, t, i, s, r) {
  if (e < t) {
    let o = n.buffer[e + 1];
    i.push(n.slice(e, t, o)), s.push(o - r);
  }
}
function rw(n) {
  let { node: e } = n, t = [], i = e.context.buffer;
  do
    t.push(n.index), n.parent();
  while (!n.tree);
  let s = n.tree, r = s.children.indexOf(i), o = s.children[r], l = o.buffer, a = [r];
  function h(c, f, u, d, m, p) {
    let g = t[p], b = [], w = [];
    pf(o, c, g, b, w, d);
    let k = l[g + 1], x = l[g + 2];
    a.push(b.length);
    let _ = p ? h(g + 4, l[g + 3], o.set.types[l[g]], k, x - k, p - 1) : e.toTree();
    return b.push(_), w.push(k - d), pf(o, l[g + 3], f, b, w, d), new fe(u, b, w, m);
  }
  s.children[r] = h(0, l.length, Ue.none, 0, o.length, t.length - 1);
  for (let c of a) {
    let f = n.tree.children[c], u = n.tree.positions[c];
    n.yield(new Ne(f, u + n.from, c, n._tree));
  }
}
class gf {
  constructor(e, t) {
    this.offset = t, this.done = !1, this.cursor = e.cursor(pe.IncludeAnonymous | pe.IgnoreMounts);
  }
  // Move to the first node (in pre-order) that starts at or after `pos`.
  moveTo(e) {
    let { cursor: t } = this, i = e - this.offset;
    for (; !this.done && t.from < i; )
      t.to >= e && t.enter(i, 1, pe.IgnoreOverlays | pe.ExcludeBuffers) || t.next(!1) || (this.done = !0);
  }
  hasNode(e) {
    if (this.moveTo(e.from), !this.done && this.cursor.from + this.offset == e.from && this.cursor.tree)
      for (let t = this.cursor.tree; ; ) {
        if (t == e.tree)
          return !0;
        if (t.children.length && t.positions[0] == 0 && t.children[0] instanceof fe)
          t = t.children[0];
        else
          break;
      }
    return !1;
  }
}
class ow {
  constructor(e) {
    var t;
    if (this.fragments = e, this.curTo = 0, this.fragI = 0, e.length) {
      let i = this.curFrag = e[0];
      this.curTo = (t = i.tree.prop(xa)) !== null && t !== void 0 ? t : i.to, this.inner = new gf(i.tree, -i.offset);
    } else
      this.curFrag = this.inner = null;
  }
  hasNode(e) {
    for (; this.curFrag && e.from >= this.curTo; )
      this.nextFrag();
    return this.curFrag && this.curFrag.from <= e.from && this.curTo >= e.to && this.inner.hasNode(e);
  }
  nextFrag() {
    var e;
    if (this.fragI++, this.fragI == this.fragments.length)
      this.curFrag = this.inner = null;
    else {
      let t = this.curFrag = this.fragments[this.fragI];
      this.curTo = (e = t.tree.prop(xa)) !== null && e !== void 0 ? e : t.to, this.inner = new gf(t.tree, -t.offset);
    }
  }
  findMounts(e, t) {
    var i;
    let s = [];
    if (this.inner) {
      this.inner.cursor.moveTo(e, 1);
      for (let r = this.inner.cursor.node; r; r = r.parent) {
        let o = (i = r.tree) === null || i === void 0 ? void 0 : i.prop($.mounted);
        if (o && o.parser == t)
          for (let l = this.fragI; l < this.fragments.length; l++) {
            let a = this.fragments[l];
            if (a.from >= r.to)
              break;
            a.tree == this.curFrag.tree && s.push({
              frag: a,
              pos: r.from - a.offset,
              mount: o
            });
          }
      }
    }
    return s;
  }
}
function bf(n, e) {
  let t = null, i = e;
  for (let s = 1, r = 0; s < n.length; s++) {
    let o = n[s - 1].to, l = n[s].from;
    for (; r < i.length; r++) {
      let a = i[r];
      if (a.from >= l)
        break;
      a.to <= o || (t || (i = t = e.slice()), a.from < o ? (t[r] = new at(a.from, o), a.to > l && t.splice(r + 1, 0, new at(l, a.to))) : a.to > l ? t[r--] = new at(l, a.to) : t.splice(r--, 1));
    }
  }
  return i;
}
function lw(n, e, t, i) {
  let s = 0, r = 0, o = !1, l = !1, a = -1e9, h = [];
  for (; ; ) {
    let c = s == n.length ? 1e9 : o ? n[s].to : n[s].from, f = r == e.length ? 1e9 : l ? e[r].to : e[r].from;
    if (o != l) {
      let u = Math.max(a, t), d = Math.min(c, f, i);
      u < d && h.push(new at(u, d));
    }
    if (a = Math.min(c, f), a == 1e9)
      break;
    c == a && (o ? (o = !1, s++) : o = !0), f == a && (l ? (l = !1, r++) : l = !0);
  }
  return h;
}
function yf(n, e) {
  let t = [];
  for (let { pos: i, mount: s, frag: r } of n) {
    let o = i + (s.overlay ? s.overlay[0].from : 0), l = o + s.tree.length, a = Math.max(r.from, o), h = Math.min(r.to, l);
    if (s.overlay) {
      let c = s.overlay.map((u) => new at(u.from + i, u.to + i)), f = lw(e, c, a, h);
      for (let u = 0, d = a; ; u++) {
        let m = u == f.length, p = m ? h : f[u].from;
        if (p > d && t.push(new hi(d, p, s.tree, -o, r.from >= d || r.openStart, r.to <= p || r.openEnd)), m)
          break;
        d = f[u].to;
      }
    } else
      t.push(new hi(a, h, s.tree, -o, r.from >= o || r.openStart, r.to <= l || r.openEnd));
  }
  return t;
}
let aw = 0;
class Ut {
  /**
  @internal
  */
  constructor(e, t, i) {
    this.set = e, this.base = t, this.modified = i, this.id = aw++;
  }
  /**
  Define a new tag. If `parent` is given, the tag is treated as a
  sub-tag of that parent, and
  [highlighters](#highlight.tagHighlighter) that don't mention
  this tag will try to fall back to the parent tag (or grandparent
  tag, etc).
  */
  static define(e) {
    if (e != null && e.base)
      throw new Error("Can not derive from a modified tag");
    let t = new Ut([], null, []);
    if (t.set.push(t), e)
      for (let i of e.set)
        t.set.push(i);
    return t;
  }
  /**
  Define a tag _modifier_, which is a function that, given a tag,
  will return a tag that is a subtag of the original. Applying the
  same modifier to a twice tag will return the same value (`m1(t1)
  == m1(t1)`) and applying multiple modifiers will, regardless or
  order, produce the same tag (`m1(m2(t1)) == m2(m1(t1))`).
  
  When multiple modifiers are applied to a given base tag, each
  smaller set of modifiers is registered as a parent, so that for
  example `m1(m2(m3(t1)))` is a subtype of `m1(m2(t1))`,
  `m1(m3(t1)`, and so on.
  */
  static defineModifier() {
    let e = new so();
    return (t) => t.modified.indexOf(e) > -1 ? t : so.get(t.base || t, t.modified.concat(e).sort((i, s) => i.id - s.id));
  }
}
let hw = 0;
class so {
  constructor() {
    this.instances = [], this.id = hw++;
  }
  static get(e, t) {
    if (!t.length)
      return e;
    let i = t[0].instances.find((l) => l.base == e && cw(t, l.modified));
    if (i)
      return i;
    let s = [], r = new Ut(s, e, t);
    for (let l of t)
      l.instances.push(r);
    let o = fw(t);
    for (let l of e.set)
      if (!l.modified.length)
        for (let a of o)
          s.push(so.get(l, a));
    return r;
  }
}
function cw(n, e) {
  return n.length == e.length && n.every((t, i) => t == e[i]);
}
function fw(n) {
  let e = [[]];
  for (let t = 0; t < n.length; t++)
    for (let i = 0, s = e.length; i < s; i++)
      e.push(e[i].concat(n[t]));
  return e.sort((t, i) => i.length - t.length);
}
function uw(n) {
  let e = /* @__PURE__ */ Object.create(null);
  for (let t in n) {
    let i = n[t];
    Array.isArray(i) || (i = [i]);
    for (let s of t.split(" "))
      if (s) {
        let r = [], o = 2, l = s;
        for (let f = 0; ; ) {
          if (l == "..." && f > 0 && f + 3 == s.length) {
            o = 1;
            break;
          }
          let u = /^"(?:[^"\\]|\\.)*?"|[^\/!]+/.exec(l);
          if (!u)
            throw new RangeError("Invalid path: " + s);
          if (r.push(u[0] == "*" ? "" : u[0][0] == '"' ? JSON.parse(u[0]) : u[0]), f += u[0].length, f == s.length)
            break;
          let d = s[f++];
          if (f == s.length && d == "!") {
            o = 0;
            break;
          }
          if (d != "/")
            throw new RangeError("Invalid path: " + s);
          l = s.slice(f);
        }
        let a = r.length - 1, h = r[a];
        if (!h)
          throw new RangeError("Invalid path: " + s);
        let c = new ro(i, o, a > 0 ? r.slice(0, a) : null);
        e[h] = c.sort(e[h]);
      }
  }
  return sp.add(e);
}
const sp = new $();
class ro {
  constructor(e, t, i, s) {
    this.tags = e, this.mode = t, this.context = i, this.next = s;
  }
  get opaque() {
    return this.mode == 0;
  }
  get inherit() {
    return this.mode == 1;
  }
  sort(e) {
    return !e || e.depth < this.depth ? (this.next = e, this) : (e.next = this.sort(e.next), e);
  }
  get depth() {
    return this.context ? this.context.length : 0;
  }
}
ro.empty = new ro([], 2, null);
function rp(n, e) {
  let t = /* @__PURE__ */ Object.create(null);
  for (let r of n)
    if (!Array.isArray(r.tag))
      t[r.tag.id] = r.class;
    else
      for (let o of r.tag)
        t[o.id] = r.class;
  let { scope: i, all: s = null } = e || {};
  return {
    style: (r) => {
      let o = s;
      for (let l of r)
        for (let a of l.set) {
          let h = t[a.id];
          if (h) {
            o = o ? o + " " + h : h;
            break;
          }
        }
      return o;
    },
    scope: i
  };
}
function dw(n, e) {
  let t = null;
  for (let i of n) {
    let s = i.style(e);
    s && (t = t ? t + " " + s : s);
  }
  return t;
}
function op(n, e, t, i = 0, s = n.length) {
  let r = new mw(i, Array.isArray(e) ? e : [e], t);
  r.highlightRange(n.cursor(), i, s, "", r.highlighters), r.flush(s);
}
class mw {
  constructor(e, t, i) {
    this.at = e, this.highlighters = t, this.span = i, this.class = "";
  }
  startSpan(e, t) {
    t != this.class && (this.flush(e), e > this.at && (this.at = e), this.class = t);
  }
  flush(e) {
    e > this.at && this.class && this.span(this.at, e, this.class);
  }
  highlightRange(e, t, i, s, r) {
    let { type: o, from: l, to: a } = e;
    if (l >= i || a <= t)
      return;
    o.isTop && (r = this.highlighters.filter((d) => !d.scope || d.scope(o)));
    let h = s, c = pw(e) || ro.empty, f = dw(r, c.tags);
    if (f && (h && (h += " "), h += f, c.mode == 1 && (s += (s ? " " : "") + f)), this.startSpan(Math.max(t, l), h), c.opaque)
      return;
    let u = e.tree && e.tree.prop($.mounted);
    if (u && u.overlay) {
      let d = e.node.enter(u.overlay[0].from + l, 1), m = this.highlighters.filter((g) => !g.scope || g.scope(u.tree.type)), p = e.firstChild();
      for (let g = 0, b = l; ; g++) {
        let w = g < u.overlay.length ? u.overlay[g] : null, k = w ? w.from + l : a, x = Math.max(t, b), _ = Math.min(i, k);
        if (x < _ && p)
          for (; e.from < _ && (this.highlightRange(e, x, _, s, r), this.startSpan(Math.min(_, e.to), h), !(e.to >= k || !e.nextSibling())); )
            ;
        if (!w || k > i)
          break;
        b = w.to + l, b > t && (this.highlightRange(d.cursor(), Math.max(t, w.from + l), Math.min(i, b), "", m), this.startSpan(Math.min(i, b), h));
      }
      p && e.parent();
    } else if (e.firstChild()) {
      u && (s = "");
      do
        if (!(e.to <= t)) {
          if (e.from >= i)
            break;
          this.highlightRange(e, t, i, s, r), this.startSpan(Math.min(i, e.to), h);
        }
      while (e.nextSibling());
      e.parent();
    }
  }
}
function pw(n) {
  let e = n.type.prop(sp);
  for (; e && e.context && !n.matchContext(e.context); )
    e = e.next;
  return e || null;
}
const L = Ut.define, wr = L(), wi = L(), wf = L(wi), kf = L(wi), ki = L(), kr = L(ki), nl = L(ki), Wt = L(), Hi = L(Wt), Nt = L(), Ft = L(), Sa = L(), es = L(Sa), vr = L(), y = {
  /**
  A comment.
  */
  comment: wr,
  /**
  A line [comment](#highlight.tags.comment).
  */
  lineComment: L(wr),
  /**
  A block [comment](#highlight.tags.comment).
  */
  blockComment: L(wr),
  /**
  A documentation [comment](#highlight.tags.comment).
  */
  docComment: L(wr),
  /**
  Any kind of identifier.
  */
  name: wi,
  /**
  The [name](#highlight.tags.name) of a variable.
  */
  variableName: L(wi),
  /**
  A type [name](#highlight.tags.name).
  */
  typeName: wf,
  /**
  A tag name (subtag of [`typeName`](#highlight.tags.typeName)).
  */
  tagName: L(wf),
  /**
  A property or field [name](#highlight.tags.name).
  */
  propertyName: kf,
  /**
  An attribute name (subtag of [`propertyName`](#highlight.tags.propertyName)).
  */
  attributeName: L(kf),
  /**
  The [name](#highlight.tags.name) of a class.
  */
  className: L(wi),
  /**
  A label [name](#highlight.tags.name).
  */
  labelName: L(wi),
  /**
  A namespace [name](#highlight.tags.name).
  */
  namespace: L(wi),
  /**
  The [name](#highlight.tags.name) of a macro.
  */
  macroName: L(wi),
  /**
  A literal value.
  */
  literal: ki,
  /**
  A string [literal](#highlight.tags.literal).
  */
  string: kr,
  /**
  A documentation [string](#highlight.tags.string).
  */
  docString: L(kr),
  /**
  A character literal (subtag of [string](#highlight.tags.string)).
  */
  character: L(kr),
  /**
  An attribute value (subtag of [string](#highlight.tags.string)).
  */
  attributeValue: L(kr),
  /**
  A number [literal](#highlight.tags.literal).
  */
  number: nl,
  /**
  An integer [number](#highlight.tags.number) literal.
  */
  integer: L(nl),
  /**
  A floating-point [number](#highlight.tags.number) literal.
  */
  float: L(nl),
  /**
  A boolean [literal](#highlight.tags.literal).
  */
  bool: L(ki),
  /**
  Regular expression [literal](#highlight.tags.literal).
  */
  regexp: L(ki),
  /**
  An escape [literal](#highlight.tags.literal), for example a
  backslash escape in a string.
  */
  escape: L(ki),
  /**
  A color [literal](#highlight.tags.literal).
  */
  color: L(ki),
  /**
  A URL [literal](#highlight.tags.literal).
  */
  url: L(ki),
  /**
  A language keyword.
  */
  keyword: Nt,
  /**
  The [keyword](#highlight.tags.keyword) for the self or this
  object.
  */
  self: L(Nt),
  /**
  The [keyword](#highlight.tags.keyword) for null.
  */
  null: L(Nt),
  /**
  A [keyword](#highlight.tags.keyword) denoting some atomic value.
  */
  atom: L(Nt),
  /**
  A [keyword](#highlight.tags.keyword) that represents a unit.
  */
  unit: L(Nt),
  /**
  A modifier [keyword](#highlight.tags.keyword).
  */
  modifier: L(Nt),
  /**
  A [keyword](#highlight.tags.keyword) that acts as an operator.
  */
  operatorKeyword: L(Nt),
  /**
  A control-flow related [keyword](#highlight.tags.keyword).
  */
  controlKeyword: L(Nt),
  /**
  A [keyword](#highlight.tags.keyword) that defines something.
  */
  definitionKeyword: L(Nt),
  /**
  A [keyword](#highlight.tags.keyword) related to defining or
  interfacing with modules.
  */
  moduleKeyword: L(Nt),
  /**
  An operator.
  */
  operator: Ft,
  /**
  An [operator](#highlight.tags.operator) that dereferences something.
  */
  derefOperator: L(Ft),
  /**
  Arithmetic-related [operator](#highlight.tags.operator).
  */
  arithmeticOperator: L(Ft),
  /**
  Logical [operator](#highlight.tags.operator).
  */
  logicOperator: L(Ft),
  /**
  Bit [operator](#highlight.tags.operator).
  */
  bitwiseOperator: L(Ft),
  /**
  Comparison [operator](#highlight.tags.operator).
  */
  compareOperator: L(Ft),
  /**
  [Operator](#highlight.tags.operator) that updates its operand.
  */
  updateOperator: L(Ft),
  /**
  [Operator](#highlight.tags.operator) that defines something.
  */
  definitionOperator: L(Ft),
  /**
  Type-related [operator](#highlight.tags.operator).
  */
  typeOperator: L(Ft),
  /**
  Control-flow [operator](#highlight.tags.operator).
  */
  controlOperator: L(Ft),
  /**
  Program or markup punctuation.
  */
  punctuation: Sa,
  /**
  [Punctuation](#highlight.tags.punctuation) that separates
  things.
  */
  separator: L(Sa),
  /**
  Bracket-style [punctuation](#highlight.tags.punctuation).
  */
  bracket: es,
  /**
  Angle [brackets](#highlight.tags.bracket) (usually `<` and `>`
  tokens).
  */
  angleBracket: L(es),
  /**
  Square [brackets](#highlight.tags.bracket) (usually `[` and `]`
  tokens).
  */
  squareBracket: L(es),
  /**
  Parentheses (usually `(` and `)` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  paren: L(es),
  /**
  Braces (usually `{` and `}` tokens). Subtag of
  [bracket](#highlight.tags.bracket).
  */
  brace: L(es),
  /**
  Content, for example plain text in XML or markup documents.
  */
  content: Wt,
  /**
  [Content](#highlight.tags.content) that represents a heading.
  */
  heading: Hi,
  /**
  A level 1 [heading](#highlight.tags.heading).
  */
  heading1: L(Hi),
  /**
  A level 2 [heading](#highlight.tags.heading).
  */
  heading2: L(Hi),
  /**
  A level 3 [heading](#highlight.tags.heading).
  */
  heading3: L(Hi),
  /**
  A level 4 [heading](#highlight.tags.heading).
  */
  heading4: L(Hi),
  /**
  A level 5 [heading](#highlight.tags.heading).
  */
  heading5: L(Hi),
  /**
  A level 6 [heading](#highlight.tags.heading).
  */
  heading6: L(Hi),
  /**
  A prose separator (such as a horizontal rule).
  */
  contentSeparator: L(Wt),
  /**
  [Content](#highlight.tags.content) that represents a list.
  */
  list: L(Wt),
  /**
  [Content](#highlight.tags.content) that represents a quote.
  */
  quote: L(Wt),
  /**
  [Content](#highlight.tags.content) that is emphasized.
  */
  emphasis: L(Wt),
  /**
  [Content](#highlight.tags.content) that is styled strong.
  */
  strong: L(Wt),
  /**
  [Content](#highlight.tags.content) that is part of a link.
  */
  link: L(Wt),
  /**
  [Content](#highlight.tags.content) that is styled as code or
  monospace.
  */
  monospace: L(Wt),
  /**
  [Content](#highlight.tags.content) that has a strike-through
  style.
  */
  strikethrough: L(Wt),
  /**
  Inserted text in a change-tracking format.
  */
  inserted: L(),
  /**
  Deleted text.
  */
  deleted: L(),
  /**
  Changed text.
  */
  changed: L(),
  /**
  An invalid or unsyntactic element.
  */
  invalid: L(),
  /**
  Metadata or meta-instruction.
  */
  meta: vr,
  /**
  [Metadata](#highlight.tags.meta) that applies to the entire
  document.
  */
  documentMeta: L(vr),
  /**
  [Metadata](#highlight.tags.meta) that annotates or adds
  attributes to a given syntactic element.
  */
  annotation: L(vr),
  /**
  Processing instruction or preprocessor directive. Subtag of
  [meta](#highlight.tags.meta).
  */
  processingInstruction: L(vr),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that a
  given element is being defined. Expected to be used with the
  various [name](#highlight.tags.name) tags.
  */
  definition: Ut.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates that
  something is constant. Mostly expected to be used with
  [variable names](#highlight.tags.variableName).
  */
  constant: Ut.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) used to indicate that
  a [variable](#highlight.tags.variableName) or [property
  name](#highlight.tags.propertyName) is being called or defined
  as a function.
  */
  function: Ut.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that can be applied to
  [names](#highlight.tags.name) to indicate that they belong to
  the language's standard environment.
  */
  standard: Ut.defineModifier(),
  /**
  [Modifier](#highlight.Tag^defineModifier) that indicates a given
  [names](#highlight.tags.name) is local to some scope.
  */
  local: Ut.defineModifier(),
  /**
  A generic variant [modifier](#highlight.Tag^defineModifier) that
  can be used to tag language-specific alternative variants of
  some common tag. It is recommended for themes to define special
  forms of at least the [string](#highlight.tags.string) and
  [variable name](#highlight.tags.variableName) tags, since those
  come up a lot.
  */
  special: Ut.defineModifier()
};
rp([
  { tag: y.link, class: "tok-link" },
  { tag: y.heading, class: "tok-heading" },
  { tag: y.emphasis, class: "tok-emphasis" },
  { tag: y.strong, class: "tok-strong" },
  { tag: y.keyword, class: "tok-keyword" },
  { tag: y.atom, class: "tok-atom" },
  { tag: y.bool, class: "tok-bool" },
  { tag: y.url, class: "tok-url" },
  { tag: y.labelName, class: "tok-labelName" },
  { tag: y.inserted, class: "tok-inserted" },
  { tag: y.deleted, class: "tok-deleted" },
  { tag: y.literal, class: "tok-literal" },
  { tag: y.string, class: "tok-string" },
  { tag: y.number, class: "tok-number" },
  { tag: [y.regexp, y.escape, y.special(y.string)], class: "tok-string2" },
  { tag: y.variableName, class: "tok-variableName" },
  { tag: y.local(y.variableName), class: "tok-variableName tok-local" },
  { tag: y.definition(y.variableName), class: "tok-variableName tok-definition" },
  { tag: y.special(y.variableName), class: "tok-variableName2" },
  { tag: y.definition(y.propertyName), class: "tok-propertyName tok-definition" },
  { tag: y.typeName, class: "tok-typeName" },
  { tag: y.namespace, class: "tok-namespace" },
  { tag: y.className, class: "tok-className" },
  { tag: y.macroName, class: "tok-macroName" },
  { tag: y.propertyName, class: "tok-propertyName" },
  { tag: y.operator, class: "tok-operator" },
  { tag: y.comment, class: "tok-comment" },
  { tag: y.meta, class: "tok-meta" },
  { tag: y.invalid, class: "tok-invalid" },
  { tag: y.punctuation, class: "tok-punctuation" }
]);
var sl;
const ji = /* @__PURE__ */ new $();
function lp(n) {
  return I.define({
    combine: n ? (e) => e.concat(n) : void 0
  });
}
const gw = /* @__PURE__ */ new $();
class ht {
  /**
  Construct a language object. If you need to invoke this
  directly, first define a data facet with
  [`defineLanguageFacet`](https://codemirror.net/6/docs/ref/#language.defineLanguageFacet), and then
  configure your parser to [attach](https://codemirror.net/6/docs/ref/#language.languageDataProp) it
  to the language's outer syntax node.
  */
  constructor(e, t, i = [], s = "") {
    this.data = e, this.name = s, Z.prototype.hasOwnProperty("tree") || Object.defineProperty(Z.prototype, "tree", { get() {
      return Ae(this);
    } }), this.parser = t, this.extension = [
      ui.of(this),
      Z.languageData.of((r, o, l) => {
        let a = vf(r, o, l), h = a.type.prop(ji);
        if (!h)
          return [];
        let c = r.facet(h), f = a.type.prop(gw);
        if (f) {
          let u = a.resolve(o - a.from, l);
          for (let d of f)
            if (d.test(u, r)) {
              let m = r.facet(d.facet);
              return d.type == "replace" ? m : m.concat(c);
            }
        }
        return c;
      })
    ].concat(i);
  }
  /**
  Query whether this language is active at the given position.
  */
  isActiveAt(e, t, i = -1) {
    return vf(e, t, i).type.prop(ji) == this.data;
  }
  /**
  Find the document regions that were parsed using this language.
  The returned regions will _include_ any nested languages rooted
  in this language, when those exist.
  */
  findRegions(e) {
    let t = e.facet(ui);
    if ((t == null ? void 0 : t.data) == this.data)
      return [{ from: 0, to: e.doc.length }];
    if (!t || !t.allowsNesting)
      return [];
    let i = [], s = (r, o) => {
      if (r.prop(ji) == this.data) {
        i.push({ from: o, to: o + r.length });
        return;
      }
      let l = r.prop($.mounted);
      if (l) {
        if (l.tree.prop(ji) == this.data) {
          if (l.overlay)
            for (let a of l.overlay)
              i.push({ from: a.from + o, to: a.to + o });
          else
            i.push({ from: o, to: o + r.length });
          return;
        } else if (l.overlay) {
          let a = i.length;
          if (s(l.tree, l.overlay[0].from + o), i.length > a)
            return;
        }
      }
      for (let a = 0; a < r.children.length; a++) {
        let h = r.children[a];
        h instanceof fe && s(h, r.positions[a] + o);
      }
    };
    return s(Ae(e), 0), i;
  }
  /**
  Indicates whether this language allows nested languages. The
  default implementation returns true.
  */
  get allowsNesting() {
    return !0;
  }
}
ht.setState = /* @__PURE__ */ K.define();
function vf(n, e, t) {
  let i = n.facet(ui), s = Ae(n).topNode;
  if (!i || i.allowsNesting)
    for (let r = s; r; r = r.enter(e, t, pe.ExcludeBuffers))
      r.type.isTop && (s = r);
  return s;
}
class _a extends ht {
  constructor(e, t, i) {
    super(e, t, [], i), this.parser = t;
  }
  /**
  Define a language from a parser.
  */
  static define(e) {
    let t = lp(e.languageData);
    return new _a(t, e.parser.configure({
      props: [ji.add((i) => i.isTop ? t : void 0)]
    }), e.name);
  }
  /**
  Create a new instance of this language with a reconfigured
  version of its parser and optionally a new name.
  */
  configure(e, t) {
    return new _a(this.data, this.parser.configure(e), t || this.name);
  }
  get allowsNesting() {
    return this.parser.hasWrappers();
  }
}
function Ae(n) {
  let e = n.field(ht.state, !1);
  return e ? e.tree : fe.empty;
}
class bw {
  /**
  Create an input object for the given document.
  */
  constructor(e) {
    this.doc = e, this.cursorPos = 0, this.string = "", this.cursor = e.iter();
  }
  get length() {
    return this.doc.length;
  }
  syncTo(e) {
    return this.string = this.cursor.next(e - this.cursorPos).value, this.cursorPos = e + this.string.length, this.cursorPos - this.string.length;
  }
  chunk(e) {
    return this.syncTo(e), this.string;
  }
  get lineChunks() {
    return !0;
  }
  read(e, t) {
    let i = this.cursorPos - this.string.length;
    return e < i || t >= this.cursorPos ? this.doc.sliceString(e, t) : this.string.slice(e - i, t - i);
  }
}
let ts = null;
class In {
  constructor(e, t, i = [], s, r, o, l, a) {
    this.parser = e, this.state = t, this.fragments = i, this.tree = s, this.treeLen = r, this.viewport = o, this.skipped = l, this.scheduleOn = a, this.parse = null, this.tempSkipped = [];
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new In(e, t, [], fe.empty, 0, i, [], null);
  }
  startParse() {
    return this.parser.startParse(new bw(this.state.doc), this.fragments);
  }
  /**
  @internal
  */
  work(e, t) {
    return t != null && t >= this.state.doc.length && (t = void 0), this.tree != fe.empty && this.isDone(t ?? this.state.doc.length) ? (this.takeTree(), !0) : this.withContext(() => {
      var i;
      if (typeof e == "number") {
        let s = Date.now() + e;
        e = () => Date.now() > s;
      }
      for (this.parse || (this.parse = this.startParse()), t != null && (this.parse.stoppedAt == null || this.parse.stoppedAt > t) && t < this.state.doc.length && this.parse.stopAt(t); ; ) {
        let s = this.parse.advance();
        if (s)
          if (this.fragments = this.withoutTempSkipped(hi.addTree(s, this.fragments, this.parse.stoppedAt != null)), this.treeLen = (i = this.parse.stoppedAt) !== null && i !== void 0 ? i : this.state.doc.length, this.tree = s, this.parse = null, this.treeLen < (t ?? this.state.doc.length))
            this.parse = this.startParse();
          else
            return !0;
        if (e())
          return !1;
      }
    });
  }
  /**
  @internal
  */
  takeTree() {
    let e, t;
    this.parse && (e = this.parse.parsedPos) >= this.treeLen && ((this.parse.stoppedAt == null || this.parse.stoppedAt > e) && this.parse.stopAt(e), this.withContext(() => {
      for (; !(t = this.parse.advance()); )
        ;
    }), this.treeLen = e, this.tree = t, this.fragments = this.withoutTempSkipped(hi.addTree(this.tree, this.fragments, !0)), this.parse = null);
  }
  withContext(e) {
    let t = ts;
    ts = this;
    try {
      return e();
    } finally {
      ts = t;
    }
  }
  withoutTempSkipped(e) {
    for (let t; t = this.tempSkipped.pop(); )
      e = xf(e, t.from, t.to);
    return e;
  }
  /**
  @internal
  */
  changes(e, t) {
    let { fragments: i, tree: s, treeLen: r, viewport: o, skipped: l } = this;
    if (this.takeTree(), !e.empty) {
      let a = [];
      if (e.iterChangedRanges((h, c, f, u) => a.push({ fromA: h, toA: c, fromB: f, toB: u })), i = hi.applyChanges(i, a), s = fe.empty, r = 0, o = { from: e.mapPos(o.from, -1), to: e.mapPos(o.to, 1) }, this.skipped.length) {
        l = [];
        for (let h of this.skipped) {
          let c = e.mapPos(h.from, 1), f = e.mapPos(h.to, -1);
          c < f && l.push({ from: c, to: f });
        }
      }
    }
    return new In(this.parser, t, i, s, r, o, l, this.scheduleOn);
  }
  /**
  @internal
  */
  updateViewport(e) {
    if (this.viewport.from == e.from && this.viewport.to == e.to)
      return !1;
    this.viewport = e;
    let t = this.skipped.length;
    for (let i = 0; i < this.skipped.length; i++) {
      let { from: s, to: r } = this.skipped[i];
      s < e.to && r > e.from && (this.fragments = xf(this.fragments, s, r), this.skipped.splice(i--, 1));
    }
    return this.skipped.length >= t ? !1 : (this.reset(), !0);
  }
  /**
  @internal
  */
  reset() {
    this.parse && (this.takeTree(), this.parse = null);
  }
  /**
  Notify the parse scheduler that the given region was skipped
  because it wasn't in view, and the parse should be restarted
  when it comes into view.
  */
  skipUntilInView(e, t) {
    this.skipped.push({ from: e, to: t });
  }
  /**
  Returns a parser intended to be used as placeholder when
  asynchronously loading a nested parser. It'll skip its input and
  mark it as not-really-parsed, so that the next update will parse
  it again.
  
  When `until` is given, a reparse will be scheduled when that
  promise resolves.
  */
  static getSkippingParser(e) {
    return new class extends np {
      createParse(t, i, s) {
        let r = s[0].from, o = s[s.length - 1].to;
        return {
          parsedPos: r,
          advance() {
            let a = ts;
            if (a) {
              for (let h of s)
                a.tempSkipped.push(h);
              e && (a.scheduleOn = a.scheduleOn ? Promise.all([a.scheduleOn, e]) : e);
            }
            return this.parsedPos = o, new fe(Ue.none, [], [], o - r);
          },
          stoppedAt: null,
          stopAt() {
          }
        };
      }
    }();
  }
  /**
  @internal
  */
  isDone(e) {
    e = Math.min(e, this.state.doc.length);
    let t = this.fragments;
    return this.treeLen >= e && t.length && t[0].from == 0 && t[0].to >= e;
  }
  /**
  Get the context for the current parse, or `null` if no editor
  parse is in progress.
  */
  static get() {
    return ts;
  }
}
function xf(n, e, t) {
  return hi.applyChanges(n, [{ fromA: e, toA: t, fromB: e, toB: t }]);
}
class Nn {
  constructor(e) {
    this.context = e, this.tree = e.tree;
  }
  apply(e) {
    if (!e.docChanged && this.tree == this.context.tree)
      return this;
    let t = this.context.changes(e.changes, e.state), i = this.context.treeLen == e.startState.doc.length ? void 0 : Math.max(e.changes.mapPos(this.context.treeLen), t.viewport.to);
    return t.work(20, i) || t.takeTree(), new Nn(t);
  }
  static init(e) {
    let t = Math.min(3e3, e.doc.length), i = In.create(e.facet(ui).parser, e, { from: 0, to: t });
    return i.work(20, t) || i.takeTree(), new Nn(i);
  }
}
ht.state = /* @__PURE__ */ ke.define({
  create: Nn.init,
  update(n, e) {
    for (let t of e.effects)
      if (t.is(ht.setState))
        return t.value;
    return e.startState.facet(ui) != e.state.facet(ui) ? Nn.init(e.state) : n.apply(e);
  }
});
let ap = (n) => {
  let e = setTimeout(
    () => n(),
    500
    /* Work.MaxPause */
  );
  return () => clearTimeout(e);
};
typeof requestIdleCallback < "u" && (ap = (n) => {
  let e = -1, t = setTimeout(
    () => {
      e = requestIdleCallback(n, {
        timeout: 400
        /* Work.MinPause */
      });
    },
    100
    /* Work.MinPause */
  );
  return () => e < 0 ? clearTimeout(t) : cancelIdleCallback(e);
});
const rl = typeof navigator < "u" && (!((sl = navigator.scheduling) === null || sl === void 0) && sl.isInputPending) ? () => navigator.scheduling.isInputPending() : null, yw = /* @__PURE__ */ be.fromClass(class {
  constructor(e) {
    this.view = e, this.working = null, this.workScheduled = 0, this.chunkEnd = -1, this.chunkBudget = -1, this.work = this.work.bind(this), this.scheduleWork();
  }
  update(e) {
    let t = this.view.state.field(ht.state).context;
    (t.updateViewport(e.view.viewport) || this.view.viewport.to > t.treeLen) && this.scheduleWork(), (e.docChanged || e.selectionSet) && (this.view.hasFocus && (this.chunkBudget += 50), this.scheduleWork()), this.checkAsyncSchedule(t);
  }
  scheduleWork() {
    if (this.working)
      return;
    let { state: e } = this.view, t = e.field(ht.state);
    (t.tree != t.context.tree || !t.context.isDone(e.doc.length)) && (this.working = ap(this.work));
  }
  work(e) {
    this.working = null;
    let t = Date.now();
    if (this.chunkEnd < t && (this.chunkEnd < 0 || this.view.hasFocus) && (this.chunkEnd = t + 3e4, this.chunkBudget = 3e3), this.chunkBudget <= 0)
      return;
    let { state: i, viewport: { to: s } } = this.view, r = i.field(ht.state);
    if (r.tree == r.context.tree && r.context.isDone(
      s + 1e5
      /* Work.MaxParseAhead */
    ))
      return;
    let o = Date.now() + Math.min(this.chunkBudget, 100, e && !rl ? Math.max(25, e.timeRemaining() - 5) : 1e9), l = r.context.treeLen < s && i.doc.length > s + 1e3, a = r.context.work(() => rl && rl() || Date.now() > o, s + (l ? 0 : 1e5));
    this.chunkBudget -= Date.now() - t, (a || this.chunkBudget <= 0) && (r.context.takeTree(), this.view.dispatch({ effects: ht.setState.of(new Nn(r.context)) })), this.chunkBudget > 0 && !(a && !l) && this.scheduleWork(), this.checkAsyncSchedule(r.context);
  }
  checkAsyncSchedule(e) {
    e.scheduleOn && (this.workScheduled++, e.scheduleOn.then(() => this.scheduleWork()).catch((t) => Je(this.view.state, t)).then(() => this.workScheduled--), e.scheduleOn = null);
  }
  destroy() {
    this.working && this.working();
  }
  isWorking() {
    return !!(this.working || this.workScheduled > 0);
  }
}, {
  eventHandlers: { focus() {
    this.scheduleWork();
  } }
}), ui = /* @__PURE__ */ I.define({
  combine(n) {
    return n.length ? n[0] : null;
  },
  enables: (n) => [
    ht.state,
    yw,
    O.contentAttributes.compute([n], (e) => {
      let t = e.facet(n);
      return t && t.name ? { "data-language": t.name } : {};
    })
  ]
});
class FM {
  /**
  Create a language support object.
  */
  constructor(e, t = []) {
    this.language = e, this.support = t, this.extension = [e, t];
  }
}
class hp {
  constructor(e, t, i, s, r, o = void 0) {
    this.name = e, this.alias = t, this.extensions = i, this.filename = s, this.loadFunc = r, this.support = o, this.loading = null;
  }
  /**
  Start loading the the language. Will return a promise that
  resolves to a [`LanguageSupport`](https://codemirror.net/6/docs/ref/#language.LanguageSupport)
  object when the language successfully loads.
  */
  load() {
    return this.loading || (this.loading = this.loadFunc().then((e) => this.support = e, (e) => {
      throw this.loading = null, e;
    }));
  }
  /**
  Create a language description.
  */
  static of(e) {
    let { load: t, support: i } = e;
    if (!t) {
      if (!i)
        throw new RangeError("Must pass either 'load' or 'support' to LanguageDescription.of");
      t = () => Promise.resolve(i);
    }
    return new hp(e.name, (e.alias || []).concat(e.name).map((s) => s.toLowerCase()), e.extensions || [], e.filename, t, i);
  }
  /**
  Look for a language in the given array of descriptions that
  matches the filename. Will first match
  [`filename`](https://codemirror.net/6/docs/ref/#language.LanguageDescription.filename) patterns,
  and then [extensions](https://codemirror.net/6/docs/ref/#language.LanguageDescription.extensions),
  and return the first language that matches.
  */
  static matchFilename(e, t) {
    for (let s of e)
      if (s.filename && s.filename.test(t))
        return s;
    let i = /\.([^.]+)$/.exec(t);
    if (i) {
      for (let s of e)
        if (s.extensions.indexOf(i[1]) > -1)
          return s;
    }
    return null;
  }
  /**
  Look for a language whose name or alias matches the the given
  name (case-insensitively). If `fuzzy` is true, and no direct
  matchs is found, this'll also search for a language whose name
  or alias occurs in the string (for names shorter than three
  characters, only when surrounded by non-word characters).
  */
  static matchLanguageName(e, t, i = !0) {
    t = t.toLowerCase();
    for (let s of e)
      if (s.alias.some((r) => r == t))
        return s;
    if (i)
      for (let s of e)
        for (let r of s.alias) {
          let o = t.indexOf(r);
          if (o > -1 && (r.length > 2 || !/\w/.test(t[o - 1]) && !/\w/.test(t[o + r.length])))
            return s;
        }
    return null;
  }
}
const cp = /* @__PURE__ */ I.define(), Do = /* @__PURE__ */ I.define({
  combine: (n) => {
    if (!n.length)
      return "  ";
    let e = n[0];
    if (!e || /\S/.test(e) || Array.from(e).some((t) => t != e[0]))
      throw new Error("Invalid indent unit: " + JSON.stringify(n[0]));
    return e;
  }
});
function $i(n) {
  let e = n.facet(Do);
  return e.charCodeAt(0) == 9 ? n.tabSize * e.length : e.length;
}
function Ns(n, e) {
  let t = "", i = n.tabSize, s = n.facet(Do)[0];
  if (s == "	") {
    for (; e >= i; )
      t += "	", e -= i;
    s = " ";
  }
  for (let r = 0; r < e; r++)
    t += s;
  return t;
}
function lh(n, e) {
  n instanceof Z && (n = new Oo(n));
  for (let i of n.state.facet(cp)) {
    let s = i(n, e);
    if (s !== void 0)
      return s;
  }
  let t = Ae(n.state);
  return t.length >= e ? kw(n, t, e) : null;
}
class Oo {
  /**
  Create an indent context.
  */
  constructor(e, t = {}) {
    this.state = e, this.options = t, this.unit = $i(e);
  }
  /**
  Get a description of the line at the given position, taking
  [simulated line
  breaks](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  into account. If there is such a break at `pos`, the `bias`
  argument determines whether the part of the line line before or
  after the break is used.
  */
  lineAt(e, t = 1) {
    let i = this.state.doc.lineAt(e), { simulateBreak: s, simulateDoubleBreak: r } = this.options;
    return s != null && s >= i.from && s <= i.to ? r && s == e ? { text: "", from: e } : (t < 0 ? s < e : s <= e) ? { text: i.text.slice(s - i.from), from: s } : { text: i.text.slice(0, s - i.from), from: i.from } : i;
  }
  /**
  Get the text directly after `pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  textAfterPos(e, t = 1) {
    if (this.options.simulateDoubleBreak && e == this.options.simulateBreak)
      return "";
    let { text: i, from: s } = this.lineAt(e, t);
    return i.slice(e - s, Math.min(i.length, e + 100 - s));
  }
  /**
  Find the column for the given position.
  */
  column(e, t = 1) {
    let { text: i, from: s } = this.lineAt(e, t), r = this.countColumn(i, e - s), o = this.options.overrideIndentation ? this.options.overrideIndentation(s) : -1;
    return o > -1 && (r += o - this.countColumn(i, i.search(/\S|$/))), r;
  }
  /**
  Find the column position (taking tabs into account) of the given
  position in the given string.
  */
  countColumn(e, t = e.length) {
    return Wn(e, this.state.tabSize, t);
  }
  /**
  Find the indentation column of the line at the given point.
  */
  lineIndent(e, t = 1) {
    let { text: i, from: s } = this.lineAt(e, t), r = this.options.overrideIndentation;
    if (r) {
      let o = r(s);
      if (o > -1)
        return o;
    }
    return this.countColumn(i, i.search(/\S|$/));
  }
  /**
  Returns the [simulated line
  break](https://codemirror.net/6/docs/ref/#language.IndentContext.constructor^options.simulateBreak)
  for this context, if any.
  */
  get simulatedBreak() {
    return this.options.simulateBreak || null;
  }
}
const ww = /* @__PURE__ */ new $();
function kw(n, e, t) {
  let i = e.resolveStack(t), s = i.node.enterUnfinishedNodesBefore(t);
  if (s != i.node) {
    let r = [];
    for (let o = s; o != i.node; o = o.parent)
      r.push(o);
    for (let o = r.length - 1; o >= 0; o--)
      i = { node: r[o], next: i };
  }
  return fp(i, n, t);
}
function fp(n, e, t) {
  for (let i = n; i; i = i.next) {
    let s = xw(i.node);
    if (s)
      return s(ah.create(e, t, i));
  }
  return 0;
}
function vw(n) {
  return n.pos == n.options.simulateBreak && n.options.simulateDoubleBreak;
}
function xw(n) {
  let e = n.type.prop(ww);
  if (e)
    return e;
  let t = n.firstChild, i;
  if (t && (i = t.type.prop($.closedBy))) {
    let s = n.lastChild, r = s && i.indexOf(s.name) > -1;
    return (o) => up(o, !0, 1, void 0, r && !vw(o) ? s.from : void 0);
  }
  return n.parent == null ? Sw : null;
}
function Sw() {
  return 0;
}
class ah extends Oo {
  constructor(e, t, i) {
    super(e.state, e.options), this.base = e, this.pos = t, this.context = i;
  }
  /**
  The syntax tree node to which the indentation strategy
  applies.
  */
  get node() {
    return this.context.node;
  }
  /**
  @internal
  */
  static create(e, t, i) {
    return new ah(e, t, i);
  }
  /**
  Get the text directly after `this.pos`, either the entire line
  or the next 100 characters, whichever is shorter.
  */
  get textAfter() {
    return this.textAfterPos(this.pos);
  }
  /**
  Get the indentation at the reference line for `this.node`, which
  is the line on which it starts, unless there is a node that is
  _not_ a parent of this node covering the start of that line. If
  so, the line at the start of that node is tried, again skipping
  on if it is covered by another such node.
  */
  get baseIndent() {
    return this.baseIndentFor(this.node);
  }
  /**
  Get the indentation for the reference line of the given node
  (see [`baseIndent`](https://codemirror.net/6/docs/ref/#language.TreeIndentContext.baseIndent)).
  */
  baseIndentFor(e) {
    let t = this.state.doc.lineAt(e.from);
    for (; ; ) {
      let i = e.resolve(t.from);
      for (; i.parent && i.parent.from == i.from; )
        i = i.parent;
      if (_w(i, e))
        break;
      t = this.state.doc.lineAt(i.from);
    }
    return this.lineIndent(t.from);
  }
  /**
  Continue looking for indentations in the node's parent nodes,
  and return the result of that.
  */
  continue() {
    return fp(this.context.next, this.base, this.pos);
  }
}
function _w(n, e) {
  for (let t = e; t; t = t.parent)
    if (n == t)
      return !0;
  return !1;
}
function Cw(n) {
  let e = n.node, t = e.childAfter(e.from), i = e.lastChild;
  if (!t)
    return null;
  let s = n.options.simulateBreak, r = n.state.doc.lineAt(t.from), o = s == null || s <= r.from ? r.to : Math.min(r.to, s);
  for (let l = t.to; ; ) {
    let a = e.childAfter(l);
    if (!a || a == i)
      return null;
    if (!a.type.isSkipped)
      return a.from < o ? t : null;
    l = a.to;
  }
}
function HM({ closing: n, align: e = !0, units: t = 1 }) {
  return (i) => up(i, e, t, n);
}
function up(n, e, t, i, s) {
  let r = n.textAfter, o = r.match(/^\s*/)[0].length, l = i && r.slice(o, o + i.length) == i || s == n.pos + o, a = e ? Cw(n) : null;
  return a ? l ? n.column(a.from) : n.column(a.to) : n.baseIndent + (l ? 0 : n.unit * t);
}
const VM = (n) => n.baseIndent;
function WM({ except: n, units: e = 1 } = {}) {
  return (t) => {
    let i = n && n.test(t.textAfter);
    return t.baseIndent + (i ? 0 : e * t.unit);
  };
}
const Aw = 200;
function dp() {
  return Z.transactionFilter.of((n) => {
    if (!n.docChanged || !n.isUserEvent("input.type") && !n.isUserEvent("input.complete"))
      return n;
    let e = n.startState.languageDataAt("indentOnInput", n.startState.selection.main.head);
    if (!e.length)
      return n;
    let t = n.newDoc, { head: i } = n.newSelection.main, s = t.lineAt(i);
    if (i > s.from + Aw)
      return n;
    let r = t.sliceString(s.from, i);
    if (!e.some((h) => h.test(r)))
      return n;
    let { state: o } = n, l = -1, a = [];
    for (let { head: h } of o.selection.ranges) {
      let c = o.doc.lineAt(h);
      if (c.from == l)
        continue;
      l = c.from;
      let f = lh(o, c.from);
      if (f == null)
        continue;
      let u = /^\s*/.exec(c.text)[0], d = Ns(o, f);
      u != d && a.push({ from: c.from, to: c.from + u.length, insert: d });
    }
    return a.length ? [n, { changes: a, sequential: !0 }] : n;
  });
}
const Mw = /* @__PURE__ */ I.define(), Tw = /* @__PURE__ */ new $();
function zM(n) {
  let e = n.firstChild, t = n.lastChild;
  return e && e.to < t.from ? { from: e.to, to: t.type.isError ? n.to : t.from } : null;
}
function Dw(n, e, t) {
  let i = Ae(n);
  if (i.length < t)
    return null;
  let s = i.resolveStack(t, 1), r = null;
  for (let o = s; o; o = o.next) {
    let l = o.node;
    if (l.to <= t || l.from > t)
      continue;
    if (r && l.from < e)
      break;
    let a = l.type.prop(Tw);
    if (a && (l.to < i.length - 50 || i.length == n.doc.length || !Ow(l))) {
      let h = a(l, n);
      h && h.from <= t && h.from >= e && h.to > t && (r = h);
    }
  }
  return r;
}
function Ow(n) {
  let e = n.lastChild;
  return e && e.to == n.to && e.type.isError;
}
function oo(n, e, t) {
  for (let i of n.facet(Mw)) {
    let s = i(n, e, t);
    if (s)
      return s;
  }
  return Dw(n, e, t);
}
function mp(n, e) {
  let t = e.mapPos(n.from, 1), i = e.mapPos(n.to, -1);
  return t >= i ? void 0 : { from: t, to: i };
}
const Eo = /* @__PURE__ */ K.define({ map: mp }), Js = /* @__PURE__ */ K.define({ map: mp });
function pp(n) {
  let e = [];
  for (let { head: t } of n.state.selection.ranges)
    e.some((i) => i.from <= t && i.to >= t) || e.push(n.lineBlockAt(t));
  return e;
}
const en = /* @__PURE__ */ ke.define({
  create() {
    return N.none;
  },
  update(n, e) {
    n = n.map(e.changes);
    for (let t of e.effects)
      if (t.is(Eo) && !Ew(n, t.value.from, t.value.to)) {
        let { preparePlaceholder: i } = e.state.facet(wp), s = i ? N.replace({ widget: new Nw(i(e.state, t.value)) }) : Sf;
        n = n.update({ add: [s.range(t.value.from, t.value.to)] });
      } else t.is(Js) && (n = n.update({
        filter: (i, s) => t.value.from != i || t.value.to != s,
        filterFrom: t.value.from,
        filterTo: t.value.to
      }));
    if (e.selection) {
      let t = !1, { head: i } = e.selection.main;
      n.between(i, i, (s, r) => {
        s < i && r > i && (t = !0);
      }), t && (n = n.update({
        filterFrom: i,
        filterTo: i,
        filter: (s, r) => r <= i || s >= i
      }));
    }
    return n;
  },
  provide: (n) => O.decorations.from(n),
  toJSON(n, e) {
    let t = [];
    return n.between(0, e.doc.length, (i, s) => {
      t.push(i, s);
    }), t;
  },
  fromJSON(n) {
    if (!Array.isArray(n) || n.length % 2)
      throw new RangeError("Invalid JSON for fold state");
    let e = [];
    for (let t = 0; t < n.length; ) {
      let i = n[t++], s = n[t++];
      if (typeof i != "number" || typeof s != "number")
        throw new RangeError("Invalid JSON for fold state");
      e.push(Sf.range(i, s));
    }
    return N.set(e, !0);
  }
});
function lo(n, e, t) {
  var i;
  let s = null;
  return (i = n.field(en, !1)) === null || i === void 0 || i.between(e, t, (r, o) => {
    (!s || s.from > r) && (s = { from: r, to: o });
  }), s;
}
function Ew(n, e, t) {
  let i = !1;
  return n.between(e, e, (s, r) => {
    s == e && r == t && (i = !0);
  }), i;
}
function gp(n, e) {
  return n.field(en, !1) ? e : e.concat(K.appendConfig.of(kp()));
}
const Lw = (n) => {
  for (let e of pp(n)) {
    let t = oo(n.state, e.from, e.to);
    if (t)
      return n.dispatch({ effects: gp(n.state, [Eo.of(t), bp(n, t)]) }), !0;
  }
  return !1;
}, Rw = (n) => {
  if (!n.state.field(en, !1))
    return !1;
  let e = [];
  for (let t of pp(n)) {
    let i = lo(n.state, t.from, t.to);
    i && e.push(Js.of(i), bp(n, i, !1));
  }
  return e.length && n.dispatch({ effects: e }), e.length > 0;
};
function bp(n, e, t = !0) {
  let i = n.state.doc.lineAt(e.from).number, s = n.state.doc.lineAt(e.to).number;
  return O.announce.of(`${n.state.phrase(t ? "Folded lines" : "Unfolded lines")} ${i} ${n.state.phrase("to")} ${s}.`);
}
const Pw = (n) => {
  let { state: e } = n, t = [];
  for (let i = 0; i < e.doc.length; ) {
    let s = n.lineBlockAt(i), r = oo(e, s.from, s.to);
    r && t.push(Eo.of(r)), i = (r ? n.lineBlockAt(r.to) : s).to + 1;
  }
  return t.length && n.dispatch({ effects: gp(n.state, t) }), !!t.length;
}, Bw = (n) => {
  let e = n.state.field(en, !1);
  if (!e || !e.size)
    return !1;
  let t = [];
  return e.between(0, n.state.doc.length, (i, s) => {
    t.push(Js.of({ from: i, to: s }));
  }), n.dispatch({ effects: t }), !0;
}, yp = [
  { key: "Ctrl-Shift-[", mac: "Cmd-Alt-[", run: Lw },
  { key: "Ctrl-Shift-]", mac: "Cmd-Alt-]", run: Rw },
  { key: "Ctrl-Alt-[", run: Pw },
  { key: "Ctrl-Alt-]", run: Bw }
], Iw = {
  placeholderDOM: null,
  preparePlaceholder: null,
  placeholderText: "…"
}, wp = /* @__PURE__ */ I.define({
  combine(n) {
    return ti(n, Iw);
  }
});
function kp(n) {
  return [en, Hw];
}
function vp(n, e) {
  let { state: t } = n, i = t.facet(wp), s = (o) => {
    let l = n.lineBlockAt(n.posAtDOM(o.target)), a = lo(n.state, l.from, l.to);
    a && n.dispatch({ effects: Js.of(a) }), o.preventDefault();
  };
  if (i.placeholderDOM)
    return i.placeholderDOM(n, s, e);
  let r = document.createElement("span");
  return r.textContent = i.placeholderText, r.setAttribute("aria-label", t.phrase("folded code")), r.title = t.phrase("unfold"), r.className = "cm-foldPlaceholder", r.onclick = s, r;
}
const Sf = /* @__PURE__ */ N.replace({ widget: /* @__PURE__ */ new class extends Lt {
  toDOM(n) {
    return vp(n, null);
  }
}() });
class Nw extends Lt {
  constructor(e) {
    super(), this.value = e;
  }
  eq(e) {
    return this.value == e.value;
  }
  toDOM(e) {
    return vp(e, this.value);
  }
}
const Fw = {
  openText: "⌄",
  closedText: "›",
  markerDOM: null,
  domEventHandlers: {},
  foldingChanged: () => !1
};
class ol extends Et {
  constructor(e, t) {
    super(), this.config = e, this.open = t;
  }
  eq(e) {
    return this.config == e.config && this.open == e.open;
  }
  toDOM(e) {
    if (this.config.markerDOM)
      return this.config.markerDOM(this.open);
    let t = document.createElement("span");
    return t.textContent = this.open ? this.config.openText : this.config.closedText, t.title = e.state.phrase(this.open ? "Fold line" : "Unfold line"), t;
  }
}
function xp(n = {}) {
  let e = Object.assign(Object.assign({}, Fw), n), t = new ol(e, !0), i = new ol(e, !1), s = be.fromClass(class {
    constructor(o) {
      this.from = o.viewport.from, this.markers = this.buildMarkers(o);
    }
    update(o) {
      (o.docChanged || o.viewportChanged || o.startState.facet(ui) != o.state.facet(ui) || o.startState.field(en, !1) != o.state.field(en, !1) || Ae(o.startState) != Ae(o.state) || e.foldingChanged(o)) && (this.markers = this.buildMarkers(o.view));
    }
    buildMarkers(o) {
      let l = new Tt();
      for (let a of o.viewportLineBlocks) {
        let h = lo(o.state, a.from, a.to) ? i : oo(o.state, a.from, a.to) ? t : null;
        h && l.add(a.from, a.from, h);
      }
      return l.finish();
    }
  }), { domEventHandlers: r } = e;
  return [
    s,
    Jm({
      class: "cm-foldGutter",
      markers(o) {
        var l;
        return ((l = o.plugin(s)) === null || l === void 0 ? void 0 : l.markers) || ne.empty;
      },
      initialSpacer() {
        return new ol(e, !1);
      },
      domEventHandlers: Object.assign(Object.assign({}, r), { click: (o, l, a) => {
        if (r.click && r.click(o, l, a))
          return !0;
        let h = lo(o.state, l.from, l.to);
        if (h)
          return o.dispatch({ effects: Js.of(h) }), !0;
        let c = oo(o.state, l.from, l.to);
        return c ? (o.dispatch({ effects: Eo.of(c) }), !0) : !1;
      } })
    }),
    kp()
  ];
}
const Hw = /* @__PURE__ */ O.baseTheme({
  ".cm-foldPlaceholder": {
    backgroundColor: "#eee",
    border: "1px solid #ddd",
    color: "#888",
    borderRadius: ".2em",
    margin: "0 1px",
    padding: "0 1px",
    cursor: "pointer"
  },
  ".cm-foldGutter span": {
    padding: "0 1px",
    cursor: "pointer"
  }
});
class zn {
  constructor(e, t) {
    this.specs = e;
    let i;
    function s(l) {
      let a = Di.newName();
      return (i || (i = /* @__PURE__ */ Object.create(null)))["." + a] = l, a;
    }
    const r = typeof t.all == "string" ? t.all : t.all ? s(t.all) : void 0, o = t.scope;
    this.scope = o instanceof ht ? (l) => l.prop(ji) == o.data : o ? (l) => l == o : void 0, this.style = rp(e.map((l) => ({
      tag: l.tag,
      class: l.class || s(Object.assign({}, l, { tag: null }))
    })), {
      all: r
    }).style, this.module = i ? new Di(i) : null, this.themeType = t.themeType;
  }
  /**
  Create a highlighter style that associates the given styles to
  the given tags. The specs must be objects that hold a style tag
  or array of tags in their `tag` property, and either a single
  `class` property providing a static CSS class (for highlighter
  that rely on external styling), or a
  [`style-mod`](https://github.com/marijnh/style-mod#documentation)-style
  set of CSS properties (which define the styling for those tags).
  
  The CSS rules created for a highlighter will be emitted in the
  order of the spec's properties. That means that for elements that
  have multiple tags associated with them, styles defined further
  down in the list will have a higher CSS precedence than styles
  defined earlier.
  */
  static define(e, t) {
    return new zn(e, t || {});
  }
}
const Ca = /* @__PURE__ */ I.define(), Sp = /* @__PURE__ */ I.define({
  combine(n) {
    return n.length ? [n[0]] : null;
  }
});
function Kr(n) {
  let e = n.facet(Ca);
  return e.length ? e : n.facet(Sp);
}
function Lo(n, e) {
  let t = [zw], i;
  return n instanceof zn && (n.module && t.push(O.styleModule.of(n.module)), i = n.themeType), e != null && e.fallback ? t.push(Sp.of(n)) : i ? t.push(Ca.computeN([O.darkTheme], (s) => s.facet(O.darkTheme) == (i == "dark") ? [n] : [])) : t.push(Ca.of(n)), t;
}
function Vw(n, e, t) {
  let i = Kr(n), s = null;
  if (i) {
    for (let r of i)
      if (!r.scope || t) {
        let o = r.style(e);
        o && (s = s ? s + " " + o : o);
      }
  }
  return s;
}
class Ww {
  constructor(e) {
    this.markCache = /* @__PURE__ */ Object.create(null), this.tree = Ae(e.state), this.decorations = this.buildDeco(e, Kr(e.state)), this.decoratedTo = e.viewport.to;
  }
  update(e) {
    let t = Ae(e.state), i = Kr(e.state), s = i != Kr(e.startState), { viewport: r } = e.view, o = e.changes.mapPos(this.decoratedTo, 1);
    t.length < r.to && !s && t.type == this.tree.type && o >= r.to ? (this.decorations = this.decorations.map(e.changes), this.decoratedTo = o) : (t != this.tree || e.viewportChanged || s) && (this.tree = t, this.decorations = this.buildDeco(e.view, i), this.decoratedTo = r.to);
  }
  buildDeco(e, t) {
    if (!t || !this.tree.length)
      return N.none;
    let i = new Tt();
    for (let { from: s, to: r } of e.visibleRanges)
      op(this.tree, t, (o, l, a) => {
        i.add(o, l, this.markCache[a] || (this.markCache[a] = N.mark({ class: a })));
      }, s, r);
    return i.finish();
  }
}
const zw = /* @__PURE__ */ ei.high(/* @__PURE__ */ be.fromClass(Ww, {
  decorations: (n) => n.decorations
})), _p = /* @__PURE__ */ zn.define([
  {
    tag: y.meta,
    color: "#404740"
  },
  {
    tag: y.link,
    textDecoration: "underline"
  },
  {
    tag: y.heading,
    textDecoration: "underline",
    fontWeight: "bold"
  },
  {
    tag: y.emphasis,
    fontStyle: "italic"
  },
  {
    tag: y.strong,
    fontWeight: "bold"
  },
  {
    tag: y.strikethrough,
    textDecoration: "line-through"
  },
  {
    tag: y.keyword,
    color: "#708"
  },
  {
    tag: [y.atom, y.bool, y.url, y.contentSeparator, y.labelName],
    color: "#219"
  },
  {
    tag: [y.literal, y.inserted],
    color: "#164"
  },
  {
    tag: [y.string, y.deleted],
    color: "#a11"
  },
  {
    tag: [y.regexp, y.escape, /* @__PURE__ */ y.special(y.string)],
    color: "#e40"
  },
  {
    tag: /* @__PURE__ */ y.definition(y.variableName),
    color: "#00f"
  },
  {
    tag: /* @__PURE__ */ y.local(y.variableName),
    color: "#30a"
  },
  {
    tag: [y.typeName, y.namespace],
    color: "#085"
  },
  {
    tag: y.className,
    color: "#167"
  },
  {
    tag: [/* @__PURE__ */ y.special(y.variableName), y.macroName],
    color: "#256"
  },
  {
    tag: /* @__PURE__ */ y.definition(y.propertyName),
    color: "#00c"
  },
  {
    tag: y.comment,
    color: "#940"
  },
  {
    tag: y.invalid,
    color: "#f00"
  }
]), qw = /* @__PURE__ */ O.baseTheme({
  "&.cm-focused .cm-matchingBracket": { backgroundColor: "#328c8252" },
  "&.cm-focused .cm-nonmatchingBracket": { backgroundColor: "#bb555544" }
}), Cp = 1e4, Ap = "()[]{}", Mp = /* @__PURE__ */ I.define({
  combine(n) {
    return ti(n, {
      afterCursor: !0,
      brackets: Ap,
      maxScanDistance: Cp,
      renderMatch: Kw
    });
  }
}), Uw = /* @__PURE__ */ N.mark({ class: "cm-matchingBracket" }), jw = /* @__PURE__ */ N.mark({ class: "cm-nonmatchingBracket" });
function Kw(n) {
  let e = [], t = n.matched ? Uw : jw;
  return e.push(t.range(n.start.from, n.start.to)), n.end && e.push(t.range(n.end.from, n.end.to)), e;
}
const Gw = /* @__PURE__ */ ke.define({
  create() {
    return N.none;
  },
  update(n, e) {
    if (!e.docChanged && !e.selection)
      return n;
    let t = [], i = e.state.facet(Mp);
    for (let s of e.state.selection.ranges) {
      if (!s.empty)
        continue;
      let r = Yt(e.state, s.head, -1, i) || s.head > 0 && Yt(e.state, s.head - 1, 1, i) || i.afterCursor && (Yt(e.state, s.head, 1, i) || s.head < e.state.doc.length && Yt(e.state, s.head + 1, -1, i));
      r && (t = t.concat(i.renderMatch(r, e.state)));
    }
    return N.set(t, !0);
  },
  provide: (n) => O.decorations.from(n)
}), Yw = [
  Gw,
  qw
];
function Xw(n = {}) {
  return [Mp.of(n), Yw];
}
const Jw = /* @__PURE__ */ new $();
function Aa(n, e, t) {
  let i = n.prop(e < 0 ? $.openedBy : $.closedBy);
  if (i)
    return i;
  if (n.name.length == 1) {
    let s = t.indexOf(n.name);
    if (s > -1 && s % 2 == (e < 0 ? 1 : 0))
      return [t[s + e]];
  }
  return null;
}
function Ma(n) {
  let e = n.type.prop(Jw);
  return e ? e(n.node) : n;
}
function Yt(n, e, t, i = {}) {
  let s = i.maxScanDistance || Cp, r = i.brackets || Ap, o = Ae(n), l = o.resolveInner(e, t);
  for (let a = l; a; a = a.parent) {
    let h = Aa(a.type, t, r);
    if (h && a.from < a.to) {
      let c = Ma(a);
      if (c && (t > 0 ? e >= c.from && e < c.to : e > c.from && e <= c.to))
        return Qw(n, e, t, a, c, h, r);
    }
  }
  return Zw(n, e, t, o, l.type, s, r);
}
function Qw(n, e, t, i, s, r, o) {
  let l = i.parent, a = { from: s.from, to: s.to }, h = 0, c = l == null ? void 0 : l.cursor();
  if (c && (t < 0 ? c.childBefore(i.from) : c.childAfter(i.to)))
    do
      if (t < 0 ? c.to <= i.from : c.from >= i.to) {
        if (h == 0 && r.indexOf(c.type.name) > -1 && c.from < c.to) {
          let f = Ma(c);
          return { start: a, end: f ? { from: f.from, to: f.to } : void 0, matched: !0 };
        } else if (Aa(c.type, t, o))
          h++;
        else if (Aa(c.type, -t, o)) {
          if (h == 0) {
            let f = Ma(c);
            return {
              start: a,
              end: f && f.from < f.to ? { from: f.from, to: f.to } : void 0,
              matched: !1
            };
          }
          h--;
        }
      }
    while (t < 0 ? c.prevSibling() : c.nextSibling());
  return { start: a, matched: !1 };
}
function Zw(n, e, t, i, s, r, o) {
  let l = t < 0 ? n.sliceDoc(e - 1, e) : n.sliceDoc(e, e + 1), a = o.indexOf(l);
  if (a < 0 || a % 2 == 0 != t > 0)
    return null;
  let h = { from: t < 0 ? e - 1 : e, to: t > 0 ? e + 1 : e }, c = n.doc.iterRange(e, t > 0 ? n.doc.length : 0), f = 0;
  for (let u = 0; !c.next().done && u <= r; ) {
    let d = c.value;
    t < 0 && (u += d.length);
    let m = e + u * t;
    for (let p = t > 0 ? 0 : d.length - 1, g = t > 0 ? d.length : -1; p != g; p += t) {
      let b = o.indexOf(d[p]);
      if (!(b < 0 || i.resolveInner(m + p, 1).type != s))
        if (b % 2 == 0 == t > 0)
          f++;
        else {
          if (f == 1)
            return { start: h, end: { from: m + p, to: m + p + 1 }, matched: b >> 1 == a >> 1 };
          f--;
        }
    }
    t > 0 && (u += d.length);
  }
  return c.done ? { start: h, matched: !1 } : null;
}
function _f(n, e, t, i = 0, s = 0) {
  e == null && (e = n.search(/[^\s\u00a0]/), e == -1 && (e = n.length));
  let r = s;
  for (let o = i; o < e; o++)
    n.charCodeAt(o) == 9 ? r += t - r % t : r++;
  return r;
}
class Tp {
  /**
  Create a stream.
  */
  constructor(e, t, i, s) {
    this.string = e, this.tabSize = t, this.indentUnit = i, this.overrideIndent = s, this.pos = 0, this.start = 0, this.lastColumnPos = 0, this.lastColumnValue = 0;
  }
  /**
  True if we are at the end of the line.
  */
  eol() {
    return this.pos >= this.string.length;
  }
  /**
  True if we are at the start of the line.
  */
  sol() {
    return this.pos == 0;
  }
  /**
  Get the next code unit after the current position, or undefined
  if we're at the end of the line.
  */
  peek() {
    return this.string.charAt(this.pos) || void 0;
  }
  /**
  Read the next code unit and advance `this.pos`.
  */
  next() {
    if (this.pos < this.string.length)
      return this.string.charAt(this.pos++);
  }
  /**
  Match the next character against the given string, regular
  expression, or predicate. Consume and return it if it matches.
  */
  eat(e) {
    let t = this.string.charAt(this.pos), i;
    if (typeof e == "string" ? i = t == e : i = t && (e instanceof RegExp ? e.test(t) : e(t)), i)
      return ++this.pos, t;
  }
  /**
  Continue matching characters that match the given string,
  regular expression, or predicate function. Return true if any
  characters were consumed.
  */
  eatWhile(e) {
    let t = this.pos;
    for (; this.eat(e); )
      ;
    return this.pos > t;
  }
  /**
  Consume whitespace ahead of `this.pos`. Return true if any was
  found.
  */
  eatSpace() {
    let e = this.pos;
    for (; /[\s\u00a0]/.test(this.string.charAt(this.pos)); )
      ++this.pos;
    return this.pos > e;
  }
  /**
  Move to the end of the line.
  */
  skipToEnd() {
    this.pos = this.string.length;
  }
  /**
  Move to directly before the given character, if found on the
  current line.
  */
  skipTo(e) {
    let t = this.string.indexOf(e, this.pos);
    if (t > -1)
      return this.pos = t, !0;
  }
  /**
  Move back `n` characters.
  */
  backUp(e) {
    this.pos -= e;
  }
  /**
  Get the column position at `this.pos`.
  */
  column() {
    return this.lastColumnPos < this.start && (this.lastColumnValue = _f(this.string, this.start, this.tabSize, this.lastColumnPos, this.lastColumnValue), this.lastColumnPos = this.start), this.lastColumnValue;
  }
  /**
  Get the indentation column of the current line.
  */
  indentation() {
    var e;
    return (e = this.overrideIndent) !== null && e !== void 0 ? e : _f(this.string, null, this.tabSize);
  }
  /**
  Match the input against the given string or regular expression
  (which should start with a `^`). Return true or the regexp match
  if it matches.
  
  Unless `consume` is set to `false`, this will move `this.pos`
  past the matched text.
  
  When matching a string `caseInsensitive` can be set to true to
  make the match case-insensitive.
  */
  match(e, t, i) {
    if (typeof e == "string") {
      let s = (o) => i ? o.toLowerCase() : o, r = this.string.substr(this.pos, e.length);
      return s(r) == s(e) ? (t !== !1 && (this.pos += e.length), !0) : null;
    } else {
      let s = this.string.slice(this.pos).match(e);
      return s && s.index > 0 ? null : (s && t !== !1 && (this.pos += s[0].length), s);
    }
  }
  /**
  Get the current token.
  */
  current() {
    return this.string.slice(this.start, this.pos);
  }
}
function $w(n) {
  return {
    name: n.name || "",
    token: n.token,
    blankLine: n.blankLine || (() => {
    }),
    startState: n.startState || (() => !0),
    copyState: n.copyState || ek,
    indent: n.indent || (() => null),
    languageData: n.languageData || {},
    tokenTable: n.tokenTable || ch
  };
}
function ek(n) {
  if (typeof n != "object")
    return n;
  let e = {};
  for (let t in n) {
    let i = n[t];
    e[t] = i instanceof Array ? i.slice() : i;
  }
  return e;
}
const Cf = /* @__PURE__ */ new WeakMap();
class zt extends ht {
  constructor(e) {
    let t = lp(e.languageData), i = $w(e), s, r = new class extends np {
      createParse(o, l, a) {
        return new ik(s, o, l, a);
      }
    }();
    super(t, r, [cp.of((o, l) => this.getIndent(o, l))], e.name), this.topNode = rk(t), s = this, this.streamParser = i, this.stateAfter = new $({ perNode: !0 }), this.tokenTable = e.tokenTable ? new Lp(i.tokenTable) : sk;
  }
  /**
  Define a stream language.
  */
  static define(e) {
    return new zt(e);
  }
  getIndent(e, t) {
    let i = Ae(e.state), s = i.resolve(t);
    for (; s && s.type != this.topNode; )
      s = s.parent;
    if (!s)
      return null;
    let r, { overrideIndentation: o } = e.options;
    o && (r = Cf.get(e.state), r != null && r < t - 1e4 && (r = void 0));
    let l = hh(this, i, 0, s.from, r ?? t), a, h;
    if (l ? (h = l.state, a = l.pos + 1) : (h = this.streamParser.startState(e.unit), a = 0), t - a > 1e4)
      return null;
    for (; a < t; ) {
      let f = e.state.doc.lineAt(a), u = Math.min(t, f.to);
      if (f.length) {
        let d = o ? o(f.from) : -1, m = new Tp(f.text, e.state.tabSize, e.unit, d < 0 ? void 0 : d);
        for (; m.pos < u - f.from; )
          Op(this.streamParser.token, m, h);
      } else
        this.streamParser.blankLine(h, e.unit);
      if (u == t)
        break;
      a = f.to + 1;
    }
    let c = e.lineAt(t);
    return o && r == null && Cf.set(e.state, c.from), this.streamParser.indent(h, /^\s*(.*)/.exec(c.text)[1], e);
  }
  get allowsNesting() {
    return !1;
  }
}
function hh(n, e, t, i, s) {
  let r = t >= i && t + e.length <= s && e.prop(n.stateAfter);
  if (r)
    return { state: n.streamParser.copyState(r), pos: t + e.length };
  for (let o = e.children.length - 1; o >= 0; o--) {
    let l = e.children[o], a = t + e.positions[o], h = l instanceof fe && a < s && hh(n, l, a, i, s);
    if (h)
      return h;
  }
  return null;
}
function Dp(n, e, t, i, s) {
  if (s && t <= 0 && i >= e.length)
    return e;
  !s && e.type == n.topNode && (s = !0);
  for (let r = e.children.length - 1; r >= 0; r--) {
    let o = e.positions[r], l = e.children[r], a;
    if (o < i && l instanceof fe) {
      if (!(a = Dp(n, l, t - o, i - o, s)))
        break;
      return s ? new fe(e.type, e.children.slice(0, r).concat(a), e.positions.slice(0, r + 1), o + a.length) : a;
    }
  }
  return null;
}
function tk(n, e, t, i) {
  for (let s of e) {
    let r = s.from + (s.openStart ? 25 : 0), o = s.to - (s.openEnd ? 25 : 0), l = r <= t && o > t && hh(n, s.tree, 0 - s.offset, t, o), a;
    if (l && (a = Dp(n, s.tree, t + s.offset, l.pos + s.offset, !1)))
      return { state: l.state, tree: a };
  }
  return { state: n.streamParser.startState(i ? $i(i) : 4), tree: fe.empty };
}
class ik {
  constructor(e, t, i, s) {
    this.lang = e, this.input = t, this.fragments = i, this.ranges = s, this.stoppedAt = null, this.chunks = [], this.chunkPos = [], this.chunk = [], this.chunkReused = void 0, this.rangeIndex = 0, this.to = s[s.length - 1].to;
    let r = In.get(), o = s[0].from, { state: l, tree: a } = tk(e, i, o, r == null ? void 0 : r.state);
    this.state = l, this.parsedPos = this.chunkStart = o + a.length;
    for (let h = 0; h < a.children.length; h++)
      this.chunks.push(a.children[h]), this.chunkPos.push(a.positions[h]);
    r && this.parsedPos < r.viewport.from - 1e5 && (this.state = this.lang.streamParser.startState($i(r.state)), r.skipUntilInView(this.parsedPos, r.viewport.from), this.parsedPos = r.viewport.from), this.moveRangeIndex();
  }
  advance() {
    let e = In.get(), t = this.stoppedAt == null ? this.to : Math.min(this.to, this.stoppedAt), i = Math.min(
      t,
      this.chunkStart + 2048
      /* C.ChunkSize */
    );
    for (e && (i = Math.min(i, e.viewport.to)); this.parsedPos < i; )
      this.parseLine(e);
    return this.chunkStart < this.parsedPos && this.finishChunk(), this.parsedPos >= t ? this.finish() : e && this.parsedPos >= e.viewport.to ? (e.skipUntilInView(this.parsedPos, t), this.finish()) : null;
  }
  stopAt(e) {
    this.stoppedAt = e;
  }
  lineAfter(e) {
    let t = this.input.chunk(e);
    if (this.input.lineChunks)
      t == `
` && (t = "");
    else {
      let i = t.indexOf(`
`);
      i > -1 && (t = t.slice(0, i));
    }
    return e + t.length <= this.to ? t : t.slice(0, this.to - e);
  }
  nextLine() {
    let e = this.parsedPos, t = this.lineAfter(e), i = e + t.length;
    for (let s = this.rangeIndex; ; ) {
      let r = this.ranges[s].to;
      if (r >= i || (t = t.slice(0, r - (i - t.length)), s++, s == this.ranges.length))
        break;
      let o = this.ranges[s].from, l = this.lineAfter(o);
      t += l, i = o + l.length;
    }
    return { line: t, end: i };
  }
  skipGapsTo(e, t, i) {
    for (; ; ) {
      let s = this.ranges[this.rangeIndex].to, r = e + t;
      if (i > 0 ? s > r : s >= r)
        break;
      let o = this.ranges[++this.rangeIndex].from;
      t += o - s;
    }
    return t;
  }
  moveRangeIndex() {
    for (; this.ranges[this.rangeIndex].to < this.parsedPos; )
      this.rangeIndex++;
  }
  emitToken(e, t, i, s, r) {
    if (this.ranges.length > 1) {
      r = this.skipGapsTo(t, r, 1), t += r;
      let o = this.chunk.length;
      r = this.skipGapsTo(i, r, -1), i += r, s += this.chunk.length - o;
    }
    return this.chunk.push(e, t, i, s), r;
  }
  parseLine(e) {
    let { line: t, end: i } = this.nextLine(), s = 0, { streamParser: r } = this.lang, o = new Tp(t, e ? e.state.tabSize : 4, e ? $i(e.state) : 2);
    if (o.eol())
      r.blankLine(this.state, o.indentUnit);
    else
      for (; !o.eol(); ) {
        let l = Op(r.token, o, this.state);
        if (l && (s = this.emitToken(this.lang.tokenTable.resolve(l), this.parsedPos + o.start, this.parsedPos + o.pos, 4, s)), o.start > 1e4)
          break;
      }
    this.parsedPos = i, this.moveRangeIndex(), this.parsedPos < this.to && this.parsedPos++;
  }
  finishChunk() {
    let e = fe.build({
      buffer: this.chunk,
      start: this.chunkStart,
      length: this.parsedPos - this.chunkStart,
      nodeSet: nk,
      topID: 0,
      maxBufferLength: 2048,
      reused: this.chunkReused
    });
    e = new fe(e.type, e.children, e.positions, e.length, [[this.lang.stateAfter, this.lang.streamParser.copyState(this.state)]]), this.chunks.push(e), this.chunkPos.push(this.chunkStart - this.ranges[0].from), this.chunk = [], this.chunkReused = void 0, this.chunkStart = this.parsedPos;
  }
  finish() {
    return new fe(this.lang.topNode, this.chunks, this.chunkPos, this.parsedPos - this.ranges[0].from).balance();
  }
}
function Op(n, e, t) {
  e.start = e.pos;
  for (let i = 0; i < 10; i++) {
    let s = n(e, t);
    if (e.pos > e.start)
      return s;
  }
  throw new Error("Stream parser failed to advance stream.");
}
const ch = /* @__PURE__ */ Object.create(null), Fs = [Ue.none], nk = /* @__PURE__ */ new nh(Fs), Af = [], Mf = /* @__PURE__ */ Object.create(null), Ep = /* @__PURE__ */ Object.create(null);
for (let [n, e] of [
  ["variable", "variableName"],
  ["variable-2", "variableName.special"],
  ["string-2", "string.special"],
  ["def", "variableName.definition"],
  ["tag", "tagName"],
  ["attribute", "attributeName"],
  ["type", "typeName"],
  ["builtin", "variableName.standard"],
  ["qualifier", "modifier"],
  ["error", "invalid"],
  ["header", "heading"],
  ["property", "propertyName"]
])
  Ep[n] = /* @__PURE__ */ Rp(ch, e);
class Lp {
  constructor(e) {
    this.extra = e, this.table = Object.assign(/* @__PURE__ */ Object.create(null), Ep);
  }
  resolve(e) {
    return e ? this.table[e] || (this.table[e] = Rp(this.extra, e)) : 0;
  }
}
const sk = /* @__PURE__ */ new Lp(ch);
function ll(n, e) {
  Af.indexOf(n) > -1 || (Af.push(n), console.warn(e));
}
function Rp(n, e) {
  let t = [];
  for (let l of e.split(" ")) {
    let a = [];
    for (let h of l.split(".")) {
      let c = n[h] || y[h];
      c ? typeof c == "function" ? a.length ? a = a.map(c) : ll(h, `Modifier ${h} used at start of tag`) : a.length ? ll(h, `Tag ${h} used as modifier`) : a = Array.isArray(c) ? c : [c] : ll(h, `Unknown highlighting tag ${h}`);
    }
    for (let h of a)
      t.push(h);
  }
  if (!t.length)
    return 0;
  let i = e.replace(/ /g, "_"), s = i + " " + t.map((l) => l.id), r = Mf[s];
  if (r)
    return r.id;
  let o = Mf[s] = Ue.define({
    id: Fs.length,
    name: i,
    props: [uw({ [i]: t })]
  });
  return Fs.push(o), o.id;
}
function rk(n) {
  let e = Ue.define({ id: Fs.length, name: "Document", props: [ji.add(() => n)], top: !0 });
  return Fs.push(e), e;
}
de.RTL, de.LTR;
const ok = (n) => {
  let { state: e } = n, t = e.doc.lineAt(e.selection.main.from), i = uh(n.state, t.from);
  return i.line ? lk(n) : i.block ? hk(n) : !1;
};
function fh(n, e) {
  return ({ state: t, dispatch: i }) => {
    if (t.readOnly)
      return !1;
    let s = n(e, t);
    return s ? (i(t.update(s)), !0) : !1;
  };
}
const lk = /* @__PURE__ */ fh(
  uk,
  0
  /* CommentOption.Toggle */
), ak = /* @__PURE__ */ fh(
  Pp,
  0
  /* CommentOption.Toggle */
), hk = /* @__PURE__ */ fh(
  (n, e) => Pp(n, e, fk(e)),
  0
  /* CommentOption.Toggle */
);
function uh(n, e) {
  let t = n.languageDataAt("commentTokens", e);
  return t.length ? t[0] : {};
}
const is = 50;
function ck(n, { open: e, close: t }, i, s) {
  let r = n.sliceDoc(i - is, i), o = n.sliceDoc(s, s + is), l = /\s*$/.exec(r)[0].length, a = /^\s*/.exec(o)[0].length, h = r.length - l;
  if (r.slice(h - e.length, h) == e && o.slice(a, a + t.length) == t)
    return {
      open: { pos: i - l, margin: l && 1 },
      close: { pos: s + a, margin: a && 1 }
    };
  let c, f;
  s - i <= 2 * is ? c = f = n.sliceDoc(i, s) : (c = n.sliceDoc(i, i + is), f = n.sliceDoc(s - is, s));
  let u = /^\s*/.exec(c)[0].length, d = /\s*$/.exec(f)[0].length, m = f.length - d - t.length;
  return c.slice(u, u + e.length) == e && f.slice(m, m + t.length) == t ? {
    open: {
      pos: i + u + e.length,
      margin: /\s/.test(c.charAt(u + e.length)) ? 1 : 0
    },
    close: {
      pos: s - d - t.length,
      margin: /\s/.test(f.charAt(m - 1)) ? 1 : 0
    }
  } : null;
}
function fk(n) {
  let e = [];
  for (let t of n.selection.ranges) {
    let i = n.doc.lineAt(t.from), s = t.to <= i.to ? i : n.doc.lineAt(t.to), r = e.length - 1;
    r >= 0 && e[r].to > i.from ? e[r].to = s.to : e.push({ from: i.from + /^\s*/.exec(i.text)[0].length, to: s.to });
  }
  return e;
}
function Pp(n, e, t = e.selection.ranges) {
  let i = t.map((r) => uh(e, r.from).block);
  if (!i.every((r) => r))
    return null;
  let s = t.map((r, o) => ck(e, i[o], r.from, r.to));
  if (n != 2 && !s.every((r) => r))
    return { changes: e.changes(t.map((r, o) => s[o] ? [] : [{ from: r.from, insert: i[o].open + " " }, { from: r.to, insert: " " + i[o].close }])) };
  if (n != 1 && s.some((r) => r)) {
    let r = [];
    for (let o = 0, l; o < s.length; o++)
      if (l = s[o]) {
        let a = i[o], { open: h, close: c } = l;
        r.push({ from: h.pos - a.open.length, to: h.pos + h.margin }, { from: c.pos - c.margin, to: c.pos + a.close.length });
      }
    return { changes: r };
  }
  return null;
}
function uk(n, e, t = e.selection.ranges) {
  let i = [], s = -1;
  for (let { from: r, to: o } of t) {
    let l = i.length, a = 1e9, h = uh(e, r).line;
    if (h) {
      for (let c = r; c <= o; ) {
        let f = e.doc.lineAt(c);
        if (f.from > s && (r == o || o > f.from)) {
          s = f.from;
          let u = /^\s*/.exec(f.text)[0].length, d = u == f.length, m = f.text.slice(u, u + h.length) == h ? u : -1;
          u < f.text.length && u < a && (a = u), i.push({ line: f, comment: m, token: h, indent: u, empty: d, single: !1 });
        }
        c = f.to + 1;
      }
      if (a < 1e9)
        for (let c = l; c < i.length; c++)
          i[c].indent < i[c].line.text.length && (i[c].indent = a);
      i.length == l + 1 && (i[l].single = !0);
    }
  }
  if (n != 2 && i.some((r) => r.comment < 0 && (!r.empty || r.single))) {
    let r = [];
    for (let { line: l, token: a, indent: h, empty: c, single: f } of i)
      (f || !c) && r.push({ from: l.from + h, insert: a + " " });
    let o = e.changes(r);
    return { changes: o, selection: e.selection.map(o, 1) };
  } else if (n != 1 && i.some((r) => r.comment >= 0)) {
    let r = [];
    for (let { line: o, comment: l, token: a } of i)
      if (l >= 0) {
        let h = o.from + l, c = h + a.length;
        o.text[c - o.from] == " " && c++, r.push({ from: h, to: c });
      }
    return { changes: r };
  }
  return null;
}
const Ta = /* @__PURE__ */ di.define(), dk = /* @__PURE__ */ di.define(), mk = /* @__PURE__ */ I.define(), Bp = /* @__PURE__ */ I.define({
  combine(n) {
    return ti(n, {
      minDepth: 100,
      newGroupDelay: 500,
      joinToEvent: (e, t) => t
    }, {
      minDepth: Math.max,
      newGroupDelay: Math.min,
      joinToEvent: (e, t) => (i, s) => e(i, s) || t(i, s)
    });
  }
}), Ip = /* @__PURE__ */ ke.define({
  create() {
    return Xt.empty;
  },
  update(n, e) {
    let t = e.state.facet(Bp), i = e.annotation(Ta);
    if (i) {
      let a = Qe.fromTransaction(e, i.selection), h = i.side, c = h == 0 ? n.undone : n.done;
      return a ? c = ao(c, c.length, t.minDepth, a) : c = Vp(c, e.startState.selection), new Xt(h == 0 ? i.rest : c, h == 0 ? c : i.rest);
    }
    let s = e.annotation(dk);
    if ((s == "full" || s == "before") && (n = n.isolate()), e.annotation(_e.addToHistory) === !1)
      return e.changes.empty ? n : n.addMapping(e.changes.desc);
    let r = Qe.fromTransaction(e), o = e.annotation(_e.time), l = e.annotation(_e.userEvent);
    return r ? n = n.addChanges(r, o, l, t, e) : e.selection && (n = n.addSelection(e.startState.selection, o, l, t.newGroupDelay)), (s == "full" || s == "after") && (n = n.isolate()), n;
  },
  toJSON(n) {
    return { done: n.done.map((e) => e.toJSON()), undone: n.undone.map((e) => e.toJSON()) };
  },
  fromJSON(n) {
    return new Xt(n.done.map(Qe.fromJSON), n.undone.map(Qe.fromJSON));
  }
});
function Np(n = {}) {
  return [
    Ip,
    Bp.of(n),
    O.domEventHandlers({
      beforeinput(e, t) {
        let i = e.inputType == "historyUndo" ? Fp : e.inputType == "historyRedo" ? Da : null;
        return i ? (e.preventDefault(), i(t)) : !1;
      }
    })
  ];
}
function Ro(n, e) {
  return function({ state: t, dispatch: i }) {
    if (!e && t.readOnly)
      return !1;
    let s = t.field(Ip, !1);
    if (!s)
      return !1;
    let r = s.pop(n, t, e);
    return r ? (i(r), !0) : !1;
  };
}
const Fp = /* @__PURE__ */ Ro(0, !1), Da = /* @__PURE__ */ Ro(1, !1), pk = /* @__PURE__ */ Ro(0, !0), gk = /* @__PURE__ */ Ro(1, !0);
class Qe {
  constructor(e, t, i, s, r) {
    this.changes = e, this.effects = t, this.mapped = i, this.startSelection = s, this.selectionsAfter = r;
  }
  setSelAfter(e) {
    return new Qe(this.changes, this.effects, this.mapped, this.startSelection, e);
  }
  toJSON() {
    var e, t, i;
    return {
      changes: (e = this.changes) === null || e === void 0 ? void 0 : e.toJSON(),
      mapped: (t = this.mapped) === null || t === void 0 ? void 0 : t.toJSON(),
      startSelection: (i = this.startSelection) === null || i === void 0 ? void 0 : i.toJSON(),
      selectionsAfter: this.selectionsAfter.map((s) => s.toJSON())
    };
  }
  static fromJSON(e) {
    return new Qe(e.changes && Se.fromJSON(e.changes), [], e.mapped && Zt.fromJSON(e.mapped), e.startSelection && C.fromJSON(e.startSelection), e.selectionsAfter.map(C.fromJSON));
  }
  // This does not check `addToHistory` and such, it assumes the
  // transaction needs to be converted to an item. Returns null when
  // there are no changes or effects in the transaction.
  static fromTransaction(e, t) {
    let i = ct;
    for (let s of e.startState.facet(mk)) {
      let r = s(e);
      r.length && (i = i.concat(r));
    }
    return !i.length && e.changes.empty ? null : new Qe(e.changes.invert(e.startState.doc), i, void 0, t || e.startState.selection, ct);
  }
  static selection(e) {
    return new Qe(void 0, ct, void 0, void 0, e);
  }
}
function ao(n, e, t, i) {
  let s = e + 1 > t + 20 ? e - t - 1 : 0, r = n.slice(s, e);
  return r.push(i), r;
}
function bk(n, e) {
  let t = [], i = !1;
  return n.iterChangedRanges((s, r) => t.push(s, r)), e.iterChangedRanges((s, r, o, l) => {
    for (let a = 0; a < t.length; ) {
      let h = t[a++], c = t[a++];
      l >= h && o <= c && (i = !0);
    }
  }), i;
}
function yk(n, e) {
  return n.ranges.length == e.ranges.length && n.ranges.filter((t, i) => t.empty != e.ranges[i].empty).length === 0;
}
function Hp(n, e) {
  return n.length ? e.length ? n.concat(e) : n : e;
}
const ct = [], wk = 200;
function Vp(n, e) {
  if (n.length) {
    let t = n[n.length - 1], i = t.selectionsAfter.slice(Math.max(0, t.selectionsAfter.length - wk));
    return i.length && i[i.length - 1].eq(e) ? n : (i.push(e), ao(n, n.length - 1, 1e9, t.setSelAfter(i)));
  } else
    return [Qe.selection([e])];
}
function kk(n) {
  let e = n[n.length - 1], t = n.slice();
  return t[n.length - 1] = e.setSelAfter(e.selectionsAfter.slice(0, e.selectionsAfter.length - 1)), t;
}
function al(n, e) {
  if (!n.length)
    return n;
  let t = n.length, i = ct;
  for (; t; ) {
    let s = vk(n[t - 1], e, i);
    if (s.changes && !s.changes.empty || s.effects.length) {
      let r = n.slice(0, t);
      return r[t - 1] = s, r;
    } else
      e = s.mapped, t--, i = s.selectionsAfter;
  }
  return i.length ? [Qe.selection(i)] : ct;
}
function vk(n, e, t) {
  let i = Hp(n.selectionsAfter.length ? n.selectionsAfter.map((l) => l.map(e)) : ct, t);
  if (!n.changes)
    return Qe.selection(i);
  let s = n.changes.map(e), r = e.mapDesc(n.changes, !0), o = n.mapped ? n.mapped.composeDesc(r) : r;
  return new Qe(s, K.mapEffects(n.effects, e), o, n.startSelection.map(r), i);
}
const xk = /^(input\.type|delete)($|\.)/;
class Xt {
  constructor(e, t, i = 0, s = void 0) {
    this.done = e, this.undone = t, this.prevTime = i, this.prevUserEvent = s;
  }
  isolate() {
    return this.prevTime ? new Xt(this.done, this.undone) : this;
  }
  addChanges(e, t, i, s, r) {
    let o = this.done, l = o[o.length - 1];
    return l && l.changes && !l.changes.empty && e.changes && (!i || xk.test(i)) && (!l.selectionsAfter.length && t - this.prevTime < s.newGroupDelay && s.joinToEvent(r, bk(l.changes, e.changes)) || // For compose (but not compose.start) events, always join with previous event
    i == "input.type.compose") ? o = ao(o, o.length - 1, s.minDepth, new Qe(e.changes.compose(l.changes), Hp(e.effects, l.effects), l.mapped, l.startSelection, ct)) : o = ao(o, o.length, s.minDepth, e), new Xt(o, ct, t, i);
  }
  addSelection(e, t, i, s) {
    let r = this.done.length ? this.done[this.done.length - 1].selectionsAfter : ct;
    return r.length > 0 && t - this.prevTime < s && i == this.prevUserEvent && i && /^select($|\.)/.test(i) && yk(r[r.length - 1], e) ? this : new Xt(Vp(this.done, e), this.undone, t, i);
  }
  addMapping(e) {
    return new Xt(al(this.done, e), al(this.undone, e), this.prevTime, this.prevUserEvent);
  }
  pop(e, t, i) {
    let s = e == 0 ? this.done : this.undone;
    if (s.length == 0)
      return null;
    let r = s[s.length - 1], o = r.selectionsAfter[0] || t.selection;
    if (i && r.selectionsAfter.length)
      return t.update({
        selection: r.selectionsAfter[r.selectionsAfter.length - 1],
        annotations: Ta.of({ side: e, rest: kk(s), selection: o }),
        userEvent: e == 0 ? "select.undo" : "select.redo",
        scrollIntoView: !0
      });
    if (r.changes) {
      let l = s.length == 1 ? ct : s.slice(0, s.length - 1);
      return r.mapped && (l = al(l, r.mapped)), t.update({
        changes: r.changes,
        selection: r.startSelection,
        effects: r.effects,
        annotations: Ta.of({ side: e, rest: l, selection: o }),
        filter: !1,
        userEvent: e == 0 ? "undo" : "redo",
        scrollIntoView: !0
      });
    } else
      return null;
  }
}
Xt.empty = /* @__PURE__ */ new Xt(ct, ct);
const Wp = [
  { key: "Mod-z", run: Fp, preventDefault: !0 },
  { key: "Mod-y", mac: "Mod-Shift-z", run: Da, preventDefault: !0 },
  { linux: "Ctrl-Shift-z", run: Da, preventDefault: !0 },
  { key: "Mod-u", run: pk, preventDefault: !0 },
  { key: "Alt-u", mac: "Mod-Shift-u", run: gk, preventDefault: !0 }
];
function qn(n, e) {
  return C.create(n.ranges.map(e), n.mainIndex);
}
function ii(n, e) {
  return n.update({ selection: e, scrollIntoView: !0, userEvent: "select" });
}
function Rt({ state: n, dispatch: e }, t) {
  let i = qn(n.selection, t);
  return i.eq(n.selection, !0) ? !1 : (e(ii(n, i)), !0);
}
function Po(n, e) {
  return C.cursor(e ? n.to : n.from);
}
function zp(n, e) {
  return Rt(n, (t) => t.empty ? n.moveByChar(t, e) : Po(t, e));
}
function Fe(n) {
  return n.textDirectionAt(n.state.selection.main.head) == de.LTR;
}
const qp = (n) => zp(n, !Fe(n)), Up = (n) => zp(n, Fe(n));
function jp(n, e) {
  return Rt(n, (t) => t.empty ? n.moveByGroup(t, e) : Po(t, e));
}
const Sk = (n) => jp(n, !Fe(n)), _k = (n) => jp(n, Fe(n));
function Ck(n, e, t) {
  if (e.type.prop(t))
    return !0;
  let i = e.to - e.from;
  return i && (i > 2 || /[^\s,.;:]/.test(n.sliceDoc(e.from, e.to))) || e.firstChild;
}
function Bo(n, e, t) {
  let i = Ae(n).resolveInner(e.head), s = t ? $.closedBy : $.openedBy;
  for (let a = e.head; ; ) {
    let h = t ? i.childAfter(a) : i.childBefore(a);
    if (!h)
      break;
    Ck(n, h, s) ? i = h : a = t ? h.to : h.from;
  }
  let r = i.type.prop(s), o, l;
  return r && (o = t ? Yt(n, i.from, 1) : Yt(n, i.to, -1)) && o.matched ? l = t ? o.end.to : o.end.from : l = t ? i.to : i.from, C.cursor(l, t ? -1 : 1);
}
const Ak = (n) => Rt(n, (e) => Bo(n.state, e, !Fe(n))), Mk = (n) => Rt(n, (e) => Bo(n.state, e, Fe(n)));
function Kp(n, e) {
  return Rt(n, (t) => {
    if (!t.empty)
      return Po(t, e);
    let i = n.moveVertically(t, e);
    return i.head != t.head ? i : n.moveToLineBoundary(t, e);
  });
}
const Gp = (n) => Kp(n, !1), Yp = (n) => Kp(n, !0);
function Xp(n) {
  let e = n.scrollDOM.clientHeight < n.scrollDOM.scrollHeight - 2, t = 0, i = 0, s;
  if (e) {
    for (let r of n.state.facet(O.scrollMargins)) {
      let o = r(n);
      o != null && o.top && (t = Math.max(o == null ? void 0 : o.top, t)), o != null && o.bottom && (i = Math.max(o == null ? void 0 : o.bottom, i));
    }
    s = n.scrollDOM.clientHeight - t - i;
  } else
    s = (n.dom.ownerDocument.defaultView || window).innerHeight;
  return {
    marginTop: t,
    marginBottom: i,
    selfScroll: e,
    height: Math.max(n.defaultLineHeight, s - 5)
  };
}
function Jp(n, e) {
  let t = Xp(n), { state: i } = n, s = qn(i.selection, (o) => o.empty ? n.moveVertically(o, e, t.height) : Po(o, e));
  if (s.eq(i.selection))
    return !1;
  let r;
  if (t.selfScroll) {
    let o = n.coordsAtPos(i.selection.main.head), l = n.scrollDOM.getBoundingClientRect(), a = l.top + t.marginTop, h = l.bottom - t.marginBottom;
    o && o.top > a && o.bottom < h && (r = O.scrollIntoView(s.main.head, { y: "start", yMargin: o.top - a }));
  }
  return n.dispatch(ii(i, s), { effects: r }), !0;
}
const Tf = (n) => Jp(n, !1), Oa = (n) => Jp(n, !0);
function Ii(n, e, t) {
  let i = n.lineBlockAt(e.head), s = n.moveToLineBoundary(e, t);
  if (s.head == e.head && s.head != (t ? i.to : i.from) && (s = n.moveToLineBoundary(e, t, !1)), !t && s.head == i.from && i.length) {
    let r = /^\s*/.exec(n.state.sliceDoc(i.from, Math.min(i.from + 100, i.to)))[0].length;
    r && e.head != i.from + r && (s = C.cursor(i.from + r));
  }
  return s;
}
const Tk = (n) => Rt(n, (e) => Ii(n, e, !0)), Dk = (n) => Rt(n, (e) => Ii(n, e, !1)), Ok = (n) => Rt(n, (e) => Ii(n, e, !Fe(n))), Ek = (n) => Rt(n, (e) => Ii(n, e, Fe(n))), Lk = (n) => Rt(n, (e) => C.cursor(n.lineBlockAt(e.head).from, 1)), Rk = (n) => Rt(n, (e) => C.cursor(n.lineBlockAt(e.head).to, -1));
function Pk(n, e, t) {
  let i = !1, s = qn(n.selection, (r) => {
    let o = Yt(n, r.head, -1) || Yt(n, r.head, 1) || r.head > 0 && Yt(n, r.head - 1, 1) || r.head < n.doc.length && Yt(n, r.head + 1, -1);
    if (!o || !o.end)
      return r;
    i = !0;
    let l = o.start.from == r.head ? o.end.to : o.end.from;
    return C.cursor(l);
  });
  return i ? (e(ii(n, s)), !0) : !1;
}
const Bk = ({ state: n, dispatch: e }) => Pk(n, e);
function yt(n, e) {
  let t = qn(n.state.selection, (i) => {
    let s = e(i);
    return C.range(i.anchor, s.head, s.goalColumn, s.bidiLevel || void 0);
  });
  return t.eq(n.state.selection) ? !1 : (n.dispatch(ii(n.state, t)), !0);
}
function Qp(n, e) {
  return yt(n, (t) => n.moveByChar(t, e));
}
const Zp = (n) => Qp(n, !Fe(n)), $p = (n) => Qp(n, Fe(n));
function eg(n, e) {
  return yt(n, (t) => n.moveByGroup(t, e));
}
const Ik = (n) => eg(n, !Fe(n)), Nk = (n) => eg(n, Fe(n)), Fk = (n) => yt(n, (e) => Bo(n.state, e, !Fe(n))), Hk = (n) => yt(n, (e) => Bo(n.state, e, Fe(n)));
function tg(n, e) {
  return yt(n, (t) => n.moveVertically(t, e));
}
const ig = (n) => tg(n, !1), ng = (n) => tg(n, !0);
function sg(n, e) {
  return yt(n, (t) => n.moveVertically(t, e, Xp(n).height));
}
const Df = (n) => sg(n, !1), Of = (n) => sg(n, !0), Vk = (n) => yt(n, (e) => Ii(n, e, !0)), Wk = (n) => yt(n, (e) => Ii(n, e, !1)), zk = (n) => yt(n, (e) => Ii(n, e, !Fe(n))), qk = (n) => yt(n, (e) => Ii(n, e, Fe(n))), Uk = (n) => yt(n, (e) => C.cursor(n.lineBlockAt(e.head).from)), jk = (n) => yt(n, (e) => C.cursor(n.lineBlockAt(e.head).to)), Ef = ({ state: n, dispatch: e }) => (e(ii(n, { anchor: 0 })), !0), Lf = ({ state: n, dispatch: e }) => (e(ii(n, { anchor: n.doc.length })), !0), Rf = ({ state: n, dispatch: e }) => (e(ii(n, { anchor: n.selection.main.anchor, head: 0 })), !0), Pf = ({ state: n, dispatch: e }) => (e(ii(n, { anchor: n.selection.main.anchor, head: n.doc.length })), !0), Kk = ({ state: n, dispatch: e }) => (e(n.update({ selection: { anchor: 0, head: n.doc.length }, userEvent: "select" })), !0), Gk = ({ state: n, dispatch: e }) => {
  let t = Io(n).map(({ from: i, to: s }) => C.range(i, Math.min(s + 1, n.doc.length)));
  return e(n.update({ selection: C.create(t), userEvent: "select" })), !0;
}, Yk = ({ state: n, dispatch: e }) => {
  let t = qn(n.selection, (i) => {
    var s;
    let r = Ae(n).resolveStack(i.from, 1);
    for (let o = r; o; o = o.next) {
      let { node: l } = o;
      if ((l.from < i.from && l.to >= i.to || l.to > i.to && l.from <= i.from) && (!((s = l.parent) === null || s === void 0) && s.parent))
        return C.range(l.to, l.from);
    }
    return i;
  });
  return e(ii(n, t)), !0;
}, Xk = ({ state: n, dispatch: e }) => {
  let t = n.selection, i = null;
  return t.ranges.length > 1 ? i = C.create([t.main]) : t.main.empty || (i = C.create([C.cursor(t.main.head)])), i ? (e(ii(n, i)), !0) : !1;
};
function Qs(n, e) {
  if (n.state.readOnly)
    return !1;
  let t = "delete.selection", { state: i } = n, s = i.changeByRange((r) => {
    let { from: o, to: l } = r;
    if (o == l) {
      let a = e(r);
      a < o ? (t = "delete.backward", a = xr(n, a, !1)) : a > o && (t = "delete.forward", a = xr(n, a, !0)), o = Math.min(o, a), l = Math.max(l, a);
    } else
      o = xr(n, o, !1), l = xr(n, l, !0);
    return o == l ? { range: r } : { changes: { from: o, to: l }, range: C.cursor(o, o < r.head ? -1 : 1) };
  });
  return s.changes.empty ? !1 : (n.dispatch(i.update(s, {
    scrollIntoView: !0,
    userEvent: t,
    effects: t == "delete.selection" ? O.announce.of(i.phrase("Selection deleted")) : void 0
  })), !0);
}
function xr(n, e, t) {
  if (n instanceof O)
    for (let i of n.state.facet(O.atomicRanges).map((s) => s(n)))
      i.between(e, e, (s, r) => {
        s < e && r > e && (e = t ? r : s);
      });
  return e;
}
const rg = (n, e, t) => Qs(n, (i) => {
  let s = i.from, { state: r } = n, o = r.doc.lineAt(s), l, a;
  if (t && !e && s > o.from && s < o.from + 200 && !/[^ \t]/.test(l = o.text.slice(0, s - o.from))) {
    if (l[l.length - 1] == "	")
      return s - 1;
    let h = Wn(l, r.tabSize), c = h % $i(r) || $i(r);
    for (let f = 0; f < c && l[l.length - 1 - f] == " "; f++)
      s--;
    a = s;
  } else
    a = Re(o.text, s - o.from, e, e) + o.from, a == s && o.number != (e ? r.doc.lines : 1) ? a += e ? 1 : -1 : !e && /[\ufe00-\ufe0f]/.test(o.text.slice(a - o.from, s - o.from)) && (a = Re(o.text, a - o.from, !1, !1) + o.from);
  return a;
}), Ea = (n) => rg(n, !1, !0), og = (n) => rg(n, !0, !1), lg = (n, e) => Qs(n, (t) => {
  let i = t.head, { state: s } = n, r = s.doc.lineAt(i), o = s.charCategorizer(i);
  for (let l = null; ; ) {
    if (i == (e ? r.to : r.from)) {
      i == t.head && r.number != (e ? s.doc.lines : 1) && (i += e ? 1 : -1);
      break;
    }
    let a = Re(r.text, i - r.from, e) + r.from, h = r.text.slice(Math.min(i, a) - r.from, Math.max(i, a) - r.from), c = o(h);
    if (l != null && c != l)
      break;
    (h != " " || i != t.head) && (l = c), i = a;
  }
  return i;
}), ag = (n) => lg(n, !1), Jk = (n) => lg(n, !0), Qk = (n) => Qs(n, (e) => {
  let t = n.lineBlockAt(e.head).to;
  return e.head < t ? t : Math.min(n.state.doc.length, e.head + 1);
}), Zk = (n) => Qs(n, (e) => {
  let t = n.moveToLineBoundary(e, !1).head;
  return e.head > t ? t : Math.max(0, e.head - 1);
}), $k = (n) => Qs(n, (e) => {
  let t = n.moveToLineBoundary(e, !0).head;
  return e.head < t ? t : Math.min(n.state.doc.length, e.head + 1);
}), ev = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = n.changeByRange((i) => ({
    changes: { from: i.from, to: i.to, insert: ie.of(["", ""]) },
    range: C.cursor(i.from)
  }));
  return e(n.update(t, { scrollIntoView: !0, userEvent: "input" })), !0;
}, tv = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = n.changeByRange((i) => {
    if (!i.empty || i.from == 0 || i.from == n.doc.length)
      return { range: i };
    let s = i.from, r = n.doc.lineAt(s), o = s == r.from ? s - 1 : Re(r.text, s - r.from, !1) + r.from, l = s == r.to ? s + 1 : Re(r.text, s - r.from, !0) + r.from;
    return {
      changes: { from: o, to: l, insert: n.doc.slice(s, l).append(n.doc.slice(o, s)) },
      range: C.cursor(l)
    };
  });
  return t.changes.empty ? !1 : (e(n.update(t, { scrollIntoView: !0, userEvent: "move.character" })), !0);
};
function Io(n) {
  let e = [], t = -1;
  for (let i of n.selection.ranges) {
    let s = n.doc.lineAt(i.from), r = n.doc.lineAt(i.to);
    if (!i.empty && i.to == r.from && (r = n.doc.lineAt(i.to - 1)), t >= s.number) {
      let o = e[e.length - 1];
      o.to = r.to, o.ranges.push(i);
    } else
      e.push({ from: s.from, to: r.to, ranges: [i] });
    t = r.number + 1;
  }
  return e;
}
function hg(n, e, t) {
  if (n.readOnly)
    return !1;
  let i = [], s = [];
  for (let r of Io(n)) {
    if (t ? r.to == n.doc.length : r.from == 0)
      continue;
    let o = n.doc.lineAt(t ? r.to + 1 : r.from - 1), l = o.length + 1;
    if (t) {
      i.push({ from: r.to, to: o.to }, { from: r.from, insert: o.text + n.lineBreak });
      for (let a of r.ranges)
        s.push(C.range(Math.min(n.doc.length, a.anchor + l), Math.min(n.doc.length, a.head + l)));
    } else {
      i.push({ from: o.from, to: r.from }, { from: r.to, insert: n.lineBreak + o.text });
      for (let a of r.ranges)
        s.push(C.range(a.anchor - l, a.head - l));
    }
  }
  return i.length ? (e(n.update({
    changes: i,
    scrollIntoView: !0,
    selection: C.create(s, n.selection.mainIndex),
    userEvent: "move.line"
  })), !0) : !1;
}
const iv = ({ state: n, dispatch: e }) => hg(n, e, !1), nv = ({ state: n, dispatch: e }) => hg(n, e, !0);
function cg(n, e, t) {
  if (n.readOnly)
    return !1;
  let i = [];
  for (let s of Io(n))
    t ? i.push({ from: s.from, insert: n.doc.slice(s.from, s.to) + n.lineBreak }) : i.push({ from: s.to, insert: n.lineBreak + n.doc.slice(s.from, s.to) });
  return e(n.update({ changes: i, scrollIntoView: !0, userEvent: "input.copyline" })), !0;
}
const sv = ({ state: n, dispatch: e }) => cg(n, e, !1), rv = ({ state: n, dispatch: e }) => cg(n, e, !0), ov = (n) => {
  if (n.state.readOnly)
    return !1;
  let { state: e } = n, t = e.changes(Io(e).map(({ from: s, to: r }) => (s > 0 ? s-- : r < e.doc.length && r++, { from: s, to: r }))), i = qn(e.selection, (s) => {
    let r;
    if (n.lineWrapping) {
      let o = n.lineBlockAt(s.head), l = n.coordsAtPos(s.head, s.assoc || 1);
      l && (r = o.bottom + n.documentTop - l.bottom + n.defaultLineHeight / 2);
    }
    return n.moveVertically(s, !0, r);
  }).map(t);
  return n.dispatch({ changes: t, selection: i, scrollIntoView: !0, userEvent: "delete.line" }), !0;
};
function lv(n, e) {
  if (/\(\)|\[\]|\{\}/.test(n.sliceDoc(e - 1, e + 1)))
    return { from: e, to: e };
  let t = Ae(n).resolveInner(e), i = t.childBefore(e), s = t.childAfter(e), r;
  return i && s && i.to <= e && s.from >= e && (r = i.type.prop($.closedBy)) && r.indexOf(s.name) > -1 && n.doc.lineAt(i.to).from == n.doc.lineAt(s.from).from && !/\S/.test(n.sliceDoc(i.to, s.from)) ? { from: i.to, to: s.from } : null;
}
const av = /* @__PURE__ */ fg(!1), hv = /* @__PURE__ */ fg(!0);
function fg(n) {
  return ({ state: e, dispatch: t }) => {
    if (e.readOnly)
      return !1;
    let i = e.changeByRange((s) => {
      let { from: r, to: o } = s, l = e.doc.lineAt(r), a = !n && r == o && lv(e, r);
      n && (r = o = (o <= l.to ? l : e.doc.lineAt(o)).to);
      let h = new Oo(e, { simulateBreak: r, simulateDoubleBreak: !!a }), c = lh(h, r);
      for (c == null && (c = Wn(/^\s*/.exec(e.doc.lineAt(r).text)[0], e.tabSize)); o < l.to && /\s/.test(l.text[o - l.from]); )
        o++;
      a ? { from: r, to: o } = a : r > l.from && r < l.from + 100 && !/\S/.test(l.text.slice(0, r)) && (r = l.from);
      let f = ["", Ns(e, c)];
      return a && f.push(Ns(e, h.lineIndent(l.from, -1))), {
        changes: { from: r, to: o, insert: ie.of(f) },
        range: C.cursor(r + 1 + f[1].length)
      };
    });
    return t(e.update(i, { scrollIntoView: !0, userEvent: "input" })), !0;
  };
}
function dh(n, e) {
  let t = -1;
  return n.changeByRange((i) => {
    let s = [];
    for (let o = i.from; o <= i.to; ) {
      let l = n.doc.lineAt(o);
      l.number > t && (i.empty || i.to > l.from) && (e(l, s, i), t = l.number), o = l.to + 1;
    }
    let r = n.changes(s);
    return {
      changes: s,
      range: C.range(r.mapPos(i.anchor, 1), r.mapPos(i.head, 1))
    };
  });
}
const cv = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let t = /* @__PURE__ */ Object.create(null), i = new Oo(n, { overrideIndentation: (r) => {
    let o = t[r];
    return o ?? -1;
  } }), s = dh(n, (r, o, l) => {
    let a = lh(i, r.from);
    if (a == null)
      return;
    /\S/.test(r.text) || (a = 0);
    let h = /^\s*/.exec(r.text)[0], c = Ns(n, a);
    (h != c || l.from < r.from + h.length) && (t[r.from] = a, o.push({ from: r.from, to: r.from + h.length, insert: c }));
  });
  return s.changes.empty || e(n.update(s, { userEvent: "indent" })), !0;
}, ug = ({ state: n, dispatch: e }) => n.readOnly ? !1 : (e(n.update(dh(n, (t, i) => {
  i.push({ from: t.from, insert: n.facet(Do) });
}), { userEvent: "input.indent" })), !0), dg = ({ state: n, dispatch: e }) => n.readOnly ? !1 : (e(n.update(dh(n, (t, i) => {
  let s = /^\s*/.exec(t.text)[0];
  if (!s)
    return;
  let r = Wn(s, n.tabSize), o = 0, l = Ns(n, Math.max(0, r - $i(n)));
  for (; o < s.length && o < l.length && s.charCodeAt(o) == l.charCodeAt(o); )
    o++;
  i.push({ from: t.from + o, to: t.from + s.length, insert: l.slice(o) });
}), { userEvent: "delete.dedent" })), !0), fv = (n) => (n.setTabFocusMode(), !0), uv = [
  { key: "Ctrl-b", run: qp, shift: Zp, preventDefault: !0 },
  { key: "Ctrl-f", run: Up, shift: $p },
  { key: "Ctrl-p", run: Gp, shift: ig },
  { key: "Ctrl-n", run: Yp, shift: ng },
  { key: "Ctrl-a", run: Lk, shift: Uk },
  { key: "Ctrl-e", run: Rk, shift: jk },
  { key: "Ctrl-d", run: og },
  { key: "Ctrl-h", run: Ea },
  { key: "Ctrl-k", run: Qk },
  { key: "Ctrl-Alt-h", run: ag },
  { key: "Ctrl-o", run: ev },
  { key: "Ctrl-t", run: tv },
  { key: "Ctrl-v", run: Oa }
], dv = /* @__PURE__ */ [
  { key: "ArrowLeft", run: qp, shift: Zp, preventDefault: !0 },
  { key: "Mod-ArrowLeft", mac: "Alt-ArrowLeft", run: Sk, shift: Ik, preventDefault: !0 },
  { mac: "Cmd-ArrowLeft", run: Ok, shift: zk, preventDefault: !0 },
  { key: "ArrowRight", run: Up, shift: $p, preventDefault: !0 },
  { key: "Mod-ArrowRight", mac: "Alt-ArrowRight", run: _k, shift: Nk, preventDefault: !0 },
  { mac: "Cmd-ArrowRight", run: Ek, shift: qk, preventDefault: !0 },
  { key: "ArrowUp", run: Gp, shift: ig, preventDefault: !0 },
  { mac: "Cmd-ArrowUp", run: Ef, shift: Rf },
  { mac: "Ctrl-ArrowUp", run: Tf, shift: Df },
  { key: "ArrowDown", run: Yp, shift: ng, preventDefault: !0 },
  { mac: "Cmd-ArrowDown", run: Lf, shift: Pf },
  { mac: "Ctrl-ArrowDown", run: Oa, shift: Of },
  { key: "PageUp", run: Tf, shift: Df },
  { key: "PageDown", run: Oa, shift: Of },
  { key: "Home", run: Dk, shift: Wk, preventDefault: !0 },
  { key: "Mod-Home", run: Ef, shift: Rf },
  { key: "End", run: Tk, shift: Vk, preventDefault: !0 },
  { key: "Mod-End", run: Lf, shift: Pf },
  { key: "Enter", run: av },
  { key: "Mod-a", run: Kk },
  { key: "Backspace", run: Ea, shift: Ea },
  { key: "Delete", run: og },
  { key: "Mod-Backspace", mac: "Alt-Backspace", run: ag },
  { key: "Mod-Delete", mac: "Alt-Delete", run: Jk },
  { mac: "Mod-Backspace", run: Zk },
  { mac: "Mod-Delete", run: $k }
].concat(/* @__PURE__ */ uv.map((n) => ({ mac: n.key, run: n.run, shift: n.shift }))), mg = /* @__PURE__ */ [
  { key: "Alt-ArrowLeft", mac: "Ctrl-ArrowLeft", run: Ak, shift: Fk },
  { key: "Alt-ArrowRight", mac: "Ctrl-ArrowRight", run: Mk, shift: Hk },
  { key: "Alt-ArrowUp", run: iv },
  { key: "Shift-Alt-ArrowUp", run: sv },
  { key: "Alt-ArrowDown", run: nv },
  { key: "Shift-Alt-ArrowDown", run: rv },
  { key: "Escape", run: Xk },
  { key: "Mod-Enter", run: hv },
  { key: "Alt-l", mac: "Ctrl-l", run: Gk },
  { key: "Mod-i", run: Yk, preventDefault: !0 },
  { key: "Mod-[", run: dg },
  { key: "Mod-]", run: ug },
  { key: "Mod-Alt-\\", run: cv },
  { key: "Shift-Mod-k", run: ov },
  { key: "Shift-Mod-\\", run: Bk },
  { key: "Mod-/", run: ok },
  { key: "Alt-A", run: ak },
  { key: "Ctrl-m", mac: "Shift-Alt-m", run: fv }
].concat(dv), pg = { key: "Tab", run: ug, shift: dg }, mv = "#2E3235", qt = "#DDDDDD", Ss = "#B9D2FF", Sr = "#b0b0b0", pv = "#e0e0e0", gg = "#808080", hl = "#000000", gv = "#A54543", bg = "#fc6d24", Vi = "#fda331", cl = "#8abeb7", Bf = "#b5bd68", ns = "#6fb3d2", ss = "#cc99cc", bv = "#6987AF", If = bg, Nf = "#292d30", _r = Ss + "30", yv = mv, fl = qt, wv = "#202325", Ff = qt, kv = /* @__PURE__ */ O.theme({
  "&": {
    color: qt,
    backgroundColor: yv
  },
  ".cm-content": {
    caretColor: Ff
  },
  ".cm-cursor, .cm-dropCursor": { borderLeftColor: Ff },
  "&.cm-focused .cm-selectionBackground, .cm-selectionBackground, .cm-content ::selection": { backgroundColor: wv },
  ".cm-panels": { backgroundColor: Nf, color: Sr },
  ".cm-panels.cm-panels-top": { borderBottom: "2px solid black" },
  ".cm-panels.cm-panels-bottom": { borderTop: "2px solid black" },
  ".cm-searchMatch": {
    backgroundColor: Ss,
    outline: `1px solid ${Sr}`,
    color: hl
  },
  ".cm-searchMatch.cm-searchMatch-selected": {
    backgroundColor: pv,
    color: hl
  },
  ".cm-activeLine": { backgroundColor: _r },
  ".cm-selectionMatch": { backgroundColor: _r },
  "&.cm-focused .cm-matchingBracket, &.cm-focused .cm-nonmatchingBracket": {
    outline: `1px solid ${Sr}`
  },
  "&.cm-focused .cm-matchingBracket": {
    backgroundColor: Ss,
    color: hl
  },
  ".cm-gutters": {
    borderRight: "1px solid #ffffff10",
    color: gg,
    backgroundColor: Nf
  },
  ".cm-activeLineGutter": {
    backgroundColor: _r
  },
  ".cm-foldPlaceholder": {
    backgroundColor: "transparent",
    border: "none",
    color: Ss
  },
  ".cm-tooltip": {
    border: "none",
    backgroundColor: fl
  },
  ".cm-tooltip .cm-tooltip-arrow:before": {
    borderTopColor: "transparent",
    borderBottomColor: "transparent"
  },
  ".cm-tooltip .cm-tooltip-arrow:after": {
    borderTopColor: fl,
    borderBottomColor: fl
  },
  ".cm-tooltip-autocomplete": {
    "& > ul > li[aria-selected]": {
      backgroundColor: _r,
      color: Sr
    }
  }
}, { dark: !0 }), vv = /* @__PURE__ */ zn.define([
  { tag: y.keyword, color: Vi },
  {
    tag: [y.name, y.deleted, y.character, y.propertyName, y.macroName],
    color: Bf
  },
  { tag: [y.variableName], color: ns },
  { tag: [/* @__PURE__ */ y.function(y.variableName)], color: Vi },
  { tag: [y.labelName], color: bg },
  {
    tag: [y.color, /* @__PURE__ */ y.constant(y.name), /* @__PURE__ */ y.standard(y.name)],
    color: Vi
  },
  { tag: [/* @__PURE__ */ y.definition(y.name), y.separator], color: ss },
  { tag: [y.brace], color: ss },
  {
    tag: [y.annotation],
    color: If
  },
  {
    tag: [y.number, y.changed, y.annotation, y.modifier, y.self, y.namespace],
    color: Vi
  },
  {
    tag: [y.typeName, y.className],
    color: ns
  },
  {
    tag: [y.operator, y.operatorKeyword],
    color: ss
  },
  {
    tag: [y.tagName],
    color: Vi
  },
  {
    tag: [y.squareBracket],
    color: ss
  },
  {
    tag: [y.angleBracket],
    color: ss
  },
  {
    tag: [y.attributeName],
    color: ns
  },
  {
    tag: [y.regexp],
    color: Vi
  },
  {
    tag: [y.quote],
    color: qt
  },
  { tag: [y.string], color: Bf },
  {
    tag: y.link,
    color: bv,
    textDecoration: "underline",
    textUnderlinePosition: "under"
  },
  {
    tag: [y.url, y.escape, /* @__PURE__ */ y.special(y.string)],
    color: cl
  },
  { tag: [y.meta], color: gv },
  { tag: [y.comment], color: gg, fontStyle: "italic" },
  { tag: y.monospace, color: qt },
  { tag: y.strong, fontWeight: "bold", color: Vi },
  { tag: y.emphasis, fontStyle: "italic", color: ns },
  { tag: y.strikethrough, textDecoration: "line-through" },
  { tag: y.heading, fontWeight: "bold", color: qt },
  { tag: /* @__PURE__ */ y.special(y.heading1), fontWeight: "bold", color: qt },
  { tag: y.heading1, fontWeight: "bold", color: qt },
  {
    tag: [y.heading2, y.heading3, y.heading4],
    fontWeight: "bold",
    color: qt
  },
  {
    tag: [y.heading5, y.heading6],
    color: qt
  },
  { tag: [y.atom, y.bool, /* @__PURE__ */ y.special(y.variableName)], color: cl },
  {
    tag: [y.processingInstruction, y.inserted],
    color: cl
  },
  {
    tag: [y.contentSeparator],
    color: ns
  },
  { tag: y.invalid, color: Ss, borderBottom: `1px dotted ${If}` }
]), yg = [
  kv,
  /* @__PURE__ */ Lo(vv)
], Hf = "#2e3440", mh = "#3b4252", Vf = "#434c5e", Cr = "#4c566a", Wf = "#e5e9f0", La = "#eceff4", ul = "#8fbcbb", zf = "#88c0d0", xv = "#81a1c1", vt = "#5e81ac", Sv = "#bf616a", un = "#d08770", dl = "#ebcb8b", qf = "#a3be8c", _v = "#b48ead", Uf = "#d30102", ph = La, ml = ph, Cv = "#ffffff", pl = mh, Av = ph, jf = mh, Mv = /* @__PURE__ */ O.theme({
  "&": {
    color: Hf,
    backgroundColor: Cv
  },
  ".cm-content": {
    caretColor: jf
  },
  ".cm-cursor, .cm-dropCursor": { borderLeftColor: jf },
  "&.cm-focused .cm-selectionBackground, .cm-selectionBackground, .cm-content ::selection": { backgroundColor: Av },
  ".cm-panels": { backgroundColor: ph, color: Cr },
  ".cm-panels.cm-panels-top": { borderBottom: "2px solid black" },
  ".cm-panels.cm-panels-bottom": { borderTop: "2px solid black" },
  ".cm-searchMatch": {
    backgroundColor: "#72a1ff59",
    outline: `1px solid ${Cr}`
  },
  ".cm-searchMatch.cm-searchMatch-selected": {
    backgroundColor: Wf
  },
  ".cm-activeLine": { backgroundColor: ml },
  ".cm-selectionMatch": { backgroundColor: Wf },
  "&.cm-focused .cm-matchingBracket, &.cm-focused .cm-nonmatchingBracket": {
    outline: `1px solid ${Cr}`
  },
  "&.cm-focused .cm-matchingBracket": {
    backgroundColor: La
  },
  ".cm-gutters": {
    backgroundColor: La,
    color: Hf,
    border: "none"
  },
  ".cm-activeLineGutter": {
    backgroundColor: ml
  },
  ".cm-foldPlaceholder": {
    backgroundColor: "transparent",
    border: "none",
    color: "#ddd"
  },
  ".cm-tooltip": {
    border: "none",
    backgroundColor: pl
  },
  ".cm-tooltip .cm-tooltip-arrow:before": {
    borderTopColor: "transparent",
    borderBottomColor: "transparent"
  },
  ".cm-tooltip .cm-tooltip-arrow:after": {
    borderTopColor: pl,
    borderBottomColor: pl
  },
  ".cm-tooltip-autocomplete": {
    "& > ul > li[aria-selected]": {
      backgroundColor: ml,
      color: Cr
    }
  }
}, { dark: !1 }), Tv = /* @__PURE__ */ zn.define([
  { tag: y.keyword, color: vt },
  {
    tag: [y.name, y.deleted, y.character, y.propertyName, y.macroName],
    color: un
  },
  { tag: [y.variableName], color: un },
  { tag: [/* @__PURE__ */ y.function(y.variableName)], color: vt },
  { tag: [y.labelName], color: xv },
  {
    tag: [y.color, /* @__PURE__ */ y.constant(y.name), /* @__PURE__ */ y.standard(y.name)],
    color: vt
  },
  { tag: [/* @__PURE__ */ y.definition(y.name), y.separator], color: qf },
  { tag: [y.brace], color: ul },
  {
    tag: [y.annotation],
    color: Uf
  },
  {
    tag: [y.number, y.changed, y.annotation, y.modifier, y.self, y.namespace],
    color: zf
  },
  {
    tag: [y.typeName, y.className],
    color: dl
  },
  {
    tag: [y.operator, y.operatorKeyword],
    color: qf
  },
  {
    tag: [y.tagName],
    color: _v
  },
  {
    tag: [y.squareBracket],
    color: Sv
  },
  {
    tag: [y.angleBracket],
    color: un
  },
  {
    tag: [y.attributeName],
    color: dl
  },
  {
    tag: [y.regexp],
    color: vt
  },
  {
    tag: [y.quote],
    color: mh
  },
  { tag: [y.string], color: un },
  {
    tag: y.link,
    color: ul,
    textDecoration: "underline",
    textUnderlinePosition: "under"
  },
  {
    tag: [y.url, y.escape, /* @__PURE__ */ y.special(y.string)],
    color: un
  },
  { tag: [y.meta], color: zf },
  { tag: [y.comment], color: Vf, fontStyle: "italic" },
  { tag: y.strong, fontWeight: "bold", color: vt },
  { tag: y.emphasis, fontStyle: "italic", color: vt },
  { tag: y.strikethrough, textDecoration: "line-through" },
  { tag: y.heading, fontWeight: "bold", color: vt },
  { tag: /* @__PURE__ */ y.special(y.heading1), fontWeight: "bold", color: vt },
  { tag: y.heading1, fontWeight: "bold", color: vt },
  {
    tag: [y.heading2, y.heading3, y.heading4],
    fontWeight: "bold",
    color: vt
  },
  {
    tag: [y.heading5, y.heading6],
    color: vt
  },
  { tag: [y.atom, y.bool, /* @__PURE__ */ y.special(y.variableName)], color: un },
  {
    tag: [y.processingInstruction, y.inserted],
    color: ul
  },
  {
    tag: [y.contentSeparator],
    color: dl
  },
  { tag: y.invalid, color: Vf, borderBottom: `1px dotted ${Uf}` }
]), wg = [
  Mv,
  /* @__PURE__ */ Lo(Tv)
];
class kg {
  /**
  Create a new completion context. (Mostly useful for testing
  completion sources—in the editor, the extension will create
  these for you.)
  */
  constructor(e, t, i, s) {
    this.state = e, this.pos = t, this.explicit = i, this.view = s, this.abortListeners = [], this.abortOnDocChange = !1;
  }
  /**
  Get the extent, content, and (if there is a token) type of the
  token before `this.pos`.
  */
  tokenBefore(e) {
    let t = Ae(this.state).resolveInner(this.pos, -1);
    for (; t && e.indexOf(t.name) < 0; )
      t = t.parent;
    return t ? {
      from: t.from,
      to: this.pos,
      text: this.state.sliceDoc(t.from, this.pos),
      type: t.type
    } : null;
  }
  /**
  Get the match of the given expression directly before the
  cursor.
  */
  matchBefore(e) {
    let t = this.state.doc.lineAt(this.pos), i = Math.max(t.from, this.pos - 250), s = t.text.slice(i - t.from, this.pos - t.from), r = s.search(vg(e, !1));
    return r < 0 ? null : { from: i + r, to: this.pos, text: s.slice(r) };
  }
  /**
  Yields true when the query has been aborted. Can be useful in
  asynchronous queries to avoid doing work that will be ignored.
  */
  get aborted() {
    return this.abortListeners == null;
  }
  /**
  Allows you to register abort handlers, which will be called when
  the query is
  [aborted](https://codemirror.net/6/docs/ref/#autocomplete.CompletionContext.aborted).
  
  By default, running queries will not be aborted for regular
  typing or backspacing, on the assumption that they are likely to
  return a result with a
  [`validFor`](https://codemirror.net/6/docs/ref/#autocomplete.CompletionResult.validFor) field that
  allows the result to be used after all. Passing `onDocChange:
  true` will cause this query to be aborted for any document
  change.
  */
  addEventListener(e, t, i) {
    e == "abort" && this.abortListeners && (this.abortListeners.push(t), i && i.onDocChange && (this.abortOnDocChange = !0));
  }
}
function Kf(n) {
  let e = Object.keys(n).join(""), t = /\w/.test(e);
  return t && (e = e.replace(/\w/g, "")), `[${t ? "\\w" : ""}${e.replace(/[^\w\s]/g, "\\$&")}]`;
}
function Dv(n) {
  let e = /* @__PURE__ */ Object.create(null), t = /* @__PURE__ */ Object.create(null);
  for (let { label: s } of n) {
    e[s[0]] = !0;
    for (let r = 1; r < s.length; r++)
      t[s[r]] = !0;
  }
  let i = Kf(e) + Kf(t) + "*$";
  return [new RegExp("^" + i), new RegExp(i)];
}
function Ov(n) {
  let e = n.map((s) => typeof s == "string" ? { label: s } : s), [t, i] = e.every((s) => /^\w+$/.test(s.label)) ? [/\w*$/, /\w+$/] : Dv(e);
  return (s) => {
    let r = s.matchBefore(i);
    return r || s.explicit ? { from: r ? r.from : s.pos, options: e, validFor: t } : null;
  };
}
function qM(n, e) {
  return (t) => {
    for (let i = Ae(t.state).resolveInner(t.pos, -1); i; i = i.parent) {
      if (n.indexOf(i.name) > -1)
        return null;
      if (i.type.isTop)
        break;
    }
    return e(t);
  };
}
class Gf {
  constructor(e, t, i, s) {
    this.completion = e, this.source = t, this.match = i, this.score = s;
  }
}
function Mi(n) {
  return n.selection.main.from;
}
function vg(n, e) {
  var t;
  let { source: i } = n, s = e && i[0] != "^", r = i[i.length - 1] != "$";
  return !s && !r ? n : new RegExp(`${s ? "^" : ""}(?:${i})${r ? "$" : ""}`, (t = n.flags) !== null && t !== void 0 ? t : n.ignoreCase ? "i" : "");
}
const gh = /* @__PURE__ */ di.define();
function Ev(n, e, t, i) {
  let { main: s } = n.selection, r = t - s.from, o = i - s.from;
  return Object.assign(Object.assign({}, n.changeByRange((l) => l != s && t != i && n.sliceDoc(l.from + r, l.from + o) != n.sliceDoc(t, i) ? { range: l } : {
    changes: { from: l.from + r, to: i == s.from ? l.to : l.from + o, insert: e },
    range: C.cursor(l.from + r + e.length)
  })), { scrollIntoView: !0, userEvent: "input.complete" });
}
const Yf = /* @__PURE__ */ new WeakMap();
function Lv(n) {
  if (!Array.isArray(n))
    return n;
  let e = Yf.get(n);
  return e || Yf.set(n, e = Ov(n)), e;
}
const ho = /* @__PURE__ */ K.define(), Hs = /* @__PURE__ */ K.define();
class Rv {
  constructor(e) {
    this.pattern = e, this.chars = [], this.folded = [], this.any = [], this.precise = [], this.byWord = [], this.score = 0, this.matched = [];
    for (let t = 0; t < e.length; ) {
      let i = De(e, t), s = lt(i);
      this.chars.push(i);
      let r = e.slice(t, t + s), o = r.toUpperCase();
      this.folded.push(De(o == r ? r.toLowerCase() : o, 0)), t += s;
    }
    this.astral = e.length != this.chars.length;
  }
  ret(e, t) {
    return this.score = e, this.matched = t, this;
  }
  // Matches a given word (completion) against the pattern (input).
  // Will return a boolean indicating whether there was a match and,
  // on success, set `this.score` to the score, `this.matched` to an
  // array of `from, to` pairs indicating the matched parts of `word`.
  //
  // The score is a number that is more negative the worse the match
  // is. See `Penalty` above.
  match(e) {
    if (this.pattern.length == 0)
      return this.ret(-100, []);
    if (e.length < this.pattern.length)
      return null;
    let { chars: t, folded: i, any: s, precise: r, byWord: o } = this;
    if (t.length == 1) {
      let w = De(e, 0), k = lt(w), x = k == e.length ? 0 : -100;
      if (w != t[0]) if (w == i[0])
        x += -200;
      else
        return null;
      return this.ret(x, [0, k]);
    }
    let l = e.indexOf(this.pattern);
    if (l == 0)
      return this.ret(e.length == this.pattern.length ? 0 : -100, [0, this.pattern.length]);
    let a = t.length, h = 0;
    if (l < 0) {
      for (let w = 0, k = Math.min(e.length, 200); w < k && h < a; ) {
        let x = De(e, w);
        (x == t[h] || x == i[h]) && (s[h++] = w), w += lt(x);
      }
      if (h < a)
        return null;
    }
    let c = 0, f = 0, u = !1, d = 0, m = -1, p = -1, g = /[a-z]/.test(e), b = !0;
    for (let w = 0, k = Math.min(e.length, 200), x = 0; w < k && f < a; ) {
      let _ = De(e, w);
      l < 0 && (c < a && _ == t[c] && (r[c++] = w), d < a && (_ == t[d] || _ == i[d] ? (d == 0 && (m = w), p = w + 1, d++) : d = 0));
      let S, A = _ < 255 ? _ >= 48 && _ <= 57 || _ >= 97 && _ <= 122 ? 2 : _ >= 65 && _ <= 90 ? 1 : 0 : (S = ja(_)) != S.toLowerCase() ? 1 : S != S.toUpperCase() ? 2 : 0;
      (!w || A == 1 && g || x == 0 && A != 0) && (t[f] == _ || i[f] == _ && (u = !0) ? o[f++] = w : o.length && (b = !1)), x = A, w += lt(_);
    }
    return f == a && o[0] == 0 && b ? this.result(-100 + (u ? -200 : 0), o, e) : d == a && m == 0 ? this.ret(-200 - e.length + (p == e.length ? 0 : -100), [0, p]) : l > -1 ? this.ret(-700 - e.length, [l, l + this.pattern.length]) : d == a ? this.ret(-900 - e.length, [m, p]) : f == a ? this.result(-100 + (u ? -200 : 0) + -700 + (b ? 0 : -1100), o, e) : t.length == 2 ? null : this.result((s[0] ? -700 : 0) + -200 + -1100, s, e);
  }
  result(e, t, i) {
    let s = [], r = 0;
    for (let o of t) {
      let l = o + (this.astral ? lt(De(i, o)) : 1);
      r && s[r - 1] == o ? s[r - 1] = l : (s[r++] = o, s[r++] = l);
    }
    return this.ret(e - i.length, s);
  }
}
class Pv {
  constructor(e) {
    this.pattern = e, this.matched = [], this.score = 0, this.folded = e.toLowerCase();
  }
  match(e) {
    if (e.length < this.pattern.length)
      return null;
    let t = e.slice(0, this.pattern.length), i = t == this.pattern ? 0 : t.toLowerCase() == this.folded ? -200 : null;
    return i == null ? null : (this.matched = [0, t.length], this.score = i + (e.length == this.pattern.length ? 0 : -100), this);
  }
}
const Le = /* @__PURE__ */ I.define({
  combine(n) {
    return ti(n, {
      activateOnTyping: !0,
      activateOnCompletion: () => !1,
      activateOnTypingDelay: 100,
      selectOnOpen: !0,
      override: null,
      closeOnBlur: !0,
      maxRenderedOptions: 100,
      defaultKeymap: !0,
      tooltipClass: () => "",
      optionClass: () => "",
      aboveCursor: !1,
      icons: !0,
      addToOptions: [],
      positionInfo: Bv,
      filterStrict: !1,
      compareCompletions: (e, t) => e.label.localeCompare(t.label),
      interactionDelay: 75,
      updateSyncTime: 100
    }, {
      defaultKeymap: (e, t) => e && t,
      closeOnBlur: (e, t) => e && t,
      icons: (e, t) => e && t,
      tooltipClass: (e, t) => (i) => Xf(e(i), t(i)),
      optionClass: (e, t) => (i) => Xf(e(i), t(i)),
      addToOptions: (e, t) => e.concat(t),
      filterStrict: (e, t) => e || t
    });
  }
});
function Xf(n, e) {
  return n ? e ? n + " " + e : n : e;
}
function Bv(n, e, t, i, s, r) {
  let o = n.textDirection == de.RTL, l = o, a = !1, h = "top", c, f, u = e.left - s.left, d = s.right - e.right, m = i.right - i.left, p = i.bottom - i.top;
  if (l && u < Math.min(m, d) ? l = !1 : !l && d < Math.min(m, u) && (l = !0), m <= (l ? u : d))
    c = Math.max(s.top, Math.min(t.top, s.bottom - p)) - e.top, f = Math.min(400, l ? u : d);
  else {
    a = !0, f = Math.min(
      400,
      (o ? e.right : s.right - e.left) - 30
      /* Info.Margin */
    );
    let w = s.bottom - e.bottom;
    w >= p || w > e.top ? c = t.bottom - e.top : (h = "bottom", c = e.bottom - t.top);
  }
  let g = (e.bottom - e.top) / r.offsetHeight, b = (e.right - e.left) / r.offsetWidth;
  return {
    style: `${h}: ${c / g}px; max-width: ${f / b}px`,
    class: "cm-completionInfo-" + (a ? o ? "left-narrow" : "right-narrow" : l ? "left" : "right")
  };
}
function Iv(n) {
  let e = n.addToOptions.slice();
  return n.icons && e.push({
    render(t) {
      let i = document.createElement("div");
      return i.classList.add("cm-completionIcon"), t.type && i.classList.add(...t.type.split(/\s+/g).map((s) => "cm-completionIcon-" + s)), i.setAttribute("aria-hidden", "true"), i;
    },
    position: 20
  }), e.push({
    render(t, i, s, r) {
      let o = document.createElement("span");
      o.className = "cm-completionLabel";
      let l = t.displayLabel || t.label, a = 0;
      for (let h = 0; h < r.length; ) {
        let c = r[h++], f = r[h++];
        c > a && o.appendChild(document.createTextNode(l.slice(a, c)));
        let u = o.appendChild(document.createElement("span"));
        u.appendChild(document.createTextNode(l.slice(c, f))), u.className = "cm-completionMatchedText", a = f;
      }
      return a < l.length && o.appendChild(document.createTextNode(l.slice(a))), o;
    },
    position: 50
  }, {
    render(t) {
      if (!t.detail)
        return null;
      let i = document.createElement("span");
      return i.className = "cm-completionDetail", i.textContent = t.detail, i;
    },
    position: 80
  }), e.sort((t, i) => t.position - i.position).map((t) => t.render);
}
function gl(n, e, t) {
  if (n <= t)
    return { from: 0, to: n };
  if (e < 0 && (e = 0), e <= n >> 1) {
    let s = Math.floor(e / t);
    return { from: s * t, to: (s + 1) * t };
  }
  let i = Math.floor((n - e) / t);
  return { from: n - (i + 1) * t, to: n - i * t };
}
class Nv {
  constructor(e, t, i) {
    this.view = e, this.stateField = t, this.applyCompletion = i, this.info = null, this.infoDestroy = null, this.placeInfoReq = {
      read: () => this.measureInfo(),
      write: (a) => this.placeInfo(a),
      key: this
    }, this.space = null, this.currentClass = "";
    let s = e.state.field(t), { options: r, selected: o } = s.open, l = e.state.facet(Le);
    this.optionContent = Iv(l), this.optionClass = l.optionClass, this.tooltipClass = l.tooltipClass, this.range = gl(r.length, o, l.maxRenderedOptions), this.dom = document.createElement("div"), this.dom.className = "cm-tooltip-autocomplete", this.updateTooltipClass(e.state), this.dom.addEventListener("mousedown", (a) => {
      let { options: h } = e.state.field(t).open;
      for (let c = a.target, f; c && c != this.dom; c = c.parentNode)
        if (c.nodeName == "LI" && (f = /-(\d+)$/.exec(c.id)) && +f[1] < h.length) {
          this.applyCompletion(e, h[+f[1]]), a.preventDefault();
          return;
        }
    }), this.dom.addEventListener("focusout", (a) => {
      let h = e.state.field(this.stateField, !1);
      h && h.tooltip && e.state.facet(Le).closeOnBlur && a.relatedTarget != e.contentDOM && e.dispatch({ effects: Hs.of(null) });
    }), this.showOptions(r, s.id);
  }
  mount() {
    this.updateSel();
  }
  showOptions(e, t) {
    this.list && this.list.remove(), this.list = this.dom.appendChild(this.createListBox(e, t, this.range)), this.list.addEventListener("scroll", () => {
      this.info && this.view.requestMeasure(this.placeInfoReq);
    });
  }
  update(e) {
    var t;
    let i = e.state.field(this.stateField), s = e.startState.field(this.stateField);
    if (this.updateTooltipClass(e.state), i != s) {
      let { options: r, selected: o, disabled: l } = i.open;
      (!s.open || s.open.options != r) && (this.range = gl(r.length, o, e.state.facet(Le).maxRenderedOptions), this.showOptions(r, i.id)), this.updateSel(), l != ((t = s.open) === null || t === void 0 ? void 0 : t.disabled) && this.dom.classList.toggle("cm-tooltip-autocomplete-disabled", !!l);
    }
  }
  updateTooltipClass(e) {
    let t = this.tooltipClass(e);
    if (t != this.currentClass) {
      for (let i of this.currentClass.split(" "))
        i && this.dom.classList.remove(i);
      for (let i of t.split(" "))
        i && this.dom.classList.add(i);
      this.currentClass = t;
    }
  }
  positioned(e) {
    this.space = e, this.info && this.view.requestMeasure(this.placeInfoReq);
  }
  updateSel() {
    let e = this.view.state.field(this.stateField), t = e.open;
    if ((t.selected > -1 && t.selected < this.range.from || t.selected >= this.range.to) && (this.range = gl(t.options.length, t.selected, this.view.state.facet(Le).maxRenderedOptions), this.showOptions(t.options, e.id)), this.updateSelectedOption(t.selected)) {
      this.destroyInfo();
      let { completion: i } = t.options[t.selected], { info: s } = i;
      if (!s)
        return;
      let r = typeof s == "string" ? document.createTextNode(s) : s(i);
      if (!r)
        return;
      "then" in r ? r.then((o) => {
        o && this.view.state.field(this.stateField, !1) == e && this.addInfoPane(o, i);
      }).catch((o) => Je(this.view.state, o, "completion info")) : this.addInfoPane(r, i);
    }
  }
  addInfoPane(e, t) {
    this.destroyInfo();
    let i = this.info = document.createElement("div");
    if (i.className = "cm-tooltip cm-completionInfo", e.nodeType != null)
      i.appendChild(e), this.infoDestroy = null;
    else {
      let { dom: s, destroy: r } = e;
      i.appendChild(s), this.infoDestroy = r || null;
    }
    this.dom.appendChild(i), this.view.requestMeasure(this.placeInfoReq);
  }
  updateSelectedOption(e) {
    let t = null;
    for (let i = this.list.firstChild, s = this.range.from; i; i = i.nextSibling, s++)
      i.nodeName != "LI" || !i.id ? s-- : s == e ? i.hasAttribute("aria-selected") || (i.setAttribute("aria-selected", "true"), t = i) : i.hasAttribute("aria-selected") && i.removeAttribute("aria-selected");
    return t && Hv(this.list, t), t;
  }
  measureInfo() {
    let e = this.dom.querySelector("[aria-selected]");
    if (!e || !this.info)
      return null;
    let t = this.dom.getBoundingClientRect(), i = this.info.getBoundingClientRect(), s = e.getBoundingClientRect(), r = this.space;
    if (!r) {
      let o = this.dom.ownerDocument.defaultView || window;
      r = { left: 0, top: 0, right: o.innerWidth, bottom: o.innerHeight };
    }
    return s.top > Math.min(r.bottom, t.bottom) - 10 || s.bottom < Math.max(r.top, t.top) + 10 ? null : this.view.state.facet(Le).positionInfo(this.view, t, s, i, r, this.dom);
  }
  placeInfo(e) {
    this.info && (e ? (e.style && (this.info.style.cssText = e.style), this.info.className = "cm-tooltip cm-completionInfo " + (e.class || "")) : this.info.style.cssText = "top: -1e6px");
  }
  createListBox(e, t, i) {
    const s = document.createElement("ul");
    s.id = t, s.setAttribute("role", "listbox"), s.setAttribute("aria-expanded", "true"), s.setAttribute("aria-label", this.view.state.phrase("Completions"));
    let r = null;
    for (let o = i.from; o < i.to; o++) {
      let { completion: l, match: a } = e[o], { section: h } = l;
      if (h) {
        let u = typeof h == "string" ? h : h.name;
        if (u != r && (o > i.from || i.from == 0))
          if (r = u, typeof h != "string" && h.header)
            s.appendChild(h.header(h));
          else {
            let d = s.appendChild(document.createElement("completion-section"));
            d.textContent = u;
          }
      }
      const c = s.appendChild(document.createElement("li"));
      c.id = t + "-" + o, c.setAttribute("role", "option");
      let f = this.optionClass(l);
      f && (c.className = f);
      for (let u of this.optionContent) {
        let d = u(l, this.view.state, this.view, a);
        d && c.appendChild(d);
      }
    }
    return i.from && s.classList.add("cm-completionListIncompleteTop"), i.to < e.length && s.classList.add("cm-completionListIncompleteBottom"), s;
  }
  destroyInfo() {
    this.info && (this.infoDestroy && this.infoDestroy(), this.info.remove(), this.info = null);
  }
  destroy() {
    this.destroyInfo();
  }
}
function Fv(n, e) {
  return (t) => new Nv(t, n, e);
}
function Hv(n, e) {
  let t = n.getBoundingClientRect(), i = e.getBoundingClientRect(), s = t.height / n.offsetHeight;
  i.top < t.top ? n.scrollTop -= (t.top - i.top) / s : i.bottom > t.bottom && (n.scrollTop += (i.bottom - t.bottom) / s);
}
function Jf(n) {
  return (n.boost || 0) * 100 + (n.apply ? 10 : 0) + (n.info ? 5 : 0) + (n.type ? 1 : 0);
}
function Vv(n, e) {
  let t = [], i = null, s = (h) => {
    t.push(h);
    let { section: c } = h.completion;
    if (c) {
      i || (i = []);
      let f = typeof c == "string" ? c : c.name;
      i.some((u) => u.name == f) || i.push(typeof c == "string" ? { name: f } : c);
    }
  }, r = e.facet(Le);
  for (let h of n)
    if (h.hasResult()) {
      let c = h.result.getMatch;
      if (h.result.filter === !1)
        for (let f of h.result.options)
          s(new Gf(f, h.source, c ? c(f) : [], 1e9 - t.length));
      else {
        let f = e.sliceDoc(h.from, h.to), u, d = r.filterStrict ? new Pv(f) : new Rv(f);
        for (let m of h.result.options)
          if (u = d.match(m.label)) {
            let p = m.displayLabel ? c ? c(m, u.matched) : [] : u.matched;
            s(new Gf(m, h.source, p, u.score + (m.boost || 0)));
          }
      }
    }
  if (i) {
    let h = /* @__PURE__ */ Object.create(null), c = 0, f = (u, d) => {
      var m, p;
      return ((m = u.rank) !== null && m !== void 0 ? m : 1e9) - ((p = d.rank) !== null && p !== void 0 ? p : 1e9) || (u.name < d.name ? -1 : 1);
    };
    for (let u of i.sort(f))
      c -= 1e5, h[u.name] = c;
    for (let u of t) {
      let { section: d } = u.completion;
      d && (u.score += h[typeof d == "string" ? d : d.name]);
    }
  }
  let o = [], l = null, a = r.compareCompletions;
  for (let h of t.sort((c, f) => f.score - c.score || a(c.completion, f.completion))) {
    let c = h.completion;
    !l || l.label != c.label || l.detail != c.detail || l.type != null && c.type != null && l.type != c.type || l.apply != c.apply || l.boost != c.boost ? o.push(h) : Jf(h.completion) > Jf(l) && (o[o.length - 1] = h), l = h.completion;
  }
  return o;
}
class kn {
  constructor(e, t, i, s, r, o) {
    this.options = e, this.attrs = t, this.tooltip = i, this.timestamp = s, this.selected = r, this.disabled = o;
  }
  setSelected(e, t) {
    return e == this.selected || e >= this.options.length ? this : new kn(this.options, Qf(t, e), this.tooltip, this.timestamp, e, this.disabled);
  }
  static build(e, t, i, s, r) {
    let o = Vv(e, t);
    if (!o.length)
      return s && e.some(
        (a) => a.state == 1
        /* State.Pending */
      ) ? new kn(s.options, s.attrs, s.tooltip, s.timestamp, s.selected, !0) : null;
    let l = t.facet(Le).selectOnOpen ? 0 : -1;
    if (s && s.selected != l && s.selected != -1) {
      let a = s.options[s.selected].completion;
      for (let h = 0; h < o.length; h++)
        if (o[h].completion == a) {
          l = h;
          break;
        }
    }
    return new kn(o, Qf(i, l), {
      pos: e.reduce((a, h) => h.hasResult() ? Math.min(a, h.from) : a, 1e8),
      create: Kv,
      above: r.aboveCursor
    }, s ? s.timestamp : Date.now(), l, !1);
  }
  map(e) {
    return new kn(this.options, this.attrs, Object.assign(Object.assign({}, this.tooltip), { pos: e.mapPos(this.tooltip.pos) }), this.timestamp, this.selected, this.disabled);
  }
}
class co {
  constructor(e, t, i) {
    this.active = e, this.id = t, this.open = i;
  }
  static start() {
    return new co(Uv, "cm-ac-" + Math.floor(Math.random() * 2e6).toString(36), null);
  }
  update(e) {
    let { state: t } = e, i = t.facet(Le), r = (i.override || t.languageDataAt("autocomplete", Mi(t)).map(Lv)).map((l) => (this.active.find((h) => h.source == l) || new tt(
      l,
      this.active.some(
        (h) => h.state != 0
        /* State.Inactive */
      ) ? 1 : 0
      /* State.Inactive */
    )).update(e, i));
    r.length == this.active.length && r.every((l, a) => l == this.active[a]) && (r = this.active);
    let o = this.open;
    o && e.docChanged && (o = o.map(e.changes)), e.selection || r.some((l) => l.hasResult() && e.changes.touchesRange(l.from, l.to)) || !Wv(r, this.active) ? o = kn.build(r, t, this.id, o, i) : o && o.disabled && !r.some(
      (l) => l.state == 1
      /* State.Pending */
    ) && (o = null), !o && r.every(
      (l) => l.state != 1
      /* State.Pending */
    ) && r.some((l) => l.hasResult()) && (r = r.map((l) => l.hasResult() ? new tt(
      l.source,
      0
      /* State.Inactive */
    ) : l));
    for (let l of e.effects)
      l.is(_g) && (o = o && o.setSelected(l.value, this.id));
    return r == this.active && o == this.open ? this : new co(r, this.id, o);
  }
  get tooltip() {
    return this.open ? this.open.tooltip : null;
  }
  get attrs() {
    return this.open ? this.open.attrs : this.active.length ? zv : qv;
  }
}
function Wv(n, e) {
  if (n == e)
    return !0;
  for (let t = 0, i = 0; ; ) {
    for (; t < n.length && !n[t].hasResult; )
      t++;
    for (; i < e.length && !e[i].hasResult; )
      i++;
    let s = t == n.length, r = i == e.length;
    if (s || r)
      return s == r;
    if (n[t++].result != e[i++].result)
      return !1;
  }
}
const zv = {
  "aria-autocomplete": "list"
}, qv = {};
function Qf(n, e) {
  let t = {
    "aria-autocomplete": "list",
    "aria-haspopup": "listbox",
    "aria-controls": n
  };
  return e > -1 && (t["aria-activedescendant"] = n + "-" + e), t;
}
const Uv = [];
function xg(n, e) {
  if (n.isUserEvent("input.complete")) {
    let i = n.annotation(gh);
    if (i && e.activateOnCompletion(i))
      return 12;
  }
  let t = n.isUserEvent("input.type");
  return t && e.activateOnTyping ? 5 : t ? 1 : n.isUserEvent("delete.backward") ? 2 : n.selection ? 8 : n.docChanged ? 16 : 0;
}
class tt {
  constructor(e, t, i = -1) {
    this.source = e, this.state = t, this.explicitPos = i;
  }
  hasResult() {
    return !1;
  }
  update(e, t) {
    let i = xg(e, t), s = this;
    (i & 8 || i & 16 && this.touches(e)) && (s = new tt(
      s.source,
      0
      /* State.Inactive */
    )), i & 4 && s.state == 0 && (s = new tt(
      this.source,
      1
      /* State.Pending */
    )), s = s.updateFor(e, i);
    for (let r of e.effects)
      if (r.is(ho))
        s = new tt(s.source, 1, r.value ? Mi(e.state) : -1);
      else if (r.is(Hs))
        s = new tt(
          s.source,
          0
          /* State.Inactive */
        );
      else if (r.is(Sg))
        for (let o of r.value)
          o.source == s.source && (s = o);
    return s;
  }
  updateFor(e, t) {
    return this.map(e.changes);
  }
  map(e) {
    return e.empty || this.explicitPos < 0 ? this : new tt(this.source, this.state, e.mapPos(this.explicitPos));
  }
  touches(e) {
    return e.changes.touchesRange(Mi(e.state));
  }
}
class Mn extends tt {
  constructor(e, t, i, s, r) {
    super(e, 2, t), this.result = i, this.from = s, this.to = r;
  }
  hasResult() {
    return !0;
  }
  updateFor(e, t) {
    var i;
    if (!(t & 3))
      return this.map(e.changes);
    let s = this.result;
    s.map && !e.changes.empty && (s = s.map(s, e.changes));
    let r = e.changes.mapPos(this.from), o = e.changes.mapPos(this.to, 1), l = Mi(e.state);
    if ((this.explicitPos < 0 ? l <= r : l < this.from) || l > o || !s || t & 2 && Mi(e.startState) == this.from)
      return new tt(
        this.source,
        t & 4 ? 1 : 0
        /* State.Inactive */
      );
    let a = this.explicitPos < 0 ? -1 : e.changes.mapPos(this.explicitPos);
    return jv(s.validFor, e.state, r, o) ? new Mn(this.source, a, s, r, o) : s.update && (s = s.update(s, r, o, new kg(e.state, l, a >= 0))) ? new Mn(this.source, a, s, s.from, (i = s.to) !== null && i !== void 0 ? i : Mi(e.state)) : new tt(this.source, 1, a);
  }
  map(e) {
    return e.empty ? this : (this.result.map ? this.result.map(this.result, e) : this.result) ? new Mn(this.source, this.explicitPos < 0 ? -1 : e.mapPos(this.explicitPos), this.result, e.mapPos(this.from), e.mapPos(this.to, 1)) : new tt(
      this.source,
      0
      /* State.Inactive */
    );
  }
  touches(e) {
    return e.changes.touchesRange(this.from, this.to);
  }
}
function jv(n, e, t, i) {
  if (!n)
    return !1;
  let s = e.sliceDoc(t, i);
  return typeof n == "function" ? n(s, t, i, e) : vg(n, !0).test(s);
}
const Sg = /* @__PURE__ */ K.define({
  map(n, e) {
    return n.map((t) => t.map(e));
  }
}), _g = /* @__PURE__ */ K.define(), Xe = /* @__PURE__ */ ke.define({
  create() {
    return co.start();
  },
  update(n, e) {
    return n.update(e);
  },
  provide: (n) => [
    ih.from(n, (e) => e.tooltip),
    O.contentAttributes.from(n, (e) => e.attrs)
  ]
});
function bh(n, e) {
  const t = e.completion.apply || e.completion.label;
  let i = n.state.field(Xe).active.find((s) => s.source == e.source);
  return i instanceof Mn ? (typeof t == "string" ? n.dispatch(Object.assign(Object.assign({}, Ev(n.state, t, i.from, i.to)), { annotations: gh.of(e.completion) })) : t(n, e.completion, i.from, i.to), !0) : !1;
}
const Kv = /* @__PURE__ */ Fv(Xe, bh);
function Ar(n, e = "option") {
  return (t) => {
    let i = t.state.field(Xe, !1);
    if (!i || !i.open || i.open.disabled || Date.now() - i.open.timestamp < t.state.facet(Le).interactionDelay)
      return !1;
    let s = 1, r;
    e == "page" && (r = Ym(t, i.open.tooltip)) && (s = Math.max(2, Math.floor(r.dom.offsetHeight / r.dom.querySelector("li").offsetHeight) - 1));
    let { length: o } = i.open.options, l = i.open.selected > -1 ? i.open.selected + s * (n ? 1 : -1) : n ? 0 : o - 1;
    return l < 0 ? l = e == "page" ? 0 : o - 1 : l >= o && (l = e == "page" ? o - 1 : 0), t.dispatch({ effects: _g.of(l) }), !0;
  };
}
const Gv = (n) => {
  let e = n.state.field(Xe, !1);
  return n.state.readOnly || !e || !e.open || e.open.selected < 0 || e.open.disabled || Date.now() - e.open.timestamp < n.state.facet(Le).interactionDelay ? !1 : bh(n, e.open.options[e.open.selected]);
}, Yv = (n) => n.state.field(Xe, !1) ? (n.dispatch({ effects: ho.of(!0) }), !0) : !1, Xv = (n) => {
  let e = n.state.field(Xe, !1);
  return !e || !e.active.some(
    (t) => t.state != 0
    /* State.Inactive */
  ) ? !1 : (n.dispatch({ effects: Hs.of(null) }), !0);
};
class Jv {
  constructor(e, t) {
    this.active = e, this.context = t, this.time = Date.now(), this.updates = [], this.done = void 0;
  }
}
const Qv = 50, Zv = 1e3, $v = /* @__PURE__ */ be.fromClass(class {
  constructor(n) {
    this.view = n, this.debounceUpdate = -1, this.running = [], this.debounceAccept = -1, this.pendingStart = !1, this.composing = 0;
    for (let e of n.state.field(Xe).active)
      e.state == 1 && this.startQuery(e);
  }
  update(n) {
    let e = n.state.field(Xe), t = n.state.facet(Le);
    if (!n.selectionSet && !n.docChanged && n.startState.field(Xe) == e)
      return;
    let i = n.transactions.some((r) => {
      let o = xg(r, t);
      return o & 8 || (r.selection || r.docChanged) && !(o & 3);
    });
    for (let r = 0; r < this.running.length; r++) {
      let o = this.running[r];
      if (i || o.context.abortOnDocChange && n.docChanged || o.updates.length + n.transactions.length > Qv && Date.now() - o.time > Zv) {
        for (let l of o.context.abortListeners)
          try {
            l();
          } catch (a) {
            Je(this.view.state, a);
          }
        o.context.abortListeners = null, this.running.splice(r--, 1);
      } else
        o.updates.push(...n.transactions);
    }
    this.debounceUpdate > -1 && clearTimeout(this.debounceUpdate), n.transactions.some((r) => r.effects.some((o) => o.is(ho))) && (this.pendingStart = !0);
    let s = this.pendingStart ? 50 : t.activateOnTypingDelay;
    if (this.debounceUpdate = e.active.some((r) => r.state == 1 && !this.running.some((o) => o.active.source == r.source)) ? setTimeout(() => this.startUpdate(), s) : -1, this.composing != 0)
      for (let r of n.transactions)
        r.isUserEvent("input.type") ? this.composing = 2 : this.composing == 2 && r.selection && (this.composing = 3);
  }
  startUpdate() {
    this.debounceUpdate = -1, this.pendingStart = !1;
    let { state: n } = this.view, e = n.field(Xe);
    for (let t of e.active)
      t.state == 1 && !this.running.some((i) => i.active.source == t.source) && this.startQuery(t);
  }
  startQuery(n) {
    let { state: e } = this.view, t = Mi(e), i = new kg(e, t, n.explicitPos == t, this.view), s = new Jv(n, i);
    this.running.push(s), Promise.resolve(n.source(i)).then((r) => {
      s.context.aborted || (s.done = r || null, this.scheduleAccept());
    }, (r) => {
      this.view.dispatch({ effects: Hs.of(null) }), Je(this.view.state, r);
    });
  }
  scheduleAccept() {
    this.running.every((n) => n.done !== void 0) ? this.accept() : this.debounceAccept < 0 && (this.debounceAccept = setTimeout(() => this.accept(), this.view.state.facet(Le).updateSyncTime));
  }
  // For each finished query in this.running, try to create a result
  // or, if appropriate, restart the query.
  accept() {
    var n;
    this.debounceAccept > -1 && clearTimeout(this.debounceAccept), this.debounceAccept = -1;
    let e = [], t = this.view.state.facet(Le);
    for (let i = 0; i < this.running.length; i++) {
      let s = this.running[i];
      if (s.done === void 0)
        continue;
      if (this.running.splice(i--, 1), s.done) {
        let o = new Mn(s.active.source, s.active.explicitPos, s.done, s.done.from, (n = s.done.to) !== null && n !== void 0 ? n : Mi(s.updates.length ? s.updates[0].startState : this.view.state));
        for (let l of s.updates)
          o = o.update(l, t);
        if (o.hasResult()) {
          e.push(o);
          continue;
        }
      }
      let r = this.view.state.field(Xe).active.find((o) => o.source == s.active.source);
      if (r && r.state == 1)
        if (s.done == null) {
          let o = new tt(
            s.active.source,
            0
            /* State.Inactive */
          );
          for (let l of s.updates)
            o = o.update(l, t);
          o.state != 1 && e.push(o);
        } else
          this.startQuery(r);
    }
    e.length && this.view.dispatch({ effects: Sg.of(e) });
  }
}, {
  eventHandlers: {
    blur(n) {
      let e = this.view.state.field(Xe, !1);
      if (e && e.tooltip && this.view.state.facet(Le).closeOnBlur) {
        let t = e.open && Ym(this.view, e.open.tooltip);
        (!t || !t.dom.contains(n.relatedTarget)) && setTimeout(() => this.view.dispatch({ effects: Hs.of(null) }), 10);
      }
    },
    compositionstart() {
      this.composing = 1;
    },
    compositionend() {
      this.composing == 3 && setTimeout(() => this.view.dispatch({ effects: ho.of(!1) }), 20), this.composing = 0;
    }
  }
}), ex = typeof navigator == "object" && /* @__PURE__ */ /Win/.test(navigator.platform), tx = /* @__PURE__ */ ei.highest(/* @__PURE__ */ O.domEventHandlers({
  keydown(n, e) {
    let t = e.state.field(Xe, !1);
    if (!t || !t.open || t.open.disabled || t.open.selected < 0 || n.key.length > 1 || n.ctrlKey && !(ex && n.altKey) || n.metaKey)
      return !1;
    let i = t.open.options[t.open.selected], s = t.active.find((o) => o.source == i.source), r = i.completion.commitCharacters || s.result.commitCharacters;
    return r && r.indexOf(n.key) > -1 && bh(e, i), !1;
  }
})), Cg = /* @__PURE__ */ O.baseTheme({
  ".cm-tooltip.cm-tooltip-autocomplete": {
    "& > ul": {
      fontFamily: "monospace",
      whiteSpace: "nowrap",
      overflow: "hidden auto",
      maxWidth_fallback: "700px",
      maxWidth: "min(700px, 95vw)",
      minWidth: "250px",
      maxHeight: "10em",
      height: "100%",
      listStyle: "none",
      margin: 0,
      padding: 0,
      "& > li, & > completion-section": {
        padding: "1px 3px",
        lineHeight: 1.2
      },
      "& > li": {
        overflowX: "hidden",
        textOverflow: "ellipsis",
        cursor: "pointer"
      },
      "& > completion-section": {
        display: "list-item",
        borderBottom: "1px solid silver",
        paddingLeft: "0.5em",
        opacity: 0.7
      }
    }
  },
  "&light .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#17c",
    color: "white"
  },
  "&light .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#777"
  },
  "&dark .cm-tooltip-autocomplete ul li[aria-selected]": {
    background: "#347",
    color: "white"
  },
  "&dark .cm-tooltip-autocomplete-disabled ul li[aria-selected]": {
    background: "#444"
  },
  ".cm-completionListIncompleteTop:before, .cm-completionListIncompleteBottom:after": {
    content: '"···"',
    opacity: 0.5,
    display: "block",
    textAlign: "center"
  },
  ".cm-tooltip.cm-completionInfo": {
    position: "absolute",
    padding: "3px 9px",
    width: "max-content",
    maxWidth: "400px",
    boxSizing: "border-box",
    whiteSpace: "pre-line"
  },
  ".cm-completionInfo.cm-completionInfo-left": { right: "100%" },
  ".cm-completionInfo.cm-completionInfo-right": { left: "100%" },
  ".cm-completionInfo.cm-completionInfo-left-narrow": { right: "30px" },
  ".cm-completionInfo.cm-completionInfo-right-narrow": { left: "30px" },
  "&light .cm-snippetField": { backgroundColor: "#00000022" },
  "&dark .cm-snippetField": { backgroundColor: "#ffffff22" },
  ".cm-snippetFieldPosition": {
    verticalAlign: "text-top",
    width: 0,
    height: "1.15em",
    display: "inline-block",
    margin: "0 -0.7px -.7em",
    borderLeft: "1.4px dotted #888"
  },
  ".cm-completionMatchedText": {
    textDecoration: "underline"
  },
  ".cm-completionDetail": {
    marginLeft: "0.5em",
    fontStyle: "italic"
  },
  ".cm-completionIcon": {
    fontSize: "90%",
    width: ".8em",
    display: "inline-block",
    textAlign: "center",
    paddingRight: ".6em",
    opacity: "0.6",
    boxSizing: "content-box"
  },
  ".cm-completionIcon-function, .cm-completionIcon-method": {
    "&:after": { content: "'ƒ'" }
  },
  ".cm-completionIcon-class": {
    "&:after": { content: "'○'" }
  },
  ".cm-completionIcon-interface": {
    "&:after": { content: "'◌'" }
  },
  ".cm-completionIcon-variable": {
    "&:after": { content: "'𝑥'" }
  },
  ".cm-completionIcon-constant": {
    "&:after": { content: "'𝐶'" }
  },
  ".cm-completionIcon-type": {
    "&:after": { content: "'𝑡'" }
  },
  ".cm-completionIcon-enum": {
    "&:after": { content: "'∪'" }
  },
  ".cm-completionIcon-property": {
    "&:after": { content: "'□'" }
  },
  ".cm-completionIcon-keyword": {
    "&:after": { content: "'🔑︎'" }
    // Disable emoji rendering
  },
  ".cm-completionIcon-namespace": {
    "&:after": { content: "'▢'" }
  },
  ".cm-completionIcon-text": {
    "&:after": { content: "'abc'", fontSize: "50%", verticalAlign: "middle" }
  }
});
class ix {
  constructor(e, t, i, s) {
    this.field = e, this.line = t, this.from = i, this.to = s;
  }
}
class yh {
  constructor(e, t, i) {
    this.field = e, this.from = t, this.to = i;
  }
  map(e) {
    let t = e.mapPos(this.from, -1, Ee.TrackDel), i = e.mapPos(this.to, 1, Ee.TrackDel);
    return t == null || i == null ? null : new yh(this.field, t, i);
  }
}
class wh {
  constructor(e, t) {
    this.lines = e, this.fieldPositions = t;
  }
  instantiate(e, t) {
    let i = [], s = [t], r = e.doc.lineAt(t), o = /^\s*/.exec(r.text)[0];
    for (let a of this.lines) {
      if (i.length) {
        let h = o, c = /^\t*/.exec(a)[0].length;
        for (let f = 0; f < c; f++)
          h += e.facet(Do);
        s.push(t + h.length - c), a = h + a.slice(c);
      }
      i.push(a), t += a.length + 1;
    }
    let l = this.fieldPositions.map((a) => new yh(a.field, s[a.line] + a.from, s[a.line] + a.to));
    return { text: i, ranges: l };
  }
  static parse(e) {
    let t = [], i = [], s = [], r;
    for (let o of e.split(/\r\n?|\n/)) {
      for (; r = /[#$]\{(?:(\d+)(?::([^}]*))?|((?:\\[{}]|[^}])*))\}/.exec(o); ) {
        let l = r[1] ? +r[1] : null, a = r[2] || r[3] || "", h = -1, c = a.replace(/\\[{}]/g, (f) => f[1]);
        for (let f = 0; f < t.length; f++)
          (l != null ? t[f].seq == l : c && t[f].name == c) && (h = f);
        if (h < 0) {
          let f = 0;
          for (; f < t.length && (l == null || t[f].seq != null && t[f].seq < l); )
            f++;
          t.splice(f, 0, { seq: l, name: c }), h = f;
          for (let u of s)
            u.field >= h && u.field++;
        }
        s.push(new ix(h, i.length, r.index, r.index + c.length)), o = o.slice(0, r.index) + a + o.slice(r.index + r[0].length);
      }
      o = o.replace(/\\([{}])/g, (l, a, h) => {
        for (let c of s)
          c.line == i.length && c.from > h && (c.from--, c.to--);
        return a;
      }), i.push(o);
    }
    return new wh(i, s);
  }
}
let nx = /* @__PURE__ */ N.widget({ widget: /* @__PURE__ */ new class extends Lt {
  toDOM() {
    let n = document.createElement("span");
    return n.className = "cm-snippetFieldPosition", n;
  }
  ignoreEvent() {
    return !1;
  }
}() }), sx = /* @__PURE__ */ N.mark({ class: "cm-snippetField" });
class Un {
  constructor(e, t) {
    this.ranges = e, this.active = t, this.deco = N.set(e.map((i) => (i.from == i.to ? nx : sx).range(i.from, i.to)));
  }
  map(e) {
    let t = [];
    for (let i of this.ranges) {
      let s = i.map(e);
      if (!s)
        return null;
      t.push(s);
    }
    return new Un(t, this.active);
  }
  selectionInsideField(e) {
    return e.ranges.every((t) => this.ranges.some((i) => i.field == this.active && i.from <= t.from && i.to >= t.to));
  }
}
const Zs = /* @__PURE__ */ K.define({
  map(n, e) {
    return n && n.map(e);
  }
}), rx = /* @__PURE__ */ K.define(), Vs = /* @__PURE__ */ ke.define({
  create() {
    return null;
  },
  update(n, e) {
    for (let t of e.effects) {
      if (t.is(Zs))
        return t.value;
      if (t.is(rx) && n)
        return new Un(n.ranges, t.value);
    }
    return n && e.docChanged && (n = n.map(e.changes)), n && e.selection && !n.selectionInsideField(e.selection) && (n = null), n;
  },
  provide: (n) => O.decorations.from(n, (e) => e ? e.deco : N.none)
});
function kh(n, e) {
  return C.create(n.filter((t) => t.field == e).map((t) => C.range(t.from, t.to)));
}
function ox(n) {
  let e = wh.parse(n);
  return (t, i, s, r) => {
    let { text: o, ranges: l } = e.instantiate(t.state, s), a = {
      changes: { from: s, to: r, insert: ie.of(o) },
      scrollIntoView: !0,
      annotations: i ? [gh.of(i), _e.userEvent.of("input.complete")] : void 0
    };
    if (l.length && (a.selection = kh(l, 0)), l.some((h) => h.field > 0)) {
      let h = new Un(l, 0), c = a.effects = [Zs.of(h)];
      t.state.field(Vs, !1) === void 0 && c.push(K.appendConfig.of([Vs, fx, ux, Cg]));
    }
    t.dispatch(t.state.update(a));
  };
}
function Ag(n) {
  return ({ state: e, dispatch: t }) => {
    let i = e.field(Vs, !1);
    if (!i || n < 0 && i.active == 0)
      return !1;
    let s = i.active + n, r = n > 0 && !i.ranges.some((o) => o.field == s + n);
    return t(e.update({
      selection: kh(i.ranges, s),
      effects: Zs.of(r ? null : new Un(i.ranges, s)),
      scrollIntoView: !0
    })), !0;
  };
}
const lx = ({ state: n, dispatch: e }) => n.field(Vs, !1) ? (e(n.update({ effects: Zs.of(null) })), !0) : !1, ax = /* @__PURE__ */ Ag(1), hx = /* @__PURE__ */ Ag(-1), cx = [
  { key: "Tab", run: ax, shift: hx },
  { key: "Escape", run: lx }
], Zf = /* @__PURE__ */ I.define({
  combine(n) {
    return n.length ? n[0] : cx;
  }
}), fx = /* @__PURE__ */ ei.highest(/* @__PURE__ */ rn.compute([Zf], (n) => n.facet(Zf)));
function UM(n, e) {
  return Object.assign(Object.assign({}, e), { apply: ox(n) });
}
const ux = /* @__PURE__ */ O.domEventHandlers({
  mousedown(n, e) {
    let t = e.state.field(Vs, !1), i;
    if (!t || (i = e.posAtCoords({ x: n.clientX, y: n.clientY })) == null)
      return !1;
    let s = t.ranges.find((r) => r.from <= i && r.to >= i);
    return !s || s.field == t.active ? !1 : (e.dispatch({
      selection: kh(t.ranges, s.field),
      effects: Zs.of(t.ranges.some((r) => r.field > s.field) ? new Un(t.ranges, s.field) : null),
      scrollIntoView: !0
    }), !0);
  }
}), Ws = {
  brackets: ["(", "[", "{", "'", '"'],
  before: ")]}:;>",
  stringPrefixes: []
}, Ki = /* @__PURE__ */ K.define({
  map(n, e) {
    let t = e.mapPos(n, -1, Ee.TrackAfter);
    return t ?? void 0;
  }
}), vh = /* @__PURE__ */ new class extends Xi {
}();
vh.startSide = 1;
vh.endSide = -1;
const Mg = /* @__PURE__ */ ke.define({
  create() {
    return ne.empty;
  },
  update(n, e) {
    if (n = n.map(e.changes), e.selection) {
      let t = e.state.doc.lineAt(e.selection.main.head);
      n = n.update({ filter: (i) => i >= t.from && i <= t.to });
    }
    for (let t of e.effects)
      t.is(Ki) && (n = n.update({ add: [vh.range(t.value, t.value + 1)] }));
    return n;
  }
});
function Tg() {
  return [mx, Mg];
}
const bl = "()[]{}<>";
function Dg(n) {
  for (let e = 0; e < bl.length; e += 2)
    if (bl.charCodeAt(e) == n)
      return bl.charAt(e + 1);
  return ja(n < 128 ? n : n + 1);
}
function Og(n, e) {
  return n.languageDataAt("closeBrackets", e)[0] || Ws;
}
const dx = typeof navigator == "object" && /* @__PURE__ */ /Android\b/.test(navigator.userAgent), mx = /* @__PURE__ */ O.inputHandler.of((n, e, t, i) => {
  if ((dx ? n.composing : n.compositionStarted) || n.state.readOnly)
    return !1;
  let s = n.state.selection.main;
  if (i.length > 2 || i.length == 2 && lt(De(i, 0)) == 1 || e != s.from || t != s.to)
    return !1;
  let r = gx(n.state, i);
  return r ? (n.dispatch(r), !0) : !1;
}), px = ({ state: n, dispatch: e }) => {
  if (n.readOnly)
    return !1;
  let i = Og(n, n.selection.main.head).brackets || Ws.brackets, s = null, r = n.changeByRange((o) => {
    if (o.empty) {
      let l = bx(n.doc, o.head);
      for (let a of i)
        if (a == l && No(n.doc, o.head) == Dg(De(a, 0)))
          return {
            changes: { from: o.head - a.length, to: o.head + a.length },
            range: C.cursor(o.head - a.length)
          };
    }
    return { range: s = o };
  });
  return s || e(n.update(r, { scrollIntoView: !0, userEvent: "delete.backward" })), !s;
}, Eg = [
  { key: "Backspace", run: px }
];
function gx(n, e) {
  let t = Og(n, n.selection.main.head), i = t.brackets || Ws.brackets;
  for (let s of i) {
    let r = Dg(De(s, 0));
    if (e == s)
      return r == s ? kx(n, s, i.indexOf(s + s + s) > -1, t) : yx(n, s, r, t.before || Ws.before);
    if (e == r && Lg(n, n.selection.main.from))
      return wx(n, s, r);
  }
  return null;
}
function Lg(n, e) {
  let t = !1;
  return n.field(Mg).between(0, n.doc.length, (i) => {
    i == e && (t = !0);
  }), t;
}
function No(n, e) {
  let t = n.sliceString(e, e + 2);
  return t.slice(0, lt(De(t, 0)));
}
function bx(n, e) {
  let t = n.sliceString(e - 2, e);
  return lt(De(t, 0)) == t.length ? t : t.slice(1);
}
function yx(n, e, t, i) {
  let s = null, r = n.changeByRange((o) => {
    if (!o.empty)
      return {
        changes: [{ insert: e, from: o.from }, { insert: t, from: o.to }],
        effects: Ki.of(o.to + e.length),
        range: C.range(o.anchor + e.length, o.head + e.length)
      };
    let l = No(n.doc, o.head);
    return !l || /\s/.test(l) || i.indexOf(l) > -1 ? {
      changes: { insert: e + t, from: o.head },
      effects: Ki.of(o.head + e.length),
      range: C.cursor(o.head + e.length)
    } : { range: s = o };
  });
  return s ? null : n.update(r, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function wx(n, e, t) {
  let i = null, s = n.changeByRange((r) => r.empty && No(n.doc, r.head) == t ? {
    changes: { from: r.head, to: r.head + t.length, insert: t },
    range: C.cursor(r.head + t.length)
  } : i = { range: r });
  return i ? null : n.update(s, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function kx(n, e, t, i) {
  let s = i.stringPrefixes || Ws.stringPrefixes, r = null, o = n.changeByRange((l) => {
    if (!l.empty)
      return {
        changes: [{ insert: e, from: l.from }, { insert: e, from: l.to }],
        effects: Ki.of(l.to + e.length),
        range: C.range(l.anchor + e.length, l.head + e.length)
      };
    let a = l.head, h = No(n.doc, a), c;
    if (h == e) {
      if ($f(n, a))
        return {
          changes: { insert: e + e, from: a },
          effects: Ki.of(a + e.length),
          range: C.cursor(a + e.length)
        };
      if (Lg(n, a)) {
        let u = t && n.sliceDoc(a, a + e.length * 3) == e + e + e ? e + e + e : e;
        return {
          changes: { from: a, to: a + u.length, insert: u },
          range: C.cursor(a + u.length)
        };
      }
    } else {
      if (t && n.sliceDoc(a - 2 * e.length, a) == e + e && (c = eu(n, a - 2 * e.length, s)) > -1 && $f(n, c))
        return {
          changes: { insert: e + e + e + e, from: a },
          effects: Ki.of(a + e.length),
          range: C.cursor(a + e.length)
        };
      if (n.charCategorizer(a)(h) != me.Word && eu(n, a, s) > -1 && !vx(n, a, e, s))
        return {
          changes: { insert: e + e, from: a },
          effects: Ki.of(a + e.length),
          range: C.cursor(a + e.length)
        };
    }
    return { range: r = l };
  });
  return r ? null : n.update(o, {
    scrollIntoView: !0,
    userEvent: "input.type"
  });
}
function $f(n, e) {
  let t = Ae(n).resolveInner(e + 1);
  return t.parent && t.from == e;
}
function vx(n, e, t, i) {
  let s = Ae(n).resolveInner(e, -1), r = i.reduce((o, l) => Math.max(o, l.length), 0);
  for (let o = 0; o < 5; o++) {
    let l = n.sliceDoc(s.from, Math.min(s.to, s.from + t.length + r)), a = l.indexOf(t);
    if (!a || a > -1 && i.indexOf(l.slice(0, a)) > -1) {
      let c = s.firstChild;
      for (; c && c.from == s.from && c.to - c.from > t.length + a; ) {
        if (n.sliceDoc(c.to - t.length, c.to) == t)
          return !1;
        c = c.firstChild;
      }
      return !0;
    }
    let h = s.to == e && s.parent;
    if (!h)
      break;
    s = h;
  }
  return !1;
}
function eu(n, e, t) {
  let i = n.charCategorizer(e);
  if (i(n.sliceDoc(e - 1, e)) != me.Word)
    return e;
  for (let s of t) {
    let r = e - s.length;
    if (n.sliceDoc(r, e) == s && i(n.sliceDoc(r - 1, r)) != me.Word)
      return r;
  }
  return -1;
}
function xx(n = {}) {
  return [
    tx,
    Xe,
    Le.of(n),
    $v,
    Sx,
    Cg
  ];
}
const xh = [
  { key: "Ctrl-Space", run: Yv },
  { key: "Escape", run: Xv },
  { key: "ArrowDown", run: /* @__PURE__ */ Ar(!0) },
  { key: "ArrowUp", run: /* @__PURE__ */ Ar(!1) },
  { key: "PageDown", run: /* @__PURE__ */ Ar(!0, "page") },
  { key: "PageUp", run: /* @__PURE__ */ Ar(!1, "page") },
  { key: "Enter", run: Gv }
], Sx = /* @__PURE__ */ ei.highest(/* @__PURE__ */ rn.computeN([Le], (n) => n.facet(Le).defaultKeymap ? [xh] : []));
function ce() {
  var n = arguments[0];
  typeof n == "string" && (n = document.createElement(n));
  var e = 1, t = arguments[1];
  if (t && typeof t == "object" && t.nodeType == null && !Array.isArray(t)) {
    for (var i in t) if (Object.prototype.hasOwnProperty.call(t, i)) {
      var s = t[i];
      typeof s == "string" ? n.setAttribute(i, s) : s != null && (n[i] = s);
    }
    e++;
  }
  for (; e < arguments.length; e++) Rg(n, arguments[e]);
  return n;
}
function Rg(n, e) {
  if (typeof e == "string")
    n.appendChild(document.createTextNode(e));
  else if (e != null) if (e.nodeType != null)
    n.appendChild(e);
  else if (Array.isArray(e))
    for (var t = 0; t < e.length; t++) Rg(n, e[t]);
  else
    throw new RangeError("Unsupported child node: " + e);
}
class _x {
  constructor(e, t, i) {
    this.from = e, this.to = t, this.diagnostic = i;
  }
}
class qi {
  constructor(e, t, i) {
    this.diagnostics = e, this.panel = t, this.selected = i;
  }
  static init(e, t, i) {
    let s = e, r = i.facet(zs).markerFilter;
    r && (s = r(s, i));
    let o = N.set(s.map((l) => l.from == l.to || l.from == l.to - 1 && i.doc.lineAt(l.from).to == l.from ? N.widget({
      widget: new Lx(l),
      diagnostic: l
    }).range(l.from) : N.mark({
      attributes: { class: "cm-lintRange cm-lintRange-" + l.severity + (l.markClass ? " " + l.markClass : "") },
      diagnostic: l
    }).range(l.from, l.to)), !0);
    return new qi(o, t, Fn(o));
  }
}
function Fn(n, e = null, t = 0) {
  let i = null;
  return n.between(t, 1e9, (s, r, { spec: o }) => {
    if (!(e && o.diagnostic != e))
      return i = new _x(s, r, o.diagnostic), !1;
  }), i;
}
function Cx(n, e) {
  let t = e.pos, i = e.end || t, s = n.state.facet(zs).hideOn(n, t, i);
  if (s != null)
    return s;
  let r = n.startState.doc.lineAt(e.pos);
  return !!(n.effects.some((o) => o.is(Pg)) || n.changes.touchesRange(r.from, Math.max(r.to, i)));
}
function Ax(n, e) {
  return n.field(it, !1) ? e : e.concat(K.appendConfig.of(Bx));
}
const Pg = /* @__PURE__ */ K.define(), Sh = /* @__PURE__ */ K.define(), Bg = /* @__PURE__ */ K.define(), it = /* @__PURE__ */ ke.define({
  create() {
    return new qi(N.none, null, null);
  },
  update(n, e) {
    if (e.docChanged && n.diagnostics.size) {
      let t = n.diagnostics.map(e.changes), i = null, s = n.panel;
      if (n.selected) {
        let r = e.changes.mapPos(n.selected.from, 1);
        i = Fn(t, n.selected.diagnostic, r) || Fn(t, null, r);
      }
      !t.size && s && e.state.facet(zs).autoPanel && (s = null), n = new qi(t, s, i);
    }
    for (let t of e.effects)
      if (t.is(Pg)) {
        let i = e.state.facet(zs).autoPanel ? t.value.length ? qs.open : null : n.panel;
        n = qi.init(t.value, i, e.state);
      } else t.is(Sh) ? n = new qi(n.diagnostics, t.value ? qs.open : null, n.selected) : t.is(Bg) && (n = new qi(n.diagnostics, n.panel, t.value));
    return n;
  },
  provide: (n) => [
    Ps.from(n, (e) => e.panel),
    O.decorations.from(n, (e) => e.diagnostics)
  ]
}), Mx = /* @__PURE__ */ N.mark({ class: "cm-lintRange cm-lintRange-active" });
function Tx(n, e, t) {
  let { diagnostics: i } = n.state.field(it), s = [], r = 2e8, o = 0;
  i.between(e - (t < 0 ? 1 : 0), e + (t > 0 ? 1 : 0), (a, h, { spec: c }) => {
    e >= a && e <= h && (a == h || (e > a || t > 0) && (e < h || t < 0)) && (s.push(c.diagnostic), r = Math.min(a, r), o = Math.max(h, o));
  });
  let l = n.state.facet(zs).tooltipFilter;
  return l && (s = l(s, n.state)), s.length ? {
    pos: r,
    end: o,
    above: n.state.doc.lineAt(r).to < o,
    create() {
      return { dom: Dx(n, s) };
    }
  } : null;
}
function Dx(n, e) {
  return ce("ul", { class: "cm-tooltip-lint" }, e.map((t) => Fg(n, t, !1)));
}
const Ox = (n) => {
  let e = n.state.field(it, !1);
  (!e || !e.panel) && n.dispatch({ effects: Ax(n.state, [Sh.of(!0)]) });
  let t = Rs(n, qs.open);
  return t && t.dom.querySelector(".cm-panel-lint ul").focus(), !0;
}, tu = (n) => {
  let e = n.state.field(it, !1);
  return !e || !e.panel ? !1 : (n.dispatch({ effects: Sh.of(!1) }), !0);
}, Ex = (n) => {
  let e = n.state.field(it, !1);
  if (!e)
    return !1;
  let t = n.state.selection.main, i = e.diagnostics.iter(t.to + 1);
  return !i.value && (i = e.diagnostics.iter(0), !i.value || i.from == t.from && i.to == t.to) ? !1 : (n.dispatch({ selection: { anchor: i.from, head: i.to }, scrollIntoView: !0 }), !0);
}, Ig = [
  { key: "Mod-Shift-m", run: Ox, preventDefault: !0 },
  { key: "F8", run: Ex }
], zs = /* @__PURE__ */ I.define({
  combine(n) {
    return Object.assign({ sources: n.map((e) => e.source).filter((e) => e != null) }, ti(n.map((e) => e.config), {
      delay: 750,
      markerFilter: null,
      tooltipFilter: null,
      needsRefresh: null,
      hideOn: () => null
    }, {
      needsRefresh: (e, t) => e ? t ? (i) => e(i) || t(i) : e : t
    }));
  }
});
function Ng(n) {
  let e = [];
  if (n)
    e: for (let { name: t } of n) {
      for (let i = 0; i < t.length; i++) {
        let s = t[i];
        if (/[a-zA-Z]/.test(s) && !e.some((r) => r.toLowerCase() == s.toLowerCase())) {
          e.push(s);
          continue e;
        }
      }
      e.push("");
    }
  return e;
}
function Fg(n, e, t) {
  var i;
  let s = t ? Ng(e.actions) : [];
  return ce("li", { class: "cm-diagnostic cm-diagnostic-" + e.severity }, ce("span", { class: "cm-diagnosticText" }, e.renderMessage ? e.renderMessage(n) : e.message), (i = e.actions) === null || i === void 0 ? void 0 : i.map((r, o) => {
    let l = !1, a = (u) => {
      if (u.preventDefault(), l)
        return;
      l = !0;
      let d = Fn(n.state.field(it).diagnostics, e);
      d && r.apply(n, d.from, d.to);
    }, { name: h } = r, c = s[o] ? h.indexOf(s[o]) : -1, f = c < 0 ? h : [
      h.slice(0, c),
      ce("u", h.slice(c, c + 1)),
      h.slice(c + 1)
    ];
    return ce("button", {
      type: "button",
      class: "cm-diagnosticAction",
      onclick: a,
      onmousedown: a,
      "aria-label": ` Action: ${h}${c < 0 ? "" : ` (access key "${s[o]})"`}.`
    }, f);
  }), e.source && ce("div", { class: "cm-diagnosticSource" }, e.source));
}
class Lx extends Lt {
  constructor(e) {
    super(), this.diagnostic = e;
  }
  eq(e) {
    return e.diagnostic == this.diagnostic;
  }
  toDOM() {
    return ce("span", { class: "cm-lintPoint cm-lintPoint-" + this.diagnostic.severity });
  }
}
class iu {
  constructor(e, t) {
    this.diagnostic = t, this.id = "item_" + Math.floor(Math.random() * 4294967295).toString(16), this.dom = Fg(e, t, !0), this.dom.id = this.id, this.dom.setAttribute("role", "option");
  }
}
class qs {
  constructor(e) {
    this.view = e, this.items = [];
    let t = (s) => {
      if (s.keyCode == 27)
        tu(this.view), this.view.focus();
      else if (s.keyCode == 38 || s.keyCode == 33)
        this.moveSelection((this.selectedIndex - 1 + this.items.length) % this.items.length);
      else if (s.keyCode == 40 || s.keyCode == 34)
        this.moveSelection((this.selectedIndex + 1) % this.items.length);
      else if (s.keyCode == 36)
        this.moveSelection(0);
      else if (s.keyCode == 35)
        this.moveSelection(this.items.length - 1);
      else if (s.keyCode == 13)
        this.view.focus();
      else if (s.keyCode >= 65 && s.keyCode <= 90 && this.selectedIndex >= 0) {
        let { diagnostic: r } = this.items[this.selectedIndex], o = Ng(r.actions);
        for (let l = 0; l < o.length; l++)
          if (o[l].toUpperCase().charCodeAt(0) == s.keyCode) {
            let a = Fn(this.view.state.field(it).diagnostics, r);
            a && r.actions[l].apply(e, a.from, a.to);
          }
      } else
        return;
      s.preventDefault();
    }, i = (s) => {
      for (let r = 0; r < this.items.length; r++)
        this.items[r].dom.contains(s.target) && this.moveSelection(r);
    };
    this.list = ce("ul", {
      tabIndex: 0,
      role: "listbox",
      "aria-label": this.view.state.phrase("Diagnostics"),
      onkeydown: t,
      onclick: i
    }), this.dom = ce("div", { class: "cm-panel-lint" }, this.list, ce("button", {
      type: "button",
      name: "close",
      "aria-label": this.view.state.phrase("close"),
      onclick: () => tu(this.view)
    }, "×")), this.update();
  }
  get selectedIndex() {
    let e = this.view.state.field(it).selected;
    if (!e)
      return -1;
    for (let t = 0; t < this.items.length; t++)
      if (this.items[t].diagnostic == e.diagnostic)
        return t;
    return -1;
  }
  update() {
    let { diagnostics: e, selected: t } = this.view.state.field(it), i = 0, s = !1, r = null;
    for (e.between(0, this.view.state.doc.length, (o, l, { spec: a }) => {
      let h = -1, c;
      for (let f = i; f < this.items.length; f++)
        if (this.items[f].diagnostic == a.diagnostic) {
          h = f;
          break;
        }
      h < 0 ? (c = new iu(this.view, a.diagnostic), this.items.splice(i, 0, c), s = !0) : (c = this.items[h], h > i && (this.items.splice(i, h - i), s = !0)), t && c.diagnostic == t.diagnostic ? c.dom.hasAttribute("aria-selected") || (c.dom.setAttribute("aria-selected", "true"), r = c) : c.dom.hasAttribute("aria-selected") && c.dom.removeAttribute("aria-selected"), i++;
    }); i < this.items.length && !(this.items.length == 1 && this.items[0].diagnostic.from < 0); )
      s = !0, this.items.pop();
    this.items.length == 0 && (this.items.push(new iu(this.view, {
      from: -1,
      to: -1,
      severity: "info",
      message: this.view.state.phrase("No diagnostics")
    })), s = !0), r ? (this.list.setAttribute("aria-activedescendant", r.id), this.view.requestMeasure({
      key: this,
      read: () => ({ sel: r.dom.getBoundingClientRect(), panel: this.list.getBoundingClientRect() }),
      write: ({ sel: o, panel: l }) => {
        let a = l.height / this.list.offsetHeight;
        o.top < l.top ? this.list.scrollTop -= (l.top - o.top) / a : o.bottom > l.bottom && (this.list.scrollTop += (o.bottom - l.bottom) / a);
      }
    })) : this.selectedIndex < 0 && this.list.removeAttribute("aria-activedescendant"), s && this.sync();
  }
  sync() {
    let e = this.list.firstChild;
    function t() {
      let i = e;
      e = i.nextSibling, i.remove();
    }
    for (let i of this.items)
      if (i.dom.parentNode == this.list) {
        for (; e != i.dom; )
          t();
        e = i.dom.nextSibling;
      } else
        this.list.insertBefore(i.dom, e);
    for (; e; )
      t();
  }
  moveSelection(e) {
    if (this.selectedIndex < 0)
      return;
    let t = this.view.state.field(it), i = Fn(t.diagnostics, this.items[e].diagnostic);
    i && this.view.dispatch({
      selection: { anchor: i.from, head: i.to },
      scrollIntoView: !0,
      effects: Bg.of(i)
    });
  }
  static open(e) {
    return new qs(e);
  }
}
function Rx(n, e = 'viewBox="0 0 40 40"') {
  return `url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" ${e}>${encodeURIComponent(n)}</svg>')`;
}
function Mr(n) {
  return Rx(`<path d="m0 2.5 l2 -1.5 l1 0 l2 1.5 l1 0" stroke="${n}" fill="none" stroke-width=".7"/>`, 'width="6" height="3"');
}
const Px = /* @__PURE__ */ O.baseTheme({
  ".cm-diagnostic": {
    padding: "3px 6px 3px 8px",
    marginLeft: "-1px",
    display: "block",
    whiteSpace: "pre-wrap"
  },
  ".cm-diagnostic-error": { borderLeft: "5px solid #d11" },
  ".cm-diagnostic-warning": { borderLeft: "5px solid orange" },
  ".cm-diagnostic-info": { borderLeft: "5px solid #999" },
  ".cm-diagnostic-hint": { borderLeft: "5px solid #66d" },
  ".cm-diagnosticAction": {
    font: "inherit",
    border: "none",
    padding: "2px 4px",
    backgroundColor: "#444",
    color: "white",
    borderRadius: "3px",
    marginLeft: "8px",
    cursor: "pointer"
  },
  ".cm-diagnosticSource": {
    fontSize: "70%",
    opacity: 0.7
  },
  ".cm-lintRange": {
    backgroundPosition: "left bottom",
    backgroundRepeat: "repeat-x",
    paddingBottom: "0.7px"
  },
  ".cm-lintRange-error": { backgroundImage: /* @__PURE__ */ Mr("#d11") },
  ".cm-lintRange-warning": { backgroundImage: /* @__PURE__ */ Mr("orange") },
  ".cm-lintRange-info": { backgroundImage: /* @__PURE__ */ Mr("#999") },
  ".cm-lintRange-hint": { backgroundImage: /* @__PURE__ */ Mr("#66d") },
  ".cm-lintRange-active": { backgroundColor: "#ffdd9980" },
  ".cm-tooltip-lint": {
    padding: 0,
    margin: 0
  },
  ".cm-lintPoint": {
    position: "relative",
    "&:after": {
      content: '""',
      position: "absolute",
      bottom: 0,
      left: "-2px",
      borderLeft: "3px solid transparent",
      borderRight: "3px solid transparent",
      borderBottom: "4px solid #d11"
    }
  },
  ".cm-lintPoint-warning": {
    "&:after": { borderBottomColor: "orange" }
  },
  ".cm-lintPoint-info": {
    "&:after": { borderBottomColor: "#999" }
  },
  ".cm-lintPoint-hint": {
    "&:after": { borderBottomColor: "#66d" }
  },
  ".cm-panel.cm-panel-lint": {
    position: "relative",
    "& ul": {
      maxHeight: "100px",
      overflowY: "auto",
      "& [aria-selected]": {
        backgroundColor: "#ddd",
        "& u": { textDecoration: "underline" }
      },
      "&:focus [aria-selected]": {
        background_fallback: "#bdf",
        backgroundColor: "Highlight",
        color_fallback: "white",
        color: "HighlightText"
      },
      "& u": { textDecoration: "none" },
      padding: 0,
      margin: 0
    },
    "& [name=close]": {
      position: "absolute",
      top: "0",
      right: "2px",
      background: "inherit",
      border: "none",
      font: "inherit",
      padding: 0,
      margin: 0
    }
  }
}), Bx = [
  it,
  /* @__PURE__ */ O.decorations.compute([it], (n) => {
    let { selected: e, panel: t } = n.field(it);
    return !e || !t || e.from == e.to ? N.none : N.set([
      Mx.range(e.from, e.to)
    ]);
  }),
  /* @__PURE__ */ Ny(Tx, { hideOn: Cx }),
  Px
], Ix = [
  $m(),
  Um(),
  Np(),
  xp(),
  Wm(),
  Z.allowMultipleSelections.of(!0),
  dp(),
  Lo(_p, { fallback: !0 }),
  Tg(),
  jm(),
  Km(),
  rn.of([
    ...Eg,
    ...mg,
    ...Wp,
    ...yp,
    ...xh,
    ...Ig
  ])
], Nx = [
  "standardSQL",
  "msSQL",
  "mySQL",
  "mariaDB",
  "sqlite",
  "cassandra",
  "plSQL",
  "hive",
  "pgSQL",
  "gql",
  "gpSQL",
  "sparkSQL",
  "esper"
], nu = {
  python: () => import("./index-CGoHbTt0.js").then((n) => n.python()),
  java: () => import("./index-Bk5JOZkt.js").then((n) => n.java()),
  c: () => import("./clike-DxjBFHnq.js").then(
    (n) => zt.define(n.c)
  ),
  cpp: () => import("./clike-DxjBFHnq.js").then(
    (n) => zt.define(n.cpp)
  ),
  markdown: async () => {
    const [n, e] = await Promise.all([
      import("./index-BVht5dwe.js"),
      import("./frontmatter-Pkmn_T7C.js")
    ]);
    return n.markdown({ extensions: [e.frontmatter] });
  },
  json: () => import("./index-CJnxIHB-.js").then((n) => n.json()),
  html: () => import("./index-B5dso0q8.js").then((n) => n.html()),
  css: () => import("./index-COjJdXGY.js").then((n) => n.css()),
  javascript: () => import("./index-CnExemN_.js").then((n) => n.javascript()),
  typescript: () => import("./index-CnExemN_.js").then(
    (n) => n.javascript({ typescript: !0 })
  ),
  yaml: () => import("./yaml-Dt6Tp2eU.js").then(
    (n) => zt.define(n.yaml)
  ),
  dockerfile: () => import("./dockerfile-CEE6bo6a.js").then(
    (n) => zt.define(n.dockerFile)
  ),
  shell: () => import("./shell-C0C2sNA_.js").then(
    (n) => zt.define(n.shell)
  ),
  r: () => import("./r-Bz1d3XP0.js").then(
    (n) => zt.define(n.r)
  ),
  sql: () => import("./sql-uoWIYwDX.js").then(
    (n) => zt.define(n.standardSQL)
  ),
  ...Object.fromEntries(
    Nx.map((n) => [
      "sql-" + n,
      () => import("./sql-uoWIYwDX.js").then(
        (e) => zt.define(e[n])
      )
    ])
  )
}, Fx = {
  py: "python",
  md: "markdown",
  js: "javascript",
  ts: "typescript",
  sh: "shell"
};
async function Hg(n) {
  const e = nu[n] || nu[Fx[n]] || void 0;
  if (e)
    return e();
}
const {
  SvelteComponent: Hx,
  append: Vx,
  attr: yl,
  binding_callbacks: Wx,
  detach: zx,
  element: su,
  init: qx,
  insert: Ux,
  noop: ru,
  safe_not_equal: jx
} = window.__gradio__svelte__internal, { createEventDispatcher: Kx, onMount: Gx } = window.__gradio__svelte__internal;
function Yx(n) {
  let e, t, i;
  return {
    c() {
      e = su("div"), t = su("div"), yl(t, "class", i = "codemirror-wrapper " + /*class_names*/
      n[0] + " svelte-1f1hlu0"), yl(e, "class", "wrap svelte-1f1hlu0");
    },
    m(s, r) {
      Ux(s, e, r), Vx(e, t), n[12](t);
    },
    p(s, [r]) {
      r & /*class_names*/
      1 && i !== (i = "codemirror-wrapper " + /*class_names*/
      s[0] + " svelte-1f1hlu0") && yl(t, "class", i);
    },
    i: ru,
    o: ru,
    d(s) {
      s && zx(e), n[12](null);
    }
  };
}
function Xx(n) {
  var e, t;
  let i = n.dom.querySelectorAll(".cm-gutterElement");
  if (i.length === 0)
    return null;
  for (var s = 0; s < i.length; s++) {
    let r = i[s], o = (t = (e = getComputedStyle(r)) === null || e === void 0 ? void 0 : e.height) !== null && t !== void 0 ? t : "0px";
    if (o != "0px")
      return o;
  }
  return null;
}
function Jx(n, e, t) {
  var i = this && this.__awaiter || function(T, ee, J, j) {
    function oe(q) {
      return q instanceof J ? q : new J(function(ve) {
        ve(q);
      });
    }
    return new (J || (J = Promise))(function(q, ve) {
      function E(He) {
        try {
          rt(j.next(He));
        } catch (ni) {
          ve(ni);
        }
      }
      function st(He) {
        try {
          rt(j.throw(He));
        } catch (ni) {
          ve(ni);
        }
      }
      function rt(He) {
        He.done ? q(He.value) : oe(He.value).then(E, st);
      }
      rt((j = j.apply(T, ee || [])).next());
    });
  };
  let { class_names: s = "" } = e, { value: r = {
    code: "",
    selected_code: { start: 0, end: 0, text: "" }
  } } = e, { dark_mode: o } = e, { basic: l = !0 } = e, { language: a } = e, { lines: h = 5 } = e, { extensions: c = [] } = e, { use_tab: f = !0 } = e, { readonly: u = !1 } = e, { placeholder: d = void 0 } = e;
  const m = Kx();
  let p, g, b;
  function w(T) {
    return i(this, void 0, void 0, function* () {
      const ee = yield Hg(T);
      t(11, p = ee);
    });
  }
  function k(T) {
    b && T !== b.state.doc.toString() && b.dispatch({
      changes: {
        from: 0,
        to: b.state.doc.length,
        insert: T
      }
    });
  }
  function x() {
    b && b.requestMeasure({ read: P });
  }
  function _() {
    const T = new O({
      parent: g,
      state: R(r.code)
    });
    return T.dom.addEventListener("focus", S, !0), T.dom.addEventListener("blur", A, !0), T;
  }
  function S() {
    m("focus");
  }
  function A() {
    m("blur");
  }
  function P(T) {
    let ee = T.dom.querySelectorAll(".cm-gutter"), J = h + 1, j = Xx(T);
    if (!j)
      return null;
    for (var oe = 0; oe < ee.length; oe++) {
      let q = ee[oe];
      q.style.minHeight = `calc(${j} * ${J})`;
    }
    return null;
  }
  function W(T) {
    if (T.docChanged) {
      const J = T.state.doc.toString();
      t(2, r.code = J, r), m("change", J);
    }
    T.selectionSet && U(T.state), b.requestMeasure({ read: P });
  }
  function U(T) {
    const ee = T.selection.main;
    t(
      2,
      r.selected_code = {
        start: ee.from,
        end: ee.to,
        text: T.sliceDoc(ee.from, ee.to)
      },
      r
    );
  }
  function F() {
    return [
      ...z(l, f, d, u, p),
      M,
      ...G(),
      ...c
    ];
  }
  const M = O.theme({
    "&": {
      fontSize: "var(--text-sm)",
      backgroundColor: "var(--border-color-secondary)"
    },
    ".cm-content": {
      paddingTop: "5px",
      paddingBottom: "5px",
      color: "var(--body-text-color)",
      fontFamily: "var(--font-mono)",
      minHeight: "100%"
    },
    ".cm-gutters": {
      marginRight: "1px",
      borderRight: "1px solid var(--border-color-primary)",
      backgroundColor: "var(--block-background-fill);",
      color: "var(--body-text-color-subdued)"
    },
    ".cm-focused": { outline: "none" },
    ".cm-scroller": { height: "auto" },
    ".cm-cursor": {
      borderLeftColor: "var(--body-text-color)"
    }
  });
  function R(T) {
    return Z.create({
      doc: T ?? void 0,
      extensions: F()
    });
  }
  function z(T, ee, J, j, oe) {
    const q = [
      O.editable.of(!j),
      Z.readOnly.of(j),
      O.contentAttributes.of({ "aria-label": "Code input container" })
    ];
    return T && q.push(Ix), ee && q.push(rn.of([pg])), J && q.push(_y(J)), oe && q.push(oe), q.push(O.updateListener.of(W)), q;
  }
  function G() {
    const T = [];
    return o ? T.push(yg) : T.push(wg), T;
  }
  function Q() {
    b == null || b.dispatch({
      effects: K.reconfigure.of(F())
    });
  }
  Gx(() => (b = _(), () => b == null ? void 0 : b.destroy()));
  function re(T) {
    Wx[T ? "unshift" : "push"](() => {
      g = T, t(1, g);
    });
  }
  return n.$$set = (T) => {
    "class_names" in T && t(0, s = T.class_names), "value" in T && t(2, r = T.value), "dark_mode" in T && t(3, o = T.dark_mode), "basic" in T && t(4, l = T.basic), "language" in T && t(5, a = T.language), "lines" in T && t(6, h = T.lines), "extensions" in T && t(7, c = T.extensions), "use_tab" in T && t(8, f = T.use_tab), "readonly" in T && t(9, u = T.readonly), "placeholder" in T && t(10, d = T.placeholder);
  }, n.$$.update = () => {
    n.$$.dirty & /*language*/
    32 && w(a), n.$$.dirty & /*lang_extension, readonly*/
    2560 && Q(), n.$$.dirty & /*value*/
    4 && k(r.code);
  }, x(), [
    s,
    g,
    r,
    o,
    l,
    a,
    h,
    c,
    f,
    u,
    d,
    p,
    re
  ];
}
let Qx = class extends Hx {
  constructor(e) {
    super(), qx(this, e, Jx, Yx, jx, {
      class_names: 0,
      value: 2,
      dark_mode: 3,
      basic: 4,
      language: 5,
      lines: 6,
      extensions: 7,
      use_tab: 8,
      readonly: 9,
      placeholder: 10
    });
  }
};
const ou = typeof String.prototype.normalize == "function" ? (n) => n.normalize("NFKD") : (n) => n;
class Hn {
  /**
  Create a text cursor. The query is the search string, `from` to
  `to` provides the region to search.
  
  When `normalize` is given, it will be called, on both the query
  string and the content it is matched against, before comparing.
  You can, for example, create a case-insensitive search by
  passing `s => s.toLowerCase()`.
  
  Text is always normalized with
  [`.normalize("NFKD")`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/normalize)
  (when supported).
  */
  constructor(e, t, i = 0, s = e.length, r, o) {
    this.test = o, this.value = { from: 0, to: 0 }, this.done = !1, this.matches = [], this.buffer = "", this.bufferPos = 0, this.iter = e.iterRange(i, s), this.bufferStart = i, this.normalize = r ? (l) => r(ou(l)) : ou, this.query = this.normalize(t);
  }
  peek() {
    if (this.bufferPos == this.buffer.length) {
      if (this.bufferStart += this.buffer.length, this.iter.next(), this.iter.done)
        return -1;
      this.bufferPos = 0, this.buffer = this.iter.value;
    }
    return De(this.buffer, this.bufferPos);
  }
  /**
  Look for the next match. Updates the iterator's
  [`value`](https://codemirror.net/6/docs/ref/#search.SearchCursor.value) and
  [`done`](https://codemirror.net/6/docs/ref/#search.SearchCursor.done) properties. Should be called
  at least once before using the cursor.
  */
  next() {
    for (; this.matches.length; )
      this.matches.pop();
    return this.nextOverlapping();
  }
  /**
  The `next` method will ignore matches that partially overlap a
  previous match. This method behaves like `next`, but includes
  such matches.
  */
  nextOverlapping() {
    for (; ; ) {
      let e = this.peek();
      if (e < 0)
        return this.done = !0, this;
      let t = ja(e), i = this.bufferStart + this.bufferPos;
      this.bufferPos += lt(e);
      let s = this.normalize(t);
      for (let r = 0, o = i; ; r++) {
        let l = s.charCodeAt(r), a = this.match(l, o, this.bufferPos + this.bufferStart);
        if (r == s.length - 1) {
          if (a)
            return this.value = a, this;
          break;
        }
        o == i && r < t.length && t.charCodeAt(r) == l && o++;
      }
    }
  }
  match(e, t, i) {
    let s = null;
    for (let r = 0; r < this.matches.length; r += 2) {
      let o = this.matches[r], l = !1;
      this.query.charCodeAt(o) == e && (o == this.query.length - 1 ? s = { from: this.matches[r + 1], to: i } : (this.matches[r]++, l = !0)), l || (this.matches.splice(r, 2), r -= 2);
    }
    return this.query.charCodeAt(0) == e && (this.query.length == 1 ? s = { from: t, to: i } : this.matches.push(1, t)), s && this.test && !this.test(s.from, s.to, this.buffer, this.bufferStart) && (s = null), s;
  }
}
typeof Symbol < "u" && (Hn.prototype[Symbol.iterator] = function() {
  return this;
});
const Vg = { from: -1, to: -1, match: /* @__PURE__ */ /.*/.exec("") }, _h = "gm" + (/x/.unicode == null ? "" : "u");
class Wg {
  /**
  Create a cursor that will search the given range in the given
  document. `query` should be the raw pattern (as you'd pass it to
  `new RegExp`).
  */
  constructor(e, t, i, s = 0, r = e.length) {
    if (this.text = e, this.to = r, this.curLine = "", this.done = !1, this.value = Vg, /\\[sWDnr]|\n|\r|\[\^/.test(t))
      return new zg(e, t, i, s, r);
    this.re = new RegExp(t, _h + (i != null && i.ignoreCase ? "i" : "")), this.test = i == null ? void 0 : i.test, this.iter = e.iter();
    let o = e.lineAt(s);
    this.curLineStart = o.from, this.matchPos = fo(e, s), this.getLine(this.curLineStart);
  }
  getLine(e) {
    this.iter.next(e), this.iter.lineBreak ? this.curLine = "" : (this.curLine = this.iter.value, this.curLineStart + this.curLine.length > this.to && (this.curLine = this.curLine.slice(0, this.to - this.curLineStart)), this.iter.next());
  }
  nextLine() {
    this.curLineStart = this.curLineStart + this.curLine.length + 1, this.curLineStart > this.to ? this.curLine = "" : this.getLine(0);
  }
  /**
  Move to the next match, if there is one.
  */
  next() {
    for (let e = this.matchPos - this.curLineStart; ; ) {
      this.re.lastIndex = e;
      let t = this.matchPos <= this.to && this.re.exec(this.curLine);
      if (t) {
        let i = this.curLineStart + t.index, s = i + t[0].length;
        if (this.matchPos = fo(this.text, s + (i == s ? 1 : 0)), i == this.curLineStart + this.curLine.length && this.nextLine(), (i < s || i > this.value.to) && (!this.test || this.test(i, s, t)))
          return this.value = { from: i, to: s, match: t }, this;
        e = this.matchPos - this.curLineStart;
      } else if (this.curLineStart + this.curLine.length < this.to)
        this.nextLine(), e = 0;
      else
        return this.done = !0, this;
    }
  }
}
const wl = /* @__PURE__ */ new WeakMap();
class Tn {
  constructor(e, t) {
    this.from = e, this.text = t;
  }
  get to() {
    return this.from + this.text.length;
  }
  static get(e, t, i) {
    let s = wl.get(e);
    if (!s || s.from >= i || s.to <= t) {
      let l = new Tn(t, e.sliceString(t, i));
      return wl.set(e, l), l;
    }
    if (s.from == t && s.to == i)
      return s;
    let { text: r, from: o } = s;
    return o > t && (r = e.sliceString(t, o) + r, o = t), s.to < i && (r += e.sliceString(s.to, i)), wl.set(e, new Tn(o, r)), new Tn(t, r.slice(t - o, i - o));
  }
}
class zg {
  constructor(e, t, i, s, r) {
    this.text = e, this.to = r, this.done = !1, this.value = Vg, this.matchPos = fo(e, s), this.re = new RegExp(t, _h + (i != null && i.ignoreCase ? "i" : "")), this.test = i == null ? void 0 : i.test, this.flat = Tn.get(e, s, this.chunkEnd(
      s + 5e3
      /* Chunk.Base */
    ));
  }
  chunkEnd(e) {
    return e >= this.to ? this.to : this.text.lineAt(e).to;
  }
  next() {
    for (; ; ) {
      let e = this.re.lastIndex = this.matchPos - this.flat.from, t = this.re.exec(this.flat.text);
      if (t && !t[0] && t.index == e && (this.re.lastIndex = e + 1, t = this.re.exec(this.flat.text)), t) {
        let i = this.flat.from + t.index, s = i + t[0].length;
        if ((this.flat.to >= this.to || t.index + t[0].length <= this.flat.text.length - 10) && (!this.test || this.test(i, s, t)))
          return this.value = { from: i, to: s, match: t }, this.matchPos = fo(this.text, s + (i == s ? 1 : 0)), this;
      }
      if (this.flat.to == this.to)
        return this.done = !0, this;
      this.flat = Tn.get(this.text, this.flat.from, this.chunkEnd(this.flat.from + this.flat.text.length * 2));
    }
  }
}
typeof Symbol < "u" && (Wg.prototype[Symbol.iterator] = zg.prototype[Symbol.iterator] = function() {
  return this;
});
function Zx(n) {
  try {
    return new RegExp(n, _h), !0;
  } catch {
    return !1;
  }
}
function fo(n, e) {
  if (e >= n.length)
    return e;
  let t = n.lineAt(e), i;
  for (; e < t.to && (i = t.text.charCodeAt(e - t.from)) >= 56320 && i < 57344; )
    e++;
  return e;
}
function Ra(n) {
  let e = String(n.state.doc.lineAt(n.state.selection.main.head).number), t = ce("input", { class: "cm-textfield", name: "line", value: e }), i = ce("form", {
    class: "cm-gotoLine",
    onkeydown: (r) => {
      r.keyCode == 27 ? (r.preventDefault(), n.dispatch({ effects: uo.of(!1) }), n.focus()) : r.keyCode == 13 && (r.preventDefault(), s());
    },
    onsubmit: (r) => {
      r.preventDefault(), s();
    }
  }, ce("label", n.state.phrase("Go to line"), ": ", t), " ", ce("button", { class: "cm-button", type: "submit" }, n.state.phrase("go")));
  function s() {
    let r = /^([+-])?(\d+)?(:\d+)?(%)?$/.exec(t.value);
    if (!r)
      return;
    let { state: o } = n, l = o.doc.lineAt(o.selection.main.head), [, a, h, c, f] = r, u = c ? +c.slice(1) : 0, d = h ? +h : l.number;
    if (h && f) {
      let g = d / 100;
      a && (g = g * (a == "-" ? -1 : 1) + l.number / o.doc.lines), d = Math.round(o.doc.lines * g);
    } else h && a && (d = d * (a == "-" ? -1 : 1) + l.number);
    let m = o.doc.line(Math.max(1, Math.min(o.doc.lines, d))), p = C.cursor(m.from + Math.max(0, Math.min(u, m.length)));
    n.dispatch({
      effects: [uo.of(!1), O.scrollIntoView(p.from, { y: "center" })],
      selection: p
    }), n.focus();
  }
  return { dom: i };
}
const uo = /* @__PURE__ */ K.define(), lu = /* @__PURE__ */ ke.define({
  create() {
    return !0;
  },
  update(n, e) {
    for (let t of e.effects)
      t.is(uo) && (n = t.value);
    return n;
  },
  provide: (n) => Ps.from(n, (e) => e ? Ra : null)
}), $x = (n) => {
  let e = Rs(n, Ra);
  if (!e) {
    let t = [uo.of(!0)];
    n.state.field(lu, !1) == null && t.push(K.appendConfig.of([lu, eS])), n.dispatch({ effects: t }), e = Rs(n, Ra);
  }
  return e && e.dom.querySelector("input").select(), !0;
}, eS = /* @__PURE__ */ O.baseTheme({
  ".cm-panel.cm-gotoLine": {
    padding: "2px 6px 4px",
    "& label": { fontSize: "80%" }
  }
}), tS = {
  highlightWordAroundCursor: !1,
  minSelectionLength: 1,
  maxMatches: 100,
  wholeWords: !1
}, iS = /* @__PURE__ */ I.define({
  combine(n) {
    return ti(n, tS, {
      highlightWordAroundCursor: (e, t) => e || t,
      minSelectionLength: Math.min,
      maxMatches: Math.min
    });
  }
});
function nS(n) {
  return [aS, lS];
}
const sS = /* @__PURE__ */ N.mark({ class: "cm-selectionMatch" }), rS = /* @__PURE__ */ N.mark({ class: "cm-selectionMatch cm-selectionMatch-main" });
function au(n, e, t, i) {
  return (t == 0 || n(e.sliceDoc(t - 1, t)) != me.Word) && (i == e.doc.length || n(e.sliceDoc(i, i + 1)) != me.Word);
}
function oS(n, e, t, i) {
  return n(e.sliceDoc(t, t + 1)) == me.Word && n(e.sliceDoc(i - 1, i)) == me.Word;
}
const lS = /* @__PURE__ */ be.fromClass(class {
  constructor(n) {
    this.decorations = this.getDeco(n);
  }
  update(n) {
    (n.selectionSet || n.docChanged || n.viewportChanged) && (this.decorations = this.getDeco(n.view));
  }
  getDeco(n) {
    let e = n.state.facet(iS), { state: t } = n, i = t.selection;
    if (i.ranges.length > 1)
      return N.none;
    let s = i.main, r, o = null;
    if (s.empty) {
      if (!e.highlightWordAroundCursor)
        return N.none;
      let a = t.wordAt(s.head);
      if (!a)
        return N.none;
      o = t.charCategorizer(s.head), r = t.sliceDoc(a.from, a.to);
    } else {
      let a = s.to - s.from;
      if (a < e.minSelectionLength || a > 200)
        return N.none;
      if (e.wholeWords) {
        if (r = t.sliceDoc(s.from, s.to), o = t.charCategorizer(s.head), !(au(o, t, s.from, s.to) && oS(o, t, s.from, s.to)))
          return N.none;
      } else if (r = t.sliceDoc(s.from, s.to), !r)
        return N.none;
    }
    let l = [];
    for (let a of n.visibleRanges) {
      let h = new Hn(t.doc, r, a.from, a.to);
      for (; !h.next().done; ) {
        let { from: c, to: f } = h.value;
        if ((!o || au(o, t, c, f)) && (s.empty && c <= s.from && f >= s.to ? l.push(rS.range(c, f)) : (c >= s.to || f <= s.from) && l.push(sS.range(c, f)), l.length > e.maxMatches))
          return N.none;
      }
    }
    return N.set(l);
  }
}, {
  decorations: (n) => n.decorations
}), aS = /* @__PURE__ */ O.baseTheme({
  ".cm-selectionMatch": { backgroundColor: "#99ff7780" },
  ".cm-searchMatch .cm-selectionMatch": { backgroundColor: "transparent" }
}), hS = ({ state: n, dispatch: e }) => {
  let { selection: t } = n, i = C.create(t.ranges.map((s) => n.wordAt(s.head) || C.cursor(s.head)), t.mainIndex);
  return i.eq(t) ? !1 : (e(n.update({ selection: i })), !0);
};
function cS(n, e) {
  let { main: t, ranges: i } = n.selection, s = n.wordAt(t.head), r = s && s.from == t.from && s.to == t.to;
  for (let o = !1, l = new Hn(n.doc, e, i[i.length - 1].to); ; )
    if (l.next(), l.done) {
      if (o)
        return null;
      l = new Hn(n.doc, e, 0, Math.max(0, i[i.length - 1].from - 1)), o = !0;
    } else {
      if (o && i.some((a) => a.from == l.value.from))
        continue;
      if (r) {
        let a = n.wordAt(l.value.from);
        if (!a || a.from != l.value.from || a.to != l.value.to)
          continue;
      }
      return l.value;
    }
}
const fS = ({ state: n, dispatch: e }) => {
  let { ranges: t } = n.selection;
  if (t.some((r) => r.from === r.to))
    return hS({ state: n, dispatch: e });
  let i = n.sliceDoc(t[0].from, t[0].to);
  if (n.selection.ranges.some((r) => n.sliceDoc(r.from, r.to) != i))
    return !1;
  let s = cS(n, i);
  return s ? (e(n.update({
    selection: n.selection.addRange(C.range(s.from, s.to), !1),
    effects: O.scrollIntoView(s.to)
  })), !0) : !1;
}, jn = /* @__PURE__ */ I.define({
  combine(n) {
    return ti(n, {
      top: !1,
      caseSensitive: !1,
      literal: !1,
      regexp: !1,
      wholeWord: !1,
      createPanel: (e) => new SS(e),
      scrollToMatch: (e) => O.scrollIntoView(e)
    });
  }
});
class qg {
  /**
  Create a query object.
  */
  constructor(e) {
    this.search = e.search, this.caseSensitive = !!e.caseSensitive, this.literal = !!e.literal, this.regexp = !!e.regexp, this.replace = e.replace || "", this.valid = !!this.search && (!this.regexp || Zx(this.search)), this.unquoted = this.unquote(this.search), this.wholeWord = !!e.wholeWord;
  }
  /**
  @internal
  */
  unquote(e) {
    return this.literal ? e : e.replace(/\\([nrt\\])/g, (t, i) => i == "n" ? `
` : i == "r" ? "\r" : i == "t" ? "	" : "\\");
  }
  /**
  Compare this query to another query.
  */
  eq(e) {
    return this.search == e.search && this.replace == e.replace && this.caseSensitive == e.caseSensitive && this.regexp == e.regexp && this.wholeWord == e.wholeWord;
  }
  /**
  @internal
  */
  create() {
    return this.regexp ? new pS(this) : new dS(this);
  }
  /**
  Get a search cursor for this query, searching through the given
  range in the given state.
  */
  getCursor(e, t = 0, i) {
    let s = e.doc ? e : Z.create({ doc: e });
    return i == null && (i = s.doc.length), this.regexp ? yn(this, s, t, i) : bn(this, s, t, i);
  }
}
class Ug {
  constructor(e) {
    this.spec = e;
  }
}
function bn(n, e, t, i) {
  return new Hn(e.doc, n.unquoted, t, i, n.caseSensitive ? void 0 : (s) => s.toLowerCase(), n.wholeWord ? uS(e.doc, e.charCategorizer(e.selection.main.head)) : void 0);
}
function uS(n, e) {
  return (t, i, s, r) => ((r > t || r + s.length < i) && (r = Math.max(0, t - 2), s = n.sliceString(r, Math.min(n.length, i + 2))), (e(mo(s, t - r)) != me.Word || e(po(s, t - r)) != me.Word) && (e(po(s, i - r)) != me.Word || e(mo(s, i - r)) != me.Word));
}
class dS extends Ug {
  constructor(e) {
    super(e);
  }
  nextMatch(e, t, i) {
    let s = bn(this.spec, e, i, e.doc.length).nextOverlapping();
    return s.done && (s = bn(this.spec, e, 0, t).nextOverlapping()), s.done ? null : s.value;
  }
  // Searching in reverse is, rather than implementing an inverted search
  // cursor, done by scanning chunk after chunk forward.
  prevMatchInRange(e, t, i) {
    for (let s = i; ; ) {
      let r = Math.max(t, s - 1e4 - this.spec.unquoted.length), o = bn(this.spec, e, r, s), l = null;
      for (; !o.nextOverlapping().done; )
        l = o.value;
      if (l)
        return l;
      if (r == t)
        return null;
      s -= 1e4;
    }
  }
  prevMatch(e, t, i) {
    return this.prevMatchInRange(e, 0, t) || this.prevMatchInRange(e, i, e.doc.length);
  }
  getReplacement(e) {
    return this.spec.unquote(this.spec.replace);
  }
  matchAll(e, t) {
    let i = bn(this.spec, e, 0, e.doc.length), s = [];
    for (; !i.next().done; ) {
      if (s.length >= t)
        return null;
      s.push(i.value);
    }
    return s;
  }
  highlight(e, t, i, s) {
    let r = bn(this.spec, e, Math.max(0, t - this.spec.unquoted.length), Math.min(i + this.spec.unquoted.length, e.doc.length));
    for (; !r.next().done; )
      s(r.value.from, r.value.to);
  }
}
function yn(n, e, t, i) {
  return new Wg(e.doc, n.search, {
    ignoreCase: !n.caseSensitive,
    test: n.wholeWord ? mS(e.charCategorizer(e.selection.main.head)) : void 0
  }, t, i);
}
function mo(n, e) {
  return n.slice(Re(n, e, !1), e);
}
function po(n, e) {
  return n.slice(e, Re(n, e));
}
function mS(n) {
  return (e, t, i) => !i[0].length || (n(mo(i.input, i.index)) != me.Word || n(po(i.input, i.index)) != me.Word) && (n(po(i.input, i.index + i[0].length)) != me.Word || n(mo(i.input, i.index + i[0].length)) != me.Word);
}
class pS extends Ug {
  nextMatch(e, t, i) {
    let s = yn(this.spec, e, i, e.doc.length).next();
    return s.done && (s = yn(this.spec, e, 0, t).next()), s.done ? null : s.value;
  }
  prevMatchInRange(e, t, i) {
    for (let s = 1; ; s++) {
      let r = Math.max(
        t,
        i - s * 1e4
        /* FindPrev.ChunkSize */
      ), o = yn(this.spec, e, r, i), l = null;
      for (; !o.next().done; )
        l = o.value;
      if (l && (r == t || l.from > r + 10))
        return l;
      if (r == t)
        return null;
    }
  }
  prevMatch(e, t, i) {
    return this.prevMatchInRange(e, 0, t) || this.prevMatchInRange(e, i, e.doc.length);
  }
  getReplacement(e) {
    return this.spec.unquote(this.spec.replace).replace(/\$([$&\d+])/g, (t, i) => i == "$" ? "$" : i == "&" ? e.match[0] : i != "0" && +i < e.match.length ? e.match[i] : t);
  }
  matchAll(e, t) {
    let i = yn(this.spec, e, 0, e.doc.length), s = [];
    for (; !i.next().done; ) {
      if (s.length >= t)
        return null;
      s.push(i.value);
    }
    return s;
  }
  highlight(e, t, i, s) {
    let r = yn(this.spec, e, Math.max(
      0,
      t - 250
      /* RegExp.HighlightMargin */
    ), Math.min(i + 250, e.doc.length));
    for (; !r.next().done; )
      s(r.value.from, r.value.to);
  }
}
const Us = /* @__PURE__ */ K.define(), Ch = /* @__PURE__ */ K.define(), Ti = /* @__PURE__ */ ke.define({
  create(n) {
    return new kl(Pa(n).create(), null);
  },
  update(n, e) {
    for (let t of e.effects)
      t.is(Us) ? n = new kl(t.value.create(), n.panel) : t.is(Ch) && (n = new kl(n.query, t.value ? Ah : null));
    return n;
  },
  provide: (n) => Ps.from(n, (e) => e.panel)
});
class kl {
  constructor(e, t) {
    this.query = e, this.panel = t;
  }
}
const gS = /* @__PURE__ */ N.mark({ class: "cm-searchMatch" }), bS = /* @__PURE__ */ N.mark({ class: "cm-searchMatch cm-searchMatch-selected" }), yS = /* @__PURE__ */ be.fromClass(class {
  constructor(n) {
    this.view = n, this.decorations = this.highlight(n.state.field(Ti));
  }
  update(n) {
    let e = n.state.field(Ti);
    (e != n.startState.field(Ti) || n.docChanged || n.selectionSet || n.viewportChanged) && (this.decorations = this.highlight(e));
  }
  highlight({ query: n, panel: e }) {
    if (!e || !n.spec.valid)
      return N.none;
    let { view: t } = this, i = new Tt();
    for (let s = 0, r = t.visibleRanges, o = r.length; s < o; s++) {
      let { from: l, to: a } = r[s];
      for (; s < o - 1 && a > r[s + 1].from - 2 * 250; )
        a = r[++s].to;
      n.highlight(t.state, l, a, (h, c) => {
        let f = t.state.selection.ranges.some((u) => u.from == h && u.to == c);
        i.add(h, c, f ? bS : gS);
      });
    }
    return i.finish();
  }
}, {
  decorations: (n) => n.decorations
});
function $s(n) {
  return (e) => {
    let t = e.state.field(Ti, !1);
    return t && t.query.spec.valid ? n(e, t) : Gg(e);
  };
}
const go = /* @__PURE__ */ $s((n, { query: e }) => {
  let { to: t } = n.state.selection.main, i = e.nextMatch(n.state, t, t);
  if (!i)
    return !1;
  let s = C.single(i.from, i.to), r = n.state.facet(jn);
  return n.dispatch({
    selection: s,
    effects: [Mh(n, i), r.scrollToMatch(s.main, n)],
    userEvent: "select.search"
  }), Kg(n), !0;
}), bo = /* @__PURE__ */ $s((n, { query: e }) => {
  let { state: t } = n, { from: i } = t.selection.main, s = e.prevMatch(t, i, i);
  if (!s)
    return !1;
  let r = C.single(s.from, s.to), o = n.state.facet(jn);
  return n.dispatch({
    selection: r,
    effects: [Mh(n, s), o.scrollToMatch(r.main, n)],
    userEvent: "select.search"
  }), Kg(n), !0;
}), wS = /* @__PURE__ */ $s((n, { query: e }) => {
  let t = e.matchAll(n.state, 1e3);
  return !t || !t.length ? !1 : (n.dispatch({
    selection: C.create(t.map((i) => C.range(i.from, i.to))),
    userEvent: "select.search.matches"
  }), !0);
}), kS = ({ state: n, dispatch: e }) => {
  let t = n.selection;
  if (t.ranges.length > 1 || t.main.empty)
    return !1;
  let { from: i, to: s } = t.main, r = [], o = 0;
  for (let l = new Hn(n.doc, n.sliceDoc(i, s)); !l.next().done; ) {
    if (r.length > 1e3)
      return !1;
    l.value.from == i && (o = r.length), r.push(C.range(l.value.from, l.value.to));
  }
  return e(n.update({
    selection: C.create(r, o),
    userEvent: "select.search.matches"
  })), !0;
}, hu = /* @__PURE__ */ $s((n, { query: e }) => {
  let { state: t } = n, { from: i, to: s } = t.selection.main;
  if (t.readOnly)
    return !1;
  let r = e.nextMatch(t, i, i);
  if (!r)
    return !1;
  let o = [], l, a, h = [];
  if (r.from == i && r.to == s && (a = t.toText(e.getReplacement(r)), o.push({ from: r.from, to: r.to, insert: a }), r = e.nextMatch(t, r.from, r.to), h.push(O.announce.of(t.phrase("replaced match on line $", t.doc.lineAt(i).number) + "."))), r) {
    let c = o.length == 0 || o[0].from >= r.to ? 0 : r.to - r.from - a.length;
    l = C.single(r.from - c, r.to - c), h.push(Mh(n, r)), h.push(t.facet(jn).scrollToMatch(l.main, n));
  }
  return n.dispatch({
    changes: o,
    selection: l,
    effects: h,
    userEvent: "input.replace"
  }), !0;
}), vS = /* @__PURE__ */ $s((n, { query: e }) => {
  if (n.state.readOnly)
    return !1;
  let t = e.matchAll(n.state, 1e9).map((s) => {
    let { from: r, to: o } = s;
    return { from: r, to: o, insert: e.getReplacement(s) };
  });
  if (!t.length)
    return !1;
  let i = n.state.phrase("replaced $ matches", t.length) + ".";
  return n.dispatch({
    changes: t,
    effects: O.announce.of(i),
    userEvent: "input.replace.all"
  }), !0;
});
function Ah(n) {
  return n.state.facet(jn).createPanel(n);
}
function Pa(n, e) {
  var t, i, s, r, o;
  let l = n.selection.main, a = l.empty || l.to > l.from + 100 ? "" : n.sliceDoc(l.from, l.to);
  if (e && !a)
    return e;
  let h = n.facet(jn);
  return new qg({
    search: ((t = e == null ? void 0 : e.literal) !== null && t !== void 0 ? t : h.literal) ? a : a.replace(/\n/g, "\\n"),
    caseSensitive: (i = e == null ? void 0 : e.caseSensitive) !== null && i !== void 0 ? i : h.caseSensitive,
    literal: (s = e == null ? void 0 : e.literal) !== null && s !== void 0 ? s : h.literal,
    regexp: (r = e == null ? void 0 : e.regexp) !== null && r !== void 0 ? r : h.regexp,
    wholeWord: (o = e == null ? void 0 : e.wholeWord) !== null && o !== void 0 ? o : h.wholeWord
  });
}
function jg(n) {
  let e = Rs(n, Ah);
  return e && e.dom.querySelector("[main-field]");
}
function Kg(n) {
  let e = jg(n);
  e && e == n.root.activeElement && e.select();
}
const Gg = (n) => {
  let e = n.state.field(Ti, !1);
  if (e && e.panel) {
    let t = jg(n);
    if (t && t != n.root.activeElement) {
      let i = Pa(n.state, e.query.spec);
      i.valid && n.dispatch({ effects: Us.of(i) }), t.focus(), t.select();
    }
  } else
    n.dispatch({ effects: [
      Ch.of(!0),
      e ? Us.of(Pa(n.state, e.query.spec)) : K.appendConfig.of(CS)
    ] });
  return !0;
}, Yg = (n) => {
  let e = n.state.field(Ti, !1);
  if (!e || !e.panel)
    return !1;
  let t = Rs(n, Ah);
  return t && t.dom.contains(n.root.activeElement) && n.focus(), n.dispatch({ effects: Ch.of(!1) }), !0;
}, xS = [
  { key: "Mod-f", run: Gg, scope: "editor search-panel" },
  { key: "F3", run: go, shift: bo, scope: "editor search-panel", preventDefault: !0 },
  { key: "Mod-g", run: go, shift: bo, scope: "editor search-panel", preventDefault: !0 },
  { key: "Escape", run: Yg, scope: "editor search-panel" },
  { key: "Mod-Shift-l", run: kS },
  { key: "Mod-Alt-g", run: $x },
  { key: "Mod-d", run: fS, preventDefault: !0 }
];
class SS {
  constructor(e) {
    this.view = e;
    let t = this.query = e.state.field(Ti).query.spec;
    this.commit = this.commit.bind(this), this.searchField = ce("input", {
      value: t.search,
      placeholder: Ze(e, "Find"),
      "aria-label": Ze(e, "Find"),
      class: "cm-textfield",
      name: "search",
      form: "",
      "main-field": "true",
      onchange: this.commit,
      onkeyup: this.commit
    }), this.replaceField = ce("input", {
      value: t.replace,
      placeholder: Ze(e, "Replace"),
      "aria-label": Ze(e, "Replace"),
      class: "cm-textfield",
      name: "replace",
      form: "",
      onchange: this.commit,
      onkeyup: this.commit
    }), this.caseField = ce("input", {
      type: "checkbox",
      name: "case",
      form: "",
      checked: t.caseSensitive,
      onchange: this.commit
    }), this.reField = ce("input", {
      type: "checkbox",
      name: "re",
      form: "",
      checked: t.regexp,
      onchange: this.commit
    }), this.wordField = ce("input", {
      type: "checkbox",
      name: "word",
      form: "",
      checked: t.wholeWord,
      onchange: this.commit
    });
    function i(s, r, o) {
      return ce("button", { class: "cm-button", name: s, onclick: r, type: "button" }, o);
    }
    this.dom = ce("div", { onkeydown: (s) => this.keydown(s), class: "cm-search" }, [
      this.searchField,
      i("next", () => go(e), [Ze(e, "next")]),
      i("prev", () => bo(e), [Ze(e, "previous")]),
      i("select", () => wS(e), [Ze(e, "all")]),
      ce("label", null, [this.caseField, Ze(e, "match case")]),
      ce("label", null, [this.reField, Ze(e, "regexp")]),
      ce("label", null, [this.wordField, Ze(e, "by word")]),
      ...e.state.readOnly ? [] : [
        ce("br"),
        this.replaceField,
        i("replace", () => hu(e), [Ze(e, "replace")]),
        i("replaceAll", () => vS(e), [Ze(e, "replace all")])
      ],
      ce("button", {
        name: "close",
        onclick: () => Yg(e),
        "aria-label": Ze(e, "close"),
        type: "button"
      }, ["×"])
    ]);
  }
  commit() {
    let e = new qg({
      search: this.searchField.value,
      caseSensitive: this.caseField.checked,
      regexp: this.reField.checked,
      wholeWord: this.wordField.checked,
      replace: this.replaceField.value
    });
    e.eq(this.query) || (this.query = e, this.view.dispatch({ effects: Us.of(e) }));
  }
  keydown(e) {
    $b(this.view, e, "search-panel") ? e.preventDefault() : e.keyCode == 13 && e.target == this.searchField ? (e.preventDefault(), (e.shiftKey ? bo : go)(this.view)) : e.keyCode == 13 && e.target == this.replaceField && (e.preventDefault(), hu(this.view));
  }
  update(e) {
    for (let t of e.transactions)
      for (let i of t.effects)
        i.is(Us) && !i.value.eq(this.query) && this.setQuery(i.value);
  }
  setQuery(e) {
    this.query = e, this.searchField.value = e.search, this.replaceField.value = e.replace, this.caseField.checked = e.caseSensitive, this.reField.checked = e.regexp, this.wordField.checked = e.wholeWord;
  }
  mount() {
    this.searchField.select();
  }
  get pos() {
    return 80;
  }
  get top() {
    return this.view.state.facet(jn).top;
  }
}
function Ze(n, e) {
  return n.state.phrase(e);
}
const Tr = 30, Dr = /[\s\.,:;?!]/;
function Mh(n, { from: e, to: t }) {
  let i = n.state.doc.lineAt(e), s = n.state.doc.lineAt(t).to, r = Math.max(i.from, e - Tr), o = Math.min(s, t + Tr), l = n.state.sliceDoc(r, o);
  if (r != i.from) {
    for (let a = 0; a < Tr; a++)
      if (!Dr.test(l[a + 1]) && Dr.test(l[a])) {
        l = l.slice(a);
        break;
      }
  }
  if (o != s) {
    for (let a = l.length - 1; a > l.length - Tr; a--)
      if (!Dr.test(l[a - 1]) && Dr.test(l[a])) {
        l = l.slice(0, a);
        break;
      }
  }
  return O.announce.of(`${n.state.phrase("current match")}. ${l} ${n.state.phrase("on line")} ${i.number}.`);
}
const _S = /* @__PURE__ */ O.baseTheme({
  ".cm-panel.cm-search": {
    padding: "2px 6px 4px",
    position: "relative",
    "& [name=close]": {
      position: "absolute",
      top: "0",
      right: "4px",
      backgroundColor: "inherit",
      border: "none",
      font: "inherit",
      padding: 0,
      margin: 0
    },
    "& input, & button, & label": {
      margin: ".2em .6em .2em 0"
    },
    "& input[type=checkbox]": {
      marginRight: ".2em"
    },
    "& label": {
      fontSize: "80%",
      whiteSpace: "pre"
    }
  },
  "&light .cm-searchMatch": { backgroundColor: "#ffff0054" },
  "&dark .cm-searchMatch": { backgroundColor: "#00ffff8a" },
  "&light .cm-searchMatch-selected": { backgroundColor: "#ff6a0054" },
  "&dark .cm-searchMatch-selected": { backgroundColor: "#ff00ff8a" }
}), CS = [
  Ti,
  /* @__PURE__ */ ei.low(yS),
  _S
], AS = [
  $m(),
  Gy(),
  Um(),
  Np(),
  xp(),
  Wm(),
  hy(),
  Z.allowMultipleSelections.of(!0),
  dp(),
  Lo(_p, { fallback: !0 }),
  Xw(),
  Tg(),
  xx(),
  jm(),
  Km(),
  ky(),
  nS(),
  rn.of([
    ...Eg,
    ...mg,
    ...xS,
    ...Wp,
    ...yp,
    ...xh,
    ...Ig
  ])
];
class we {
  constructor(e, t, i, s) {
    this.fromA = e, this.toA = t, this.fromB = i, this.toB = s;
  }
  /**
  @internal
  */
  offset(e, t) {
    return new we(this.fromA + e, this.toA + e, this.fromB + t, this.toB + t);
  }
}
function tn(n, e, t, i, s, r) {
  if (n == i)
    return [];
  let o = Th(n, e, t, i, s, r), l = Dh(n, e + o, t, i, s + o, r);
  e += o, t -= l, s += o, r -= l;
  let a = t - e, h = r - s;
  if (!a || !h)
    return [new we(e, t, s, r)];
  if (a > h) {
    let f = n.slice(e, t).indexOf(i.slice(s, r));
    if (f > -1)
      return [
        new we(e, e + f, s, s),
        new we(e + f + h, t, r, r)
      ];
  } else if (h > a) {
    let f = i.slice(s, r).indexOf(n.slice(e, t));
    if (f > -1)
      return [
        new we(e, e, s, s + f),
        new we(t, t, s + f + a, r)
      ];
  }
  if (a == 1 || h == 1)
    return [new we(e, t, s, r)];
  let c = Qg(n, e, t, i, s, r);
  if (c) {
    let [f, u, d] = c;
    return tn(n, e, f, i, s, u).concat(tn(n, f + d, t, i, u + d, r));
  }
  return MS(n, e, t, i, s, r);
}
let gs = 1e9;
function MS(n, e, t, i, s, r) {
  let o = t - e, l = r - s;
  if (gs < 1e9 && Math.min(o, l) > gs * 16)
    return Math.min(o, l) > gs * 64 ? [new we(e, t, s, r)] : cu(n, e, t, i, s, r);
  let a = Math.ceil((o + l) / 2);
  vl.reset(a), xl.reset(a);
  let h = (d, m) => n.charCodeAt(e + d) == i.charCodeAt(s + m), c = (d, m) => n.charCodeAt(t - d - 1) == i.charCodeAt(r - m - 1), f = (o - l) % 2 != 0 ? xl : null, u = f ? null : vl;
  for (let d = 0; d < a; d++) {
    if (d > gs)
      return cu(n, e, t, i, s, r);
    let m = vl.advance(d, o, l, a, f, !1, h) || xl.advance(d, o, l, a, u, !0, c);
    if (m)
      return TS(n, e, t, e + m[0], i, s, r, s + m[1]);
  }
  return [new we(e, t, s, r)];
}
class Xg {
  constructor() {
    this.vec = [];
  }
  reset(e) {
    this.len = e << 1;
    for (let t = 0; t < this.len; t++)
      this.vec[t] = -1;
    this.vec[e + 1] = 0, this.start = this.end = 0;
  }
  advance(e, t, i, s, r, o, l) {
    for (let a = -e + this.start; a <= e - this.end; a += 2) {
      let h = s + a, c = a == -e || a != e && this.vec[h - 1] < this.vec[h + 1] ? this.vec[h + 1] : this.vec[h - 1] + 1, f = c - a;
      for (; c < t && f < i && l(c, f); )
        c++, f++;
      if (this.vec[h] = c, c > t)
        this.end += 2;
      else if (f > i)
        this.start += 2;
      else if (r) {
        let u = s + (t - i) - a;
        if (u >= 0 && u < this.len && r.vec[u] != -1)
          if (o) {
            let d = r.vec[u];
            if (d >= t - c)
              return [d, s + d - u];
          } else {
            let d = t - r.vec[u];
            if (c >= d)
              return [c, f];
          }
      }
    }
    return null;
  }
}
const vl = /* @__PURE__ */ new Xg(), xl = /* @__PURE__ */ new Xg();
function TS(n, e, t, i, s, r, o, l) {
  let a = !1;
  return !Vn(n, i) && ++i == t && (a = !0), !Vn(s, l) && ++l == o && (a = !0), a ? [new we(e, t, r, o)] : tn(n, e, i, s, r, l).concat(tn(n, i, t, s, l, o));
}
function Jg(n, e) {
  let t = 1, i = Math.min(n, e);
  for (; t < i; )
    t = t << 1;
  return t;
}
function Th(n, e, t, i, s, r) {
  if (e == t || e == r || n.charCodeAt(e) != i.charCodeAt(s))
    return 0;
  let o = Jg(t - e, r - s);
  for (let l = e, a = s; ; ) {
    let h = l + o, c = a + o;
    if (h > t || c > r || n.slice(l, h) != i.slice(a, c)) {
      if (o == 1)
        return l - e - (Vn(n, l) ? 0 : 1);
      o = o >> 1;
    } else {
      if (h == t || c == r)
        return h - e;
      l = h, a = c;
    }
  }
}
function Dh(n, e, t, i, s, r) {
  if (e == t || s == r || n.charCodeAt(t - 1) != i.charCodeAt(r - 1))
    return 0;
  let o = Jg(t - e, r - s);
  for (let l = t, a = r; ; ) {
    let h = l - o, c = a - o;
    if (h < e || c < s || n.slice(h, l) != i.slice(c, a)) {
      if (o == 1)
        return t - l - (Vn(n, l) ? 0 : 1);
      o = o >> 1;
    } else {
      if (h == e || c == s)
        return t - h;
      l = h, a = c;
    }
  }
}
function Ba(n, e, t, i, s, r, o, l) {
  let a = i.slice(s, r), h = null;
  for (; ; ) {
    if (h || o < l)
      return h;
    for (let c = e + o; ; ) {
      Vn(n, c) || c++;
      let f = c + o;
      if (Vn(n, f) || (f += f == c + 1 ? 1 : -1), f >= t)
        break;
      let u = n.slice(c, f), d = -1;
      for (; (d = a.indexOf(u, d + 1)) != -1; ) {
        let m = Th(n, f, t, i, s + d + u.length, r), p = Dh(n, e, c, i, s, s + d), g = u.length + m + p;
        (!h || h[2] < g) && (h = [c - p, s + d - p, g]);
      }
      c = f;
    }
    if (l < 0)
      return h;
    o = o >> 1;
  }
}
function Qg(n, e, t, i, s, r) {
  let o = t - e, l = r - s;
  if (o < l) {
    let a = Qg(i, s, r, n, e, t);
    return a && [a[1], a[0], a[2]];
  }
  return o < 4 || l * 2 < o ? null : Ba(n, e, t, i, s, r, Math.floor(o / 4), -1);
}
function cu(n, e, t, i, s, r) {
  let o = t - e, l = r - s, a;
  if (o < l) {
    let u = Ba(i, s, r, n, e, t, Math.floor(o / 6), 50);
    a = u && [u[1], u[0], u[2]];
  } else
    a = Ba(n, e, t, i, s, r, Math.floor(l / 6), 50);
  if (!a)
    return [new we(e, t, s, r)];
  let [h, c, f] = a;
  return tn(n, e, h, i, s, c).concat(tn(n, h + f, t, i, c + f, r));
}
function Zg(n, e) {
  for (let t = 1; t < n.length; t++) {
    let i = n[t - 1], s = n[t];
    i.toA > s.fromA - e && i.toB > s.fromB - e && (n[t - 1] = new we(i.fromA, s.toA, i.fromB, s.toB), n.splice(t--, 1));
  }
}
function DS(n, e, t) {
  for (; ; ) {
    Zg(t, 1);
    let i = !1;
    for (let s = 0; s < t.length; s++) {
      let r = t[s], o, l;
      (o = Th(n, r.fromA, r.toA, e, r.fromB, r.toB)) && (r = t[s] = new we(r.fromA + o, r.toA, r.fromB + o, r.toB)), (l = Dh(n, r.fromA, r.toA, e, r.fromB, r.toB)) && (r = t[s] = new we(r.fromA, r.toA - l, r.fromB, r.toB - l));
      let a = r.toA - r.fromA, h = r.toB - r.fromB;
      if (a && h)
        continue;
      let c = r.fromA - (s ? t[s - 1].toA : 0), f = (s < t.length - 1 ? t[s + 1].fromA : n.length) - r.toA;
      if (!c || !f)
        continue;
      let u = a ? n.slice(r.fromA, r.toA) : e.slice(r.fromB, r.toB);
      c <= u.length && n.slice(r.fromA - c, r.fromA) == u.slice(u.length - c) ? (t[s] = new we(r.fromA - c, r.toA - c, r.fromB - c, r.toB - c), i = !0) : f <= u.length && n.slice(r.toA, r.toA + f) == u.slice(0, f) && (t[s] = new we(r.fromA + f, r.toA + f, r.fromB + f, r.toB + f), i = !0);
    }
    if (!i)
      break;
  }
  return t;
}
function OS(n, e, t) {
  for (let i = 0, s = 0; s < n.length; s++) {
    let r = n[s], o = r.toA - r.fromA, l = r.toB - r.fromB;
    if (o && l || o > 3 || l > 3) {
      let a = s == n.length - 1 ? e.length : n[s + 1].fromA, h = r.fromA - i, c = a - r.toA, f = uu(e, r.fromA, Math.min(h, 5)), u = fu(e, r.toA, Math.min(c, 5)), d = r.fromA - f, m = u - r.toA;
      if (!o || !l) {
        let p = Math.max(o, l), [g, b, w] = o ? [e, r.fromA, r.toA] : [t, r.fromB, r.toB], k, x;
        d && m ? (p > d && e.slice(f, r.fromA) == g.slice(w - d, w) ? (r = n[s] = new we(f, f + o, r.fromB - d, r.toB - d), f = r.fromA, u = fu(e, r.toA, Math.min(a - r.toA, 5))) : p > m && e.slice(r.toA, u) == g.slice(b, b + m) && (r = n[s] = new we(u - o, u, r.fromB + m, r.toB + m), u = r.toA, f = uu(e, r.fromA, Math.min(r.fromA - i, 5))), d = r.fromA - f, m = u - r.toA) : !d && !m && (x = r.fromA - (k = ES(e, r.fromA, h))) && e.slice(k, r.fromA) == g.slice(w - x, w) && (r = n[s] = new we(k, k + o, r.fromB - x, r.toB - x));
      }
      (d || m) && (r = n[s] = new we(r.fromA - d, r.toA + m, r.fromB - d, r.toB + m)), i = r.toA;
    }
  }
  return Zg(n, 3), n;
}
let Yi;
try {
  Yi = /* @__PURE__ */ new RegExp("[\\p{Alphabetic}\\p{Number}]", "u");
} catch {
}
function $g(n) {
  return n > 48 && n < 58 || n > 64 && n < 91 || n > 96 && n < 123;
}
function e0(n, e) {
  if (e == n.length)
    return 0;
  let t = n.charCodeAt(e);
  return t < 192 ? $g(t) ? 1 : 0 : Yi ? !i0(t) || e == n.length - 1 ? Yi.test(String.fromCharCode(t)) ? 1 : 0 : Yi.test(n.slice(e, e + 2)) ? 2 : 0 : 0;
}
function t0(n, e) {
  if (!e)
    return 0;
  let t = n.charCodeAt(e - 1);
  return t < 192 ? $g(t) ? 1 : 0 : Yi ? !n0(t) || e == 1 ? Yi.test(String.fromCharCode(t)) ? 1 : 0 : Yi.test(n.slice(e - 2, e)) ? 2 : 0 : 0;
}
function fu(n, e, t) {
  if (e == n.length || !t0(n, e))
    return e;
  for (let i = e, s = e + t; ; ) {
    let r = e0(n, i);
    if (!r)
      return i;
    if (i += r, i > s)
      return e;
  }
}
function uu(n, e, t) {
  if (!e || !e0(n, e))
    return e;
  for (let i = e, s = e - t; ; ) {
    let r = t0(n, i);
    if (!r)
      return i;
    if (i -= r, i < s)
      return e;
  }
}
function ES(n, e, t) {
  for (let i = e, s = e - t; ; ) {
    let r = i ? n.charCodeAt(i - 1) : 10;
    if (r == 10)
      return i;
    if (i--, i < s || r != 32 && r != 9)
      return e;
  }
}
const i0 = (n) => n >= 55296 && n <= 56319, n0 = (n) => n >= 56320 && n <= 57343;
function Vn(n, e) {
  return !e || e == n.length || !i0(n.charCodeAt(e - 1)) || !n0(n.charCodeAt(e));
}
function LS(n, e, t) {
  var i;
  return gs = ((i = t == null ? void 0 : t.scanLimit) !== null && i !== void 0 ? i : 1e9) >> 1, DS(n, e, tn(n, 0, n.length, e, 0, e.length));
}
function s0(n, e, t) {
  return OS(LS(n, e, t), n, e);
}
const js = /* @__PURE__ */ I.define({
  combine: (n) => n[0]
}), r0 = /* @__PURE__ */ K.define(), $t = /* @__PURE__ */ ke.define({
  create(n) {
    return null;
  },
  update(n, e) {
    for (let t of e.effects)
      t.is(r0) && (n = t.value);
    return n;
  }
});
class Dn {
  constructor(e, t, i, s, r) {
    this.changes = e, this.fromA = t, this.toA = i, this.fromB = s, this.toB = r;
  }
  /**
  @internal
  */
  offset(e, t) {
    return e || t ? new Dn(this.changes, this.fromA + e, this.toA + e, this.fromB + t, this.toB + t) : this;
  }
  /**
  Returns `fromA` if the chunk is empty in A, or the end of the
  last line in the chunk otherwise.
  */
  get endA() {
    return Math.max(this.fromA, this.toA - 1);
  }
  /**
  Returns `fromB` if the chunk is empty in B, or the end of the
  last line in the chunk otherwise.
  */
  get endB() {
    return Math.max(this.fromB, this.toB - 1);
  }
  /**
  Build a set of changed chunks for the given documents.
  */
  static build(e, t, i) {
    return o0(s0(e.toString(), t.toString(), i), e, t, 0, 0);
  }
  /**
  Update a set of chunks for changes in document A. `a` should
  hold the updated document A.
  */
  static updateA(e, t, i, s, r) {
    return bu(gu(e, s, !0, i.length), e, t, i, r);
  }
  /**
  Update a set of chunks for changes in document B.
  */
  static updateB(e, t, i, s, r) {
    return bu(gu(e, s, !1, t.length), e, t, i, r);
  }
}
function du(n, e, t, i) {
  let s = t.lineAt(n), r = i.lineAt(e);
  return s.to == n && r.to == e && n < t.length && e < i.length ? [n + 1, e + 1] : [s.from, r.from];
}
function mu(n, e, t, i) {
  let s = t.lineAt(n), r = i.lineAt(e);
  return s.from == n && r.from == e ? [n, e] : [s.to + 1, r.to + 1];
}
function o0(n, e, t, i, s) {
  let r = [];
  for (let o = 0; o < n.length; o++) {
    let l = n[o], [a, h] = du(l.fromA + i, l.fromB + s, e, t), [c, f] = mu(l.toA + i, l.toB + s, e, t), u = [l.offset(-a + i, -h + s)];
    for (; o < n.length - 1; ) {
      let d = n[o + 1], [m, p] = du(d.fromA + i, d.fromB + s, e, t);
      if (m > c + 1 && p > f + 1)
        break;
      u.push(d.offset(-a + i, -h + s)), [c, f] = mu(d.toA + i, d.toB + s, e, t), o++;
    }
    r.push(new Dn(u, a, Math.max(a, c), h, Math.max(h, f)));
  }
  return r;
}
const Or = 1e3;
function pu(n, e, t, i) {
  let s = 0, r = n.length;
  for (; ; ) {
    if (s == r) {
      let c = 0, f = 0;
      s && ({ toA: c, toB: f } = n[s - 1]);
      let u = e - (t ? c : f);
      return [c + u, f + u];
    }
    let o = s + r >> 1, l = n[o], [a, h] = t ? [l.fromA, l.toA] : [l.fromB, l.toB];
    if (a > e)
      r = o;
    else if (h <= e)
      s = o + 1;
    else
      return i ? [l.fromA, l.fromB] : [l.toA, l.toB];
  }
}
function gu(n, e, t, i) {
  let s = [];
  return e.iterChangedRanges((r, o, l, a) => {
    let h = 0, c = t ? e.length : i, f = 0, u = t ? i : e.length;
    r > Or && ([h, f] = pu(n, r - Or, t, !0)), o < e.length - Or && ([c, u] = pu(n, o + Or, t, !1));
    let d = a - l - (o - r), m, [p, g] = t ? [d, 0] : [0, d];
    s.length && (m = s[s.length - 1]).toA >= h ? s[s.length - 1] = {
      fromA: m.fromA,
      fromB: m.fromB,
      toA: c,
      toB: u,
      diffA: m.diffA + p,
      diffB: m.diffB + g
    } : s.push({ fromA: h, toA: c, fromB: f, toB: u, diffA: p, diffB: g });
  }), s;
}
function bu(n, e, t, i, s) {
  if (!n.length)
    return e;
  let r = [];
  for (let o = 0, l = 0, a = 0, h = 0; ; o++) {
    let c = o == n.length ? null : n[o], f = c ? c.fromA + l : t.length, u = c ? c.fromB + a : i.length;
    for (; h < e.length; ) {
      let g = e[h];
      if (g.toA + l > f || g.toB + a > u)
        break;
      r.push(g.offset(l, a)), h++;
    }
    if (!c)
      break;
    let d = c.toA + l + c.diffA, m = c.toB + a + c.diffB, p = s0(t.sliceString(f, d), i.sliceString(u, m), s);
    for (let g of o0(p, t, i, f, u))
      r.push(g);
    for (l += c.diffA, a += c.diffB; h < e.length; ) {
      let g = e[h];
      if (g.fromA + l > d && g.fromB + a > m)
        break;
      h++;
    }
  }
  return r;
}
const RS = { scanLimit: 500 }, l0 = /* @__PURE__ */ be.fromClass(class {
  constructor(n) {
    ({ deco: this.deco, gutter: this.gutter } = ku(n));
  }
  update(n) {
    (n.docChanged || n.viewportChanged || PS(n.startState, n.state) || BS(n.startState, n.state)) && ({ deco: this.deco, gutter: this.gutter } = ku(n.view));
  }
}, {
  decorations: (n) => n.deco
});
function PS(n, e) {
  return n.field($t, !1) != e.field($t, !1);
}
function BS(n, e) {
  return n.facet(js) != e.facet(js);
}
const yu = /* @__PURE__ */ N.line({ class: "cm-changedLine" }), IS = /* @__PURE__ */ N.mark({ class: "cm-changedText" }), NS = /* @__PURE__ */ N.mark({ tagName: "ins", class: "cm-insertedLine" }), FS = /* @__PURE__ */ N.mark({ tagName: "del", class: "cm-deletedLine" }), wu = /* @__PURE__ */ new class extends Et {
  constructor() {
    super(...arguments), this.elementClass = "cm-changedLineGutter";
  }
}();
function HS(n, e, t, i, s, r) {
  let o = t ? n.fromA : n.fromB, l = t ? n.toA : n.toB, a = 0;
  if (o != l) {
    s.add(o, o, yu), s.add(o, l, t ? FS : NS), r && r.add(o, o, wu);
    for (let h = e.iterRange(o, l - 1), c = o; !h.next().done; ) {
      if (h.lineBreak) {
        c++, s.add(c, c, yu), r && r.add(c, c, wu);
        continue;
      }
      let f = c + h.value.length;
      if (i)
        for (; a < n.changes.length; ) {
          let u = n.changes[a], d = o + (t ? u.fromA : u.fromB), m = o + (t ? u.toA : u.toB), p = Math.max(c, d), g = Math.min(f, m);
          if (p < g && s.add(p, g, IS), m < f)
            a++;
          else
            break;
        }
      c = f;
    }
  }
}
function ku(n) {
  let e = n.state.field($t), { side: t, highlightChanges: i, markGutter: s } = n.state.facet(js), r = t == "a", o = new Tt(), l = s ? new Tt() : null, { from: a, to: h } = n.viewport;
  for (let c of e) {
    if ((r ? c.fromA : c.fromB) >= h)
      break;
    (r ? c.toA : c.toB) > a && HS(c, n.state.doc, r, i, o, l);
  }
  return { deco: o.finish(), gutter: l && l.finish() };
}
const VS = /* @__PURE__ */ O.baseTheme({
  ".cm-mergeView & .cm-scroller, .cm-mergeView &": {
    height: "auto !important",
    overflowY: "visible !important"
  },
  "&.cm-merge-a .cm-changedLine, .cm-deletedChunk": {
    backgroundColor: "rgba(160, 128, 100, .08)"
  },
  "&.cm-merge-b .cm-changedLine": {
    backgroundColor: "rgba(100, 160, 128, .08)"
  },
  "&light.cm-merge-a .cm-changedText, &light .cm-deletedChunk .cm-deletedText": {
    background: "linear-gradient(#ee443366, #ee443366) bottom/100% 2px no-repeat"
  },
  "&dark.cm-merge-a .cm-changedText, &dark .cm-deletedChunk .cm-deletedText": {
    background: "linear-gradient(#ffaa9966, #ffaa9966) bottom/100% 2px no-repeat"
  },
  "&light.cm-merge-b .cm-changedText": {
    background: "linear-gradient(#22bb2266, #22bb2266) bottom/100% 2px no-repeat"
  },
  "&dark.cm-merge-b .cm-changedText": {
    background: "linear-gradient(#88ff8866, #88ff8866) bottom/100% 2px no-repeat"
  },
  ".cm-insertedLine, .cm-deletedLine": {
    textDecoration: "none"
  },
  ".cm-deletedChunk": {
    paddingLeft: "6px",
    "& .cm-chunkButtons": {
      position: "absolute",
      insetInlineEnd: "5px"
    },
    "& button": {
      border: "none",
      cursor: "pointer",
      color: "white",
      margin: "0 2px",
      borderRadius: "3px",
      "&[name=accept]": { background: "#2a2" },
      "&[name=reject]": { background: "#d43" }
    }
  },
  ".cm-collapsedLines": {
    padding: "5px 5px 5px 10px",
    cursor: "pointer"
  },
  "&light .cm-collapsedLines": {
    color: "#444",
    background: "linear-gradient(to bottom, transparent 0, #f3f3f3 30%, #f3f3f3 70%, transparent 100%)"
  },
  "&dark .cm-collapsedLines": {
    color: "#ddd",
    background: "linear-gradient(to bottom, transparent 0, #222 30%, #222 70%, transparent 100%)"
  },
  ".cm-changeGutter": { width: "3px", paddingLeft: "1px" },
  "&light.cm-merge-a .cm-changedLineGutter, &light .cm-deletedLineGutter": { background: "#e43" },
  "&dark.cm-merge-a .cm-changedLineGutter, &dark .cm-deletedLineGutter": { background: "#fa9" },
  "&light.cm-merge-b .cm-changedLineGutter": { background: "#2b2" },
  "&dark.cm-merge-b .cm-changedLineGutter": { background: "#8f8" }
}), WS = /* @__PURE__ */ new class extends Et {
  constructor() {
    super(...arguments), this.elementClass = "cm-deletedLineGutter";
  }
}(), zS = /* @__PURE__ */ ei.low(/* @__PURE__ */ Jm({
  class: "cm-changeGutter",
  markers: (n) => {
    var e;
    return ((e = n.plugin(l0)) === null || e === void 0 ? void 0 : e.gutter) || ne.empty;
  },
  widgetMarker: (n, e) => e instanceof a0 ? WS : null
}));
function qS(n) {
  let e = typeof n.original == "string" ? ie.of(n.original.split(/\r?\n/)) : n.original, t = n.diffConfig || RS;
  return [
    ei.low(l0),
    GS,
    VS,
    O.editorAttributes.of({ class: "cm-merge-b" }),
    Z.transactionExtender.of((i) => {
      let s = i.effects.find((l) => l.is(Oh));
      if (!i.docChanged && !s)
        return null;
      let r = i.startState.field($t), o = s ? Dn.updateA(r, s.value.doc, i.newDoc, s.value.changes, t) : Dn.updateB(r, i.startState.field(Ks), i.newDoc, i.changes, t);
      return { effects: r0.of(o) };
    }),
    js.of({
      highlightChanges: n.highlightChanges !== !1,
      markGutter: n.gutter !== !1,
      syntaxHighlightDeletions: n.syntaxHighlightDeletions !== !1,
      mergeControls: n.mergeControls !== !1,
      side: "b"
    }),
    Ks.init(() => e),
    n.gutter !== !1 ? zS : [],
    $t.init((i) => Dn.build(e, i.doc, t))
  ];
}
const Oh = /* @__PURE__ */ K.define(), Ks = /* @__PURE__ */ ke.define({
  create: () => ie.empty,
  update(n, e) {
    for (let t of e.effects)
      t.is(Oh) && (n = t.value.doc);
    return n;
  }
}), vu = /* @__PURE__ */ new WeakMap();
class a0 extends Lt {
  constructor(e) {
    super(), this.buildDOM = e, this.dom = null;
  }
  eq(e) {
    return this.dom == e.dom;
  }
  toDOM(e) {
    return this.dom || (this.dom = this.buildDOM(e));
  }
}
function US(n, e) {
  let t = vu.get(e.changes);
  if (t)
    return t;
  let i = (r) => {
    let { highlightChanges: o, syntaxHighlightDeletions: l, mergeControls: a } = n.facet(js), h = r.state.field(Ks).sliceString(e.fromA, e.endA), c = l && n.facet(ui), f = document.createElement("div");
    if (f.className = "cm-deletedChunk", a) {
      let b = f.appendChild(document.createElement("div"));
      b.className = "cm-chunkButtons";
      let w = b.appendChild(document.createElement("button"));
      w.name = "accept", w.textContent = n.phrase("Accept"), w.onmousedown = (x) => {
        x.preventDefault(), jS(r, r.posAtDOM(f));
      };
      let k = b.appendChild(document.createElement("button"));
      k.name = "reject", k.textContent = n.phrase("Reject"), k.onmousedown = (x) => {
        x.preventDefault(), KS(r, r.posAtDOM(f));
      };
    }
    let u = f.appendChild(document.createElement("del")), d = e.changes, m = 0, p = !1;
    function g(b, w, k) {
      for (let x = b; x < w; ) {
        let _ = w, S = k + (p ? " cm-deletedText" : ""), A = !1;
        if (o && m < d.length) {
          let P = Math.max(0, p ? d[m].toA : d[m].fromA);
          P <= _ && (_ = P, p && m++, A = !0);
        }
        if (_ > x) {
          let P = document.createTextNode(h.slice(x, _));
          if (S) {
            let W = u.appendChild(document.createElement("span"));
            W.className = S, W.appendChild(P);
          } else
            u.appendChild(P);
        }
        x = _, A && (p = !p);
      }
    }
    if (c) {
      let b = c.parser.parse(h), w = 0;
      op(b, { style: (k) => Vw(n, k) }, (k, x, _) => {
        k > w && g(w, k, ""), g(k, x, _), w = x;
      }), g(w, h.length, "");
    } else
      g(0, h.length, "");
    return f;
  }, s = N.widget({
    block: !0,
    side: -1,
    widget: new a0(i)
  });
  return vu.set(e.changes, s), s;
}
function jS(n, e) {
  let { state: t } = n, i = e ?? t.selection.main.head, s = n.state.field($t).find((a) => a.fromB <= i && a.endB >= i);
  if (!s)
    return !1;
  let r = n.state.sliceDoc(s.fromB, Math.max(s.fromB, s.toB - 1)), o = n.state.field(Ks);
  s.fromB != s.toB && s.toA <= o.length && (r += n.state.lineBreak);
  let l = Se.of({ from: s.fromA, to: Math.min(o.length, s.toA), insert: r }, o.length);
  return n.dispatch({
    effects: Oh.of({ doc: l.apply(o), changes: l }),
    userEvent: "accept"
  }), !0;
}
function KS(n, e) {
  let { state: t } = n, i = e ?? t.selection.main.head, s = t.field($t).find((l) => l.fromB <= i && l.endB >= i);
  if (!s)
    return !1;
  let o = t.field(Ks).sliceString(s.fromA, Math.max(s.fromA, s.toA - 1));
  return s.fromA != s.toA && s.toB <= t.doc.length && (o += t.lineBreak), n.dispatch({
    changes: { from: s.fromB, to: Math.min(t.doc.length, s.toB), insert: o },
    userEvent: "revert"
  }), !0;
}
function xu(n) {
  let e = new Tt();
  for (let t of n.field($t))
    e.add(t.fromB, t.fromB, US(n, t));
  return e.finish();
}
const GS = /* @__PURE__ */ ke.define({
  create: (n) => xu(n),
  update(n, e) {
    return e.state.field($t, !1) != e.startState.field($t, !1) ? xu(e.state) : n;
  },
  provide: (n) => O.decorations.from(n)
}), {
  SvelteComponent: YS,
  append: XS,
  attr: Sl,
  binding_callbacks: JS,
  detach: QS,
  element: Su,
  init: ZS,
  insert: $S,
  noop: _u,
  safe_not_equal: e_
} = window.__gradio__svelte__internal, { onMount: t_, onDestroy: i_, createEventDispatcher: n_ } = window.__gradio__svelte__internal;
function s_(n) {
  let e, t, i;
  return {
    c() {
      e = Su("div"), t = Su("div"), Sl(t, "class", i = "codemirror-wrapper " + /*class_names*/
      n[0] + " svelte-1f1hlu0"), Sl(e, "class", "wrap svelte-1f1hlu0");
    },
    m(s, r) {
      $S(s, e, r), XS(e, t), n[10](t);
    },
    p(s, [r]) {
      r & /*class_names*/
      1 && i !== (i = "codemirror-wrapper " + /*class_names*/
      s[0] + " svelte-1f1hlu0") && Sl(t, "class", i);
    },
    i: _u,
    o: _u,
    d(s) {
      s && QS(e), n[10](null);
    }
  };
}
let r_ = !0;
function o_(n) {
  var e, t;
  let i = n.dom.querySelectorAll(".cm-gutterElement");
  if (i.length === 0)
    return null;
  for (var s = 0; s < i.length; s++) {
    let r = i[s], o = (t = (e = getComputedStyle(r)) === null || e === void 0 ? void 0 : e.height) !== null && t !== void 0 ? t : "0px";
    if (o != "0px")
      return o;
  }
  return null;
}
function l_(n, e, t) {
  var i = this && this.__awaiter || function(R, z, G, Q) {
    function re(T) {
      return T instanceof G ? T : new G(function(ee) {
        ee(T);
      });
    }
    return new (G || (G = Promise))(function(T, ee) {
      function J(q) {
        try {
          oe(Q.next(q));
        } catch (ve) {
          ee(ve);
        }
      }
      function j(q) {
        try {
          oe(Q.throw(q));
        } catch (ve) {
          ee(ve);
        }
      }
      function oe(q) {
        q.done ? T(q.value) : re(q.value).then(J, j);
      }
      oe((Q = Q.apply(R, z || [])).next());
    });
  };
  let { class_names: s = "" } = e, { value: r } = e, { dark_mode: o } = e, { basic: l = !0 } = e, { language: a } = e, { lines: h = 5 } = e, { extensions: c = [] } = e, { use_tab: f = !0 } = e, u, d, m;
  const p = n_();
  function g(R) {
    return i(this, void 0, void 0, function* () {
      u = yield Hg(R);
    });
  }
  function b() {
    const R = new O({
      parent: d,
      state: _(r.diff)
    });
    return R.dom.addEventListener("focus", w, !0), R.dom.addEventListener("blur", k, !0), R;
  }
  function w() {
    p("focus");
  }
  function k() {
    p("blur");
  }
  function x(R) {
    if (R.docChanged) {
      const G = R.state.doc.toString();
      t(2, r.diff = G, r), p("change", G);
    }
    m.requestMeasure({ read: P });
  }
  function _(R) {
    return Z.create({
      doc: R,
      extensions: S()
    });
  }
  function S() {
    return [
      ...U(l, f, null, r_, u),
      W,
      ...F(),
      ...c,
      qS({
        original: r.code,
        mergeControls: !1,
        gutter: !0
      }),
      O.updateListener.of(x)
    ];
  }
  function A() {
    m == null || m.dispatch({
      effects: K.reconfigure.of(S())
    });
  }
  t_(() => (t(9, m = b()), () => m == null ? void 0 : m.destroy()));
  function P(R) {
    let z = R.dom.querySelectorAll(".cm-gutter"), G = h + 1, Q = o_(R);
    if (!Q)
      return null;
    for (var re = 0; re < z.length; re++) {
      let T = z[re];
      T.style.minHeight = `calc(${Q} * ${G})`;
    }
    return null;
  }
  i_(() => {
    m && m.destroy();
  });
  const W = O.theme({
    "&": {
      fontSize: "var(--text-sm)",
      backgroundColor: "var(--border-color-secondary)"
    },
    ".cm-content": {
      paddingTop: "5px",
      paddingBottom: "5px",
      color: "var(--body-text-color)",
      fontFamily: "var(--font-mono)",
      minHeight: "100%"
    },
    ".cm-gutters": {
      marginRight: "1px",
      borderRight: "1px solid var(--border-color-primary)",
      backgroundColor: "var(--block-background-fill);",
      color: "var(--body-text-color-subdued)"
    },
    ".cm-focused": { outline: "none" },
    ".cm-scroller": { height: "auto" },
    ".cm-cursor": {
      borderLeftColor: "var(--body-text-color)"
    }
  });
  function U(R, z, G, Q, re) {
    const T = [O.editable.of(!Q), Z.readOnly.of(Q)];
    return R && T.push(AS), z && T.push(rn.of([pg])), re && T.push(re), T;
  }
  function F() {
    return o ? [yg] : [wg];
  }
  function M(R) {
    JS[R ? "unshift" : "push"](() => {
      d = R, t(1, d);
    });
  }
  return n.$$set = (R) => {
    "class_names" in R && t(0, s = R.class_names), "value" in R && t(2, r = R.value), "dark_mode" in R && t(3, o = R.dark_mode), "basic" in R && t(4, l = R.basic), "language" in R && t(5, a = R.language), "lines" in R && t(6, h = R.lines), "extensions" in R && t(7, c = R.extensions), "use_tab" in R && t(8, f = R.use_tab);
  }, n.$$.update = () => {
    n.$$.dirty & /*view, value, dark_mode, language*/
    556 && m && (r || o || a) && A(), n.$$.dirty & /*language*/
    32 && g(a);
  }, [
    s,
    d,
    r,
    o,
    l,
    a,
    h,
    c,
    f,
    m,
    M
  ];
}
class a_ extends YS {
  constructor(e) {
    super(), ZS(this, e, l_, s_, e_, {
      class_names: 0,
      value: 2,
      dark_mode: 3,
      basic: 4,
      language: 5,
      lines: 6,
      extensions: 7,
      use_tab: 8
    });
  }
}
const {
  SvelteComponent: h_,
  append: c_,
  attr: oi,
  detach: f_,
  init: u_,
  insert: d_,
  noop: _l,
  safe_not_equal: m_,
  svg_element: Cu
} = window.__gradio__svelte__internal;
function p_(n) {
  let e, t;
  return {
    c() {
      e = Cu("svg"), t = Cu("polyline"), oi(t, "points", "20 6 9 17 4 12"), oi(e, "xmlns", "http://www.w3.org/2000/svg"), oi(e, "viewBox", "2 0 20 20"), oi(e, "fill", "none"), oi(e, "stroke", "currentColor"), oi(e, "aria-hidden", "true"), oi(e, "stroke-width", "2"), oi(e, "stroke-linecap", "round"), oi(e, "stroke-linejoin", "round");
    },
    m(i, s) {
      d_(i, e, s), c_(e, t);
    },
    p: _l,
    i: _l,
    o: _l,
    d(i) {
      i && f_(e);
    }
  };
}
class h0 extends h_ {
  constructor(e) {
    super(), u_(this, e, null, p_, m_, {});
  }
}
const {
  SvelteComponent: g_,
  append: Cl,
  attr: xt,
  detach: b_,
  init: y_,
  insert: w_,
  noop: Al,
  safe_not_equal: k_,
  set_style: Ht,
  svg_element: Er
} = window.__gradio__svelte__internal;
function v_(n) {
  let e, t, i, s;
  return {
    c() {
      e = Er("svg"), t = Er("g"), i = Er("path"), s = Er("path"), xt(i, "d", "M18,6L6.087,17.913"), Ht(i, "fill", "none"), Ht(i, "fill-rule", "nonzero"), Ht(i, "stroke-width", "2px"), xt(t, "transform", "matrix(1.14096,-0.140958,-0.140958,1.14096,-0.0559523,0.0559523)"), xt(s, "d", "M4.364,4.364L19.636,19.636"), Ht(s, "fill", "none"), Ht(s, "fill-rule", "nonzero"), Ht(s, "stroke-width", "2px"), xt(e, "width", "100%"), xt(e, "height", "100%"), xt(e, "viewBox", "0 0 24 24"), xt(e, "version", "1.1"), xt(e, "xmlns", "http://www.w3.org/2000/svg"), xt(e, "xmlns:xlink", "http://www.w3.org/1999/xlink"), xt(e, "xml:space", "preserve"), xt(e, "stroke", "currentColor"), Ht(e, "fill-rule", "evenodd"), Ht(e, "clip-rule", "evenodd"), Ht(e, "stroke-linecap", "round"), Ht(e, "stroke-linejoin", "round");
    },
    m(r, o) {
      w_(r, e, o), Cl(e, t), Cl(t, i), Cl(e, s);
    },
    p: Al,
    i: Al,
    o: Al,
    d(r) {
      r && b_(e);
    }
  };
}
class x_ extends g_ {
  constructor(e) {
    super(), y_(this, e, null, v_, k_, {});
  }
}
const {
  SvelteComponent: S_,
  append: __,
  attr: rs,
  detach: C_,
  init: A_,
  insert: M_,
  noop: Ml,
  safe_not_equal: T_,
  svg_element: Au
} = window.__gradio__svelte__internal;
function D_(n) {
  let e, t;
  return {
    c() {
      e = Au("svg"), t = Au("path"), rs(t, "fill", "currentColor"), rs(t, "d", "m31 16l-7 7l-1.41-1.41L28.17 16l-5.58-5.59L24 9l7 7zM1 16l7-7l1.41 1.41L3.83 16l5.58 5.59L8 23l-7-7zm11.42 9.484L17.64 6l1.932.517L14.352 26z"), rs(e, "width", "100%"), rs(e, "height", "100%"), rs(e, "viewBox", "0 0 32 32");
    },
    m(i, s) {
      M_(i, e, s), __(e, t);
    },
    p: Ml,
    i: Ml,
    o: Ml,
    d(i) {
      i && C_(e);
    }
  };
}
class c0 extends S_ {
  constructor(e) {
    super(), A_(this, e, null, D_, T_, {});
  }
}
const {
  SvelteComponent: O_,
  append: Mu,
  attr: gi,
  detach: E_,
  init: L_,
  insert: R_,
  noop: Tl,
  safe_not_equal: P_,
  svg_element: Dl
} = window.__gradio__svelte__internal;
function B_(n) {
  let e, t, i;
  return {
    c() {
      e = Dl("svg"), t = Dl("path"), i = Dl("path"), gi(t, "fill", "currentColor"), gi(t, "d", "M28 10v18H10V10h18m0-2H10a2 2 0 0 0-2 2v18a2 2 0 0 0 2 2h18a2 2 0 0 0 2-2V10a2 2 0 0 0-2-2Z"), gi(i, "fill", "currentColor"), gi(i, "d", "M4 18H2V4a2 2 0 0 1 2-2h14v2H4Z"), gi(e, "xmlns", "http://www.w3.org/2000/svg"), gi(e, "viewBox", "0 0 33 33"), gi(e, "color", "currentColor"), gi(e, "aria-hidden", "true");
    },
    m(s, r) {
      R_(s, e, r), Mu(e, t), Mu(e, i);
    },
    p: Tl,
    i: Tl,
    o: Tl,
    d(s) {
      s && E_(e);
    }
  };
}
class I_ extends O_ {
  constructor(e) {
    super(), L_(this, e, null, B_, P_, {});
  }
}
const {
  SvelteComponent: N_,
  append: F_,
  attr: dn,
  detach: H_,
  init: V_,
  insert: W_,
  noop: Ol,
  safe_not_equal: z_,
  svg_element: Tu
} = window.__gradio__svelte__internal;
function q_(n) {
  let e, t;
  return {
    c() {
      e = Tu("svg"), t = Tu("path"), dn(t, "fill", "currentColor"), dn(t, "d", "M26 24v4H6v-4H4v4a2 2 0 0 0 2 2h20a2 2 0 0 0 2-2v-4zm0-10l-1.41-1.41L17 20.17V2h-2v18.17l-7.59-7.58L6 14l10 10l10-10z"), dn(e, "xmlns", "http://www.w3.org/2000/svg"), dn(e, "width", "100%"), dn(e, "height", "100%"), dn(e, "viewBox", "0 0 32 32");
    },
    m(i, s) {
      W_(i, e, s), F_(e, t);
    },
    p: Ol,
    i: Ol,
    o: Ol,
    d(i) {
      i && H_(e);
    }
  };
}
class U_ extends N_ {
  constructor(e) {
    super(), V_(this, e, null, q_, z_, {});
  }
}
const {
  SvelteComponent: j_,
  attr: bs,
  check_outros: K_,
  create_component: f0,
  destroy_component: u0,
  detach: d0,
  element: m0,
  group_outros: G_,
  init: Y_,
  insert: p0,
  listen: X_,
  mount_component: g0,
  safe_not_equal: J_,
  toggle_class: Du,
  transition_in: yo,
  transition_out: wo
} = window.__gradio__svelte__internal, { onDestroy: Q_ } = window.__gradio__svelte__internal;
function Z_(n) {
  let e, t, i;
  return t = new h0({}), {
    c() {
      e = m0("span"), f0(t.$$.fragment), bs(e, "class", "check svelte-1uyt7d6");
    },
    m(s, r) {
      p0(s, e, r), g0(t, e, null), i = !0;
    },
    i(s) {
      i || (yo(t.$$.fragment, s), i = !0);
    },
    o(s) {
      wo(t.$$.fragment, s), i = !1;
    },
    d(s) {
      s && d0(e), u0(t);
    }
  };
}
function $_(n) {
  let e, t;
  return e = new I_({}), {
    c() {
      f0(e.$$.fragment);
    },
    m(i, s) {
      g0(e, i, s), t = !0;
    },
    i(i) {
      t || (yo(e.$$.fragment, i), t = !0);
    },
    o(i) {
      wo(e.$$.fragment, i), t = !1;
    },
    d(i) {
      u0(e, i);
    }
  };
}
function eC(n) {
  let e, t, i, s, r, o, l;
  const a = [$_, Z_], h = [];
  function c(f, u) {
    return (
      /*copied*/
      f[0] ? 1 : 0
    );
  }
  return t = c(n), i = h[t] = a[t](n), {
    c() {
      e = m0("button"), i.c(), bs(e, "title", "copy"), bs(e, "aria-label", s = /*copied*/
      n[0] ? "Value copied" : "Copy value"), bs(e, "class", "svelte-1uyt7d6"), Du(
        e,
        "copied",
        /*copied*/
        n[0]
      );
    },
    m(f, u) {
      p0(f, e, u), h[t].m(e, null), r = !0, o || (l = X_(
        e,
        "click",
        /*handle_copy*/
        n[1]
      ), o = !0);
    },
    p(f, [u]) {
      let d = t;
      t = c(f), t !== d && (G_(), wo(h[d], 1, 1, () => {
        h[d] = null;
      }), K_(), i = h[t], i || (i = h[t] = a[t](f), i.c()), yo(i, 1), i.m(e, null)), (!r || u & /*copied*/
      1 && s !== (s = /*copied*/
      f[0] ? "Value copied" : "Copy value")) && bs(e, "aria-label", s), (!r || u & /*copied*/
      1) && Du(
        e,
        "copied",
        /*copied*/
        f[0]
      );
    },
    i(f) {
      r || (yo(i), r = !0);
    },
    o(f) {
      wo(i), r = !1;
    },
    d(f) {
      f && d0(e), h[t].d(), o = !1, l();
    }
  };
}
function tC(n, e, t) {
  var i = this && this.__awaiter || function(h, c, f, u) {
    function d(m) {
      return m instanceof f ? m : new f(function(p) {
        p(m);
      });
    }
    return new (f || (f = Promise))(function(m, p) {
      function g(k) {
        try {
          w(u.next(k));
        } catch (x) {
          p(x);
        }
      }
      function b(k) {
        try {
          w(u.throw(k));
        } catch (x) {
          p(x);
        }
      }
      function w(k) {
        k.done ? m(k.value) : d(k.value).then(g, b);
      }
      w((u = u.apply(h, c || [])).next());
    });
  };
  let s = !1, { value: r } = e, o;
  function l() {
    t(0, s = !0), o && clearTimeout(o), o = setTimeout(
      () => {
        t(0, s = !1);
      },
      2e3
    );
  }
  function a() {
    return i(this, void 0, void 0, function* () {
      "clipboard" in navigator && (yield navigator.clipboard.writeText(r), l());
    });
  }
  return Q_(() => {
    o && clearTimeout(o);
  }), n.$$set = (h) => {
    "value" in h && t(2, r = h.value);
  }, [s, a, r];
}
class iC extends j_ {
  constructor(e) {
    super(), Y_(this, e, tC, eC, J_, { value: 2 });
  }
}
function Gr() {
}
const nC = (n) => n;
function sC(n, e) {
  return n != n ? e == e : n !== e || n && typeof n == "object" || typeof n == "function";
}
const b0 = typeof window < "u";
let Ou = b0 ? () => window.performance.now() : () => Date.now(), y0 = b0 ? (n) => requestAnimationFrame(n) : Gr;
const On = /* @__PURE__ */ new Set();
function w0(n) {
  On.forEach((e) => {
    e.c(n) || (On.delete(e), e.f());
  }), On.size !== 0 && y0(w0);
}
function rC(n) {
  let e;
  return On.size === 0 && y0(w0), {
    promise: new Promise((t) => {
      On.add(e = { c: n, f: t });
    }),
    abort() {
      On.delete(e);
    }
  };
}
function Eu(n, { delay: e = 0, duration: t = 400, easing: i = nC } = {}) {
  const s = +getComputedStyle(n).opacity;
  return {
    delay: e,
    duration: t,
    easing: i,
    css: (r) => `opacity: ${r * s}`
  };
}
const mn = [];
function oC(n, e = Gr) {
  let t;
  const i = /* @__PURE__ */ new Set();
  function s(l) {
    if (sC(n, l) && (n = l, t)) {
      const a = !mn.length;
      for (const h of i)
        h[1](), mn.push(h, n);
      if (a) {
        for (let h = 0; h < mn.length; h += 2)
          mn[h][0](mn[h + 1]);
        mn.length = 0;
      }
    }
  }
  function r(l) {
    s(l(n));
  }
  function o(l, a = Gr) {
    const h = [l, a];
    return i.add(h), i.size === 1 && (t = e(s, r) || Gr), l(n), () => {
      i.delete(h), i.size === 0 && t && (t(), t = null);
    };
  }
  return { set: s, update: r, subscribe: o };
}
function Lu(n) {
  return Object.prototype.toString.call(n) === "[object Date]";
}
function Ia(n, e, t, i) {
  if (typeof t == "number" || Lu(t)) {
    const s = i - t, r = (t - e) / (n.dt || 1 / 60), o = n.opts.stiffness * s, l = n.opts.damping * r, a = (o - l) * n.inv_mass, h = (r + a) * n.dt;
    return Math.abs(h) < n.opts.precision && Math.abs(s) < n.opts.precision ? i : (n.settled = !1, Lu(t) ? new Date(t.getTime() + h) : t + h);
  } else {
    if (Array.isArray(t))
      return t.map(
        (s, r) => Ia(n, e[r], t[r], i[r])
      );
    if (typeof t == "object") {
      const s = {};
      for (const r in t)
        s[r] = Ia(n, e[r], t[r], i[r]);
      return s;
    } else
      throw new Error(`Cannot spring ${typeof t} values`);
  }
}
function Ru(n, e = {}) {
  const t = oC(n), { stiffness: i = 0.15, damping: s = 0.8, precision: r = 0.01 } = e;
  let o, l, a, h = n, c = n, f = 1, u = 0, d = !1;
  function m(g, b = {}) {
    c = g;
    const w = a = {};
    return n == null || b.hard || p.stiffness >= 1 && p.damping >= 1 ? (d = !0, o = Ou(), h = g, t.set(n = c), Promise.resolve()) : (b.soft && (u = 1 / ((b.soft === !0 ? 0.5 : +b.soft) * 60), f = 0), l || (o = Ou(), d = !1, l = rC((k) => {
      if (d)
        return d = !1, l = null, !1;
      f = Math.min(f + u, 1);
      const x = {
        inv_mass: f,
        opts: p,
        settled: !0,
        dt: (k - o) * 60 / 1e3
      }, _ = Ia(x, h, n, c);
      return o = k, h = n, t.set(n = _), x.settled && (l = null), !x.settled;
    })), new Promise((k) => {
      l.promise.then(() => {
        w === a && k();
      });
    }));
  }
  const p = {
    set: m,
    update: (g, b) => m(g(c, n), b),
    subscribe: t.subscribe,
    stiffness: i,
    damping: s,
    precision: r
  };
  return p;
}
const { setContext: KM, getContext: lC } = window.__gradio__svelte__internal, aC = "WORKER_PROXY_CONTEXT_KEY";
function hC() {
  return lC(aC);
}
function cC(n) {
  return n.host === window.location.host || n.host === "localhost:7860" || n.host === "127.0.0.1:7860" || // Ref: https://github.com/gradio-app/gradio/blob/v3.32.0/js/app/src/Index.svelte#L194
  n.host === "lite.local";
}
function fC(n, e) {
  const t = e.toLowerCase();
  for (const [i, s] of Object.entries(n))
    if (i.toLowerCase() === t)
      return s;
}
function uC(n) {
  if (n == null)
    return !1;
  const e = new URL(n, window.location.href);
  return !(!cC(e) || e.protocol !== "http:" && e.protocol !== "https:");
}
const {
  SvelteComponent: dC,
  assign: ko,
  check_outros: k0,
  compute_rest_props: Pu,
  create_slot: Eh,
  detach: Fo,
  element: v0,
  empty: x0,
  exclude_internal_props: mC,
  get_all_dirty_from_scope: Lh,
  get_slot_changes: Rh,
  get_spread_update: S0,
  group_outros: _0,
  init: pC,
  insert: Ho,
  listen: C0,
  prevent_default: gC,
  safe_not_equal: bC,
  set_attributes: vo,
  transition_in: nn,
  transition_out: sn,
  update_slot_base: Ph
} = window.__gradio__svelte__internal, { createEventDispatcher: yC } = window.__gradio__svelte__internal;
function wC(n) {
  let e, t, i, s, r;
  const o = (
    /*#slots*/
    n[8].default
  ), l = Eh(
    o,
    n,
    /*$$scope*/
    n[7],
    null
  );
  let a = [
    { href: (
      /*href*/
      n[0]
    ) },
    {
      target: t = typeof window < "u" && window.__is_colab__ ? "_blank" : null
    },
    { rel: "noopener noreferrer" },
    { download: (
      /*download*/
      n[1]
    ) },
    /*$$restProps*/
    n[6]
  ], h = {};
  for (let c = 0; c < a.length; c += 1)
    h = ko(h, a[c]);
  return {
    c() {
      e = v0("a"), l && l.c(), vo(e, h);
    },
    m(c, f) {
      Ho(c, e, f), l && l.m(e, null), i = !0, s || (r = C0(
        e,
        "click",
        /*dispatch*/
        n[3].bind(null, "click")
      ), s = !0);
    },
    p(c, f) {
      l && l.p && (!i || f & /*$$scope*/
      128) && Ph(
        l,
        o,
        c,
        /*$$scope*/
        c[7],
        i ? Rh(
          o,
          /*$$scope*/
          c[7],
          f,
          null
        ) : Lh(
          /*$$scope*/
          c[7]
        ),
        null
      ), vo(e, h = S0(a, [
        (!i || f & /*href*/
        1) && { href: (
          /*href*/
          c[0]
        ) },
        { target: t },
        { rel: "noopener noreferrer" },
        (!i || f & /*download*/
        2) && { download: (
          /*download*/
          c[1]
        ) },
        f & /*$$restProps*/
        64 && /*$$restProps*/
        c[6]
      ]));
    },
    i(c) {
      i || (nn(l, c), i = !0);
    },
    o(c) {
      sn(l, c), i = !1;
    },
    d(c) {
      c && Fo(e), l && l.d(c), s = !1, r();
    }
  };
}
function kC(n) {
  let e, t, i, s;
  const r = [xC, vC], o = [];
  function l(a, h) {
    return (
      /*is_downloading*/
      a[2] ? 0 : 1
    );
  }
  return e = l(n), t = o[e] = r[e](n), {
    c() {
      t.c(), i = x0();
    },
    m(a, h) {
      o[e].m(a, h), Ho(a, i, h), s = !0;
    },
    p(a, h) {
      let c = e;
      e = l(a), e === c ? o[e].p(a, h) : (_0(), sn(o[c], 1, 1, () => {
        o[c] = null;
      }), k0(), t = o[e], t ? t.p(a, h) : (t = o[e] = r[e](a), t.c()), nn(t, 1), t.m(i.parentNode, i));
    },
    i(a) {
      s || (nn(t), s = !0);
    },
    o(a) {
      sn(t), s = !1;
    },
    d(a) {
      a && Fo(i), o[e].d(a);
    }
  };
}
function vC(n) {
  let e, t, i, s;
  const r = (
    /*#slots*/
    n[8].default
  ), o = Eh(
    r,
    n,
    /*$$scope*/
    n[7],
    null
  );
  let l = [
    /*$$restProps*/
    n[6],
    { href: (
      /*href*/
      n[0]
    ) }
  ], a = {};
  for (let h = 0; h < l.length; h += 1)
    a = ko(a, l[h]);
  return {
    c() {
      e = v0("a"), o && o.c(), vo(e, a);
    },
    m(h, c) {
      Ho(h, e, c), o && o.m(e, null), t = !0, i || (s = C0(e, "click", gC(
        /*wasm_click_handler*/
        n[5]
      )), i = !0);
    },
    p(h, c) {
      o && o.p && (!t || c & /*$$scope*/
      128) && Ph(
        o,
        r,
        h,
        /*$$scope*/
        h[7],
        t ? Rh(
          r,
          /*$$scope*/
          h[7],
          c,
          null
        ) : Lh(
          /*$$scope*/
          h[7]
        ),
        null
      ), vo(e, a = S0(l, [
        c & /*$$restProps*/
        64 && /*$$restProps*/
        h[6],
        (!t || c & /*href*/
        1) && { href: (
          /*href*/
          h[0]
        ) }
      ]));
    },
    i(h) {
      t || (nn(o, h), t = !0);
    },
    o(h) {
      sn(o, h), t = !1;
    },
    d(h) {
      h && Fo(e), o && o.d(h), i = !1, s();
    }
  };
}
function xC(n) {
  let e;
  const t = (
    /*#slots*/
    n[8].default
  ), i = Eh(
    t,
    n,
    /*$$scope*/
    n[7],
    null
  );
  return {
    c() {
      i && i.c();
    },
    m(s, r) {
      i && i.m(s, r), e = !0;
    },
    p(s, r) {
      i && i.p && (!e || r & /*$$scope*/
      128) && Ph(
        i,
        t,
        s,
        /*$$scope*/
        s[7],
        e ? Rh(
          t,
          /*$$scope*/
          s[7],
          r,
          null
        ) : Lh(
          /*$$scope*/
          s[7]
        ),
        null
      );
    },
    i(s) {
      e || (nn(i, s), e = !0);
    },
    o(s) {
      sn(i, s), e = !1;
    },
    d(s) {
      i && i.d(s);
    }
  };
}
function SC(n) {
  let e, t, i, s, r;
  const o = [kC, wC], l = [];
  function a(h, c) {
    return c & /*href*/
    1 && (e = null), e == null && (e = !!/*worker_proxy*/
    (h[4] && uC(
      /*href*/
      h[0]
    ))), e ? 0 : 1;
  }
  return t = a(n, -1), i = l[t] = o[t](n), {
    c() {
      i.c(), s = x0();
    },
    m(h, c) {
      l[t].m(h, c), Ho(h, s, c), r = !0;
    },
    p(h, [c]) {
      let f = t;
      t = a(h, c), t === f ? l[t].p(h, c) : (_0(), sn(l[f], 1, 1, () => {
        l[f] = null;
      }), k0(), i = l[t], i ? i.p(h, c) : (i = l[t] = o[t](h), i.c()), nn(i, 1), i.m(s.parentNode, s));
    },
    i(h) {
      r || (nn(i), r = !0);
    },
    o(h) {
      sn(i), r = !1;
    },
    d(h) {
      h && Fo(s), l[t].d(h);
    }
  };
}
function _C(n, e, t) {
  const i = ["href", "download"];
  let s = Pu(e, i), { $$slots: r = {}, $$scope: o } = e;
  var l = this && this.__awaiter || function(m, p, g, b) {
    function w(k) {
      return k instanceof g ? k : new g(function(x) {
        x(k);
      });
    }
    return new (g || (g = Promise))(function(k, x) {
      function _(P) {
        try {
          A(b.next(P));
        } catch (W) {
          x(W);
        }
      }
      function S(P) {
        try {
          A(b.throw(P));
        } catch (W) {
          x(W);
        }
      }
      function A(P) {
        P.done ? k(P.value) : w(P.value).then(_, S);
      }
      A((b = b.apply(m, p || [])).next());
    });
  };
  let { href: a = void 0 } = e, { download: h } = e;
  const c = yC();
  let f = !1;
  const u = hC();
  function d() {
    return l(this, void 0, void 0, function* () {
      if (f)
        return;
      if (c("click"), a == null)
        throw new Error("href is not defined.");
      if (u == null)
        throw new Error("Wasm worker proxy is not available.");
      const p = new URL(a, window.location.href).pathname;
      t(2, f = !0), u.httpRequest({
        method: "GET",
        path: p,
        headers: {},
        query_string: ""
      }).then((g) => {
        if (g.status !== 200)
          throw new Error(`Failed to get file ${p} from the Wasm worker.`);
        const b = new Blob(
          [g.body],
          {
            type: fC(g.headers, "content-type")
          }
        ), w = URL.createObjectURL(b), k = document.createElement("a");
        k.href = w, k.download = h, k.click(), URL.revokeObjectURL(w);
      }).finally(() => {
        t(2, f = !1);
      });
    });
  }
  return n.$$set = (m) => {
    e = ko(ko({}, e), mC(m)), t(6, s = Pu(e, i)), "href" in m && t(0, a = m.href), "download" in m && t(1, h = m.download), "$$scope" in m && t(7, o = m.$$scope);
  }, [
    a,
    h,
    f,
    c,
    u,
    d,
    s,
    o,
    r
  ];
}
class CC extends dC {
  constructor(e) {
    super(), pC(this, e, _C, SC, bC, { href: 0, download: 1 });
  }
}
const {
  SvelteComponent: AC,
  add_render_callback: MC,
  attr: A0,
  check_outros: TC,
  create_bidirectional_transition: Bu,
  create_component: Bh,
  destroy_component: Ih,
  detach: xo,
  element: M0,
  empty: DC,
  group_outros: OC,
  init: EC,
  insert: So,
  mount_component: Nh,
  safe_not_equal: LC,
  space: RC,
  transition_in: vn,
  transition_out: _s
} = window.__gradio__svelte__internal, { onDestroy: PC } = window.__gradio__svelte__internal;
function Iu(n) {
  let e, t, i, s;
  return t = new h0({}), {
    c() {
      e = M0("span"), Bh(t.$$.fragment), A0(e, "class", "check svelte-peh06t");
    },
    m(r, o) {
      So(r, e, o), Nh(t, e, null), s = !0;
    },
    i(r) {
      s || (vn(t.$$.fragment, r), r && MC(() => {
        s && (i || (i = Bu(e, Eu, {}, !0)), i.run(1));
      }), s = !0);
    },
    o(r) {
      _s(t.$$.fragment, r), r && (i || (i = Bu(e, Eu, {}, !1)), i.run(0)), s = !1;
    },
    d(r) {
      r && xo(e), Ih(t), r && i && i.end();
    }
  };
}
function BC(n) {
  let e, t, i, s;
  e = new U_({});
  let r = (
    /*copied*/
    n[0] && Iu()
  );
  return {
    c() {
      Bh(e.$$.fragment), t = RC(), r && r.c(), i = DC();
    },
    m(o, l) {
      Nh(e, o, l), So(o, t, l), r && r.m(o, l), So(o, i, l), s = !0;
    },
    p(o, l) {
      /*copied*/
      o[0] ? r ? l & /*copied*/
      1 && vn(r, 1) : (r = Iu(), r.c(), vn(r, 1), r.m(i.parentNode, i)) : r && (OC(), _s(r, 1, 1, () => {
        r = null;
      }), TC());
    },
    i(o) {
      s || (vn(e.$$.fragment, o), vn(r), s = !0);
    },
    o(o) {
      _s(e.$$.fragment, o), _s(r), s = !1;
    },
    d(o) {
      o && (xo(t), xo(i)), Ih(e, o), r && r.d(o);
    }
  };
}
function IC(n) {
  let e, t, i;
  return t = new CC({
    props: {
      download: "file." + /*ext*/
      n[2],
      href: (
        /*download_value*/
        n[1]
      ),
      $$slots: { default: [BC] },
      $$scope: { ctx: n }
    }
  }), t.$on(
    "click",
    /*copy_feedback*/
    n[3]
  ), {
    c() {
      e = M0("div"), Bh(t.$$.fragment), A0(e, "class", "container svelte-peh06t");
    },
    m(s, r) {
      So(s, e, r), Nh(t, e, null), i = !0;
    },
    p(s, [r]) {
      const o = {};
      r & /*ext*/
      4 && (o.download = "file." + /*ext*/
      s[2]), r & /*download_value*/
      2 && (o.href = /*download_value*/
      s[1]), r & /*$$scope, copied*/
      129 && (o.$$scope = { dirty: r, ctx: s }), t.$set(o);
    },
    i(s) {
      i || (vn(t.$$.fragment, s), i = !0);
    },
    o(s) {
      _s(t.$$.fragment, s), i = !1;
    },
    d(s) {
      s && xo(e), Ih(t);
    }
  };
}
function NC(n) {
  return {
    py: "py",
    python: "py",
    md: "md",
    markdown: "md",
    json: "json",
    html: "html",
    css: "css",
    js: "js",
    javascript: "js",
    ts: "ts",
    typescript: "ts",
    yaml: "yaml",
    yml: "yml",
    dockerfile: "dockerfile",
    sh: "sh",
    shell: "sh",
    r: "r",
    c: "c",
    cpp: "cpp"
  }[n] || "txt";
}
function FC(n, e, t) {
  let i, s, { value: r } = e, { language: o } = e, l = !1, a;
  function h() {
    t(0, l = !0), a && clearTimeout(a), a = setTimeout(
      () => {
        t(0, l = !1);
      },
      2e3
    );
  }
  return PC(() => {
    a && clearTimeout(a);
  }), n.$$set = (c) => {
    "value" in c && t(4, r = c.value), "language" in c && t(5, o = c.language);
  }, n.$$.update = () => {
    n.$$.dirty & /*language*/
    32 && t(2, i = NC(o)), n.$$.dirty & /*value*/
    16 && t(1, s = URL.createObjectURL(new Blob([r])));
  }, [l, s, i, h, r, o];
}
class HC extends AC {
  constructor(e) {
    super(), EC(this, e, FC, IC, LC, { value: 4, language: 5 });
  }
}
const {
  SvelteComponent: VC,
  append: WC,
  attr: zC,
  create_component: Nu,
  destroy_component: Fu,
  detach: qC,
  element: UC,
  init: jC,
  insert: KC,
  mount_component: Hu,
  safe_not_equal: GC,
  space: YC,
  transition_in: Vu,
  transition_out: Wu
} = window.__gradio__svelte__internal;
function XC(n) {
  let e, t, i, s, r;
  return t = new HC({
    props: {
      value: (
        /*value*/
        n[0]
      ),
      language: (
        /*language*/
        n[1]
      )
    }
  }), s = new iC({ props: { value: (
    /*value*/
    n[0]
  ) } }), {
    c() {
      e = UC("div"), Nu(t.$$.fragment), i = YC(), Nu(s.$$.fragment), zC(e, "class", "svelte-1bqqv16");
    },
    m(o, l) {
      KC(o, e, l), Hu(t, e, null), WC(e, i), Hu(s, e, null), r = !0;
    },
    p(o, [l]) {
      const a = {};
      l & /*value*/
      1 && (a.value = /*value*/
      o[0]), l & /*language*/
      2 && (a.language = /*language*/
      o[1]), t.$set(a);
      const h = {};
      l & /*value*/
      1 && (h.value = /*value*/
      o[0]), s.$set(h);
    },
    i(o) {
      r || (Vu(t.$$.fragment, o), Vu(s.$$.fragment, o), r = !0);
    },
    o(o) {
      Wu(t.$$.fragment, o), Wu(s.$$.fragment, o), r = !1;
    },
    d(o) {
      o && qC(e), Fu(t), Fu(s);
    }
  };
}
function JC(n, e, t) {
  let { value: i } = e, { language: s } = e;
  return n.$$set = (r) => {
    "value" in r && t(0, i = r.value), "language" in r && t(1, s = r.language);
  }, [i, s];
}
class QC extends VC {
  constructor(e) {
    super(), jC(this, e, JC, XC, GC, { value: 0, language: 1 });
  }
}
function xn(n) {
  let e = ["", "k", "M", "G", "T", "P", "E", "Z"], t = 0;
  for (; n > 1e3 && t < e.length - 1; )
    n /= 1e3, t++;
  let i = e[t];
  return (Number.isInteger(n) ? n : n.toFixed(1)) + i;
}
const {
  SvelteComponent: ZC,
  append: St,
  attr: se,
  component_subscribe: zu,
  detach: $C,
  element: e2,
  init: t2,
  insert: i2,
  noop: qu,
  safe_not_equal: n2,
  set_style: Lr,
  svg_element: _t,
  toggle_class: Uu
} = window.__gradio__svelte__internal, { onMount: s2 } = window.__gradio__svelte__internal;
function r2(n) {
  let e, t, i, s, r, o, l, a, h, c, f, u;
  return {
    c() {
      e = e2("div"), t = _t("svg"), i = _t("g"), s = _t("path"), r = _t("path"), o = _t("path"), l = _t("path"), a = _t("g"), h = _t("path"), c = _t("path"), f = _t("path"), u = _t("path"), se(s, "d", "M255.926 0.754768L509.702 139.936V221.027L255.926 81.8465V0.754768Z"), se(s, "fill", "#FF7C00"), se(s, "fill-opacity", "0.4"), se(s, "class", "svelte-43sxxs"), se(r, "d", "M509.69 139.936L254.981 279.641V361.255L509.69 221.55V139.936Z"), se(r, "fill", "#FF7C00"), se(r, "class", "svelte-43sxxs"), se(o, "d", "M0.250138 139.937L254.981 279.641V361.255L0.250138 221.55V139.937Z"), se(o, "fill", "#FF7C00"), se(o, "fill-opacity", "0.4"), se(o, "class", "svelte-43sxxs"), se(l, "d", "M255.923 0.232622L0.236328 139.936V221.55L255.923 81.8469V0.232622Z"), se(l, "fill", "#FF7C00"), se(l, "class", "svelte-43sxxs"), Lr(i, "transform", "translate(" + /*$top*/
      n[1][0] + "px, " + /*$top*/
      n[1][1] + "px)"), se(h, "d", "M255.926 141.5L509.702 280.681V361.773L255.926 222.592V141.5Z"), se(h, "fill", "#FF7C00"), se(h, "fill-opacity", "0.4"), se(h, "class", "svelte-43sxxs"), se(c, "d", "M509.69 280.679L254.981 420.384V501.998L509.69 362.293V280.679Z"), se(c, "fill", "#FF7C00"), se(c, "class", "svelte-43sxxs"), se(f, "d", "M0.250138 280.681L254.981 420.386V502L0.250138 362.295V280.681Z"), se(f, "fill", "#FF7C00"), se(f, "fill-opacity", "0.4"), se(f, "class", "svelte-43sxxs"), se(u, "d", "M255.923 140.977L0.236328 280.68V362.294L255.923 222.591V140.977Z"), se(u, "fill", "#FF7C00"), se(u, "class", "svelte-43sxxs"), Lr(a, "transform", "translate(" + /*$bottom*/
      n[2][0] + "px, " + /*$bottom*/
      n[2][1] + "px)"), se(t, "viewBox", "-1200 -1200 3000 3000"), se(t, "fill", "none"), se(t, "xmlns", "http://www.w3.org/2000/svg"), se(t, "class", "svelte-43sxxs"), se(e, "class", "svelte-43sxxs"), Uu(
        e,
        "margin",
        /*margin*/
        n[0]
      );
    },
    m(d, m) {
      i2(d, e, m), St(e, t), St(t, i), St(i, s), St(i, r), St(i, o), St(i, l), St(t, a), St(a, h), St(a, c), St(a, f), St(a, u);
    },
    p(d, [m]) {
      m & /*$top*/
      2 && Lr(i, "transform", "translate(" + /*$top*/
      d[1][0] + "px, " + /*$top*/
      d[1][1] + "px)"), m & /*$bottom*/
      4 && Lr(a, "transform", "translate(" + /*$bottom*/
      d[2][0] + "px, " + /*$bottom*/
      d[2][1] + "px)"), m & /*margin*/
      1 && Uu(
        e,
        "margin",
        /*margin*/
        d[0]
      );
    },
    i: qu,
    o: qu,
    d(d) {
      d && $C(e);
    }
  };
}
function o2(n, e, t) {
  let i, s;
  var r = this && this.__awaiter || function(d, m, p, g) {
    function b(w) {
      return w instanceof p ? w : new p(function(k) {
        k(w);
      });
    }
    return new (p || (p = Promise))(function(w, k) {
      function x(A) {
        try {
          S(g.next(A));
        } catch (P) {
          k(P);
        }
      }
      function _(A) {
        try {
          S(g.throw(A));
        } catch (P) {
          k(P);
        }
      }
      function S(A) {
        A.done ? w(A.value) : b(A.value).then(x, _);
      }
      S((g = g.apply(d, m || [])).next());
    });
  };
  let { margin: o = !0 } = e;
  const l = Ru([0, 0]);
  zu(n, l, (d) => t(1, i = d));
  const a = Ru([0, 0]);
  zu(n, a, (d) => t(2, s = d));
  let h;
  function c() {
    return r(this, void 0, void 0, function* () {
      yield Promise.all([l.set([125, 140]), a.set([-125, -140])]), yield Promise.all([l.set([-125, 140]), a.set([125, -140])]), yield Promise.all([l.set([-125, 0]), a.set([125, -0])]), yield Promise.all([l.set([125, 0]), a.set([-125, 0])]);
    });
  }
  function f() {
    return r(this, void 0, void 0, function* () {
      yield c(), h || f();
    });
  }
  function u() {
    return r(this, void 0, void 0, function* () {
      yield Promise.all([l.set([125, 0]), a.set([-125, 0])]), f();
    });
  }
  return s2(() => (u(), () => h = !0)), n.$$set = (d) => {
    "margin" in d && t(0, o = d.margin);
  }, [o, i, s, l, a];
}
class l2 extends ZC {
  constructor(e) {
    super(), t2(this, e, o2, r2, n2, { margin: 0 });
  }
}
const {
  SvelteComponent: a2,
  assign: h2,
  create_slot: c2,
  detach: f2,
  element: u2,
  get_all_dirty_from_scope: d2,
  get_slot_changes: m2,
  get_spread_update: p2,
  init: g2,
  insert: b2,
  safe_not_equal: y2,
  set_dynamic_element_data: ju,
  set_style: $e,
  toggle_class: Vt,
  transition_in: T0,
  transition_out: D0,
  update_slot_base: w2
} = window.__gradio__svelte__internal;
function k2(n) {
  let e, t, i;
  const s = (
    /*#slots*/
    n[18].default
  ), r = c2(
    s,
    n,
    /*$$scope*/
    n[17],
    null
  );
  let o = [
    { "data-testid": (
      /*test_id*/
      n[7]
    ) },
    { id: (
      /*elem_id*/
      n[2]
    ) },
    {
      class: t = "block " + /*elem_classes*/
      n[3].join(" ") + " svelte-nl1om8"
    }
  ], l = {};
  for (let a = 0; a < o.length; a += 1)
    l = h2(l, o[a]);
  return {
    c() {
      e = u2(
        /*tag*/
        n[14]
      ), r && r.c(), ju(
        /*tag*/
        n[14]
      )(e, l), Vt(
        e,
        "hidden",
        /*visible*/
        n[10] === !1
      ), Vt(
        e,
        "padded",
        /*padding*/
        n[6]
      ), Vt(
        e,
        "border_focus",
        /*border_mode*/
        n[5] === "focus"
      ), Vt(
        e,
        "border_contrast",
        /*border_mode*/
        n[5] === "contrast"
      ), Vt(e, "hide-container", !/*explicit_call*/
      n[8] && !/*container*/
      n[9]), $e(
        e,
        "height",
        /*get_dimension*/
        n[15](
          /*height*/
          n[0]
        )
      ), $e(e, "width", typeof /*width*/
      n[1] == "number" ? `calc(min(${/*width*/
      n[1]}px, 100%))` : (
        /*get_dimension*/
        n[15](
          /*width*/
          n[1]
        )
      )), $e(
        e,
        "border-style",
        /*variant*/
        n[4]
      ), $e(
        e,
        "overflow",
        /*allow_overflow*/
        n[11] ? "visible" : "hidden"
      ), $e(
        e,
        "flex-grow",
        /*scale*/
        n[12]
      ), $e(e, "min-width", `calc(min(${/*min_width*/
      n[13]}px, 100%))`), $e(e, "border-width", "var(--block-border-width)");
    },
    m(a, h) {
      b2(a, e, h), r && r.m(e, null), i = !0;
    },
    p(a, h) {
      r && r.p && (!i || h & /*$$scope*/
      131072) && w2(
        r,
        s,
        a,
        /*$$scope*/
        a[17],
        i ? m2(
          s,
          /*$$scope*/
          a[17],
          h,
          null
        ) : d2(
          /*$$scope*/
          a[17]
        ),
        null
      ), ju(
        /*tag*/
        a[14]
      )(e, l = p2(o, [
        (!i || h & /*test_id*/
        128) && { "data-testid": (
          /*test_id*/
          a[7]
        ) },
        (!i || h & /*elem_id*/
        4) && { id: (
          /*elem_id*/
          a[2]
        ) },
        (!i || h & /*elem_classes*/
        8 && t !== (t = "block " + /*elem_classes*/
        a[3].join(" ") + " svelte-nl1om8")) && { class: t }
      ])), Vt(
        e,
        "hidden",
        /*visible*/
        a[10] === !1
      ), Vt(
        e,
        "padded",
        /*padding*/
        a[6]
      ), Vt(
        e,
        "border_focus",
        /*border_mode*/
        a[5] === "focus"
      ), Vt(
        e,
        "border_contrast",
        /*border_mode*/
        a[5] === "contrast"
      ), Vt(e, "hide-container", !/*explicit_call*/
      a[8] && !/*container*/
      a[9]), h & /*height*/
      1 && $e(
        e,
        "height",
        /*get_dimension*/
        a[15](
          /*height*/
          a[0]
        )
      ), h & /*width*/
      2 && $e(e, "width", typeof /*width*/
      a[1] == "number" ? `calc(min(${/*width*/
      a[1]}px, 100%))` : (
        /*get_dimension*/
        a[15](
          /*width*/
          a[1]
        )
      )), h & /*variant*/
      16 && $e(
        e,
        "border-style",
        /*variant*/
        a[4]
      ), h & /*allow_overflow*/
      2048 && $e(
        e,
        "overflow",
        /*allow_overflow*/
        a[11] ? "visible" : "hidden"
      ), h & /*scale*/
      4096 && $e(
        e,
        "flex-grow",
        /*scale*/
        a[12]
      ), h & /*min_width*/
      8192 && $e(e, "min-width", `calc(min(${/*min_width*/
      a[13]}px, 100%))`);
    },
    i(a) {
      i || (T0(r, a), i = !0);
    },
    o(a) {
      D0(r, a), i = !1;
    },
    d(a) {
      a && f2(e), r && r.d(a);
    }
  };
}
function v2(n) {
  let e, t = (
    /*tag*/
    n[14] && k2(n)
  );
  return {
    c() {
      t && t.c();
    },
    m(i, s) {
      t && t.m(i, s), e = !0;
    },
    p(i, [s]) {
      /*tag*/
      i[14] && t.p(i, s);
    },
    i(i) {
      e || (T0(t, i), e = !0);
    },
    o(i) {
      D0(t, i), e = !1;
    },
    d(i) {
      t && t.d(i);
    }
  };
}
function x2(n, e, t) {
  let { $$slots: i = {}, $$scope: s } = e, { height: r = void 0 } = e, { width: o = void 0 } = e, { elem_id: l = "" } = e, { elem_classes: a = [] } = e, { variant: h = "solid" } = e, { border_mode: c = "base" } = e, { padding: f = !0 } = e, { type: u = "normal" } = e, { test_id: d = void 0 } = e, { explicit_call: m = !1 } = e, { container: p = !0 } = e, { visible: g = !0 } = e, { allow_overflow: b = !0 } = e, { scale: w = null } = e, { min_width: k = 0 } = e, x = u === "fieldset" ? "fieldset" : "div";
  const _ = (S) => {
    if (S !== void 0) {
      if (typeof S == "number")
        return S + "px";
      if (typeof S == "string")
        return S;
    }
  };
  return n.$$set = (S) => {
    "height" in S && t(0, r = S.height), "width" in S && t(1, o = S.width), "elem_id" in S && t(2, l = S.elem_id), "elem_classes" in S && t(3, a = S.elem_classes), "variant" in S && t(4, h = S.variant), "border_mode" in S && t(5, c = S.border_mode), "padding" in S && t(6, f = S.padding), "type" in S && t(16, u = S.type), "test_id" in S && t(7, d = S.test_id), "explicit_call" in S && t(8, m = S.explicit_call), "container" in S && t(9, p = S.container), "visible" in S && t(10, g = S.visible), "allow_overflow" in S && t(11, b = S.allow_overflow), "scale" in S && t(12, w = S.scale), "min_width" in S && t(13, k = S.min_width), "$$scope" in S && t(17, s = S.$$scope);
  }, [
    r,
    o,
    l,
    a,
    h,
    c,
    f,
    d,
    m,
    p,
    g,
    b,
    w,
    k,
    x,
    _,
    u,
    s,
    i
  ];
}
class S2 extends a2 {
  constructor(e) {
    super(), g2(this, e, x2, v2, y2, {
      height: 0,
      width: 1,
      elem_id: 2,
      elem_classes: 3,
      variant: 4,
      border_mode: 5,
      padding: 6,
      type: 16,
      test_id: 7,
      explicit_call: 8,
      container: 9,
      visible: 10,
      allow_overflow: 11,
      scale: 12,
      min_width: 13
    });
  }
}
const {
  SvelteComponent: _2,
  append: El,
  attr: Rr,
  create_component: C2,
  destroy_component: A2,
  detach: M2,
  element: Ku,
  init: T2,
  insert: D2,
  mount_component: O2,
  safe_not_equal: E2,
  set_data: L2,
  space: R2,
  text: P2,
  toggle_class: bi,
  transition_in: B2,
  transition_out: I2
} = window.__gradio__svelte__internal;
function N2(n) {
  let e, t, i, s, r, o;
  return i = new /*Icon*/
  n[1]({}), {
    c() {
      e = Ku("label"), t = Ku("span"), C2(i.$$.fragment), s = R2(), r = P2(
        /*label*/
        n[0]
      ), Rr(t, "class", "svelte-9gxdi0"), Rr(e, "for", ""), Rr(e, "data-testid", "block-label"), Rr(e, "class", "svelte-9gxdi0"), bi(e, "hide", !/*show_label*/
      n[2]), bi(e, "sr-only", !/*show_label*/
      n[2]), bi(
        e,
        "float",
        /*float*/
        n[4]
      ), bi(
        e,
        "hide-label",
        /*disable*/
        n[3]
      );
    },
    m(l, a) {
      D2(l, e, a), El(e, t), O2(i, t, null), El(e, s), El(e, r), o = !0;
    },
    p(l, [a]) {
      (!o || a & /*label*/
      1) && L2(
        r,
        /*label*/
        l[0]
      ), (!o || a & /*show_label*/
      4) && bi(e, "hide", !/*show_label*/
      l[2]), (!o || a & /*show_label*/
      4) && bi(e, "sr-only", !/*show_label*/
      l[2]), (!o || a & /*float*/
      16) && bi(
        e,
        "float",
        /*float*/
        l[4]
      ), (!o || a & /*disable*/
      8) && bi(
        e,
        "hide-label",
        /*disable*/
        l[3]
      );
    },
    i(l) {
      o || (B2(i.$$.fragment, l), o = !0);
    },
    o(l) {
      I2(i.$$.fragment, l), o = !1;
    },
    d(l) {
      l && M2(e), A2(i);
    }
  };
}
function F2(n, e, t) {
  let { label: i = null } = e, { Icon: s } = e, { show_label: r = !0 } = e, { disable: o = !1 } = e, { float: l = !0 } = e;
  return n.$$set = (a) => {
    "label" in a && t(0, i = a.label), "Icon" in a && t(1, s = a.Icon), "show_label" in a && t(2, r = a.show_label), "disable" in a && t(3, o = a.disable), "float" in a && t(4, l = a.float);
  }, [i, s, r, o, l];
}
class H2 extends _2 {
  constructor(e) {
    super(), T2(this, e, F2, N2, E2, {
      label: 0,
      Icon: 1,
      show_label: 2,
      disable: 3,
      float: 4
    });
  }
}
const {
  SvelteComponent: V2,
  append: Na,
  attr: li,
  bubble: W2,
  create_component: z2,
  destroy_component: q2,
  detach: O0,
  element: Fa,
  init: U2,
  insert: E0,
  listen: j2,
  mount_component: K2,
  safe_not_equal: G2,
  set_data: Y2,
  set_style: pn,
  space: X2,
  text: J2,
  toggle_class: Ge,
  transition_in: Q2,
  transition_out: Z2
} = window.__gradio__svelte__internal;
function Gu(n) {
  let e, t;
  return {
    c() {
      e = Fa("span"), t = J2(
        /*label*/
        n[1]
      ), li(e, "class", "svelte-1lrphxw");
    },
    m(i, s) {
      E0(i, e, s), Na(e, t);
    },
    p(i, s) {
      s & /*label*/
      2 && Y2(
        t,
        /*label*/
        i[1]
      );
    },
    d(i) {
      i && O0(e);
    }
  };
}
function $2(n) {
  let e, t, i, s, r, o, l, a = (
    /*show_label*/
    n[2] && Gu(n)
  );
  return s = new /*Icon*/
  n[0]({}), {
    c() {
      e = Fa("button"), a && a.c(), t = X2(), i = Fa("div"), z2(s.$$.fragment), li(i, "class", "svelte-1lrphxw"), Ge(
        i,
        "small",
        /*size*/
        n[4] === "small"
      ), Ge(
        i,
        "large",
        /*size*/
        n[4] === "large"
      ), Ge(
        i,
        "medium",
        /*size*/
        n[4] === "medium"
      ), e.disabled = /*disabled*/
      n[7], li(
        e,
        "aria-label",
        /*label*/
        n[1]
      ), li(
        e,
        "aria-haspopup",
        /*hasPopup*/
        n[8]
      ), li(
        e,
        "title",
        /*label*/
        n[1]
      ), li(e, "class", "svelte-1lrphxw"), Ge(
        e,
        "pending",
        /*pending*/
        n[3]
      ), Ge(
        e,
        "padded",
        /*padded*/
        n[5]
      ), Ge(
        e,
        "highlight",
        /*highlight*/
        n[6]
      ), Ge(
        e,
        "transparent",
        /*transparent*/
        n[9]
      ), pn(e, "color", !/*disabled*/
      n[7] && /*_color*/
      n[12] ? (
        /*_color*/
        n[12]
      ) : "var(--block-label-text-color)"), pn(e, "--bg-color", /*disabled*/
      n[7] ? "auto" : (
        /*background*/
        n[10]
      )), pn(
        e,
        "margin-left",
        /*offset*/
        n[11] + "px"
      );
    },
    m(h, c) {
      E0(h, e, c), a && a.m(e, null), Na(e, t), Na(e, i), K2(s, i, null), r = !0, o || (l = j2(
        e,
        "click",
        /*click_handler*/
        n[14]
      ), o = !0);
    },
    p(h, [c]) {
      /*show_label*/
      h[2] ? a ? a.p(h, c) : (a = Gu(h), a.c(), a.m(e, t)) : a && (a.d(1), a = null), (!r || c & /*size*/
      16) && Ge(
        i,
        "small",
        /*size*/
        h[4] === "small"
      ), (!r || c & /*size*/
      16) && Ge(
        i,
        "large",
        /*size*/
        h[4] === "large"
      ), (!r || c & /*size*/
      16) && Ge(
        i,
        "medium",
        /*size*/
        h[4] === "medium"
      ), (!r || c & /*disabled*/
      128) && (e.disabled = /*disabled*/
      h[7]), (!r || c & /*label*/
      2) && li(
        e,
        "aria-label",
        /*label*/
        h[1]
      ), (!r || c & /*hasPopup*/
      256) && li(
        e,
        "aria-haspopup",
        /*hasPopup*/
        h[8]
      ), (!r || c & /*label*/
      2) && li(
        e,
        "title",
        /*label*/
        h[1]
      ), (!r || c & /*pending*/
      8) && Ge(
        e,
        "pending",
        /*pending*/
        h[3]
      ), (!r || c & /*padded*/
      32) && Ge(
        e,
        "padded",
        /*padded*/
        h[5]
      ), (!r || c & /*highlight*/
      64) && Ge(
        e,
        "highlight",
        /*highlight*/
        h[6]
      ), (!r || c & /*transparent*/
      512) && Ge(
        e,
        "transparent",
        /*transparent*/
        h[9]
      ), c & /*disabled, _color*/
      4224 && pn(e, "color", !/*disabled*/
      h[7] && /*_color*/
      h[12] ? (
        /*_color*/
        h[12]
      ) : "var(--block-label-text-color)"), c & /*disabled, background*/
      1152 && pn(e, "--bg-color", /*disabled*/
      h[7] ? "auto" : (
        /*background*/
        h[10]
      )), c & /*offset*/
      2048 && pn(
        e,
        "margin-left",
        /*offset*/
        h[11] + "px"
      );
    },
    i(h) {
      r || (Q2(s.$$.fragment, h), r = !0);
    },
    o(h) {
      Z2(s.$$.fragment, h), r = !1;
    },
    d(h) {
      h && O0(e), a && a.d(), q2(s), o = !1, l();
    }
  };
}
function eA(n, e, t) {
  let i, { Icon: s } = e, { label: r = "" } = e, { show_label: o = !1 } = e, { pending: l = !1 } = e, { size: a = "small" } = e, { padded: h = !0 } = e, { highlight: c = !1 } = e, { disabled: f = !1 } = e, { hasPopup: u = !1 } = e, { color: d = "var(--block-label-text-color)" } = e, { transparent: m = !1 } = e, { background: p = "var(--background-fill-primary)" } = e, { offset: g = 0 } = e;
  function b(w) {
    W2.call(this, n, w);
  }
  return n.$$set = (w) => {
    "Icon" in w && t(0, s = w.Icon), "label" in w && t(1, r = w.label), "show_label" in w && t(2, o = w.show_label), "pending" in w && t(3, l = w.pending), "size" in w && t(4, a = w.size), "padded" in w && t(5, h = w.padded), "highlight" in w && t(6, c = w.highlight), "disabled" in w && t(7, f = w.disabled), "hasPopup" in w && t(8, u = w.hasPopup), "color" in w && t(13, d = w.color), "transparent" in w && t(9, m = w.transparent), "background" in w && t(10, p = w.background), "offset" in w && t(11, g = w.offset);
  }, n.$$.update = () => {
    n.$$.dirty & /*highlight, color*/
    8256 && t(12, i = c ? "var(--color-accent)" : d);
  }, [
    s,
    r,
    o,
    l,
    a,
    h,
    c,
    f,
    u,
    m,
    p,
    g,
    i,
    d,
    b
  ];
}
class tA extends V2 {
  constructor(e) {
    super(), U2(this, e, eA, $2, G2, {
      Icon: 0,
      label: 1,
      show_label: 2,
      pending: 3,
      size: 4,
      padded: 5,
      highlight: 6,
      disabled: 7,
      hasPopup: 8,
      color: 13,
      transparent: 9,
      background: 10,
      offset: 11
    });
  }
}
const {
  SvelteComponent: iA,
  append: nA,
  attr: Ll,
  binding_callbacks: sA,
  create_slot: rA,
  detach: oA,
  element: Yu,
  get_all_dirty_from_scope: lA,
  get_slot_changes: aA,
  init: hA,
  insert: cA,
  safe_not_equal: fA,
  toggle_class: yi,
  transition_in: uA,
  transition_out: dA,
  update_slot_base: mA
} = window.__gradio__svelte__internal;
function pA(n) {
  let e, t, i;
  const s = (
    /*#slots*/
    n[5].default
  ), r = rA(
    s,
    n,
    /*$$scope*/
    n[4],
    null
  );
  return {
    c() {
      e = Yu("div"), t = Yu("div"), r && r.c(), Ll(t, "class", "icon svelte-3w3rth"), Ll(e, "class", "empty svelte-3w3rth"), Ll(e, "aria-label", "Empty value"), yi(
        e,
        "small",
        /*size*/
        n[0] === "small"
      ), yi(
        e,
        "large",
        /*size*/
        n[0] === "large"
      ), yi(
        e,
        "unpadded_box",
        /*unpadded_box*/
        n[1]
      ), yi(
        e,
        "small_parent",
        /*parent_height*/
        n[3]
      );
    },
    m(o, l) {
      cA(o, e, l), nA(e, t), r && r.m(t, null), n[6](e), i = !0;
    },
    p(o, [l]) {
      r && r.p && (!i || l & /*$$scope*/
      16) && mA(
        r,
        s,
        o,
        /*$$scope*/
        o[4],
        i ? aA(
          s,
          /*$$scope*/
          o[4],
          l,
          null
        ) : lA(
          /*$$scope*/
          o[4]
        ),
        null
      ), (!i || l & /*size*/
      1) && yi(
        e,
        "small",
        /*size*/
        o[0] === "small"
      ), (!i || l & /*size*/
      1) && yi(
        e,
        "large",
        /*size*/
        o[0] === "large"
      ), (!i || l & /*unpadded_box*/
      2) && yi(
        e,
        "unpadded_box",
        /*unpadded_box*/
        o[1]
      ), (!i || l & /*parent_height*/
      8) && yi(
        e,
        "small_parent",
        /*parent_height*/
        o[3]
      );
    },
    i(o) {
      i || (uA(r, o), i = !0);
    },
    o(o) {
      dA(r, o), i = !1;
    },
    d(o) {
      o && oA(e), r && r.d(o), n[6](null);
    }
  };
}
function gA(n, e, t) {
  let i, { $$slots: s = {}, $$scope: r } = e, { size: o = "small" } = e, { unpadded_box: l = !1 } = e, a;
  function h(f) {
    var u;
    if (!f) return !1;
    const { height: d } = f.getBoundingClientRect(), { height: m } = ((u = f.parentElement) === null || u === void 0 ? void 0 : u.getBoundingClientRect()) || { height: d };
    return d > m + 2;
  }
  function c(f) {
    sA[f ? "unshift" : "push"](() => {
      a = f, t(2, a);
    });
  }
  return n.$$set = (f) => {
    "size" in f && t(0, o = f.size), "unpadded_box" in f && t(1, l = f.unpadded_box), "$$scope" in f && t(4, r = f.$$scope);
  }, n.$$.update = () => {
    n.$$.dirty & /*el*/
    4 && t(3, i = h(a));
  }, [o, l, a, i, r, s, c];
}
class bA extends iA {
  constructor(e) {
    super(), hA(this, e, gA, pA, fA, { size: 0, unpadded_box: 1 });
  }
}
const yA = [
  { color: "red", primary: 600, secondary: 100 },
  { color: "green", primary: 600, secondary: 100 },
  { color: "blue", primary: 600, secondary: 100 },
  { color: "yellow", primary: 500, secondary: 100 },
  { color: "purple", primary: 600, secondary: 100 },
  { color: "teal", primary: 600, secondary: 100 },
  { color: "orange", primary: 600, secondary: 100 },
  { color: "cyan", primary: 600, secondary: 100 },
  { color: "lime", primary: 500, secondary: 100 },
  { color: "pink", primary: 600, secondary: 100 }
], Xu = {
  inherit: "inherit",
  current: "currentColor",
  transparent: "transparent",
  black: "#000",
  white: "#fff",
  slate: {
    50: "#f8fafc",
    100: "#f1f5f9",
    200: "#e2e8f0",
    300: "#cbd5e1",
    400: "#94a3b8",
    500: "#64748b",
    600: "#475569",
    700: "#334155",
    800: "#1e293b",
    900: "#0f172a",
    950: "#020617"
  },
  gray: {
    50: "#f9fafb",
    100: "#f3f4f6",
    200: "#e5e7eb",
    300: "#d1d5db",
    400: "#9ca3af",
    500: "#6b7280",
    600: "#4b5563",
    700: "#374151",
    800: "#1f2937",
    900: "#111827",
    950: "#030712"
  },
  zinc: {
    50: "#fafafa",
    100: "#f4f4f5",
    200: "#e4e4e7",
    300: "#d4d4d8",
    400: "#a1a1aa",
    500: "#71717a",
    600: "#52525b",
    700: "#3f3f46",
    800: "#27272a",
    900: "#18181b",
    950: "#09090b"
  },
  neutral: {
    50: "#fafafa",
    100: "#f5f5f5",
    200: "#e5e5e5",
    300: "#d4d4d4",
    400: "#a3a3a3",
    500: "#737373",
    600: "#525252",
    700: "#404040",
    800: "#262626",
    900: "#171717",
    950: "#0a0a0a"
  },
  stone: {
    50: "#fafaf9",
    100: "#f5f5f4",
    200: "#e7e5e4",
    300: "#d6d3d1",
    400: "#a8a29e",
    500: "#78716c",
    600: "#57534e",
    700: "#44403c",
    800: "#292524",
    900: "#1c1917",
    950: "#0c0a09"
  },
  red: {
    50: "#fef2f2",
    100: "#fee2e2",
    200: "#fecaca",
    300: "#fca5a5",
    400: "#f87171",
    500: "#ef4444",
    600: "#dc2626",
    700: "#b91c1c",
    800: "#991b1b",
    900: "#7f1d1d",
    950: "#450a0a"
  },
  orange: {
    50: "#fff7ed",
    100: "#ffedd5",
    200: "#fed7aa",
    300: "#fdba74",
    400: "#fb923c",
    500: "#f97316",
    600: "#ea580c",
    700: "#c2410c",
    800: "#9a3412",
    900: "#7c2d12",
    950: "#431407"
  },
  amber: {
    50: "#fffbeb",
    100: "#fef3c7",
    200: "#fde68a",
    300: "#fcd34d",
    400: "#fbbf24",
    500: "#f59e0b",
    600: "#d97706",
    700: "#b45309",
    800: "#92400e",
    900: "#78350f",
    950: "#451a03"
  },
  yellow: {
    50: "#fefce8",
    100: "#fef9c3",
    200: "#fef08a",
    300: "#fde047",
    400: "#facc15",
    500: "#eab308",
    600: "#ca8a04",
    700: "#a16207",
    800: "#854d0e",
    900: "#713f12",
    950: "#422006"
  },
  lime: {
    50: "#f7fee7",
    100: "#ecfccb",
    200: "#d9f99d",
    300: "#bef264",
    400: "#a3e635",
    500: "#84cc16",
    600: "#65a30d",
    700: "#4d7c0f",
    800: "#3f6212",
    900: "#365314",
    950: "#1a2e05"
  },
  green: {
    50: "#f0fdf4",
    100: "#dcfce7",
    200: "#bbf7d0",
    300: "#86efac",
    400: "#4ade80",
    500: "#22c55e",
    600: "#16a34a",
    700: "#15803d",
    800: "#166534",
    900: "#14532d",
    950: "#052e16"
  },
  emerald: {
    50: "#ecfdf5",
    100: "#d1fae5",
    200: "#a7f3d0",
    300: "#6ee7b7",
    400: "#34d399",
    500: "#10b981",
    600: "#059669",
    700: "#047857",
    800: "#065f46",
    900: "#064e3b",
    950: "#022c22"
  },
  teal: {
    50: "#f0fdfa",
    100: "#ccfbf1",
    200: "#99f6e4",
    300: "#5eead4",
    400: "#2dd4bf",
    500: "#14b8a6",
    600: "#0d9488",
    700: "#0f766e",
    800: "#115e59",
    900: "#134e4a",
    950: "#042f2e"
  },
  cyan: {
    50: "#ecfeff",
    100: "#cffafe",
    200: "#a5f3fc",
    300: "#67e8f9",
    400: "#22d3ee",
    500: "#06b6d4",
    600: "#0891b2",
    700: "#0e7490",
    800: "#155e75",
    900: "#164e63",
    950: "#083344"
  },
  sky: {
    50: "#f0f9ff",
    100: "#e0f2fe",
    200: "#bae6fd",
    300: "#7dd3fc",
    400: "#38bdf8",
    500: "#0ea5e9",
    600: "#0284c7",
    700: "#0369a1",
    800: "#075985",
    900: "#0c4a6e",
    950: "#082f49"
  },
  blue: {
    50: "#eff6ff",
    100: "#dbeafe",
    200: "#bfdbfe",
    300: "#93c5fd",
    400: "#60a5fa",
    500: "#3b82f6",
    600: "#2563eb",
    700: "#1d4ed8",
    800: "#1e40af",
    900: "#1e3a8a",
    950: "#172554"
  },
  indigo: {
    50: "#eef2ff",
    100: "#e0e7ff",
    200: "#c7d2fe",
    300: "#a5b4fc",
    400: "#818cf8",
    500: "#6366f1",
    600: "#4f46e5",
    700: "#4338ca",
    800: "#3730a3",
    900: "#312e81",
    950: "#1e1b4b"
  },
  violet: {
    50: "#f5f3ff",
    100: "#ede9fe",
    200: "#ddd6fe",
    300: "#c4b5fd",
    400: "#a78bfa",
    500: "#8b5cf6",
    600: "#7c3aed",
    700: "#6d28d9",
    800: "#5b21b6",
    900: "#4c1d95",
    950: "#2e1065"
  },
  purple: {
    50: "#faf5ff",
    100: "#f3e8ff",
    200: "#e9d5ff",
    300: "#d8b4fe",
    400: "#c084fc",
    500: "#a855f7",
    600: "#9333ea",
    700: "#7e22ce",
    800: "#6b21a8",
    900: "#581c87",
    950: "#3b0764"
  },
  fuchsia: {
    50: "#fdf4ff",
    100: "#fae8ff",
    200: "#f5d0fe",
    300: "#f0abfc",
    400: "#e879f9",
    500: "#d946ef",
    600: "#c026d3",
    700: "#a21caf",
    800: "#86198f",
    900: "#701a75",
    950: "#4a044e"
  },
  pink: {
    50: "#fdf2f8",
    100: "#fce7f3",
    200: "#fbcfe8",
    300: "#f9a8d4",
    400: "#f472b6",
    500: "#ec4899",
    600: "#db2777",
    700: "#be185d",
    800: "#9d174d",
    900: "#831843",
    950: "#500724"
  },
  rose: {
    50: "#fff1f2",
    100: "#ffe4e6",
    200: "#fecdd3",
    300: "#fda4af",
    400: "#fb7185",
    500: "#f43f5e",
    600: "#e11d48",
    700: "#be123c",
    800: "#9f1239",
    900: "#881337",
    950: "#4c0519"
  }
};
yA.reduce(
  (n, { color: e, primary: t, secondary: i }) => ({
    ...n,
    [e]: {
      primary: Xu[e][t],
      secondary: Xu[e][i]
    }
  }),
  {}
);
const {
  SvelteComponent: wA,
  append: Gi,
  attr: Mt,
  binding_callbacks: Ju,
  check_outros: Ha,
  create_component: L0,
  create_slot: R0,
  destroy_component: P0,
  destroy_each: B0,
  detach: Y,
  element: Jt,
  empty: Kn,
  ensure_array_like: _o,
  get_all_dirty_from_scope: I0,
  get_slot_changes: N0,
  group_outros: Va,
  init: kA,
  insert: X,
  mount_component: F0,
  noop: Wa,
  safe_not_equal: vA,
  set_data: gt,
  set_style: Ai,
  space: ft,
  text: ge,
  toggle_class: ot,
  transition_in: At,
  transition_out: Qt,
  update_slot_base: H0
} = window.__gradio__svelte__internal, { tick: xA } = window.__gradio__svelte__internal, { onDestroy: SA } = window.__gradio__svelte__internal, { createEventDispatcher: _A } = window.__gradio__svelte__internal, CA = (n) => ({}), Qu = (n) => ({}), AA = (n) => ({}), Zu = (n) => ({});
function $u(n, e, t) {
  const i = n.slice();
  return i[41] = e[t], i[43] = t, i;
}
function ed(n, e, t) {
  const i = n.slice();
  return i[41] = e[t], i;
}
function MA(n) {
  let e, t, i, s, r = (
    /*i18n*/
    n[1]("common.error") + ""
  ), o, l, a;
  t = new tA({
    props: {
      Icon: x_,
      label: (
        /*i18n*/
        n[1]("common.clear")
      ),
      disabled: !1
    }
  }), t.$on(
    "click",
    /*click_handler*/
    n[32]
  );
  const h = (
    /*#slots*/
    n[30].error
  ), c = R0(
    h,
    n,
    /*$$scope*/
    n[29],
    Qu
  );
  return {
    c() {
      e = Jt("div"), L0(t.$$.fragment), i = ft(), s = Jt("span"), o = ge(r), l = ft(), c && c.c(), Mt(e, "class", "clear-status svelte-v0wucf"), Mt(s, "class", "error svelte-v0wucf");
    },
    m(f, u) {
      X(f, e, u), F0(t, e, null), X(f, i, u), X(f, s, u), Gi(s, o), X(f, l, u), c && c.m(f, u), a = !0;
    },
    p(f, u) {
      const d = {};
      u[0] & /*i18n*/
      2 && (d.label = /*i18n*/
      f[1]("common.clear")), t.$set(d), (!a || u[0] & /*i18n*/
      2) && r !== (r = /*i18n*/
      f[1]("common.error") + "") && gt(o, r), c && c.p && (!a || u[0] & /*$$scope*/
      536870912) && H0(
        c,
        h,
        f,
        /*$$scope*/
        f[29],
        a ? N0(
          h,
          /*$$scope*/
          f[29],
          u,
          CA
        ) : I0(
          /*$$scope*/
          f[29]
        ),
        Qu
      );
    },
    i(f) {
      a || (At(t.$$.fragment, f), At(c, f), a = !0);
    },
    o(f) {
      Qt(t.$$.fragment, f), Qt(c, f), a = !1;
    },
    d(f) {
      f && (Y(e), Y(i), Y(s), Y(l)), P0(t), c && c.d(f);
    }
  };
}
function TA(n) {
  let e, t, i, s, r, o, l, a, h, c = (
    /*variant*/
    n[8] === "default" && /*show_eta_bar*/
    n[18] && /*show_progress*/
    n[6] === "full" && td(n)
  );
  function f(k, x) {
    if (
      /*progress*/
      k[7]
    ) return EA;
    if (
      /*queue_position*/
      k[2] !== null && /*queue_size*/
      k[3] !== void 0 && /*queue_position*/
      k[2] >= 0
    ) return OA;
    if (
      /*queue_position*/
      k[2] === 0
    ) return DA;
  }
  let u = f(n), d = u && u(n), m = (
    /*timer*/
    n[5] && sd(n)
  );
  const p = [BA, PA], g = [];
  function b(k, x) {
    return (
      /*last_progress_level*/
      k[15] != null ? 0 : (
        /*show_progress*/
        k[6] === "full" ? 1 : -1
      )
    );
  }
  ~(r = b(n)) && (o = g[r] = p[r](n));
  let w = !/*timer*/
  n[5] && fd(n);
  return {
    c() {
      c && c.c(), e = ft(), t = Jt("div"), d && d.c(), i = ft(), m && m.c(), s = ft(), o && o.c(), l = ft(), w && w.c(), a = Kn(), Mt(t, "class", "progress-text svelte-v0wucf"), ot(
        t,
        "meta-text-center",
        /*variant*/
        n[8] === "center"
      ), ot(
        t,
        "meta-text",
        /*variant*/
        n[8] === "default"
      );
    },
    m(k, x) {
      c && c.m(k, x), X(k, e, x), X(k, t, x), d && d.m(t, null), Gi(t, i), m && m.m(t, null), X(k, s, x), ~r && g[r].m(k, x), X(k, l, x), w && w.m(k, x), X(k, a, x), h = !0;
    },
    p(k, x) {
      /*variant*/
      k[8] === "default" && /*show_eta_bar*/
      k[18] && /*show_progress*/
      k[6] === "full" ? c ? c.p(k, x) : (c = td(k), c.c(), c.m(e.parentNode, e)) : c && (c.d(1), c = null), u === (u = f(k)) && d ? d.p(k, x) : (d && d.d(1), d = u && u(k), d && (d.c(), d.m(t, i))), /*timer*/
      k[5] ? m ? m.p(k, x) : (m = sd(k), m.c(), m.m(t, null)) : m && (m.d(1), m = null), (!h || x[0] & /*variant*/
      256) && ot(
        t,
        "meta-text-center",
        /*variant*/
        k[8] === "center"
      ), (!h || x[0] & /*variant*/
      256) && ot(
        t,
        "meta-text",
        /*variant*/
        k[8] === "default"
      );
      let _ = r;
      r = b(k), r === _ ? ~r && g[r].p(k, x) : (o && (Va(), Qt(g[_], 1, 1, () => {
        g[_] = null;
      }), Ha()), ~r ? (o = g[r], o ? o.p(k, x) : (o = g[r] = p[r](k), o.c()), At(o, 1), o.m(l.parentNode, l)) : o = null), /*timer*/
      k[5] ? w && (Va(), Qt(w, 1, 1, () => {
        w = null;
      }), Ha()) : w ? (w.p(k, x), x[0] & /*timer*/
      32 && At(w, 1)) : (w = fd(k), w.c(), At(w, 1), w.m(a.parentNode, a));
    },
    i(k) {
      h || (At(o), At(w), h = !0);
    },
    o(k) {
      Qt(o), Qt(w), h = !1;
    },
    d(k) {
      k && (Y(e), Y(t), Y(s), Y(l), Y(a)), c && c.d(k), d && d.d(), m && m.d(), ~r && g[r].d(k), w && w.d(k);
    }
  };
}
function td(n) {
  let e, t = `translateX(${/*eta_level*/
  (n[17] || 0) * 100 - 100}%)`;
  return {
    c() {
      e = Jt("div"), Mt(e, "class", "eta-bar svelte-v0wucf"), Ai(e, "transform", t);
    },
    m(i, s) {
      X(i, e, s);
    },
    p(i, s) {
      s[0] & /*eta_level*/
      131072 && t !== (t = `translateX(${/*eta_level*/
      (i[17] || 0) * 100 - 100}%)`) && Ai(e, "transform", t);
    },
    d(i) {
      i && Y(e);
    }
  };
}
function DA(n) {
  let e;
  return {
    c() {
      e = ge("processing |");
    },
    m(t, i) {
      X(t, e, i);
    },
    p: Wa,
    d(t) {
      t && Y(e);
    }
  };
}
function OA(n) {
  let e, t = (
    /*queue_position*/
    n[2] + 1 + ""
  ), i, s, r, o;
  return {
    c() {
      e = ge("queue: "), i = ge(t), s = ge("/"), r = ge(
        /*queue_size*/
        n[3]
      ), o = ge(" |");
    },
    m(l, a) {
      X(l, e, a), X(l, i, a), X(l, s, a), X(l, r, a), X(l, o, a);
    },
    p(l, a) {
      a[0] & /*queue_position*/
      4 && t !== (t = /*queue_position*/
      l[2] + 1 + "") && gt(i, t), a[0] & /*queue_size*/
      8 && gt(
        r,
        /*queue_size*/
        l[3]
      );
    },
    d(l) {
      l && (Y(e), Y(i), Y(s), Y(r), Y(o));
    }
  };
}
function EA(n) {
  let e, t = _o(
    /*progress*/
    n[7]
  ), i = [];
  for (let s = 0; s < t.length; s += 1)
    i[s] = nd(ed(n, t, s));
  return {
    c() {
      for (let s = 0; s < i.length; s += 1)
        i[s].c();
      e = Kn();
    },
    m(s, r) {
      for (let o = 0; o < i.length; o += 1)
        i[o] && i[o].m(s, r);
      X(s, e, r);
    },
    p(s, r) {
      if (r[0] & /*progress*/
      128) {
        t = _o(
          /*progress*/
          s[7]
        );
        let o;
        for (o = 0; o < t.length; o += 1) {
          const l = ed(s, t, o);
          i[o] ? i[o].p(l, r) : (i[o] = nd(l), i[o].c(), i[o].m(e.parentNode, e));
        }
        for (; o < i.length; o += 1)
          i[o].d(1);
        i.length = t.length;
      }
    },
    d(s) {
      s && Y(e), B0(i, s);
    }
  };
}
function id(n) {
  let e, t = (
    /*p*/
    n[41].unit + ""
  ), i, s, r = " ", o;
  function l(c, f) {
    return (
      /*p*/
      c[41].length != null ? RA : LA
    );
  }
  let a = l(n), h = a(n);
  return {
    c() {
      h.c(), e = ft(), i = ge(t), s = ge(" | "), o = ge(r);
    },
    m(c, f) {
      h.m(c, f), X(c, e, f), X(c, i, f), X(c, s, f), X(c, o, f);
    },
    p(c, f) {
      a === (a = l(c)) && h ? h.p(c, f) : (h.d(1), h = a(c), h && (h.c(), h.m(e.parentNode, e))), f[0] & /*progress*/
      128 && t !== (t = /*p*/
      c[41].unit + "") && gt(i, t);
    },
    d(c) {
      c && (Y(e), Y(i), Y(s), Y(o)), h.d(c);
    }
  };
}
function LA(n) {
  let e = xn(
    /*p*/
    n[41].index || 0
  ) + "", t;
  return {
    c() {
      t = ge(e);
    },
    m(i, s) {
      X(i, t, s);
    },
    p(i, s) {
      s[0] & /*progress*/
      128 && e !== (e = xn(
        /*p*/
        i[41].index || 0
      ) + "") && gt(t, e);
    },
    d(i) {
      i && Y(t);
    }
  };
}
function RA(n) {
  let e = xn(
    /*p*/
    n[41].index || 0
  ) + "", t, i, s = xn(
    /*p*/
    n[41].length
  ) + "", r;
  return {
    c() {
      t = ge(e), i = ge("/"), r = ge(s);
    },
    m(o, l) {
      X(o, t, l), X(o, i, l), X(o, r, l);
    },
    p(o, l) {
      l[0] & /*progress*/
      128 && e !== (e = xn(
        /*p*/
        o[41].index || 0
      ) + "") && gt(t, e), l[0] & /*progress*/
      128 && s !== (s = xn(
        /*p*/
        o[41].length
      ) + "") && gt(r, s);
    },
    d(o) {
      o && (Y(t), Y(i), Y(r));
    }
  };
}
function nd(n) {
  let e, t = (
    /*p*/
    n[41].index != null && id(n)
  );
  return {
    c() {
      t && t.c(), e = Kn();
    },
    m(i, s) {
      t && t.m(i, s), X(i, e, s);
    },
    p(i, s) {
      /*p*/
      i[41].index != null ? t ? t.p(i, s) : (t = id(i), t.c(), t.m(e.parentNode, e)) : t && (t.d(1), t = null);
    },
    d(i) {
      i && Y(e), t && t.d(i);
    }
  };
}
function sd(n) {
  let e, t = (
    /*eta*/
    n[0] ? `/${/*formatted_eta*/
    n[19]}` : ""
  ), i, s;
  return {
    c() {
      e = ge(
        /*formatted_timer*/
        n[20]
      ), i = ge(t), s = ge("s");
    },
    m(r, o) {
      X(r, e, o), X(r, i, o), X(r, s, o);
    },
    p(r, o) {
      o[0] & /*formatted_timer*/
      1048576 && gt(
        e,
        /*formatted_timer*/
        r[20]
      ), o[0] & /*eta, formatted_eta*/
      524289 && t !== (t = /*eta*/
      r[0] ? `/${/*formatted_eta*/
      r[19]}` : "") && gt(i, t);
    },
    d(r) {
      r && (Y(e), Y(i), Y(s));
    }
  };
}
function PA(n) {
  let e, t;
  return e = new l2({
    props: { margin: (
      /*variant*/
      n[8] === "default"
    ) }
  }), {
    c() {
      L0(e.$$.fragment);
    },
    m(i, s) {
      F0(e, i, s), t = !0;
    },
    p(i, s) {
      const r = {};
      s[0] & /*variant*/
      256 && (r.margin = /*variant*/
      i[8] === "default"), e.$set(r);
    },
    i(i) {
      t || (At(e.$$.fragment, i), t = !0);
    },
    o(i) {
      Qt(e.$$.fragment, i), t = !1;
    },
    d(i) {
      P0(e, i);
    }
  };
}
function BA(n) {
  let e, t, i, s, r, o = `${/*last_progress_level*/
  n[15] * 100}%`, l = (
    /*progress*/
    n[7] != null && rd(n)
  );
  return {
    c() {
      e = Jt("div"), t = Jt("div"), l && l.c(), i = ft(), s = Jt("div"), r = Jt("div"), Mt(t, "class", "progress-level-inner svelte-v0wucf"), Mt(r, "class", "progress-bar svelte-v0wucf"), Ai(r, "width", o), Mt(s, "class", "progress-bar-wrap svelte-v0wucf"), Mt(e, "class", "progress-level svelte-v0wucf");
    },
    m(a, h) {
      X(a, e, h), Gi(e, t), l && l.m(t, null), Gi(e, i), Gi(e, s), Gi(s, r), n[31](r);
    },
    p(a, h) {
      /*progress*/
      a[7] != null ? l ? l.p(a, h) : (l = rd(a), l.c(), l.m(t, null)) : l && (l.d(1), l = null), h[0] & /*last_progress_level*/
      32768 && o !== (o = `${/*last_progress_level*/
      a[15] * 100}%`) && Ai(r, "width", o);
    },
    i: Wa,
    o: Wa,
    d(a) {
      a && Y(e), l && l.d(), n[31](null);
    }
  };
}
function rd(n) {
  let e, t = _o(
    /*progress*/
    n[7]
  ), i = [];
  for (let s = 0; s < t.length; s += 1)
    i[s] = cd($u(n, t, s));
  return {
    c() {
      for (let s = 0; s < i.length; s += 1)
        i[s].c();
      e = Kn();
    },
    m(s, r) {
      for (let o = 0; o < i.length; o += 1)
        i[o] && i[o].m(s, r);
      X(s, e, r);
    },
    p(s, r) {
      if (r[0] & /*progress_level, progress*/
      16512) {
        t = _o(
          /*progress*/
          s[7]
        );
        let o;
        for (o = 0; o < t.length; o += 1) {
          const l = $u(s, t, o);
          i[o] ? i[o].p(l, r) : (i[o] = cd(l), i[o].c(), i[o].m(e.parentNode, e));
        }
        for (; o < i.length; o += 1)
          i[o].d(1);
        i.length = t.length;
      }
    },
    d(s) {
      s && Y(e), B0(i, s);
    }
  };
}
function od(n) {
  let e, t, i, s, r = (
    /*i*/
    n[43] !== 0 && IA()
  ), o = (
    /*p*/
    n[41].desc != null && ld(n)
  ), l = (
    /*p*/
    n[41].desc != null && /*progress_level*/
    n[14] && /*progress_level*/
    n[14][
      /*i*/
      n[43]
    ] != null && ad()
  ), a = (
    /*progress_level*/
    n[14] != null && hd(n)
  );
  return {
    c() {
      r && r.c(), e = ft(), o && o.c(), t = ft(), l && l.c(), i = ft(), a && a.c(), s = Kn();
    },
    m(h, c) {
      r && r.m(h, c), X(h, e, c), o && o.m(h, c), X(h, t, c), l && l.m(h, c), X(h, i, c), a && a.m(h, c), X(h, s, c);
    },
    p(h, c) {
      /*p*/
      h[41].desc != null ? o ? o.p(h, c) : (o = ld(h), o.c(), o.m(t.parentNode, t)) : o && (o.d(1), o = null), /*p*/
      h[41].desc != null && /*progress_level*/
      h[14] && /*progress_level*/
      h[14][
        /*i*/
        h[43]
      ] != null ? l || (l = ad(), l.c(), l.m(i.parentNode, i)) : l && (l.d(1), l = null), /*progress_level*/
      h[14] != null ? a ? a.p(h, c) : (a = hd(h), a.c(), a.m(s.parentNode, s)) : a && (a.d(1), a = null);
    },
    d(h) {
      h && (Y(e), Y(t), Y(i), Y(s)), r && r.d(h), o && o.d(h), l && l.d(h), a && a.d(h);
    }
  };
}
function IA(n) {
  let e;
  return {
    c() {
      e = ge(" /");
    },
    m(t, i) {
      X(t, e, i);
    },
    d(t) {
      t && Y(e);
    }
  };
}
function ld(n) {
  let e = (
    /*p*/
    n[41].desc + ""
  ), t;
  return {
    c() {
      t = ge(e);
    },
    m(i, s) {
      X(i, t, s);
    },
    p(i, s) {
      s[0] & /*progress*/
      128 && e !== (e = /*p*/
      i[41].desc + "") && gt(t, e);
    },
    d(i) {
      i && Y(t);
    }
  };
}
function ad(n) {
  let e;
  return {
    c() {
      e = ge("-");
    },
    m(t, i) {
      X(t, e, i);
    },
    d(t) {
      t && Y(e);
    }
  };
}
function hd(n) {
  let e = (100 * /*progress_level*/
  (n[14][
    /*i*/
    n[43]
  ] || 0)).toFixed(1) + "", t, i;
  return {
    c() {
      t = ge(e), i = ge("%");
    },
    m(s, r) {
      X(s, t, r), X(s, i, r);
    },
    p(s, r) {
      r[0] & /*progress_level*/
      16384 && e !== (e = (100 * /*progress_level*/
      (s[14][
        /*i*/
        s[43]
      ] || 0)).toFixed(1) + "") && gt(t, e);
    },
    d(s) {
      s && (Y(t), Y(i));
    }
  };
}
function cd(n) {
  let e, t = (
    /*p*/
    (n[41].desc != null || /*progress_level*/
    n[14] && /*progress_level*/
    n[14][
      /*i*/
      n[43]
    ] != null) && od(n)
  );
  return {
    c() {
      t && t.c(), e = Kn();
    },
    m(i, s) {
      t && t.m(i, s), X(i, e, s);
    },
    p(i, s) {
      /*p*/
      i[41].desc != null || /*progress_level*/
      i[14] && /*progress_level*/
      i[14][
        /*i*/
        i[43]
      ] != null ? t ? t.p(i, s) : (t = od(i), t.c(), t.m(e.parentNode, e)) : t && (t.d(1), t = null);
    },
    d(i) {
      i && Y(e), t && t.d(i);
    }
  };
}
function fd(n) {
  let e, t, i, s;
  const r = (
    /*#slots*/
    n[30]["additional-loading-text"]
  ), o = R0(
    r,
    n,
    /*$$scope*/
    n[29],
    Zu
  );
  return {
    c() {
      e = Jt("p"), t = ge(
        /*loading_text*/
        n[9]
      ), i = ft(), o && o.c(), Mt(e, "class", "loading svelte-v0wucf");
    },
    m(l, a) {
      X(l, e, a), Gi(e, t), X(l, i, a), o && o.m(l, a), s = !0;
    },
    p(l, a) {
      (!s || a[0] & /*loading_text*/
      512) && gt(
        t,
        /*loading_text*/
        l[9]
      ), o && o.p && (!s || a[0] & /*$$scope*/
      536870912) && H0(
        o,
        r,
        l,
        /*$$scope*/
        l[29],
        s ? N0(
          r,
          /*$$scope*/
          l[29],
          a,
          AA
        ) : I0(
          /*$$scope*/
          l[29]
        ),
        Zu
      );
    },
    i(l) {
      s || (At(o, l), s = !0);
    },
    o(l) {
      Qt(o, l), s = !1;
    },
    d(l) {
      l && (Y(e), Y(i)), o && o.d(l);
    }
  };
}
function NA(n) {
  let e, t, i, s, r;
  const o = [TA, MA], l = [];
  function a(h, c) {
    return (
      /*status*/
      h[4] === "pending" ? 0 : (
        /*status*/
        h[4] === "error" ? 1 : -1
      )
    );
  }
  return ~(t = a(n)) && (i = l[t] = o[t](n)), {
    c() {
      e = Jt("div"), i && i.c(), Mt(e, "class", s = "wrap " + /*variant*/
      n[8] + " " + /*show_progress*/
      n[6] + " svelte-v0wucf"), ot(e, "hide", !/*status*/
      n[4] || /*status*/
      n[4] === "complete" || /*show_progress*/
      n[6] === "hidden"), ot(
        e,
        "translucent",
        /*variant*/
        n[8] === "center" && /*status*/
        (n[4] === "pending" || /*status*/
        n[4] === "error") || /*translucent*/
        n[11] || /*show_progress*/
        n[6] === "minimal"
      ), ot(
        e,
        "generating",
        /*status*/
        n[4] === "generating" && /*show_progress*/
        n[6] === "full"
      ), ot(
        e,
        "border",
        /*border*/
        n[12]
      ), Ai(
        e,
        "position",
        /*absolute*/
        n[10] ? "absolute" : "static"
      ), Ai(
        e,
        "padding",
        /*absolute*/
        n[10] ? "0" : "var(--size-8) 0"
      );
    },
    m(h, c) {
      X(h, e, c), ~t && l[t].m(e, null), n[33](e), r = !0;
    },
    p(h, c) {
      let f = t;
      t = a(h), t === f ? ~t && l[t].p(h, c) : (i && (Va(), Qt(l[f], 1, 1, () => {
        l[f] = null;
      }), Ha()), ~t ? (i = l[t], i ? i.p(h, c) : (i = l[t] = o[t](h), i.c()), At(i, 1), i.m(e, null)) : i = null), (!r || c[0] & /*variant, show_progress*/
      320 && s !== (s = "wrap " + /*variant*/
      h[8] + " " + /*show_progress*/
      h[6] + " svelte-v0wucf")) && Mt(e, "class", s), (!r || c[0] & /*variant, show_progress, status, show_progress*/
      336) && ot(e, "hide", !/*status*/
      h[4] || /*status*/
      h[4] === "complete" || /*show_progress*/
      h[6] === "hidden"), (!r || c[0] & /*variant, show_progress, variant, status, translucent, show_progress*/
      2384) && ot(
        e,
        "translucent",
        /*variant*/
        h[8] === "center" && /*status*/
        (h[4] === "pending" || /*status*/
        h[4] === "error") || /*translucent*/
        h[11] || /*show_progress*/
        h[6] === "minimal"
      ), (!r || c[0] & /*variant, show_progress, status, show_progress*/
      336) && ot(
        e,
        "generating",
        /*status*/
        h[4] === "generating" && /*show_progress*/
        h[6] === "full"
      ), (!r || c[0] & /*variant, show_progress, border*/
      4416) && ot(
        e,
        "border",
        /*border*/
        h[12]
      ), c[0] & /*absolute*/
      1024 && Ai(
        e,
        "position",
        /*absolute*/
        h[10] ? "absolute" : "static"
      ), c[0] & /*absolute*/
      1024 && Ai(
        e,
        "padding",
        /*absolute*/
        h[10] ? "0" : "var(--size-8) 0"
      );
    },
    i(h) {
      r || (At(i), r = !0);
    },
    o(h) {
      Qt(i), r = !1;
    },
    d(h) {
      h && Y(e), ~t && l[t].d(), n[33](null);
    }
  };
}
var FA = function(n, e, t, i) {
  function s(r) {
    return r instanceof t ? r : new t(function(o) {
      o(r);
    });
  }
  return new (t || (t = Promise))(function(r, o) {
    function l(c) {
      try {
        h(i.next(c));
      } catch (f) {
        o(f);
      }
    }
    function a(c) {
      try {
        h(i.throw(c));
      } catch (f) {
        o(f);
      }
    }
    function h(c) {
      c.done ? r(c.value) : s(c.value).then(l, a);
    }
    h((i = i.apply(n, e || [])).next());
  });
};
let Pr = [], Rl = !1;
function HA(n) {
  return FA(this, arguments, void 0, function* (e, t = !0) {
    if (!(window.__gradio_mode__ === "website" || window.__gradio_mode__ !== "app" && t !== !0)) {
      if (Pr.push(e), !Rl) Rl = !0;
      else return;
      yield xA(), requestAnimationFrame(() => {
        let i = [0, 0];
        for (let s = 0; s < Pr.length; s++) {
          const o = Pr[s].getBoundingClientRect();
          (s === 0 || o.top + window.scrollY <= i[0]) && (i[0] = o.top + window.scrollY, i[1] = s);
        }
        window.scrollTo({ top: i[0] - 20, behavior: "smooth" }), Rl = !1, Pr = [];
      });
    }
  });
}
function VA(n, e, t) {
  let i, { $$slots: s = {}, $$scope: r } = e;
  this && this.__awaiter;
  const o = _A();
  let { i18n: l } = e, { eta: a = null } = e, { queue_position: h } = e, { queue_size: c } = e, { status: f } = e, { scroll_to_output: u = !1 } = e, { timer: d = !0 } = e, { show_progress: m = "full" } = e, { message: p = null } = e, { progress: g = null } = e, { variant: b = "default" } = e, { loading_text: w = "Loading..." } = e, { absolute: k = !0 } = e, { translucent: x = !1 } = e, { border: _ = !1 } = e, { autoscroll: S } = e, A, P = !1, W = 0, U = 0, F = null, M = null, R = 0, z = null, G, Q = null, re = !0;
  const T = () => {
    t(0, a = t(27, F = t(19, j = null))), t(25, W = performance.now()), t(26, U = 0), P = !0, ee();
  };
  function ee() {
    requestAnimationFrame(() => {
      t(26, U = (performance.now() - W) / 1e3), P && ee();
    });
  }
  function J() {
    t(26, U = 0), t(0, a = t(27, F = t(19, j = null))), P && (P = !1);
  }
  SA(() => {
    P && J();
  });
  let j = null;
  function oe(E) {
    Ju[E ? "unshift" : "push"](() => {
      Q = E, t(16, Q), t(7, g), t(14, z), t(15, G);
    });
  }
  const q = () => {
    o("clear_status");
  };
  function ve(E) {
    Ju[E ? "unshift" : "push"](() => {
      A = E, t(13, A);
    });
  }
  return n.$$set = (E) => {
    "i18n" in E && t(1, l = E.i18n), "eta" in E && t(0, a = E.eta), "queue_position" in E && t(2, h = E.queue_position), "queue_size" in E && t(3, c = E.queue_size), "status" in E && t(4, f = E.status), "scroll_to_output" in E && t(22, u = E.scroll_to_output), "timer" in E && t(5, d = E.timer), "show_progress" in E && t(6, m = E.show_progress), "message" in E && t(23, p = E.message), "progress" in E && t(7, g = E.progress), "variant" in E && t(8, b = E.variant), "loading_text" in E && t(9, w = E.loading_text), "absolute" in E && t(10, k = E.absolute), "translucent" in E && t(11, x = E.translucent), "border" in E && t(12, _ = E.border), "autoscroll" in E && t(24, S = E.autoscroll), "$$scope" in E && t(29, r = E.$$scope);
  }, n.$$.update = () => {
    n.$$.dirty[0] & /*eta, old_eta, timer_start, eta_from_start*/
    436207617 && (a === null && t(0, a = F), a != null && F !== a && (t(28, M = (performance.now() - W) / 1e3 + a), t(19, j = M.toFixed(1)), t(27, F = a))), n.$$.dirty[0] & /*eta_from_start, timer_diff*/
    335544320 && t(17, R = M === null || M <= 0 || !U ? null : Math.min(U / M, 1)), n.$$.dirty[0] & /*progress*/
    128 && g != null && t(18, re = !1), n.$$.dirty[0] & /*progress, progress_level, progress_bar, last_progress_level*/
    114816 && (g != null ? t(14, z = g.map((E) => {
      if (E.index != null && E.length != null)
        return E.index / E.length;
      if (E.progress != null)
        return E.progress;
    })) : t(14, z = null), z ? (t(15, G = z[z.length - 1]), Q && (G === 0 ? t(16, Q.style.transition = "0", Q) : t(16, Q.style.transition = "150ms", Q))) : t(15, G = void 0)), n.$$.dirty[0] & /*status*/
    16 && (f === "pending" ? T() : J()), n.$$.dirty[0] & /*el, scroll_to_output, status, autoscroll*/
    20979728 && A && u && (f === "pending" || f === "complete") && HA(A, S), n.$$.dirty[0] & /*status, message*/
    8388624, n.$$.dirty[0] & /*timer_diff*/
    67108864 && t(20, i = U.toFixed(1));
  }, [
    a,
    l,
    h,
    c,
    f,
    d,
    m,
    g,
    b,
    w,
    k,
    x,
    _,
    A,
    z,
    G,
    Q,
    R,
    re,
    j,
    i,
    o,
    u,
    p,
    S,
    W,
    U,
    F,
    M,
    r,
    s,
    oe,
    q,
    ve
  ];
}
class WA extends wA {
  constructor(e) {
    super(), kA(
      this,
      e,
      VA,
      NA,
      vA,
      {
        i18n: 1,
        eta: 0,
        queue_position: 2,
        queue_size: 3,
        status: 4,
        scroll_to_output: 22,
        timer: 5,
        show_progress: 6,
        message: 23,
        progress: 7,
        variant: 8,
        loading_text: 9,
        absolute: 10,
        translucent: 11,
        border: 12,
        autoscroll: 24
      },
      null,
      [-1, -1]
    );
  }
}
/*! @license DOMPurify 3.1.6 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.1.6/LICENSE */
const {
  entries: V0,
  setPrototypeOf: ud,
  isFrozen: zA,
  getPrototypeOf: qA,
  getOwnPropertyDescriptor: UA
} = Object;
let {
  freeze: je,
  seal: bt,
  create: W0
} = Object, {
  apply: za,
  construct: qa
} = typeof Reflect < "u" && Reflect;
je || (je = function(e) {
  return e;
});
bt || (bt = function(e) {
  return e;
});
za || (za = function(e, t, i) {
  return e.apply(t, i);
});
qa || (qa = function(e, t) {
  return new e(...t);
});
const Br = nt(Array.prototype.forEach), dd = nt(Array.prototype.pop), os = nt(Array.prototype.push), Yr = nt(String.prototype.toLowerCase), Pl = nt(String.prototype.toString), md = nt(String.prototype.match), ls = nt(String.prototype.replace), jA = nt(String.prototype.indexOf), KA = nt(String.prototype.trim), Ct = nt(Object.prototype.hasOwnProperty), We = nt(RegExp.prototype.test), as = GA(TypeError);
function nt(n) {
  return function(e) {
    for (var t = arguments.length, i = new Array(t > 1 ? t - 1 : 0), s = 1; s < t; s++)
      i[s - 1] = arguments[s];
    return za(n, e, i);
  };
}
function GA(n) {
  return function() {
    for (var e = arguments.length, t = new Array(e), i = 0; i < e; i++)
      t[i] = arguments[i];
    return qa(n, t);
  };
}
function te(n, e) {
  let t = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : Yr;
  ud && ud(n, null);
  let i = e.length;
  for (; i--; ) {
    let s = e[i];
    if (typeof s == "string") {
      const r = t(s);
      r !== s && (zA(e) || (e[i] = r), s = r);
    }
    n[s] = !0;
  }
  return n;
}
function YA(n) {
  for (let e = 0; e < n.length; e++)
    Ct(n, e) || (n[e] = null);
  return n;
}
function Wi(n) {
  const e = W0(null);
  for (const [t, i] of V0(n))
    Ct(n, t) && (Array.isArray(i) ? e[t] = YA(i) : i && typeof i == "object" && i.constructor === Object ? e[t] = Wi(i) : e[t] = i);
  return e;
}
function hs(n, e) {
  for (; n !== null; ) {
    const i = UA(n, e);
    if (i) {
      if (i.get)
        return nt(i.get);
      if (typeof i.value == "function")
        return nt(i.value);
    }
    n = qA(n);
  }
  function t() {
    return null;
  }
  return t;
}
const pd = je(["a", "abbr", "acronym", "address", "area", "article", "aside", "audio", "b", "bdi", "bdo", "big", "blink", "blockquote", "body", "br", "button", "canvas", "caption", "center", "cite", "code", "col", "colgroup", "content", "data", "datalist", "dd", "decorator", "del", "details", "dfn", "dialog", "dir", "div", "dl", "dt", "element", "em", "fieldset", "figcaption", "figure", "font", "footer", "form", "h1", "h2", "h3", "h4", "h5", "h6", "head", "header", "hgroup", "hr", "html", "i", "img", "input", "ins", "kbd", "label", "legend", "li", "main", "map", "mark", "marquee", "menu", "menuitem", "meter", "nav", "nobr", "ol", "optgroup", "option", "output", "p", "picture", "pre", "progress", "q", "rp", "rt", "ruby", "s", "samp", "section", "select", "shadow", "small", "source", "spacer", "span", "strike", "strong", "style", "sub", "summary", "sup", "table", "tbody", "td", "template", "textarea", "tfoot", "th", "thead", "time", "tr", "track", "tt", "u", "ul", "var", "video", "wbr"]), Bl = je(["svg", "a", "altglyph", "altglyphdef", "altglyphitem", "animatecolor", "animatemotion", "animatetransform", "circle", "clippath", "defs", "desc", "ellipse", "filter", "font", "g", "glyph", "glyphref", "hkern", "image", "line", "lineargradient", "marker", "mask", "metadata", "mpath", "path", "pattern", "polygon", "polyline", "radialgradient", "rect", "stop", "style", "switch", "symbol", "text", "textpath", "title", "tref", "tspan", "view", "vkern"]), Il = je(["feBlend", "feColorMatrix", "feComponentTransfer", "feComposite", "feConvolveMatrix", "feDiffuseLighting", "feDisplacementMap", "feDistantLight", "feDropShadow", "feFlood", "feFuncA", "feFuncB", "feFuncG", "feFuncR", "feGaussianBlur", "feImage", "feMerge", "feMergeNode", "feMorphology", "feOffset", "fePointLight", "feSpecularLighting", "feSpotLight", "feTile", "feTurbulence"]), XA = je(["animate", "color-profile", "cursor", "discard", "font-face", "font-face-format", "font-face-name", "font-face-src", "font-face-uri", "foreignobject", "hatch", "hatchpath", "mesh", "meshgradient", "meshpatch", "meshrow", "missing-glyph", "script", "set", "solidcolor", "unknown", "use"]), Nl = je(["math", "menclose", "merror", "mfenced", "mfrac", "mglyph", "mi", "mlabeledtr", "mmultiscripts", "mn", "mo", "mover", "mpadded", "mphantom", "mroot", "mrow", "ms", "mspace", "msqrt", "mstyle", "msub", "msup", "msubsup", "mtable", "mtd", "mtext", "mtr", "munder", "munderover", "mprescripts"]), JA = je(["maction", "maligngroup", "malignmark", "mlongdiv", "mscarries", "mscarry", "msgroup", "mstack", "msline", "msrow", "semantics", "annotation", "annotation-xml", "mprescripts", "none"]), gd = je(["#text"]), bd = je(["accept", "action", "align", "alt", "autocapitalize", "autocomplete", "autopictureinpicture", "autoplay", "background", "bgcolor", "border", "capture", "cellpadding", "cellspacing", "checked", "cite", "class", "clear", "color", "cols", "colspan", "controls", "controlslist", "coords", "crossorigin", "datetime", "decoding", "default", "dir", "disabled", "disablepictureinpicture", "disableremoteplayback", "download", "draggable", "enctype", "enterkeyhint", "face", "for", "headers", "height", "hidden", "high", "href", "hreflang", "id", "inputmode", "integrity", "ismap", "kind", "label", "lang", "list", "loading", "loop", "low", "max", "maxlength", "media", "method", "min", "minlength", "multiple", "muted", "name", "nonce", "noshade", "novalidate", "nowrap", "open", "optimum", "pattern", "placeholder", "playsinline", "popover", "popovertarget", "popovertargetaction", "poster", "preload", "pubdate", "radiogroup", "readonly", "rel", "required", "rev", "reversed", "role", "rows", "rowspan", "spellcheck", "scope", "selected", "shape", "size", "sizes", "span", "srclang", "start", "src", "srcset", "step", "style", "summary", "tabindex", "title", "translate", "type", "usemap", "valign", "value", "width", "wrap", "xmlns", "slot"]), Fl = je(["accent-height", "accumulate", "additive", "alignment-baseline", "ascent", "attributename", "attributetype", "azimuth", "basefrequency", "baseline-shift", "begin", "bias", "by", "class", "clip", "clippathunits", "clip-path", "clip-rule", "color", "color-interpolation", "color-interpolation-filters", "color-profile", "color-rendering", "cx", "cy", "d", "dx", "dy", "diffuseconstant", "direction", "display", "divisor", "dur", "edgemode", "elevation", "end", "fill", "fill-opacity", "fill-rule", "filter", "filterunits", "flood-color", "flood-opacity", "font-family", "font-size", "font-size-adjust", "font-stretch", "font-style", "font-variant", "font-weight", "fx", "fy", "g1", "g2", "glyph-name", "glyphref", "gradientunits", "gradienttransform", "height", "href", "id", "image-rendering", "in", "in2", "k", "k1", "k2", "k3", "k4", "kerning", "keypoints", "keysplines", "keytimes", "lang", "lengthadjust", "letter-spacing", "kernelmatrix", "kernelunitlength", "lighting-color", "local", "marker-end", "marker-mid", "marker-start", "markerheight", "markerunits", "markerwidth", "maskcontentunits", "maskunits", "max", "mask", "media", "method", "mode", "min", "name", "numoctaves", "offset", "operator", "opacity", "order", "orient", "orientation", "origin", "overflow", "paint-order", "path", "pathlength", "patterncontentunits", "patterntransform", "patternunits", "points", "preservealpha", "preserveaspectratio", "primitiveunits", "r", "rx", "ry", "radius", "refx", "refy", "repeatcount", "repeatdur", "restart", "result", "rotate", "scale", "seed", "shape-rendering", "specularconstant", "specularexponent", "spreadmethod", "startoffset", "stddeviation", "stitchtiles", "stop-color", "stop-opacity", "stroke-dasharray", "stroke-dashoffset", "stroke-linecap", "stroke-linejoin", "stroke-miterlimit", "stroke-opacity", "stroke", "stroke-width", "style", "surfacescale", "systemlanguage", "tabindex", "targetx", "targety", "transform", "transform-origin", "text-anchor", "text-decoration", "text-rendering", "textlength", "type", "u1", "u2", "unicode", "values", "viewbox", "visibility", "version", "vert-adv-y", "vert-origin-x", "vert-origin-y", "width", "word-spacing", "wrap", "writing-mode", "xchannelselector", "ychannelselector", "x", "x1", "x2", "xmlns", "y", "y1", "y2", "z", "zoomandpan"]), yd = je(["accent", "accentunder", "align", "bevelled", "close", "columnsalign", "columnlines", "columnspan", "denomalign", "depth", "dir", "display", "displaystyle", "encoding", "fence", "frame", "height", "href", "id", "largeop", "length", "linethickness", "lspace", "lquote", "mathbackground", "mathcolor", "mathsize", "mathvariant", "maxsize", "minsize", "movablelimits", "notation", "numalign", "open", "rowalign", "rowlines", "rowspacing", "rowspan", "rspace", "rquote", "scriptlevel", "scriptminsize", "scriptsizemultiplier", "selection", "separator", "separators", "stretchy", "subscriptshift", "supscriptshift", "symmetric", "voffset", "width", "xmlns"]), Ir = je(["xlink:href", "xml:id", "xlink:title", "xml:space", "xmlns:xlink"]), QA = bt(/\{\{[\w\W]*|[\w\W]*\}\}/gm), ZA = bt(/<%[\w\W]*|[\w\W]*%>/gm), $A = bt(/\${[\w\W]*}/gm), eM = bt(/^data-[\-\w.\u00B7-\uFFFF]/), tM = bt(/^aria-[\-\w]+$/), z0 = bt(
  /^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i
  // eslint-disable-line no-useless-escape
), iM = bt(/^(?:\w+script|data):/i), nM = bt(
  /[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g
  // eslint-disable-line no-control-regex
), q0 = bt(/^html$/i), sM = bt(/^[a-z][.\w]*(-[.\w]+)+$/i);
var wd = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  MUSTACHE_EXPR: QA,
  ERB_EXPR: ZA,
  TMPLIT_EXPR: $A,
  DATA_ATTR: eM,
  ARIA_ATTR: tM,
  IS_ALLOWED_URI: z0,
  IS_SCRIPT_OR_DATA: iM,
  ATTR_WHITESPACE: nM,
  DOCTYPE_NAME: q0,
  CUSTOM_ELEMENT: sM
});
const cs = {
  element: 1,
  attribute: 2,
  text: 3,
  cdataSection: 4,
  entityReference: 5,
  // Deprecated
  entityNode: 6,
  // Deprecated
  progressingInstruction: 7,
  comment: 8,
  document: 9,
  documentType: 10,
  documentFragment: 11,
  notation: 12
  // Deprecated
}, rM = function() {
  return typeof window > "u" ? null : window;
}, oM = function(e, t) {
  if (typeof e != "object" || typeof e.createPolicy != "function")
    return null;
  let i = null;
  const s = "data-tt-policy-suffix";
  t && t.hasAttribute(s) && (i = t.getAttribute(s));
  const r = "dompurify" + (i ? "#" + i : "");
  try {
    return e.createPolicy(r, {
      createHTML(o) {
        return o;
      },
      createScriptURL(o) {
        return o;
      }
    });
  } catch {
    return console.warn("TrustedTypes policy " + r + " could not be created."), null;
  }
};
function U0() {
  let n = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : rM();
  const e = (V) => U0(V);
  if (e.version = "3.1.6", e.removed = [], !n || !n.document || n.document.nodeType !== cs.document)
    return e.isSupported = !1, e;
  let {
    document: t
  } = n;
  const i = t, s = i.currentScript, {
    DocumentFragment: r,
    HTMLTemplateElement: o,
    Node: l,
    Element: a,
    NodeFilter: h,
    NamedNodeMap: c = n.NamedNodeMap || n.MozNamedAttrMap,
    HTMLFormElement: f,
    DOMParser: u,
    trustedTypes: d
  } = n, m = a.prototype, p = hs(m, "cloneNode"), g = hs(m, "remove"), b = hs(m, "nextSibling"), w = hs(m, "childNodes"), k = hs(m, "parentNode");
  if (typeof o == "function") {
    const V = t.createElement("template");
    V.content && V.content.ownerDocument && (t = V.content.ownerDocument);
  }
  let x, _ = "";
  const {
    implementation: S,
    createNodeIterator: A,
    createDocumentFragment: P,
    getElementsByTagName: W
  } = t, {
    importNode: U
  } = i;
  let F = {};
  e.isSupported = typeof V0 == "function" && typeof k == "function" && S && S.createHTMLDocument !== void 0;
  const {
    MUSTACHE_EXPR: M,
    ERB_EXPR: R,
    TMPLIT_EXPR: z,
    DATA_ATTR: G,
    ARIA_ATTR: Q,
    IS_SCRIPT_OR_DATA: re,
    ATTR_WHITESPACE: T,
    CUSTOM_ELEMENT: ee
  } = wd;
  let {
    IS_ALLOWED_URI: J
  } = wd, j = null;
  const oe = te({}, [...pd, ...Bl, ...Il, ...Nl, ...gd]);
  let q = null;
  const ve = te({}, [...bd, ...Fl, ...yd, ...Ir]);
  let E = Object.seal(W0(null, {
    tagNameCheck: {
      writable: !0,
      configurable: !1,
      enumerable: !0,
      value: null
    },
    attributeNameCheck: {
      writable: !0,
      configurable: !1,
      enumerable: !0,
      value: null
    },
    allowCustomizedBuiltInElements: {
      writable: !0,
      configurable: !1,
      enumerable: !0,
      value: !1
    }
  })), st = null, rt = null, He = !0, ni = !0, mi = !1, Ni = !0, pi = !1, Gn = !0, wt = !1, kt = !1, Fi = !1, on = !1, er = !1, tr = !1, Fh = !0, Hh = !1;
  const Q0 = "user-content-";
  let Vo = !0, Yn = !1, ln = {}, an = null;
  const Vh = te({}, ["annotation-xml", "audio", "colgroup", "desc", "foreignobject", "head", "iframe", "math", "mi", "mn", "mo", "ms", "mtext", "noembed", "noframes", "noscript", "plaintext", "script", "style", "svg", "template", "thead", "title", "video", "xmp"]);
  let Wh = null;
  const zh = te({}, ["audio", "video", "img", "source", "image", "track"]);
  let Wo = null;
  const qh = te({}, ["alt", "class", "for", "id", "label", "name", "pattern", "placeholder", "role", "summary", "title", "value", "style", "xmlns"]), ir = "http://www.w3.org/1998/Math/MathML", nr = "http://www.w3.org/2000/svg", si = "http://www.w3.org/1999/xhtml";
  let hn = si, zo = !1, qo = null;
  const Z0 = te({}, [ir, nr, si], Pl);
  let Xn = null;
  const $0 = ["application/xhtml+xml", "text/html"], e1 = "text/html";
  let Ce = null, cn = null;
  const t1 = t.createElement("form"), Uh = function(v) {
    return v instanceof RegExp || v instanceof Function;
  }, Uo = function() {
    let v = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    if (!(cn && cn === v)) {
      if ((!v || typeof v != "object") && (v = {}), v = Wi(v), Xn = // eslint-disable-next-line unicorn/prefer-includes
      $0.indexOf(v.PARSER_MEDIA_TYPE) === -1 ? e1 : v.PARSER_MEDIA_TYPE, Ce = Xn === "application/xhtml+xml" ? Pl : Yr, j = Ct(v, "ALLOWED_TAGS") ? te({}, v.ALLOWED_TAGS, Ce) : oe, q = Ct(v, "ALLOWED_ATTR") ? te({}, v.ALLOWED_ATTR, Ce) : ve, qo = Ct(v, "ALLOWED_NAMESPACES") ? te({}, v.ALLOWED_NAMESPACES, Pl) : Z0, Wo = Ct(v, "ADD_URI_SAFE_ATTR") ? te(
        Wi(qh),
        // eslint-disable-line indent
        v.ADD_URI_SAFE_ATTR,
        // eslint-disable-line indent
        Ce
        // eslint-disable-line indent
      ) : qh, Wh = Ct(v, "ADD_DATA_URI_TAGS") ? te(
        Wi(zh),
        // eslint-disable-line indent
        v.ADD_DATA_URI_TAGS,
        // eslint-disable-line indent
        Ce
        // eslint-disable-line indent
      ) : zh, an = Ct(v, "FORBID_CONTENTS") ? te({}, v.FORBID_CONTENTS, Ce) : Vh, st = Ct(v, "FORBID_TAGS") ? te({}, v.FORBID_TAGS, Ce) : {}, rt = Ct(v, "FORBID_ATTR") ? te({}, v.FORBID_ATTR, Ce) : {}, ln = Ct(v, "USE_PROFILES") ? v.USE_PROFILES : !1, He = v.ALLOW_ARIA_ATTR !== !1, ni = v.ALLOW_DATA_ATTR !== !1, mi = v.ALLOW_UNKNOWN_PROTOCOLS || !1, Ni = v.ALLOW_SELF_CLOSE_IN_ATTR !== !1, pi = v.SAFE_FOR_TEMPLATES || !1, Gn = v.SAFE_FOR_XML !== !1, wt = v.WHOLE_DOCUMENT || !1, on = v.RETURN_DOM || !1, er = v.RETURN_DOM_FRAGMENT || !1, tr = v.RETURN_TRUSTED_TYPE || !1, Fi = v.FORCE_BODY || !1, Fh = v.SANITIZE_DOM !== !1, Hh = v.SANITIZE_NAMED_PROPS || !1, Vo = v.KEEP_CONTENT !== !1, Yn = v.IN_PLACE || !1, J = v.ALLOWED_URI_REGEXP || z0, hn = v.NAMESPACE || si, E = v.CUSTOM_ELEMENT_HANDLING || {}, v.CUSTOM_ELEMENT_HANDLING && Uh(v.CUSTOM_ELEMENT_HANDLING.tagNameCheck) && (E.tagNameCheck = v.CUSTOM_ELEMENT_HANDLING.tagNameCheck), v.CUSTOM_ELEMENT_HANDLING && Uh(v.CUSTOM_ELEMENT_HANDLING.attributeNameCheck) && (E.attributeNameCheck = v.CUSTOM_ELEMENT_HANDLING.attributeNameCheck), v.CUSTOM_ELEMENT_HANDLING && typeof v.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements == "boolean" && (E.allowCustomizedBuiltInElements = v.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements), pi && (ni = !1), er && (on = !0), ln && (j = te({}, gd), q = [], ln.html === !0 && (te(j, pd), te(q, bd)), ln.svg === !0 && (te(j, Bl), te(q, Fl), te(q, Ir)), ln.svgFilters === !0 && (te(j, Il), te(q, Fl), te(q, Ir)), ln.mathMl === !0 && (te(j, Nl), te(q, yd), te(q, Ir))), v.ADD_TAGS && (j === oe && (j = Wi(j)), te(j, v.ADD_TAGS, Ce)), v.ADD_ATTR && (q === ve && (q = Wi(q)), te(q, v.ADD_ATTR, Ce)), v.ADD_URI_SAFE_ATTR && te(Wo, v.ADD_URI_SAFE_ATTR, Ce), v.FORBID_CONTENTS && (an === Vh && (an = Wi(an)), te(an, v.FORBID_CONTENTS, Ce)), Vo && (j["#text"] = !0), wt && te(j, ["html", "head", "body"]), j.table && (te(j, ["tbody"]), delete st.tbody), v.TRUSTED_TYPES_POLICY) {
        if (typeof v.TRUSTED_TYPES_POLICY.createHTML != "function")
          throw as('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');
        if (typeof v.TRUSTED_TYPES_POLICY.createScriptURL != "function")
          throw as('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');
        x = v.TRUSTED_TYPES_POLICY, _ = x.createHTML("");
      } else
        x === void 0 && (x = oM(d, s)), x !== null && typeof _ == "string" && (_ = x.createHTML(""));
      je && je(v), cn = v;
    }
  }, jh = te({}, ["mi", "mo", "mn", "ms", "mtext"]), Kh = te({}, ["foreignobject", "annotation-xml"]), i1 = te({}, ["title", "style", "font", "a", "script"]), Gh = te({}, [...Bl, ...Il, ...XA]), Yh = te({}, [...Nl, ...JA]), n1 = function(v) {
    let D = k(v);
    (!D || !D.tagName) && (D = {
      namespaceURI: hn,
      tagName: "template"
    });
    const H = Yr(v.tagName), he = Yr(D.tagName);
    return qo[v.namespaceURI] ? v.namespaceURI === nr ? D.namespaceURI === si ? H === "svg" : D.namespaceURI === ir ? H === "svg" && (he === "annotation-xml" || jh[he]) : !!Gh[H] : v.namespaceURI === ir ? D.namespaceURI === si ? H === "math" : D.namespaceURI === nr ? H === "math" && Kh[he] : !!Yh[H] : v.namespaceURI === si ? D.namespaceURI === nr && !Kh[he] || D.namespaceURI === ir && !jh[he] ? !1 : !Yh[H] && (i1[H] || !Gh[H]) : !!(Xn === "application/xhtml+xml" && qo[v.namespaceURI]) : !1;
  }, Pt = function(v) {
    os(e.removed, {
      element: v
    });
    try {
      k(v).removeChild(v);
    } catch {
      g(v);
    }
  }, sr = function(v, D) {
    try {
      os(e.removed, {
        attribute: D.getAttributeNode(v),
        from: D
      });
    } catch {
      os(e.removed, {
        attribute: null,
        from: D
      });
    }
    if (D.removeAttribute(v), v === "is" && !q[v])
      if (on || er)
        try {
          Pt(D);
        } catch {
        }
      else
        try {
          D.setAttribute(v, "");
        } catch {
        }
  }, Xh = function(v) {
    let D = null, H = null;
    if (Fi)
      v = "<remove></remove>" + v;
    else {
      const Me = md(v, /^[\r\n\t ]+/);
      H = Me && Me[0];
    }
    Xn === "application/xhtml+xml" && hn === si && (v = '<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>' + v + "</body></html>");
    const he = x ? x.createHTML(v) : v;
    if (hn === si)
      try {
        D = new u().parseFromString(he, Xn);
      } catch {
      }
    if (!D || !D.documentElement) {
      D = S.createDocument(hn, "template", null);
      try {
        D.documentElement.innerHTML = zo ? _ : he;
      } catch {
      }
    }
    const Pe = D.body || D.documentElement;
    return v && H && Pe.insertBefore(t.createTextNode(H), Pe.childNodes[0] || null), hn === si ? W.call(D, wt ? "html" : "body")[0] : wt ? D.documentElement : Pe;
  }, Jh = function(v) {
    return A.call(
      v.ownerDocument || v,
      v,
      // eslint-disable-next-line no-bitwise
      h.SHOW_ELEMENT | h.SHOW_COMMENT | h.SHOW_TEXT | h.SHOW_PROCESSING_INSTRUCTION | h.SHOW_CDATA_SECTION,
      null
    );
  }, Qh = function(v) {
    return v instanceof f && (typeof v.nodeName != "string" || typeof v.textContent != "string" || typeof v.removeChild != "function" || !(v.attributes instanceof c) || typeof v.removeAttribute != "function" || typeof v.setAttribute != "function" || typeof v.namespaceURI != "string" || typeof v.insertBefore != "function" || typeof v.hasChildNodes != "function");
  }, Zh = function(v) {
    return typeof l == "function" && v instanceof l;
  }, ri = function(v, D, H) {
    F[v] && Br(F[v], (he) => {
      he.call(e, D, H, cn);
    });
  }, $h = function(v) {
    let D = null;
    if (ri("beforeSanitizeElements", v, null), Qh(v))
      return Pt(v), !0;
    const H = Ce(v.nodeName);
    if (ri("uponSanitizeElement", v, {
      tagName: H,
      allowedTags: j
    }), v.hasChildNodes() && !Zh(v.firstElementChild) && We(/<[/\w]/g, v.innerHTML) && We(/<[/\w]/g, v.textContent) || v.nodeType === cs.progressingInstruction || Gn && v.nodeType === cs.comment && We(/<[/\w]/g, v.data))
      return Pt(v), !0;
    if (!j[H] || st[H]) {
      if (!st[H] && tc(H) && (E.tagNameCheck instanceof RegExp && We(E.tagNameCheck, H) || E.tagNameCheck instanceof Function && E.tagNameCheck(H)))
        return !1;
      if (Vo && !an[H]) {
        const he = k(v) || v.parentNode, Pe = w(v) || v.childNodes;
        if (Pe && he) {
          const Me = Pe.length;
          for (let Ke = Me - 1; Ke >= 0; --Ke) {
            const Bt = p(Pe[Ke], !0);
            Bt.__removalCount = (v.__removalCount || 0) + 1, he.insertBefore(Bt, b(v));
          }
        }
      }
      return Pt(v), !0;
    }
    return v instanceof a && !n1(v) || (H === "noscript" || H === "noembed" || H === "noframes") && We(/<\/no(script|embed|frames)/i, v.innerHTML) ? (Pt(v), !0) : (pi && v.nodeType === cs.text && (D = v.textContent, Br([M, R, z], (he) => {
      D = ls(D, he, " ");
    }), v.textContent !== D && (os(e.removed, {
      element: v.cloneNode()
    }), v.textContent = D)), ri("afterSanitizeElements", v, null), !1);
  }, ec = function(v, D, H) {
    if (Fh && (D === "id" || D === "name") && (H in t || H in t1))
      return !1;
    if (!(ni && !rt[D] && We(G, D))) {
      if (!(He && We(Q, D))) {
        if (!q[D] || rt[D]) {
          if (
            // First condition does a very basic check if a) it's basically a valid custom element tagname AND
            // b) if the tagName passes whatever the user has configured for CUSTOM_ELEMENT_HANDLING.tagNameCheck
            // and c) if the attribute name passes whatever the user has configured for CUSTOM_ELEMENT_HANDLING.attributeNameCheck
            !(tc(v) && (E.tagNameCheck instanceof RegExp && We(E.tagNameCheck, v) || E.tagNameCheck instanceof Function && E.tagNameCheck(v)) && (E.attributeNameCheck instanceof RegExp && We(E.attributeNameCheck, D) || E.attributeNameCheck instanceof Function && E.attributeNameCheck(D)) || // Alternative, second condition checks if it's an `is`-attribute, AND
            // the value passes whatever the user has configured for CUSTOM_ELEMENT_HANDLING.tagNameCheck
            D === "is" && E.allowCustomizedBuiltInElements && (E.tagNameCheck instanceof RegExp && We(E.tagNameCheck, H) || E.tagNameCheck instanceof Function && E.tagNameCheck(H)))
          ) return !1;
        } else if (!Wo[D]) {
          if (!We(J, ls(H, T, ""))) {
            if (!((D === "src" || D === "xlink:href" || D === "href") && v !== "script" && jA(H, "data:") === 0 && Wh[v])) {
              if (!(mi && !We(re, ls(H, T, "")))) {
                if (H)
                  return !1;
              }
            }
          }
        }
      }
    }
    return !0;
  }, tc = function(v) {
    return v !== "annotation-xml" && md(v, ee);
  }, ic = function(v) {
    ri("beforeSanitizeAttributes", v, null);
    const {
      attributes: D
    } = v;
    if (!D)
      return;
    const H = {
      attrName: "",
      attrValue: "",
      keepAttr: !0,
      allowedAttributes: q
    };
    let he = D.length;
    for (; he--; ) {
      const Pe = D[he], {
        name: Me,
        namespaceURI: Ke,
        value: Bt
      } = Pe, Jn = Ce(Me);
      let Ve = Me === "value" ? Bt : KA(Bt);
      if (H.attrName = Jn, H.attrValue = Ve, H.keepAttr = !0, H.forceKeepAttr = void 0, ri("uponSanitizeAttribute", v, H), Ve = H.attrValue, Gn && We(/((--!?|])>)|<\/(style|title)/i, Ve)) {
        sr(Me, v);
        continue;
      }
      if (H.forceKeepAttr || (sr(Me, v), !H.keepAttr))
        continue;
      if (!Ni && We(/\/>/i, Ve)) {
        sr(Me, v);
        continue;
      }
      pi && Br([M, R, z], (sc) => {
        Ve = ls(Ve, sc, " ");
      });
      const nc = Ce(v.nodeName);
      if (ec(nc, Jn, Ve)) {
        if (Hh && (Jn === "id" || Jn === "name") && (sr(Me, v), Ve = Q0 + Ve), x && typeof d == "object" && typeof d.getAttributeType == "function" && !Ke)
          switch (d.getAttributeType(nc, Jn)) {
            case "TrustedHTML": {
              Ve = x.createHTML(Ve);
              break;
            }
            case "TrustedScriptURL": {
              Ve = x.createScriptURL(Ve);
              break;
            }
          }
        try {
          Ke ? v.setAttributeNS(Ke, Me, Ve) : v.setAttribute(Me, Ve), Qh(v) ? Pt(v) : dd(e.removed);
        } catch {
        }
      }
    }
    ri("afterSanitizeAttributes", v, null);
  }, s1 = function V(v) {
    let D = null;
    const H = Jh(v);
    for (ri("beforeSanitizeShadowDOM", v, null); D = H.nextNode(); )
      ri("uponSanitizeShadowNode", D, null), !$h(D) && (D.content instanceof r && V(D.content), ic(D));
    ri("afterSanitizeShadowDOM", v, null);
  };
  return e.sanitize = function(V) {
    let v = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, D = null, H = null, he = null, Pe = null;
    if (zo = !V, zo && (V = "<!-->"), typeof V != "string" && !Zh(V))
      if (typeof V.toString == "function") {
        if (V = V.toString(), typeof V != "string")
          throw as("dirty is not a string, aborting");
      } else
        throw as("toString is not a function");
    if (!e.isSupported)
      return V;
    if (kt || Uo(v), e.removed = [], typeof V == "string" && (Yn = !1), Yn) {
      if (V.nodeName) {
        const Bt = Ce(V.nodeName);
        if (!j[Bt] || st[Bt])
          throw as("root node is forbidden and cannot be sanitized in-place");
      }
    } else if (V instanceof l)
      D = Xh("<!---->"), H = D.ownerDocument.importNode(V, !0), H.nodeType === cs.element && H.nodeName === "BODY" || H.nodeName === "HTML" ? D = H : D.appendChild(H);
    else {
      if (!on && !pi && !wt && // eslint-disable-next-line unicorn/prefer-includes
      V.indexOf("<") === -1)
        return x && tr ? x.createHTML(V) : V;
      if (D = Xh(V), !D)
        return on ? null : tr ? _ : "";
    }
    D && Fi && Pt(D.firstChild);
    const Me = Jh(Yn ? V : D);
    for (; he = Me.nextNode(); )
      $h(he) || (he.content instanceof r && s1(he.content), ic(he));
    if (Yn)
      return V;
    if (on) {
      if (er)
        for (Pe = P.call(D.ownerDocument); D.firstChild; )
          Pe.appendChild(D.firstChild);
      else
        Pe = D;
      return (q.shadowroot || q.shadowrootmode) && (Pe = U.call(i, Pe, !0)), Pe;
    }
    let Ke = wt ? D.outerHTML : D.innerHTML;
    return wt && j["!doctype"] && D.ownerDocument && D.ownerDocument.doctype && D.ownerDocument.doctype.name && We(q0, D.ownerDocument.doctype.name) && (Ke = "<!DOCTYPE " + D.ownerDocument.doctype.name + `>
` + Ke), pi && Br([M, R, z], (Bt) => {
      Ke = ls(Ke, Bt, " ");
    }), x && tr ? x.createHTML(Ke) : Ke;
  }, e.setConfig = function() {
    let V = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {};
    Uo(V), kt = !0;
  }, e.clearConfig = function() {
    cn = null, kt = !1;
  }, e.isValidAttribute = function(V, v, D) {
    cn || Uo({});
    const H = Ce(V), he = Ce(v);
    return ec(H, he, D);
  }, e.addHook = function(V, v) {
    typeof v == "function" && (F[V] = F[V] || [], os(F[V], v));
  }, e.removeHook = function(V) {
    if (F[V])
      return dd(F[V]);
  }, e.removeHooks = function(V) {
    F[V] && (F[V] = []);
  }, e.removeAllHooks = function() {
    F = {};
  }, e;
}
U0();
const {
  SvelteComponent: lM,
  append: aM,
  attr: hM,
  detach: cM,
  element: fM,
  init: uM,
  insert: dM,
  noop: kd,
  safe_not_equal: mM,
  set_data: pM,
  text: gM,
  toggle_class: gn
} = window.__gradio__svelte__internal;
function bM(n) {
  let e, t = (
    /*value*/
    (n[0] ? (
      /*value*/
      n[0]
    ) : "") + ""
  ), i;
  return {
    c() {
      e = fM("pre"), i = gM(t), hM(e, "class", "svelte-1ioyqn2"), gn(
        e,
        "table",
        /*type*/
        n[1] === "table"
      ), gn(
        e,
        "gallery",
        /*type*/
        n[1] === "gallery"
      ), gn(
        e,
        "selected",
        /*selected*/
        n[2]
      );
    },
    m(s, r) {
      dM(s, e, r), aM(e, i);
    },
    p(s, [r]) {
      r & /*value*/
      1 && t !== (t = /*value*/
      (s[0] ? (
        /*value*/
        s[0]
      ) : "") + "") && pM(i, t), r & /*type*/
      2 && gn(
        e,
        "table",
        /*type*/
        s[1] === "table"
      ), r & /*type*/
      2 && gn(
        e,
        "gallery",
        /*type*/
        s[1] === "gallery"
      ), r & /*selected*/
      4 && gn(
        e,
        "selected",
        /*selected*/
        s[2]
      );
    },
    i: kd,
    o: kd,
    d(s) {
      s && cM(e);
    }
  };
}
function yM(n, e, t) {
  let { value: i } = e, { type: s } = e, { selected: r = !1 } = e;
  return n.$$set = (o) => {
    "value" in o && t(0, i = o.value), "type" in o && t(1, s = o.type), "selected" in o && t(2, r = o.selected);
  }, [i, s, r];
}
class GM extends lM {
  constructor(e) {
    super(), uM(this, e, yM, bM, mM, { value: 0, type: 1, selected: 2 });
  }
}
const {
  SvelteComponent: wM,
  add_flush_callback: j0,
  assign: kM,
  bind: K0,
  binding_callbacks: G0,
  check_outros: Y0,
  create_component: Ri,
  destroy_component: Pi,
  detach: Cs,
  empty: X0,
  get_spread_object: vM,
  get_spread_update: xM,
  group_outros: J0,
  init: SM,
  insert: As,
  mount_component: Bi,
  safe_not_equal: _M,
  space: Ua,
  transition_in: ut,
  transition_out: dt
} = window.__gradio__svelte__internal, { afterUpdate: CM } = window.__gradio__svelte__internal;
function AM(n) {
  let e, t, i, s, r, o;
  e = new QC({
    props: {
      language: (
        /*language*/
        n[2]
      ),
      value: (
        /*value*/
        n[0].code
      )
    }
  });
  const l = [DM, TM], a = [];
  function h(c, f) {
    return (
      /*hasDiff*/
      c[12] ? 0 : 1
    );
  }
  return i = h(n), s = a[i] = l[i](n), {
    c() {
      Ri(e.$$.fragment), t = Ua(), s.c(), r = X0();
    },
    m(c, f) {
      Bi(e, c, f), As(c, t, f), a[i].m(c, f), As(c, r, f), o = !0;
    },
    p(c, f) {
      const u = {};
      f & /*language*/
      4 && (u.language = /*language*/
      c[2]), f & /*value*/
      1 && (u.value = /*value*/
      c[0].code), e.$set(u);
      let d = i;
      i = h(c), i === d ? a[i].p(c, f) : (J0(), dt(a[d], 1, 1, () => {
        a[d] = null;
      }), Y0(), s = a[i], s ? s.p(c, f) : (s = a[i] = l[i](c), s.c()), ut(s, 1), s.m(r.parentNode, r));
    },
    i(c) {
      o || (ut(e.$$.fragment, c), ut(s), o = !0);
    },
    o(c) {
      dt(e.$$.fragment, c), dt(s), o = !1;
    },
    d(c) {
      c && (Cs(t), Cs(r)), Pi(e, c), a[i].d(c);
    }
  };
}
function MM(n) {
  let e, t;
  return e = new bA({
    props: {
      unpadded_box: !0,
      size: "large",
      $$slots: { default: [OM] },
      $$scope: { ctx: n }
    }
  }), {
    c() {
      Ri(e.$$.fragment);
    },
    m(i, s) {
      Bi(e, i, s), t = !0;
    },
    p(i, s) {
      const r = {};
      s & /*$$scope*/
      33554432 && (r.$$scope = { dirty: s, ctx: i }), e.$set(r);
    },
    i(i) {
      t || (ut(e.$$.fragment, i), t = !0);
    },
    o(i) {
      dt(e.$$.fragment, i), t = !1;
    },
    d(i) {
      Pi(e, i);
    }
  };
}
function TM(n) {
  let e, t, i;
  function s(o) {
    n[21](o);
  }
  let r = {
    language: (
      /*language*/
      n[2]
    ),
    lines: (
      /*lines*/
      n[3]
    ),
    dark_mode: (
      /*dark_mode*/
      n[13]
    ),
    readonly: !/*interactive*/
    n[11]
  };
  return (
    /*value*/
    n[0] !== void 0 && (r.value = /*value*/
    n[0]), e = new Qx({ props: r }), G0.push(() => K0(e, "value", s)), e.$on(
      "blur",
      /*blur_handler_1*/
      n[22]
    ), e.$on(
      "focus",
      /*focus_handler_1*/
      n[23]
    ), {
      c() {
        Ri(e.$$.fragment);
      },
      m(o, l) {
        Bi(e, o, l), i = !0;
      },
      p(o, l) {
        const a = {};
        l & /*language*/
        4 && (a.language = /*language*/
        o[2]), l & /*lines*/
        8 && (a.lines = /*lines*/
        o[3]), l & /*interactive*/
        2048 && (a.readonly = !/*interactive*/
        o[11]), !t && l & /*value*/
        1 && (t = !0, a.value = /*value*/
        o[0], j0(() => t = !1)), e.$set(a);
      },
      i(o) {
        i || (ut(e.$$.fragment, o), i = !0);
      },
      o(o) {
        dt(e.$$.fragment, o), i = !1;
      },
      d(o) {
        Pi(e, o);
      }
    }
  );
}
function DM(n) {
  let e, t, i;
  function s(o) {
    n[18](o);
  }
  let r = {
    language: (
      /*language*/
      n[2]
    ),
    lines: (
      /*lines*/
      n[3]
    ),
    dark_mode: (
      /*dark_mode*/
      n[13]
    )
  };
  return (
    /*value*/
    n[0] !== void 0 && (r.value = /*value*/
    n[0]), e = new a_({ props: r }), G0.push(() => K0(e, "value", s)), e.$on(
      "blur",
      /*blur_handler*/
      n[19]
    ), e.$on(
      "focus",
      /*focus_handler*/
      n[20]
    ), {
      c() {
        Ri(e.$$.fragment);
      },
      m(o, l) {
        Bi(e, o, l), i = !0;
      },
      p(o, l) {
        const a = {};
        l & /*language*/
        4 && (a.language = /*language*/
        o[2]), l & /*lines*/
        8 && (a.lines = /*lines*/
        o[3]), !t && l & /*value*/
        1 && (t = !0, a.value = /*value*/
        o[0], j0(() => t = !1)), e.$set(a);
      },
      i(o) {
        i || (ut(e.$$.fragment, o), i = !0);
      },
      o(o) {
        dt(e.$$.fragment, o), i = !1;
      },
      d(o) {
        Pi(e, o);
      }
    }
  );
}
function OM(n) {
  let e, t;
  return e = new c0({}), {
    c() {
      Ri(e.$$.fragment);
    },
    m(i, s) {
      Bi(e, i, s), t = !0;
    },
    i(i) {
      t || (ut(e.$$.fragment, i), t = !0);
    },
    o(i) {
      dt(e.$$.fragment, i), t = !1;
    },
    d(i) {
      Pi(e, i);
    }
  };
}
function EM(n) {
  let e, t, i, s, r, o, l, a;
  const h = [
    { autoscroll: (
      /*gradio*/
      n[1].autoscroll
    ) },
    { i18n: (
      /*gradio*/
      n[1].i18n
    ) },
    /*loading_status*/
    n[9]
  ];
  let c = {};
  for (let m = 0; m < h.length; m += 1)
    c = kM(c, h[m]);
  e = new WA({ props: c }), e.$on(
    "clear_status",
    /*clear_status_handler*/
    n[17]
  ), i = new H2({
    props: {
      Icon: c0,
      show_label: (
        /*show_label*/
        n[8]
      ),
      label: (
        /*label*/
        n[7]
      ),
      float: !1
    }
  });
  const f = [MM, AM], u = [];
  function d(m, p) {
    return !/*value*/
    m[0] && !/*interactive*/
    m[11] ? 0 : 1;
  }
  return r = d(n), o = u[r] = f[r](n), {
    c() {
      Ri(e.$$.fragment), t = Ua(), Ri(i.$$.fragment), s = Ua(), o.c(), l = X0();
    },
    m(m, p) {
      Bi(e, m, p), As(m, t, p), Bi(i, m, p), As(m, s, p), u[r].m(m, p), As(m, l, p), a = !0;
    },
    p(m, p) {
      const g = p & /*gradio, loading_status*/
      514 ? xM(h, [
        p & /*gradio*/
        2 && { autoscroll: (
          /*gradio*/
          m[1].autoscroll
        ) },
        p & /*gradio*/
        2 && { i18n: (
          /*gradio*/
          m[1].i18n
        ) },
        p & /*loading_status*/
        512 && vM(
          /*loading_status*/
          m[9]
        )
      ]) : {};
      e.$set(g);
      const b = {};
      p & /*show_label*/
      256 && (b.show_label = /*show_label*/
      m[8]), p & /*label*/
      128 && (b.label = /*label*/
      m[7]), i.$set(b);
      let w = r;
      r = d(m), r === w ? u[r].p(m, p) : (J0(), dt(u[w], 1, 1, () => {
        u[w] = null;
      }), Y0(), o = u[r], o ? o.p(m, p) : (o = u[r] = f[r](m), o.c()), ut(o, 1), o.m(l.parentNode, l));
    },
    i(m) {
      a || (ut(e.$$.fragment, m), ut(i.$$.fragment, m), ut(o), a = !0);
    },
    o(m) {
      dt(e.$$.fragment, m), dt(i.$$.fragment, m), dt(o), a = !1;
    },
    d(m) {
      m && (Cs(t), Cs(s), Cs(l)), Pi(e, m), Pi(i, m), u[r].d(m);
    }
  };
}
function LM(n) {
  let e, t;
  return e = new S2({
    props: {
      variant: "solid",
      padding: !1,
      elem_id: (
        /*elem_id*/
        n[4]
      ),
      elem_classes: (
        /*elem_classes*/
        n[5]
      ),
      visible: (
        /*visible*/
        n[6]
      ),
      scale: (
        /*scale*/
        n[10]
      ),
      $$slots: { default: [EM] },
      $$scope: { ctx: n }
    }
  }), {
    c() {
      Ri(e.$$.fragment);
    },
    m(i, s) {
      Bi(e, i, s), t = !0;
    },
    p(i, [s]) {
      const r = {};
      s & /*elem_id*/
      16 && (r.elem_id = /*elem_id*/
      i[4]), s & /*elem_classes*/
      32 && (r.elem_classes = /*elem_classes*/
      i[5]), s & /*visible*/
      64 && (r.visible = /*visible*/
      i[6]), s & /*scale*/
      1024 && (r.scale = /*scale*/
      i[10]), s & /*$$scope, value, interactive, language, lines, gradio, hasDiff, show_label, label, loading_status*/
      33561487 && (r.$$scope = { dirty: s, ctx: i }), e.$set(r);
    },
    i(i) {
      t || (ut(e.$$.fragment, i), t = !0);
    },
    o(i) {
      dt(e.$$.fragment, i), t = !1;
    },
    d(i) {
      Pi(e, i);
    }
  };
}
function RM(n, e, t) {
  let { gradio: i } = e, { value: s = {
    code: "",
    selected_code: { start: 0, end: 0, text: "" },
    diff: ""
  } } = e, { selection: r = { from: 0, to: 0, text: "" } } = e, { value_is_output: o = !1 } = e, { language: l = "" } = e, { lines: a = 5 } = e, { target: h } = e, { elem_id: c = "" } = e, { elem_classes: f = [] } = e, { visible: u = !0 } = e, { label: d = i.i18n("code.code") } = e, { show_label: m = !0 } = e, { loading_status: p } = e, { scale: g = null } = e, { interactive: b } = e, w = h.classList.contains("dark");
  function k() {
    i.dispatch("change", s), o || i.dispatch("input");
  }
  CM(() => {
    t(14, o = !1);
  });
  let x;
  const _ = () => i.dispatch("clear_status", p);
  function S(M) {
    s = M, t(0, s);
  }
  const A = () => i.dispatch("blur"), P = () => i.dispatch("focus");
  function W(M) {
    s = M, t(0, s);
  }
  const U = () => i.dispatch("blur"), F = () => i.dispatch("focus");
  return n.$$set = (M) => {
    "gradio" in M && t(1, i = M.gradio), "value" in M && t(0, s = M.value), "selection" in M && t(15, r = M.selection), "value_is_output" in M && t(14, o = M.value_is_output), "language" in M && t(2, l = M.language), "lines" in M && t(3, a = M.lines), "target" in M && t(16, h = M.target), "elem_id" in M && t(4, c = M.elem_id), "elem_classes" in M && t(5, f = M.elem_classes), "visible" in M && t(6, u = M.visible), "label" in M && t(7, d = M.label), "show_label" in M && t(8, m = M.show_label), "loading_status" in M && t(9, p = M.loading_status), "scale" in M && t(10, g = M.scale), "interactive" in M && t(11, b = M.interactive);
  }, n.$$.update = () => {
    n.$$.dirty & /*value*/
    1 && k(), n.$$.dirty & /*value*/
    1 && t(12, x = s.diff !== "");
  }, [
    s,
    i,
    l,
    a,
    c,
    f,
    u,
    d,
    m,
    p,
    g,
    b,
    x,
    w,
    o,
    r,
    h,
    _,
    S,
    A,
    P,
    W,
    U,
    F
  ];
}
class YM extends wM {
  constructor(e) {
    super(), SM(this, e, RM, LM, _M, {
      gradio: 1,
      value: 0,
      selection: 15,
      value_is_output: 14,
      language: 2,
      lines: 3,
      target: 16,
      elem_id: 4,
      elem_classes: 5,
      visible: 6,
      label: 7,
      show_label: 8,
      loading_status: 9,
      scale: 10,
      interactive: 11
    });
  }
}
export {
  Mw as A,
  hp as B,
  kg as C,
  In as D,
  C as E,
  Jw as F,
  O as G,
  gw as H,
  pe as I,
  Yy as J,
  YM as K,
  _a as L,
  GM as M,
  BM as N,
  HC as O,
  np as P,
  iC as Q,
  Qx as R,
  zt as S,
  Ut as T,
  QC as W,
  Ae as a,
  ww as b,
  zM as c,
  HM as d,
  FM as e,
  Tw as f,
  Ov as g,
  UM as h,
  qM as i,
  WM as j,
  VM as k,
  Ue as l,
  $ as m,
  nh as n,
  fe as o,
  IM as p,
  Wn as q,
  ei as r,
  uw as s,
  y as t,
  rn as u,
  Z as v,
  ht as w,
  Do as x,
  lp as y,
  ji as z
};
